// � 2012 SAP AG. All rights reserved.
// Author : SAP.

var dataMobiliserSettings;

/*Function to load Mobiliser Settings Page*/

function loadMobiliserSettingsData() {
	dataMobiliserSettings = null;

	try {
		xmlDoc = loadXML("app/config/mobiliserSettings.xml");

		var protocolData = xmlDoc.getElementsByTagName("PROTOCOL")[0].childNodes[0].nodeValue;
		var ipData = xmlDoc.getElementsByTagName("IP")[0].childNodes[0].nodeValue;
		var portData = xmlDoc.getElementsByTagName("PORT")[0].childNodes[0].nodeValue;

		dataMobiliserSettings = {
			protocol : protocolData,
			ip : ipData,
			port : portData
		};

		mobiliserSettingsModel = new sap.ui.model.json.JSONModel();

		mobiliserSettingsModel.setData(dataMobiliserSettings);

	} catch (err) {
		alert(oBundle.getText("error_message_no_mobiliser_settings"));
		logTechnicalFatal("Failed to load Mobiliser Server Settings", err.msg, "Common");
	}
}
