/*!
 * SAP UI development toolkit for HTML5 (SAPUI5)
 * 
 * (c) Copyright 2009-2013 SAP AG. All rights reserved
 */
jQuery.sap.declare("sap.m.List");jQuery.sap.require("sap.m.library");jQuery.sap.require("sap.ui.core.Control");sap.ui.core.Control.extend("sap.m.List",{metadata:{publicMethods:["getSelectedItem","setSelectedItem","getSelectedItems","setSelectedItemById","removeSelections","getSwipedItem","swipeOut"],library:"sap.m",properties:{"inset":{type:"boolean",group:"Misc",defaultValue:false},"visible":{type:"boolean",group:"Appearance",defaultValue:true},"headerText":{type:"string",group:"Misc",defaultValue:null},"footerText":{type:"string",group:"Misc",defaultValue:null},"mode":{type:"sap.m.ListMode",group:"Appearance",defaultValue:sap.m.ListMode.None},"width":{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},"includeItemInSelection":{type:"boolean",group:"Misc",defaultValue:false},"showUnread":{type:"boolean",group:"Misc",defaultValue:false},"noDataText":{type:"string",group:"Misc",defaultValue:null},"showNoData":{type:"boolean",group:"Misc",defaultValue:true},"swipeDirection":{type:"sap.m.SwipeDirection",group:"Misc",defaultValue:sap.m.SwipeDirection.Both},"modeAnimationOn":{type:"boolean",group:"Misc",defaultValue:true},"showSeparators":{type:"sap.m.ListSeparators",group:"Misc",defaultValue:sap.m.ListSeparators.All},"headerDesign":{type:"sap.m.ListHeaderDesign",group:"Misc",defaultValue:sap.m.ListHeaderDesign.Standard}},defaultAggregation:"items",aggregations:{"items":{type:"sap.m.ListItemBase",multiple:true,singularName:"item",bindable:"bindable"},"swipeContent":{type:"sap.ui.core.Control",multiple:false},"columns":{type:"sap.m.Column",multiple:true,singularName:"column"}},events:{"select":{},"delete":{},"swipe":{allowPreventDefault:true}}}});sap.m.List.M_EVENTS={'select':'select','delete':'delete','swipe':'swipe'};jQuery.sap.require("sap.ui.core.theming.Parameters");sap.m.List.prototype._mutex=false;
sap.m.List.prototype.init=function(){this._hasPopin=false;this._mode=this.getMode();this._includeItemInSelection=this.getIncludeItemInSelection()};
sap.m.List.prototype.onBeforeRendering=function(){if(this.hasOwnProperty("_$touchBlocker")){this.close();delete this._$touchBlocker}};
sap.m.List.prototype.onAfterRendering=function(){var s=this.getSelectedItems();for(var i=0;i<s.length;i++){this._setSelectedItem(s[i],true)}if(this.hasOwnProperty("_navRenderedBy")){jQuery.sap.byId(this.getId()+"-tblHeadNav").width(jQuery.sap.byId(this._navRenderedBy).outerWidth(true))}};
sap.m.List.prototype.setIncludeItemInSelection=function(a){this.setProperty("includeItemInSelection",a,true);var I=this.getItems();for(var i=0;i<I.length;i++){I[i]._includeItemInSelection=a;jQuery.sap.byId(I[i].getId()).toggleClass('sapMLIBCursor',a)}return this};
sap.m.List.prototype.setInset=function(i){if(i===this.getInset()){return}this.setProperty("inset",i,true);if(this.getDomRef()){if(i){this.addStyleClass('sapMListInsetBG');var u=jQuery.sap.byId(this.getId()+"-listUl").addClass('sapMListInset');if(this.getHeaderText()){jQuery.sap.byId(this.getId()+"-listHeader").removeClass('sapMListHdr').addClass('sapMListHdrInset');u.addClass('sapMListInsetHdr')}if(this.getFooterText()){u.addClass('sapMListInsetFtr');jQuery.sap.byId(this.getId()+"-listFooter").removeClass('sapMListFtr').addClass('sapMListFtrInset')}}else{this.removeStyleClass('sapMListInsetBG');var u=jQuery.sap.byId(this.getId()+"-listUl").removeClass('sapMListInset');if(this.getHeaderText()){jQuery.sap.byId(this.getId()+"-listHeader").removeClass('sapMListHdrInset').addClass('sapMListHdr');u.removeClass('sapMListInsetHdr')}if(this.getFooterText()){u.removeClass('sapMListInsetFtr');jQuery.sap.byId(this.getId()+"-listFooter").removeClass('sapMListFtrInset').addClass('sapMListFtr')}}this._setSwipePosition()}return this};
sap.m.List.prototype.setWidth=function(w){if(this.getDomRef()){this.$().width(w)}return this};
sap.m.List.prototype.setNoDataText=function(n){this.setProperty("noDataText",n,true);var N=(jQuery.sap.byId(this.getId()+"-listNoData"));if(N.length>0){N.text(n)}return this};
sap.m.List.prototype.getSelectedItem=function(){var r;var I=this.getItems();for(var i=0;i<I.length;i++){if(I[i].getSelected()){r=I[i];break}}return r};
sap.m.List.prototype.setSelectedItem=function(l,s){this._setSelectedItem(l,s);return this};
sap.m.List.prototype.getSelectedItems=function(){var r=[];var I=this.getItems();for(var i=0;i<I.length;i++){if(I[i].getSelected()){r.push(I[i])}}return r};
sap.m.List.prototype.setSelectedItemById=function(i,s){var l=sap.ui.getCore().byId(i);this._setSelectedItem(l,s);return this};
sap.m.List.prototype._setSelectedItem=function(l,s){switch(this.getMode()){case sap.m.ListMode.SingleSelect:case sap.m.ListMode.SingleSelectLeft:if(l){if(l._radioButton)l._radioButton.setSelected(s);l.setSelected(s,true);l.$().toggleClass('sapMLIBSelected',s)}break;case sap.m.ListMode.MultiSelect:if(l){if(l._checkBox)l._checkBox.setSelected(s);l.setSelected(s,true);l.$().toggleClass('sapMLIBSelected',s)}break;case sap.m.ListMode.SingleSelectMaster:if(sap.ui.core.theming.Parameters.get("sapUiListSingleSelectMasterAsActive")=="true"){l._active=s;if(l._radioButton)l._radioButton.setSelected(s);l.setSelected(s,true);l._activeHandling();if(s){l._activeHandlingNav();l._activeHandlingInheritor()}else{l._inactiveHandlingNav();l._inactiveHandlingInheritor()}}else{if(l){if(l._radioButton)l._radioButton.setSelected(s);l.setSelected(s,true);l.$().toggleClass('sapMLIBSelected',s)}}break;case sap.m.ListMode.None:break}};
sap.m.List.prototype.removeSelections=function(){this._removeCurrentSelection()};
sap.m.List.prototype._select=function(e){var l=sap.ui.getCore().byId(this.oParent.getId());var L=sap.ui.getCore().byId(l._listId);var s=e.getParameter("selected");l.setSelected(s,true);if(L.getMode()===sap.m.ListMode.SingleSelectMaster&&sap.ui.core.theming.Parameters.get("sapUiListSingleSelectMasterAsActive")=="true"){l._active=s;l._activeHandling();if(s){l._activeHandlingNav();l._activeHandlingInheritor()}else{l._inactiveHandlingNav();l._inactiveHandlingInheritor()}}else{l.$().toggleClass('sapMLIBSelected',s)}if(!L.getIncludeItemInSelection()){L.fireSelect({listItem:l})}};
sap.m.List.prototype._selectTapped=function(l){this.fireSelect({listItem:l})};
sap.m.List.prototype._delete=function(e){var l=sap.ui.getCore().byId(this.oParent.getId());var L=sap.ui.getCore().byId(l._listId);L.fireDelete({listItem:l})};
sap.m.List.prototype._removeCurrentSelection=function(){switch(this.getMode()){case sap.m.ListMode.SingleSelect:case sap.m.ListMode.SingleSelectLeft:var I=this.getItems();for(var i=0;i<I.length;i++){if(I[i]._radioButton){I[i]._radioButton.setSelected(false)}I[i].setSelected(false,true);I[i].$().toggleClass('sapMLIBSelected',false)}break;case sap.m.ListMode.MultiSelect:var I=this.getItems();for(var i=0;i<I.length;i++){if(I[i]._checkBox){I[i]._checkBox.setSelected(false)}I[i].setSelected(false,true);I[i].$().toggleClass('sapMLIBSelected',false)}break;case sap.m.ListMode.SingleSelectMaster:var I=this.getItems();for(var i=0;i<I.length;i++){if(I[i]._radioButton){I[i]._radioButton.setSelected(false)}I[i].setSelected(false,true);if(sap.ui.core.theming.Parameters.get("sapUiListSingleSelectMasterAsActive")=="true"){I[i]._active=false;I[i]._activeHandling();I[i]._inactiveHandlingNav();I[i]._inactiveHandlingInheritor()}else{I[i].$().toggleClass('sapMLIBSelected',false)}}break;case sap.m.ListMode.None:break}};
sap.m.List.prototype._getTouchBlocker=function(){return this._$touchBlocker||(this._$touchBlocker=this.$().children())};
sap.m.List.prototype._getSwipeContainer=function(){return this._$swipeContainer||(jQuery.sap.require("sap.m.InstanceManager"),this._$swipeContainer=jQuery("<div>",{"id":this.getId()+"-swp","class":"sapMListSwp"+(sap.ui.core.theming.Parameters.get("sapMPlatformDependent")=="true"&&jQuery.os.ios?" sapMBar-CTX":"")}))};
sap.m.List.prototype._setSwipePosition=function(){if(this._isSwipeActive){return this._getSwipeContainer().css("top",this._swipedItem.$().position().top)}};
sap.m.List.prototype._renderSwipeContent=function(){var $=this._swipedItem.$(),a=this._getSwipeContainer();this.$().prepend(a.css({top:$.position().top,height:$.outerHeight(true)}));if(this._bRerenderSwipeContent){this._bRerenderSwipeContent=false;var r=sap.ui.getCore().createRenderManager();r.render(this.getSwipeContent(),a.empty()[0]);r.destroy()}return this};
sap.m.List.prototype._swipeIn=function(){var t=this,$=t._getTouchBlocker(),a=t._getSwipeContainer();t._isSwipeActive=true;t._renderSwipeContent();sap.m.InstanceManager.addDialogInstance(t);window.document.activeElement.blur();jQuery(window).on("resize.swp",function(){t._setSwipePosition()});$.css("pointer-events","none").on("touchstart.swp",function(e){if(!a[0].firstChild.contains(e.target)){e.preventDefault();e.stopPropagation()}});a.bind("webkitAnimationEnd animationend",function(){jQuery(this).unbind("webkitAnimationEnd animationend");a.css("opacity",1).focus();$.parent().on("touchend.swp",function(e){if(!a[0].firstChild.contains(e.target)){t.swipeOut()}})}).removeClass("sapMListSwpOutAnim").addClass("sapMListSwpInAnim")};
sap.m.List.prototype._onSwipeOut=function(c){this._getSwipeContainer().css("opacity",0).remove();jQuery(window).off("resize.swp");this._getTouchBlocker().css("pointer-events","auto").off("touchstart.swp");if(typeof c=="function"){c.call(this,this._swipedItem,this.getSwipeContent())}this._isSwipeActive=false;sap.m.InstanceManager.removeDialogInstance(this)};
sap.m.List.prototype.swipeOut=function(c){if(!this._isSwipeActive){return this}var t=this,$=this._getSwipeContainer();this._getTouchBlocker().parent().off("touchend.swp");$.bind("webkitAnimationEnd animationend",function(){jQuery(this).unbind("webkitAnimationEnd animationend");t._onSwipeOut(c)}).removeClass("sapMListSwpInAnim").addClass("sapMListSwpOutAnim");return this};
sap.m.List.prototype.close=function(){if(this._isSwipeActive){this.swipeOut()._onSwipeOut()}};
sap.m.List.prototype._onSwipe=function(e){var c=this.getSwipeContent();if(c&&jQuery.support.touch&&!this._isSwipeActive&&this!==e.srcControl&&!this._eventHandledByControl){for(var l=e.srcControl;!(l instanceof sap.m.ListItemBase);l=l.oParent);this._swipedItem=l;this.fireSwipe({listItem:this._swipedItem,swipeContent:c,srcControl:e.srcControl},true)&&this._swipeIn()}};
sap.m.List.prototype.ontouchstart=function(e){this._eventHandledByControl=e.originalEvent._sapui_handledByControl;if(this._hasPopin){sap.m.ColumnListItem.handleEvents(e,"touchstart",this.getDomRef())}};
sap.m.List.prototype.ontap=function(e){if(this._hasPopin){sap.m.ColumnListItem.handleEvents(e,"tap",this.getDomRef())}};
sap.m.List.prototype.onswipeleft=function(e){var d=this.getSwipeDirection();if(d=="Both"||d=="RightToLeft"){this._onSwipe(e)}};
sap.m.List.prototype.onswiperight=function(e){var d=this.getSwipeDirection();if(d=="Both"||d=="LeftToRight"){this._onSwipe(e)}};
sap.m.List.prototype.setSwipeDirection=function(d){return this.setProperty("swipeDirection",d,true)};
sap.m.List.prototype.getSwipedItem=function(){return(this._isSwipeActive?this._swipedItem:null)};
sap.m.List.prototype.setSwipeContent=function(c){this._bRerenderSwipeContent=true;return this.setAggregation("swipeContent",c,true)};
sap.m.List.prototype.invalidate=function(o){if(o&&o===this.getSwipeContent()){this._bRerenderSwipeContent=true}sap.ui.core.Control.prototype.invalidate.apply(this,arguments);return this};
sap.m.List.prototype._onColumnResize=function(c){if(!this._hasPopin&&!this._mutex){var h=this.getColumns().some(function(b){return b.isPopin()});if(!h){c.setDisplay(document.getElementById(this.getId()+"-listUl"));return}}this._dirty=window.innerWidth;if(!this._mutex){var a=window.innerWidth;this._mutex=true;this.rerender();jQuery.sap.delayedCall(200,this,function(){if(Math.abs(this._dirty-a)>10){delete this._dirty;this.rerender()}this._mutex=false})}};
sap.m.List.prototype.addItemGroup=function(g,h){if(!h){h=new sap.m.GroupHeaderListItem({title:g.text||g.key}).addStyleClass("sapMListHdr")}this.addAggregation("items",h)};
sap.m.List.prototype._setTableHeaderVisibility=function(c){var $=jQuery.sap.byId(this.getId()+"-listUl").find("thead > tr"),h=!$.hasClass("sapMListTblHeaderNone"),v=$.find(".sapMListTblCell").filter(":visible"),a=v.eq(0);if(v.length==1){a.width("")}else{a.width(a.attr("data-sap-orig-width"))}if(!c&&h){$[0].className="sapMListTblRow sapMListTblHeader"}else if(c&&!h&&!v.length){$[0].className="sapMListTblHeaderNone"}};
