/*!
 * SAP UI development toolkit for HTML5 (SAPUI5)
 * 
 * (c) Copyright 2009-2013 SAP AG. All rights reserved
 */
jQuery.sap.declare("sap.m.ObjectHeader");jQuery.sap.require("sap.m.library");jQuery.sap.require("sap.ui.core.Control");sap.ui.core.Control.extend("sap.m.ObjectHeader",{metadata:{library:"sap.m",properties:{"title":{type:"string",group:"Misc",defaultValue:null},"number":{type:"string",group:"Misc",defaultValue:null},"numberUnit":{type:"string",group:"Misc",defaultValue:null},"intro":{type:"string",group:"Misc",defaultValue:null},"introActive":{type:"boolean",group:"Misc",defaultValue:null},"titleActive":{type:"boolean",group:"Misc",defaultValue:null},"icon":{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},"iconActive":{type:"boolean",group:"Misc",defaultValue:null},"visible":{type:"boolean",group:"Appearance",defaultValue:true}},defaultAggregation:"attributes",aggregations:{"attributes":{type:"sap.m.ObjectAttribute",multiple:true,singularName:"attribute"},"firstStatus":{type:"sap.m.ObjectStatus",multiple:false},"secondStatus":{type:"sap.m.ObjectStatus",multiple:false}},events:{"titlePress":{},"introPress":{},"iconPress":{}}}});sap.m.ObjectHeader.M_EVENTS={'titlePress':'titlePress','introPress':'introPress','iconPress':'iconPress'};
sap.m.ObjectHeader.prototype.init=function(){this._fNumberWidth=undefined};
sap.m.ObjectHeader.prototype.ontap=function(e){var s=e.target.id;if(this.getIntroActive()&&s===this.getId()+"-intro"){this.fireIntroPress({domRef:jQuery.sap.domById(s)})}else if(this.getTitleActive()&&s===this.getId()+"-title"){this.fireTitlePress({domRef:jQuery.sap.domById(s)})}else if(this.getIconActive()&&(s===this.getId()+"-img"||s===this.getId()+"-icon")){this.fireIconPress({domRef:jQuery.sap.domById(s)})}};
sap.m.ObjectHeader.prototype.exit=function(){if(this._sResizeListenerId){sap.ui.core.ResizeHandler.deregister(this._sResizeListenerId);this._sResizeListenerId=null}if(this._image){this._image.destroy();this._image=null}if(this._icon){this._icon.destroy();this._icon=null}};
sap.m.ObjectHeader.prototype._getImage=function(){var u=this.getIcon();var s=jQuery.device.is.phone?"2.5rem":"3rem";var i=sap.ui.core.IconPool.isIconURI(u);var I;if(i){I=this._icon||sap.ui.core.IconPool.createControlByURI({src:u,id:this.getId()+"-icon",size:s},sap.m.Image);this._icon=I}else{I=this._image||sap.ui.core.IconPool.createControlByURI({src:u,id:this.getId()+"-img",height:s,width:s},sap.m.Image);this._image=I}I.setSrc(u);return I};
sap.m.ObjectHeader.prototype.onBeforeRendering=function(){if(this._sResizeListenerId){sap.ui.core.ResizeHandler.deregister(this._sResizeListenerId);this._sResizeListenerId=null}};
sap.m.ObjectHeader.prototype.onAfterRendering=function(){if(jQuery.sap.byId(this.getId()+"-number").length>0){this._sResizeListenerId=sap.ui.core.ResizeHandler.register(this.getDomRef(),jQuery.proxy(this._resizeElements,this))}};
sap.m.ObjectHeader.prototype._resizeElements=function(){if(!this.getDomRef())return;var i=this.getId();var $=jQuery.sap.byId(i+"-numberdiv");var h=$.hasClass("sapMOHNumberWrap");if(this._fNumberWidth===undefined){this._fNumberWidth=$.width()}var o=$.parent().width()*35/100<this._fNumberWidth;if(o!=h){$.toggleClass("sapMOHNumberWrap");jQuery.sap.byId(i+"-titlediv").toggleClass("sapMOHNumberWrap");jQuery(sap.m.ObjectHeader._escapeId(i)+" .sapMOHBottomRow").css("margin-top",o&&jQuery.device.is.phone?".25rem":"")}};
sap.m.ObjectHeader._escapeId=function(i){return i?"#"+i.replace(/(:|\.)/g,'\\$1'):""};
sap.m.ObjectHeader.prototype._hasBottomContent=function(){return(this._hasAttributes()||this._hasStatus())};
sap.m.ObjectHeader.prototype._hasIcon=function(){return!!this.getIcon().trim()};
sap.m.ObjectHeader.prototype._hasAttributes=function(){var a=this.getAttributes();if(a&&a.length>0){for(var i=0;i<a.length;i++){if(!a[i]._isEmpty()){return true}}}return false};
sap.m.ObjectHeader.prototype._hasStatus=function(){return((this.getFirstStatus()&&!this.getFirstStatus()._isEmpty())||(this.getSecondStatus()&&!this.getSecondStatus()._isEmpty()))};
