/*!
 * SAP UI development toolkit for HTML5 (SAPUI5)
 * 
 * (c) Copyright 2009-2013 SAP AG. All rights reserved
 */
jQuery.sap.declare("sap.m.Select");jQuery.sap.require("sap.m.library");jQuery.sap.require("sap.ui.core.Control");sap.ui.core.Control.extend("sap.m.Select",{metadata:{library:"sap.m",properties:{"name":{type:"string",group:"Misc",defaultValue:null},"visible":{type:"boolean",group:"Appearance",defaultValue:true},"enabled":{type:"boolean",group:"Behavior",defaultValue:true},"width":{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'auto'},"maxWidth":{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},"title":{type:"string",group:"Misc",defaultValue:null},"selectedKey":{type:"string",group:"Data",defaultValue:null},"selectedItemId":{type:"string",group:"Misc",defaultValue:null}},defaultAggregation:"items",aggregations:{"items":{type:"sap.ui.core.Item",multiple:true,singularName:"item"}},associations:{"selectedItem":{type:"sap.ui.core.Item",multiple:false}},events:{"change":{}}}});sap.m.Select.M_EVENTS={'change':'change'};jQuery.sap.require("sap.ui.core.theming.Parameters");jQuery.sap.require("sap.ui.core.EnabledPropagator");sap.ui.core.EnabledPropagator.apply(sap.m.Select.prototype,[true]);
sap.m.Select.prototype.init=function(){if(this._bUseCustomSelect){jQuery.sap.require("sap.m.CustomSelect");sap.m.Select.prototype.init=null}};
sap.m.Select.prototype.onBeforeRendering=function(){var i=this.getItems(),I=this.getSelectedItem(),k=this.getSelectedKey();if(i.length){if(k!==(I&&I.getKey())){I=sap.m.Select._getItemByKey(i,""+k);if(!I){if(k!==""){jQuery.sap.log.warning('Warning: the key "'+k+'" has no corresponding aggregated item on ',this)}else{this._setDefaultSelectedItem(i[0])}}else{this.setAssociation("selectedItem",I,true);this.setProperty("selectedItemId",I.getId(),true)}}else if(i.indexOf(I)===-1){jQuery.sap.log.warning('Warning: the sap.ui.core.Item instance or sap.ui.core.Item id is not a valid aggregation on',this)}}else{this.setAssociation("selectedItem",null,true);this.setProperty("selectedItemId","",true);this.setProperty("selectedKey","",true);jQuery.sap.log.info("Info: the select control does not contain any item on",this)}this._unbindChangeEvent();if(this._bUseCustomSelect){this._onBeforeRenderingCustom()}};
sap.m.Select.prototype.onAfterRendering=function(){var l;this._$SelectCont=this.$();this._$Select=this._$SelectCont.children("select");this._$SelectOptions=this._$Select.children("option");this._$SeletedOption=this._$SelectOptions.filter(":selected");this._$SelectLabel=this._$SelectCont.children(".sapMSltLabel");this._$Select.on("change.sapMSelect",jQuery.proxy(this._handleChangeEvent,this));l=window.getComputedStyle(this._$SelectLabel[0],null);this._$Select[0].style.font=l.font;this._$Select[0].style.padding=l.padding;this._$Select[0].style.border=l.border;this._$Select.width("100%");this._$SelectCont.css("visibility","");if(this._bUseCustomSelect){this._onAfterRenderingCustom()}};
sap.m.Select.prototype.ontouchstart=function(e){e.originalEvent._sapui_handledByControl=true;this._$SelectCont.addClass("sapMSltPressed")};
sap.m.Select.prototype.ontouchmove=function(e){if(this._bUseCustomSelect){this._ontouchmoveCustom(e)}};
sap.m.Select.prototype.ontouchend=function(){this._$SelectCont.removeClass("sapMSltPressed")};
sap.m.Select.prototype._handleChangeEvent=function(){var n=this._$SelectOptions.filter(":selected"),i=n.attr("id"),I=sap.ui.getCore().byId(i),s=this.getSelectedItem();if(!s||s.getId()===i){return}this._$SeletedOption.removeAttr("selected");n.attr("selected","selected");this._$SeletedOption=n;this.setAssociation("selectedItem",i,true);this.setProperty("selectedItemId",i,true);this.setProperty("selectedKey",sap.ui.getCore().byId(i).getKey(),true);this._$SelectLabel.text(I.getText());this.fireChange({selectedItem:I})};
sap.m.Select.prototype._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");sap.m.Select.prototype._sNoData=sap.m.Select.prototype._oRb.getText("SELECT_NO_DATA");sap.m.Select.prototype._bUseCustomSelect=(jQuery.os.android&&jQuery.os.fVersion===2.3)||!sap.ui.core.theming.Parameters.get("sapMPlatformDependent");sap.m.Select.prototype._sLang=sap.ui.getCore().getConfiguration().getLanguage().split("-")[0];
sap.m.Select.prototype._unbindChangeEvent=function(){if(this._$Select){this._$Select.off("change.sapMSelect",this._handleChangeEvent)}};
sap.m.Select._getItemByKey=function(I,k){for(var i=0;i<I.length;i++){if(I[i].getKey()===k){return I[i]}}};
sap.m.Select.prototype._setDefaultSelectedItem=function(i){var i=i||this.getItems()[0];if(i){this.setAssociation("selectedItem",i.getId(),true);this.setProperty("selectedItemId",i.getId(),true);this.setProperty("selectedKey",i.getKey(),true)}};
sap.m.Select.prototype.setSelectedItem=function(i){if(typeof i==="string"){i=sap.ui.getCore().byId(i)}if(!(i instanceof sap.ui.core.Item)&&i!==null){jQuery.sap.log.warning('Warning: "vItem" needs to be an instance of sap.ui.core.Item, a valid sap.ui.core.Item id, or null on',this);return this}this.setAssociation("selectedItem",i||null);this.setProperty("selectedItemId",i?i.getId():"");this.setProperty("selectedKey",i?i.getKey():"");return this};
sap.m.Select.prototype.setSelectedItemId=function(i){var I=sap.ui.getCore().byId(i);if(!(I instanceof sap.ui.core.Item)&&i!==""&&i!==undefined){jQuery.sap.log.warning('Warning: "sItem" must be a string id of an sap.ui.core.Item instance, an empty string or undefined on',this);return this}this.setAssociation("selectedItem",I||null);this.setProperty("selectedItemId",i||"");this.setProperty("selectedKey",I?I.getKey():"");return this};
sap.m.Select.prototype.setSelectedKey=function(k){return this.setProperty("selectedKey",k)};
sap.m.Select.prototype.getSelectedItem=function(){var s=this.getAssociation("selectedItem");return(s===null)?null:sap.ui.getCore().byId(s)};
sap.m.Select.prototype.removeItem=function(i){if(typeof i==="string"){i=sap.ui.getCore().byId(i)}if(!(i instanceof sap.ui.core.Item)){jQuery.sap.log.warning('Warning: "vItem" must be a sap.ui.core.Item object or a valid item id on',this);return null}i=this.removeAggregation("items",i);if(i&&i.getId()===this.getAssociation("selectedItem")){this._setDefaultSelectedItem()}return i};
