/*!
 * SAP UI development toolkit for HTML5 (SAPUI5)
 * 
 * (c) Copyright 2009-2013 SAP AG. All rights reserved
 */
jQuery.sap.declare("sap.m.Slider");jQuery.sap.require("sap.m.library");jQuery.sap.require("sap.ui.core.Control");sap.ui.core.Control.extend("sap.m.Slider",{metadata:{publicMethods:["stepUp","stepDown"],library:"sap.m",properties:{"width":{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:'100%'},"enabled":{type:"boolean",group:"Behavior",defaultValue:true},"visible":{type:"boolean",group:"Appearance",defaultValue:true},"name":{type:"string",group:"Misc",defaultValue:null},"min":{type:"float",group:"Data",defaultValue:0},"max":{type:"float",group:"Data",defaultValue:100},"step":{type:"float",group:"Data",defaultValue:1},"progress":{type:"boolean",group:"Misc",defaultValue:true},"value":{type:"float",group:"Data",defaultValue:0}},events:{"change":{},"liveChange":{}}}});sap.m.Slider.M_EVENTS={'change':'change','liveChange':'liveChange'};jQuery.sap.require("sap.ui.core.EnabledPropagator");sap.ui.core.EnabledPropagator.apply(sap.m.Slider.prototype,[true]);sap.m.Slider.prototype._aEvents=["ontouchstart","ontouchmove","ontouchend"];sap.m.Slider.prototype._aVEvents=["_ontouchstart","_ontouchmove","_ontouchend"];
sap.m.Slider.prototype.onBeforeRendering=function(){var m=this.getMin(),M=this.getMax(),s=this.getStep(),b=false,e=false;if(m>=M){b=true;e=true;jQuery.sap.log.warning("Warning: "+"Property wrong min: "+m+" >= max: "+M+" on ",this)}if(s<=0){jQuery.sap.log.warning("Warning: "+"The step could not be negative on ",this);s=1;this.setProperty("step",s,true)}if(s>(M-m)&&!b){e=true;jQuery.sap.log.warning("Warning: "+"Property wrong step: "+s+" > max: "+M+" - "+"min: "+m+" on ",this)}if(!e){this.setValue(this.getValue());this._fProgressValue=this._getPercentFromValue(this.getValue())}};
sap.m.Slider.prototype.onAfterRendering=function(){this.getEnabled()?this._bindEvents():this._unbindEvents();this._$SliderContainer=this.$();this._$Slider=this._$SliderContainer.children(".sapMSli");this._$ProgressIndicator=this._$Slider.children(".sapMSliProgress");this._$Handle=this._$Slider.children(".sapMSliHandle");this._$Input=this._$SliderContainer.children("input.sapMSliInput");this._$SliderContainer.css("visibility","")};
sap.m.Slider.prototype._ontouchstart=function(e){var t=jQuery(e.target),m=this.getMin(),v;e.originalEvent._sapui_handledByControl=true;if(e.targetTouches.length>1){return}this._recalculateStyles();this._fDiffX=this._fSliderPaddingLeft;this._fStartValue=this.getValue();this._$Slider.addClass("sapMSliPressed");if(t.is(this._$Handle)||t.parent().is(this._$Handle)){this._fDiffX=e.targetTouches[0].pageX-this._$Handle.offset().left}else{v=(((e.targetTouches[0].pageX-this._fSliderPaddingLeft-this._fSliderOffsetLeft)/this._fSliderWidth)*(this.getMax()-m))+m;this.setValue(v);this.fireLiveChange({value:this.getValue()})}};
sap.m.Slider.prototype._ontouchmove=function(e){var m=this.getMin(),v=this.getValue(),n=(((e.targetTouches[0].pageX-this._fDiffX-this._fSliderOffsetLeft)/this._fSliderWidth)*(this.getMax()-m))+m;this.setValue(n);n=this.getValue();if(v!==n){this.fireLiveChange({value:n})}};
sap.m.Slider.prototype._ontouchend=function(){var v=this.getValue();this._$Slider.removeClass("sapMSliPressed");if(this._fStartValue!==v){this.fireChange({value:v})}delete this._fDiffX;delete this._fStartValue};
sap.m.Slider.prototype._recalculateStyles=function(){this._fSliderWidth=this._$SliderContainer.width();this._fSliderPaddingLeft=parseFloat(this._$SliderContainer.css("padding-left"));this._fSliderOffsetLeft=this._$SliderContainer.offset().left;this._fHandleWidth=this._$Handle.width()};
sap.m.Slider.prototype._bindEvents=function(){var i=0;for(;i<this._aVEvents.length;i++){this[this._aEvents[i]]=this[this._aVEvents[i]]}return this};
sap.m.Slider.prototype._unbindEvents=function(){var i=0;for(;i<this._aVEvents.length;i++){this[this._aEvents[i]]=null}return this};
sap.m.Slider.prototype._getPercentFromValue=function(v){var m=this.getMin();return((v-m)/(this.getMax()-m))*100};
sap.m.Slider.prototype._validateN=function(n){var t=typeof n;if(t==="undefined"){return 1}else if(t!=="number"){jQuery.sap.log.warning('Warning: n needs to be a number',this);return 0}else if(Math.floor(n)===n&&isFinite(n)){return n}else{jQuery.sap.log.warning('Warning: n needs to be a finite interger',this);return 0}};
sap.m.Slider.prototype._setValue=function(n){var m=this.getMin(),M=this.getMax(),s=this.getStep(),v=this.getValue(),f=Math.abs(n%s),p;if(typeof n!=="number"||!isFinite(n)){jQuery.sap.log.error("Error:",'"fNewValue" needs to be a finite number of',this);return this}n=f*2>=s?n+s-f:n-f;n=n>M?M:n<m?m:n;n=Number(n.toFixed(5));this.setProperty("value",n,true);if(v===this.getValue()){return this}if(this._$SliderContainer){this._$Input[0].setAttribute("value",n);p=this._getPercentFromValue(n)+"%";if(this.getProgress()){this._$ProgressIndicator[0].style.width=p}this._$Handle[0].style.left=p}return this};
sap.m.Slider.prototype.stepUp=function(n){return this.setValue(this.getValue()+(this._validateN(n)*this.getStep()))};
sap.m.Slider.prototype.stepDown=function(n){return this.setValue(this.getValue()-(this._validateN(n)*this.getStep()))};
sap.m.Slider.prototype.setValue=function(n){this.setValue=this._setValue;return this.setProperty("value",n,true)};
