/*!
 * SAP UI development toolkit for HTML5 (SAPUI5)
 * 
 * (c) Copyright 2009-2013 SAP AG. All rights reserved
 */
jQuery.sap.declare("sap.m.Switch");jQuery.sap.require("sap.m.library");jQuery.sap.require("sap.ui.core.Control");sap.ui.core.Control.extend("sap.m.Switch",{metadata:{library:"sap.m",properties:{"state":{type:"boolean",group:"Misc",defaultValue:false},"customTextOn":{type:"string",group:"Misc",defaultValue:null},"customTextOff":{type:"string",group:"Misc",defaultValue:null},"visible":{type:"boolean",group:"Appearance",defaultValue:true},"enabled":{type:"boolean",group:"Data",defaultValue:true},"name":{type:"string",group:"Misc",defaultValue:null},"type":{type:"sap.m.SwitchType",group:"Appearance",defaultValue:sap.m.SwitchType.Default}},events:{"change":{}}}});sap.m.Switch.M_EVENTS={'change':'change'};jQuery.sap.require("sap.ui.core.EnabledPropagator");jQuery.sap.require("sap.ui.core.theming.Parameters");jQuery.sap.require("sap.ui.core.IconPool");sap.ui.core.IconPool.insertFontFaceStyle();sap.ui.core.EnabledPropagator.apply(sap.m.Switch.prototype,[true]);
sap.m.Switch.prototype._updateUI=function(p){p=p>sap.m.Switch._fOffPosition?sap.m.Switch._fOffPosition:p<sap.m.Switch._fOnPosition?sap.m.Switch._fOnPosition:p;if(this._iCurrentPositionLeft===p){return}this._iCurrentPositionLeft=p;this._$SwitchInner[0].style.left=p+"px";this._setTempState(Math.abs(p)<sap.m.Switch._fSwapPoint)};
sap.m.Switch.prototype._setTempState=function(b){if(this._bTempState===b){return}this._bTempState=b;this._$Handle[0].setAttribute("data-sap-ui-swt",b?this._sOn:this._sOff)};
sap.m.Switch.prototype._bindEvents=function(){var i=0,S=sap.m.Switch;for(;i<S._aVEvents.length;i++){this[S._aEvents[i]]=this[S._aVEvents[i]]}return this};
sap.m.Switch.prototype._unbindEvents=function(){var i=0,S=sap.m.Switch;for(;i<S._aVEvents.length;i++){this[S._aEvents[i]]=null}return this};
sap.m.Switch._getParameter=function(p){var g=sap.ui.core.theming.Parameters.get;return g(p)||g(p+"-"+jQuery.os.os)};
(function(){var p="sapMSwitchTransitionTime",t=sap.m.Switch._getParameter(p);sap.m.Switch._bUseTransition=!!(Number(t));sap.m.Switch._iTransitionTime=Number(t)})();sap.m.Switch._fOnPosition=sap.m.Switch._getParameter("sapMSwitchOnPosition");sap.m.Switch._fOffPosition=sap.m.Switch._getParameter("sapMSwitchOffPosition");sap.m.Switch._fSwapPoint=Math.abs((sap.m.Switch._fOnPosition-sap.m.Switch._fOffPosition)/2);sap.m.Switch._aEvents=["ontouchstart","ontouchmove","ontouchend","ontouchcancel"];sap.m.Switch._aVEvents=sap.m.Switch._aEvents.map(function(e){return"_"+e});sap.m.Switch._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");
sap.m.Switch.prototype.onBeforeRendering=function(){var S=sap.m.Switch;this._sOn=this.getCustomTextOn()||S._oRb.getText("SWITCH_ON");this._sOff=this.getCustomTextOff()||S._oRb.getText("SWITCH_OFF")};
sap.m.Switch.prototype.onAfterRendering=function(){var s;this.getEnabled()?this._bindEvents():this._unbindEvents();s=this.$();this._$Switch=s.find(".sapMSwt");this._$SwitchInner=this._$Switch.children(".sapMSwtInner");this._$Handle=this._$SwitchInner.children(".sapMSwtHandle");this._$Checkbox=s.children("input");this._iSwitchWidth=this._$Switch.outerWidth()};
sap.m.Switch.prototype._ontouchstart=function(e){var t=e.targetTouches[0];e.originalEvent._sapui_handledByControl=true;if(sap.m.touch.countContained(e.touches,this.getId())>1){return}this._iActiveTouch=t.identifier;this._$Switch.addClass("sapMSwtPressed").removeClass("sapMSwtTrans");this._bTempState=this.getState();this._iTouchStartPageX=t.pageX;this._iSwitchPositionLeft=this._$SwitchInner.position().left;this._bDragged=false};
sap.m.Switch.prototype._ontouchmove=function(e){var t,p,T=sap.m.touch;t=T.find(e.changedTouches,this._iActiveTouch);if(!t){return}this._bDragged=true;p=((this._iTouchStartPageX-t.pageX)*-1)+this._iSwitchPositionLeft;this._updateUI(p)};
if(jQuery.os.os==="ios"&&jQuery.os.fVersion<=5&&sap.ui.core.theming.Parameters.get("sapMPlatformDependent")){sap.m.Switch.prototype._ontouchmove=null}
sap.m.Switch.prototype._ontouchend=function(e){var t=sap.m.touch,a=jQuery.sap.assert;a(this._iActiveTouch!==undefined,'sap.m.Switch.prototype._ontouchend(): expect to already be touching');if(!t.find(e.changedTouches,this._iActiveTouch)){return}a(!t.find(e.touches,this._iActiveTouch),'sap.m.Switch.prototype._ontouchend(): touch ended also still active');this._$Switch.removeClass("sapMSwtPressed");this.setState(this._bDragged?this._bTempState:!this._bTempState,true)};
sap.m.Switch.prototype._ontouchcancel=sap.m.Switch.prototype._ontouchend;
sap.m.Switch.prototype.setState=function(s,t){var S,n,a=sap.m.Switch;if(!this.getEnabled()&&t){return this}n=!(this.getState()===s);if(n){this.setProperty("state",s,true)}if(!this._$Switch){return this}s=this.getState();S=s?this._sOn:this._sOff;if(n){this._$Handle[0].setAttribute("data-sap-ui-swt",S);this._$Checkbox[0].setAttribute("checked",s);this._$Checkbox[0].setAttribute("value",S);s?this._$Switch.removeClass("sapMSwtOff").addClass("sapMSwtOn"):this._$Switch.removeClass("sapMSwtOn").addClass("sapMSwtOff");if(t){if(a._bUseTransition){jQuery.sap.delayedCall(a._iTransitionTime,this,function _sapSwtFireChangeDelayed(){this.fireChange({state:s})},[s])}else{this.fireChange({state:s})}}}this._$Switch.addClass("sapMSwtTrans");this._$SwitchInner.removeAttr("style");return this};
