/*!
 * SAP UI development toolkit for HTML5 (SAPUI5)
 * 
 * (c) Copyright 2009-2013 SAP AG. All rights reserved
 */
jQuery.sap.declare("sap.m.TilePage");jQuery.sap.require("sap.m.library");jQuery.sap.require("sap.m.Page");sap.m.Page.extend("sap.m.TilePage",{metadata:{library:"sap.m",properties:{"tileWidth":{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},"tileHeight":{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},"tilePadding":{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:null},"width":{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},"height":{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'}},aggregations:{"tiles":{type:"sap.ui.core.Control",multiple:true,singularName:"tile"}},associations:{"group":{type:"sap.ui.core.Control",multiple:false},"container":{type:"sap.ui.core.Control",multiple:false}}}});
sap.m.TilePage.prototype.addTile=function(t){var p=this.getTiles().length;if(p<this._maxtiles){this.insertTile(t,p)}else{jQuery.sap.log.debug('Pos '+p+' maxtiles '+this._maxtiles);this._sendTileToNextPage(t,false)}};
sap.m.TilePage.prototype.insertTile=function(t,i){if(i>this.getTiles().length){jQuery.sap.log.debug('TilePage.insertTile trying to insert a tile too far out')}t.setSize(this._tilewidth,this._tileheight);var r=sap.ui.getCore().createRenderManager();var q=jQuery.sap.byId(this.getId()+"-cont");r.render(t,q[0]);r.destroy();if(i<this.getTiles().length){jQuery(q.children()[i]).before(t.getDomRef())}this.insertAggregation("tiles",t,i,true);if(this.getTiles().length>this._maxtiles){this._sendTileToNextPage(this.getTiles()[this._maxtiles],true)}this._updateTilePositions()};
sap.m.TilePage.prototype.deleteTile=function(t){var i=this.getTiles().indexOf(t.getId());if(i>=0){this.removeAggregation("tiles",t.getId(),false);t.$().remove();this._updateTilePositions();if(this.getTiles().length<this._maxtiles)this._appendFirstTileFromNextPage()}else jQuery.sap.log.debug('TilePage.deleteTile trying to remove nonexisting tile')};
sap.m.TilePage.prototype._resize=function(){this._calculateSpace();for(var i=this.getTiles().length;i<this._maxtiles;i++){if(!this._appendFirstTileFromNextPage())break}for(var i=this.getTiles().length-1;i>=this._maxtiles;i--){this._sendTileToNextPage(this.getTiles()[i],true)}this._updateTilePositions()};
sap.m.TilePage.prototype.onBeforeRendering=function(){};
sap.m.TilePage.prototype.onAfterRendering=function(){this._calculateSpace();var a=this.getTiles();var r=sap.ui.getCore().createRenderManager();this._updateTilePositions();for(var t=0;t<a.length;t++){r.render(a[t],jQuery.sap.byId(this.getId()+"-cont")[0])}r.destroy()};
sap.m.TilePage.prototype._appendFirstTileFromNextPage=function(){var n=sap.ui.getCore().byId(this.getContainer()).getNextPage(this,false);if(n){if(n.getTiles().length>0){var t=n.getTiles()[0];n.deleteTile(t);this.addTile(t);return true}if(n.getTiles().length==0){sap.ui.getCore().byId(this.getContainer()).deletePage(n)}}return false};
sap.m.TilePage.prototype._sendTileToNextPage=function(t,b){var n=sap.ui.getCore().byId(this.getContainer()).getNextPage(this,true);this.deleteTile(t);b?n.insertTile(t,0):n.addTile(t)};
sap.m.TilePage.prototype._updateTilePositions=function(){var a=this.getTiles();for(var t=0;t<a.length;t++){a[t].setPos(this._borderx+t%this._maxtilex*(this._tilewidth+this._tilepadding),this._bordery+Math.floor(t/this._maxtilex)*(this._tileheight+this._tilepadding))}};
sap.m.TilePage.prototype._calculateSpace=function(){var t=this._tilewidth;var a=this._tileheight;var b=this._tilepadding;var w=jQuery.sap.byId(this.getId()+"-cont").width();var c=jQuery.sap.byId(this.getId()+"-cont").height();var d=this.getTiles().length;var m=Math.floor((w+b)/(t+b));var e=Math.floor((c+b)/(a+b));var f=m*e;var n=(d<m)?d:m;var g=(d/n<e)?Math.ceil(d/n):e;var h=d<f?d:f;var i=Math.floor((w-(t+b)*n-b)/2);var j=Math.floor((c-(a+b)*g-b)/2);if(sap.ui.getCore().byId(this.getContainer()).getTileGroups().length>1||sap.ui.getCore().byId(this.getGroup()).getTiles().length>f){c=c-30;var e=Math.floor((c+b)/(a+b));var f=m*e;sap.ui.getCore().byId(this.getContainer())._carousel.setShowPageIndicator(true)}else sap.ui.getCore().byId(this.getContainer())._carousel.setShowPageIndicator(false);this._maxtiles=f;this._maxtilex=m;this._maxtiley=e;this._borderx=i;this._bordery=j;jQuery.sap.log.debug("maxtiles "+f+" on page "+this.getId()+", w:"+w+", h:"+c)};
sap.m.TilePage.prototype._toPixel=function(s){var t=jQuery('<div style="display:none; width:'+s+';">').appendTo('body');var p=t.width();t.remove();return p};
sap.m.TilePage.prototype.setTileWidth=function(t){this.setProperty("tileWidth",t,true);this._tilewidth=this._toPixel(t);jQuery.sap.log.debug("Tile width in pixel: "+this._tilewidth)};
sap.m.TilePage.prototype.setTileHeight=function(t){this.setProperty("tileHeight",t,true);this._tileheight=this._toPixel(t);jQuery.sap.log.debug("Tile height in pixel: "+this._tileheight)};
sap.m.TilePage.prototype.setTilePadding=function(t){this.setProperty("tilePadding",t,true);this._tilepadding=this._toPixel(t);jQuery.sap.log.debug("Tile padding in pixel: "+this._tilepadding)}
