

SmartphoneService = {
		
	timedOutRequests: [],
	REQ_TIMEOUT_INTERVAL: 20000,
	PING_TIMEOUT_INTERVAL: 20000,
	
	url : userState['PROTOCOL'] + "://" + userState['IPADDRESS'] + ":" + userState['PORT'] + "/mobiliser/rest/smartphone",
	cookie: '',
	
	setUrl: function() {
		if(userState['PORT'] == "" || userState['PORT'] == null || userState['PORT'] == undefined || userState['PORT'] == 'null')
			this.url = userState['PROTOCOL'] + "://"  + userState['IPADDRESS'] + "/mobiliser/rest/smartphone";
		else
			this.url = userState['PROTOCOL'] + "://"  + userState['IPADDRESS'] + ":" + userState['PORT'] + "/mobiliser/rest/smartphone";
		//this.url = userState['PROTOCOL'] + "://" + userState['IPADDRESS'] + ":" + userState['PORT'] + userState['CONTEXT'];
	},
	
    createXmlHttpRequest : function () {
        if (window.XMLHttpRequest) {
            return new XMLHttpRequest();
        } else if (window.ActiveXObject) {
            return new ActiveXObject("Microsoft.XMLHTTP");
        } else {
            throw "XMLHttpRequest not available";
        }
    },
    
    //checks connection to server every  ___ seconds	
	ping: function(obj, func, launchHomeScreen){
		var now = new Date();
		var ping = this.createXmlHttpRequest();
		ping.onreadystatechange = function() {
			
			if(SmartphoneService.timedOutRequests.indexOf("ping"+now.getTime()) != -1)
			{
				//request has already been aborted
				return;
			}
			if (ping.readyState == 4) {
				if (ping.status == 200) {
					clearTimeout(pingTimeout);
					func(eval('('+ping.responseText+')'), ping.status);
					//util.closeBusyDialog();
				}
			}
		};
        
		ping.open("POST", this.url+"/"+"ping", true);
        ping.setRequestHeader("Content-Type", "application/json; charset=utf-8");
        ping.setRequestHeader("Accept", "application/json");
        ping.setRequestHeader("Pragma", "no-cache");
        ping.setRequestHeader("cache-Control", "no-cache, must-revalidate");
        ping.send(JSON.stringify(obj));
        var pingTimeout;
        if(launchHomeScreen != undefined){
        	pingTimeout=setTimeout(ajaxTimeout,6000);
        }
        else
        	pingTimeout=setTimeout(ajaxTimeout,SmartphoneService.PING_TIMEOUT_INTERVAL);
        function ajaxTimeout(){
        	
        	if(launchHomeScreen != undefined){
            	var response = {
            			Status : {
            				code : "1"
            			}
            	};
            	if (homeController == undefined) {
    				homeController = sap.ui.controller("app.ui.home.homeController");
    			}
            	homeController.modelData.homeDemoConnectedToServer = false; 
            	func(response,1);
        	}
        	
        	util.closeBusyDialog();
			//Push the request into the array of aborted requests.
        	SmartphoneService.timedOutRequests.push("ping"+now.getTime());
        	//need to set connection value
			if (app.getPage(MOBILISER_SETTINGS_PAGE) != null){
				var tempData = app.getPage(MOBILISER_SETTINGS_PAGE).getContent()[0].getModel().getData();
				tempData.connectionStatus = oBundle.getText("disconnected");
				app.getPage(MOBILISER_SETTINGS_PAGE).getContent()[0].getModel().setData(tempData);
			}
            if (app.getPage(SETTINGS_PAGE) != null){
				var tempData = app.getPage(SETTINGS_PAGE).getContent()[0].getModel().getData();
				tempData.connectionStatus = oBundle.getText("disconnected");
				app.getPage(SETTINGS_PAGE).getContent()[0].getModel().setData(tempData);
			}
        }
	},
	

	post: function(obj, methodName, callback, user, pass, requestCookie, noErrorPopups)
	{
		/*
		 * The argument noErrorPopups signifies that the service call is made in background and hence no error
		 * popup should be shown in case of any error.
		 */
		/** Checking network Connection **/
		var networkState = "";
		
		try
		{
			networkState = navigator.connection.type;
		}
		catch(errorMsg)
		{
			//browser mode
		}

		logTechnicalInfo("RestService-invoke", " network status " + networkState);
		
		if(networkState != "" && userState['DEMO_MODE'] == false)
		{
			if(networkState == Connection.NONE || networkState == Connection.UNKNOWN)
			{        
				util.closeBusyDialog();
				logTechnicalFatal("ServiceClient-invoke","No Internet Connectivity for method " + methodName + " with network status " + networkState);
				if(noErrorPopups == undefined || noErrorPopups != true)
					logError("error_message_no_network", "no network connection", "SmartPhone Service Call");
			} else
	        {
				this._sendRequest(obj, methodName, callback, user, pass, requestCookie, noErrorPopups);
	        }
		}
		else 
		{        
			this._sendRequest(obj, methodName, callback, user, pass, requestCookie, noErrorPopups);
		}	 
	},
	
	
	_sendRequest: function(obj, methodName, callback, user, pass, requestCookie, noErrorPopups)
	{
		/*
		 * The argument noErrorPopups signifies that the service call is made in background and hence no error
		 * popup should be shown in case of any error.
		 */

		logTechnicalInfo("_sendRequest", " Parameteres: Req Data- " + JSON.stringify(obj) + " methodName- " + methodName + " callback- "  + callback);

		/*** Performance Reading ***/
		var startTime = util.startPerformanceReading();

		/*
		 * In case of demo mode, pick up the demo data and respond instantly
		 */
		
		if(userState['DEMO_MODE'] == true) {
			var data = MLoyaltyDemoData.resolveRequest(methodName, obj, userState['BRANDTYPE']);
			if(data !== undefined) callback(data, 200);
			else {
				util.closeBusyDialog();
				logError("demo_mode_message", "Not Supported In Demo Mode", "RestService");
			}
			return;
		}


		//For some services like loginCustomer, getLoyaltyConfiguration etc, we do not need to check cookie expiration
		//but for all other services userState[EXPIRATION] should be greater than current time, otherwise throw an error
		//and take the user to login page
		var currentTime = new Date().getTime();
		if (!
				( methodName.indexOf("loginCustomer")!=-1 || methodName.indexOf("getLoyaltyConfiguration") != -1 ||
						methodName.indexOf("getAllAppConfiguration") != -1 || methodName.indexOf("CreateLoyaltyCustomer") != -1 || methodName.indexOf("resetPassword") != -1 ||
						methodName.indexOf("createEmailToken") != -1 || methodName.indexOf("createSmsToken") != -1 || methodName.indexOf("logout") != -1 || 
						methodName.indexOf("getLoyaltyCustomerByIdentification") != -1 || methodName.indexOf("getAnonymousOffers") != -1 || methodName.indexOf("getCatalogURL") != -1 || 
						methodName.indexOf("getMemberCardBackgroundImage") != -1 || methodName.indexOf("changeLoyaltyCredential") != -1 || 
						methodName.indexOf("getCountries") != -1 || methodName.indexOf("getStoreLocatorResults") != -1 || methodName.indexOf("getStoreSearch") != -1 ||
						methodName.indexOf("createUpdatePreferredStoreForMember") != -1 ||methodName.indexOf("getStoreDetail") != -1  || methodName.indexOf("getSingleBrandAnonymousProgramInfo") != -1 ||methodName.indexOf("decodeBarcode") != -1 || methodName.indexOf("getOffersForArticle") != -1 ||
						userState['EXPIRATION'] > currentTime )
		){
			util.closeBusyDialog();
			
			logError("error_message_401_expiration", "Cookie Expired", "RestService");
			//app.to(ID_LOGIN_PAGE);
			/*userState.DEMO_MODE = false;
			userState.LOGGED_IN = false;
			if(homeController == undefined)
				homeController = sap.ui.controller('app.ui.home.homeController');
			homeController.launchAnonymousHomePage();*/
			if(userCredentialSettingsController == undefined)
				userCredentialSettingsController = sap.ui.controller('app.ui.settings.userCredentialSettings');
			userCredentialSettingsController.SignOut();
			return;
		}


		var req = this.createXmlHttpRequest();

		/*
		 * In case a service request doesn't respond within interval REQ_TIMEOUT_INTERVAL, we will push the service name appended by the time
		 * when call was made (to uniquely identify the call, in case same service is called again). On callbacks onreadystatechange, onerror
		 * and onabort, we will check if that particular call is already timed out (if it is part of array timedOutRequests) and if so, we will
		 * not do anything and simply avoid the callbacks.
		 */
		var requestTimeout=setTimeout(ajaxTimeout,SmartphoneService.REQ_TIMEOUT_INTERVAL);
		function ajaxTimeout(){
			
			//Push the request into the array of aborted requests.
			SmartphoneService.timedOutRequests.push(methodName + startTime.toString());
			
			//If the getAppConfig request times out, take the user to connection settings
			if(methodName == "getAllAppConfiguration"){
				if(connectionSettingsController == undefined)
					connectionSettingsController = sap.ui.controller('app.ui.home.connectionSettings');
				connectionSettingsController.launchConnectionSettingPage();
			}
				
			/*
			 * Abort the request. This MUST BE DONE AFTER the request has been pushed to the
			 * timedOutRequests array, because it will trigger the onerror callback for the
			 * XMLHttpRequest, which will result in another error popup if the methodName has
			 * not been pushed to the array.
			 */
			
			req.abort();

			logTechnicalError("XmlHttpRequest TimeOut", "XmlHttpRequest Timed Out for " + methodName + " reqData " + JSON.stringify(obj));
			util.closeBusyDialog();
			if(noErrorPopups == undefined || noErrorPopups != true)
				logError("pre_call_not_connected","XmlHttpRequest TimeOut for method " + methodName,"RestService");
			util.closeBusyDialog();
		}

		req.onreadystatechange = function () 
		{

			if(SmartphoneService.timedOutRequests.indexOf(methodName + startTime.toString()) != -1)
			{
				//request has already been aborted
				return;
			}
			if (req.readyState == 4) {

				//Clearing the request timeout timer since the call response has reached client
				clearTimeout(requestTimeout);

				/** Performance Reading **/
				//logPerformanceInfo("HTTP Request - Response time (in secs)  for method " + method ,reading.toString(),"ServiceLayer");
				util.stopPerformanceReading(startTime,"HTTP Request - Response time (in secs)  for method " + methodName);


				if (req.status == 200) {
					var currentTime =	new Date().getTime();
					userState['EXPIRATION'] = currentTime + userState['SESSION_TIMEOUT'] - 5;
					//logTechnicalError("Response for method " + methodName,"Response\n" + JSON.stringify(req.responseText));
					
					//Calling the callback method for the service call
					if(callback !== null) callback(eval('('+req.responseText+')'), req.status);
				} else {
					
					var http_status = req.status;
					logTechnicalError("RestService-onreadystatechange","Error in XmlHttpResponse for method " + methodName + " with status: " + http_status + " and text: " + req.statusText);
					util.closeBusyDialog();
					if(noErrorPopups == undefined || noErrorPopups != true)
						logError("pre_call_not_connected", "Error in XmlHttpResponse for method " + methodName + " with status: " + http_status + " and text: " + req.statusText);
					if(CALL_HOME_SERVICE == true){
						if(callback !== null) callback();
					}
				}
			}	
		};

		req.onabort = function () {

			if(SmartphoneService.timedOutRequests.indexOf(methodName + startTime.toString()) != -1)
			{
				//request has already been aborted
				return;
			}

			//Clearing the timeout timer
			clearTimeout(requestTimeout);

			/** Performance Reading **/
			util.stopPerformanceReading(startTime,"HTTP Request - Response time (in secs)  for method " + methodName);
			//logPerformanceInfo("HTTP Request - Response time (in secs)  for method " + method ,reading.toString(),"ServiceLayer");

			logTechnicalError("XmlHttpRequest Aborted","XmlHttpRequest Aborted for method " + methodName);
			util.closeBusyDialog();
			if (req.readyState != 4) {
				if(noErrorPopups == undefined || noErrorPopups != true)
					logError("pre_call_not_connected","XmlHttpRequest Aborted for method " + methodName,"RestService");
			}
		}
		req.onerror = function () {

			if(SmartphoneService.timedOutRequests.indexOf(methodName + startTime.toString()) != -1)
			{
				//request has already been aborted
				return;
			}

			//Clearing the timeout timer
			clearTimeout(requestTimeout);

			/** Performance Reading **/
			util.stopPerformanceReading(startTime,"HTTP Request - Response time (in secs)  for method " + methodName);

			logTechnicalError("XmlHttpRequest Errored","Error occured while sending XmlHttpRequest for method " + methodName);
			util.closeBusyDialog();
			if (req.readyState != 4) {
				if(noErrorPopups == undefined || noErrorPopups != true)
					logError("pre_call_not_connected","Error occured while sending request!! " + methodName,"RestService");
			}
		}

		if (requestCookie) {
			req.open("POST", this.url+"/"+methodName+"?create_mobiliser_remember_me=yes", true);
		} else {
			req.open("POST", this.url+"/"+methodName, true);
		}

		if (user && pass) {
			req.setRequestHeader("Authorization", "Basic "+ util.encode(user+":"+pass));
		}

		req.setRequestHeader("Content-Type", "application/json; charset=utf-8");
		req.setRequestHeader("Accept", "application/json");
		req.setRequestHeader("Pragma", "no-cache");
		req.setRequestHeader("cache-Control", "no-cache, must-revalidate");
		req.send(JSON.stringify(obj));

	},
	
	//Returns the time in seconds from the last successful service call
	getInactivityPeriod: function(){
		var lastServiceCallTime = userState['EXPIRATION'] - userState['SESSION_TIMEOUT'];
		var currTime = new Date().getTime();
		return (currTime - lastServiceCallTime)/1000;
	},
	
	searchShopArticles : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "searchShopArticles", callback, user, pass, requestCookie);
    },
    
	updatePreferences : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "updatePreferences", callback, user, pass, requestCookie);
    },
	
	getEnrollmentPreferences : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getEnrollmentPreferences", callback, user, pass, requestCookie);
    },
    
	getAllPreferences : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getAllPreferences", callback, user, pass, requestCookie);
    },
    createHouseholdForProgram : function(obj, callback, user, pass, requestCookie) {
    	
    	var body = {
        		origin:"mLoyalty",
        		traceNo: UUIDv4(),
        		programId : obj.programId,
        		
        };
        this.post(body, "createHouseholdForProgram", callback, user, pass, requestCookie);
    },
    getHouseholdDetailsForMember : function(obj, callback, user, pass, requestCookie) {
        this.post({}, "getHouseholdDetailsForMember", callback, user, pass, requestCookie);
    },
    getHouseholdPrograms : function(obj, callback, user, pass, requestCookie) {
        this.post({}, "getHouseholdPrograms", callback, user, pass, requestCookie);
    },
    sendInvitationsForHousehold : function(obj, callback, user, pass, requestCookie) {
    	var body = {
        		origin:"mLoyalty",
        		traceNo: UUIDv4(),
        		householdId : obj.householdId,
        		householdName : obj.householdName,
        		programId : obj.programId,
        		programName : obj.programName,
        		invitations: obj.invitations,
        };
        this.post(body, "sendInvitationsForHousehold", callback, user, pass, requestCookie);
    },
    acceptInvitationForHousehold : function(obj, callback, user, pass, requestCookie) {
    	var body = {
        		origin:"mLoyalty",
        		traceNo: UUIDv4(),
        		invitationCode: obj.invitationCode,
        		email: obj.email,
        		phone: obj.phone,
        };
        this.post(body, "acceptInvitationForHousehold", callback, user, pass, requestCookie);
    },
    removeMemberFromHousehold : function(obj, callback, memberType, user, pass, requestCookie) {
    	var body = {
        		origin:"mLoyalty",
        		traceNo: UUIDv4(),
        		
        		householdId: obj.householdId,
        	
        };
    	if(memberType == true){
    		body.customerId =  obj.customerId;
    	}
    	else{
    		body.invitationId = obj.invitationId;
    	}
        this.post(body, "removeMemberFromHousehold", callback, user, pass, requestCookie);
    },
    
    
    updateMemberRolesForHousehold : function(obj, callback, user, pass, requestCookie) {
    	var body = {
        		origin:"mLoyalty",
        		traceNo: UUIDv4(),
        		
        		memberRoles : obj.memberRoles,
        		householdId : obj.householdId
        };
        this.post(body, "updateMemberRolesForHousehold", callback, user, pass, requestCookie);
    },
    //Get the shopping store checkIn info
    //Remove the store 
    // getShoppingStoreCheckinInfo : function(obj, callback, user, pass, requestCookie) {
    	// var body = {
        		// origin:"mLoyalty",
        		// traceNo: UUIDv4(),
        		// storeId : 500323400
        // };
        // this.post(body, "getShoppingStoreCheckinInfo", callback, user, pass, requestCookie);
    // },
    // checkInStore : function(obj, callback, user, pass, requestCookie) {
    	// var body = {
        		// origin:"mLoyalty",
        		// traceNo: UUIDv4(),
        		// storeId : 500323400
        // };
        // this.post(body, "checkInStore", callback, user, pass, requestCookie);
    // },
    // createBasket : function(obj, callback, user, pass, requestCookie) {
    	// var body = {
        		// origin:"mLoyalty",
        		// traceNo: UUIDv4(),
        		// storeId : 500323400
        // };
        // this.post(body, "createBasket", callback, user, pass, requestCookie);
    // },
    getShoppingHistoryBasket : function(obj, callback, user, pass, requestCookie) {
    	var body = {
        		origin:"mLoyalty",
        		traceNo: UUIDv4(),
        		/*storeId : obj.storeId,*/
        		includeExpired : true
        };
        this.post(body, "getShoppingHistoryBasket", callback, user, pass, requestCookie);
    },
    getShoppingBasketItemsForBasket : function(obj, callback, user, pass, requestCookie) {
    	var body = {
        		origin:"mLoyalty",
        		traceNo: UUIDv4(),
        		basketId : obj.basketId
        };
        this.post(body, "getShoppingBasketItemsForBasket", callback, user, pass, requestCookie);
    },
    getWalletEntriesByCustomer : function(obj, callback, user, pass, requestCookie) {
    	var body = {
        		origin:"mLoyalty",
        		traceNo: UUIDv4(),
        		customerId : loginResponseModel.customer.id
        };
        this.post(body, "getWalletEntriesByCustomer", callback, user, pass, requestCookie);
    },
    
    getBalanceAlertByPaymentInstrument : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getBalanceAlertByPaymentInstrument", callback, user, pass, requestCookie);
    },

    createBalanceAlert : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "createBalanceAlert", callback, user, pass, requestCookie);
    },

    updateBalanceAlert : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "updateBalanceAlert", callback, user, pass, requestCookie);
    },

    createWalletEntry : function(obj, callback, user, pass, requestCookie) {
    	var body = {
        		origin:"mLoyalty",
        		traceNo: UUIDv4(),
        		walletEntry : obj.walletEntry,
        		primaryDebit : obj.primaryDebit,
        		primaryCredit : obj.primaryCredit,
        };
        this.post(body, "createWalletEntry", callback, user, pass, requestCookie);
    },
    
    validateAndCreateWalletEntry : function(obj, callback, user, pass, requestCookie) {
    	var body = {
        		origin:"mLoyalty",
        		traceNo: UUIDv4(),
        		walletEntry : obj.walletEntry,
        		primaryDebit : obj.primaryDebit,
        		primaryCredit : obj.primaryCredit,
        };
        this.post(body, "validateAndCreateWalletEntry", callback, user, pass, requestCookie);
    },

    getPaymentInstrumentBalance : function(obj, callback, user, pass, requestCookie) {
    	var body = {
        		origin:"mLoyalty",
        		traceNo: UUIDv4(),
        		paymentInstrumentId : obj
        };
        this.post(body, "getPaymentInstrumentBalance", callback, user, pass, requestCookie);
    },

    updatePaymentInstrument : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "updatePaymentInstrument", callback, user, pass, requestCookie);
    },

    getWalletEntriesByCustomer : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getWalletEntriesByCustomer", callback, user, pass, requestCookie);
    },
    
    getRsaPublicKey : function(obj, callback, user, pass, requestCookie) {
    	var body = {
    			origin:"mLoyalty",
        		traceNo: UUIDv4(),
        		keyName : obj.keyName,	
    	};
        this.post(body, "getRsaPublicKey", callback, user, pass, requestCookie);
    },

    updateWalletEntry : function(obj, callback, user, pass, requestCookie) {
    	var body = {
        		origin:"mLoyalty",
        		traceNo: UUIDv4(),
        		walletEntry : obj.walletEntry,
        		primaryDebit : obj.primaryDebit,
        		primaryCredit : obj.primaryCredit,
        };
        this.post(body, "updateWalletEntry", callback, user, pass, requestCookie);
    },

    deleteWalletEntry : function(obj, callback, user, pass, requestCookie) {
    	var body = {
        		origin:"mLoyalty",
        		traceNo: UUIDv4(),
        		walletEntryId : obj.walletEntryId,
        };
        this.post(body, "deleteWalletEntry", callback, user, pass, requestCookie);
    },

    whoami : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "whoami", callback, user, pass, requestCookie);
    },

    getCustomer : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getCustomer", callback, user, pass, requestCookie);
    },

    createFullCustomer : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "createFullCustomer", callback, user, pass, requestCookie);
    },

    getCustomerByIdentification : function(obj, callback, user, pass, requestCookie) {
    	var body = {
    		origin:"mLoyalty",
    		traceNo: UUIDv4(),
    		identification: obj.oData.user,
            identificationType: "5"	
    	};
    	
        this.post(body, "getCustomerByIdentification", callback, user, pass, requestCookie);
    },
    getLoyaltyCustomerByIdentification : function(obj, callback, user, pass, requestCookie){
        var body = {
    		origin:"mLoyalty",
    		traceNo: UUIDv4(),
    		identification: obj.oData.user,
            identificationType: "5"	
    	};
    	
        this.post(body, "getLoyaltyCustomerByIdentification", callback, user, pass, requestCookie);
    },
	
    updateCustomer : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "updateCustomer", callback, user, pass, requestCookie);
    },

    deleteCustomer : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "deleteCustomer", callback, user, pass, requestCookie);
    },

    logout : function(obj, callback, user, pass, requestCookie, noChecks) {
		var body = {
			origin:"mLoyalty",
    		traceNo: UUIDv4(),
			destroyPersistentLogin : true
		}
		
        this.post(body, "logout", callback, user, pass, requestCookie, noChecks);
    },

    setCredential : function(obj, callback, user, pass, requestCookie) {
    	var body = {
 			   origin:"mLoyalty",
			   traceNo: UUIDv4(),
			   customerId : obj.oData.id,
			   credential : obj.oData.newPassword,
		       credentialType : "1"
    	};
    	
        this.post(body, "setCredential", callback, user, pass, requestCookie);
    },
    
    ChangeLoyaltyCredential : function(obj, callback, user, pass, requestCookie) {
    	var body = {
 			   origin:"mLoyalty",
			   traceNo: UUIDv4(),
               identification : obj.oData.id,
			   identificationType : 5,
               oldCredential: obj.oData.oldPassword, 
               newCredential : obj.oData.newPassword,
		       credentialType : "1"
    	};
    	
        this.post(body, "changeLoyaltyCredential", callback, user, pass, requestCookie);
    },
    ChangeLoyaltyWalletCredential : function(obj, callback, user, pass, requestCookie) {
    	var body = {
   			   origin:"mLoyalty",
  			   traceNo: UUIDv4(),
                 identification : obj.identification.toString(),
  			   identificationType : 1,
                 oldCredential: obj.oldCredential, 
                 newCredential : obj.newCredential,
  		       credentialType : 0
      	};
        this.post(body, "changeLoyaltyCredential", callback, user, pass, requestCookie);
    },
    /* Function to do login call */
    loginCustomer : function(obj, callback, user, pass, requestCookie) {
	
    	var body = {
    			   origin:"mLoyalty",
    			   traceNo: UUIDv4(),
    			   identification: obj.oData.account.identification,
    			   credential: obj.oData.account.credential,
    			   identificationType:"5",
    			   credentialType:"1"

    	}; 
        this.post(body, "loginCustomer", callback, user, pass, requestCookie);
    },

    changeCredential : function(obj, callback, user, pass, requestCookie) {
    	var body = {
 			   origin:"mLoyalty",
			   traceNo: UUIDv4(),
			   customerId: loginResponseModel.customer.id,
			   oldCredential: obj.oData.currPassValue,
			   newCredential: obj.oData.newPassValue,
			   credentialType: "1"
    	};
    	
        this.post(body, "changeCredential", callback, user, pass, requestCookie);
    },

    checkCredential : function(obj, callback, user, pass, requestCookie) {
		//crednetial type 0 for PIN
		var body = {
			origin: "mLoyalty",
 			traceNo: UUIDv4(),
			customerId : loginResponseModel.customer.id,
			credential : obj,
			credentialType : 0,
		}
		
        this.post(body, "checkCredential", callback, user, pass, requestCookie);
    },

    checkCredentialStrength : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "checkCredentialStrength", callback, user, pass, requestCookie);
    },

    hasCredential : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "hasCredential", callback, user, pass, requestCookie);
    },

    findTransactions : function(obj, callback, user, pass, requestCookie) {
    	var body = {
  			   origin: "mLoyalty",
 			   traceNo: UUIDv4(),
 			   customerId: loginResponseModel.customer.id,
 			   fromDate: obj.fromDate,
 			   toDate: obj.toDate,
 			   showFaulty: false,
 			   maxRecords: 100,
 			   paymentInstrumentId : obj.paymentInstrumentId,
 			   showInitial: false
     	};
        this.post(body, "findTransactions", callback, user, pass, requestCookie);
    },

    getTransactionDetails : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getTransactionDetails", callback, user, pass, requestCookie);
    },

    getAddress : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getAddress", callback, user, pass, requestCookie);
    },

    getAttachmentsByCustomer : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getAttachmentsByCustomer", callback, user, pass, requestCookie);
    },

    getMembership : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getMembership", callback, user, pass, requestCookie);
    },

    getAttachment : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getAttachment", callback, user, pass, requestCookie);
    },

    checkin : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "checkin", callback, user, pass, requestCookie);
    },

    checkout : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "checkout", callback, user, pass, requestCookie);
    },

    /* Function to send an image as attachment for Card Front/Back Side capture */
    createAttachment : function(obj, callback, user, pass, requestCookie) {
    	
    	var body = {
    			   origin:"mLoyalty",
    			   traceNo: UUIDv4(),
    			   attachment: obj.attachment
    	};
        this.post(body, "createAttachment", callback, user, pass, requestCookie);
    },

    deleteAttachment : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "deleteAttachment", callback, user, pass, requestCookie);
    },

    updateAttachment : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "updateAttachment", callback, user, pass, requestCookie);
    },

    getActivities : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getActivities", callback, user, pass, requestCookie);
    },

    getCompletedActivities : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getCompletedActivities", callback, user, pass, requestCookie);
    },

    getActivePrograms : function(obj, callback, user, pass, requestCookie) {
    	var body = {
 			   origin:"mLoyalty",
 			   traceNo: UUIDv4()
 			  
    	};

        this.post(body, "getActivePrograms", callback, user, pass, requestCookie);
        
    },
    addCouponsToActiveCheckIn : function(obj, callback, user, pass, requestCookie){
    	var body = {
    			origin:"mLoyalty",
    			traceNo: UUIDv4(),
    			/*couponInstanceId : obj.couponInstanceid,*/
    			storeId : obj.storeId,
    			inactivityPeriod : this.getInactivityPeriod(),
    			couponTypeId : obj.couponTypeid,
				offerId : obj.offerId,
				amountPointsNeeded : obj.amountPointsNeeded,
				couponCaption : obj.offerCaption 
    	};
    	
    	if(obj.couponInstanceid){
    		//console.log(obj.couponInstanceid.length);
    		body.couponInstanceId = obj.couponInstanceid
    		
    	}
        this.post(body, "addCouponsToActivecheckIn", callback, user, pass, requestCookie);
    },
    removeCouponsFromActiveCheckIn : function(obj, callback, user, pass, requestCookie){
    	var body = {
    			origin:"mLoyalty",
    			traceNo: UUIDv4(),
    			/*couponInstanceId : obj.couponInstanceid,*/
    			storeId : obj.storeId,
    			inactivityPeriod : this.getInactivityPeriod(),
    			couponTypeId : obj.couponTypeid,
    			amountPointsNeeded : obj.amountPointsNeeded
    	};
    	if(obj.couponInstanceid){
    		//console.log(obj.couponInstanceid.length);
    		body.couponInstanceId = [obj.couponInstanceid]
    		
    	}
        this.post(body, "removeCouponsFromActiveCheckIn", callback, user, pass, requestCookie);
    },
    getMembershipByProgram : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getMembershipByProgram", callback, user, pass, requestCookie);
    },

    /* Function to get a new card */
    subscribeToProgram : function(obj, callback, user, pass, requestCookie) {
    	var body  = {
   			   origin:"mLoyalty",
  			   traceNo: UUIDv4(),
  			   programId : obj.programId,
  			   customerId : obj.customerId

    	};
    	
    	this.post( body, "subscribeToProgram", callback, user, pass, requestCookie);
     },

    /* Function to add an existing card */
    subscribeToProgramWithCard : function(obj, callback, user, pass, requestCookie) {
    	var body = {
  			   origin:"mLoyalty",
  			   traceNo: UUIDv4(),
  			   programId: obj.programId,
  			   customerId: obj.customerId,
  			   cardName: obj.cardName,
  			   cardNumber: obj.cardNumber,
  			   cardPin: obj.cardPin,
  			   expDate: obj.expDate


     	};
 
        this.post(body, "subscribeToProgramWithCard", callback, user, pass, requestCookie);
    },

    unsubscribeToProgram : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "unsubscribeToProgram", callback, user, pass, requestCookie);
    },
    
    getCountries : function(obj, callback, user, pass, requestCookie) {
    	this.post(obj, "getCountries", callback, user, pass, requestCookie);
    },

    updateLoyaltyMember : function(obj, callback, user, pass, requestCookie) {
    	var body = {
   			   origin:"mLoyalty",
  			   traceNo: UUIDv4(),
  			   member: obj
    	};
   	
        this.post(body, "UpdateLoyaltyMember", callback, user, pass, requestCookie);
    },

    createLoyaltyCustomer : function(obj, callback, user, pass, requestCookie) {
    	
    	var personalinfo = obj.createProfileModel.oData.personalinfo;
    	var password = obj.createProfileModel.oData.password;
    	var passcode = obj.createProfileModel.oData.passcode;
    	
    	var token = obj.verificationCodeModel.oData.token;
    	var tokenType = obj.verificationCodeModel.oData.type;
   	
    	var hardcode = {
    			customer: {
    				orgUnitID: "0000",
    				blackListReason: "0",
    				active: "true",
    				test: "false",
    				riskCategoryId: "0",
    				customerTypeId: "2",
    				cancellationReasonId: "0",
    				txnReceiptModeId: "3",
    				addressType: "0",
    				addressStatus: "0",
    				identificationTypePhone: "0",
    				identificationTypeName: "5",
    				//identificationTypeName: "7",
    				credentialTypePIN: "0",
    				credentialTypePword: "1",
    				country: "US",
    				language: "en"
    			}
    		};

		var customer  = {
			orgUnitId: hardcode.customer.orgUnitID,
			blackListReason: hardcode.customer.blackListReason,
			active: hardcode.customer.active,
			test: hardcode.customer.test,
			displayName: personalinfo.firstname,
			riskCategoryId: hardcode.customer.riskCategoryId,
			customerTypeId: hardcode.customer.customerTypeId,
			cancellationReasonId: hardcode.customer.cancellationReasonId,
			txnReceiptModeId: hardcode.customer.txnReceiptModeId,
			language: hardcode.customer.language,
			country: obj.createProfileModel.oData.personalinfo.country
		};
		
		var identifications = [
		    { type: hardcode.customer.identificationTypePhone,
		      identification: personalinfo.phonenumber
			},
			
			{ type: hardcode.customer.identificationTypeName,
			  identification:  personalinfo.email
			}
		                       
		];
		
		var credentials = [
		    { type: hardcode.customer.credentialTypePIN,
		      credential: passcode.passcode
		    },
		      			
		    { type: hardcode.customer.credentialTypePword,
		      credential: password.password
		    }		                   
		];
    	
		var addresses = [{
		    addressType:  hardcode.customer.addressType,
		    addressStatus: hardcode.customer.addressStatus,
			firstName: personalinfo.firstname,
			lastName: personalinfo.lastname,
			email: personalinfo.email,
			zip : personalinfo.zipcode
		}];
		
    	var body = {
    		origin:"mLoyalty",
    		traceNo: UUIDv4(),
    		customer: customer,
    		identifications: identifications,
    		credentials: credentials,
    		addresses: addresses,
    		walletPIN: passcode.passcode
    		
	
    	};
    	
    	if ( tokenType !="" ){
    		body.token = token;
    	}

    	
        this.post(body, "CreateLoyaltyCustomer", callback, user, pass, requestCookie);
    },

    CreateCustomerWithoutToken : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "CreateCustomerWithoutToken", callback, user, pass, requestCookie);
    },

    createEmailToken : function(obj, callback, user, pass, requestCookie) {
    	var body = {
   			   origin:"mLoyalty",
  			   traceNo: UUIDv4(),
  			   msisdn: obj.oData.personalinfo.phonenumber,
  			   language: "en",
  			   email: obj.oData.personalinfo.email
     	};
    	
        this.post(body, "createEmailToken", callback, user, pass, requestCookie);
    },

    generateTemporaryCredential : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "generateTemporaryCredential", callback, user, pass, requestCookie);
    },

    createAddress : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "createAddress", callback, user, pass, requestCookie);
    },

    deleteAddress : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "deleteAddress", callback, user, pass, requestCookie);
    },

    getAddressByCustomer : function(obj, callback, user, pass, requestCookie) {
    	var body = {
    			origin:"mLoyalty",
      			traceNo: UUIDv4(),
      			customerId: loginResponseModel.customer.id,
      			addressType: "0"	
    	};
    	
    	//console.warn(body);
    	
        this.post(body, "getAddressByCustomer", callback, user, pass, requestCookie);
    },

    resetPassword : function(obj, callback, user, pass, requestCookie) {
    	var body = {
   			   origin:"mLoyalty",
  			   traceNo: UUIDv4(),
  			   userid: obj.oData.username    			
     	};
    	
    	this.post(body, "resetPassword", callback, user, pass, requestCookie);
    },

    getLoyaltyConfiguration : function(obj, callback, user, pass, requestCookie) {
    	
    	var body = {
  			   origin:"mLoyalty",
 			   traceNo: UUIDv4(),
 			   configParameter: obj    			
    	};
    	
        this.post(body, "getLoyaltyConfiguration", callback, user, pass, requestCookie);
    },

    createCustomerAttribute : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "createCustomerAttribute", callback, user, pass, requestCookie);
    },

    updateCustomerAttribute : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "updateCustomerAttribute", callback, user, pass, requestCookie);
    },

    deleteCustomerAttribute : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "deleteCustomerAttribute", callback, user, pass, requestCookie);
    },

    getCustomerAttribute : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getCustomerAttribute", callback, user, pass, requestCookie);
    },

    /* Function to get list of Unsubscribed Programs for a particular customer id */
    getNonSubscribedProgramsByCustomerId : function(obj, callback, user, pass, requestCookie) {
    	var body = {
 			   origin:"mLoyalty",
 			   traceNo: UUIDv4(),
 			   customerId: obj.customerId
    	}; 
    	
        this.post(body, "getNonSubscribedProgramsByCustomerId", callback, user, pass, requestCookie);
    },
    getMemberCardBackgroundImage : function(obj, callback, user, pass, requestCookie) {
    	var body = {
  			   origin:"mLoyalty",
  			   traceNo: UUIDv4(),
  			   cardType: obj
     	}; 
     	this.post(body, "getMemberCardBackgroundImage", callback, user, pass, requestCookie);
    },
    /*Anonymous callback for getting the background image in case of anonymous call*/
    getMemberCardAnonymousBackgroundImage : function(obj, callback, user, pass, requestCookie) {
    	var body = {
   			   origin:"mLoyalty",
   			   traceNo: UUIDv4(),
   			   
      	}; 
      	this.post(body, "getMemberCardBackgroundImage", callback, user, pass, requestCookie);
    },
    getSingleBrandAnonymousProgramInfo : function(obj, callback, user, pass, requestCookie) {
    	var body = {
    			   origin:"mLoyalty",
    			   traceNo: UUIDv4(),
    			   
       	}; 
       	this.post(body, "getSingleBrandAnonymousProgramInfo", callback, user, pass, requestCookie);
    },
    payInvoice : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "payInvoice", callback, user, pass, requestCookie);
    },

    capture : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "capture", callback, user, pass, requestCookie);
    },

    pickupmoney : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "pickupmoney", callback, user, pass, requestCookie);
    },

    confirmvoucher : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "confirmvoucher", callback, user, pass, requestCookie);
    },

    captureCancel : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "captureCancel", callback, user, pass, requestCookie);
    },

    authorisationCancel : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "authorisationCancel", callback, user, pass, requestCookie);
    },

    authorisation : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "authorisation", callback, user, pass, requestCookie);
    },

    preAuthorisation : function(obj, callback, user, pass, requestCookie) {
    	var body = {
  			   origin:"mLoyalty",
  			   traceNo: UUIDv4(),
  			   Payer : obj.payer,
  			   Payee : obj.payee,
  			   Amount : obj.amount,
  			   Text : obj. text,
  			   orderChannel : obj.orderChannel,
  			   autoCapture : true,
  			   usecase : obj.useCase
     	}; 
     	this.post(body, "preAuthorisation", callback, user, pass, requestCookie);
    },

    preAuthorisationContinue : function(obj, callback, user, pass, requestCookie) {
    	var body = {
   			   origin:"mLoyalty",
   			   traceNo: UUIDv4(),
   			   ReferenceTransaction : obj.ReferenceTransaction 
    	}
        this.post(body, "preAuthorisationContinue", callback, user, pass, requestCookie);
    },

    demandForPayment : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "demandForPayment", callback, user, pass, requestCookie);
    },

    startVoucher : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "startVoucher", callback, user, pass, requestCookie);
    },

    getInvoiceConfiguration : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getInvoiceConfiguration", callback, user, pass, requestCookie);
    },

    getInvoice : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getInvoice", callback, user, pass, requestCookie);
    },

    getInvoiceConfigurationsByCustomer : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getInvoiceConfigurationsByCustomer", callback, user, pass, requestCookie);
    },

    deleteInvoiceConfiguration : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "deleteInvoiceConfiguration", callback, user, pass, requestCookie);
    },

    updateInvoiceConfiguration : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "updateInvoiceConfiguration", callback, user, pass, requestCookie);
    },

    createInvoiceConfiguration : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "createInvoiceConfiguration", callback, user, pass, requestCookie);
    },

    createInvoice : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "createInvoice", callback, user, pass, requestCookie);
    },

    getAllInvoiceTypes : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getAllInvoiceTypes", callback, user, pass, requestCookie);
    },

    getInvoicesByCustomer : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getInvoicesByCustomer", callback, user, pass, requestCookie);
    },

    getInvoiceTypesByIssuer : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getInvoiceTypesByIssuer", callback, user, pass, requestCookie);
    },

    getInvoiceTypesByGroup : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getInvoiceTypesByGroup", callback, user, pass, requestCookie);
    },

    createInvoiceForInvoiceType : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "createInvoiceForInvoiceType", callback, user, pass, requestCookie);
    },

    cancelInvoice : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "cancelInvoice", callback, user, pass, requestCookie);
    },

    deleteBalanceAlert : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "deleteBalanceAlert", callback, user, pass, requestCookie);
    },

    getBalanceAlertByPaymentInstrument : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getBalanceAlertByPaymentInstrument", callback, user, pass, requestCookie);
    },

    createBalanceAlert : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "createBalanceAlert", callback, user, pass, requestCookie);
    },

    updateBalanceAlert : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "updateBalanceAlert", callback, user, pass, requestCookie);
    },

    getAddress : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getAddress", callback, user, pass, requestCookie);
    },

    createAddress : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "createAddress", callback, user, pass, requestCookie);
    },

    updateAddress : function(obj, callback, user, pass, requestCookie) {
    	var body = {
   			   origin:"mLoyalty",
 			   traceNo: UUIDv4(),
 			   address: obj
    	};
    	
        this.post(body, "updateAddress", callback, user, pass, requestCookie);
    },

    deleteAddress : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "deleteAddress", callback, user, pass, requestCookie);
    },

    getIdentifications : function(obj, callback, user, pass, requestCookie) {
		var body ={
			origin:"mLoyalty",
    		traceNo: UUIDv4(),
			customerId : obj,
			identificationTypeId : 0,
			includeInactive : false
		};
		
        this.post(body, "getIdentifications", callback, user, pass, requestCookie);
    },
	
    createIdentification : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "createIdentification", callback, user, pass, requestCookie);
    },

    deleteIdentification : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "deleteIdentification", callback, user, pass, requestCookie);
    },

    updateIdentification : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "updateIdentification", callback, user, pass, requestCookie);
    },

    createSmsToken : function(obj, callback, user, pass, requestCookie) {
    	var body = {
  			   origin:"mLoyalty",
 			   traceNo: UUIDv4(),
 			   msisdn: obj.oData.personalinfo.phonenumber,
 			   language: "en" 			   
    	};
        this.post(body, "createSmsToken", callback, user, pass, requestCookie);
    },

    getAttachmentsByCustomer : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getAttachmentsByCustomer", callback, user, pass, requestCookie);
    },

    getAttachment : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getAttachment", callback, user, pass, requestCookie);
    },

    deleteAttachment : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "deleteAttachment", callback, user, pass, requestCookie);
    },

    updateAttachment : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "updateAttachment", callback, user, pass, requestCookie);
    },

    cancelInvoice : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "cancelInvoice", callback, user, pass, requestCookie);
    },

    createCustomerAttribute : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "createCustomerAttribute", callback, user, pass, requestCookie);
    },

    updateCustomerAttribute : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "updateCustomerAttribute", callback, user, pass, requestCookie);
    },

    deleteCustomerAttribute : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "deleteCustomerAttribute", callback, user, pass, requestCookie);
    },

    getCustomerAttribute : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getCustomerAttribute", callback, user, pass, requestCookie);
    },

    generateTemporaryCredential : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "generateTemporaryCredential", callback, user, pass, requestCookie);
    },

    getOrgUnits : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getOrgUnits", callback, user, pass, requestCookie);
    },

    getLookups : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getLookups", callback, user, pass, requestCookie);
    },

    getRequiredPointsToClimbTiersForMember : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getRequiredPointsToClimbTiersForMember", callback, user, pass, requestCookie);
    },

    getSubscribedProgramAndMembershipDetailsByCustomerId : function(obj, callback, user, pass, requestCookie) {
	var body = {
	    origin:"mLoyalty",
	    traceNo: UUIDv4(),
	    customerId: obj.customer.id
	}
	
        this.post(body, "getSubscribedProgramAndMembershipDetailsByCustomerId", callback, user, pass, requestCookie);
    },

    getAllTierInfoForMember : function(obj, callback, user, pass, requestCookie) {
        var body = {
                origin: "mLoyalty",
                traceNo: UUIDv4(),
                membershipId: obj
            };

        this.post(body, "getAllTierInfoForMember", callback, user, pass, requestCookie);
    },

    getCurrMembershipTierForMember : function(obj, callback, user, pass, requestCookie) {
        var body = {
                origin: "mLoyalty",
                traceNo: UUIDv4(),
                membershipId: obj
            };

	
        this.post(body, "getCurrMembershipTierForMember", callback, user, pass, requestCookie);
    },

    getLoyaltyTiersByProgram : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getLoyaltyTiersByProgram", callback, user, pass, requestCookie);
    },

    getPointInfoForMember : function(obj, callback, user, pass, requestCookie) {
        var body = {
                origin: "mLoyalty",
                traceNo: UUIDv4(),
                membershipId: obj
            };
    	
    	
        this.post(body, "getPointInfoForMember", callback, user, pass, requestCookie);
    },

    getMemerbByCustomerId : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getMemerbByCustomerId", callback, user, pass, requestCookie);
    },

    deleteCoupon: function (obj, callback, user, pass, requestCookie) {
        var body = {
            origin: "mLoyalty",
            traceNo: UUIDv4(),
            couponInstanceId: obj

        };
        this.post(body, "deleteCoupon", callback, user, pass, requestCookie);
    },

    /* Function to show offers */
    getMyCoupons : function(obj, callback, user, pass, requestCookie) {
    	var body = {
  			   origin:"mLoyalty",
  			   traceNo: UUIDv4(),
  			   locale: obj.locale,
  			   mimeType: obj.mimeType
     	}; 

    	
    	this.post(body, "getMyCoupons", callback, user, pass, requestCookie);
    },
    
    getAnonymousOffers : function(obj, callback, user, pass, requestCookie) {
        
    	var body = {
        origin:"mLoyalty",
        traceNo: UUIDv4(),
        locale: obj.locale,
     	};
        
    	this.post(body, "getAnonymousOffers", callback, user, pass, requestCookie);
    },

    assignCoupon : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "assignCoupon", callback, user, pass, requestCookie);
    },

    getChildCategories : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getChildCategories", callback, user, pass, requestCookie);
    },

    getRootCategories : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getRootCategories", callback, user, pass, requestCookie);
    },

    getCategoryTree : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getCategoryTree", callback, user, pass, requestCookie);
    },

    getCouponTypesForCategory : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getCouponTypesForCategory", callback, user, pass, requestCookie);
    },

    findCouponTypesByTags : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "findCouponTypesByTags", callback, user, pass, requestCookie);
    },

    purchaseCoupon : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "purchaseCoupon", callback, user, pass, requestCookie);
    },

    checkInvoice : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "checkInvoice", callback, user, pass, requestCookie);
    },

    continueInvoice : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "continueInvoice", callback, user, pass, requestCookie);
    },

    getLineItemTransactionsByHeaderTxnId : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getLineItemTransactionsByHeaderTxnId", callback, user, pass, requestCookie);
    },

    getReportOfPointTransactionFilterByMemberAndDateRange : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getReportOfPointTransactionFilterByMemberAndDateRange", callback, user, pass, requestCookie);
    },

    getReportOfHeaderUserTransactionsForMembership : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getReportOfHeaderUserTransactionsForMembership", callback, user, pass, requestCookie);
    },

    getReportOfUserTransactionsForMembership : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getReportOfUserTransactionsForMembership", callback, user, pass, requestCookie);
    },

    /* Function to get Member Card Info */
    getMemberCards : function(obj, callback, user, pass, requestCookie) {
    	
    	var body = {
   			   origin:"mLoyalty",
 			   traceNo: UUIDv4(),
			    memberId: obj
    			
    	};
        this.post(body, "getMemberCards", callback, user, pass, requestCookie);
    },
    
    /*getMemberCardBackgroundImage : function(obj, callback, user, pass, requestCookie) {
    	var body = {
    			  origin : "mLoyalty",
    			  traceNo : UUIDv4(),
    			  
    	};
        this.post(body, "getMemberCardBackgroundImage", callback, user, pass, requestCookie);
    },*/

    /* Function to get MemberShip Reward */
    getMembershipReward : function(obj, callback, user, pass, requestCookie) {
    	
        var body = {
            origin:"mLoyalty",
            traceNo: UUIDv4(),
            membershipId: obj.membershipId
        };
   
        this.post(body, "getMembershipReward", callback, user, pass, requestCookie);
    },

    /* Function to get membership details from customerId */
    getMemberByCustomerId : function(obj, callback, user, pass, requestCookie) {
    	
    	var body = {
   			   origin:"mLoyalty",
 			   traceNo: UUIDv4(),
 			   customerId: obj
    	};
    	
    	this.post(body, "getMemberByCustomerId", callback, user, pass, requestCookie);
    },

    removeMemberCard : function(obj, callback, user, pass, requestCookie) {
	
	var body = {
			    origin:"mLoyalty",
    			   traceNo: UUIDv4(),
			   cardId: obj
	};

        this.post(body, "removeMemberCard", callback, user, pass, requestCookie);
    },

    /* Function to add Non Loyalty card by Card Number*/
    addNonLoyaltyCardByCardNumber : function(obj, callback, user, pass, requestCookie) {
    	
    	var body = {
  			   origin:"mLoyalty",
 			   traceNo: UUIDv4(),
 			   customerId : obj.customerId,
 			   cardNumber: obj.cardNumber,
 			   nameOnCard: obj.nameOnCard,
 			  expirationDate: obj.expirationDate
    	};
        this.post(body, "addNonLoyaltyCardByCardNumber", callback, user, pass, requestCookie);
    },


    GetReportOfPointTransactionsForMembership: function (obj, callback, user, pass, requestCookie) {

        var body = {
            origin: "mLoyalty",
            traceNo: UUIDv4(),
            membershipId: obj.membershipId,
 
        };
        this.post(body, "getReportOfPointTransactionsForMembership", callback, user, pass, requestCookie);
    },

    
    /* Function to get information on a particular card */
    showMemberFrontCard : function(obj, callback, user, pass, requestCookie) {
    	
    	var body = {
   			   origin:"mLoyalty",
 			   traceNo: UUIDv4(),
 			   cardId: obj.cardId,
 			   membershipId : obj.membershipId
    	};
    	
    		
    	
        this.post(body, "showMemberFrontCard", callback, user, pass, requestCookie);
    },

    showMemberRearCard : function(obj, callback, user, pass, requestCookie) {
    	var body = {
   			   origin:"mLoyalty",
 			   traceNo: UUIDv4(),
 			   cardId: obj.cardId
    	};
    	
        this.post(body, "showMemberRearCard", callback, user, pass, requestCookie);
    },

    /* Function to add non loyalty card by Image Capture */
    addNonLoyaltyCardByCardImage : function(obj, callback, user, pass, requestCookie) {
        
    	var body = {
   			   origin:"mLoyalty",
   			   traceNo: UUIDv4(),
   			   customerId: obj.customerId,
			   nameOnCard : obj.nameOnCard,
   			   cardFrontImageId: obj.cardFrontImageId,
   			   cardrearImageId: obj.cardrearImageId
      	};

    	this.post(body, "addNonLoyaltyCardByCardImage", callback, user, pass, requestCookie);
    },

    updateMemberCard : function(obj, callback, user, pass, requestCookie) {
    	var body = {
   			   origin:"mLoyalty",
   			   traceNo: UUIDv4(),
   			   card: obj
    	};
    	
        this.post(body, "UpdateMemberCard", callback, user, pass, requestCookie);
    },

    deleteShoppingList : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "deleteShoppingList", callback, user, pass, requestCookie);
    },

    getAllShoppingList : function(callback, user, pass, requestCookie) {
    	var body = {
    			origin:"mLoyalty",
       			traceNo: UUIDv4()
    	};
    	
        this.post(body, "getAllShoppingList", callback, user, pass, requestCookie);
    },
	
	getListInstancesForCustomer : function(obj, callback, user, pass, requestCookie){
		var body = {
			origin:"mLoyalty",
			traceNo: UUIDv4(),
		};
		this.post(body, "getListInstancesForCustomer", callback, user, pass, requestCookie);
	},
	

    deleteListItem : function(obj, callback, user, pass, requestCookie) {
    	var body = {
    			origin:"mLoyalty",
       			traceNo: UUIDv4(),
       			listItemId: obj
    	};
    	
        this.post(body, "deleteListItem", callback, user, pass, requestCookie);
    },

    getAllListItem : function(obj, callback, user, pass, requestCookie) {
    	var body = {
    		origin:"mLoyalty",
       		traceNo: UUIDv4(),
       		shoppingListId: obj
    	};
    	
        this.post(body, "getAllListItem", callback, user, pass, requestCookie);
    },

    createShoppingList : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "createShoppingList", callback, user, pass, requestCookie);
    },

    updateShoppingList : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "updateShoppingList", callback, user, pass, requestCookie);
    },

    createListItem : function(obj, callback, user, pass, requestCookie) {
    	var body = {
        		origin:"mLoyalty",
           		traceNo: UUIDv4(),
           		listItem: obj
    	};
    	
        this.post(body, "createListItem", callback, user, pass, requestCookie);
    },

    updateListItem : function(obj, callback, user, pass, requestCookie) {
    	var body = {
        		origin:"mLoyalty",
           		traceNo: UUIDv4(),
           		listItem: obj
    	};

        this.post(body, "updateListItem", callback, user, pass, requestCookie);
    },
    
    updateListData : function(obj, callback, user, pass, requestCookie) {
    	var body = {
        		origin:"mLoyalty",
           		traceNo: UUIDv4(),
           		listData: obj
    	};

        this.post(body, "updateListData", callback, user, pass, requestCookie);
    },
    
    getAllOffers: function(obj, callback, user, pass, requestCookie) {

    	var body = {
        		origin:"mLoyalty",
           		traceNo: UUIDv4(),
           		programId: obj.programId,
           		locale: obj.locale
           		
    	};
    	
    	this.post(body, "getAllOffersRequest", callback, user, pass, requestCookie);

    	
    },
    

    getActiveAlertNotificationMessages : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getActiveAlertNotificationMessages", callback, user, pass, requestCookie);
    },

    getActiveAlertTypes : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getActiveAlertTypes", callback, user, pass, requestCookie);
    },

    getAlertNotificationMessage : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getAlertNotificationMessage", callback, user, pass, requestCookie);
    },

    getAlertType : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getAlertType", callback, user, pass, requestCookie);
    },

    createAlertNotificationMessage : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "createAlertNotificationMessage", callback, user, pass, requestCookie);
    },

    updateAlertNotificationMessage : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "updateAlertNotificationMessage", callback, user, pass, requestCookie);
    },

    deleteAlertNotificationMessage : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "deleteAlertNotificationMessage", callback, user, pass, requestCookie);
    },

    getActiveAlertNotifMsgByAlertTypeAndNotifMsgType : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getActiveAlertNotifMsgByAlertTypeAndNotifMsgType", callback, user, pass, requestCookie);
    },

    findAlertTypeByName : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "findAlertTypeByName", callback, user, pass, requestCookie);
    },

    getCustomerAlert : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getCustomerAlert", callback, user, pass, requestCookie);
    },

    createCustomerOtherIdentification : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "createCustomerOtherIdentification", callback, user, pass, requestCookie);
    },

    updateCustomerOtherIdentification : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "updateCustomerOtherIdentification", callback, user, pass, requestCookie);
    },

    deleteCustomerOtherIdentification : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "deleteCustomerOtherIdentification", callback, user, pass, requestCookie);
    },

    getCustomerOtherIdentification : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getCustomerOtherIdentification", callback, user, pass, requestCookie);
    },

    getCustomerOtherIdentificationByCustomer : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getCustomerOtherIdentificationByCustomer", callback, user, pass, requestCookie);
    },

    deleteCustomerAlertByCustomerAndData : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "deleteCustomerAlertByCustomerAndData", callback, user, pass, requestCookie);
    },

    getCustomerContactPointByCustomerAlert : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getCustomerContactPointByCustomerAlert", callback, user, pass, requestCookie);
    },

    createCustomerBlackoutSchedule : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "createCustomerBlackoutSchedule", callback, user, pass, requestCookie);
    },

    updateCustomerBlackoutSchedule : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "updateCustomerBlackoutSchedule", callback, user, pass, requestCookie);
    },

    deleteCustomerBlackoutSchedule : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "deleteCustomerBlackoutSchedule", callback, user, pass, requestCookie);
    },

    getCustomerBlackoutScheduleByCustomer : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getCustomerBlackoutScheduleByCustomer", callback, user, pass, requestCookie);
    },

    removeBlackoutFromCustomerAlert : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "removeBlackoutFromCustomerAlert", callback, user, pass, requestCookie);
    },

    createCustomerAlert : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "createCustomerAlert", callback, user, pass, requestCookie);
    },

    updateCustomerAlert : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "updateCustomerAlert", callback, user, pass, requestCookie);
    },

    deleteCustomerAlert : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "deleteCustomerAlert", callback, user, pass, requestCookie);
    },

    findCustomerAlertByCustomer : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "findCustomerAlertByCustomer", callback, user, pass, requestCookie);
    },

    createCustomerContactPoint : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "createCustomerContactPoint", callback, user, pass, requestCookie);
    },

    getCustomerContactPoint : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getCustomerContactPoint", callback, user, pass, requestCookie);
    },

    deleteCustomerContactPoint : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "deleteCustomerContactPoint", callback, user, pass, requestCookie);
    },

    getCustomerBlackoutSchedule : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getCustomerBlackoutSchedule", callback, user, pass, requestCookie);
    },

    createCustomerBlackoutTime : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "createCustomerBlackoutTime", callback, user, pass, requestCookie);
    },

    getCustomerBlackoutTime : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "getCustomerBlackoutTime", callback, user, pass, requestCookie);
    },

    updateCustomerBlackoutTime : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "updateCustomerBlackoutTime", callback, user, pass, requestCookie);
    },

    deleteCustomerBlackoutTime : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "deleteCustomerBlackoutTime", callback, user, pass, requestCookie);
    },

    addBlackoutToCustomerAlert : function(obj, callback, user, pass, requestCookie) {
        this.post(obj, "addBlackoutToCustomerAlert", callback, user, pass, requestCookie);
    },
    
    getSubscribedProgramAndMemerbshipDetailsByCustomerId : function(obj, callback, user, pass, requestCookie) {
    	var body = {
        		origin:"mLoyalty",
           		traceNo: UUIDv4(),
           		customerId: obj.customer.id
    	};
    	
    	this.post(body, "getSubscribedProgramAndMemerbshipDetailsByCustomerId", callback, user, pass, requestCookie);
    },
    
    getStoreLocatorResults : function(obj, callback, user, pass, requestCookie) {
		if (obj.programId) {
			var body = {
				origin:"mLoyalty",
				traceNo: UUIDv4(),
				programId: obj.programId,
				location : {
					longitude : obj.location.longitude,
					latitude : obj.location.latitude
				},
				radius: obj.radius
			};
		}
		else{
			var body = {
				origin:"mLoyalty",
				traceNo: UUIDv4(),
				programCode : obj.programCode,
				location : {
					longitude : obj.location.longitude,
					latitude : obj.location.latitude
				},
			};
		}

        this.post(body, "getStoreLocatorResults", callback, user, pass, requestCookie);
    },
    getStoreOffers : function(obj, callback, user, pass, requestCookie) {
        var body = {
    			   origin:"mLoyalty",
    			   traceNo: UUIDv4(),
    			   storeId: obj,
    			   locale : navigator.language.split("-")[0]
       	};

         this.post(body, "getStoreOffers", callback, user, pass, requestCookie);
     },
    getStoreDetail: function(obj, callback, user, pass, requestCookie) {
        var body = {
   			   origin:"mLoyalty",
   			   traceNo: UUIDv4(),
   			   storeId: obj.storeId,
      	};

        this.post(body, "getStoreDetail", callback, user, pass, requestCookie);
    },
    
    getStoreSearch: function(obj, callback, user, pass, requestCookie) {
		if (obj.programId) {
			 var body = {
   			   origin:"mLoyalty",
   			   traceNo: UUIDv4(),
   			   programId : obj.programId,
   			   searchItem : obj.searchItem
			};
		}
        else{
			var body = {
   			   origin:"mLoyalty",
   			   traceNo: UUIDv4(),
   			   programCode : obj.programCode,
   			   searchItem : obj.searchItem
			};
		}

        this.post(body, "getStoreSearch", callback, user, pass, requestCookie);
    },

    wantOffer: function(obj, callback, user, pass, requestCookie) {
    	var body = {
    			origin:"mLoyalty",
       			traceNo: UUIDv4(),
       			couponTypeid: obj.couponTypeid,
       			offerId : obj.offerId,
				amountPointsNeeded : obj.amountPointsNeeded,
				couponCaption : obj.couponCaption
    	};
    	
    	this.post(body, "wantOffer", callback, user, pass, requestCookie);
    	
    },
	
	getCatalogURL : function(obj, callback, user, pass, requestCookie) {
		var body = {
    			origin:"mLoyalty",
       			traceNo: UUIDv4(),
    	};
		
        this.post(body, "getCatalogURL", callback, user, pass, requestCookie);
    },
	
	getTransactionReceipt : function(obj, callback, user, pass, requestCookie) {
		var body = {
    			origin:"mLoyalty",
       			traceNo: UUIDv4(),
				transactionId : obj,
    	};
        this.post(body, "getTransactionReceipt", callback, user, pass, requestCookie);
    },
    
    GetListInstancesForMemberResponse : function(obj, callback, user, pass, requestCookie){
	var body = {
		origin:"mLoyalty",
		traceNo: UUIDv4(),
		membershipId: obj,	
	};
	this.post(body, "getListInstancesForMember", callback, user, pass, requestCookie);
    },

    CreateIndividualCustomListInstance : function(obj, callback, user, pass, requestCookie){
	var body = {
		origin:"mLoyalty",
       		traceNo: UUIDv4(),
		customListInstance : {
			memberId: obj.id,
			name: obj.title,
			/*description : obj.description,*/
		},
	};
	this.post(body, "createIndividualCustomListInstance", callback, user, pass, requestCookie);
    },
    CreateSharedCustomListInstance : function(obj, callback, user, pass, requestCookie){
	var body = {
		origin:"mLoyalty",
       		traceNo: UUIDv4(),
			customListInstance : {
			memberId: obj.id,
			name: obj.title,
			/*description : obj.description,*/
		},
	};
	this.post(body, "createSharedCustomListInstance", callback, user, pass, requestCookie);
    },
    //ONLY ABLE ADD SINGLE DATA AT TIME
    createListData : function(obj, callback, user, pass, requestCookie){
	var body = {
		origin:"mLoyalty",
       		traceNo: UUIDv4(),
		listData: {
			contentTypeId : 2,
			instanceId : obj.listId,
			dataStatusId : 1,
			title : obj.listData.title,
			freeText : obj.listData.description,
		},
	};
	this.post(body, "createListData", callback, user, pass, requestCookie);
    },
	
	
	createArrayOfListData : function(obj, callback, user, pass, requestCookie) {
	
		var list = [];
		for( i = 0; i<obj.list.listData.length; i++) {
			var temp = {
				contentTypeId : obj.list.listData[i].contentTypeId,
				entitySourceId: obj.list.listData[i].entitySourceId,
				entityId : obj.list.listData[i].id_entity,
				instanceId : obj.listId,
				dataStatusId : 1,
				title : obj.list.listData[i].title,
				freeText : obj.list.listData[i].description,
			}
			list.push(temp);
		}
		var body = {
			origin:"mLoyalty",
       		traceNo: UUIDv4(),
			listData:list,
		}
		//console.log(body);
		this.post(body, "createArrayOfListData", callback, user, pass, requestCookie);
	},
	
	createIndividualCustomListInstanceWithListData : function(obj, callback, user, pass, requestCookie) {
	
	var list = [];
		for( i = 0; i<obj.list.listData.length; i++) {
			var temp = {
				contentTypeId : 2,
				dataStatusId : 1,
				title : obj.list.listData[i].title,
				freeText : obj.list.listData[i].description,
				entityId : obj.list.listData[i].id_entity,
			}
			list.push(temp);
		}
		var body = {
			origin:"mLoyalty",
       		traceNo: UUIDv4(),
			customListInstance : {
									name: obj.title,
								},
			listData:list,
			}
		this.post(body, "createIndividualCustomListInstanceWithListData", callback, user, pass, requestCookie);
	
	},
	
	createSharedCustomListInstanceWithListData : function(obj, callback, user, pass, requestCookie) {
	
		var list = [];
		for( i = 0; i<obj.list.listData.length; i++) {
			var temp = {
				contentTypeId : 2,
				dataStatusId : 1,
				title : obj.list.listData[i].title,
				freeText : obj.list.listData[i].description,
				entityId : obj.list.listData[i].id_entity,
			}
			list.push(temp);
		}
		var body = {
			origin:"mLoyalty",
       		traceNo: UUIDv4(),
			customListInstance : {
									//memberId: obj.id,
									name: obj.title,
								},
			listData:list,
			}
			
		this.post(body, "createSharedCustomListInstanceWithListData", callback, user, pass, requestCookie);
	},
	
    deleteListInstance : function(obj, callback, user, pass, requestCookie) {
	var body = {
		origin:"mLoyalty",
       		traceNo: UUIDv4(),
		id: obj,
	};
	this.post(body, "deleteListInstance", callback, user, pass, requestCookie);
    },
    getListDataForList : function (obj, callback, user, pass, requestCookie){
	var body = {
		origin:"mLoyalty",
       		traceNo: UUIDv4(),
		listInstanceId: obj,
	};
	this.post(body, "getListDataForList", callback, user, pass, requestCookie);
    },
    deleteListData : function (obj, callback, user, pass, requestCookie){
	var body = {
		origin:"mLoyalty",
       		traceNo: UUIDv4(),
		id: obj,
	};
	this.post(body, "deleteListData", callback, user, pass, requestCookie);
    },
    getStoreCheckinInfo : function (obj, callback, user, pass, requestCookie){
		if (obj.storeCode) {
			var body = {
				origin:"mLoyalty",
				traceNo: UUIDv4(),
				storeCode : obj.storeCode, //temp on Siri server SW1
			};	
		}
		else{
			var body = {
				origin:"mLoyalty",
				traceNo: UUIDv4(),
				storeId : obj.storeId, //temp on Siri server SW1
			};
		}
		this.post(body, "getStoreCheckinInfo", callback, user, pass, requestCookie);
    },
	
    createPickListData : function (obj, callback, user, pass, requestCookie){
	var body = {
		origin:"mLoyalty",
       		traceNo: UUIDv4(),
		listInstance : obj.listID,
		memberId : obj.memberID,
	};	
	this.post(body, "createPickListData", callback, user, pass, requestCookie);
    },
	
	checkinStoreAndCreatePickList : function (obj, callback, user, pass, requestCookie){
	var body = {
		origin:"mLoyalty",
       	traceNo: UUIDv4(),
		storeId: obj.storeId,
		listInstance : obj.listID,
		};	
		this.post(body, "checkInStoreAndCreatePickList", callback, user, pass, requestCookie);
    },
	
	addSingleItemInBasket : function (obj, callback, user, pass, requestCookie){
		basketItem = {
			gtin : obj.gtin,
            quantity :obj.quantity,
            unitOfMeasurement : obj.unitOfMeasurement,
            totalAmount : obj.totalAmount,
			listDataItemId : obj.listId,
		};
		var body = {
		origin:"mLoyalty",
       	traceNo: UUIDv4(),
		basketItem : basketItem,
		inactivityPeriod : this.getInactivityPeriod(),
		};	
		this.post(body, "addSingleItemInBasket", callback, user, pass, requestCookie);
	
	},
	
	removeListOfItemsFromBasket : function (obj, callback, user, pass, requestCookie){
		basketItemId = [obj.basketItemId];
		listDataItemId = [obj.listId];
		var body = {
			origin:"mLoyalty",
			traceNo: UUIDv4(),
			basketItemId : basketItemId,
			listDataItemId : listDataItemId,
			inactivityPeriod : this.getInactivityPeriod(),
		};	
		this.post(body, "removeListOfItemsFromBasket", callback, user, pass, requestCookie);
	
	},
	
	checkOutFromStore : function (obj, callback, user, pass, requestCookie){
		var body = {
			origin:"mLoyalty",
	       	traceNo: UUIDv4(),
			terminalId : obj,
			inactivityPeriod : this.getInactivityPeriod(),
		};	
		this.post(body, "checkoutFromStore", callback, user, pass, requestCookie);
	
	},
	
	 abortShopping : function(obj, callback, user, pass, requestCookie) {
		 
		 var body = {
					origin:"mLoyalty",
			       	traceNo: UUIDv4(),
			       	inactivityPeriod : this.getInactivityPeriod(),
				};	
	     this.post( body , "abortShopping", callback, user, pass, requestCookie);
	},
	
	authenticatePosTransaction : function(obj, callback, user, pass, requestCookie) {
		var body = {
		origin:"mLoyalty",
       	traceNo: UUIDv4(),
		transactionId : obj.transactionId,
		credential : obj.credential,
		};	
        this.post(body, "authenticatePosTransaction", callback, user, pass, requestCookie);
    },
	
	 getOpenPosTransaction : function(obj, callback, user, pass, requestCookie) {
	 
		var body = {
		origin:"mLoyalty",
       	traceNo: UUIDv4(),
		basketId : obj,
		maxWaitSeconds : '3',
		};	
        this.post(body, "getShoppingOpenPosTransaction", callback, user, pass, requestCookie);
    },
	
    decodeBarcode : function (obj, callback, user, pass, requestCookie){
		var body = {
			origin:"mLoyalty",
				traceNo: UUIDv4(),
			format : obj.format,
			text : obj.text,
		};
		
		this.post(body, "decodeBarcode", callback, user, pass, requestCookie);
    },
	decodeBarcodeAndUpdatePickList : function(obj, callback, user, pass, requestCookie) {
	
		var body = {
			origin:"mLoyalty",
			traceNo: UUIDv4(),
			format : obj.format,
			text : obj.text,
			storeId : obj.storeId,
			listInstance : obj.listID,
			inactivityPeriod : this.getInactivityPeriod(),
		};
        this.post(body, "decodeBarcodeAndUpdatePickList", callback, user, pass, requestCookie);
    },
	
	getAllConfigurationParameters : function (obj, callback, user, pass, requestCookie){
		var body = {
			origin:"mLoyalty",
			traceNo: UUIDv4(),
		};
		
		this.post(body, "getAllAppConfiguration", callback, user, pass, requestCookie);
    },
	getPreferredStoreForMember : function(obj, callback, user, pass, requestCookie){
		var body = {
			origin:"mLoyalty",
			traceNo: UUIDv4(),
		};
		this.post(body, "getPreferredStoreForMember", callback, user, pass, requestCookie);
	},
	createUpdatePreferredStoreForMember : function(obj, callback, user, pass, requestCookie){
		var body = {
			origin:"mLoyalty",
			traceNo: UUIDv4(),
			storeId : obj,
		};
		this.post(body, "createUpdatePreferredStoreForMember", callback, user, pass, requestCookie);
	},
	getOffersForArticle : function(obj, callback, user, pass, requestCookie){
		if (obj.gtin) {
			var body = {
				origin:"mLoyalty",
				traceNo: UUIDv4(),
				GTIN : obj.gtin,
				locale : navigator.language.split("-")[0],
			};	
		}
		else if (obj.id){
			var body = {
				origin:"mLoyalty",
				traceNo: UUIDv4(),
				articleId : obj.entityId,
				locale : navigator.language.split("-")[0],
			};	
		}
		
		this.post(body, "getOffersForArticle", callback, user, pass, requestCookie);
	},
};

function isRESTStatusCodeCorrect(response) {
	//console.warn(response);
	return (response.Status.code == '0');
}

UUIDv4 = function b(a){return a?(a^Math.random()*16>>a/4).toString(16):([1e7]+-1e3+-4e3+-8e3+-1e11).replace(/[018]/g,b)};

function  checkErrorStatus(response){
    util.closeBusyDialog();
    if (response == '401'){
	logWarning("error_message_server_response_401", "401 Status", "check POST");
	app.to(ID_LOGIN_PAGE);
    }
    else if (response == '500' ){
	logWarning("error_message_server_response_500", "500 Status", "check POST");
    }
    else{
	return;
    }
}

function checkErrorMobiliserStatus( response){
	util.closeBusyDialog();
	
	var statusCode = response.Status.code;
	if (statusCode == 201 ){
		if (response.Status.value == "GENERIC ENTITY NOT FOUND") {
			logError( "Please Check Sever Configuration", "Please Check Sever Configuration", "Please Check Sever Configuration");
		}
		else if (response.Status.value == "Mobiliser customer object for Store could not be found") {
			logError( "Not Found", "Not Found", "Not Found");
		}
		else
			logError( oBundle.getText("error_message_user_DNE"), "User does not exist", "login");
	}
	else if (statusCode == 204) {
		logError( oBundle.getText("invalid_Barcode"), "Invalid Barcode", "Invalid Barcode" );
	}
	else if ( statusCode == 302 ){
		util.customDialogWithButton( oBundle.getText("error_message_302_blacklisted") );
		//logError( oBundle.getText("error_message_302_blacklisted"), "user blacklisted", "login" );
	}
	else if ( statusCode == 324 ){
		logError( oBundle.getText("password_too_weak") );  
	}
	else if ( statusCode == 328){
		logError( oBundle.getText("error_message_credential_short"), "credentials too short", "" );
	}
	else if ( statusCode == 329 ){
		logError( oBundle.getText("error_message_app_not_recognize_user_or_pass"), "credentials do not match", "login" );
	}
	else if (statusCode == 330){
		logError ( oBundle.getText("too_many_attempts"), "too many incorrect login attempts", "too many incorrect login attempts");
		if (userCredentialSettingsController == undefined) {
			userCredentialSettingsController = sap.ui.controller("app.ui.settings.userCredentialSettings");
        }
		userCredentialSettingsController.SignOut();
	}
	else if ( statusCode == 331 ){
		util.customDialogWithButton( oBundle.getText("error_message_pw_expired") );
	}
	else if ( statusCode == 334){
		logError( oBundle.getText("error_message_PW_previously_used"), "Password in User Credential Update", "User Update");
	}
	else if ( statusCode == 351 ){
		logError("error_message_too_many_open_sessions", "too may open sessions with this user", "loginBack");
	}
	else if ( statusCode == 403){
		logError("error_message_user_email_forgot_pw", "User Email not found", "User not Found");
	}
	else if (statusCode == 1001){
		logError(response.Status.value, "illegal request, text based on text sent by server", "RestService");
	}
	else if (statusCode == 1222){
		logError("User Resource denied", "is not allowed to access resources of User", "BACK END TO INVESTIGATE");
	}
	else if (statusCode == 2522){
		logError("error_message_user_email_invalid_emailToken", "EmailToken is invalid or expired.", "EmailToken is invalid or expired.");
	}
	else if (statusCode == 3002) {
		logError( "error_no_coupon_left", "No more Coupons for Offer left", "No more coupons for Offer left" );
	}
	else if (statusCode == 6432) {
		logError( "invalid_store", "Invalid Store", "Checked in store mobile payment is not enabled." );
	}
	else if (statusCode == 9935) {
		logError( "ORACLE DATABASE ERROR", "No more Coupons for Offer left", "ORACLE DATABASE ERROR" );
	}
	else{
		logError( oBundle.getText("unexpected_error"), "status code not handled in checkErrorMobiliserStatus", "unknown component");
	}
}
