sap.ui.controller('app.ui.addcard.addExistingCardController', {
        onAfterRendering: function(){

	},
	
	displayInputPinScreen: function() {
		if(pinScreenController == undefined) pinScreenController = sap.ui.controller("app.ui.addcard.pinScreenController");
		pinScreenController.displayInputPinScreen(null, this.handleDoneForRequiredField, this.handleCancelForRequiredField);
		//this.createInputPinScreen();
	},

	displayAddExistingCardPage: function() {
		if(!app.getPage(ADD_EXISTING_CARD_PAGE)) {

			var addExistingCardDetailsView = sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.addcard.addExistingCardView",
				controller : this
			});

			var addExistingCardPage = new sap.m.Page(ADD_EXISTING_CARD_PAGE, {
				title : oBundle.getText("add_existing_card"),
				content : [ addExistingCardDetailsView ],
				showNavButton : false
			});

			addExistingCardModel = new sap.ui.model.json.JSONModel();
			addExistingCardPage.setModel(addExistingCardModel);
			app.addPage(addExistingCardPage);

		}
		
		var cardType = cardPickerController.listData.programs[selectedProgramIndex].cardtype;
		
		var typeOfField = "Text";
		var expirationDateLabelVisibility = false;
		var expirationDateNoLabel = true;
		 if(window.cordova) {
			 if(window.device.platform === "iOS") {
				 typeOfField = "Date";
				 expirationDateLabelVisibility = (cardType.isCaptureExpiryDate === true);
				 expirationDateNoLabel = false;
			 }
		 }

	
		cardInputData = {
				details:	   {
					cardNumber: "",
					expirationDate: "",
					nameOnCard: "",
					pin: "",
					typeOfField: typeOfField,
					expirationDateLabelVisibility: expirationDateLabelVisibility,
					expirationDateNoLabel: expirationDateNoLabel,
					failureMessage: "",
					isCaptureExpiryDate: cardType.isCaptureExpiryDate === true,
					isCaptureMembershipId: cardType.isCaptureMembershipId === true,
					isCaptureName: cardType.isCaptureName === true,
					isCapturePin: cardType.isCapturePin === true
				}
		};
		
		if( userState['BRANDTYPE'] == "single"){
				cardInputData.details.isCaptureMembershipId = true;
		}
		
		addExistingCardModel.setData(cardInputData);		
		app.to(ADD_EXISTING_CARD_PAGE);
		//this.attachNativeDatePicker();
		
		// Attaching the browser event to make the pin container clickable on tap.
		app.getPage(ADD_EXISTING_CARD_PAGE).getContent()[0].byId("add_existing_card_input_pin_container").attachBrowserEvent("click", function() { 
            addExistingCardController.displayInputPinScreen();   
        });
		
	},
	
	cancelAddExistingCard: function() {
		app.back();
		if(cardPickerController.isSingleBrandLoading) {
			cardPickerController.attachSingleBrandAddCardPopup();
		}
	},
	
	displayCreatedCardPage: function() {
		
		var inputCardDetails = cardInputData.details;
		
		if(inputCardDetails.isCaptureMembershipId && inputCardDetails.cardNumber == "") {
			cardInputData.details.failureMessage = oBundle.getText("enter_card_number");
			addExistingCardModel.setData(cardInputData);
			return;
		}
		
		if(inputCardDetails.isCaptureExpiryDate && inputCardDetails.expirationDate == "") {
			cardInputData.details.failureMessage = oBundle.getText("enter_expiration_date");
			addExistingCardModel.setData(cardInputData);
			return;
		}

		if(inputCardDetails.isCaptureName && inputCardDetails.nameOnCard == "") {
			cardInputData.details.failureMessage = oBundle.getText("enter_name_on_card");
			addExistingCardModel.setData(cardInputData);
			return;
		}
		
		if(inputCardDetails.isCapturePin && inputCardDetails.pin == "") {
			cardInputData.details.failureMessage = oBundle.getText("enter_pin");
			addExistingCardModel.setData(cardInputData);
			return;
		}
		var newDate = new Date(inputCardDetails.expirationDate);
        var current_date = newDate.getDate();
        var current_month = newDate.getMonth()+1; 
        var current_year = newDate.getFullYear();
        
        var expirationDate = current_year+"-"+current_month+"-"+current_date;

		if (inputCardDetails.isCaptureExpiryDate && (new Date(inputCardDetails.expirationDate).getTime() < new Date(Date.now()).getTime())) {
		    cardInputData.details.failureMessage = oBundle.getText("past_expiration_date");
		    addExistingCardModel.setData(cardInputData);
		    return;
		}
		
		var subscribeToProgramWithCardData = {
				programId: cardPickerController.listData.programs[selectedProgramIndex].id,
				customerId: loginResponseModel.customer.id,
				cardName: inputCardDetails.nameOnCard,
				cardNumber: inputCardDetails.cardNumber,
				cardPin: inputCardDetails.pin,
				
		};
		if(!(isNaN(expirationDate))){
			subscribeToProgramWithCardData.expDate = expirationDate;
		}
		SmartphoneService.subscribeToProgramWithCard( subscribeToProgramWithCardData, addExistingCardController.subscribeToProgramWithCardBack, null, null, true);
		
		// This needs to be optimized to pass the correct details and the image. This will be done by setting new data for this screen.
		if (cardCreatedController == undefined) cardCreatedController = sap.ui.controller("app.ui.addcard.cardCreatedController");
		cardCreatedController.displayCreatedCardPage(true);
		$(".photoBorder").html("");
		$(".photoBorder").css("border", "");
		$(".photoBorder").css("background-color", "");


		
	},
	
	subscribeToProgramWithCardBack: function(response, status) {
		if (status != 200) {
			checkErrorStatus(status);
			return;
		}

		if(isRESTStatusCodeCorrect(response)) {
			
			var responseModel = response;
			
			//Once we get the card template data, we need to extract and pass that also.			
			var createdCardPageModelData = app.getPage(CARD_CREATED_PAGE).getModel().oData;
			createdCardPageModelData.cardAdded = oBundle.getText("your_card_added");
			if(responseModel.CardInfo.templateFrontImage !== undefined && responseModel.CardInfo.templateFrontImage !== null) {
				var cardInfo = util.decode(responseModel.CardInfo.templateFrontImage);

				var cardName = cardPickerController.listData.programs[selectedProgramIndex].name;
				cardInfo = cardInfo.replace("{cardName}", cardName);
				cardInfo = cardInfo.replace("{cardHolderName}", responseModel.CardInfo.cardName);
				cardInfo = cardInfo.replace("{cardId}", responseModel.CardInfo.cardNumber);
				cardInfo = cardInfo.replace("{memberSince}", util.convertDateToReadableFormat(responseModel.Membership.startdate));
				cardInfo = cardInfo.replace("{expDate}", responseModel.CardInfo.expDate != null ? util.convertDateToReadableFormat(responseModel.Membership.enddate) : "");

				
				if(cardInputData.details.expirationDate !== null) {
					var expirationDateObj = new Date(cardInputData.details.expirationDate);
				    var dateCardFormat = expirationDateObj.getDate() + "/" + (expirationDateObj.getMonth() + 1) + expirationDateObj.getFullYear();
					cardInfo = cardInfo.replace("{expDate}", dateCardFormat);
				} else cardInfo = cardInfo.replace("{expDate}", "");

				//console.warn(cardInfo);
				$(".photoBorder").html("");
				$(".photoBorder").append(cardInfo.trim());
				//$(".photoBorder #CardFront").css("width", "320px");
				//$(".photoBorder #CardFront").css("height", "212px");
				//$(".photoBorder #CardFront").css("background-size", "320px 212px");
				$(".photoBorder").css("border", "0px");
				$(".photoBorder").css("background-color", "transparent");
			}
			
			/*
			 * The objective of createdCardObject is to keep track of the newly added card. As per the new requirements, user can launch the preferences
			 * from the Card Added confirmation age. After the preferences screens, we need to show the user the card details screen which comes after wallet
			 * in multibrand scenario and comes from MyCard in single brand scenario. To launch the card detail screen, we will need this createdCardObject.
			 */
			var createdCardObject = {
					cardId: responseModel.CardInfo.customerCardId,
					membershipId: responseModel.Membership.id,
					programId: cardPickerController.listData.programs[selectedProgramIndex].id,
			};
			cardCreatedController.updateCreatedCardObject(createdCardObject);
			
			app.getPage(CARD_CREATED_PAGE).getModel().setData(createdCardPageModelData);
			
			//sliderMenuController.updateOffersWithAddedCard();
			if (cardPickerController !== undefined) cardPickerController.updateCardsListAfterAddingCard();
			

		} else {
			checkErrorMobiliserStatus(response);
		}
		
	},

	handleCancelForRequiredField: function() {
		app.back();
		var cancelFieldModelData = inputRequiredField.getModel().oData;	
		cancelFieldModelData.inputFieldValue = oldFieldValue;
	},

	handleDoneForRequiredField: function() {
		app.back();
		var returnedModelData = inputRequiredField.getModel().oData;
		var inputValueReturnedModelData = returnedModelData.inputFieldValue;
		var returnedInputValueType = returnedModelData.type;

		cardInputData.details.pin = inputValueReturnedModelData;
		addExistingCardModel.setData(cardInputData);
		
//clear pin from adding existing card
		var dataForEnterPinScreen = app.getPage(ENTER_ONE_FIELD_PAGE).getModel().getData();
		dataForEnterPinScreen.inputFieldValue = "";
		app.getPage(ENTER_ONE_FIELD_PAGE).getModel().setData(dataForEnterPinScreen)
		
		//console.warn(cardInputData);

	},
	
	 // Attaches the Native Date Picker functionality with the Expiration Date Field
	 /*attachNativeDatePicker: function() {
		 // Sometimes the page gets re-created and sometimes reused
		 // So before attaching an event, we need to be sure that we do not attach the same event again.
		 // window.cordova check done so that Phonegap related code runs in Mobile application only
		 if(window.cordova) {
			 if(window.device.platform === "iPhone" || window.device.platform === "iOS") {
//				 
//				 $(".nativedatepicker.add_existing_card_control_spacing").off("focus", this.convertIOSExpirationFieldToDate);
//				 $(".nativedatepicker.add_existing_card_control_spacing").on("focus", this.convertIOSExpirationFieldToDate);
//				 
//				 $(".nativedatepicker.add_existing_card_control_spacing").off("blur", this.convertIOSExpirationFieldToText);
//				 $(".nativedatepicker.add_existing_card_control_spacing").on("blur", this.convertIOSExpirationFieldToText);

			 } else {
//				 $('.nativedatepicker').off('click', this.handleTapOnDateField);
//				 $('.nativedatepicker').on('click', this.handleTapOnDateField);
				 app.getPage(ADD_EXISTING_CARD_PAGE).getContent()[0].byId("add_existing_card_expirationDateInput_android").detachBrowserEvent("click", addExistingCardController.handleTapOnDateField);
				 app.getPage(ADD_EXISTING_CARD_PAGE).getContent()[0].byId("add_existing_card_expirationDateInput_android").attachBrowserEvent("click", addExistingCardController.handleTapOnDateField);

			 }
		 }
	 },*/
	 
	 /*convertIOSExpirationFieldToDate: function() {
		 // jQuery does not do type change as IE does not support it.
		 $(this).children()[0].type = "date";
	 },
	 
	 convertIOSExpirationFieldToText: function() {
		// jQuery does not do type change as IE does not support it.
		 $(this).children()[0].type = "text";
	 }, 
	 

	 // Handler for tap on Expiration Date field
	 handleTapOnDateField: function(event) {
			
		 	// This PhoneGap call will close the NativeKeyBoard which might be displayed in the screen before displaying the date picker.
			window.plugins.nativeKeyBoard.closeKeyBoard(function(obj){
				// Don't know but console.log does not work here
				// However any code written here will get executed on success
			}, function(obj){
				// Code in case of failures
			});
			var inputField = app.getPage(ADD_EXISTING_CARD_PAGE).getContent()[0].byId("add_existing_card_expirationDateInput_android").getDomRef();

	        var currentField = $(inputField).children();
	        currentField.blur();
	        var myNewDate = null;
	        if (cardInputData.details.expirationDate != "") {
	        	myNewDate = new Date(Date.parse(cardInputData.details.expirationDate));
	        } else {
	        	myNewDate = new Date();
	        }
	        
	        var dateValue = (myNewDate.getMonth() + 1) + "/" + (myNewDate.getDate()) + "/" + (myNewDate.getFullYear());
	        var data = {
	        	date: dateValue	
	        };
	        
	       window.plugins.nativeDatePickerPlugin.action(function(returnDate) {
	            var newDate = new Date(returnDate);
	            var current_date = newDate.getDate();
	            var current_month = newDate.getMonth() + 1; 
	            var current_year = newDate.getFullYear();
	            //currentField.val(current_year + "-" + current_month + "-" + current_date);

	            currentField.blur();
	            cardInputData.details.expirationDate = current_year+"-"+current_month+"-"+current_date;
	            addExistingCardModel.setData(cardInputData);
	            
	        }, function(failureMessage){
	        	//console.warn("Failed to open the Native Android Date Picker");
	        }, data);

	 },*/
	 
});

function launchPINEntry(){
		addExistingCardController.displayInputPinScreen()
}