sap.ui.controller('app.ui.addcard.addOtherCardController', {
	
	otherCardCaptureSettings: null,
	
   	onAfterRendering: function(){ 

	},
	
	// Used to create add other card page
	displayAddOtherCardPage: function() {
	   if(app.getPage(ADD_OTHER_CARD_PAGE) == null ) {
		var addOtherCardButtonsView = sap.ui.view({
			type : sap.ui.core.mvc.ViewType.XML,
			viewName : "app.ui.addcard.addOtherCardView",
			controller : this
	    });
		
	    var addOtherCardPage = new sap.m.Page(ADD_OTHER_CARD_PAGE, {
			title : oBundle.getText("add_other_card"),
			content : [ addOtherCardButtonsView ],
			showNavButton : false
		});
	    
	    app.addPage(addOtherCardPage);
	   }
	    app.to(ADD_OTHER_CARD_PAGE);
	},
	
    // Used to create and display add card info page
	displayAddCardInfoPage: function() {
		
		if(app.getPage(ADD_OTHER_CARD_INPUT_PAGE) == null ) {
			var addOtherCardInputInfoView = sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.addcard.addOtherCardInputInfoView",
				controller : this
			});
			
			var addOtherCardInputInfoPage = new sap.m.Page(ADD_OTHER_CARD_INPUT_PAGE, {
				title : oBundle.getText("input_details"),
				content : [ addOtherCardInputInfoView ],
				showNavButton : false
			});
			
			app.addPage(addOtherCardInputInfoPage);
		}
		
		var typeOfField = "Text";
		var expirationDateLabelVisibility = false;
		var expirationDateNoLabel = true;
		 if(window.cordova) {
			 if(window.device.platform === "iOS") {
				 typeOfField = "Date";
				 expirationDateLabelVisibility = (this.otherCardCaptureSettings.cardtype.isCaptureExpiryDate === true);
				 expirationDateNoLabel = false;
			 }
		 }

		
		otherCardInputData = {
				details:	   {
					cardNumber: "",
					expirationDate: "",
					nameOnCard: "",
					typeOfField: typeOfField,
					expirationDateLabelVisibility: expirationDateLabelVisibility,
					expirationDateNoLabel: expirationDateNoLabel,
					failureMessage: "",
					isCaptureExpiryDate: this.otherCardCaptureSettings.cardtype.isCaptureExpiryDate === true,
					isCaptureMembershipId: this.otherCardCaptureSettings.cardtype.isCaptureMembershipId === true,
					isCaptureName: this.otherCardCaptureSettings.cardtype.isCaptureName === true,
					isCapturePin: this.otherCardCaptureSettings.cardtype.isCapturePin === true
				}
		};

		addOtherCardModel = new sap.ui.model.json.JSONModel();
		addOtherCardModel.setData(otherCardInputData);
		app.getPage(ADD_OTHER_CARD_INPUT_PAGE).setModel(addOtherCardModel);
	
		app.to(ADD_OTHER_CARD_INPUT_PAGE);
		//this.attachNativeDatePicker();

	},
	
	doneInputAddCardInfo: function() {
		
		var otherCardInputDetails = otherCardInputData.details;
		if( otherCardInputDetails.isCaptureMembershipId && otherCardInputDetails.cardNumber == "") {
			otherCardInputDetails.failureMessage = oBundle.getText("enter_card_number");
			addOtherCardModel.setData(otherCardInputData);
			return;
		}
		
		if( otherCardInputDetails.isCaptureExpiryDate && otherCardInputDetails.expirationDate == "") {
			otherCardInputDetails.failureMessage = oBundle.getText("enter_expiration_date");
			addOtherCardModel.setData(otherCardInputData);
			return;
		}
		
		if( otherCardInputDetails.isCaptureName && otherCardInputDetails.nameOnCard == "") {
			otherCardInputDetails.failureMessage = oBundle.getText("enter_name_on_card");
			addOtherCardModel.setData(otherCardInputData);
			return;
		}
		
		addNonLoyaltyCardByCardNumberModel = new sap.ui.model.json.JSONModel();
		var expiryDate = new Date(otherCardInputDetails.expirationDate);
		var requestData = {
				customerId : loginResponseModel.customer.id,
				cardNumber: otherCardInputData.details.cardNumber,
				nameOnCard: otherCardInputData.details.nameOnCard,
		};
		if(!(isNaN(expiryDate))){
			requestData.expirationDate = expiryDate.getTime().toString();
		}
		addNonLoyaltyCardByCardNumberModel.setData(requestData);
		SmartphoneService.addNonLoyaltyCardByCardNumber( requestData, addOtherCardController.addNonLoyaltyCardByCardNumberBack, null, null, true);
		//proxy_login.AddNonLoyaltyCardByCardNumber(addOtherCardController.addNonLoyaltyCardByCardNumberBack, addNonLoyaltyCardByCardNumberModel);
		// This needs to be optimized to pass the correct details and the image. This will be done by setting new data for this screen.
		
		if (cardCreatedController == undefined) cardCreatedController = sap.ui.controller("app.ui.addcard.cardCreatedController");
		
		//Here need to call a web service and the response callback need to display the crated card page
		cardCreatedController.displayCreatedCardPage(true);
		$(".photoBorder").html("");
		$(".photoBorder").css("border", "");
		$(".photoBorder").css("background-color", "");
		

	},
	
	cancelInputAddCardInfo: function() {
		otherCardInputData = {
				details:	   {
					cardNumber: "",
					expirationDate: "",
					nameOnCard: "",
					failureMessage: ""
				}
		}
		addOtherCardModel.setData(otherCardInputData);
		app.back();
	},
	
	openAddOtherCardPage: function() {
		popupControlForAddOtherCard.removeFromPage();
		this.displayAddCardInfoPage();
		
	},	

	// Function to navigate to take card photo page and create if it does not exist
	takeCardPhoto: function() {
		popupControlForAddOtherCard.removeFromPage();
		
	  // Good approach to use such checks to use same pages again
	   if(takeCardPhotoController == undefined) takeCardPhotoController = sap.ui.controller("app.ui.addcard.takeCardPhotoController");
	   takeCardPhotoController.startCardCaptureScreenFlow();
	 } ,
	 
	 cancelAddOtherCard: function() {
		 popupControlForAddOtherCard.removeFromPage();
		 //app.back();
	 },
	 
	 addNonLoyaltyCardByCardNumberBack: function(response, status) {
			if (status != 200) {
                                 checkErrorStatus(status);
                                 return;
                         }

			if(isRESTStatusCodeCorrect(response)) {
				
				var createdCardPageModelData = app.getPage(CARD_CREATED_PAGE).getModel().oData;
				createdCardPageModelData.cardAdded = oBundle.getText("your_card_added");
				if(response.card.cardFrontImage !== undefined && response.card.cardFrontImage !== null) {
					var cardInfo = util.decode(response.card.cardFrontImage);
					//createdCardPageModelData.url = "data:image/jpg;base64," + response.card.cardFrontImage;
					cardInfo = cardInfo.replace("{cardHolderName}", otherCardInputData.details.nameOnCard);
					cardInfo = cardInfo.replace("{cardId}", otherCardInputData.details.cardNumber);
 

					$(".photoBorder").html("");
					$(".photoBorder").append(cardInfo.trim());
//					$(".photoBorder #CardFront").css("width", "320px");
//					$(".photoBorder #CardFront").css("height", "212px");
//					$(".photoBorder #CardFront").css("background-size", "320px 212px");
					$(".photoBorder").css("border", "0px");
					$(".photoBorder").css("background-color", "transparent");
					$(".cardMemSince").remove();

				}
				
				app.getPage(CARD_CREATED_PAGE).getModel().setData(createdCardPageModelData);
		
				


			} else {
				checkErrorMobiliserStatus(response);
			}	
			
			//No need to save this model as the response is required once only for the "Your card has been added" message
	 },
	 
	 displayOtherCardPopup: function() {
		 
		
		    var buttonsPanel = sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.addcard.addOtherCardbuttonsPanelView",
				controller : this
			    });
			    
			    popupControlForAddOtherCard = new PopupSliderControl({ content: [ buttonsPanel]});
		 
		 
		 popupControlForAddOtherCard.attachToPage(app.getCurrentPage(), popupControlForAddOtherCard);

	 },

	 // Attaches the Native Date Picker functionality with the Expiration Date Field
	 /*attachNativeDatePicker: function() {
		 // Sometimes the page gets re-created and sometimes reused
		 // So before attaching an event, we need to be sure that we do not attach the same event again.
		 // window.cordova check done so that Phonegap related code runs in Mobile application only
		 if(window.cordova) {
			 if(window.device.platform === "iPhone" || window.device.platform === "iOS") {
				 $('.nativedatepicker').off('focus', function(){ $(this).children().attr('type', "date");});
				 $('.nativedatepicker').on('focus', function(){ $(this).children().attr('type', "date");});
				 
				 $('.nativedatepicker').off('blur', function(){ $(this).children().attr('type', "text");});
				 $('.nativedatepicker').on('blur', function(){ $(this).children().attr('type', "text");});
//				 
				 
			 } else {
//				 $('.nativedatepicker').off('click', this.handleTapOnDateField);
//				 $('.nativedatepicker').on('click', this.handleTapOnDateField);
				 app.getPage(ADD_OTHER_CARD_INPUT_PAGE).getContent()[0].byId("add_other_card_expirationDateInput_android").detachBrowserEvent("click", addOtherCardController.handleTapOnDateField);
				 app.getPage(ADD_OTHER_CARD_INPUT_PAGE).getContent()[0].byId("add_other_card_expirationDateInput_android").attachBrowserEvent("click", addOtherCardController.handleTapOnDateField);

			 }
		 }
	 },

	 // Handler for tap on Expiration Date field
	 handleTapOnDateField: function(event) {
			
		 	// This PhoneGap call will close the NativeKeyBoard which might be displayed in the screen before displaying the date picker.
			window.plugins.nativeKeyBoard.closeKeyBoard(function(obj){
				// Don't know but console.log does not work here
				// However any code written here will get executed on success
			}, function(obj){
				// Code in case of failures
			});
			
			var inputField = app.getPage(ADD_OTHER_CARD_INPUT_PAGE).getContent()[0].byId("add_other_card_expirationDateInput_android").getDomRef();
			
	        var currentField = $(inputField).children();
	        currentField.blur();
	        var myNewDate = null;
	        if (otherCardInputData.details.expirationDate != "") {
	        	myNewDate = new Date(Date.parse(otherCardInputData.details.expirationDate));
	        } else {
	        	myNewDate = new Date();
	        }
	        
	        var dateValue = (myNewDate.getMonth() + 1) + "/" + (myNewDate.getDate()) + "/" + (myNewDate.getFullYear());
	        var data = {
	        	date: dateValue	
	        };
	        
	       window.plugins.nativeDatePickerPlugin.action(function(returnDate) {
	            var newDate = new Date(returnDate);
	            var current_date = newDate.getDate();
	            var current_month = newDate.getMonth() + 1; 
	            var current_year = newDate.getFullYear();
	            //currentField.val(current_year+"-"+current_month+"-"+current_date);
	            currentField.blur();
	            otherCardInputData.details.expirationDate = current_year+"-"+current_month+"-"+current_date;
	            addOtherCardModel.setData(otherCardInputData);
	        }, function(failureMessage){
	        	//console.warn("Failed to open the Native Android Date Picker");
	        }, data);

	 }*/

	 
	
});

