var walletController;
var cardCreatedPage;
sap.ui.controller('app.ui.addcard.cardCreatedController', {

	onAfterRendering: function(){ 

	},
	
	displayCreatedCardPage: function(resetData, data) {
		
		var isNotSingleBrand = true;
		
		/*if ( userState['BRANDTYPE'] == "single"){
			isNotSingleBrand = true;
		}*/
		var createdCardData = {
				cardAdded: oBundle.getText("your_card_being_added"),
				url: "",
				isNotSingleBrand: isNotSingleBrand,
				showHousehold: false,
				showPreferences: false,
		};

		if(!app.getPage(CARD_CREATED_PAGE) ) {

			createdCardPageModel = new sap.ui.model.json.JSONModel();
			createdCardPageModel.setData(createdCardData);

			var cardCreatedButtonsView = sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.addcard.cardCreatedButtonsView",
				controller : this
			});

			cardCreatedButtonsView.setModel(createdCardPageModel);


			cardCreatedPage = new sap.m.Page(CARD_CREATED_PAGE, {
				title : oBundle.getText("card_added"),
				content : [ cardCreatedButtonsView ],
				showNavButton : false
			});

			cardCreatedPage.setModel(createdCardPageModel);
			app.addPage(cardCreatedPage);
		}
		
		if(resetData && data) {
			// The below line does not work in some devices..probably a UI5 bug or device bug
			//createdCardData.url = data;
			cardCreatedPage.getModel().setData(createdCardData);
			
			// Using jQuery to make it work
			$(".photoBorder img").attr("src",data);
		} else if(resetData) {
			cardCreatedPage.getModel().setData(createdCardData);
			$(".photoBorder div").empty();
		}
		
		app.to(CARD_CREATED_PAGE);
	},
	
	reloadCardCreatedPage: function() {

		if(app.getPage(CARD_CREATED_PAGE)) {
			var cardCreatedButtonsView = sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.addcard.cardCreatedButtonsView",
				controller : this
			});

			app.getPage(CARD_CREATED_PAGE).removeAllContent();
			app.getPage(CARD_CREATED_PAGE).addContent(cardCreatedButtonsView);
		}

	},

	addAnotherCard: function() {
		if (allOffersController == undefined) allOffersController = sap.ui.controller("app.ui.offers.allOffersController");
		allOffersController.subscriptionChangesMade = true;
		sliderMenuController.getSubscribedProgramAndMembershipDetails();
		cardPickerController.launchCardPickerPage();
	},
	
	launchApp : function(){
		if (allOffersController == undefined) allOffersController = sap.ui.controller("app.ui.offers.allOffersController");
		if(selectedProgramIndex == -1) {
			allOffersController.displayAllOffersScreen();
			//Highlighting the All Offers menu item
			/*var allOffersMenuItem = sliderMenuController.sliderListView.byId("menuNavList").getItems()[0];
			setTimeout(function(){
				sliderMenuController.setSelectedItemForNavList(allOffersMenuItem);
			},500);*/
		} else {
			allOffersController.subscriptionChangesMade = true;
			util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
			SmartphoneService.getSubscribedProgramAndMembershipDetailsByCustomerId (  loginResponseModel, homepageController.hasCardsBack, null, null, true);
		}

	},
	
	/*
	 * The objective of createdCardObject is to keep track of the newly added card. As per the new requirements, user can launch the preferences
	 * from the Card Added confirmation age. After the preferences screens, we need to show the user the card details screen which comes after wallet
	 * in multibrand scenario and comes from MyCard in single brand scenario. To launch the card detail screen, we will need this createdCardObject.
	 */
	createdCardObject: null,
	updateCreatedCardObject: function(cardObject){
		this.createdCardObject = cardObject;
	},
	
	launchHousehold : function(){
		 
		 if(householdController==undefined){
			 householdController = sap.ui.controller("app.ui.household.household");
		 }
		 householdController.launchHouseholdPage(CARD_CREATED_PAGE);
	 },
	 
	 launchPreferences: function(){
		 var callback = function(response, status){
			 //console.log("response\n" + JSON.stringify(response));

			 if ( isRESTStatusCodeCorrect(response) ){
				 if (preferencesController == undefined)
					 preferencesController = sap.ui.controller("app.ui.preferences.preferences");

				 preferencesController.launchCardEnrollPreferences(response, cardCreatedController.createdCardObject);
			 }else{
				 util.closeBusyDialog();
				 logError("error_message_general", "Error in the response of getAllPreferences for programId " + cardCreatedController.createdCardObject.programId, "cardCreatedController");
			 }

		 }

		 SmartphoneService.getAllPreferences({ programId: cardCreatedController.createdCardObject.programId }, callback);

	 },
	
});
