sap.ui.controller('app.ui.addcard.pinScreenController', {
	
	
	actionOnDone: function(callback) {
		callback();
	},
	
	startInputPinScreenFlow: function() {

		// Check if Pin Input Screen flow is required or not
		var cardType = cardPickerController.listData.programs[selectedProgramIndex].cardtype;
		if (cardType.isCapturePin === true) {

			dataForEnterPinScreen = {
					inputFieldValue: "",
					placeHolderValue: oBundle.getText("set_card_pin"),
					labelValue: oBundle.getText("set_a_pin_number"),
					type: oBundle.getText("pin"),
					typeOfValue: "Password",
					nextButtonText: oBundle.getText("next"),
					maxLength:"8" 
			};

			dataForConfirmPinScreen = {
					inputFieldValue: "",
					placeHolderValue: oBundle.getText("confirm_card_pin"),
					labelValue: oBundle.getText("confirm_pin_number"),
					type: oBundle.getText("pin"),
					typeOfValue: "Password",
					nextButtonText: oBundle.getText("done"),
					maxLength: "8"
			},

			setPinScreenModel = new sap.ui.model.json.JSONModel();
			setPinScreenModel.setData(dataForEnterPinScreen);

			this.createInputPinScreen("setPinScreen", this.displayConfirmPinScreen, this.backToPreviousScreen);
			app.getPage("setPinScreen").setModel(setPinScreenModel);

			confirmPinScreenModel = new sap.ui.model.json.JSONModel();
			confirmPinScreenModel.setData(dataForConfirmPinScreen);

			this.createInputPinScreen("confirmPinScreen", this.createCardFromPin, this.backToPreviousScreen);
			app.getPage("confirmPinScreen").setModel(confirmPinScreenModel);

			app.to("setPinScreen");
			
		} else {
			this.sendNewCardRequest();
		}
	},
	
	backToPreviousScreen: function() {
		
		if(userState['BRANDTYPE'] == "single")
		{
			app.backToPage("singleBrandAddCardPage");
			cardPickerController.attachSingleBrandAddCardPopup();
		}
		else
		{
			app.backToPage(CARD_PICKER_PAGE);
		}
		
	},	
	
	displayConfirmPinScreen: function() {
		if(setPinScreenModel.oData.inputFieldValue != ""){
			app.to("confirmPinScreen");
		}
		else{
			var confirmDialog = new sap.m.Dialog({
				title : oBundle.getText("set_card_pin"),
				content : [new sap.m.Text({
					text : oBundle.getText("enter_card_pin")
				})],
				leftButton : new sap.m.Button({
					text : oBundle.getText("OK"),
					width : "100%",
					tap :function(){
						confirmDialog.close();
					}
				})
			});
			
			confirmDialog.open();
		}
	},
	
	resetPinSceens: function(){
		dataForEnterPinScreen = {
				inputFieldValue: "",
				placeHolderValue: oBundle.getText("set_card_pin"),
				labelValue: oBundle.getText("set_a_pin_number"),
				type: oBundle.getText("pin"),
				typeOfValue: "Password",
				nextButtonText: oBundle.getText("next"),
				maxLength: "8"
		};

		dataForConfirmPinScreen = {
				inputFieldValue: "",
				placeHolderValue: oBundle.getText("confirm_card_pin"),
				labelValue: oBundle.getText("confirm_pin_number"),
				type: oBundle.getText("pin"),
				typeOfValue: "Password",
				nextButtonText: oBundle.getText("done"),
				maxLength: "8"
		},
		setPinScreenModel.setData(dataForEnterPinScreen);

		app.getPage("setPinScreen").setModel(setPinScreenModel);

		confirmPinScreenModel.setData(dataForConfirmPinScreen);

		app.getPage("confirmPinScreen").setModel(confirmPinScreenModel);

		logError("error_PIN_not_match", "PIN's do not match", "PIN's do not match");
	},

	createCardFromPin: function() {
		if( !validatePIN() ){
		//on failing that PINs are not same reset value and re-ask for pins
			pinScreenController.resetPinSceens();
			app.back().back();	
		}
		else {
			
			pinScreenController.sendNewCardRequest();
		}

	},
	
	sendNewCardRequest: function() {
		var programId = cardPickerController.listData.programs[selectedProgramIndex].id;
		var customerId = loginResponseModel.customer.id;
		
		var subscribeToProgramData = {
				programId : programId,
				customerId : customerId
			};

		SmartphoneService.subscribeToProgram( subscribeToProgramData, pinScreenController.subscribeToProgramBack);
		//proxy_login.SubscribeToProgram(pinScreenController.subscribeToProgramBack, subscribeToProgramData);
		
		if(cardCreatedController == undefined) cardCreatedController = sap.ui.controller('app.ui.addcard.cardCreatedController');
		cardCreatedController.displayCreatedCardPage(true);
		$(".photoBorder").html("");
		$(".photoBorder").css("border", "");
		$(".photoBorder").css("background-color", "");

	},
	/*sendNewCardRequestForHousehold: function() {
		var programId = cardPickerController.listData.programs[selectedProgramIndex].id;
		
		
		var subscribeToProgramData = {
				programId : programId,
				
		};

		SmartphoneService.subscribeToProgram( subscribeToProgramData, pinScreenController.subscribeToProgramBack);
		//proxy_login.SubscribeToProgram(pinScreenController.subscribeToProgramBack, subscribeToProgramData);
		
		if(cardCreatedController == undefined) cardCreatedController = sap.ui.controller('app.ui.addcard.cardCreatedController');
		cardCreatedController.displayCreatedCardPage(true);
		$(".photoBorder").html("");
		$(".photoBorder").css("border", "");
		$(".photoBorder").css("background-color", "");

	},*/
	subscribeToProgramBack: function(response, status) {
		if (status != 200) {
			checkErrorStatus(status);
			return;
		}

		if(isRESTStatusCodeCorrect(response)) {
			var responseModel = response;	
			pinScreenController.updateCardAddedPage(responseModel.CardInfo, responseModel.Membership);
		}

		
	},
	
	updateCardAddedPage: function(CardInfo, Membership){
		//Once we get the card template data, we need to extract and pass that also.
		// This is a complex code and any changes in Card Template from server will affect look in client app
		var createdCardPageModelData = app.getPage(CARD_CREATED_PAGE).getModel().oData;
		createdCardPageModelData.cardAdded = oBundle.getText("your_card_added");
		if(CardInfo.templateFrontImage !== undefined && CardInfo.templateFrontImage !== null) {
			var cardInfo = util.decode(CardInfo.templateFrontImage);

			var cardName = cardPickerController.listData.programs[selectedProgramIndex].name;
			cardInfo = cardInfo.replace("{cardName}", cardName);
			cardInfo = cardInfo.replace("{cardHolderName}", CardInfo.cardName);
			cardInfo = cardInfo.replace("{cardId}", CardInfo.cardNumber);
			cardInfo = cardInfo.replace("{memberSince}", util.convertDateToReadableFormat(Membership.startdate));
			cardInfo = cardInfo.replace("{expDate}", CardInfo.expDate != null ? util.convertDateToReadableFormat(Membership.enddate) : "");


			$(".photoBorder").html("");
			$(".photoBorder").append(cardInfo.trim());
			//$(".photoBorder #CardFront").css("width", "320px");
			//$(".photoBorder #CardFront").css("height", "212px");
			//$(".photoBorder #CardFront").css("background-size", "320px 212px");
			$(".photoBorder").css("border", "0px");
			$(".photoBorder").css("background-color", "transparent");
			$(".cardFooterLabels").remove();
			$(".cardFooterValues").remove();

		}
		
		/*
		 * The objective of createdCardObject is to keep track of the newly added card. As per the new requirements, user can launch the preferences
		 * from the Card Added confirmation age. After the preferences screens, we need to show the user the card details screen which comes after wallet
		 * in multibrand scenario and comes from MyCard in single brand scenario. To launch the card detail screen, we will need this createdCardObject.
		 */
		var createdCardObject = {
				cardId: CardInfo.customerCardId,
				membershipId: Membership.id,
				programId: cardPickerController.listData.programs[selectedProgramIndex].id,
		};
		cardCreatedController.updateCreatedCardObject(createdCardObject);
		
		//If household needs to be created then hold the ID of the program to which the household needs to be created.
		if(householdController == undefined){
			householdController = sap.ui.controller("app.ui.household.household");
		}
		householdController.programId = Membership.id_program;
		householdController.programName = Membership.programName;
		
		//createdCardPageModelData.url = "data:image/jpg;base64," + CardInfo.templateFrontImage;
		
		/*
		 * The preferences option should not be shown in case of a library card (non-loyalty) card. So in case of
		 * multibrand scenario, we will check if the selectedProgramIndex (which is set by the card picker screen)
		 * is -1. For single brand scenario, there is no option to add a library card so the preferences option 
		 * should always be shown.
		 */
		var showPreferences = (selectedProgramIndex !== -1);
		if ( userState['BRANDTYPE'] == "single"){
			showPreferences = true;
		}
		createdCardPageModelData.showPreferences = showPreferences;
		
		//show household if it is enabled
		var showHousehold = false;
		if(userState.HOUSEHOLDING_ENABLED == true &&
				cardPickerController.listData.programs[selectedProgramIndex].householdingEnabled != undefined &&
				cardPickerController.listData.programs[selectedProgramIndex].householdingEnabled != null)
		{
			showHousehold = cardPickerController.listData.programs[selectedProgramIndex].householdingEnabled;
		}
		createdCardPageModelData.showHousehold = showHousehold;
		
		app.getPage(CARD_CREATED_PAGE).getModel().setData(createdCardPageModelData);
		
		//sliderMenuController.updateOffersWithAddedCard();
		if (cardPickerController !== undefined) cardPickerController.updateCardsListAfterAddingCard();
	},
	
	startPinScreenFlowForHousehold: function() {

		// Check if Pin Input Screen flow is required or not
		var cardType = cardPickerController.listData.programs[selectedProgramIndex].cardtype;
		if (cardType.isCapturePin === true) {

			dataForEnterPinScreen = {
					inputFieldValue: "",
					placeHolderValue: oBundle.getText("set_card_pin"),
					labelValue: oBundle.getText("set_a_pin_number"),
					type: oBundle.getText("pin"),
					typeOfValue: "Password",
					nextButtonText: oBundle.getText("next"),
					maxLength:"8" 
			};

			dataForConfirmPinScreen = {
					inputFieldValue: "",
					placeHolderValue: oBundle.getText("confirm_card_pin"),
					labelValue: oBundle.getText("confirm_pin_number"),
					type: oBundle.getText("pin"),
					typeOfValue: "Password",
					nextButtonText: oBundle.getText("done"),
					maxLength: "8"
			},

			setPinScreenModel = new sap.ui.model.json.JSONModel();
			setPinScreenModel.setData(dataForEnterPinScreen);

			var callbackForCancel = function(){
				app.backToPage("household_invitation_code_page");
			}
			this.createInputPinScreen("setPinScreen", this.displayConfirmPinScreen, callbackForCancel );
			app.getPage("setPinScreen").setModel(setPinScreenModel);

			confirmPinScreenModel = new sap.ui.model.json.JSONModel();
			confirmPinScreenModel.setData(dataForConfirmPinScreen);

			var callbackForDone = function(){
				if( !validatePIN() ){
					//on failing that PINs are not same reset value and re-ask for pins
					pinScreenController.resetPinSceens();
					app.backToPage("household_invitation_code_page");
				}else{
					pinScreenController.acceptHouseholdInvitation();
				}
				
			};
			this.createInputPinScreen("confirmPinScreen", callbackForDone, callbackForCancel );
			app.getPage("confirmPinScreen").setModel(confirmPinScreenModel);

			app.to("setPinScreen");
			
		} else {
			this.acceptHouseholdInvitation();
		}
	},
	
	acceptHouseholdInvitation: function(){

		//console.log("Inv Code " + dataForInvCodeScreen.inputFieldValue);
		/*
		 * Here we need to call a service to verify the code and then goto next screen or show error msg accordingly
		 */
		//cardPickerController.openInputPinScreen();
		var email;
		var id;
		//call back for fetching the email address
		var callbackForEmail = function(response,status){

			if ( isRESTStatusCodeCorrect(response) ){
				//Fetch the email and customer id of the user who want to join household  
				email = response.address.email;
				id = response.address.customerId;

				//Fetch the phone number of the user who want to join household
				var callbackForPhone = function(response,status){
					if ( isRESTStatusCodeCorrect(response) ){

						phone = response.identifications[0].identification;
						var acceptInvitation = {
								invitationCode : dataForInvCodeScreen.inputFieldValue,
								email : email,
								phone : phone,
						};

						var cardType = cardPickerController.listData.programs[selectedProgramIndex].cardtype;
						if (cardType.isCapturePin === true) {
							acceptInvitation.cardPin = setPinScreenModel.oData.inputFieldValue;
						}

						//Callback for sending the activation code along with users email, phone and customer id.
						
						var callbackSend = function(response, status){

							if ( isRESTStatusCodeCorrect(response) ){
								/*
								 *Decomment the below line for UI testing
								 *response = {"conversationId":null,"result":{"verificationResult":"ACCEPTED","membershipForHousehold":{"id":500263618,"id_program":500152700,"programName":"Megamart Program","pointsName":null,"extRefId":null,"membershipnum":"500263618","startdate":1373959187526,"enddate":null,"lastactivitydate":null,"idMembershipStatus":null,"membershipStatusName":"Active","tiersenabled":false,"pointsenabled":false,"currentTierName":null,"amtQualifyingPoints":null,"enteredOnDate":null,"expiresOnDate":null,"idMember":null,"amtalltimepoints":null,"amtexpiredpoints":null,"amtredeemedpoints":null,"amtBalancePoints":null},"CardInfo":{"customerCardId":500279455,"cardName":"rec1","cardNumber":"500279455","cardExpiryDate":null,"cardPin":null,"frontCardImage":null,"frontCardImageType":null,"templateId":null,"templateFrontImage":null,"templateContentType":null,"templateFrontContent":null}},"UnstructuredData":[],"Status":{"value":null,"code":0}};
								*/
								util.closeBusyDialog();
								
								if(response.result.verificationResult == "ACCEPTED" && response.result.membershipForHousehold != null){
									if(cardCreatedController == undefined) 
										cardCreatedController = sap.ui.controller('app.ui.addcard.cardCreatedController');
									cardCreatedController.displayCreatedCardPage(true);
									pinScreenController.updateCardAddedPage(response.result.CardInfo, response.result.membershipForHousehold);
								}
								else{
									app.backToPage("household_invitation_code_page");
									logError("error_message_household_invitaion_code_incorrect", "Invitation code wrong or expired", "accept_household");
								}

							}else{
								util.closeBusyDialog();
								logError("error_message_general", "Error in the response of gethousehold details for members", "accept_household");
							}

						};

						//Smartphone service that sends user details along with activation code for confirmation of the invitation.
						SmartphoneService.acceptInvitationForHousehold(acceptInvitation, callbackSend);
					}else{
						util.closeBusyDialog();
						logError("error_message_general", "Error in the response for getting the phone details for members", "login");
					}
				};
				//Smartphone service call for fetching the phone number of the user
				SmartphoneService.getIdentifications(parseInt(id),callbackForPhone);
			}else{
				util.closeBusyDialog();
				logError("error_message_general", "Error in the response for getting the email details for members", "login");
			}
		};

		//Smartphone service call for fetching the email address of the user.
		util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
		SmartphoneService.getAddressByCustomer({},callbackForEmail);

	},

	displayInputPinScreen: function(modelData, callbackOnDone, callbackOnCancel) {
		if(callbackOnDone != null) callbackOnDoneInPinScreen = callbackOnDone;
		if(callbackOnCancel !=null) callbackOnCancelInPinScreen = callbackOnCancel;
		
		if(!app.getPage(ENTER_ONE_FIELD_PAGE)) {
			inputRequiredField = sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.addcard.enterFieldValueView",
				controller : this
			});

			requiredFieldModel = new sap.ui.model.json.JSONModel();

			requiredFieldPin = {
					inputFieldValue: "",
					placeHolderValue: oBundle.getText("enter_card_pin"),
					labelValue: oBundle.getText("enter_your_pin_number"),
					type: oBundle.getText("pin"),
					typeOfValue: "Password"
			}

			var header = new sap.m.Bar({
				contentRight : [new sap.m.Button('pinScreenDoneButton', { text: oBundle.getText("done"),
					tap : function() {
						callbackOnDoneInPinScreen();
						//handleDoneForRequiredField();
					}
				})],
				contentMiddle : [new sap.m.Label("pinScreenTitle", {text: "{/placeHolderValue}" })],
				contentLeft : [new sap.m.Button('pinScreenCancelButton', { text: oBundle.getText("cancel"),
					tap :function() {
						callbackOnCancelInPinScreen();
						//handleCancelForRequiredField();
					}
				})]
			});


			enterRequiredFieldPage = new sap.m.Page(ENTER_ONE_FIELD_PAGE, {
				customHeader: header,
				content: [ inputRequiredField ],
				navButtonTap : function() {
					app.back();
				}
			});

			enterRequiredFieldPage.setModel(requiredFieldModel);    
			app.addPage(enterRequiredFieldPage);
		}
		
		if(modelData!=null) {
			requiredFieldModel.setData(modelData);
		} else {
			oldFieldValue = requiredFieldPin.inputFieldValue;
			requiredFieldModel.setData(requiredFieldPin);
		}
		
		app.to(ENTER_ONE_FIELD_PAGE);

	},
	
	createInputPinScreen: function(pageId, callbackOnDone, callbackOnCancel) {
		
		//if(callbackOnDone != null) callbackOnDoneInPinScreen = callbackOnDone;
		//if(callbackOnCancel !=null) callbackOnCancelInPinScreen = callbackOnCancel;
		var pageFirstTimeLoad = 0;
		if(!app.getPage(pageId)) {
			pageFirstTimeLoad = 1;
			inputRequiredField = sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.addcard.enterFieldValueView",
				controller : this
			});

//			requiredFieldModel = new sap.ui.model.json.JSONModel();
//
//			requiredFieldPin = {
//					inputFieldValue: "",
//					placeHolderValue: oBundle.getText("enter_card_pin"),
//					labelValue: oBundle.getText("enter_your_pin_number"),
//					type: oBundle.getText("pin"),
//					typeOfValue: "Number"
//			}

			var header = new sap.m.Bar({
				contentRight : [new sap.m.Button(pageId + 'pinScreenDoneButton', { text: "{/nextButtonText}",
					tap : function() {
						callbackOnDone();
						//handleDoneForRequiredField();
					}
				})],
				contentMiddle : [new sap.m.Label(pageId + "pinScreenTitle", {text: "{/placeHolderValue}" })],
				contentLeft : [new sap.m.Button(pageId + 'pinScreenCancelButton', { text: oBundle.getText("cancel"),
					tap :function() {
						callbackOnCancel();
						//handleCancelForRequiredField();
					}
				})]
			});


			enterRequiredFieldPage = new sap.m.Page(pageId, {
				customHeader: header,
				content: [ inputRequiredField ],
				navButtonTap : function() {
					app.back();
				}
			});

//			enterRequiredFieldPage.setModel(requiredFieldModel);    
			app.addPage(enterRequiredFieldPage);
		}
		
//		if(modelData!=null) {
//			requiredFieldModel.setData(modelData);
//		} else {
//			oldFieldValue = requiredFieldPin.inputFieldValue;
//			requiredFieldModel.setData(requiredFieldPin);
//		}
		app.to(pageId);
		//If page is already exists then add new call back events for done, cancel.
		if(pageFirstTimeLoad == 0){
			var contentLeftButton = app.getPage(pageId).getCustomHeader().getContentLeft()[0];
			contentLeftButton.ontap = function(){
				callbackOnCancel();
			};
			var contentRightButton = app.getPage(pageId).getCustomHeader().getContentRight()[0];
			contentRightButton.ontap = function(){
				
				callbackOnDone();
			};
		}
	}
});

function validatePIN(){
	var inputPIN = setPinScreenModel.oData.inputFieldValue;
	var validatePIN = confirmPinScreenModel.oData.inputFieldValue;
	if (inputPIN == validatePIN)
		return true;
	else
		return false;
}
