jQuery.sap.declare("ScanOffersButtonControl");
jQuery.sap.require("sap.ui.core.Core");
jQuery.sap.require("sap.ui.core.library");


sap.ui.core.Control.extend("ScanOffersButtonControl", { 

	// the control API:
	metadata : {
		properties : { // setter and getter are created behind the scenes,
						// incl. data binding and type validation
			"text" : "string", // in simple cases, just define the type
		}

		,
		aggregations: {
            content: {singularName: "content"} // default type is "sap.ui.core.Control", multiple is "true"
         }

	},

	visibleState : false,

	// the part creating the HTML:
	renderer : function(oRm, oControl) { 
		
		oRm.write("<div");
		oRm.writeControlData(oControl); 
	    oRm.writeStyles();
		oRm.addClass("scanOffersButtonControl");									
		oRm.writeClasses();							
		oRm.write(">");

		var aChildren = oControl.getContent();
		for (var i = 0; i < aChildren.length; i++) {
			oRm.renderControl(aChildren[i]);   
		}
		oRm.write("</div>");
	},

	attachToPage: function(pageObject, buttonControl) {
		var pageId = pageObject.getId();
	    $("document").ready(function() {	    	
	        var controlHTML = sap.ui.getCore().getRenderManager().getHTML(buttonControl);
	        //$("#"+pageId+"-cont").append($(controlHTML));
	        //console.warn(jQuery.sap.byId(pageId).parent());
	        //console.warn($(controlHTML));
	        jQuery.sap.byId(pageId).append($(controlHTML));
	    });	    
	   
	},
	
	removeFromPage: function() {
		$(this.getDomRef()).remove();
	}
	
});
