var takeCardPhotoView;
var captureCount = 0;

sap.ui.controller('app.ui.addcard.takeCardPhotoController', {
	
	imageCaptureResolution: "",

	onAfterRendering: function(){ 

	},

	// Function which begins the flow of screens to capture both sides of card
	startCardCaptureScreenFlow: function() {
		
		if(!(userState['CARD_CAPTURE_RESOLUTION'] == ""))
		{ imageCaptureResolution = userState['CARD_CAPTURE_RESOLUTION'].split("x");
		} else {
			imageCaptureResolution = [];
			imageCaptureResolution[0] = 304;
			imageCaptureResolution[1] = 175;
		}

		
		if(cardCreatedController == undefined) cardCreatedController = sap.ui.controller('app.ui.addcard.cardCreatedController');
		cardCreatedController.reloadCardCreatedPage();

		dataForCardFrontScreen = {
				url: "",
				labeltext: oBundle.getText("take_picture_card_front"),
				titleOfScreen: oBundle.getText("card_front"),
				rightButtonText: oBundle.getText("next"),
				screenType: "CardFront"
		};
		
		dataForCardBackScreen = {
				url: "",
				labeltext: oBundle.getText("take_picture_card_back"),
				titleOfScreen: oBundle.getText("card_back"),
				rightButtonText: oBundle.getText("done"),
				screenType: "CardBack"
		};
		
		attachmentDataForCardBack = {
				attachment: {
					customerId: loginResponseModel.customer.id,
					attachmentType : "8",
					name : "Card Back Image",
					contentType : "image/jpeg",
					content : "",
					status : "0"
				}
		};

		
		attachmentDataForCardFront = {
				attachment: {
					customerId: loginResponseModel.customer.id,
					attachmentType : "7",
					name : "Card Front Image",
					contentType : "image/jpeg",
					content : "",
					status : "0"
				}
		};

		cardAttachementResponseDetails = {
		        nameOnCard: "",
			cardFrontSide: "",
			cardBackSide: ""
		};

		takeCardPhotoModel = new sap.ui.model.json.JSONModel();
		takeCardPhotoModel.setData(cardAttachementResponseDetails);

		takeCardFrontSidePhotoModel = new sap.ui.model.json.JSONModel();
		takeCardFrontSidePhotoModel.setData(dataForCardFrontScreen);

		this.createNewTakePhotoPage("cardFrontSideCaptureScreen", this.backToPreviousScreen, this.displayCardBackSideCapture);
		app.getPage("cardFrontSideCaptureScreen").setModel(takeCardFrontSidePhotoModel);
		
		takeCardBackSidePhotoModel = new sap.ui.model.json.JSONModel();
		takeCardBackSidePhotoModel.setData(dataForCardBackScreen);

		this.createNewTakePhotoPage("cardBackSideCaptureScreen", this.backToPreviousScreen, this.doneCapturingCard);
		app.getPage("cardBackSideCaptureScreen").setModel(takeCardBackSidePhotoModel);

		if(app.getPage(PHOTO_NAME_PAGE) == null ) {
			var header = new sap.m.Bar({
				contentRight : [new sap.m.Button(PHOTO_NAME_PAGE+'takeCardPictureDoneButton', { text: oBundle.getText("next"),
				    tap: function () {

				        if (cardAttachementResponseDetails.nameOnCard === '') {

				            logError(oBundle.getText("card_capture_name_error"));
				            return;
				        }


						app.to("cardFrontSideCaptureScreen");
					}
				})],
				contentMiddle : [new sap.m.Label(PHOTO_NAME_PAGE+"takeCardPictureTitle", {text:  oBundle.getText("phoneName")})],
				contentLeft : [new sap.m.Button(PHOTO_NAME_PAGE+'takeCardPictureCancelButton', { text: oBundle.getText("cancel"),
					tap :function() {
						app.back();
					}
				})]
			});

			  takeCardPhotoView = sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.addcard.takeCardPhotoNameView",
				controller : this
			});

			var takeCardPhotoPage = new sap.m.Page(PHOTO_NAME_PAGE, {
				customHeader: header,
				content: [ takeCardPhotoView ],
				navButtonTap : function() {
					app.back();
				}
			});

			takeCardPhotoView.setModel(takeCardPhotoModel);
			
			app.addPage(takeCardPhotoPage);
			
		}

		takeCardPhotoView.setModel(takeCardPhotoModel);


		app.to(PHOTO_NAME_PAGE);
		
	},
	
	photoNameToCapture : function(){
		app.to("cardFrontSideCaptureScreen");
	},
	
	backToPreviousScreen: function() {
		app.back();
	},
	
	displayCardBackSideCapture: function() {
		createAttachmentModel = new sap.ui.model.json.JSONModel();
		
		createAttachmentModel.setData(attachmentDataForCardFront);
		util.createBusyDialog( "", oBundle.getText("uploading_image"));
		//var proxy_login = new Proxy();
		SmartphoneService.createAttachment(attachmentDataForCardFront, takeCardPhotoController.createAttachmentForCardFrontSideBack, null, null, true);
		//proxy_login.CreateAttachment(takeCardPhotoController.createAttachmentForCardFrontSideBack, createAttachmentModel);
	},
	
	//Need to complete the createAttachment callback handler function
	createAttachmentForCardFrontSideBack: function(response, status) {
		if (status != 200) {
				checkErrorStatus(status);
				return;
			}
		
		if(isRESTStatusCodeCorrect(response)) {			
			cardAttachementResponseDetails.cardFrontSide = response.attachmentId;
			util.closeBusyDialog();
			app.to("cardBackSideCaptureScreen");
			
		} else {
			// Need to write implementation for this once service starts working
			checkErrorMobiliserStatus(response);
			
		}	 
	},
	
	// This function has to be include the call for web service
	doneCapturingCard: function() {

//     	createAttachmentModel.setData(attachmentDataForCardBack);
		util.createBusyDialog( "", oBundle.getText("uploading_image"));
     	SmartphoneService.createAttachment(attachmentDataForCardBack, takeCardPhotoController.createAttachmentForCardBackSideBack, null, null, true);
		//proxy_login.CreateAttachment(takeCardPhotoController.createAttachmentForCardBackSideBack, createAttachmentModel);		
     	
		// At last, cleanup the images taken by the Camera
		// This will do the cleanup in iPhone
		navigator.camera.cleanup( function onSuccess(){
			
		}, function onFailure(){
			
		} );
		
//		window.resolveLocalFileSystemURI(dataForCardFrontScreen.url, function(fileEntry){
//			fileEntry.remove(function(e){
//				alert("file removed inside entry method");
//			}, function(evt){
//				alert("Failed in removing the file");
//			});
//		}, function(evt){
//			alert("failure");
//		});
//		
//		window.resolveLocalFileSystemURI(dataForCardBackScreen.url, function(fileEntry){
//			fileEntry.remove(function(e){
//				alert("file removed inside entry method");
//			}, function(evt){
//				alert("Failed in removing the file");
//			});
//		}, function(evt){
//			alert("failure");
//		});

		
		
	},	
	
	//Need to complete the createAttachment callback handler function
	createAttachmentForCardBackSideBack: function(response, status) {
		if(status != 200) {
			// Custom implementation for this case
			checkErrorStatus(status);
			return;
		}
		
		if(isRESTStatusCodeCorrect(response)) {
			cardAttachementResponseDetails.cardBackSide = response.attachmentId;
			//bothSideCardAttachmentModel = new sap.ui.model.json.JSONModel();
			var bothCardSideData = {
					customerId: loginResponseModel.customer.id,
					nameOnCard : cardAttachementResponseDetails.nameOnCard,
					cardFrontImageId: cardAttachementResponseDetails.cardFrontSide,
					cardrearImageId: cardAttachementResponseDetails.cardBackSide				   
			};

			util.closeBusyDialog();
			//bothSideCardAttachmentModel.setData(bothCardSideData);
			SmartphoneService.addNonLoyaltyCardByCardImage(bothCardSideData, takeCardPhotoController.addNonLoyaltyCardByCardImageBack, null, null, true);
			//proxy_login.AddNonLoyaltyCardByCardImage(takeCardPhotoController.addNonLoyaltyCardByCardImageBack, bothSideCardAttachmentModel);

			if(cardCreatedController == undefined) cardCreatedController = sap.ui.controller('app.ui.addcard.cardCreatedController');
			//Need the below line to render the card image on next screen properly
			cardCreatedController.displayCreatedCardPage(true);
			var frontImageData = "data:image/jpeg;base64," + attachmentDataForCardFront.attachment.content;
			cardCreatedController.displayCreatedCardPage(true, frontImageData);
			$(".photoBorder").css("border", "0px");
			$(".photoBorder").css("background-color", "transparent");
			$(".photoBorder").css("border-radius", "5px");
			
//			$(".photoBorder").css("border", "");
//			$(".photoBorder").css("background-color", "");


			
		} else {
			// Need to write implementation for this once service starts working
			checkErrorMobiliserStatus(response);
			
		}	
		   

		
	},
	
	 addNonLoyaltyCardByCardImageBack: function(response, status) {
			if(status != 200) {
				// Custom implementation for this case
				checkErrorStatus(status);
				return;
			}
			
			if(isRESTStatusCodeCorrect(response)) {

				var createdCardPageModelData = app.getPage(CARD_CREATED_PAGE).getModel().oData;
				//createdCardPageModelData.url = "data:image/jpeg;base64," + attachmentDataForCardFront.attachment.content;
				createdCardPageModelData.cardAdded = oBundle.getText("your_card_added");
				
				$(".photoBorder").css("border", "0px");
				$(".photoBorder").css("background-color", "transparent");
				$(".photoBorder").css("border-radius", "5px");

				app.getPage(CARD_CREATED_PAGE).getModel().setData(createdCardPageModelData);

			} else {
				// Need to write implementation for this once service starts working
				checkErrorMobiliserStatus(response);
				
			}	 
			   //Not sure where to use the cardId. Just needed to confirm that the card was added
			  //console.warn("Card got added finally");
	 },

	
	
		
	 // Function which triggers the device native camera application so that user can take a picture
	 takeCardPhoto: function() {
		 navigator.camera.getPicture(function onSuccess(imageURI){
			 var pageModel = app.getCurrentPage().getModel();
			 pageData = pageModel.oData;
			 //pageData.url = "data:image/jpeg;base64," + imageData;
			 pageData.url = imageURI;
			 pageModel.setData(pageData);
				
			 //util.encodeImageURI(imageURI, takeCardPhotoController.assignImageDataToAttachments);
			 util.encodeImageURIViaCanvas(imageURI, takeCardPhotoController.assignImageDataToAttachments);
			 captureCount = captureCount + 1;
		 }, function onFail(){

		 },{ 
			 quality: 40, 
			 sourceType:Camera.PictureSourceType.CAMERA,
			 destinationType:Camera.DestinationType.FILE_URI,
			 targetWidth: imageCaptureResolution[0],
			 targetHeight: imageCaptureResolution[1],
			 correctOrientation: true,
			 saveToPhotoAlbum: false

		 });
	 },

		assignImageDataToAttachments: function(imageData){
				imageData = imageData.substring(imageData.indexOf(",") + 1, imageData.length);
				if(pageData.screenType.indexOf("CardFront") != -1) attachmentDataForCardFront.attachment.content = imageData;
				else attachmentDataForCardBack.attachment.content = imageData;
		},

	// Function to create the Image Capture Page. Using a function as need to create two separate pages with same functionality.
	// Could have used the same page but in the current scenario, need to show navigation from one image capture page to another image capture page.
	createNewTakePhotoPage: function(pageId, callbackForCancel, callbackForNext) {
		if(app.getPage(pageId) == null ) {
			var header = new sap.m.Bar({
				contentRight : [new sap.m.Button(pageId+'takeCardPictureDoneButton', { text: "{/rightButtonText}",
				    tap: function () {


				        if (captureCount < 1 && pageId === "cardFrontSideCaptureScreen") {

				            logError(oBundle.getText("card_capture_error"));
				            return;
				        }

				        if (captureCount < 2 && pageId === "cardBackSideCaptureScreen") {

				            logError(oBundle.getText("card_capture_error_back"));
				            return;
				        }



						callbackForNext();
					}
				})],
				contentMiddle : [new sap.m.Label(pageId+"takeCardPictureTitle", {text: "{/titleOfScreen}" })],
				contentLeft : [new sap.m.Button(pageId+'takeCardPictureCancelButton', { text: oBundle.getText("cancel"),
					tap :function() {
						callbackForCancel();
					}
				})]
			});

			var takeCardPhotoView = sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.addcard.takeCardPhotoView",
				controller : this
			});


			var takeCardPhotoPage = new sap.m.Page(pageId, {
				customHeader: header,
				content: [ takeCardPhotoView ],
				navButtonTap : function() {
					app.back();
				}
			});

			app.addPage(takeCardPhotoPage);
			
		}
	}

});
