// 2013 SAP AG. All rights reserved.
// Author : SAP.

sap.ui.controller("app.ui.catalogue.catalogueController", {
	catalogueData : {
		catalogueURL : "",
	},

	loadCataloguePage : function(catalogueURL) {
		if (app.getPage(CATALOGUE_PAGE) == null) {

			var catalogueView = sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.catalogue.catalogueView",
				controller : catalogueController
			});
			var header = new sap.m.Bar({
				contentRight : [],
				contentMiddle : [ new sap.m.Label({
					// TODO: TRANSLATION ONCE TITLE DECIDED
					text : oBundle.getText("anonymousHome_productCatalog"),
				}) ],
				contentLeft : [ new sap.m.Button({
					icon : "sap-icon://menu2",
					activeIcon : "sap-icon://menu2",
					tap : function(event, src) {
						if (sliderMenuController == undefined){
				            sliderMenuController = sap.ui.controller("app.ui.slidermenu.sliderMenuController");
				            sliderMenuController.createSliderMenu();
				        }
				        sliderMenuController.action('menuButtonHomePage');
					}
				}).addStyleClass("menuButtonIconFont") ]
			});
			this.oModel = new sap.ui.model.json.JSONModel();
			this.oModel.setData(catalogueController.catalogueData);
			catalogueView.setModel(this.oModel);

			if (sliderMenuController == undefined) {
				sliderMenuController = sap.ui
						.controller("app.ui.slidermenu.sliderMenuController");
				sliderMenuController.createSliderMenu();
			}

			var cataloguePage = new sap.m.Page(CATALOGUE_PAGE, {
				content : [ catalogueView ],
				enableScrolling : false,
				customHeader : header

			});
			app.addPage(cataloguePage);
		}

		catalogueController.catalogueData.catalogueURL = catalogueURL;
		app.getPage(CATALOGUE_PAGE).getContent()[0].getModel().setData(
				catalogueController.catalogueData);

		app.to(CATALOGUE_PAGE);
		catalogueController.catalogueData.catalogueURL = ""
				+ catalogueController.catalogueData.catalogueURL
				+ "?link=catalogue";
		$(".iFrameClass").attr("src",
				catalogueController.catalogueData.catalogueURL);

	},

});