sap.ui.controller('app.ui.financialAccounts.addPaymentCard', {
	
	launchAddNewPaymentCard: function(){
		if(app.getPage(ID_ADD_PAYMENT_CARD_PAGE) == null)
		{
			var addNewPaymentCardView = sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.financialAccounts.addPaymentCard",
				controller : this
			});
			
			var addNewPaymentCardPage = new sap.m.Page(ID_ADD_PAYMENT_CARD_PAGE, {
				title : oBundle.getText("select_a_card"),
				content : [ addNewPaymentCardView ],
				showNavButton : true,
				navButtonText : oBundle.getText("cancel"),
				navButtonType : "Default",
				navButtonTap: function(){
					app.back();
				},
				subHeader : new sap.m.Bar({
					enableFlexBox : true,
					contentMiddle : [new sap.m.SearchField({
						placeholder : oBundle.getText("Offers_Search_Button"),
						width : "100%",
						layoutData : new sap.m.FlexItemData({
							growFactor : 1
						})
					})]
				}),
				footer : new sap.m.Bar({
					enableFlexBox : true,
					contentMiddle : [new sap.m.Button({
						text : oBundle.getText("add_a_card_not_in_list"),
						type : "Transparent",
						width : "100%",
						layoutData : new sap.m.FlexItemData({
							growFactor : 1
						})
					})]
				})
			});

			var addNewPaymentCardModel = new sap.ui.model.json.JSONModel();
			addNewPaymentCardView.setModel(addNewPaymentCardModel);

			app.addPage(addNewPaymentCardPage);
		}
		
		app.to(ID_ADD_PAYMENT_CARD_PAGE);
	},
	addPaymentCardDetail : function(ev){
		var paymentMode = ev.getSource().getTitle();
		if(addNewPaymentCardDetailsController == undefined)
			addNewPaymentCardDetailsController = sap.ui.controller("app.ui.financialAccounts.addPaymentCardDetails");
		addNewPaymentCardDetailsController.launchAddPaymentCardDetails(paymentMode);
	}
});