sap.ui.controller('app.ui.financialAccounts.householdMembersForTransferController', {
	
	householdMembersForTransferData :{
		members : [],
	},
	
	customerData :{
		customerId : ""
	},
	
	receivedData :{
		
	},

	selectedMembersInstrumentId : "",
	
	launchhouseholdMembersForTransferPage : function (){
		if(app.getPage(HOUSEHOLD_MEMBERS_FOR_TRANSFER_PAGE) == null)
		{
			var housholdMembersListView = sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.financialAccounts.householdMembersForTransferView",
				viewId : "app.ui.financialAccounts.householdMembersForTransferView",
				controller : this
			});
			
			var householdMembersForTransferPage = new sap.m.Page(HOUSEHOLD_MEMBERS_FOR_TRANSFER_PAGE, {
				title : oBundle.getText("select_member"),
				content : [ housholdMembersListView ],
				showNavButton : true,
				navButtonText : oBundle.getText("cancel"),
				navButtonTap: function(){
					app.back();
				},
			});
			
			var householdMembersModel = new sap.ui.model.json.JSONModel();
			housholdMembersListView.setModel(householdMembersModel);
			
			app.addPage(householdMembersForTransferPage);
		}
			//call get household details
			SmartphoneService.getHouseholdDetailsForMember({}, householdMembersForTransferController.callbackForHouseholdDetails);
	},
	
	callbackForHouseholdDetails : function(response, status){
		
		if(response.Status.code != 0){
			alert(response.Status.value);
		}
		
		if (isRESTStatusCodeCorrect(response)){
			var j=0;
			for(var i = 0; i<response.households[0].householdMembers.length; i++){
				if(response.households[0].householdMembers[i].customerId != null && response.households[0].householdMembers[i].customerId != loginResponseModel.customer.id){
					householdMembersForTransferController.householdMembersForTransferData.members[j] = response.households[0].householdMembers[i];
					j++;
				}
			}
			app.getPage(HOUSEHOLD_MEMBERS_FOR_TRANSFER_PAGE).getContent()[0].getModel().setData(householdMembersForTransferController.householdMembersForTransferData);
			app.to(HOUSEHOLD_MEMBERS_FOR_TRANSFER_PAGE);
		}
		else{
			logTechnicalError("Error while getting Household Members for the customer");
		}
	    
	},
	
	memberSelected : function(ev){
		var source = ev.getSource().getSelectedItem();
		var selectedMemberDetails = source.getBindingContext().getProperty(source.getBindingContext().getPath());
		svcOperationController.storedValuePageData.memberTitle = selectedMemberDetails.name;
		svcOperationController.storedValuePageData.selectedHouseholdMember = selectedMemberDetails;
		householdMembersForTransferController.customerData.customerId = svcOperationController.storedValuePageData.selectedHouseholdMember.customerId; 
		
		app.getPage("StoredValueAccountOperationPage").getContent()[0].getModel().setData(svcOperationController.storedValuePageData);
		app.back();
		
	},
	
});