	var url;
sap.ui.controller('app.ui.financialAccounts.makePrimaryCardController', {

	 currentPrimary : "",
	 selectedPageId : "",
	 selectedCard : "",

	cardModelData : {
						buttonText :oBundle.getText("make_primary_card"),
						cardDetails : [],
						showTransferBlock : false,
						bankAccountPresent : false,
						balance : null,
						svaAccountId : null,
						showMakePrimaryCardButton : true,
						cardInfo : {
							accName :"",
							accNumber : "",
							expiryDate : "",
							accType : ""
						},
						templatePresent : false,
						showHeaderText : false,
    				},
    
    				obj : {
    					 walletEntry :{
    						 	id : "",
    							customerId : "",
    							paymentInstrumentId : "",
    							alias : ""
    					  },
    					  primaryDebit : null,
    					  primaryCredit : null
    			 },
    				
	
	onAfterRendering: function(){ 
		var viewRef = app.getPage("makePrimaryCardPage").getContent()[0];
        var viewId = viewRef.getId();
		$('#' + viewId).css("min-height", "100%");
        $('#' + viewId).css("background-image" , "url('app/ui/wallet/images/page_bg.png') ");
        
        if(makePrimaryCardController.cardModelData.templatePresent == true){
        	$(".cardBlock").css("background-image", url);
			$(".cardBlock").css("background-color", "rgb(216,216,216)");
        }else{
			$(".cardBlock").css("background-color", "#29A4AA");
			$(".cardBlock").css("background-image", "none");
        }
	},
	
	cardSelected:function(selectedCard){
		makePrimaryCardController.selectedPageId = selectedCard.paymentInstrumentId;
		makePrimaryCardController.obj.walletEntry.id = selectedCard.id;
		makePrimaryCardController.selectedCard = selectedCard;
		if(app.getPage("makePrimaryCardPage") == null){
			
			var makePrimaryCardView = sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.financialAccounts.makePrimaryCardView",
				controller : this
			});
			
			var makePrimaryCardPage = new sap.m.Page(ID_MAKE_PRIMARY_CARD_PAGE, {
			        content: [makePrimaryCardView],
					showNavButton : true,
					navButtonText : oBundle.getText("Back_Button"),
					navButtonTap : function(){
						if(walletController != undefined)
						    app.backToPage(WALLET_PAGE);
						walletController.launchWalletPage();
					},
		    });
			
			var cardModel = new sap.ui.model.json.JSONModel();
			makePrimaryCardView.setModel(cardModel);
			app.addPage(makePrimaryCardPage);
			
		}
		
		//set Pages title
		app.getPage(ID_MAKE_PRIMARY_CARD_PAGE).setTitle(selectedCard.alias);
		
		//set visibility of transfer block only if the card type is "storedValue"
		if(selectedCard.sva != null){
			makePrimaryCardController.cardModelData.showTransferBlock=true;
			
			//collect sva account id for transactions
			makePrimaryCardController.cardModelData.svaAccountId = selectedCard.paymentInstrumentId;
			
			makePrimaryCardController.cardModelData.cardInfo.accName = null;
			makePrimaryCardController.cardModelData.cardInfo.accNumber = null;
			makePrimaryCardController.cardModelData.cardInfo.accType = "SVA";
			makePrimaryCardController.cardModelData.cardInfo.expiryDate = null;
			var cardType ="type_sva";
		}
		else{
			makePrimaryCardController.cardModelData.showTransferBlock=false;
			
			if(selectedCard.bankAccount != null){
				makePrimaryCardController.cardModelData.cardInfo.accName = selectedCard.alias;
				makePrimaryCardController.cardModelData.cardInfo.accType = "Bank Account";
				makePrimaryCardController.cardModelData.cardInfo.accNumber = selectedCard.bankAccount.displayNumber;
				makePrimaryCardController.cardModelData.cardInfo.expiryDate = null;
				var cardType ="type_bank";
			}else{
				makePrimaryCardController.cardModelData.cardInfo.accName = selectedCard.alias;
				makePrimaryCardController.cardModelData.cardInfo.accType = "Credit Card";
				makePrimaryCardController.cardModelData.cardInfo.accNumber = selectedCard.creditCard.displayNumber;
				makePrimaryCardController.cardModelData.cardInfo.expiryDate = selectedCard.creditCard.monthExpiry+"/"+selectedCard.creditCard.yearExpiry;
				var cardType ="type_cc";
			}
		}
		
		//set visibility of load/unload block only if the customer has bank account
		if(walletController.bankAccountPresent == true){
			makePrimaryCardController.cardModelData.bankAccountPresent=true;
		}
		else{
			makePrimaryCardController.cardModelData.bankAccountPresent=false;
		}
		
		//set the visibility of the MakePrimaryCard button
		if(selectedCard.isPrimary == true){
			makePrimaryCardController.cardModelData.showMakePrimaryCardButton=false;
			makePrimaryCardController.currentPrimary = 1;
		}
		else{
			makePrimaryCardController.cardModelData.showMakePrimaryCardButton=true;
			makePrimaryCardController.currentPrimary = 0;
		}
		
		util.createBusyDialog(oBundle.getText("Wallet_Progress_Message_Title"));
		//call the getMemberCardBackgroundImage
		SmartphoneService.getMemberCardBackgroundImage(cardType, makePrimaryCardController.cardCallBack);
		
		
	},
	
	getBalance : function(id){
		//call the balanceEnquiry for sva
		SmartphoneService.getPaymentInstrumentBalance(id, makePrimaryCardController.balanceCallback);
	},
	
	cardCallBack:function(response, status){
		//console.log(response);
		if(response.Card.cardFrontImage == ""){
			makePrimaryCardController.cardModelData.templatePresent = false;
			makePrimaryCardController.cardModelData.showHeaderText = true;
			if(makePrimaryCardController.selectedCard.sva != null){
				//get the balance
				makePrimaryCardController.getBalance(makePrimaryCardController.cardModelData.svaAccountId);
			}
			else{
				app.getPage("makePrimaryCardPage").getContent()[0].getModel().setData(makePrimaryCardController.cardModelData);
				util.closeBusyDialog();
				app.to("makePrimaryCardPage");
				$(".cardBlock").css("background-color", "#29A4AA");
				$(".cardBlock").css("background-image", "none");
			}
		}else{
			makePrimaryCardController.cardModelData.templatePresent = true;
			makePrimaryCardController.cardModelData.showHeaderText = false;
			var backgroundImage = util.decode(response.Card.cardFrontImage);
			var index = backgroundImage.indexOf("background-image: ")+18;
			var subStr = backgroundImage.slice(index);
			var endStr = subStr.indexOf(");")+1;
			url = subStr.substring(0,endStr);
			
			if(makePrimaryCardController.selectedCard.sva != null){
				//get the balance
				makePrimaryCardController.getBalance(makePrimaryCardController.cardModelData.svaAccountId);
			}
			else{
				app.getPage("makePrimaryCardPage").getContent()[0].getModel().setData(makePrimaryCardController.cardModelData);
				util.closeBusyDialog();
				app.to("makePrimaryCardPage");
				$(".cardBlock").css("background-image", url);
				$(".cardBlock").css("background-color", "rgb(216,216,216)");
			}
		}
	},
	
	balanceCallback : function(response, status){
		
		if(response.Status.code != 0){
			alert(response.Status.value);
		}
		
		if (isRESTStatusCodeCorrect(response)){
			makePrimaryCardController.cardModelData.balance = response.Balance/100;
			app.getPage("makePrimaryCardPage").getContent()[0].getModel().setData(makePrimaryCardController.cardModelData);
		}
		else{
			logTechnicalError("Error while getting the balance of the SVA");
		}
		if(makePrimaryCardController.cardModelData.templatePresent == true){
			util.closeBusyDialog();
			app.to("makePrimaryCardPage");
			$(".cardBlock").css("background-image", url);
			$(".cardBlock").css("background-color", "rgb(216,216,216)");
		}
		else{
			util.closeBusyDialog();
			app.to("makePrimaryCardPage");
			$(".cardBlock").css("background-color", "#29A4AA");
			$(".cardBlock").css("background-image", "none");
		}
		
	},

	primaryCardButtonTap :function(){
		//confirmation box for primary card
		var cardConfirmationDialog = new sap.m.Dialog({
			title : oBundle.getText("make_primary_card"),
			content : [new sap.m.Text({
				text : oBundle.getText("change_primary")
			})],
			leftButton : new sap.m.Button({
				text : oBundle.getText("cancel"),
				width : "100%",
				tap :function(){
					cardConfirmationDialog.close();
				}
			}),
			rightButton : new sap.m.Button({
				text : oBundle.getText("OK"),
				width : "100%",
				tap :function(){
						var receivedData = app.getPage(WALLET_PAGE).getContent()[0].getModel().getData();
						for(var i=0; i<receivedData.cardDetails.length; i++){
							if(receivedData.cardDetails[i].paymentInstrumentId == makePrimaryCardController.selectedPageId){
								receivedData.cardDetails[i].isPrimary = true;
								
								//get the payment Instrument Id to be updated
								makePrimaryCardController.obj.walletEntry.paymentInstrumentId = receivedData.cardDetails[i].paymentInstrumentId;
								
								//get the alias to be updated
								makePrimaryCardController.obj.walletEntry.alias = receivedData.cardDetails[i].alias;
							}
							else{
								receivedData.cardDetails[i].isPrimary = false;
							}
							
							makePrimaryCardController.obj.primaryDebit = true;
							makePrimaryCardController.obj.primaryCredit = true;
							
						}
						
						//empty the customerId
						makePrimaryCardController.obj.walletEntry.customerId = null;
						
						//get the customer id
						makePrimaryCardController.obj.walletEntry.customerId = loginResponseModel.customer.id;
						
						
						//set the button text to "Deselect Primary Card"
						makePrimaryCardController.cardModelData.showMakePrimaryCardButton=false;
						
						//set the flag so that pop over should not come
						makePrimaryCardController.currentPrimary = 1;
						
						//set Data for current page 
						makePrimaryCardController.cardModelData.cardDetails = receivedData.cardDetails;
						app.getPage("makePrimaryCardPage").getContent()[0].getModel().setData(makePrimaryCardController.cardModelData);
						
						//call the updateWalletEntry service to reflect the changes
						SmartphoneService.updateWalletEntry(makePrimaryCardController.obj, makePrimaryCardController.updateWalletEntryCallback);
						
						
						//close the dialog
						cardConfirmationDialog.close();
				}
			})
		});
		
		if(makePrimaryCardController.currentPrimary == 0){
			cardConfirmationDialog.open();
		}
	},	
		
		// shows transactions by navigating to PaymentTransaction Page
		showTransactions : function(){
			
			if(paymentTransactionController == undefined)
				paymentTransactionController = sap.ui.controller("app.ui.financialAccounts.paymentTransaction");
			paymentTransactionController.launchPaymentTransactionPage(makePrimaryCardController.selectedCard);
		},
		
		// shows StoredValueAccount Operations by navigating to StoredValueAccountOperation Page
		showStoredValueAccount : function(ev){
			var selectedItem = ev.getSource().getTitle();
			
			if(selectedItem == "Transfer"){
				if(userState.BRANDTYPE === "multi") {
					var dialog = new sap.m.Dialog({
						title : oBundle.getText("message"),
						content : [new sap.m.Text({
							text : oBundle.getText("not_enabled_multi")
						})],
						rightButton : new sap.m.Button({
							text : oBundle.getText("OK"),
							width : "100%",
							tap :function(){
									//close the dialog
									dialog.close();
							}
						})
					});
					dialog.open();
					return;
				}else{
					if(svcOperationController == undefined)
						svcOperationController = sap.ui.controller("app.ui.financialAccounts.storedValueAccountOperation");
					svcOperationController.launchStoredValueAccountOperation(selectedItem);
				}
			}else{
				if(makePrimaryCardController.cardModelData.bankAccountPresent == true){
					if(svcOperationController == undefined)
						svcOperationController = sap.ui.controller("app.ui.financialAccounts.storedValueAccountOperation");
					svcOperationController.launchStoredValueAccountOperation(selectedItem);
				}
				else{
					if(bankAccountController == undefined)
						bankAccountController = sap.ui.controller("app.ui.financialAccounts.bankAccountController");
					bankAccountController.launchBankAccountPage();
				}
			}
			
			
			
		},
		
		updateWalletEntryCallback : function(response, status){
			
			if(response.Status.code != 0){
				alert(response.Status.value);
			}
			
			if (isRESTStatusCodeCorrect(response)){
				
				//set the wallet page
				//app.getPage(WALLET_PAGE).getContent()[0].getModel().setData(walletController.dataCards);
			}
			else{
				logTechnicalError("Error while Updating the payment card for the customer");
			}
		}
});