sap.ui.controller('app.ui.financialAccounts.paymentCard', {
	
	paymentCardData :{
		cardDetails:{},
		bankName : "",
		holderName : "",
		displayName : "",
		expiryDate : ""
	},
	
	
	launchPaymentCardSavedPage: function(selectedCard){
		//console.log(selectedCard);
		
		if(app.getPage(ID_PAYMENT_CARD_SAVE_PAGE) == null)
		{
			var paymentCardSavedView = sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.financialAccounts.paymentCard",
				controller : this
			});
			
			var paymentCardSavedPage = new sap.m.Page(ID_PAYMENT_CARD_SAVE_PAGE, {
				title : oBundle.getText("your_card_added"),
				content : [ paymentCardSavedView ],
				
			});

			var paymentCardSavedModel = new sap.ui.model.json.JSONModel();
			paymentCardSavedView.setModel(paymentCardSavedModel);
			
			app.addPage(paymentCardSavedPage);
		}
		
		paymentCardSavedController.paymentCardData.cardDetails = selectedCard;
		paymentCardSavedController.paymentCardData.bankName = paymentCardSavedController.paymentCardData.cardDetails.alias;
		
		
		if(selectedCard.sva != null){
			paymentCardSavedController.paymentCardData.displayName = "";
			paymentCardSavedController.paymentCardData.expiryDate = null;
			paymentCardSavedController.paymentCardData.holderName = null;
			var cardType ="type_sva";
		}else if(selectedCard.bankAccount != null){
			paymentCardSavedController.paymentCardData.displayName = paymentCardSavedController.paymentCardData.cardDetails.bankAccount.accountNumber;
			paymentCardSavedController.paymentCardData.expiryDate = null;
			paymentCardSavedController.paymentCardData.holderName = addNewPaymentCardDetailsController.obj.walletEntry.bankAccount.accountHolderName;
			var cardType ="type_bank";
		}else if(selectedCard.creditCard != null){
			paymentCardSavedController.paymentCardData.displayName = paymentCardSavedController.paymentCardData.cardDetails.creditCard.cardNumber;
			paymentCardSavedController.paymentCardData.expiryDate = paymentCardSavedController.paymentCardData.cardDetails.creditCard.monthExpiry+"/"+paymentCardSavedController.paymentCardData.cardDetails.creditCard.yearExpiry;
			paymentCardSavedController.paymentCardData.holderName = addNewPaymentCardDetailsController.obj.walletEntry.creditCard.cardHolderName;
			var cardType ="type_cc";
		} 
		
		//call the getMemberCardBackgroundImage
		SmartphoneService.getMemberCardBackgroundImage(cardType, paymentCardSavedController.cardCallBack);
		
	},
	addAnotherPaymentCard : function(){
		addCard();
	},
	paymentCardDone : function(){
		if (walletController == undefined) 
			walletController = sap.ui.controller("app.ui.wallet.wallet");
		walletController.launchWalletPage();
	},
	
	cardCallBack : function(response,status){

		app.getPage(ID_PAYMENT_CARD_SAVE_PAGE).getContent()[0].getModel().setData(paymentCardSavedController.paymentCardData);
		var backgroundImage = util.decode(response.Card.cardFrontImage);
		var index = backgroundImage.indexOf("background-image: ")+18;
		var subStr = backgroundImage.slice(index);
		var endStr = subStr.indexOf(");")+1;
		url = subStr.substring(0,endStr);
		
		app.to(ID_PAYMENT_CARD_SAVE_PAGE);
		$(".paymentCardTemplate").css("background-image", url);
	}
});