sap.ui.controller('app.ui.financialAccounts.paymentCardDetailsController', {
	
	onAfterRendering: function(){ 
		
	},
	
	paymentCardDetailsData : {
		enabled : false,
		primaryButtonVisibility : null,
		deleteButtonVisibility : true,
		bankAccount : false,
		creditCard : false,
		sva : false,
		cardDetails : {}
	},
	
	deleteObj :{
		walletEntryId :null
	},
	
	obj : {
		 walletEntry :{
			 	id : "",
				customerId : "",
				paymentInstrumentId : "",
				alias : ""
		  },
		  primaryDebit : null,
		  primaryCredit : null
	},
	
	cardTypeSelected : function(selectedCardDetails){
		paymentCardDetailsController.paymentCardDetailsData.cardDetails = selectedCardDetails;
		paymentCardDetailsController.deleteObj.walletEntryId = selectedCardDetails.id;
		if(app.getPage("paymentCardDetails") == null){

			var paymentCardDetailsView = sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.financialAccounts.paymentCardDetailsView",
				controller : this
			});
			
			var ID_FINANCIAL_ACCOUNTS_PAGE = new sap.m.Page("paymentCardDetails",{
				showNavButton : true,
				navButtonText: oBundle.getText("Back"),
				navButtonTap : function(){
									settingsController.displaySettingsPage();
							   },
				content:[paymentCardDetailsView]
			});
			

			var paymentCardDetailsModel = new sap.ui.model.json.JSONModel();
			paymentCardDetailsView.setModel(paymentCardDetailsModel);
			
			app.addPage(ID_FINANCIAL_ACCOUNTS_PAGE);
		}
		paymentCardDetailsController.paymentCardDetailsData.enabled = false;
		
		if(selectedCardDetails.creditPriority == 1){
			paymentCardDetailsController.paymentCardDetailsData.primaryButtonVisibility = false;
		}else{
			paymentCardDetailsController.paymentCardDetailsData.primaryButtonVisibility = true;
		}
		
		//Check if it is a bank Account or credit card or sva
		if(selectedCardDetails.bankAccount != null){
			paymentCardDetailsController.mode = "Bank Account";

			//set visibility of the details screen
			paymentCardDetailsController.paymentCardDetailsData.bankAccount = true;
			paymentCardDetailsController.paymentCardDetailsData.creditCard = false;
			paymentCardDetailsController.paymentCardDetailsData.sva = false;
			paymentCardDetailsController.paymentCardDetailsData.deleteButtonVisibility = true;
			
		}else if(selectedCardDetails.creditCard != null){
			paymentCardDetailsController.mode = "Credit Card";
			
			//set visibility of the details screen
			paymentCardDetailsController.paymentCardDetailsData.bankAccount = false;
			paymentCardDetailsController.paymentCardDetailsData.creditCard = true;
			paymentCardDetailsController.paymentCardDetailsData.sva = false;
			
			//extract the expiry dated
			var month = paymentCardDetailsController.paymentCardDetailsData.cardDetails.creditCard.monthExpiry;
			var year = paymentCardDetailsController.paymentCardDetailsData.cardDetails.creditCard.yearExpiry;
			paymentCardDetailsController.paymentCardDetailsData.cardDetails.expiryDate = month+"/"+year;
			paymentCardDetailsController.paymentCardDetailsData.cardDetails.creditCard.cardNumber = selectedCardDetails.creditCard.displayNumber;
			paymentCardDetailsController.paymentCardDetailsData.deleteButtonVisibility = true;
			
		}else if(selectedCardDetails.sva != null){
			paymentCardDetailsController.mode = "SVA";
			
			//set visibility of the details screen
			paymentCardDetailsController.paymentCardDetailsData.bankAccount = false;
			paymentCardDetailsController.paymentCardDetailsData.creditCard = false;
			paymentCardDetailsController.paymentCardDetailsData.sva = true;
			paymentCardDetailsController.paymentCardDetailsData.deleteButtonVisibility = false;
			
		}
		
		
		//setting the name of the card owner
		paymentCardDetailsController.paymentCardDetailsData.cardDetails.ownerName = loginResponseModel.customer.displayName;
		
		//set data to this page
		app.getPage("paymentCardDetails").getContent()[0].getModel().setData(paymentCardDetailsController.paymentCardDetailsData);
		app.getPage("paymentCardDetails").setTitle(selectedCardDetails.alias);
		app.to("paymentCardDetails");
	},

	editButtonTap : function(){
		if(paymentCardDetailsController.paymentCardDetailsData.enabled == false){
			paymentCardDetailsController.paymentCardDetailsData.enabled=true;
			app.getPage("paymentCardDetails").getContent()[0].getModel().setData(paymentCardDetailsController.paymentCardDetailsData);
			app.getPage("paymentCardDetails").getHeaderContent()[0].setText(oBundle.getText("done"));		
		}
		else{
			paymentCardDetailsController.paymentCardDetailsData.enabled=false;
			app.getPage("paymentCardDetails").getContent()[0].getModel().setData(paymentCardDetailsController.paymentCardDetailsData);
			app.getPage("paymentCardDetails").getHeaderContent()[0].setText(oBundle.getText("edit"));
		}
	},
	
	primaryCardButtonTap : function(){

		var receivedData = app.getPage(SETTINGS_PAGE).getContent()[0].getModel().getData();
		
		for(var i=0; i<receivedData.cardDetails.length; i++){
			if(receivedData.cardDetails[i].paymentInstrumentId == paymentCardDetailsController.paymentCardDetailsData.cardDetails.paymentInstrumentId){
				receivedData.cardDetails[i].isPrimary = true;
				
				//set the wallet entry ID
				paymentCardDetailsController.obj.walletEntry.id = paymentCardDetailsController.paymentCardDetailsData.cardDetails.id;
				
				//get the customer id 
				paymentCardDetailsController.obj.walletEntry.customerId = loginResponseModel.customer.id;
				
				//get the payment Instrument Id to be updated
				paymentCardDetailsController.obj.walletEntry.paymentInstrumentId = receivedData.cardDetails[i].paymentInstrumentId;
				
				//get the alias to be updated
				paymentCardDetailsController.obj.walletEntry.alias = receivedData.cardDetails[i].alias;
			}
			else{
				receivedData.cardDetails[i].isPrimary = false;
			}
			
			paymentCardDetailsController.obj.primaryDebit = true;
			paymentCardDetailsController.obj.primaryCredit = true;
			
		}
		
		//call the updateWalletEntry service to reflect the changes
		SmartphoneService.updateWalletEntry(paymentCardDetailsController.obj, paymentCardDetailsController.updateWalletEntryCallback);

	},
	
	updateWalletEntryCallback : function (response, status){
		
		if(response.Status.code != 0){
			alert(response.Status.value);
		}
		
		if (isRESTStatusCodeCorrect(response)){
			//set the wallet page
			app.getPage(SETTINGS_PAGE).getContent()[0].getModel().setData(settingsController.cardsData);
			
			//hide the button
			paymentCardDetailsController.paymentCardDetailsData.primaryButtonVisibility = false;
			app.getPage("paymentCardDetails").getContent()[0].getModel().setData(paymentCardDetailsController.paymentCardDetailsData);
			
		}
		else{
			logTechnicalError("Error while Updating the payment card for the customer");
		}
	},
	
	//confirmation box for deleting a card
	deleteCardDialog : new sap.m.Dialog({
		title : oBundle.getText("Delete"),
		content : [new sap.m.Text({
			text : oBundle.getText("delete_this_card_from_wallet")
		})],
		leftButton : new sap.m.Button({
			text : oBundle.getText("cancel"),
			width : "100%",
			tap :function(){
				paymentCardDetailsController.deleteCardDialog.close();
			}
		}),
		rightButton : new sap.m.Button({
			text : oBundle.getText("OK"),
			width : "100%",
			tap :function(){
				
				//call the deleteWalletEntry service to reflect the changes
				SmartphoneService.deleteWalletEntry(paymentCardDetailsController.deleteObj, paymentCardDetailsController.deleteWalletEntryCallback);
				
			}
		})
	}),
	
	deleteButtonTap : function(){
		if(userState.DEMO_MODE){
			//call the deleteWalletEntry service to reflect the changes
			SmartphoneService.deleteWalletEntry(paymentCardDetailsController.deleteObj, paymentCardDetailsController.deleteWalletEntryCallback);
		}
		else{
			paymentCardDetailsController.deleteCardDialog.open();
		}
	},
	
	deleteWalletEntryCallback : function(response, status){
		if(response.Status.code != 0){
			alert(response.Status.value);
			paymentCardDetailsController.deleteCardDialog.close();
		}
		
		if (isRESTStatusCodeCorrect(response)){
			paymentCardDetailsController.deleteCardDialog.close();
			settingsController.displaySettingsPage();
		}
		else{
			logTechnicalError("Error while Deleting the payment card for the customer");
		}
	}
	
});
