sap.ui.controller('app.ui.financialAccounts.paymentTransaction', {
	
		transactionRequest : {
			customerId : null,
			fromDate : null,
			toDate : null,
			showFaulty : null,
			maxRecords : null,
			paymentInstrumentId : null,
			showInitial : null
		},
		
		transactionResponse : {
		                      transactions : [{
			
		                      }],
		                      showTransactions : false 
		},
		
		
		
		
	launchPaymentTransactionPage: function(selectedCard){
		paymentTransactionController.transactionRequest.paymentInstrumentId = selectedCard.paymentInstrumentId;
		if(app.getPage("PaymentTransactionPage") == null)
		{
			var paymentTransactionView = sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.financialAccounts.paymentTransaction",
				controller : this
			});
			
			var paymentTransactionPage = new sap.m.Page("PaymentTransactionPage", {
				title : oBundle.getText("transactions"),
				content : [ paymentTransactionView ],
				showNavButton : true,
				
				navButtonText : oBundle.getText("Back"),
				navButtonTap: function(){
					
					//clear fields and hid transaction list
					paymentTransactionController.transactionResponse.showTransactions = false;
					app.getCurrentPage().getContent()[0].byId("fromDate").setValue(null);
					app.getCurrentPage().getContent()[0].byId("toDate").setValue(null);
					app.getPage("PaymentTransactionPage").getContent()[0].getModel().setData(paymentTransactionController.transactionResponse);
					
					app.back();
				},
				
			});

			var paymentTransactionModel = new sap.ui.model.json.JSONModel();
			paymentTransactionView.setModel(paymentTransactionModel);

			app.addPage(paymentTransactionPage);
		}
		app.getPage("PaymentTransactionPage").getContent()[0].getModel().setData(paymentTransactionController.transactionResponse);
		app.to("PaymentTransactionPage");
	},
	
	getDateXsd : function(date){
		  function pad(n) {
			 var s = n.toString();
			 return s.length < 2 ? '0'+s : s;
		  };

		  var yyyy = date.getFullYear();
		  var mm1  = pad(date.getMonth()+1);
		  var dd   = pad(date.getDate());
		  var hh   = pad(date.getHours());
		  var mm2  = pad(date.getMinutes());
		  var ss   = pad(date.getSeconds());

		  return yyyy +'-' +mm1 +'-' +dd +'T' +hh +':' +mm2 +':' +ss;
	},
	
	transactionCallback : function(response, status){
		if(response.Status.code != 0){
			alert(response.Status.value);
			util.closeBusyDialog();
		}
		
		paymentTransactionController.transactionResponse.transactions = response.transactions;
		paymentTransactionController.transactionResponse.showTransactions = true;
		
		for(var i=0; i<response.transactions.length; i++){
			
			paymentTransactionController.transactionResponse.transactions[i].amount.value = (response.transactions[i].amount.value)/100;
			
			if(response.transactions[i].useCase == 193){
				paymentTransactionController.transactionResponse.transactions[i].type = "Transfer";
			}else if(response.transactions[i].useCase == 160){
				paymentTransactionController.transactionResponse.transactions[i].type = "Load";
			}else if(response.transactions[i].useCase == 161){
				paymentTransactionController.transactionResponse.transactions[i].type = "Unload";
			}else {	
				paymentTransactionController.transactionResponse.transactions[i].type = paymentTransactionController.transactionResponse.transactions[i].payeeDisplayName;
			}
		}
		util.closeBusyDialog();
		app.getPage("PaymentTransactionPage").getContent()[0].getModel().setData(paymentTransactionController.transactionResponse);
	},
	
	transactionButtonTap : function(){
		var fromDate = app.getCurrentPage().getContent()[0].byId("fromDate").getDateValue();
		var toDate = app.getCurrentPage().getContent()[0].byId("toDate").getDateValue();
		
		if(fromDate != null || toDate != null){
			paymentTransactionController.transactionRequest.fromDate = paymentTransactionController.getDateXsd(fromDate);
			paymentTransactionController.transactionRequest.toDate = paymentTransactionController.getDateXsd(toDate);
			util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
			//Call get all transactions
			SmartphoneService.findTransactions(paymentTransactionController.transactionRequest,paymentTransactionController.transactionCallback);
		}
		else{
			var dialog = new sap.m.Dialog({
				title : oBundle.getText("enter_required_fields"),
				content : [new sap.m.Text({
					text : oBundle.getText("date_fields")
				})],
				rightButton : new sap.m.Button({
					text : oBundle.getText("OK"),
					width : "100%",
					tap :function(){
							//close the dialog
							dialog.close();
					}
				})
			});
			dialog.open();
		}
	}
});