sap.ui.controller('app.ui.financialAccounts.storedValueAccountOperation', {
	
	storedValuePageData : {
		mode : "",
		modeText : "",
		detailsText : oBundle.getText("notes"),
		memberTitle : oBundle.getText("select_member"),
		loadUnloadTitle : oBundle.getText("select_account"),
		selectedHouseholdMember : null,
		selectedAccount:null
	},
	
	obj : {
		payer :{
			paymentInstrumentId : null,
			identifier :{
				value : "",
				type : "1",
			}
		},
		payee :{
			paymentInstrumentId : null,
			identifier :{
				value : "",
				type : "1",
			}
		},
		amount :{
			value :"",
			currency : "EUR"
		},
		text : "",
		orderChannel : 0,
		useCase : ""
	},
	
	transactionObj : {
		ReferenceTransaction :{
			value : "",
			systemId : ""
		}
	},
	
	launchStoredValueAccountOperation: function(operation){
		
		if(app.getPage("StoredValueAccountOperationPage") == null)
		{
			var svcOperationView = sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.financialAccounts.storedValueAccountOperation",
				controller : this
			});
			
			var svcOperationPage = new sap.m.Page("StoredValueAccountOperationPage", {
				title : "",
				content : [ svcOperationView ],
				showNavButton : true,
				headerContent : [new sap.m.Button({
					text : oBundle.getText("done"),
					tap : function(){
						svcOperationController.doneButtonTapped();
					}
				})],
				navButtonText : oBundle.getText("cancel"),
				navButtonTap: function(){
					app.back();
				},
				
				
			});
			
			var svcOperationModel = new sap.ui.model.json.JSONModel();
			svcOperationView.setModel(svcOperationModel);
			
			app.addPage(svcOperationPage);
		}
		var svcOperationTitle = svcOperationController.getOperation(operation);
		app.getPage("StoredValueAccountOperationPage").setTitle(svcOperationTitle);
		app.getPage("StoredValueAccountOperationPage").getContent()[0].getModel().setData(svcOperationController.storedValuePageData);
		app.to("StoredValueAccountOperationPage");
		
		//clear all fields
		app.getCurrentPage().getContent()[0].byId("amount").setValue("");
		app.getCurrentPage().getContent()[0].byId("message").setValue("");
		app.getCurrentPage().getContent()[0].byId("memberTitle").setTitle("Select Member");
		app.getCurrentPage().getContent()[0].byId("loadTitle").setTitle("Select Account");
		app.getCurrentPage().getContent()[0].byId("unloadTitle").setTitle("Select Account");

	},
	
	getOperation : function(op){
		var opTitle;
		if(op == "Transfer"){
			opTitle = "Transfer Funds";
			svcOperationController.storedValuePageData.mode = "Transfer";
			svcOperationController.storedValuePageData.modeText = "HouseHold Member";
			svcOperationController.storedValuePageData.detailsText = "Message";
			
			//set visibility for the transer load unload navigation item
			svcOperationController.storedValuePageData.transferMode = true;
			svcOperationController.storedValuePageData.loadMode = false;
			svcOperationController.storedValuePageData.unloadMode = false;
		}
		else if(op == "Load Amount"){
			opTitle = "Load Funds";
			svcOperationController.storedValuePageData.mode = "Load";
			svcOperationController.storedValuePageData.modeText = "Source Account";
			svcOperationController.storedValuePageData.detailsText = "Notes";
			
			//set visibility for the transer load unload navigation item
			svcOperationController.storedValuePageData.transferMode = false;
			svcOperationController.storedValuePageData.loadMode = true;
			svcOperationController.storedValuePageData.unloadMode = false;
		}
		else{
			opTitle = "Unload Funds";
			svcOperationController.storedValuePageData.mode = "Unload";
			svcOperationController.storedValuePageData.modeText = "Target Account";
			svcOperationController.storedValuePageData.detailsText = "Notes";
			
			//set visibility for the transer load unload navigation item
			svcOperationController.storedValuePageData.transferMode = false;
			svcOperationController.storedValuePageData.loadMode = false;
			svcOperationController.storedValuePageData.unloadMode = true;
		}
		
		
		
		return opTitle;
	},
	
	selectHouseholdMember : function (){
		if(householdMembersForTransferController == undefined){
			householdMembersForTransferController = sap.ui.controller("app.ui.financialAccounts.householdMembersForTransferController");
		}
		householdMembersForTransferController.launchhouseholdMembersForTransferPage();
	},
	
	selectSourceAccount : function(){
		if(svaAccountsForLoadUnloadController == undefined){
			svaAccountsForLoadUnloadController = sap.ui.controller("app.ui.financialAccounts.svaAccountsForLoadUnloadController");
		}
		
		svaAccountsForLoadUnloadController.launchSvaAccountsForLoadUnloadPage();
	},
	
	selectTargetAccount : function(){
		if(svaAccountsForLoadUnloadController == undefined){
			svaAccountsForLoadUnloadController = sap.ui.controller("app.ui.financialAccounts.svaAccountsForLoadUnloadController");
		}
		svaAccountsForLoadUnloadController.launchSvaAccountsForLoadUnloadPage();
	},
	
	doneButtonTapped : function(){
		var amount = app.getCurrentPage().getContent()[0].byId("amount").getValue();
		
		if(amount <= 0){
			var verifyDialog = new sap.m.Dialog({
				title : oBundle.getText("Message"),
				content : [new sap.m.Text({
					text : oBundle.getText("correct_fields")
				})],
				leftButton : new sap.m.Button({
					text : oBundle.getText("OK"),
					width : "100%",
					tap :function(){
						verifyDialog.close();
						
					}
				})
			});
			verifyDialog.open();
			return;
		}
		
		var text = app.getCurrentPage().getContent()[0].byId("message").getValue();
		
		if(amount != "" && (svcOperationController.storedValuePageData.selectedAccount != null || svcOperationController.storedValuePageData.selectedHouseholdMember != null )){
			if(svcOperationController.storedValuePageData.mode == "Transfer"){
				//get the payeeId of selected Household Member
				var payeeId = svcOperationController.storedValuePageData.selectedHouseholdMember.customerId;
				
				//collect customer id of payer and payee
				svcOperationController.obj.payer.identifier.value = loginResponseModel.customer.id;
				svcOperationController.obj.payee.identifier.value = payeeId;
				
				//set payment instrument ids to null
				svcOperationController.obj.payer.paymentInstrumentId = null;
				svcOperationController.obj.payee.paymentInstrumentId = null;
				
				//set payment instrument types to 0
				svcOperationController.obj.payer.paymentInstrumentType = 0;
				svcOperationController.obj.payee.paymentInstrumentType = 0;
				
				//for transfer 
				svcOperationController.obj.useCase = 193; 
				
			}else if(svcOperationController.storedValuePageData.mode == "Load"){
				
				//get the customerId for payer and payee(both are same)
				svcOperationController.obj.payer.identifier.value = loginResponseModel.customer.id;
				svcOperationController.obj.payee.identifier.value = loginResponseModel.customer.id;
				
				//collect payment instrument ids
				svcOperationController.obj.payer.paymentInstrumentId = svcOperationController.storedValuePageData.selectedAccount.paymentInstrumentId;
				svcOperationController.obj.payee.paymentInstrumentId = makePrimaryCardController.selectedPageId;
				
				//set payment instrument types to null
				svcOperationController.obj.payer.paymentInstrumentType = null;
				svcOperationController.obj.payee.paymentInstrumentType = null;
				
				//for load
				svcOperationController.obj.useCase = 160; 
				
			}else if(svcOperationController.storedValuePageData.mode == "Unload"){

				//get the customerId for payee and payer(both are same)
				svcOperationController.obj.payer.identifier.value = loginResponseModel.customer.id;
				svcOperationController.obj.payee.identifier.value = loginResponseModel.customer.id;
				
				//get the paymentInstrument ids
				svcOperationController.obj.payer.paymentInstrumentId = makePrimaryCardController.selectedPageId;
				svcOperationController.obj.payee.paymentInstrumentId = svcOperationController.storedValuePageData.selectedAccount.paymentInstrumentId;
				
				//set payment instrument types to bull
				svcOperationController.obj.payer.paymentInstrumentType = null;
				svcOperationController.obj.payee.paymentInstrumentType = null;
				
				//for unload
				svcOperationController.obj.useCase = 161; 
				
			}
			
			//Set amount and text(amount should be multipied by 100)
			svcOperationController.obj.amount.value = amount*100;
			svcOperationController.obj.text = text;		
			
			//call PreAuthorisation
			util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
			SmartphoneService.preAuthorisation(svcOperationController.obj, svcOperationController.svcCallback);
		}
		else{
			var errorDialog = new sap.m.Dialog({
				title : oBundle.getText("message"),
				content : [new sap.m.Text({
					text : oBundle.getText("req_fields")
				})],
				leftButton : new sap.m.Button({
					text : oBundle.getText("ok"),
					width : "100%",
					tap :function(){
						errorDialog.close();
					}
				})
			});
			errorDialog.open();
		}
		
		
	},
	
	svcCallback : function(response, status){
		
		if(response.Status.code != 0){
			alert(response.Status.value);
			util.closeBusyDialog();
		}
		
		//Clear all fields
		app.getCurrentPage().getContent()[0].byId("amount").setValue("");
		app.getCurrentPage().getContent()[0].byId("message").setValue("");
		
		if (isRESTStatusCodeCorrect(response)){
			//Call PreAuthorisation Continue
			svcOperationController.transactionObj.ReferenceTransaction.systemId = response.Transaction.systemId;
			svcOperationController.transactionObj.ReferenceTransaction.value = response.Transaction.value;
			util.closeBusyDialog();
			util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
			SmartphoneService.preAuthorisationContinue(svcOperationController.transactionObj, svcOperationController.svcContinueCallback);
		}
		else{
			util.closeBusyDialog();
			logTechnicalError("Error while transacting with this payment card for the customer");
		}
	},
	
	svcContinueCallback : function(response, status){
		
		if(response.Status.code != 0){
			alert(response.Status.value);
			util.closeBusyDialog();
		}
		
		if (isRESTStatusCodeCorrect(response)){
			svcOperationController.storedValuePageData.selectedAccount = null;
			//move to wallet page
			util.closeBusyDialog();
			walletController.launchWalletPage();
		}
		else{
			logTechnicalError("Error while authenticating this transaction for the customer");
			util.closeBusyDialog();
		}
	}
});