sap.ui.controller('app.ui.financialAccounts.svaAccountsForLoadUnloadController', {
	
	svaAccountsData :{
		accounts : []
	},
	customerData : {
		customerId : null
	},
	
	launchSvaAccountsForLoadUnloadPage : function (){
		if(app.getPage(SVA_FOR_LOAD_UNLOAD_PAGE) == null)
		{
			var svaAccountsListView = sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.financialAccounts.svaAccountsForLoadUnloadView",
				viewId : "app.ui.financialAccounts.svaAccountsForLoadUnloadView",
				controller : this
			});
			
			var svaAccountsPage = new sap.m.Page(SVA_FOR_LOAD_UNLOAD_PAGE, {
				title : oBundle.getText("select_account"),
				content : [ svaAccountsListView ],
				showNavButton : true,
				navButtonText : oBundle.getText("cancel"),
				navButtonTap: function(){
					app.back();
				},
			});
			
			var svaAccountsModel = new sap.ui.model.json.JSONModel();
			svaAccountsListView.setModel(svaAccountsModel);
			
			app.addPage(svaAccountsPage);
		}
		
		//empty and full the customer Id
		svaAccountsForLoadUnloadController.customerData.customerId = null;
		svaAccountsForLoadUnloadController.customerData.customerId = loginResponseModel.customer.id;
		
		//Calls the service to get paymentCardInstruments
	    SmartphoneService.getWalletEntriesByCustomer(svaAccountsForLoadUnloadController.customerData, svaAccountsForLoadUnloadController.paymentCardDetailsCallBack);
		
	},
	
	paymentCardDetailsCallBack : function(response, status){
		if(response.Status.code != 0){
			alert(response.Status.value);
		}
		
		if (isRESTStatusCodeCorrect(response)){
			var svaAccounts = response.walletEntries;
			svaAccountsForLoadUnloadController.svaAccountsData.accounts = [];
			var j = 0;
			if(svcOperationController.storedValuePageData.mode == "Load"){
				for(var i = 0; i<svaAccounts.length; i++){
					if(svaAccounts[i].bankAccount != null || svaAccounts[i].creditCard !=null){
						svaAccountsForLoadUnloadController.svaAccountsData.accounts[j] = svaAccounts[i];
						j++;
					}
				}
			}else{
				for(var i = 0; i<svaAccounts.length; i++){
					if(svaAccounts[i].bankAccount != null){
						svaAccountsForLoadUnloadController.svaAccountsData.accounts[j] = svaAccounts[i];
						j++;
					}
				}
			}
			
			
			app.getPage(SVA_FOR_LOAD_UNLOAD_PAGE).getContent()[0].getModel().setData(svaAccountsForLoadUnloadController.svaAccountsData);
			app.to(SVA_FOR_LOAD_UNLOAD_PAGE);
			
		}
		else{
			logTechnicalError("Error while authenticating this transaction for the customer");
		}
	},
	
	accountSelected : function(ev){
		var source = ev.getSource().getSelectedItem();
		var selectedAccountDetails = source.getBindingContext().getProperty(source.getBindingContext().getPath());
		svcOperationController.storedValuePageData.loadUnloadTitle = selectedAccountDetails.alias;
		svcOperationController.storedValuePageData.selectedAccount = selectedAccountDetails;
		app.getPage("StoredValueAccountOperationPage").getContent()[0].getModel().setData(svcOperationController.storedValuePageData);
		for(var i=0; i<svaAccountsForLoadUnloadController.svaAccountsData.accounts.length; i++ ){
			svaAccountsForLoadUnloadController.svaAccountsData.accounts[i] = null;
		}
		app.back();
	}
	
});