// 2012 SAP AG. All rights reserved.

var doNothing = function(){};

sap.ui.controller('app.ui.googleMaps.mapController', {
    stores : [],
    programId : null,
	programCode : null,
    myLocation : null,
    isSearch : false,
    multiLocationsDialog : null,
    isInitialStores : true,
    detailsData : null,
    locationPermissionAllowed : false,
    previousPage : null,
    customGMap : null,
    
    

    launchPage : function(sTransitionName, prevPage) {
		//console.warn("MAP.CONTROLLER LAUNCHPAGE");
		var startRenderTime = util.startPerformanceReading();
		if (app.getPage(MAP_PAGE) == null) {
			var header = new sap.m.Bar(
					{
						contentRight : [ new sap.m.Button(
								'listButton',
								{
									text : oBundle
											.getText("List_button"),
									tap : this.toList
								}) ],
						contentMiddle : [ new sap.m.Label(
								"mapTitle",
								{
									text : oBundle
											.getText("Store_Locator")
								}) ],
						contentLeft : [ new sap.m.Button(
								'backButtonMap',
								{
									/*text : oBundle
											.getText("Back_Button"),
									type : sap.m.ButtonType.Back,
									tap : function(event, src) {
										app.backToPage(mapController.previousPage);
									}*/
									icon : "sap-icon://menu2",
									activeIcon : "sap-icon://menu2",
									tap : function(event, src) {
										sliderMenuController.action('menuButtonStoreLocator');
									}
				                }).addStyleClass("menuButtonIconFont")
							 ]
					});
	
//			this.searchField = new sap.m.SearchField({
//				width : "100%",
//				placeholder : oBundle.getText("store_search"),
//				search : this.searchByField,
//				layoutData : new sap.m.FlexItemData({
//					growFactor : 1
//				})
//			});
//			
			this.searchField = new sap.m.Input({
				width : "100%",
				placeholder : oBundle.getText("store_search"),
				change : mapController.searchByField,
				layoutData : new sap.m.FlexItemData({
					growFactor : 1
				})
			});
	
			var footer = new sap.m.Bar('gmaps_footer_bar',
					{
						contentRight : [ new sap.m.Button(
								{
									tap : mapController.locateMe,
									icon : "app/ui/googleMaps/img/locate.png",
									activeIcon : "app/ui/googleMaps/img/locate-active.png"
								}) ],
						contentMiddle : [ mapController.searchField ],
						enableFlexBox : true
					});
	
			var html = new sap.ui.core.HTML(
					{
						preferDOM : true,
						content : "<div id='map_canvas' style='width:100%; height:100%'/>"
					});
	
			var page1 = new sap.m.Page(MAP_PAGE, {
				customHeader : header,
				content : [ html ],
				footer : footer,
				enableScrolling : false
			});
			app.addPage(page1);
		}
		if(mapController.customGMap!=null)
			mapController.customGMap.clearOverlays();
		mapController.loadGoogleAPI(true);
	
		app.to(MAP_PAGE, sTransitionName);
		util.stopPerformanceReading(startRenderTime,
				"Locator Render Time");
	
	},

    loadGoogleAPI : function(loadMapNotRequired) {
		//console.warn("MAP.CONTROLLER LOADGOOGLEAPI");
		var key = userState.GOOGLE_APIKEY;
		var script = document.createElement("script");
		script.type = "text/javascript";
		if(loadMapNotRequired != undefined && loadMapNotRequired == true)
			script.src = "http://maps.googleapis.com/maps/api/js?v=3.9key="
				+ key + "&sensor=true&&callback=doNothing";
		else
			script.src = "http://maps.googleapis.com/maps/api/js?v=3.9key="
					+ key + "&sensor=true&callback=loadMap";
		document.head.appendChild(script);
	},

	locateMe : function() {
		if (mapController.locationPermissionAllowed == false) {
			util.alertDialog(oBundle
					.getText("location_Not_Allowed"));
			return;
		}
		// original call uses current location
		loadMap();
	},

	searchByField : function() {
		//console.warn("MAP.CONTROLLER UPDATE SEARCH");
		var searchValue = mapController.searchField.getValue();
		if (mapController.previousPage == ANONYMOUS_HOME_PAGE) {
			if (searchValue.trim().length > 0) {
				var request = {
					programCode : mapController.programCode,
					searchItem : searchValue
				};
				SmartphoneService.getStoreSearch(request, UpdateSearchOnMapBack, null, null, true);
			}
		}
		else{
			if (searchValue.trim().length > 0) {
				var request = {
					programId : mapController.programId,
					searchItem : searchValue
				};
				SmartphoneService.getStoreSearch(request, UpdateSearchOnMapBack, null, null, true);
			}	
		}
	},
    
    updateMyLocation : function() {
		var options = {
			enableHighAccuracy : true
		};
		var onSuccess = function(position) {
			mapController.locationPermissionAllowed = true;
			mapController.myLocation = {
				latitude : position.coords.latitude,
				longitude : position.coords.longitude,
				altitude : position.coords.altitude,
				accuracy : position.coords.accuracy,
				altitudeAccuracy : position.coords.altitudeAccuracy,
				heading : position.coords.heading,
				speed : position.coords.speed,
				timestamp : position.timestamp
			}
			mapController.getStores();
		};
		var onError = function(error) {
			//console.log('NAVIGATOR.GEOLOCATION ERROR');
			//console.log('code: ' + error.code + '\n' + 'message: ' + error.message + '\n');
			mapController.myLocation = undefined;
			mapController.locationPermissionAllowed = false;
			
			if (error.code == 1) {
				//console.log("Location Permission Denied");
				logError("location_Not_Allowed","Location Permission Denied","MapController");
				return;
				/*
				mapController.myLocation = {
					latitude : -66,
					longitude : -65,
				}
				
				 * var watrchId =
				 * navigator.geolocation.watchPosition(
				 * function(position){ console.warn("watch
				 * position success");
				 * this.locationPermissionAllowed = true;
				 * navigator.geolocation.clearWatch(watchId); },
				 * function(error){ console.warn("watch position
				 * failed"); this.locationPermissionAllowed =
				 * false; } );
				 
				mapController.getStores();
				*/
			} else if (error.code == 2) {
				//console.log("Location Not Available");
				logError("location_Not_Allowed","Location Not Available","MapController");
				return;
			}
		};
		navigator.geolocation.getCurrentPosition(onSuccess,
				onError, options);
	},
    
// to different pages function via buttons
	toList : function() {
		if (storeLocatorListController == undefined) {
			storeLocatorListController = sap.ui
					.controller("app.ui.storelocator.list");
		}
		storeLocatorListController.launchPage();
	},

	toDetailsPage : function(id) {
		//console.log("TO DETAILS CALL");
		request = {
			storeId : id
		};
		this.attachEvent("storeDetailsRetrieved",
				this.openDetailsPage);
		SmartphoneService.getStoreDetail(request,
				getStoreDetailBack, null, null, true);
	},
    

    openDetailsPage : function() {
		//console.log("OPEN DETAILS PAGE");
		mapController.detachEvent("storeDetailsRetrieved");
		if (shoppingListDetailsController == undefined) {
			shoppingListDetailsController = sap.ui
					.controller("app.ui.storelocator.details")
		}
		shoppingListDetailsController.launchPage();
	},

// SERVER CALL TO GET STORES
	getStores : function() {
		//console.warn("MAP.CONTROLLER GET STORES");
		if (mapController.previousPage == ANONYMOUS_HOME_PAGE) {
			if (userState.BRANDTYPE == "single") {
				var request = {
					programCode : mapController.programCode,
					location : {
						longitude : util
								.checkForUndefined(mapController.myLocation.longitude),
						latitude : util
								.checkForUndefined(mapController.myLocation.latitude)
					}
				};	
			}
			else if (userState.BRANDTYPE == "multi") {
				var request = {
					location : {
						longitude : util
								.checkForUndefined(mapController.myLocation.longitude),
						latitude : util
								.checkForUndefined(mapController.myLocation.latitude)
					}
				};	
			}
			
			var startServiceTime = util.startPerformanceReading();
			SmartphoneService.getStoreLocatorResults(request, GetStoreLocatorResultsBack, null, null, true);
		}
		else{
			var request = {
				programId : mapController.programId,
				location : {
					longitude : util
							.checkForUndefined(mapController.myLocation.longitude),
					latitude : util
							.checkForUndefined(mapController.myLocation.latitude)
				}
			};
			var startServiceTime = util.startPerformanceReading();
			SmartphoneService.getStoreLocatorResults(request, GetStoreLocatorResultsBack, null, null, true);
		}
		
	},
	
	selectCity : function(oControlEvent) {
		if (mapController.previousPage == ANONYMOUS_HOME_PAGE) {
			//console.warn("MAP.CONTROLLER SELECT CITY");
			var selectedItem = oControlEvent.getSource();
			var index = mapController.cities
					.indexOfItem(selectedItem);
			var item = this.oModel.getData().list[index];
			var request = {
				programCode : mapController.programCode,
				location : {
					latitude : item.location.latitude,
					longitude : item.location.longitude
				}
			};
			SmartphoneService.getStoreLocatorResults(request, GetStoreLocatorResultsBack, null, null, true);
		}
		else {
			//console.warn("MAP.CONTROLLER SELECT CITY");
			var selectedItem = oControlEvent.getSource();
			var index = mapController.cities
					.indexOfItem(selectedItem);
			var item = this.oModel.getData().list[index];
			var request = {
				programId : mapController.programId,
				location : {
					latitude : item.location.latitude,
					longitude : item.location.longitude
				}
			};
			SmartphoneService.getStoreLocatorResults(request, GetStoreLocatorResultsBack, null, null, true);
		}
		
		mapController.multiLocationsDialog.close();
	},
	
});

GetStoreLocatorResultsBack = function(response, status) {
	//console.warn("MAP.CONTROLLER  GETSTORELOCATORRESULTBACK");
	if (status != 200) {
		checkErrorStatus(status);
		return;
	} else if (isRESTStatusCodeCorrect(response)) {
		mapController.stores = response.StoreSearchResultList;
		mapController.isInitialStores = false;
		mapController.customGMap = new CustomGoogleMap();
		// draw the map on the specified canvas
		mapController.customGMap.drawMap('map_canvas', mapController.stores);
		// set the handle tab function for info bubble
		mapController.customGMap.handleTabFunc = function(location) {
			//console.log(location);
		};
	} else {
		checkErrorMobiliserStatus(response);
	}
};

getStoreDetailBack = function(response, status) {
	//console.warn("MAP.CONTROLLER  GETSTOREDETAILBACK");
	var data;
	if (status != 200) {
		checkErrorStatus(status);
		return;
	} else if (isRESTStatusCodeCorrect(response)) {
		mapController.detailsData = response.StoreDetail;
		// mapController.fireEvent("storeDetailsRetrieved");
		if (shoppingListDetailsController == undefined) {
			shoppingListDetailsController = sap.ui
					.controller("app.ui.storelocator.details")
		}
		shoppingListDetailsController.launchPage();
	} else if (response.Status.code == 329) {
		checkErrorMobiliserStatus(response);
	}
};
    


UpdateSearchOnMapBack = function(response, status) {
	//console.warn("MAP.CONTROLLER UPDATESEARCHONMAPBACK");
	if (status != 200) {
		checkErrorStatus(status);
		return;
	} else if (isRESTStatusCodeCorrect(response)) {
		var results = response.StoreSearchResultList;
		if (results.length != 0) {
			var data;
			var id = results[0].id;
			var name = results[0].name;
			if (id == 0 && name == "LocationSearchResult") {
				//console.warn("search returned list of cities.");
				// choose from city list from furthuer search
				var cities = response.StoreSearchResultList;
				for (key in cities) {
					cities[key].name = cities[key].shortAddress;
					cities[key].shortAddress = null;
				}
				var data = {
					list : cities
				}
				mapController.oModel = new sap.ui.model.json.JSONModel();
				mapController.oModel.setData(data);
				var citiesView = sap.ui.view({
					type : sap.ui.core.mvc.ViewType.XML,
					viewName : "app.ui.storelocator.cities",
					controller : mapController
				});
				mapController.cities = citiesView.byId("cityList");
				citiesView.setModel(mapController.oModel);

				// for different item segue behavior
				mapController.multiLocationsDialog = new sap.m.Dialog({
					title : oBundle.getText("Multiple_location_title"),
					// this will get ownership of the view, so when close the
					// dialog, need to set view back to the page content
					content : [ citiesView ],
				/*
				 * leftButton : new sap.m.Button({ text :
				 * oBundle.getText("cancel"), type : sap.m.ButtonType.Reject,
				 * tap : function() {
				 * mapController.multiLocationsDialog.close(); //
				 * mapController.detachEvent("storeListUpdated",
				 * mapController.replaceMarkers); } }),
				 */
				})
				mapController.multiLocationsDialog.open();
			} else {
				//console.warn("stores got back directly");
				// no need to choose city, stores got back directly
				mapController.stores = results;
				data = {
					list : mapController.stores
				}
				mapController.customGMap = new CustomGoogleMap();
				mapController.customGMap.drawMap('map_canvas', mapController.stores);
				// set the handle tab function for info bubble
				mapController.customGMap.handleTabFunc = function(location) {
					//console.log(location);
				};
			}
		} else {
			logError(oBundle.getText("error_message_no_results_found"),
					"Map page search result gave empty response",
					"mapController");
		}
		//console.warn(results.length);
	} else {

		checkErrorMobiliserStatus(response);
	}
};

/*
 * loadMap from initial reload via back or going to map page again locate me
 * button on map page after search from list
 */

loadMap = function(isSearch, latitude, longitude) {
	//console.warn("MAP.CONTROLLER  LOAD MAP");
	if (isSearch) {
		mapController.myLocation.latitude = latitude;
		mapController.myLocation.longitude = longitude;
		mapController.getStores();
	} else {
		//console.warn("MAP.CONTROLLER  UPDATE MY LOCATION CALL");
		mapController.updateMyLocation();
	}
	// get List of Stores
	// alert("LOAD MAP longitude " + mapController.myLocation.longitude + "
	// latitude: " + mapController.myLocation.latitude)

};