sap.ui.controller('app.ui.home.homeController', {
    notLoggedInToPage : null,
    modelData : {
        loggedInVsiibility : false,
        notLoggedInVisiblity : true,
        signedSingleBrandMode : false,
        unSignedSingleBrandMode : false,
        displayOffers : false,
        notConnectedToServer : false,
        brandMode : "",
        offers : [],
        cardId : "",
        programName : "",
        homeFooterMenu : [],
        homeFooterMenuLastItem : [],
        homeDemoConnectedToServer : false,
        homeSignUpText : oBundle.getText("sign_up_for"),
        logo: "",
    	pointsName : "", 
    	offersRefreshNeeded : 0,
    	callAppConfig : true,
    },
	productCatalogueURL : "",
    prevPage: "initial",
    pageCount : 0,
	isSelfScanningEnabled : false,
    launchAnonymousHomePage : function(){
    	homeController.pageCount = 0;
    	util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
    	//Empty the current ofers in the screen.
    	if(userState.DEMO_MODE){
    		homeController.prevPage = "to";
    		homeController.modelData.homeDemoConnectedToServer = false;
    		homeController.getHomeScreenMode("connected");
    	}
        //if no connection settings, go to generic screen
    	else if (userState.IPADDRESS == "" || userState.PROTOCOL == "") {
			homeController.modelData.signedSingleBrandMode = false;
            homeController.modelData.unSignedSingleBrandMode = false;
            homeController.modelData.displayOffers = false;
            homeController.modelData.notConnectedToServer = true;
            homeController.modelData.homeDemoConnectedToServer = false;
            
            if(userState.IPADDRESS == "" && userState.PROTOCOL == ""){
            	if(connectionSettingsController == undefined)
    				connectionSettingsController = sap.ui.controller('app.ui.home.connectionSettings');
    			connectionSettingsController.launchConnectionSettingPage();
            	return;
            }
            //If connection settings was not successful then stay in current page.
            var prev = app.getCurrentPage().getId();
            if(prev == "serviceSettingsPage"){
            	util.closeBusyDialog();
            	logError("pre_call_not_connected","Not connected to server","Connection failed");
            	
            	return;
            }
            util.closeBusyDialog();
			
		}
		//if connection settings exist, check server data
		else{
			homeController.modelData.homeDemoConnectedToServer = true;
			var callBack = function(response,status){
				
				var connectionStatus;
				
				if(isRESTStatusCodeCorrect(response)) {
					connectionStatus = "connected";
				}
				else{
					connectionStatus = "disconnected";
				}
				homeController.getHomeScreenMode(connectionStatus);
			};
			
			var body = {
					origin:"mLoyalty",
					traceNo: UUIDv4()
			};
                  
            SmartphoneService.setUrl();
			
			//Pass the true value to indicate ping service that it is an anonymous call and decrease the timeout period.
			SmartphoneService.ping(body,callBack,true);
			
		}
    },
    //Check whether the user has given the correct connection settings or not.
    getHomeScreenMode : function(connectionStatus){
        /*if connection settings are not done*/
    	
        if(connectionStatus == "disconnected"){
            homeController.modelData.signedSingleBrandMode = false;
            homeController.modelData.unSignedSingleBrandMode = false;
            homeController.modelData.displayOffers = false;
            homeController.modelData.notConnectedToServer = true;
            
            //If ping service call did not work then stay in the connection settings page.
            var prev = app.getCurrentPage().getId();
            if(prev == "serviceSettingsPage"){
            	util.closeBusyDialog();
            	alert(oBundle.getText("pre_call_not_connected"));
            	return;
            }
        }
        else{
        	//Call all app configuration function if connection settings was successful.
        	if(homeController.modelData.callAppConfig || userState.DEMO_MODE){
        		SmartphoneService.getAllConfigurationParameters("no val pass", homeController.getAllAppConfigBack);
        		homeController.modelData.callAppConfig = false;
        	}
        	else{
    			//Set the data if getAllApppConfiguration call was successful.
    			homeController.setHomeScreenContent();
        		if(userState.LOGGED_IN){
        			homeController.setLoggedInOffers();
        			
        		}
        		else{
        			homeController.setAnonymousOffers();
        		}
        	}
        		
            //SmartphoneService.getLoyaltyConfiguration("BrandMode", homeController.checkBrandBack);
        }
    },
    setAnonymousOffers : function(){
    	if(homeController.modelData.brandMode == "single"){
            homeController.modelData.unSignedSingleBrandMode = true;
            homeController.modelData.signedSingleBrandMode = false;
        }
        else{
            homeController.modelData.signedSingleBrandMode = false;
            homeController.modelData.unSignedSingleBrandMode = false;
        }
    	//CHECK BRAND MODE HERE
		var getAllOffersData = {
                locale : navigator.language.split("-")[0]
        };
    	//call getAnonymousOffers service
		if(homeController.isRefreshNeeded())
			SmartphoneService.getAnonymousOffers(getAllOffersData, homeController.offersCallback);
		//Simultaneous call for getMemberCardAnonymousBackgroundImage service call in case of single brand mode and in case of multi brand directly call the home screen.
		if(homeController.modelData.brandMode == "single"){
    		
    		SmartphoneService.getSingleBrandAnonymousProgramInfo("Anonymous",homeController.getMemberFrontCardAnonymousCallback);
            
        }
        else if(homeController.modelData.brandMode == "multi"){
        	homeController.setHomeScreenContent();
        }
    },
    setLoggedInOffers : function(){
    	homeController.modelData.unSignedSingleBrandMode = false;
        if(homeController.modelData.brandMode == "single"){
            homeController.modelData.signedSingleBrandMode = true;
        }
        else{
            homeController.modelData.signedSingleBrandMode = false;
        }
    	//CHECK BRAND MODE HERE
		var getAllOffersData = {
                locale : navigator.language.split("-")[0]
        };
    	//Call getAllOffers for logged in members
		if(homeController.isRefreshNeeded()){
			if(allOffersController && allOffersController.allOffersModel && allOffersController.allOffersModel.oData.length > 0){
                var response = {
                		offer : allOffersController.allOffersModel.oData,
                		Status : {
                			code : 0,
                			value : null
                		}
                	}
                
                homeController.offersCallback(response, 200);
            }
			else
				SmartphoneService.getAllOffers(getAllOffersData, homeController.offersCallback);
		}
		else{
			if(allOffersController && allOffersController.allOffersModel && allOffersController.allOffersModel.oData.length > 0){
				homeController.modelData.offers = [];
                var response = {
                		offer : allOffersController.allOffersModel.oData,
                		Status : {
                			code : 0,
                			value : null
                		}
                	}
                
                homeController.offersCallback(response, 200);
            }
		}
        //Simutaneous call for getMemberCards in case of single brand scenario and in case of multi brand set the home scree.
        if(homeController.modelData.brandMode == "single"){
            //SmartphoneService.getMemberCards(loginResponseModel.customer.memberId, homeController.getWalletCardId);
        	/*homeController.modelData.programName = subscribedPrograms[0].programName;
        	homeController.modelData.logo = "data:image/png;base64,"+subscribedPrograms[0].logo;*/
        	homeController.modelData.programName = subscribedPrograms[0].programName;
        	if(allOffersController == undefined)
        		allOffersController = sap.ui.controller('app.ui.offers.allOffersController');
        	homeController.renderLoggedInCardTemplate();
        	//SmartphoneService.getMembershipReward(subscribedPrograms[0].membershipId, homeController.setCardTemplateForLoggedIn);
        }
        else if(homeController.modelData.brandMode == "multi"){
        	homeController.setHomeScreenContent();
        }
    },
    //call back handler for getAllAppConfiguration services
	getAllAppConfigBack : function(response, status){
		homeController.modelData.notConnectedToServer = false;
        homeController.modelData.displayOffers = true;
        var loggedIn = userState["LOGGED_IN"];
        homeController.modelData.brandMode = "";
        
        if(isRESTStatusCodeCorrect(response)){
        	if (allOffersController == undefined) 
				allOffersController = sap.ui.controller("app.ui.offers.allOffersController");
			//SET BRAND MODE
			homeController.isSelfScanningEnabled = response.selfScanningEnabled;
			userState.BRANDTYPE = response.AppConfiguration.brandMode;
			userState['CARD_CAPTURE_RESOLUTION'] = response.AppConfiguration.cardCaptureResolution;
			cardCaptureResolution = response.AppConfiguration.cardCaptureResolution;
			userState['CHECKIN_ENABLED'] = response.AppConfiguration.checkInEnabled;
			userState['FACEBOOK_APPID'] = response.AppConfiguration.facebookAppId;
			
			facebookAppId = response.AppConfiguration.facebookAppId;
			if(facebookAppId !== "" && facebookAppId !== null && facebookAppId !== undefined) {
				if(window.cordova) {
					if(device.platform.indexOf("Android") !== -1) initializeFacebook();
				}			
			}
			userState['GOOGLE_APIKEY'] = response.AppConfiguration.googleAPIKey;
			
			userState['MOBILE_PAYMENT_ENABLED'] = response.AppConfiguration.mobilePaymentEnabled;
			userState['OFFER_REFRESH_PERIOD'] = response.AppConfiguration.offersRefreshPeriod;
			userState['SELF_SCANNING_ENABLED'] = response.AppConfiguration.selfScanningEnabled;
			userState['SHOPPING_ENABLED'] =  response.AppConfiguration.shoppingEnabled;
			userState['SHOPPING_LIST_ENABLED'] = response.AppConfiguration.shoppingListEnabled;
			userState['SINGLE_BRAND_PROGRAM_CODE'] = response.AppConfiguration.singleBrandProgramCode;
			userState['STORE_TO_RETURN'] = response.AppConfiguration.storesToReturn;
			userState['TOKEN_VALIDATION_ENABLED'] = response.AppConfiguration.tokenValidationEnabled;
			if(response.AppConfiguration.tokenValidationtype)
				userState['TOKEN_VALIDATION_TYPE'] = response.AppConfiguration.tokenValidationtype;
			else
				userState['TOKEN_VALIDATION_TYPE'] = "";
			
			/*passcode length convert string to value */
			if ( response.AppConfiguration.walletPasscodeLength == 0)
				userState['PASSCODE_LENGTH'] = 0;
			else if ( response.AppConfiguration.walletPasscodeLength == 3)
				userState['PASSCODE_LENGTH'] = 3;
			else if ( response.AppConfiguration.walletPasscodeLength == 4)
				userState['PASSCODE_LENGTH'] = 4;
			else if ( response.AppConfiguration.walletPasscodeLength == 5)
				userState['PASSCODE_LENGTH'] = 5;
			else if ( response.AppConfiguration.walletPasscodeLength == 6)
				userState['PASSCODE_LENGTH'] = 6;
			userState['PASSCODE_TIMEOUT'] = response.AppConfiguration.walletPassCodeTimeout * 1000;

			if(response.AppConfiguration.picklistTimeout != undefined &&
					response.AppConfiguration.picklistTimeout != null &&
					response.AppConfiguration.picklistTimeout.length > 0)
				userState.PICKLIST_TIMEOUT = parseInt(response.AppConfiguration.picklistTimeout);
			
			if(response.AppConfiguration.walletPassCodeEnabled != undefined &&
					response.AppConfiguration.walletPassCodeEnabled == 'false')
				userState.WALLET_PASSCODE_ENABLED = false;
			else
				userState.WALLET_PASSCODE_ENABLED = true;
			if (response.AppConfiguration.houseHoldingEnabled == 'true') {
				userState['HOUSEHOLDING_ENABLED'] = true;
			}
			else {
				userState['HOUSEHOLDING_ENABLED'] = false;
			}
			
            homeController.modelData.brandMode = response.AppConfiguration.brandMode;
            //SET APP MODE
            if(userState.DEMO_MODE){
            	
            }
            else{
				if (response.AppConfiguration.appMode == "mLoyalty" ) {
					userState.APP_MODE = "mLoyalty";
				}
				else{
					userState.APP_MODE = "mShopping";
				}
            }
			//homeController.modelData.shoppingEnabled = userState.APP_MODE;
			//SET GOOGLE API KEY
			userState.GOOGLE_APIKEY = response.AppConfiguration.googleAPIKey;
			
			//CHECK BRAND MODE HERE
			var getAllOffersData = {
                    locale : navigator.language.split("-")[0]
            };
			
			if(response.AppConfiguration.picklistTimeout != undefined &&
					response.AppConfiguration.picklistTimeout != null &&
					response.AppConfiguration.picklistTimeout.length > 0)
				userState.PICKLIST_TIMEOUT = parseInt(response.AppConfiguration.picklistTimeout);
			
			if(response.AppConfiguration.walletPassCodeEnabled != undefined &&
					response.AppConfiguration.walletPassCodeEnabled == 'false')
				userState.WALLET_PASSCODE_ENABLED = false;
			else
				userState.WALLET_PASSCODE_ENABLED = true;
			if (response.AppConfiguration.defaultCountryCode != "") {
				userState.DEFAULT_COUNTRY_CODE  = response.AppConfiguration.defaultCountryCode;
			}
			else{
				userState.DEFAULT_COUNTRY_CODE  = "US";
			}
			
            /*if logged in then unsigned mode is false and single brand mode depends on the brand mode*/
            /*if logged in then call the getAllOffers service else call the get anonymous offers*/
            if(loggedIn){
                homeController.modelData.unSignedSingleBrandMode = false;
                if(homeController.modelData.brandMode == "single"){
                    homeController.modelData.signedSingleBrandMode = true;
                }
                else{
                    homeController.modelData.signedSingleBrandMode = false;
                }
                //Call getAllOffers for logged in members
                SmartphoneService.getAllOffers(getAllOffersData, homeController.offersCallback);
                
                homeController.setLoggedInOffers();
            }
            else{
                if(homeController.modelData.brandMode == "single"){
                    homeController.modelData.unSignedSingleBrandMode = true;
                    homeController.modelData.signedSingleBrandMode = false;
                }
                else{
                    homeController.modelData.signedSingleBrandMode = false;
                    homeController.modelData.unSignedSingleBrandMode = false;
                }
				var getAllOffersData = {
					locale : navigator.language.split("-")[0]
				};
				//SET SINGLE BRAND PROGRAM CODE
				if (userState.BRANDTYPE == "single") {
					if ( response.AppConfiguration.singleBrandProgramCode ) {
						userState.SINGLE_BRAND_PROGRAM_CODE = response.AppConfiguration.singleBrandProgramCode;
					}	
				}
				//Set the data if getAllApppConfiguration call was successful.
				homeController.setAnonymousOffers();
			}
		}
        else{
        	//console.log("Error in response for getAlAppConfiguration service call");
        }
        homeController.setHomeScreenContent();
	},
	isRefreshNeeded : function(){
		var currentTime = new Date().getTime();
		if (currentTime >= homeController.modelData.offersRefreshNeeded || userState.DEMO_MODE) {
			homeController.modelData.offersRefreshNeeded = 0;
			homeController.modelData.offers = [];
			return true;
		} else {
			return false;
		}
	},
	renderLoggedInCardTemplate : function(){
		var details = allOffersController.generateProgramTierAndPointsInfo(subscribedPrograms[0]);
		var programName = subscribedPrograms[0].programName;
		var programLogo = subscribedPrograms[0].logo;
		var programBackground = subscribedPrograms[0].logoUrlOrColour;
		var tierName = "";
		if(subscribedPrograms[0].memberPointInfo){
			if(subscribedPrograms[0].memberPointInfo.tierPointInfo)
				tierName = subscribedPrograms[0].memberPointInfo.tierPointInfo.tierName;
		}
		var programDetails = "";
		if(programLogo){
			if(!userState.DEMO_MODE)
				programLogo = "data:image/png;base64," + programLogo;
		}
		if(programBackground == null)
			programBackground = "rgb(0, 122, 255)";
		else if(programBackground.length == 6)
			programBackground = "#" + programBackground;
		else if(programBackground.length > 6)
			programBackground = programBackground;
		if(tierName)
			programDetails = tierName + " | " + details;
		else
			programDetails = details;
		$('#homeAnonymousView--cardHomeFrontPlaceHolder').html("");
		if(programName){
			$('#homeAnonymousView--cardHomeFrontPlaceHolder').css("position","relative");
			$('#homeAnonymousView--cardHomeFrontPlaceHolder').append("<div style='float:left'><img style='width: 40px;margin-top: 10px;margin-left: 10px; margin-right:10px;' src='"+programLogo+"'/></div>");
        	$('#homeAnonymousView--cardHomeFrontPlaceHolder').append("<span style='font-size: 18px;color: #ffffff;position: relative;top: 14px;'>"+programName+"</span");
        	$('#homeAnonymousView--cardHomeFrontPlaceHolder').append("<div style='position:absolute;bottom:22px;'><div style='clear:left;padding-left: 10px;float: left;font-size: 11px;color: white;'>"+loginResponseModel.customer.displayName+"</div><div style='clear:left;padding-left: 10px;float: left;font-size: 11px;color: white;'>"+programDetails+"</div></div>");
        	//$('#homeAnonymousView--cardHomeFrontPlaceHolder').append("<div><table style='clear:both;color:#ffffff;padding-left: 10px;'><tr><th style='text-align:left;color:#ffffff'>"+ nextTierValue+"</th><th style='text-align:left;color:#ffffff'>"+currentTierValue+"</th></tr><tr><td style='text-align:left;font-size:12px;'>"+pointsToNextTier+"</td><td style='text-align:left;font-size:12px;'>"+pointsInThisTier+"</td></tr></table></div>");
        	
            $('#homeAnonymousView--cardHomeWrapper').addClass("cardHomeWrapper");
            $('#homeAnonymousView--cardHomeFrontPlaceHolder').css("border-radius","10px");
            $('#homeAnonymousView--cardHomeFrontPlaceHolder').css("background",programBackground);
		}
		else{
			$('#homeAnonymousView--cardHomeFrontPlaceHolder').html("");
            $('#homeAnonymousView--cardHomeWrapper').removeClass("cardHomeWrapper");
		}
	},
	
    //Get the offers details for the user when he is logged in.
	offersCallback : function(response,status){
		if (status != 200) {
			checkErrorStatus(status);
			return;
		}
		else if( isRESTStatusCodeCorrect(response) ) {
        //keeps track of the number of offer items to be displayed in single and multi brand scenario. For home screen
		var count = 0;
        
		//If single brand offers count should be maximum 2. In case of multi brand scenario max offers is 4.
        if(homeController.modelData.brandMode == "single"){
            //homeController.modelData.signedSingleBrandMode = true;
            if(response.offer.length < 2)
                count = response.offer.length;
            else
                count = 2;
        }
        else{
            //homeController.modelData.signedSingleBrandMode = false;
            if(response.offer.length < 4)
                count = response.offer.length;
            else
                count = 4;
        }
        /*Store the offers in this property array*/
        for(var i = 0 ; i < count ; i++){
        	if(userState['LOGGED_IN'])
                var programLogo = allOffersController.getProgramImageFromProgramId(response.offer.programId);
            else
                var programLogo = null;
            var isHighlight = true;

            if (response.offer[i].highlight == null) {
                isHighlight = false;
            }
            var tempCaption;
            if(response.offer[i].caption == null){
                tempCaption = "";
            }
            else
                tempCaption = response.offer[i].caption;
            var couponDetailData = {
            		amountPointsNeeded : response.offer[i].amountPointsNeeded,
                    
                    offerId : response.offer[i].offerId,
                    caption : tempCaption,
                    highlight : response.offer[i].highlight,
                    description : response.offer[i].description,
                    subCaption : response.offer[i].subCaption,
                    couponImage : response.offer[i].image,
                    isWanted : response.offer[i].isWanted,
                    isExpiring : response.offer[i].isExpiring,
                    isFeatured : response.offer[i].isFeatured,
                    isNew : response.offer[i].isNew,
                    imageSource : "",
                    programId : response.offer[i].programId,
                    thumbUrl : response.offer[i].thumbUrl,
                    url : response.offer[i].url,
                    image : response.offer[i].image,
                    validTime : "",
                    programLogo : programLogo,
                    isHighlight : isHighlight,
                    couponTypeid : response.offer[i].couponTypeid
            };
            var fromDate = homeController.convertOfferDatesToReadableFormat(response.offer[i].validFrom);
            var toDate = homeController.convertOfferDatesToReadableFormat(response.offer[i].validTo);
            couponDetailData.validTime = fromDate + " to " + toDate;
            if (couponDetailData.image != undefined || couponDetailData.image != null) {
            	var appendText = "data:image/png;base64,";
            	if(couponDetailData.image.indexOf(appendText, 0) == -1)
            		couponDetailData.image = "data:image/png;base64,"+ couponDetailData.image;
            	couponDetailData.url = couponDetailData.image;
            	couponDetailData.thumbUrl = couponDetailData.image;
			}
			
			
			if (couponDetailData.thumbUrl == null || couponDetailData.thumbUrl.length == 0 || userState['DEMO_MODE'] == true) {
				couponDetailData.thumbUrl = couponDetailData.url;
			}
			//In case the url image is not there, insertinga blank transparent image so that the uilayout doesn't break on redeem offers page.
			if (couponDetailData.url == null || couponDetailData.url.length == 0) {
				couponDetailData.url = "data:image/gif;base64,R0lGODlhAQABAAAAACH5BAEKAAEALAAAAAABAAEAAAICTAEAOw==";
			}
            if (couponDetailData.isWanted !== false) {
				couponDetailData.imageSource = "app/ui/offers/images/want-fold.png";
				//sap.ui.getCore().byId("couponDetailButton1iOS").addStyleClass("sapmbtnactive");
			}
			else if (couponDetailData.isExpiring !== false) {
				couponDetailData.imageSource = "app/ui/offers/images/expiring-banner.png";
			}
			else if (couponDetailData.isNew !== false) {
				couponDetailData.imageSource = "app/ui/offers/images/new-banner.png";
			}
            homeController.modelData.offers.push(couponDetailData);
            if(homeController.modelData.offersRefreshNeeded == 0)
        		homeController.modelData.offersRefreshNeeded = new Date().getTime() + 60 * 1000 * 1;
        }
        
        //Set the home screen with the offers fetched.
		}
        homeController.setHomeScreenContent();
    },
    
    //Call back for anonymous card template in single brand scenario.
    getMemberFrontCardAnonymousCallback : function(response, status){
        
        if(isRESTStatusCodeCorrect(response)){
        	
        	if(response.singleBrandAnonymousProgramInfo.logoUrlOrColour){
        		if(response.singleBrandAnonymousProgramInfo.logoUrlOrColour.length == 6)
        			homeController.modelData.cardSingleBrandMode = "#" +response.singleBrandAnonymousProgramInfo.logoUrlOrColour;
        		else
        			homeController.modelData.cardSingleBrandMode = response.singleBrandAnonymousProgramInfo.logoUrlOrColour;
        	}
        	else
        		homeController.modelData.cardSingleBrandMode = "rgb(0, 122, 255)";
        	if(response.singleBrandAnonymousProgramInfo.programName)
        		homeController.modelData.programName = response.singleBrandAnonymousProgramInfo.programName;
        	if(response.singleBrandAnonymousProgramInfo.logo)
        		homeController.modelData.logo = "data:image/png;base64,"+ response.singleBrandAnonymousProgramInfo.logo;
        	$('#homeAnonymousView--cardPlaceHolder').css("background",homeController.modelData.cardSingleBrandMode);
        	$('#homeAnonymousView--cardPlaceHolder').css("border-radius","10px");
	        $('#homeAnonymousView--cardHomeFrontPlaceHolder').html("");
	        $('#homeAnonymousView--cardHomeWrapper').removeClass("cardHomeWrapper");
        }
        else{
        	//console.log("Card template for anonymous acces error");
        }
        
        //Set the background image for anonymous scenario.  
        homeController.setHomeScreenContent();
    },
    
    //Inflates the footer menu options.
    getFooterContent : function(){
    	homeController.modelData.homeFooterMenu = [];
    	homeController.modelData.isLastItem = false;
    	homeController.modelData.homeFooterMenuLastItem = [];
        if(homeController.modelData.brandMode == "single"){
            homeController.modelData.homeFooterMenu = [{
                    menuName : oBundle.getText("Store_Locator"), 
                    menuIcon : "sap-icon://locate-me"
            }];
            if(userState.SHOPPING_LIST_ENABLED == "true"){
            	homeController.modelData.homeFooterMenu.push({
                    menuName : oBundle.getText("anonymousHome_shoppingList"), 
                    menuIcon : "sap-icon://survey"
                });
            }
            if(userState.APP_MODE != "mLoyalty"){
            	if(userState.CHECKIN_ENABLED == "true")
            		homeController.modelData.homeFooterMenu.push({
            			menuName : oBundle.getText("anonymousHome_checkIn"), 
            			menuIcon : "sap-icon://functional-location"
            		});
            	homeController.modelData.homeFooterMenu.push({
                    menuName : oBundle.getText("anonymousHome_productCatalog"), 
                    menuIcon : "sap-icon://dimension"
                });
            	if(userState.SELF_SCANNING_ENABLED == "true"){
	            	homeController.modelData.homeFooterMenu.push({
	                    menuName : oBundle.getText("anonymousHome_scanProduct"), 
	                    menuIcon : "sap-icon://bar-code"
	                });
            	}
            	if(userState.MOBILE_PAYMENT_ENABLED == "true")
                	homeController.modelData.homeFooterMenu.push({
                        menuName : oBundle.getText("anonymousHome_mobilePay"), 
                        menuIcon : "sap-icon://iphone-2"
                });
            }
        }
        else{
            homeController.modelData.homeFooterMenu = [{
                menuName : oBundle.getText("Store_Locator"), 
                menuIcon : "sap-icon://locate-me"
            }];
            
            if(userState.SHOPPING_LIST_ENABLED == "true")
            	homeController.modelData.homeFooterMenu.push({
                    menuName : oBundle.getText("anonymousHome_shoppingList"), 
                    menuIcon : "sap-icon://survey"
                });
            /*if(userState.MOBILE_PAYMENT_ENABLED)
            	homeController.modelData.homeFooterMenu.push({
                    menuName : oBundle.getText("anonymousHome_mobilePay"), 
                    menuIcon : "sap-icon://iphone-2"
                });*/
        }
        //If footer length is odd number then the last footer menu option needs to be stretched.
        var footerLength = homeController.modelData.homeFooterMenu.length;
        if(footerLength % 2 != 0){
        	
        	homeController.modelData.isLastItem = true;
        	homeController.modelData.homeFooterMenuLastItem.push(homeController.modelData.homeFooterMenu[footerLength - 1]);
        	homeController.modelData.homeFooterMenu.splice(footerLength - 1,1);
        }
    },
    //Sets the home screen content that needs to be displayed when the app is launched.
    setHomeScreenContent : function(){
    	homeController.pageCount++;
        //Call anonymous home page.
    	//Create slider menu when app was launched else inflate the slider menu.
        if (sliderMenuController == undefined){
            sliderMenuController = sap.ui.controller("app.ui.slidermenu.sliderMenuController");
            sliderMenuController.createSliderMenu();
        }
        else
        	sliderMenuController.sliderListView.setModel(sliderMenuController.getSliderMenuNavListModel());
        
        //Set the default selected option in home screen.
        /*var allOffersMenuItem = sliderMenuController.sliderListView.byId("menuNavList").getItems();
		sliderMenuController.setSelectedItemForNavList(allOffersMenuItem[0]);*/
        
        var loggedInHeader = new sap.m.Bar({
            contentMiddle : [new sap.m.Label({
                text : oBundle.getText("HomePageTitle"),
            })],
            contentLeft : [new sap.m.Button({
                icon: "sap-icon://menu2",
                activeIcon: "sap-icon://menu2",
                tap : function(event, src) {
                    homeController.selectMenu();
                }
            }).addStyleClass("menuButtonIconFont")]
        });
            
        //var mShoppingMode = true;
        if (app.getPage(ANONYMOUS_HOME_PAGE) == null) {
        	
        	var header = new sap.m.Bar({
                contentRight : [new sap.m.Button("home_sign_in_option", {
                    tap : function(event, src) {
                        if (homepageController==undefined){
                            homepageController = sap.ui.controller("app.ui.login.login");
                        }   
                        //If user logs in demo mode, taps on home page then taps on sign in button then we need to set demo mode flag as false;
                        //userState.DEMO_MODE = false;
                        launchLoginPage();
                    },
                    text : oBundle.getText("TitleSignIn"),
                })],
                contentMiddle : [new sap.m.Label({
                    //TODO: TRANSLATION ONCE TITLE DECIDED
                    text : oBundle.getText("HomePageTitle"),
                })],
                contentLeft : [new sap.m.Button({
                    icon: "sap-icon://menu2",
                    activeIcon: "sap-icon://menu2",
                    tap : function(event, src) {
                        homeController.selectMenu();
                    }
                }).addStyleClass("menuButtonIconFont")]
            });
        	
            var homePageView = sap.ui.view({
                type : sap.ui.core.mvc.ViewType.XML,
                viewName : "app.ui.home.homeView",
                id : "homeAnonymousView",
                controller : homeController
            });
            this.oModel = new sap.ui.model.json.JSONModel();
            homePageView.setModel(this.oModel);
            
            var homePage = new sap.m.Page(ANONYMOUS_HOME_PAGE, {
              customHeader : header,
              content : [homePageView]
            });
            app.addPage(homePage);
        }
		
        var signInBtn = app.getPage(ANONYMOUS_HOME_PAGE).getCustomHeader().getContentRight()[0];
        if ( userState['LOGGED_IN']) {
        	signInBtn.setVisible(false);
        }
        else{
        	signInBtn.setVisible(true);
        }
        if(homeController.pageCount == 1)
        	homeController.getFooterContent();
        app.getPage(ANONYMOUS_HOME_PAGE).getContent()[0].getModel().setData(homeController.modelData);
		//app.getPage(ANONYMOUS_HOME_PAGE).rerender()
        if(homeController.pageCount == 1){
			switch (homeController.prevPage ) {
				case "initial":
					app.to(ANONYMOUS_HOME_PAGE,"show");
					break;
				case "back":
					app.backToPage(ANONYMOUS_HOME_PAGE);
					break;
				case "to":
					app.to(ANONYMOUS_HOME_PAGE);
					break;
			}
        }
        //Display the card only when the brand mode is Single. 
        if(homeController.modelData.unSignedSingleBrandMode != false){
        	if(homeController.modelData.cardSingleBrandMode){
        		$('#homeAnonymousView--cardPlaceHolder >.sapMFlexItem').css("background",homeController.modelData.cardSingleBrandMode);
        	}
        	else{
        		$('#homeAnonymousView--cardPlaceHolder >.sapMFlexItem').css("background","rgb(0, 122, 255)");
        	}
        	$('#homeAnonymousView--cardHomeFrontPlaceHolder').addClass("unsignedSingleBrand");
        	$('#homeAnonymousView--cardPlaceHolder').css("margin-bottom","16px");
            try{
	            var viewRef = app.getPage(ANONYMOUS_HOME_PAGE).getContent()[0].byId("cardPlaceHolder");
	            viewRef.addStyleClass("homeScreenCardStye");
            }catch(e){
            	
            }
            
        }
        if(homeController.modelData.signedSingleBrandMode){
        	$('#homeAnonymousView--cardPlaceHolder').css("margin-bottom","");
        	$('#homeAnonymousView--cardHomeFrontPlaceHolder').css("background",homeController.modelData.cardSingleBrandMode);
        	$('#homeAnonymousView--cardHomeFrontPlaceHolder').addClass("unsignedSingleBrand");
        }
        else{
        	$('#homeAnonymousView--cardHomeFrontPlaceHolder').css("background","");
        	$('#homeAnonymousView--cardHomeFrontPlaceHolder').html("");
        	$('#homeAnonymousView--cardHomeFrontPlaceHolder').removeClass("unsignedSingleBrand");
        }
        if(homeController.modelData.brandMode == "multi"){
        	$('#homeAnonymousView--cardHomeFrontPlaceHolder').html("");
        }
        if(homeController.modelData.brandMode == "single"){
        	//if(homeController.modelData.programName == undefined || homeController.modelData.programName == null || homeController.modelData.programName == "")
        	if(!userState.LOGGED_IN)
        		app.getPage(ANONYMOUS_HOME_PAGE).getCustomHeader().getContentMiddle()[0].setText(oBundle.getText("HomePageTitle"));
        	else
        		app.getPage(ANONYMOUS_HOME_PAGE).getCustomHeader().getContentMiddle()[0].setText(homeController.modelData.programName);
        }
        else
            app.getPage(ANONYMOUS_HOME_PAGE).getCustomHeader().getContentMiddle()[0].setText(oBundle.getText("HomePageTitle"));
        /*if(homeController.modelData.notConnectedToServer || (homeController.modelData.offers.length <= 2 && homeController.modelData.brandMode == "multi") || (homeController.modelData.offers.length == 0 && homeController.modelData.brandMode == "single")){
        	
        	$("#homeAnonymousView").css("height","100%");
        	if(homeController.modelData.brandMode == "single")
        		$("#AnonymousHomePage-cont .sapMPageScroll").removeClass("setSizeAndScrollSingle");
        	else
        		$("#AnonymousHomePage-cont .sapMPageScroll").removeClass("setSizeAndScrollMulti");
        }
        else if(homeController.modelData.offers.length > 0 && homeController.modelData.brandMode == "single"){
        	$("#homeAnonymousView").css("height","100%");
        	if(homeController.modelData.brandMode == "single")
        		$("#AnonymousHomePage-cont .sapMPageScroll").addClass("setSizeAndScrollSingle");
        	else
        		$("#AnonymousHomePage-cont .sapMPageScroll").addClass("setSizeAndScrollMulti");
        }
        else if(homeController.modelData.offers.length > 2 && homeController.modelData.brandMode == "multi")
        	$("#homeAnonymousView").css("height","100%");
        $("#homeAnonymousView--homeScreenFooterOptions").addClass("homeScreenFooterOption");*/
        homeController.alignFooterContent();
        util.closeBusyDialog();
        if(homeController.pageCount == 1){
        	app.getPage(ANONYMOUS_HOME_PAGE).getContent()[0].byId("itemListOne").rerender();
        	clearTimeout(captureTimeOut);
        	try{
        	navigator.splashscreen.hide();
        	}
        	catch(e){
        		
        	}
        	
        }
        
        homeController.assignBorderToFooter();
        if(userState.DEMO_MODE)
        	setTimeout(function(){homeController.assignBorderToFooter();homeController.alignFooterContent();},500);
    },
    onAfterRendering : function(){
        if(homeController.modelData.unSignedSingleBrandMode != false){
        	if(homeController.modelData.cardSingleBrandMode)
        		$('#homeAnonymousView--cardPlaceHolder >.sapMFlexItem').css("background",homeController.modelData.cardSingleBrandMode);
        	else
        		$('#homeAnonymousView--cardPlaceHolder >.sapMFlexItem').css("background","rgb(0, 122, 255)");
        	$('#homeAnonymousView--cardHomeFrontPlaceHolder').addClass("unsignedSingleBrand");
        }
        if(homeController.modelData.signedSingleBrandMode){
        	$('#homeAnonymousView--cardHomeFrontPlaceHolder').css("background",homeController.modelData.cardSingleBrandMode);
        	$('#homeAnonymousView--cardHomeFrontPlaceHolder').addClass("unsignedSingleBrand");
        }
        else{
        	$('#homeAnonymousView--cardHomeFrontPlaceHolder').css("background","");
        	$('#homeAnonymousView--cardHomeFrontPlaceHolder').removeClass("unsignedSingleBrand");
        	$('#homeAnonymousView--cardHomeFrontPlaceHolder').html("");
        }
        /*if(homeController.modelData.notConnectedToServer || (homeController.modelData.offers.length <= 2 && homeController.modelData.brandMode == "multi") || (homeController.modelData.offers.length == 0 && homeController.modelData.brandMode == "single")){
        	
        	$("#homeAnonymousView").css("height","100%");
        	if(homeController.modelData.brandMode == "single")
        		$("#AnonymousHomePage-cont .sapMPageScroll").removeClass("setSizeAndScrollSingle");
        	else
        		$("#AnonymousHomePage-cont .sapMPageScroll").removeClass("setSizeAndScrollMulti");
        }
        else if(homeController.modelData.offers.length > 0 && homeController.modelData.brandMode == "single"){
        	$("#homeAnonymousView").css("height","100%");
        	if(homeController.modelData.brandMode == "single")
        		$("#AnonymousHomePage-cont .sapMPageScroll").addClass("setSizeAndScrollSingle");
        	else
        		$("#AnonymousHomePage-cont .sapMPageScroll").addClass("setSizeAndScrollMulti");
        }
        else if(homeController.modelData.offers.length > 2 && homeController.modelData.brandMode == "multi")
        	$("#homeAnonymousView").css("height","100%");
        $("#homeAnonymousView--homeScreenFooterOptions").addClass("homeScreenFooterOption");*/
    },
    alignFooterContent : function(){
    	var screenHeight = $(window).height();
        if(homeController.modelData.brandMode == "multi"){
        	if(screenHeight > 552)
        		$("#homeAnonymousView--homeScreenFooterOptions").css("position","absolute");
        	else{
        		if(homeController.modelData.offers.length > 2)
        			$("#homeAnonymousView--homeScreenFooterOptions").css("position","relative");
        		else
        			$("#homeAnonymousView--homeScreenFooterOptions").css("position","absolute");
        	}
        }
        else{
        	if(userState.APP_MODE == "mLoyalty"){
        		if(screenHeight > 508)
        			$("#homeAnonymousView--homeScreenFooterOptions").css("position","absolute");
        		else{
            		if(homeController.modelData.offers.length > 1)
            			$("#homeAnonymousView--homeScreenFooterOptions").css("position","relative");
            		else
            			$("#homeAnonymousView--homeScreenFooterOptions").css("position","absolute");
            	}
        	}
        	else{
        		if(screenHeight > 655)
        			$("#homeAnonymousView--homeScreenFooterOptions").css("position","absolute");
        		else{
        			var footerMenuLength = homeController.modelData.homeFooterMenuLastItem.length + (homeController.modelData.homeFooterMenu.length/2);
            		if(homeController.modelData.offers.length == 0)
        				$("#homeAnonymousView--homeScreenFooterOptions").css("position","absolute");
            		else if(footerMenuLength == 2 && screenHeight > 579)
            			$("#homeAnonymousView--homeScreenFooterOptions").css("position","absolute");
            		else if(footerMenuLength == 1 && screenHeight > 504)
            			$("#homeAnonymousView--homeScreenFooterOptions").css("position","absolute");
            		else{
           				$("#homeAnonymousView--homeScreenFooterOptions").css("position","relative");
            		}
            	}
        	}
        }
        $("#homeAnonymousView--homeScreenFooterOptions").addClass("homeScreenFooterOption");
    },
    assignBorderToFooter : function(){
    	var footerCountOne = app.getPage(ANONYMOUS_HOME_PAGE).getContent()[0].byId("itemListOne").getItems().length;
    	var itemOne = app.getPage(ANONYMOUS_HOME_PAGE).getContent()[0].byId("itemListOne").getDomRef();
    	for(var i = 0 ; i < footerCountOne ; i++){
    		if(i % 2 == 0)
    			itemOne.childNodes[0].childNodes[i].style.boxShadow = "inset -1px -2px 0px #249191";
    		else
    			itemOne.childNodes[0].childNodes[i].style.boxShadow = "inset 1px -2px 0px #249191";
    	}
    },
    checkOperation : function(ev){
    	var selectedItem = ev.getSource();
    	var item = selectedItem.getBindingContext().getProperty(selectedItem.getBindingContext().getPath())
    	switch(item.menuName){
    	case oBundle.getText("anonymousHome_scanProduct"):
    		if(!userState.DEMO_MODE){
    			homeController.launchScanProduct();
	    	}
			else
				alert(oBundle.getText("demo_mode_message"));
    		break;
    	case oBundle.getText("anonymousHome_shoppingList"):
    		homeController.myShoppingList();
    		break;
    	case oBundle.getText("anonymousHome_productCatalog"):
    		homeController.browseProducts();
    		break;
    	case oBundle.getText("Store_Locator"):
    		if(!userState.DEMO_MODE)
    			homeController.launchStoreLocator();
			else
				alert(oBundle.getText("demo_mode_message"));
    		break;
    	case oBundle.getText("anonymousHome_checkIn"):
    			homeController.inStoreShopping();
    		break;
    	case oBundle.getText("anonymousHome_mobilePay"):
    		if(!userState.DEMO_MODE)
    			homeController.launchMobilePayment();
	    	else
				alert(oBundle.getText("demo_mode_message"));
    		break;
    	}
    },
    restHeaderBar : function(){
        if (userState.LOGGED_IN) {
            var signInBtn = app.getPage(ANONYMOUS_HOME_PAGE).getCustomHeader().getContentRight()[0];
            signInBtn.setVisible(false);
            homeController.modelData.notLoggedInVisiblity = false;
            homeController.modelData.loggedInVsiibility = true;
            app.getPage(ANONYMOUS_HOME_PAGE).getContent()[0].getModel().setData(homeController.modelData);
        }
        else{
        	var signInBtn = app.getPage(ANONYMOUS_HOME_PAGE).getCustomHeader().getContentRight()[0];
            signInBtn.setVisible(true);
            homeController.modelData.notLoggedInVisiblity = true;
            homeController.modelData.loggedInVsiibility = false;
            app.getPage(ANONYMOUS_HOME_PAGE).getContent()[0].getModel().setData(homeController.modelData);
        }
        
    },
    selectMenu : function(){
        if (sliderMenuController == undefined){
            sliderMenuController = sap.ui.controller("app.ui.slidermenu.sliderMenuController");
            sliderMenuController.createSliderMenu();
        }
        sliderMenuController.action('menuButtonHomePage');
    },
    viewOffers : function(ev){
        if (userState['LOGGED_IN']) {
            //go to Offers
            
            if (userState['BRANDTYPE'] == 'single') {
                allOffersController.navigateToOffersScreen();
            }
            else if (userState['BRANDTYPE'] == 'multi') {
                allOffersController.navigateToOffersScreen();
            }
        }
        else{
  
            userState['BRANDTYPE'] = "single";
            if(homeController.modelData.notConnectedToServer == false)
            	allOffersController.navigateToOffersScreen();
        }
        if(homeController.modelData.notConnectedToServer == true)
        {
        	alert(oBundle.getText("error_connection_msg"));
        	homeController.launchConnectionSettings();
        }
    },
    launchScanProduct : function(){
    	if(listDetailController == undefined)
    		listDetailController = sap.ui.controller('app.ui.myLists.listDetailController');
    	listDetailController.barcodeButtonTapFunction("fromHome");
    },
	launchStoreLocator : function(){
		if (mapController == undefined) {
			mapController = sap.ui.controller("app.ui.googleMaps.mapController");
		}
		//console.log(ANONYMOUS_HOME_PAGE);
		if (userState.BRANDTYPE == "single") {
			mapController.programCode = userState.SINGLE_BRAND_PROGRAM_CODE;
		}
		mapController.previousPage = ANONYMOUS_HOME_PAGE;
		mapController.updateMyLocation();
		mapController.launchPage("to", ANONYMOUS_HOME_PAGE);
    },
    browseProducts : function(){
		SmartphoneService.getCatalogURL("nothing to be passed",homeController.urlBack); 
    },
	urlBack : function(response, status){
		if (status != 200) {
			checkErrorStatus(status);
			return;
		}
		else if( isRESTStatusCodeCorrect(response) ) {
			
			if(response.catalogURL != null || response.catalogURL != "") {
				if (catalogueController == undefined) {
					catalogueController = sap.ui.controller("app.ui.catalogue.catalogueController");
				}
				catalogueController.loadCataloguePage(response.catalogURL);
			}
			else {
				util.alertDialog( "Catalogue URL Not Found" );
			}
		}
		else{
			checkErrorMobiliserStatus(response);
		}
	},
    myShoppingList : function(){
        if (userState['LOGGED_IN']) {
            //go to ShoppingList
            if (myListController == undefined) {
                    myListController = sap.ui.controller("app.ui.myLists.myListController");
            }
            myListController.launchMyListsPage();
        }
        else{
            homeController.notLoggedInToPage = "shoppingList";
            if (homepageController==undefined){
                homepageController = sap.ui.controller("app.ui.login.login");
            }   
            launchLoginPage();
            //console.log("Not logged in");
        }
    },
    inStoreShopping : function(){
		if (userState['LOGGED_IN']) {
			if (checkInController == undefined) 
				checkInController = sap.ui.controller("app.ui.myLists.checkIn");
			checkInController.launchCheckInPage();
		}
		else{
			homeController.notLoggedInToPage = "inStoreShopping";
            if (homepageController==undefined){
                homepageController = sap.ui.controller("app.ui.login.login");
            }   
            launchLoginPage();
            //console.log("Not logged in");
		}
    },
	launchMobilePayment : function(){
    	if (userState['LOGGED_IN']) {
    		
			if (openTransactionController == undefined) {
				openTransactionController = sap.ui.controller("app.ui.myLists.openTransactionController");
			}
			openTransactionController.launchOpenTransactionController();
		}
		else{
			homeController.notLoggedInToPage = "mobilePayment";
            if (homepageController==undefined){
                homepageController = sap.ui.controller("app.ui.login.login");
            }   
            launchLoginPage();
            //console.log("Not logged in");
		}
    },
    signUpAddCard : function(){
    	if(createProfileController == undefined)
     	   createProfileController = sap.ui.controller('app.ui.register.registerList');
        createProfileController.launchCreateProfile(ANONYMOUS_HOME_PAGE);
    },
    //Launch the application in single brand mode.
   launchSingleBrandDemoMode : function(){
       homeController.launchLoginPage();
       if(homepageController == undefined)
           homepageController = sap.ui.controller('app.ui.login.login');
       //homepageController.launchSingleDemoMode();
       userState['DEMO_MODE'] = true;
        userState['BRANDTYPE'] = "single";
        var loginView = app.getPage(ID_LOGIN_PAGE).getContent()[0];
        loginView.byId("input_username").setValue("DemoUser");
        loginView.byId("input_password").setValue("Password");
        homepageController.doLogin();
   },
   //Launch the application in Multi brand mode.
   launchMultiBrandDemoMode : function(){
       homeController.launchLoginPage();
       if(homepageController == undefined)
           homepageController = sap.ui.controller('app.ui.login.login');
       //homepageController.launchMultiDemoMode();
       userState['DEMO_MODE'] = true;
        userState['BRANDTYPE'] = "multi";
        var loginView = app.getPage(ID_LOGIN_PAGE).getContent()[0];
        loginView.byId("input_username").setValue("DemoUser");
        loginView.byId("input_password").setValue("Password");
        homepageController.doLogin();
   },
   //Set the connection settings
   launchConnectionSettings : function(){
       if(homepageController == undefined)
           homepageController = sap.ui.controller('app.ui.login.login');
       homepageController.doConnectSettings();
   },
   //Sign up for a new user account.
   createProfile : function(){
       if(createProfileController == undefined)
    	   createProfileController = sap.ui.controller('app.ui.register.registerList');
       createProfileController.launchCreateProfile(ANONYMOUS_HOME_PAGE);
   },
   //Call this function since login controller would not be loaded when app is first created.
   launchLoginPage : function(){
       if (app.getPage(ID_LOGIN_PAGE) == null) {    
            if (userState['LOGGED_IN']==false){
            //LOGIN PAGE VIEW
                var loginView = sap.ui.view({
                    type : sap.ui.core.mvc.ViewType.XML,
                    viewName : "app.ui.login.login",
                    controller : homepageController
                });

            
            //ADDING PAGES
                var page1 = new sap.m.Page(ID_LOGIN_PAGE, {
                title : oBundle.getText("Login_Title"),
                content : [ loginView ],
                showNavButton : true,
                navButtonType : "Back",
                navButtonText : oBundle.getText("Back_Button"),
                navButtonTap : function(){
                	app.back();
                },
                });
                
                var dataLogin = {
                account:       {
                    identification:"",
                    credential:""
                }
                };
                loginModel = new sap.ui.model.json.JSONModel();
                loginModel.setData(dataLogin);
                loginView.setModel(loginModel);
                app.addPage(page1);
            }   
        //else signed in
            else{
                //GO TO LANDING PAGE
                checkMultiSingle();
            }
       }  
   },
   homeScreenOfferDescription : function(ev){
       if(allOffersController == undefined)
           allOffersController = sap.ui.controller('app.ui.offers.allOffersController');
       homeController.viewOffers(ev);
   },
   displayHomeOfferDetails : function(oControlEvent){
       var currentPageData = oControlEvent.getSource().getBindingContext().getProperty();
       if(allOffersController == undefined){
    	   allOffersController = sap.ui.controller('app.ui.offers.allOffersController');
       }
        if (app.getPage("CouponHomeDetailsPage") == null) {
            var couponDetailView = sap.ui.view({
                type : sap.ui.core.mvc.ViewType.XML,
                viewName : "app.ui.offers.couponDetailView",
                id : "couponHomeDetailView",
                controller : this
            });

            var headerBar = new sap.m.Bar({
                        contentLeft : [ new sap.m.Button(
                                {
                                    text : oBundle.getText("Back_Button"),
                                    type : sap.m.ButtonType.Back,
                                    tap : function() {
                                        
                                        app.back();
                                        
                                    }
                                }) ],
                        contentMiddle : [ new sap.m.Label("offerHomeDetailLabel", 
                                {
                                    text : ""
                                }) ],
                        contentRight : [ new sap.m.Button('offerHomeDetailMapButton',
                                {
		                        	icon : "sap-icon://map",
									activeIcon : "sap-icon://map",
                                    tap : function(event, src) {
                                        if (userState['DEMO_MODE'] == true) {
                                            logError("demo_mode_message","In Demo Mode","Not Supported In Demo Mode");
                                            return;
                                        }
                                        if (mapController == undefined) {
                                            mapController = sap.ui.controller("app.ui.googleMaps.mapController");
                                            // mapController =
                                            // sap.ui.controller("app.ui.storelocator.map");
                                        }
                                        mapController.programId = allOffersController.currentProgramId;
                                        mapController.previousPage = COUPON_DETAIL_PAGE;
                                        mapController.updateMyLocation();
                                        mapController.launchPage();
                                    }
                                }) ]
                    });

            var button1ios = new sap.m.Button('couponHomeDetailButton1iOS',
                    {
                        text : oBundle.getText("want"),
                        type : sap.m.ButtonType.Default,
                        width : "100px",
                        icon : "app/ui/offers/images/want-heart-button-up.png",
                        activeIcon : "app/ui/offers/images/want-heart-button-red-ios.png",
                        enabled : true,
                        tap : function(event) {
                            button1ios.fireEvent("iosButtonActiveRemove");
                            if (userState['DEMO_MODE'] == true) {
                                logError("demo_mode_message","In Demo Mode","Not Supported In Demo Mode");
                                return;
                            }
                            if(userState['LOGGED_IN'])
                            	homeController.wantOfferCall();
                            else {
                                    homeController.notLoggedInToPage = "Offers";
                                    if (homepageController==undefined){
                                        homepageController = sap.ui.controller("app.ui.login.login");
                                    }   
                                    launchLoginPage();
                            }
                                
                        }
                    });

            var button1 = new sap.m.Button('couponHomeDetailButton1',
                    {
                        text : oBundle.getText("want"),
                        type : sap.m.ButtonType.Default,
                        icon : "app/ui/offers/images/want-heart-button-up.png",
                        activeIcon : "app/ui/offers/images/want-heart-button-down.png",
                        enabled : true,
                        tap : function(event) {
                            if (userState['DEMO_MODE'] == true) {
                                logError("demo_mode_message","In Demo Mode","Not Supported In Demo Mode");
                                return;
                            }
                            if(userState['LOGGED_IN'])
                            	homeController.wantOfferCall();
                            else {
                                 homeController.notLoggedInToPage = "Offers";
                                    if (homepageController==undefined){
                                        homepageController = sap.ui.controller("app.ui.login.login");
                                    }   
                                    launchLoginPage();
                            }
                        }
                    });

            var button2 = new sap.m.Button('couponHomeDetailButton2',
                    {
                        text : oBundle.getText("share"),
                        type : sap.m.ButtonType.Default,
                        icon : "app/ui/offers/images/share-icon-button-up.png",
                        activeIcon : "app/ui/offers/images/share-icon-button-down.png",
                        enabled : true,
                        tap : function(event) {
                            if (userState['DEMO_MODE'] == true) {
                                logError("demo_mode_message","In Demo Mode","Not Supported In Demo Mode");
                                return;
                            }
                            allOffersController.shareOffer();
                        }
                    });
            var footer;
            if (window.cordova && window.device.platform === "iOS") {
                footer = new sap.m.Bar('couponHomeDetailFooterBar',
                        {
                            contentMiddle : [ button1ios, button2 ],
                                      enableFlexBox : true
                        });
            } else {
                footer = new sap.m.Bar('couponHomeDetailFooterBar',
                        {
                            contentLeft : [],
                            contentMiddle : [ button1, button2 ],
                            contentRight : [],
                            enableFlexBox : true
                        });
            }

            var couponDetailPage = new sap.m.Page("CouponHomeDetailsPage",{
                        title : "Single Offer",
                        content : [ couponDetailView ],
                        showNavButton : false,
                        customHeader : headerBar,
                        footer : footer
                    });
            couponDetailPage.addStyleClass("customFooter");
            couponDetailPage.addStyleClass("offerDetails");
            this.couponDetailModel = new sap.ui.model.json.JSONModel();
            couponDetailPage.setModel(this.couponDetailModel);
            app.addPage(couponDetailPage);
        }
        if(userState['LOGGED_IN']){
        	var programLogo;
        	if(homeController.modelData.brandMode == "single")
        		programLogo = allOffersController.getProgramImageFromProgramId(currentPageData.programId);
        	else
        		programLogo = allOffersController.getProgramImageFromProgramId(currentPageData.programId);
        }
        else
            var programLogo = null;
        var isHighlight = true;

        if (currentPageData.highlight == null) {
            isHighlight = false;
        }
        var tempCaption;
        if(currentPageData.caption == null){
            tempCaption = "";
        }
        else
            tempCaption = currentPageData.caption.toUpperCase();
        if(currentPageData.isWanted == null)
        	currentPageData.isWanted = false;
        if(currentPageData.isExpiring == null)
        	currentPageData.isExpiring = false;
        if(currentPageData.isNew == null)
        	currentPageData.isNew =false;
        couponDetailData = {
        		amountPointsNeeded : currentPageData.amountPointsNeeded,
                caption : tempCaption,
                highlight : currentPageData.highlight,
                description : currentPageData.description,
                subCaption : currentPageData.subCaption,
                offerId : currentPageData.offerId,
                couponImage : currentPageData.image,
                isWanted : currentPageData.isWanted,
                isExpiring : currentPageData.isExpiring,
                isFeatured : currentPageData.isFeatured,
                isNew : currentPageData.isNew,
                imageSource : "",
                programId : currentPageData.programId,
                thumbUrl : currentPageData.thumbUrl,
                url : currentPageData.url,
                validTime : currentPageData.validTime,
                programLogo : programLogo,
                isHighlight : isHighlight,
                couponTypeid : currentPageData.couponTypeid
        };
        if (couponDetailData.isWanted !== false) {
            couponDetailData.imageSource = "sap-icon://electrocardiogram";
            //sap.ui.getCore().byId("couponDetailButton1iOS").addStyleClass("sapmbtnactive");
        }
        else if (couponDetailData.isExpiring !== false) {
            couponDetailData.imageSource = "sap-icon://history";
        }
        else if (couponDetailData.isNew !== false) {
            couponDetailData.imageSource = "sap-icon://lightbulb";
        }
        homeController.modelData.currentCouponTypeid = currentPageData.couponTypeid;
        app.getPage("CouponHomeDetailsPage").getContent()[0].getModel().setData(couponDetailData);
        
        if(userState['LOGGED_IN']){
        	var programName = "";
        	programName = allOffersController.getProgramNameFromProgramId(couponDetailData.programId);
        	if(homeController.modelData.brandMode == "single")
        		app.getPage("CouponHomeDetailsPage").getCustomHeader().getContentMiddle()[0].setText(programName);
        	else{
        		app.getPage("CouponHomeDetailsPage").getCustomHeader().getContentMiddle()[0].setText(programName);
        	}
        }
        else
        	app.getPage("CouponHomeDetailsPage").getCustomHeader().getContentMiddle()[0].setText(couponDetailData.caption);

        
        app.to("CouponHomeDetailsPage");
        if (couponDetailData.isWanted === true) {
            sap.ui.getCore().byId("couponHomeDetailButton1").addStyleClass("sapmbtnactive");
            sap.ui.getCore().byId("couponHomeDetailButton1iOS").addStyleClass("sapmbtnactive");
            sap.ui.getCore().byId("couponHomeDetailButton1").setIcon("app/ui/offers/images/want-heart-button-down.png");
            sap.ui.getCore().byId("couponHomeDetailButton1iOS").setIcon("app/ui/offers/images/want-heart-button-red-ios.png");
        } else {
            sap.ui.getCore().byId("couponHomeDetailButton1").removeStyleClass("sapmbtnactive");
            sap.ui.getCore().byId("couponHomeDetailButton1iOS").removeStyleClass("sapmbtnactive");
            sap.ui.getCore().byId("couponHomeDetailButton1").setIcon("app/ui/offers/images/want-heart-button-up.png");
            sap.ui.getCore().byId("couponHomeDetailButton1iOS").setIcon("app/ui/offers/images/want-heart-button-up.png");
        }
        var wantedIcon = app.getPage("CouponHomeDetailsPage").getContent()[0].byId("wantedIconHolder");
		wantedIcon.rerender();
   },
   wantOfferCall : function() {
	   var offerDetails = app.getPage("CouponHomeDetailsPage").getContent()[0].getModel().getData();
		if (offerDetails.isWanted === true)
			util.createBusyDialog(oBundle.getText("Offers_Progress_Message"),oBundle.getText("offer_removed_from_wanted"));
		else
			util.createBusyDialog(oBundle.getText("Offers_Progress_Message"),oBundle.getText("offer_set_as_wanted"));
		var wantOfferCallData = {
			couponTypeid : offerDetails.couponTypeid,
			amountPointsNeeded : offerDetails.amountPointsNeeded,
			offerId : offerDetails.offerId,
			couponCaption : offerDetails.caption
		};
		SmartphoneService.wantOffer(wantOfferCallData,homeController.wantOfferBack);
	},

	wantOfferBack : function(response, status) {
		if (status != 200) {
			checkErrorStatus(status);
			return;
		}
		if (isRESTStatusCodeCorrect(response)) {
			var offerDetails = app.getPage("CouponHomeDetailsPage").getContent()[0].getModel().getData();
			util.closeBusyDialog();
			offerDetails.isWanted = !offerDetails.isWanted;
			if (offerDetails.isWanted === true) {
				sap.ui.getCore().byId("couponHomeDetailButton1").addStyleClass("sapmbtnactive");
	            sap.ui.getCore().byId("couponHomeDetailButton1iOS").addStyleClass("sapmbtnactive");
	            sap.ui.getCore().byId("couponHomeDetailButton1").setIcon("app/ui/offers/images/want-heart-button-down.png");
	            sap.ui.getCore().byId("couponHomeDetailButton1iOS").setIcon("app/ui/offers/images/want-heart-button-red-ios.png");
	        } else {
	            sap.ui.getCore().byId("couponHomeDetailButton1").removeStyleClass("sapmbtnactive");
	            sap.ui.getCore().byId("couponHomeDetailButton1iOS").removeStyleClass("sapmbtnactive");
	            sap.ui.getCore().byId("couponHomeDetailButton1").setIcon("app/ui/offers/images/want-heart-button-up.png");
	            sap.ui.getCore().byId("couponHomeDetailButton1iOS").setIcon("app/ui/offers/images/want-heart-button-up.png");
			}
			if (offerDetails.isWanted !== false) {
				offerDetails.imageSource = "sap-icon://electrocardiogram";
			}
			else if (offerDetails.isExpiring !== false) {
				offerDetails.imageSource = "sap-icon://history";
			}
			else if (offerDetails.isNew !== false) {
				offerDetails.imageSource = "sap-icon://lightbulb";
			}
			else {
				offerDetails.imageSource = "";
			}
			app.getPage("CouponHomeDetailsPage").getContent()[0].getModel().setData(pageData);
			if(allOffersController != undefined && allOffersController.dataOffers){
				
				for ( var i = 0; i < allOffersController.dataOffers.length; i++) {
					
					if (allOffersController.dataOffers[i].couponTypeid == homeController.modelData.currentCouponTypeid) {
						// No need to do this for different cards data as the offer object is being referenced in card data also.
						// So a change here will be reflected in the cards offers as well.
						allOffersController.dataOffers[i].isWanted = !allOffersController.dataOffers[i].isWanted;
						/*if (allOffersController.dataOffers[i].isWanted === true) {
							sap.ui.getCore().byId("couponDetailAndroid").setIcon("app/ui/offers/images/want-heart-button-down.png");
							sap.ui.getCore().byId("couponDetailiOS").setIcon("app/ui/offers/images/want-heart-button-red-ios.png");
	
						} 
						else {
							sap.ui.getCore().byId("couponDetailAndroid").setIcon("app/ui/offers/images/want-heart-button-up.png");
							sap.ui.getCore().byId("couponDetailiOS").setIcon("app/ui/offers/images/want-heart-button-up.png");
						}*/
						
						/*var pageData = allOffersController.couponDetailModel.oData;
						pageData.isWanted = allOffersController.dataOffers[i].isWanted;*/
						allOffersController.dataOffers[i].imageSource = "";
						//pageData.imageSource = "";
	
						if (allOffersController.dataOffers[i].isWanted !== false) {
							allOffersController.dataOffers[i].imageSource = "sap-icon://electrocardiogram";
							//pageData.imageSource = "sap-icon://electrocardiogram";
						}
						else if (allOffersController.dataOffers[i].isExpiring !== false) {
							allOffersController.dataOffers[i].imageSource = "sap-icon://history";
							//pageData.imageSource = "sap-icon://history";
						}
						else if (allOffersController.dataOffers[i].isNew !== false) {
							allOffersController.dataOffers[i].imageSource = "sap-icon://lightbulb";
							//pageData.imageSource = "sap-icon://lightbulb";
						}
						else {
							allOffersController.dataOffers[i].imageSource = "";
							//pageData.imageSource = "";
						}
	
						//allOffersController.couponDetailModel.setData(pageData);
						//app.getCurrentPage().getContent()[0].getModel().setData(pageData);
						/**/
						allOffersController.dataOffers[i].couponInstanceid = response.offer.couponInstanceid;
						allOffersController.dataOffers[i].strCode = response.offer.strCode;
						allOffersController.dataOffers[i].serialNumber = response.offer.serialNumber;
					}
				}
				allOffersController.allOffersModel.setData(allOffersController.dataOffers);
			}
			for ( var i = 0; i < homeController.modelData.offers.length; i++) {
				
				if (homeController.modelData.offers[i].couponTypeid == homeController.modelData.currentCouponTypeid) {
					// No need to do this for different cards data as the offer object is being referenced in card data also.
					// So a change here will be reflected in the cards offers as well.
					homeController.modelData.offers[i].isWanted = offerDetails.isWanted;
					
					var pageData = homeController.modelData.offers[i];
					//pageData.isWanted = homeController.modelData.offers[i].isWanted;
					homeController.modelData.offers[i].imageSource = "";
					pageData.imageSource = "";

					if (homeController.modelData.offers[i].isWanted !== false) {
						homeController.modelData.offers[i].imageSource = "sap-icon://electrocardiogram";
						pageData.imageSource = "sap-icon://electrocardiogram";
					}
					else if (homeController.modelData.offers[i].isExpiring !== false) {
						homeController.modelData.offers[i].imageSource = "sap-icon://history";
						pageData.imageSource = "sap-icon://history";
					}
					else if (homeController.modelData.offers[i].isNew !== false) {
						homeController.modelData.offers[i].imageSource = "sap-icon://lightbulb";
						pageData.imageSource = "sap-icon://lightbulb";
					}
					else {
						homeController.modelData.offers[i].imageSource = "";
						pageData.imageSource = "";
					}
					pageData.programLogo = allOffersController.getProgramImageFromProgramId(homeController.modelData.offers[i].programId);
					//allOffersController.couponDetailModel.setData(pageData);
					//app.getCurrentPage().getContent()[0].getModel().setData(pageData);
					app.getPage("CouponHomeDetailsPage").getContent()[0].getModel().setData(pageData);
					var wantedIcon = app.getPage("CouponHomeDetailsPage").getContent()[0].byId("wantedIconHolder");
					wantedIcon.rerender();
					homeController.modelData.offers[i].couponInstanceid = response.offer.couponInstanceid;
					homeController.modelData.offers[i].strCode = response.offer.strCode;
					homeController.modelData.offers[i].serialNumber = response.offer.serialNumber;
				}
			}
			app.getPage(ANONYMOUS_HOME_PAGE).getContent()[0].getModel().setData(homeController.modelData);
			//app.getPage("CouponHomeDetailsPage").getContent()[0].getModel().setData(offerDetails);
			
		} else {
			checkErrorMobiliserStatus(response);
		}
	},
	convertDateToReadableFormat : function(dateinms) {
		if (dateinms == null)
			return null;
		var newDate = new Date(dateinms);
		var dateOfMonth = newDate.getDate();
		var val = newDate.toDateString();
		var month_name = val.substr(val.indexOf(" ") + 1, 3).toLowerCase();
		// Bad way to get the month names. Dont want to change the strings file as may break SLS way of adding the names
		if (month_name === "jun") {
			month_name = "june";
		} else if (month_name === "jul") {
			month_name = "july";
		}
		var month = oBundle.getText("month_" + month_name);
		month = month.substr(0, 3);
		month = month.charAt(0).toUpperCase() + month.slice(1);
		return month + " " + dateOfMonth;
	},

	convertOfferDatesToReadableFormat : function(date) {
		var formatedDate = homeController.convertDateToReadableFormat(date);
		return formatedDate;
	},
});
function displayCardFromHome(){
    var checkTime = new Date().getTime();
    if (userState['PASSCODE_LENGTH'] != 0 && (userState['PASSCODE_FIRST'] || checkTime > userState['PASSCODE_EXP']) && !userState['DEMO_MODE']) {
        if ( PINController == null)
            PINController = sap.ui.controller("app.ui.passcode.passcodeController")
        PINController.toWallet();
    }
    else{
        if (walletController == undefined) 
        walletController = sap.ui.controller("app.ui.wallet.wallet");
        walletController.launchWalletPage();
    }
} 
