//Temporary demo data
var contact = {
    			names : [
    	    	    {
    	        		name : "Sam Cook",
    	        		emails : [
    	        			{email: "samy@gmail.com", selected: false},
    	        			{email: "jims@yahoo.com", selected: false}
    	        		],
    	        		phones : [
    	    	        			{phone: "+4 478(9)7-8---9", selected: true},
    	    	        			{phone: "8477073585", selected: false},
    	    	        ],
    	        		invited : false,
    	        		additionalOwner: true,
    	        	},{
    	    		   name : "Nancy",
    	    		   emails : [
    	        			{email: "nancy@sap.com", selected: true},
    	        			{email: "clauss@yahoo.com", selected: false}
    	        		],
    	        		phones : [
    	    	        			{phone: "+44369369", selected: true},
    	    	        			{phone: "+912))0(7)7(8235)((45", selected: false},
    	    	       ],
    	    		   invited : false,
    	    		   additionalOwner: false,
    	    	    },
    	        	{
    	        		name : "Reji" + " " + "Smith",
    	        		emails : [
    	    	        			{email: "simo@gmail.com", selected: true},
    	    	        			{email: "sims@yahoo.com", selected: false}
    	    	        ],
    	        		phones : [
    	        			{phone: "+110989288767", selected: true},
    	        			{phone: "+922903873545", selected: false},
    	        		],
    	        		invited : false,
    	        		additionalOwner: false,
    	        	},
    	        	{
    	        		name : "Jhon" + " " + "Smith",
    	        		emails : [
    	    	        			{email: "jhonfs@gmail.com", selected: true},
    	    	        			{email: "jhons@yahoo.com", selected: false}
    	    	        ],
    	        		phones : [
    	        			{phone: "8977898700111", selected: true},
    	        			{phone: "+908933870111", selected: false},
    	        		],
    	        		invited : false,
    	        		additionalOwner: false,
    	        	},
    	        	{
    	        		name : "beckham" + " " + "Smith",
    	        		emails : [
    	    	        			{email: "beckhmmss@gmail.com", selected: true},
    	    	        			{email: "beckhams@yahoo.com", selected: false}
    	    	        ],
    	        		phones : [
    	        			{phone: "897710199222", selected: true},
    	        			{phone: "+908101073222", selected: false},
    	        		],
    	        		invited : false,
    	        		additionalOwner: false,
    	        	},
    	        	{
    	        		name : "Ted" + " " + "Smith",
    	        		emails : [
    	    	        			{email: "abcdekg@gmail.com", selected: true},
    	    	        			{email: "teds@yahoo.com", selected: false}
    	    	        ],
    	        		phones : [
    	        			{phone: "8977137170", selected: true},
    	        			{phone: "+908977000888", selected: false},
    	        		],
    	        		invited : false,
    	        		additionalOwner: false,
    	        	}],
    			next : false
 };
   

sap.ui.controller("app.ui.household.addMembers", {
	initialListData : null,
	currentListData: null,
	count: 0,
	pageCount: 0,
	
	addMemberToHousehold : function(contactsData) {
		//Sorting the contacts alphabatically
		util.sortByKeyIgnoreCase(contactsData.names,"name");
		
		if (app.getPage(ID_ADD_HOUSEHOLD_MEMBERS_PAGE) == null) {
			var contactlistView = sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.household.addMembers",
				controller : addHouseholdMembersController
			});
			var contactlistPage = new sap.m.Page(ID_ADD_HOUSEHOLD_MEMBERS_PAGE, {
				showNavButton : true,
				title : oBundle.getText("add_members"),
				navButtonText : oBundle.getText("Back_Button"),
				navButtonTap : function(){
					app.back();
				},

				headerContent : [new sap.m.Button({
					text:oBundle.getText("next"),
					enabled : "{/next}",
					tap:function(){
						addHouseholdMembersController.navigateToReview();
					}})],
				subHeader : new sap.m.Bar("addMemberSearchBar",{
						enableFlexBox : true,
						contentMiddle: [new sap.m.SearchField("newSearch",{
							placeholder : oBundle.getText("search_for_name"),
							layoutData : new sap.m.FlexItemData({
								growFactor : 1
							}),
							search : addHouseholdMembersController.performSearch,
						})]
					}),
				content : [ contactlistView ],

			});
			var contactlistModel = new sap.ui.model.json.JSONModel();
			contactlistPage.setModel(contactlistModel);

			app.addPage(contactlistPage);

		}
		
		addHouseholdMembersController.initialListData = contactsData;
		addHouseholdMembersController.currentListData = addHouseholdMembersController.initialListData;
		app.getPage(ID_ADD_HOUSEHOLD_MEMBERS_PAGE).getContent()[0].getModel().setData(addHouseholdMembersController.initialListData);

		app.to(ID_ADD_HOUSEHOLD_MEMBERS_PAGE);

	},
	
	launchAddMembersPage: function(){
		
		var onSuccess = function(contacts) {
			var templateContact = {
					names : [],
					next : false,
			};
			for(var outer=0; outer<contacts.length; outer++){
					
				if(contacts[outer].displayName){
					var found = 0;
					var cName = "";
					var cPhones = [];
					var cEmails = [];
					
					cName = contacts[outer].displayName;

					if(contacts[outer].phoneNumbers && contacts[outer].phoneNumbers.length > 0){
						for(var inner=0;inner<contacts[outer].phoneNumbers.length; inner++)
						{
							//if the phone number is of type mobile, add it to the top else push it to bottom
							if(contacts[outer].phoneNumbers[inner].type == "mobile")
								cPhones.unshift({ 
									phone: contacts[outer].phoneNumbers[inner].value,
									selected: false });
							else
								cPhones.push({ 
									phone: contacts[outer].phoneNumbers[inner].value,
									selected: false});
						}
						//Making the first mobile number selected by default
						if(cPhones.length > 0)
							cPhones[0].selected = true;
						found = 1;   
					}

					if(contacts[outer].emails  && contacts[outer].emails.length > 0){
						for(var inner=0;inner<contacts[outer].emails.length; inner++)
						{
							cEmails.push({ 
								email: contacts[outer].emails[inner].value,
								selected: false});
						}
						//making the first email selected by default
						if(cEmails.length > 0)
							cEmails[0].selected = true;
						 
						found = 1;  
					}

					if(found == 0)
						continue;                      
					templateContact.names.push({name : cName,
							emails : cEmails,
							phones : cPhones,
							invited : false,
							additionalOwner: false});
				}            
			}
			
			util.closeBusyDialog();
			addHouseholdMembersController.addMemberToHousehold(templateContact);

		};
		
		var onError = function(contactError) {
			util.closeBusyDialog();
		    logError("error_fecth_mobile_contacts","error_fecth_mobile_contacts","Household Add Members");
		};
		
		// find all contacts on the device
		var options = new ContactFindOptions();
		options.multiple=true; 
		var fields = ["displayName","phoneNumbers","emails"];
		
		util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
		navigator.contacts.find(fields, onSuccess, onError, options);
		
		//Browser Mode
		//addHouseholdMembersController.addMemberToHousehold(contact);
		
	},
	
	performSearch : function(ev) {
		var data =  addHouseholdMembersController.initialListData;
		var newList = {
				names : [],
				next :  addHouseholdMembersController.currentListData.next
		};
		for ( var i = 0; i < data.names.length; i++) {
			var currentContact = data.names[i];
			var contactName = currentContact.name.toLowerCase();
			var searchString = ev.getSource().getValue().toLowerCase();
			if (contactName.indexOf(searchString) != -1)
				newList.names.push(currentContact);
		}

		app.getPage(ID_ADD_HOUSEHOLD_MEMBERS_PAGE).getContent()[0].getModel().setData(newList);
		addHouseholdMembersController.currentListData = newList;
	},
	
	isChecked : function(ev){
		var list = ev.getSource();
		var selectedContacts = list.getSelectedItems();
		if(selectedContacts != undefined && selectedContacts.length > 0)
		{
			addHouseholdMembersController.currentListData.next = true;
		}
		else
		{
			addHouseholdMembersController.currentListData.next = false;
		}
		/*
		var selectedContact = invite.getBindingContext().getProperty(invite.getBindingContext().getPath());
		if(selectedContact.invited==true){
			addHouseholdMembersController.count++;
			addHouseholdMembersController.currentListData.next = true;
		}
		else{
			addHouseholdMembersController.count--;
		}

		if(addHouseholdMembersController.count<=0){
			addHouseholdMembersController.currentListData.next = false;

		}
		*/
		app.getPage(ID_ADD_HOUSEHOLD_MEMBERS_PAGE).getContent()[0].getModel().setData(addHouseholdMembersController.currentListData);

	},
	
	selectContact : function(ev){
		var invite = ev.getSource();
		var selectedContact = invite.getBindingContext().getProperty(invite.getBindingContext().getPath());
		
		if(selectedContact.invited==true){
			selectedContact.invited = false;
			addHouseholdMembersController.count--;
		}
		else{
			selectedContact.invited = true;
			addHouseholdMembersController.count++;
			addHouseholdMembersController.currentListData.next = true;
		}

		if(addHouseholdMembersController.count<=0){
			addHouseholdMembersController.currentListData.next = false;

		}
		app.getPage(ID_ADD_HOUSEHOLD_MEMBERS_PAGE).getContent()[0].getModel().setData(addHouseholdMembersController.currentListData);

	},
	
	navigateToReview : function(){
		
		if(app.getPage(ID_ADD_MEMBERS_REVIEW_PAGE)==null){
			var reviewlistView = sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.household.reviewMembers",
				controller : addHouseholdMembersController
			});
			var reviewlistPage = new sap.m.Page(ID_ADD_MEMBERS_REVIEW_PAGE, {
				showNavButton : true,
				title : oBundle.getText("review_invite"),
				navButtonText : oBundle.getText("Back_Button"),
				navButtonTap : function(){
					app.back();
				},

				headerContent : [new sap.m.Button({
					text:oBundle.getText("done"),
					tap:function(){
						//householdController.launchHouseholdPage(SETTINGS_PAGE);
						var found = 0;
						var memberInHousehold = "";
						memberInHousehold = addHouseholdMembersController.checkMembersInHousehold();
						if(memberInHousehold.length > 0)
							found = 1;
						if(found == 0)
							addHouseholdMembersController.sendMembersToHousehold();
						else
							alert(memberInHousehold);
						
					}})],
					content : [ reviewlistView ],

			});
			var reviewlistModel = new sap.ui.model.json.JSONModel();
			reviewlistPage.setModel(reviewlistModel);

			app.addPage(reviewlistPage);

		}
		var selContacts = this.getSelectedContact(addHouseholdMembersController.initialListData);
		app.getPage(ID_ADD_MEMBERS_REVIEW_PAGE).getContent()[0].getModel().setData(selContacts);
		addHouseholdMembersController.prepareReviewPageData();
		app.to(ID_ADD_MEMBERS_REVIEW_PAGE);
	},
	//Function to check if member already exist in household
	checkMembersInHousehold : function(){
		var selectedContacts = app.getPage(ID_ADD_MEMBERS_REVIEW_PAGE).getContent()[0].getModel().getData();
		for(var i = 0 ; i < householdController.initialData.members.length ; i++){
			for(var j = 0 ; j < selectedContacts.names.length ; j++){
				var email = selectedContacts.names[j].selectedEmail;
				var phone = selectedContacts.names[j].selectedPhone;
				if(phone){
					if(phone.indexOf(" ") != -1)
	  					phone = phone.replace(/\s+/g,'');
	  				if(phone.indexOf("-") != -1)
	  					phone = phone.replace(/-+/g,'');
	  				if(phone.indexOf("(") != -1)
	  					phone = phone.replace(/\(+/g,'');
	  				if(phone.indexOf(")") != -1)
	  					phone = phone.replace(/\)+/g,'');
				}
				//console.log(phone);
				if((email && householdController.initialData.members[i].email && email == householdController.initialData.members[i].email) 
						|| 
						(phone && householdController.initialData.members[i].phone && phone == householdController.initialData.members[i].phone)){
					var existingMember = {
							name : "",
							email : "",
							phone : ""
					}
					if(email)
						existingMember.email = email;
					if(phone)
						existingMember.phone = phone;
					if(selectedContacts.names[j].name)
						existingMember.name = selectedContacts.names[j].name;
					return oBundle.getText("error_member_already_exist_houeshold",[existingMember.name]);
				}
					
			}
		}
		return "";
	},
	//Function used to get the formatted details of the members, who are to be added to household
	sendMembersToHousehold : function(){
		
		var responseData = settingsController.householdServiceData;
		if(responseData.households.length == 0)
		{
			addHouseholdMembersController.createHouseholdForMember(responseData);
		}
		else{
		
			addHouseholdMembersController.sendInvitations(responseData);
		}
		
	},
	sendInvitations : function(responseData){
		householdController.householdId = responseData.households[0].householdId;
		
		
		addHouseholdMembersController.sendData = addHouseholdMembersController.getInvitationForMembers(responseData);
		var sendNewMemberData = addHouseholdMembersController.sendData;
		
		var callback = function(response, status){
			
			if ( isRESTStatusCodeCorrect(response) ){
				util.closeBusyDialog();
				householdController.launchHouseholdPage(householdController.previousPage);
				
			}else{
				util.closeBusyDialog();
				
				if(response.Status.code == 1001)
					alert("One of the invitee already part of household");
				else
					logError("error_message_general", "Error in the response of sendInvitationsForHousehold", "household send invitation");
				//alert(JSON.stringify(response));
			}
			
		};
		util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
		SmartphoneService.sendInvitationsForHousehold(sendNewMemberData, callback);
	},
	createHouseholdForMember : function(responseData){
		var program = {
				programId : householdController.programId
		};
		var callback = function(response, status){
			//console.log("response\n" + JSON.stringify(response));
			util.closeBusyDialog();
			if ( isRESTStatusCodeCorrect(response) ){
			      
				var callbackForHousehold = function(response, status){
					util.closeBusyDialog();
			      if ( isRESTStatusCodeCorrect(response) ){
			    	  
			    	  responseData = response;
			    	  householdController.householdId = responseData.households[0].householdId;
			  		
			  		
			  		  addHouseholdMembersController.sendData = addHouseholdMembersController.getInvitationForMembers(responseData);
			  		  var sendNewMemberData = addHouseholdMembersController.sendData;
					
			  		  var callback = function(response, status){
						
			  			  if ( isRESTStatusCodeCorrect(response) ){
			  				  util.closeBusyDialog();
			  				  householdController.launchHouseholdPage(householdController.previousPage);
							
			  			  }else{
			  				  util.closeBusyDialog();
			  				  logError("error_message_general", "Error in the response of sendInvitationsForHousehold", "login");
			  				  if(response.Status.code == 1001)
			  					  alert("One of the user already exists in the household");
							//alert(JSON.stringify(response));
			  			  }
						
			  		  };
			  		  util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
			  		  SmartphoneService.sendInvitationsForHousehold(sendNewMemberData, callback);
			      }else{
			        util.closeBusyDialog();
			          logError("error_message_general", "Error in the response of gethousehold details for members", "login");
			      }
			      
			    };
			    util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
			    SmartphoneService.getHouseholdDetailsForMember({}, callbackForHousehold);
				
				
			}else{
				util.closeBusyDialog();
		    	logError("error_message_general", "Error in the response of getAllPreferences", "login");
			}
			
		}
		
		
		util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
		SmartphoneService.createHouseholdForProgram(program, callback);
	},
	getInvitationForMembers : function(responseData){
		//Fetch the current page data which contains detail of members to send the invitation to.
		var addNewMembersData = app.getCurrentPage().getContent()[0].getModel().getData();
		//get the generic data like household name, id, loyalty program id, name;
  		var sendInvitationToMembers = {
  				householdId : responseData.households[0].householdId,
  				householdName : responseData.households[0].householdName,
  				programId : responseData.households[0].loyaltyProgramId,
  				programName : responseData.households[0].loyaltyProgramName,
  				invitations : []
  		};
  		//Fetch the details of the user to be added into the household.
  		
  		for(var i = 0 ; i < addNewMembersData.names.length ; i++){
  			var tempInvitation = {
  					invitations : {}
  			};
  			if(addNewMembersData.names[i].additionalOwner == false)
  				tempInvitation.invitations.membershipRole = "Member";
  			else
  				tempInvitation.invitations.membershipRole = "Owner";
  			tempInvitation.invitations.inviteeName = addNewMembersData.names[i].name;
  			if(addNewMembersData.names[i].selectedEmail != "")
  				tempInvitation.invitations.inviteeMail = addNewMembersData.names[i].selectedEmail;
  			if(addNewMembersData.names[i].selectedPhone != ""){
  				var phoneNumber = addNewMembersData.names[i].selectedPhone;
  				if(phoneNumber.indexOf(" ") != -1)
  					phoneNumber = phoneNumber.replace(/\s+/g,'');
  				if(phoneNumber.indexOf("-") != -1)
  					phoneNumber = phoneNumber.replace(/-+/g,'');
  				if(phoneNumber.indexOf("(") != -1)
  					phoneNumber = phoneNumber.replace(/\(+/g,'');
  				if(phoneNumber.indexOf(")") != -1)
  					phoneNumber = phoneNumber.replace(/\)+/g,'');
  				tempInvitation.invitations.inviteePhone = phoneNumber;
  				
  			}
  				
  			//if(responseData.invitations.indexOf(tempInvitation.invitations) == -1)
  				sendInvitationToMembers.invitations.push(tempInvitation.invitations);
  			
  		}
  		return sendInvitationToMembers;
	},
	/*
	 * The purpose of below function is to populate the selectedEmail and selectedPhone for each contact
	 * so that it can be displayed properly below the contact name on review page
	 */
	prepareReviewPageData: function(){
		var data = app.getPage(ID_ADD_MEMBERS_REVIEW_PAGE).getContent()[0].getModel().getData();
		for(var i=0; i<data.names.length; i++)
		{
			var contact = data.names[i];
			contact.selectedEmail = "";
			if(contact.emails)
			{
				for(var j=0; j<contact.emails.length; j++)
				{
					if(contact.emails[j].selected)
					{
						
						contact.selectedEmail = contact.emails[j].email;
						break;
					}
				}
			}
			
			
			contact.selectedPhone = "";
			if(contact.phones)
			{
				for(var j=0; j<contact.phones.length; j++)
				{
					if(contact.phones[j].selected)
					{
						contact.selectedPhone = contact.phones[j].phone;
						break;
					}
				}
			}
			
			
		}
		app.getPage(ID_ADD_MEMBERS_REVIEW_PAGE).getContent()[0].getModel().setData(data);
	},
	
	
	getSelectedContact: function(contacts){
		var selContacts = {names: []};
		for(var i=0; i < contacts.names.length; i++)
		{
			if(contacts.names[i].invited === true)
				selContacts.names.push(contacts.names[i]);
		}
		return selContacts;
	},
	
	getContactDetailsPage: function(){
		if(app.getPage(ID_ADD_MEMBERS_DETAILS_PAGE)==null){
			var detailsView = sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.household.contactDetails",
				controller : addHouseholdMembersController
			});
			var detailsPage = new sap.m.Page(ID_ADD_MEMBERS_DETAILS_PAGE, {
				showNavButton : true,
				title : oBundle.getText("Contact"),
				navButtonText : oBundle.getText("Back_Button"),
				navButtonTap : function(){
					addHouseholdMembersController.prepareReviewPageData();
					app.back();
				},
				headerContent : [new sap.m.Button({
					text:oBundle.getText("resend_invite"),
					tap:function(){
						addHouseholdMembersController.resendInvite();
					}})],
				content : [ detailsView ],

			});
			var reviewlistModel = new sap.ui.model.json.JSONModel();
			detailsPage.setModel(reviewlistModel);

			app.addPage(detailsPage);

		}
		
		return app.getPage(ID_ADD_MEMBERS_DETAILS_PAGE);
	},
	
	showDetails: function(ev){
		var contactDetailsPage = addHouseholdMembersController.getContactDetailsPage();
		
		var selContact = ev.getSource();
		var contactData = selContact.getBindingContext().getProperty(selContact.getBindingContext().getPath());
		if(contactData.phones && contactData.phones.length > 0)
			contactData.phoneNumbersAvailable = true;
		else
			contactData.phoneNumbersAvailable = false;
		
		if(contactData.emails && contactData.emails.length > 0)
			contactData.emailsAvailable = true;
		else
			contactData.emailsAvailable = false;
		
		contactData.ownerCheckBoxEnabled = true;
		contactData.phonesListHeader = oBundle.getText("select_invite_phone");
		contactData.emailsListHeader = oBundle.getText("select_invite_email");
		
		contactDetailsPage.setTitle(contactData.name);
		var resendBtn = contactDetailsPage.getHeaderContent()[0];
		resendBtn.setVisible(false);
		
		contactDetailsPage.getContent()[0].getModel().setData(contactData);
		app.to(ID_ADD_MEMBERS_DETAILS_PAGE);
		
	},
	
	tapAddOwner: function(ev){
		var source = ev.getSource();
		var contactData = app.getPage(ID_ADD_MEMBERS_DETAILS_PAGE).getContent()[0].getModel().getData();
		contactData.additionalOwner = !contactData.additionalOwner;
		app.getPage(ID_ADD_MEMBERS_DETAILS_PAGE).getContent()[0].getModel().setData(contactData);
	},
	
	makeCall: function(ev){
		var phone = ev.getSource().getTitle();
		util.openExternalLink("tel:"+phone);
	},
	
	sendEmail: function(ev){
		var email = ev.getSource().getTitle();
		util.openExternalLink("mailto:"+email);
	},
});