sap.ui.controller('app.ui.household.household', {
	editMode: false,
	initialData: null,
	previousPage: SETTINGS_PAGE,
	householdId : "",
	isRole : "",
	programId : "",
	programName : "",
	householdName : "",
	getHouseholdPage: function(){
		if(app.getPage(ID_HOUSEHOLD_PAGE) == null)
		{
			var householdView = sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.household.household",
				controller : this
			});
			
			var householdPage = new sap.m.Page(ID_HOUSEHOLD_PAGE, {
				title : oBundle.getText("household"),
				content : [ householdView ],
				showNavButton : true,
				headerContent : [new sap.m.Button({
					text:oBundle.getText("edit"),
					tap:function(){
						householdController.editMembers();
					}})],
				navButtonText:oBundle.getText("Back_Button"),
				navButtonTap: function(){
					householdController.goBack();
				},
			});

			var membersList = householdView.byId("membersList");
			membersList.onAfterRendering  = householdController.isLoginMember;
			
			var model = new sap.ui.model.json.JSONModel();
			householdView.setModel(model);

			app.addPage(householdPage);
		}
		
		return app.getPage(ID_HOUSEHOLD_PAGE);
	},
	
	navigateToHousehold: function(response, status){
		
		if(isRESTStatusCodeCorrect(response))
		{
			util.closeBusyDialog();
			var householdPage = householdController.getHouseholdPage();
			
			var editBtn = householdPage.getHeaderContent()[0];
			editBtn.setVisible(false);
			var showWelcomeText = false;
			var members;
			var welcomeText;
			//Since single view is used for starting and ending page of the household, this flag helps in identifing those pages.
			var isInitialPage = true;
			var responseHousehold = response.households[0];
			//if(responseHousehold.hasOwnProperty(householdId))
				
			/*else
				householdController.householdId = "";*/
			if(responseHousehold != undefined && responseHousehold.householdId != undefined && responseHousehold.householdMembers.length > 1)
			{
				householdController.householdId = responseHousehold.householdId;
				members = responseHousehold.householdMembers;
				//householdController.householdName = responseHousehold.householdName;
				householdController.householdName = oBundle.getText("my_household");
				//householdController.householdName = response.lastName + "'s " + oBundle.getText("household");
				//householdPage.setTitle(responseHousehold.householdName);
				//householdPage.setTitle(householdController.householdName);
				householdPage.setTitle(oBundle.getText("my_household"));
				for(var i=0; i<members.length; i++)
				{
					if(members[i].customerId == null){
						members[i].role = "Pending";
						members[i].roleText = oBundle.getText("pending");
						members[i].isRoleUpdate = false;
					}
					else if(members[i].role == "Owner"){
						members[i].roleText =  oBundle.getText("owner");
						members[i].isRoleUpdate = true;
					}
					else if(members[i].role == "Member"){
						members[i].roleText =  oBundle.getText("member");
						members[i].isRoleUpdate = true;
					}
					//members[i].deleteIcon = "app/resources/img/delete.png";
					members[i].rowType = "Navigation";
					//Check if the current user is a owner, if yes show the edit button
					if(members[i].customerId == loginResponseModel.customer.id && members[i].role == "Owner")
						editBtn.setVisible(true);
				}
				//Ending page of the household so set the flag to false.
				isInitialPage = false;
			}
			else
			{
				
				showWelcomeText = true;
				var cardTitle;
				/*if(response.households[0].loyaltyProgramName != undefined){
					
					cardTitle = response.households[0].loyaltyProgramName;
				}
				else{*/
					//cardTitle = response.households[0].loyaltyProgramName;
				
				cardTitle = response.lastName+" "+oBundle.getText("household");
				//}
				householdController.householdName = cardTitle;
				welcomeText = oBundle.getText("welcome_household_owner", [response.firstName, householdController.programName]);
				members = [{
					"customerName" : response.firstName + " " + response.lastName,
					"role": "Owner",
					"roleText" : oBundle.getText("owner"),
					"invitationStatus" : "Accepted",
					"deleteIcon" : "app/resources/img/delete.png",
					"rowType": "Inactive",
				}];
				//householdPage.setTitle(response.lastName + "'s " + oBundle.getText("household"));	
				//householdPage.setTitle(response.householdName);
				householdPage.setTitle(oBundle.getText("my_household"));
				//Starting page of the household so set the flag to true. 
				isInitialPage = true;
			}
			for(var i=0; i<members.length; i++)
			{
				if(members[i].role == oBundle.getText("owner"))
					members[i].isOwner = true;
				else
					members[i].isOwner = false;	
			}
			
			var householdData = {
					showWelcomeText: showWelcomeText,
					welcomeText : welcomeText,
					members: members,
					showNormalList: true,
					showEditList: false,
			};
			
			//Depending on the flag value set the appropriate flag values for starting and ending page in the household.
			if(isInitialPage == true){
				householdData.initialList = true;
				householdData.showNormalList = false;
			}
			else{
				householdData.initialList = false;
				householdData.showNormalList = true;
			}
			this.editMode = false;
			editBtn.setText(oBundle.getText("edit"));
			householdPage.setNavButtonText(oBundle.getText("Back_Button"));
			
			//Creating copy of the data, to be used in case user edits and do cancel
			householdController.initialData = jQuery.extend(true, {}, householdData);
			householdPage.getContent()[0].getModel().setData(householdData);
			app.to(ID_HOUSEHOLD_PAGE);
			
			/*Check to set the add members button depending on the logged in users role.*/
			householdController.isRole = "";
			var data = app.getCurrentPage().getContent()[0].getModel().getData();
			for(var i = 0 ;i < data.members.length ; i++){
				if(data.members[i].customerId == loginResponseModel.customer.id){
					householdController.isRole = data.members[i].role;
					
				}
			}
			var householdRef = app.getPage(ID_HOUSEHOLD_PAGE).getContent()[0];
			if(householdController.isRole == "Member"){
				householdData.isOwner = false;
				householdRef.byId("btn_addHouseHoldMembers").setVisible(false);
			}
			else{
				householdData.isOwner = true;
				householdRef.byId("btn_addHouseHoldMembers").setVisible(true);
			}
			householdPage.getContent()[0].getModel().setData(householdData);
		}
		else
		{
			logTechnicalError("HouseholdDetails Not Fetched","Couldn't fetch HouseholdDetails");
		}
		
		var membersList = app.getPage(ID_HOUSEHOLD_PAGE).getContent()[0].byId("membersList");
		membersList.rerender();
		
		
		
	},
	//Method calls the service to get details of members in household.
	launchHouseholdPage: function(prevPage){
		//Save the previous page name.
		householdController.previousPage = prevPage;
		
		//Call back for gethouseholdDetailsForMember.
		var callbackForHouseholdDetails = function(response, status){
			if ( isRESTStatusCodeCorrect(response) ){
		    	//Define setting controller if member has loged in for first time, and clicked on My household list item.
		        if(settingsController == undefined)
		        	settingsController = sap.ui.controller("app.ui.settings.settingsController");
		        //Store the copy of response.
		        settingsController.householdServiceData = response;
		        //Navigate to Household members page.
		        householdController.navigateToHousehold(response,status);
		        
		    }else{
		        //util.closeBusyDialog();
		        logError("error_message_general", "Error in the response of gethousehold details for members", "household");
		    }
			util.closeBusyDialog();
			
	    };
		
	    util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
	    SmartphoneService.getHouseholdDetailsForMember({}, callbackForHouseholdDetails);
	},
	//Navigate to launchAddMembersPage on press of Add Members button.
	addMembers: function(){
		if(addHouseholdMembersController == undefined)
			addHouseholdMembersController = sap.ui.controller("app.ui.household.addMembers");
		addHouseholdMembersController.launchAddMembersPage();
	},
	
	editMembers: function(){
		if(householdController.editMode)
		{
			var householdPage = householdController.getHouseholdPage();
			var data = householdPage.getContent()[0].getModel().getData();
			var members = data.members;
			var ownerPresent = false;
			var resigningFromOwnership = true;
			for(var i=0; i<members.length; i++)
			{
				if(members[i].isOwner)
				{
					ownerPresent = true;
					if(members[i].customerId == loginResponseModel.customer.id)
						resigningFromOwnership = false;
				}
			}
			if(!ownerPresent)
			{
				logError("error_household_with_no_owner","User trying to remove all owners from the household","household");
				return;
			}
			if(resigningFromOwnership)
			{
				var callBackFunction = function(selectedButtonIndex)
				{
					if(selectedButtonIndex == 0)
						householdController.performEdition();
				};
				//
				householdController.performEdition();
//				util.showDialogWithOptions(callBackFunction,
//						oBundle.getText("household_resigning_from_ownership"),
//						[oBundle.getText("Yes"),oBundle.getText("No")]);
				return;
			}
			householdController.performEdition();
		}
		else{
			householdController.toggleEditMode();
		}
	},
	
	performEdition: function(){
		//Here we need to call services to make changes in the back end
		//householdController.toggleEditMode();
		
		householdController.updateHouseholdMemberRole();
		
	},
	
	goBack: function(){
		//If edit mode button is pressed and member wants to cancel the edit mode.
		if(householdController.editMode)
		{
			var householdPage = householdController.getHouseholdPage();
			householdPage.getContent()[0].getModel().setData(householdController.initialData);
			householdController.toggleEditMode();
		}
		else
		{
			app.backToPage(householdController.previousPage);
		}
	},
	
	toggleEditMode: function(){
		var householdPage = householdController.getHouseholdPage();
		var editBtn = householdPage.getHeaderContent()[0];
		var addMemBtn = householdPage.getContent()[0].byId("btn_addHouseHoldMembers");
		var data = householdPage.getContent()[0].getModel().getData();
		var members = data.members;
		
		if(householdController.editMode)
		{
			householdPage.setTitle(householdController.householdName);
			editBtn.setText(oBundle.getText("edit"));
			householdPage.setNavButtonText(oBundle.getText("Back_Button"));
			//Editing the initial list
			data.initialList = false;
			data.showNormalList = true;
			data.showEditList = false;
			householdPage.setNavButtonType(sap.m.ButtonType.Back);
			addMemBtn.setVisible(true);
			//householdController.updateHouseholdMemberRole();
		}
		else
		{
			householdPage.setTitle(oBundle.getText("select_owners"));
			editBtn.setText(oBundle.getText("done"));
			householdPage.setNavButtonText(oBundle.getText("Cancel_Text"));
			//Editing the initial list
			data.initialList = false;
			data.showNormalList = false;
			data.showEditList = true;
			addMemBtn.setVisible(false);
			if(util.isIPhone())
				householdPage.setNavButtonType(sap.m.ButtonType.Default);
		}
		this.editMode = !this.editMode;
		data.members = members;
		householdPage.getContent()[0].getModel().setData(data);
		
	},
	//Function is called when role of the member needs to be updated.
	updateHouseholdMemberRole : function(){
		var ownerToMember = 0;
		//Confirmation dialog shown only when owner is updating his role to member from ownership.
		var confirmationDialog = new sap.m.Dialog({
			title : oBundle.getText("change_status"),
			type : sap.m.DialogType.Message,
			content : new sap.m.Text({
				text : oBundle.getText("owner_to_member_update"),
				
			}),
			leftButton:new sap.m.Button({
				text : oBundle.getText("cancel"),
				width : "100%",
				tap : function(){
					util.closeBusyDialog();
					confirmationDialog.close();
				}
			}),
			rightButton : new sap.m.Button({
				text : oBundle.getText("OK"),
				width : "100%",
				tap : function(){
					SmartphoneService.updateMemberRolesForHousehold(memberUpdate, callbackForUpdate);
					confirmationDialog.close();
				}
			})
		});
		
		//Get the current members data.
		var data = app.getCurrentPage().getContent()[0].getModel().getData();
		var memberData = data.members;
		//JSON structure that contains the details for updating the members details.
		var memberUpdate = {
				memberRoles :[],
				householdId : householdController.householdId
		};
		
		//Loop through the members who have accepted the invitations and get there customerId and roles.
		for(var i = 0 ; i < memberData.length ; i++){
  			if(memberData[i].customerId != null){
  				var roles;
  				if(memberData[i].isOwner)
  					roles = "Owner";
  				else
  					roles = "Member";
  				var memberDetail = {
  						customerId : memberData[i].customerId,
  						role : roles
  				};
  				memberUpdate.memberRoles.push(memberDetail);
  				if(memberData[i].customerId == loginResponseModel.customer.id && memberData[i].isOwner == false){
  					ownerToMember = 1;
  				}
  			}
  		}
		//Call back function for updateMemberRolesForHousehold.
		var callbackForUpdate = function(response, status){
		      //console.log("response\n" + JSON.stringify(response));
		      
		      if ( isRESTStatusCodeCorrect(response) ){
		    	  util.closeBusyDialog();
		    	  //Once the member roles are updated then call the service so that new data would be updated.
		    	  householdController.launchHouseholdPage(householdController.previousPage);
		    	  householdController.toggleEditMode();
		      }else{
		    	  util.closeBusyDialog();
		          logError("error_message_general", "Error in the response of updateMemberRolesForHousehold", "householdUpdate");
		      }
		};
		//If there is atleast on member(who has accpted the invitation) then call the update service.
		if(memberUpdate.memberRoles.length > 0){
		   util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
		   if(ownerToMember == 1)
			   confirmationDialog.open();
		   else
			   SmartphoneService.updateMemberRolesForHousehold(memberUpdate, callbackForUpdate);
		}
	},
	toggleOwner: function(ev){
		//Not needed as the fresh data will be sent by the server and we will draw UI based on that
		var checkBox = ev.getSource();
		var contact = checkBox.getBindingContext().getProperty(checkBox.getBindingContext().getPath());
		var householdMemberOwnerData = app.getCurrentPage().getContent()[0].getModel().getData();
		var householdOwnerCount = 0;
		for(var i=0 ; i<householdMemberOwnerData.members.length ; i++){
			if(householdMemberOwnerData.members[i].isOwner == true){
				householdOwnerCount++;
			}
		}
		if(householdOwnerCount == 0){
			ev.getSource().setSelected(true);
			//cancellationDialog.open();
		}
		if(householdOwnerCount > 0){
		if(checkBox.getSelected())
		{
			contact.role = "Owner";
			contact.roleText = oBundle.getText("owner");
		}
		else
		{
			contact.role = "Member";
			contact.roleText = oBundle.getText("member");
		}
		}
		else{
			//Cancellation pop up when there is only one member in the household who is the owner
			var cancellationDialog = new sap.m.Dialog({
				title : oBundle.getText("cannot_upate_status"),
				type : sap.m.DialogType.Message,
				content : new sap.m.Text({
					text : oBundle.getText("owner_to_member_no_update"),
					
				}),
				leftButton:new sap.m.Button({
					text : oBundle.getText("cancel"),
					width : "100%",
					tap : function(){
						cancellationDialog.close();
					}
				}),
			});
			cancellationDialog.open();
		}
		
	},
	swipeToRemove : function(ev){
		
		var rowData = ev.mParameters.listItem.getBindingContext().getProperty(ev.mParameters.listItem.getBindingContext().getPath());
		//var rowData = swipedRow.getBindingContext().getProperty(swipedRow.getBindingContext().getPath());
		var householdPage = householdController.getHouseholdPage();
		var data = householdPage.getContent()[0].getModel().getData();
		householdController.isRole = "";
		for(var i = 0 ;i < data.members.length ; i++){
			if(data.members[i].customerId == loginResponseModel.customer.id){
				householdController.isRole = data.members[i].role;
			}
		}
		
		if(householdController.isRole == "Member" && loginResponseModel.customer.id != rowData.customerId){
			ev.preventDefault();
		}
	},
	removeContact: function(ev){
		if(userState.DEMO_MODE){
			logError("demo_mode_message","In Demo Mode","Not Supported In Demo Mode");
			return;
		}
		var swipedRow = ev.getSource().getParent().getSwipedItem();
		var rowData = swipedRow.getBindingContext().getProperty(swipedRow.getBindingContext().getPath());
		var householdPage = householdController.getHouseholdPage();
		var data = householdPage.getContent()[0].getModel().getData();
		/*var isRole = "";
		for(var i = 0 ;i < data.members.length ; i++){
			if(data.members[i].customerId == loginResponseModel.customer.id){
				isRole = data.members[i].role;
			}
		}*/
		
		//Pop for confirmation of deletion of member from houeshold
		
		var confirmationDialog = new sap.m.Dialog({
			title : oBundle.getText("remove_from_household"),
			content : [new sap.m.Text({
				text : oBundle.getText("owner_remove_member")
			})],
			leftButton : new sap.m.Button({
				layoutData : new sap.m.FlexItemData({
					growFactor : 1
				}),
				text : oBundle.getText("cancel"),
				width : "100%",
				tap :function(){
					confirmationDialog.close();
					//swipedRow.swipeOut();
				}
			}),
			rightButton : new sap.m.Button({
				text : oBundle.getText("OK"),
				layoutData : new sap.m.FlexItemData({
					growFactor : 1
				}),
				width : "100%",
				tap :function(){
					//Condition to check whether the member to be deleted is either(owner or member) or a pending invitation.
					if(rowData.customerId != null){
						var removeMemberDetails = {
								householdId : householdController.householdId,
								customerId : "",
								
						};
						removeMemberDetails.customerId = rowData.customerId;
						var callback = function(response,status){
							if ( isRESTStatusCodeCorrect(response) ){
								
								householdController.launchHouseholdPage(householdController.previousPage);	
								
						      }else{
						        util.closeBusyDialog();
						          logError("error_message_general", "Error in the response of gethousehold details for members", "householdRemove");
						      }
							confirmationDialog.close();
						};
						SmartphoneService.removeMemberFromHousehold(removeMemberDetails,callback,true);
						
					}
					else{
						var removeMemberDetails = {
								householdId : householdController.householdId,
								
								invitationId : ""
						};
						removeMemberDetails.invitationId = rowData.invitationId;
						
						var callback = function(response,status){
							if ( isRESTStatusCodeCorrect(response) ){
								
								householdController.launchHouseholdPage(householdController.previousPage);
						      }else{
						        util.closeBusyDialog();
						          logError("error_message_general", "Error in the response of gethousehold details for members", "login");
						      }
							confirmationDialog.close();
						};
						SmartphoneService.removeMemberFromHousehold(removeMemberDetails,callback,false);
						
						
					}
					
				}
			})
		});
		var selfConfirmationDialog = new sap.m.Dialog({
			title : oBundle.getText("remove_from_household"),
			content : [new sap.m.Text({
				text : oBundle.getText("owner_self_remove")
			})],
			leftButton : new sap.m.Button({
				layoutData : new sap.m.FlexItemData({
					growFactor : 1
				}),
				text : oBundle.getText("Cancel"),
				width : "100%",
				tap :function(){
					selfConfirmationDialog.close();
					//swipedRow.swipeOut();
				}
			}),
			rightButton : new sap.m.Button({
				text : oBundle.getText("OK"),
				layoutData : new sap.m.FlexItemData({
					growFactor : 1
				}),
				width : "100%",
				tap :function(){
						var removeMemberDetails = {
								householdId : householdController.householdId,
								customerId : "",
								
						};
						removeMemberDetails.customerId = rowData.customerId;
						var callback = function(response,status){
							if ( isRESTStatusCodeCorrect(response) ){
								//sap.m.MessageToast.show("success");
								//householdController.launchHouseholdPage(householdController.previousPage);	
								//app.to(ANONYMOUS_HOME_PAGE);
								if(userCredentialSettingsController == undefined)
									userCredentialSettingsController = sap.ui.controller('app.ui.settings.userCredentialSettings');
								userCredentialSettingsController.SignOut();
						      }else{
						        util.closeBusyDialog();
						          logError("error_message_general", "Error in the response of gethousehold details for members", "householdRemove");
						      }
							selfConfirmationDialog.close();
						};
						SmartphoneService.removeMemberFromHousehold(removeMemberDetails,callback,true);
				}
			})
		});
		var cancellationDialog = new sap.m.Dialog({
			title : oBundle.getText("remove_from_household"),
			content : [new sap.m.Text({
				text : oBundle.getText("one_owner_remove")
			})],
			leftButton : new sap.m.Button({
				layoutData : new sap.m.FlexItemData({
					growFactor : 1
				}),
				text : oBundle.getText("cancel"),
				width : "100%",
				tap :function(){
					cancellationDialog.close();
					//swipedRow.swipeOut();
				}
			}),
			
		});
		if(rowData.isOwner == false && rowData.customerId == loginResponseModel.customer.id)
		{
			selfConfirmationDialog.open();
			return;
			
		}
		if(rowData.isOwner == false)
		{
			confirmationDialog.open();
			return;
			
		}
		
		//Owner count is used to keep track of owners so that atleast one owner is left.
		var ownerCount = 0;
		
		for(var i=0;i<data.members.length;i++){
			if(data.members[i].isOwner == true)
				ownerCount++;
			
		}
		
		if(ownerCount == 1)
		{
			//There is only one owner which is the current owner, so cannot delete the membership. Show an error message 
			cancellationDialog.open();
			return;
		}
	
		
		//There are more than one owners
		if(rowData.customerId == loginResponseModel.customer.id)
		{	
			selfConfirmationDialog.open();
			
		//User is trying to delete his own membership, show a confirmation
			return;
		}
		else
		{
			//User trying to delete someone else. Call the service to make the change
			confirmationDialog.open();
		}
		
		//Get the id of the item which is swiped for deletion.
		/*var delBtn = app.getCurrentPage().getContent()[0].byId("membersList");
		var selectedItem = delBtn.getSwipedItem();
		var index;
		//Based on id of each item and comparing it with other items id, get the index of the item to be deleted. 
		for(var i=0;i<delBtn.getAggregation("items").length;i++){
			if(selectedItem.getId() == delBtn.getAggregation("items")[i].getId())
				index = i;
		}
		
		var householdPage = householdController.getHouseholdPage();
		
		var currentData = app.getCurrentPage().getContent()[0].getModel().getData();
		
		//After fetching the data of current page, use the index to fetch the item through index.
		var contact = currentData.members[index];*/
		
		
		
	},
	
	showContactDetails: function(ev){
		
		if(addHouseholdMembersController == undefined)
			addHouseholdMembersController = sap.ui.controller("app.ui.household.addMembers");
		var contactDetailsPage = addHouseholdMembersController.getContactDetailsPage();
		
		var selContact = ev.getSource();
		var contactData = selContact.getBindingContext().getProperty(selContact.getBindingContext().getPath());
		if(contactData.phoneNumber && contactData.phoneNumber.length > 0)
		{
			contactData.phones = [{"phone": contactData.phoneNumber}];
			contactData.phoneNumbersAvailable = true;
		}
		else
			contactData.phoneNumbersAvailable = false;
		
		if(contactData.email && contactData.email.length > 0)
		{
			contactData.emails = [{"email": contactData.email}];
			contactData.emailsAvailable = true;
		}
		else
			contactData.emailsAvailable = false;
		
		if(contactData.isOwner)
		{
			contactData.additionalOwner = true;
		}
		else
		{
			contactData.additionalOwner = false;
		}
		contactData.ownerCheckBoxEnabled = false;
		contactData.phonesListHeader = oBundle.getText("Phone");
		contactData.emailsListHeader = oBundle.getText("Email");
		
		contactDetailsPage.setTitle(contactData.customerName);
		var resendBtn = contactDetailsPage.getHeaderContent()[0];
		resendBtn.setVisible(false);
		
		contactDetailsPage.getContent()[0].getModel().setData(contactData);
		app.to(ID_ADD_MEMBERS_DETAILS_PAGE);
		
	},
	isLoginMember : function(){
		
		var memberCount;
		householdController.isRole = "";
		var data = app.getCurrentPage().getContent()[0].getModel().getData();
		for(var i = 0 ;i < data.members.length ; i++){
			if(data.members[i].customerId == loginResponseModel.customer.id){
				householdController.isRole = data.members[i].role;
				memberCount = i;
			}
		}
		
		
		
		var householdRef = app.getPage(ID_HOUSEHOLD_PAGE).getContent()[0];
		if(householdController.isRole == "Member"){
			
			//householdRef.byId("btn_addHouseHoldMembers").setVisible(false);
			var parent = householdRef.getDomRef();
			var child = parent.childNodes[3].childNodes[0].childNodes[0];
			var householdDataCount = app.getPage(ID_HOUSEHOLD_PAGE).getContent()[0].getModel().getData();
			for(var i = 0 ;i <householdDataCount.members.length ;i++){
				if( i != memberCount){
					try{
						child.childNodes[0].childNodes[0].childNodes[i].childNodes[0].childNodes[0].childNodes[0].childNodes[0].childNodes[0].style.color = "#cccccc";
						child.childNodes[0].childNodes[0].childNodes[i].childNodes[0].childNodes[0].childNodes[0].childNodes[1].childNodes[0].style.color = "#cccccc";
						child.childNodes[0].childNodes[0].childNodes[i].childNodes[0].childNodes[0].childNodes[0].childNodes[2].childNodes[0].style.color = "#cccccc";
					}
					catch(err){
						
					}
				}
			}
		}
		else{
			var parent = householdRef.getDomRef();
			var child = parent.childNodes[3].childNodes[0].childNodes[0];
			var householdDataCount = app.getPage(ID_HOUSEHOLD_PAGE).getContent()[0].getModel().getData();
			for(var i = 0 ;i <householdDataCount.members.length ;i++){
				child.childNodes[0].childNodes[0].childNodes[i].childNodes[0].childNodes[0].childNodes[0].childNodes[0].childNodes[0].style.color = "#000000";
				child.childNodes[0].childNodes[0].childNodes[i].childNodes[0].childNodes[0].childNodes[0].childNodes[1].childNodes[0].style.color = "#7A7A7A";
				child.childNodes[0].childNodes[0].childNodes[i].childNodes[0].childNodes[0].childNodes[0].childNodes[2].childNodes[0].style.color = "#7A7A7A";
				
			}
			//householdRef.byId("btn_addHouseHoldMembers").setVisible(true);
		}
	}
	
});
