//2013 SAP AG. All rights reserved.
//Author : SAP.

//make temp password
var forgotPasswordBack = function(response, status){
    //reset forgot password input
    var tempData = ForgotPasswordModel;
    tempData.username = "";
    ForgotPasswordModel.setData(tempData);
    
    if( isRESTStatusCodeCorrect(response) ) {
        app.to(ID_LOGIN_PAGE);
    }
    else{
	logError("error_message_fail_generate_tempPW", "failed to create temporary password", "forgotPasswordBack");
    }
    
}
/*
//get id
var forgotPWGetById = function(response, status){
    
    if(isRESTStatusCodeCorrect(response)) {
        var userId = response.customer;
        
        var tempData = app.getPage(FORGOT_PASSWORD_RESET).getContent()[0].getModel().getData();
        tempData.id = userId;
        app.getPage(FORGOT_PASSWORD_RESET).getContent()[0].getModel().setData(tempData);

        var dataLoginBack ={}, customerObjVal = {};
        customerObjVal['id'] = userId;
        dataLoginBack['customer'] = customerObjVal;
        loginResponseModel = new sap.ui.model.json.JSONModel();
        loginResponseModel.setData(dataLoginBack);
        
		SmartphoneService.ChangeLoyaltyCredential(forgotResetPasswordModel, forgotResetPasswordBack);
    }
    else{
	//bad email, cust DNE
        logError("error_message_cust_email_DNE", "customer" + +" does not exist", "forgotPWGetById");  
    }
}
*/
var forgotResetPasswordBack = function (response, status){
    if(isRESTStatusCodeCorrect(response)) {
        //do standard login
        loginModel.oData.account.credential = forgotResetPasswordModel.oData.newPassword;
        
        //clear password in resetpassword page	
        var dataForgotPassword={
            user : "",
            id : "",
            newPassword : "",
            oldPassword : ""
        };
        forgotResetPasswordModel.setData(dataForgotPassword);
        app.getPage(FORGOT_PASSWORD_RESET).getContent()[0].setModel(forgotResetPasswordModel);
        
        util.createBusyDialog( oBundle.getText("login_Busy"), oBundle.getText("Busy_Title") );
        
        SmartphoneService.loginCustomer(loginModel, homepageController.loginBack, null,  null, true);
    }
    else{
        //errorCode: PW already been used previously
        checkErrorMobiliserStatus(response);
    }
}



sap.ui.controller('app.ui.login.forgotPassword', {
	
	onAfterRendering: function(){

	},
	
    launchforgotPassword : function(){
         if (app.getPage(FORGOT_PASSWORD) == null){
             var ForgotPasswordView = sap.ui.view({
                     type : sap.ui.core.mvc.ViewType.XML,
                     viewName : "app.ui.login.forgotPassword",
                     controller : forgotPasswordController
                 });
             var page1 = new sap.m.Page(FORGOT_PASSWORD, {
                 title : oBundle.getText("Login_Title"),
                 content : [ ForgotPasswordView ],
                 showNavButton : true,
		 navButtonText:oBundle.getText("Back_Button"),
                 navButtonTap: function(){
                                     app.back();
                             },
                 //footer : new sap.m.Bar()
             });
             
             var dataForgotPassword={
                 username:""
             };
             
             ForgotPasswordModel = new sap.ui.model.json.JSONModel();
             ForgotPasswordModel.setData(dataForgotPassword);
             ForgotPasswordView.setModel(ForgotPasswordModel);
             
             app.addPage(page1);
         }
         
         app.to(FORGOT_PASSWORD);
     },
    doForgotPassword : function(){
        var  forgotView = app.getPage(FORGOT_PASSWORD).getContent()[0];
        var errorLabel = forgotView.byId("sign_in_error_label");
        
        var username = forgotView.byId("forgotPassword_Username").getValue();
        if (username.trim().length == 0){
            errorLabel.setText(oBundle.getText("Please_Enter_Email"));
            forgotView.byId("forgotPassword_Username").focus();
            return;
        }
        else{
             errorLabel.setText(oBundle.getText(""));
        }
        //start service request        
        SmartphoneService.resetPassword(ForgotPasswordModel, forgotPasswordBack);
    },
    
    
    //reset PW after forgotPW launched
    doForgotPasswordReset : function( userID ) {
            var dataForgotPassword={
                user : userID,
                id : "",
                newPassword : "",
            };
            
        if (app.getPage(FORGOT_PASSWORD_RESET) == null){
            var ForgotPasswordView = sap.ui.view({
                type : sap.ui.core.mvc.ViewType.XML,
                viewName : "app.ui.login.forgotPasswordReset",
                controller : forgotPasswordController
            });
            var page1 = new sap.m.Page(FORGOT_PASSWORD_RESET, {
                title : oBundle.getText("Reset_Password"),
                content : [ ForgotPasswordView ],
                //footer : new sap.m.Bar()
            });
            
            ForgotPasswordModel = new sap.ui.model.json.JSONModel();
            ForgotPasswordModel.setData(dataForgotPassword);
            ForgotPasswordView.setModel(ForgotPasswordModel);
            
            app.addPage(page1);
         }

                     
        forgotResetPasswordModel = new sap.ui.model.json.JSONModel();
        forgotResetPasswordModel.setData(dataForgotPassword);
        app.getPage(FORGOT_PASSWORD_RESET).getContent()[0].setModel(forgotResetPasswordModel);
            
         
         util.closeBusyDialog();
         app.to(FORGOT_PASSWORD_RESET);
    },
    
    doReset: function(){

        var tempView = app.getPage(FORGOT_PASSWORD_RESET).getContent()[0];
	var errorLabel = tempView.byId("reset_error_error_label");
        
        var newpassword = tempView.byId("input_new_password").getValue();
        var verifynewpassword = tempView.byId("input_verify_password").getValue();
        
        if (newpassword.trim().length == 0 || verifynewpassword == 0){
            errorLabel.setText(oBundle.getText("error_message_missing_entry"));
	    return;
        }
        else if ( newpassword.trim().length < 3 || newpassword.trim().length > 23 ){
            errorLabel.setText(oBundle.getText("error_message_password_length"));
            return;
        }
        else if ( newpassword.trim() !=verifynewpassword.trim() ){
            errorLabel.setText(oBundle.getText("error_message__password"));
            return;
        }
        else{
		errorLabel.setText("");
        }
        var loginData = app.getPage(ID_LOGIN_PAGE).getContent()[0].getModel().getData();
        forgotResetPasswordModel.oData.id = loginData.account.identification;
        forgotResetPasswordModel.oData.oldPassword = loginData.account.credential;
        forgotResetPasswordModel.oData.newPassword = newpassword;
        SmartphoneService.ChangeLoyaltyCredential(forgotResetPasswordModel, forgotResetPasswordBack)
        
    }
    
});
