sap.ui.controller("app.ui.myLists.CheckInItemDetailController", {
//Method called when an item in the list is tapped. This method calls the item detail page to display the details of item selected.
    value : 1,
	total : 0,
	listDetailsItemDetails : null,
	article : null,
	launchHomeScanItemDetailPage : function (article){

		if (app.getPage(ID_HOME_SCAN_PRODUCT) == null) {
			var itemDetailView = sap.ui.view({
                type : sap.ui.core.mvc.ViewType.XML,
                viewName : "app.ui.myLists.CheckInItemDetail",
                id : "itemDetailView",
                controller : this
            });
    
            this.oModel = new sap.ui.model.json.JSONModel();
            //this.oModel.setData(itemDetail);
            itemDetailView.setModel(this.oModel);
            
            var itemDetailPage = new sap.m.Page(ID_HOME_SCAN_PRODUCT, {
                content : [itemDetailView],
                showNavButton:true,
                title : oBundle.getText("item_details"),
                navButtonText : oBundle.getText("Back_Button"),
                navButtonTap : function() {
                    app.back();
                },
            });
			app.addPage(itemDetailPage);
		}
		app.getPage(ID_HOME_SCAN_PRODUCT).setTitle(article.shortdescription);
		itemDetailController.listDetailsItemDetails = article;
		
		var price;
		if(article.finalprice == null || article.finalprice == undefined) {
			price = article.listprice;
        }
        else {
        	price = article.finalprice;
        }
		var currency = article.currency;
		
		if ( price && currency ) {
			if (currency.length == 1) {
				itemDetailController.listDetailsItemDetails.adjPrice = currency + numberFormatInstance.format(parseFloat(price/100).toFixed(2));
			}
			else if (article.currency.length != 1) { //if currency is euro, usd etc
				itemDetailController.listDetailsItemDetails.adjPrice = numberFormatInstance.format(parseFloat(price/100).toFixed(2))+currency;
			}
		}
		
		itemDetailController.listDetailsItemDetails.title = article.shortdescription;
		itemDetailController.listDetailsItemDetails.quantityVisible = false;
		itemDetailController.listDetailsItemDetails.fromList = false;
		itemDetailController.listDetailsItemDetails.fromCart = false;
		itemDetailController.listDetailsItemDetails.checkInVisibility = true;
		app.getPage(ID_HOME_SCAN_PRODUCT).getContent()[0].getModel().setData(itemDetailController.listDetailsItemDetails);
		app.to(ID_HOME_SCAN_PRODUCT);
		
		if (article.contentTypeId == 2) {
			if (article.gtin) {
				util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
				SmartphoneService.getOffersForArticle(article, itemDetailController.articleOfferHomeScanBack);
			}
		}
	},
	articleOfferHomeScanBack : function(response, status){
		if (status != 200) {
			checkErrorStatus(status);
			return;
		}
		else if( isRESTStatusCodeCorrect(response) ) {
			util.closeBusyDialog();
			if (response.offer!= undefined && response.offer != null) {
				itemDetailController.listDetailsItemDetails.offers = response.offer;
				for ( i = 0; i < response.offer.length; i++){
					itemDetailController.listDetailsItemDetails.offers[i].offersDate = util.convertDateToReadableFormatDDwordMM( response.offer[i].validFrom )+ " to " + util.convertDateToReadableFormatDDwordMM( response.offer[i].validTo );
				}
				app.getPage(ID_HOME_SCAN_PRODUCT).getContent()[0].getModel().setData(itemDetailController.listDetailsItemDetails);
			}
		}
		else{
			checkErrorMobiliserStatus(response);
		}
	},
//called from list detail page shopping
	launchItemDetailPage : function(article, detail){ 
    	checkInItemDetailsController.article = article;
        if(checkInItemDetailsController.article.finalprice == null || checkInItemDetailsController.article.finalprice == undefined) {
            checkInItemDetailsController.productPrice = checkInItemDetailsController.article.listprice;
        }
        else {
            checkInItemDetailsController.productPrice = checkInItemDetailsController.article.finalprice;
        }
                  
    	var addToCart = new sap.m.Button({
            	text : oBundle.getText("add_to_cart"),
           	tap: function(){
			
				var page = app.getPage(ID_CHECK_IN_ITEM_DETAILS);
				var content = page.getContent()[0];
				var input = content.byId("qtyInput");
				checkInItemDetailsController.value = input.getValue();
				if(checkInItemDetailsController.value == "")
					checkInItemDetailsController.value = 1;
				checkInItemDetailsController.total = checkInItemDetailsController.value * checkInItemDetailsController.productPrice;
				var obj ={
					gtin : article.gtin,
					quantity :checkInItemDetailsController.value,
					unitOfMeasurement : article.currency,
					totalAmount : parseInt(parseFloat(checkInItemDetailsController.total/100).toFixed(2)),
					imageUrl : article.imageUrl,
					listId : checkInShoppingController.scannedItemId,
				}
				util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading"));
           		SmartphoneService.addSingleItemInBasket( obj, checkInItemDetailsController.addTocartCallbackFunction);
		    
           	}
           });
        if (app.getPage(ID_CHECK_IN_ITEM_DETAILS) == null) {
            var itemDetailView = sap.ui.view({
                type : sap.ui.core.mvc.ViewType.XML,
                viewName : "app.ui.myLists.CheckInItemDetail",
                id : "CheckInItemDetailView",
                controller : this
            });
    
            this.oModel = new sap.ui.model.json.JSONModel();
            //this.oModel.setData(itemDetail);
            itemDetailView.setModel(this.oModel);
			var detailHeader = new sap.m.Bar({
                contentMiddle : [new sap.m.Label({
                    //TODO: add to translation file
                    text : oBundle.getText("item_details")
                })],
                contentLeft : [new sap.m.Button({
                    text : oBundle.getText("Back_Button"),
                    tap : function(event, src) {
						checkInShoppingController.scanItemtoCart = false;
						app.back();
                    }
                })],
                contentRight : addToCart
            });
            
            var itemDetailPage = new sap.m.Page(ID_CHECK_IN_ITEM_DETAILS, {
                content : [itemDetailView],
                showNavButton:true,
                title : oBundle.getText("item_details"),
                navButtonText : oBundle.getText("Back_Button"),
                enableScrolling : false,
                navButtonTap : function() {
                    app.back();
                },
                customHeader : detailHeader
            });
			app.addPage(itemDetailPage);
        }
        
		var page = app.getPage(ID_CHECK_IN_ITEM_DETAILS);
		var content = page.getContent()[0];
		var input = content.byId("qtyInput");
		input.setValue("");
//        if(checkInShoppingController.scanItemtoCart == false) {
//			//app.getPage(ID_CHECK_IN_ITEM_DETAILS).setTitle(detail.title);
//			app.getPage(ID_CHECK_IN_ITEM_DETAILS).getCustomHeader().getContentMiddle()[0].setText(detail.title);
//			checkInItemDetailsController.listDetailsItemDetails = detail;
//		}
//		else {
			//app.getPage(ID_CHECK_IN_ITEM_DETAILS).setTitle(article.shortdescription);
			app.getPage(ID_CHECK_IN_ITEM_DETAILS).getCustomHeader().getContentMiddle()[0].setText(article.shortdescription);
			checkInItemDetailsController.listDetailsItemDetails = article;
		//}
		// if (detail.contentTypeId == 2) {
			// if (detail.gtin) {
				
			// }
			// else if (detail.id) {
				// SmartphoneService.getOffersForArticle(article, checkInItemDetailsController.articleOfferShoppingBack);
			// }
		// }
		// else if (detail.contentTypeId == 1) {
			// checkInItemDetailsController.listDetailsItemDetails.fromList = true;
			// checkInItemDetailsController.listDetailsItemDetails.fromCart = false;
			// checkInItemDetailsController.listDetailsItemDetails.checkInVisibility = true;
			// checkInItemDetailsController.listDetailsItemDetails.offerVisible = true;
			// app.getPage(ID_CHECK_IN_ITEM_DETAILS).getContent()[0].getModel().setData(checkInItemDetailsController.listDetailsItemDetails);
			// app.to(ID_CHECK_IN_ITEM_DETAILS);
		// }
		SmartphoneService.getOffersForArticle(article, checkInItemDetailsController.articleOfferShoppingBack);
    },
	articleOfferShoppingBack : function(response, status){
		if (status != 200) {
			checkErrorStatus(status);
			return;
		}
		else if( isRESTStatusCodeCorrect(response) ) {
			if (response.offer != null) {
				checkInItemDetailsController.listDetailsItemDetails.offers = response.offer;
				for ( i = 0; i < response.offer.length; i++){
					checkInItemDetailsController.listDetailsItemDetails.offers[i].offersDate = util.convertDateToReadableFormatDDwordMM( response.offer[i].validFrom )+ " to " + util.convertDateToReadableFormatDDwordMM( response.offer[i].validTo );
				}
			}
			checkInItemDetailsController.listDetailsItemDetails.quantityVisible = true;
				//checkInItemDetailsController.listDetailsItemDetails.fromList = true;
				//checkInItemDetailsController.listDetailsItemDetails.fromCart = false;
				checkInItemDetailsController.listDetailsItemDetails.checkInVisibility = true;
				checkInItemDetailsController.listDetailsItemDetails.offerVisible = true;
			    checkInItemDetailsController.listDetailsItemDetails.imageUrl = checkInItemDetailsController.article.imageUrl;
				// checkInItemDetailsController.listDetailsItemDetails.title = checkInItemDetailsController.article.shortdescription;
				// checkInItemDetailsController.listDetailsItemDetails.description = checkInItemDetailsController.article.longdescription;
				var price = checkInItemDetailsController.productPrice;
				var currency = checkInItemDetailsController.article.currency;
				checkInShoppingController.listItemSelected.currency = currency;
				if ( price && currency ) {
					if (currency.length == 1) {
						checkInItemDetailsController.listDetailsItemDetails.adjPrice = currency + numberFormatInstance.format(parseFloat(price/100).toFixed(2));
					}
					else if (checkInItemDetailsController.article.currency.length != 1) { //if currency is euro, usd etc
						checkInItemDetailsController.listDetailsItemDetails.adjPrice = numberFormatInstance.format(parseFloat(price/100).toFixed(2))+currency;
					}
				}
				app.getPage(ID_CHECK_IN_ITEM_DETAILS).getContent()[0].getModel().setData(checkInItemDetailsController.listDetailsItemDetails);
				app.to(ID_CHECK_IN_ITEM_DETAILS);
			// }
			// else{
				// checkInItemDetailsController.listDetailsItemDetails.fromList = true;
				// checkInItemDetailsController.listDetailsItemDetails.fromCart = false;
				// checkInItemDetailsController.listDetailsItemDetails.checkInVisibility = true;
				// checkInItemDetailsController.listDetailsItemDetails.offerVisible = true;
				// app.getPage(ID_CHECK_IN_ITEM_DETAILS).getContent()[0].getModel().setData(checkInItemDetailsController.listDetailsItemDetails);
				// app.to(ID_CHECK_IN_ITEM_DETAILS);
			// }
				util.closeBusyDialog();
		}
		else{
			checkErrorMobiliserStatus(response);
		}
	},
	addTocartCallbackFunction : function(response, status) {
		if (status != 200) {
			checkErrorStatus(status);
			return;
		}
		else if( isRESTStatusCodeCorrect(response) ) {
			
			if(util.isShoppingSessionExpired(response)){
				return;
			}
			if(checkInShoppingController.scanItemtoCart == false) {
				for(var i=0;i<checkInShoppingController.listItemSelected.itemsInList.length;i++){
						util.closeBusyDialog();
						if( checkInShoppingController.scannedItemId == checkInShoppingController.listItemSelected.itemsInList[i].id){
							checkInShoppingController.listItemSelected.itemsInList[i].inCart = true;
							checkInShoppingController.listItemSelected.itemsInList[i].isChecked = false;
							checkInShoppingController.listItemSelected.itemsInList[i].inList = false;
							checkInShoppingController.listItemSelected.itemsInList[i].cartTitle = checkInItemDetailsController.article.shortdescription;
							checkInShoppingController.listItemSelected.itemsInList[i].basketItemId = response.basketItemId;
							checkInShoppingController.listItemSelected.qty = checkInItemDetailsController.value;
							checkInShoppingController.listItemSelected.itemsInList[i].price = checkInItemDetailsController.total;
							var adjTotal;
							if (checkInItemDetailsController.productPrice && checkInItemDetailsController.article.currency) {
								if (checkInItemDetailsController.article.currency.length == 1) {
									adjTotal = checkInItemDetailsController.article.currency + numberFormatInstance.format(parseFloat(parseInt(checkInItemDetailsController.total)/100).toFixed(2));
								}
								else if (checkInItemDetailsController.article.currency.length != 1) { //if currency is euro
									adjTotal = numberFormatInstance.format(parseFloat(parseInt(checkInItemDetailsController.total)/100).toFixed(2)) + checkInItemDetailsController.article.currency;
								}
							}
							checkInShoppingController.listItemSelected.itemsInList[i].totalPrice = adjTotal;
							checkInShoppingController.listItemSelected.cartItemCount = parseInt(checkInShoppingController.listItemSelected.cartItemCount)+1;
							break;
						}
					
					}
					var temp = (checkInShoppingController.listItemSelected.estimatedPrice*100) + parseInt(checkInItemDetailsController.total);
					checkInShoppingController.listItemSelected.estimatedPrice = parseFloat(temp/100).toFixed(2);
                  checkInShoppingController.listItemSelected.estimatedFormattedPrice =numberFormatInstance.format(checkInShoppingController.listItemSelected.estimatedPrice);
					util.closeBusyDialog();
					checkInShoppingController.changeShoppingCartButton();
			}
			else {
				checkInShoppingController.scanItemtoCart = false;
				var adjPrice;
				if (checkInItemDetailsController.productPrice && checkInItemDetailsController.article.currency) {
					if (checkInItemDetailsController.article.currency.length == 1) {
						adjPrice = checkInItemDetailsController.article.currency + numberFormatInstance.format(parseFloat(checkInItemDetailsController.productPrice/100).toFixed(2));
					}
					else if (checkInItemDetailsController.article.currency.length != 1) { //if currency is euro
						adjPrice = numberFormatInstance.format(parseFloat(checkInItemDetailsController.productPrice/100).toFixed(2)) + checkInItemDetailsController.article.currency;
					}
				}
				var adjTotal;
							if (checkInItemDetailsController.total && checkInItemDetailsController.article.currency) {
								if (checkInItemDetailsController.article.currency.length == 1) {
									adjTotal = checkInItemDetailsController.article.currency + numberFormatInstance.format(parseFloat(parseInt(checkInItemDetailsController.total)/100).toFixed(2));
								}
								else if (checkInItemDetailsController.article.currency.length != 1) { //if currency is euro
									adjTotal = numberFormatInstance.format(parseFloat(parseInt(checkInItemDetailsController.total)/100).toFixed(2)) + checkInItemDetailsController.article.currency;
								}
							}
				var tempObj = {
								inCart : true,
								isChecked : false,
								inList : false,
								deleteItem : false,
								basketItemId : response.basketItemId,
								qty : checkInItemDetailsController.value,
								price : checkInItemDetailsController.total,
								totalPrice : adjTotal,
								aisle : checkInItemDetailsController.article.aisle,
								freeText : checkInItemDetailsController.article.longdescription,
								currency : checkInItemDetailsController.article.currency,
								bay : checkInItemDetailsController.article.bay,
								uom : checkInItemDetailsController.article.uom,
								title : checkInItemDetailsController.article.shortdescription,
								cartTitle : checkInItemDetailsController.article.shortdescription,
								adjPrice : adjPrice,
							};
				checkInShoppingController.listItemSelected.itemsInList.push(tempObj);	
				checkInShoppingController.listItemSelected.cartItemCount = parseInt(checkInShoppingController.listItemSelected.cartItemCount)+1;
				var temp = (checkInShoppingController.listItemSelected.estimatedPrice*100) + parseInt(checkInItemDetailsController.total);
				checkInShoppingController.listItemSelected.estimatedPrice = parseFloat(temp/100).toFixed(2);
                checkInShoppingController.listItemSelected.estimatedFormattedPrice =numberFormatInstance.format(checkInShoppingController.listItemSelected.estimatedPrice);
				util.closeBusyDialog();
				checkInShoppingController.changeShoppingCartButton();
			}
		}
		else{
			util.closeBusyDialog();
			util.alertDialog(oBundle.getText("unable_to_add_to_cart"));
			checkErrorMobiliserStatus(response);
		}
	
	},
//Called form listDetail page
    launchListItemDetailPage : function(details){
        if (app.getPage(ITEM_DETAIL_PAGE) == null) {
            var itemDetailView = sap.ui.view({
                type : sap.ui.core.mvc.ViewType.XML,
                viewName : "app.ui.myLists.CheckInItemDetail",
                id : "itemDetailView",
                controller : this
            });
    
            this.oModel = new sap.ui.model.json.JSONModel();
            //this.oModel.setData(itemDetail);
            itemDetailView.setModel(this.oModel);
            
            var itemDetailPage = new sap.m.Page(ITEM_DETAIL_PAGE, {
                content : [itemDetailView],
                showNavButton:true,
                title : oBundle.getText("item_details"),
                navButtonText : oBundle.getText("Back_Button"),
                enableScrolling : false,
                navButtonTap : function() {
                    app.back();
                },
                
            });
            app.addPage(itemDetailPage);
        }
		app.getPage(ITEM_DETAIL_PAGE).setTitle(details.title);

		itemDetailController.listDetailsItemDetails = {};
		itemDetailController.listDetailsItemDetails.adjPrice = details.adjPrice;
		itemDetailController.listDetailsItemDetails.listPrice = details.listPrice ;
		itemDetailController.listDetailsItemDetails.memberPrice = details.memberPrice ;
		itemDetailController.listDetailsItemDetails.offerCount = details.offerCount ;
		itemDetailController.listDetailsItemDetails.qty = details.qty ;
		itemDetailController.listDetailsItemDetails.title = details.title ;
		itemDetailController.listDetailsItemDetails.imageUrl = details.imageUrl ;
		itemDetailController.listDetailsItemDetails.longdescription = details.freeText ;

		itemDetailController.listDetailsItemDetails.offers = [];
		itemDetailController.listDetailsItemDetails.fromList = true;
		itemDetailController.listDetailsItemDetails.fromCart = false;
		itemDetailController.listDetailsItemDetails.checkInVisibility = true;
		itemDetailController.listDetailsItemDetails.quantityVisible = false;
		app.getPage(ITEM_DETAIL_PAGE).getContent()[0].getModel().setData(itemDetailController.listDetailsItemDetails);
		app.to(ITEM_DETAIL_PAGE);
		
//WAITING FOR LEE
		if (details.contentTypeId == 2) {
			if (details.gtin) {
				util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
				SmartphoneService.getOffersForArticle(details, itemDetailController.articleOfferAddItemBack);
			}
			else if (details.id) {
				util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
				SmartphoneService.getOffersForArticle(details, itemDetailController.articleOfferAddItemBack);
			}
		}
		else if (detail.contentTypeId == 1) {
			//This page should not be shown for contentTypeId 
		}
		
    },
    
	articleOfferAddItemBack : function(response, status){
		if (status != 200) {
			checkErrorStatus(status);
			return;
		}
		else if( isRESTStatusCodeCorrect(response) ) {
			util.closeBusyDialog();
			if (response.offer != undefined && response.offer != null && response.offer.length > 0) {
				itemDetailController.listDetailsItemDetails.offers = response.offer;
				for ( i = 0; i < response.offer.length; i++){
					itemDetailController.listDetailsItemDetails.offers[i].offersDate = util.convertDateToReadableFormatDDwordMM( response.offer[i].validFrom )+  " "+oBundle.getText("to")+" "  + util.convertDateToReadableFormatDDwordMM( response.offer[i].validTo );
				}
				app.getPage(ITEM_DETAIL_PAGE).getContent()[0].getModel().setData(itemDetailController.listDetailsItemDetails);
			}
			else{
				//console.log("NO OFFER FOR ARTICLE");
			}
		}
		else{
			checkErrorMobiliserStatus(response);
		}
	},
	
	
//called from indiivdualShoppingHistory to go reciept details
    launchItemDetailFromIndividualShoppingHistory : function(details){
    	if (app.getPage(ID_ITEM_DETAIL_SHOPPING_HISTORY) == null) {
            var itemDetailView = sap.ui.view({
                type : sap.ui.core.mvc.ViewType.XML,
                viewName : "app.ui.myLists.CheckInItemDetail",
                controller : this
            });
    
            this.oModel = new sap.ui.model.json.JSONModel();
            //this.oModel.setData(itemDetail);
            itemDetailView.setModel(this.oModel);
            
            var itemDetailPage = new sap.m.Page(ID_ITEM_DETAIL_SHOPPING_HISTORY, {
                content : [itemDetailView],
                showNavButton:true,
                title : oBundle.getText("item_details"),
                navButtonText : oBundle.getText("Back_Button"),
                enableScrolling : false,
                navButtonTap : function() {
                    app.back();
                },
                headerContent : [new sap.m.Button({
                	text : oBundle.getText("addItem_addButton"),
                	tap : function(){
                		if(listController == undefined)
                        	listController = sap.ui.controller("app.ui.catalogue.listViewController");
                        listController.launchListPage(details.articleId,details.title,details.description,details.price,details.longdescription);
                	}
                })]
            });
            app.addPage(itemDetailPage);
        }
        offers = [];
        details.offers = offers;
		details.checkInVisibility = true;
		details.fromList = false;
        details.fromCart = true;
        details.id = details.articleId;
        details.entityId = details.articleId;
        util.createBusyDialog(oBundle.getText("Loading"),oBundle.getText("Loading"));
        app.getPage(ID_ITEM_DETAIL_SHOPPING_HISTORY).setTitle(details.title);
        app.getPage(ID_ITEM_DETAIL_SHOPPING_HISTORY).getContent()[0].getModel().setData(details);
        //app.to(ID_ITEM_DETAIL_SHOPPING_HISTORY);
        SmartphoneService.getOffersForArticle(details, checkInItemDetailsController.articleOfferShoppingHistoryBack);
    },
    articleOfferShoppingHistoryBack : function(response, status){
		if (status != 200) {
			checkErrorStatus(status);
			return;
		}
		else if( isRESTStatusCodeCorrect(response) ) {
			var details = app.getPage(ID_ITEM_DETAIL_SHOPPING_HISTORY).getContent()[0].getModel().getData(); 
			if (response.offer != null) {
				details.offers = response.offer;
				for ( i = 0; i < response.offer.length; i++){
					details.offers[i].offersDate = util.convertDateToReadableFormatDDwordMM( response.offer[i].validFrom )+ " to " + util.convertDateToReadableFormatDDwordMM( response.offer[i].validTo );
				}
				details.offerVisible = true;
			}
			else
				details.offerVisible = false;
			details.quantityVisible = false;
			checkInItemDetailsController.shoppingHistoryItemDetails = details;
			app.getPage(ID_ITEM_DETAIL_SHOPPING_HISTORY).setTitle(details.title);
	        app.getPage(ID_ITEM_DETAIL_SHOPPING_HISTORY).getContent()[0].getModel().setData(details);
	        app.to(ID_ITEM_DETAIL_SHOPPING_HISTORY);
	        util.closeBusyDialog();
		}
		else{
			checkErrorMobiliserStatus(response);
		}
	},
	displayOfferDetails : function(oControlEvent){
		var currentPageData = oControlEvent.getSource().getBindingContext().getProperty();
		//console.log(currentPageData);
	       if(allOffersController == undefined){
	    	   allOffersController = sap.ui.controller('app.ui.offers.allOffersController');
	       }
	       if (itemDetailController == undefined) {
               itemDetailController = sap.ui.controller("app.ui.myLists.CheckInItemDetailController");
           }
	        if (app.getPage("CouponItemDetailsPage") == null) {
	            var couponDetailView = sap.ui.view({
	                type : sap.ui.core.mvc.ViewType.XML,
	                viewName : "app.ui.offers.couponDetailView",
	                id : "couponItemDetailsDetailView",
	                controller : this
	            });


	            var headerBar = new sap.m.Bar({
	                        contentLeft : [ new sap.m.Button(
	                                {
	                                    text : oBundle.getText("Back_Button"),
	                                    type : sap.m.ButtonType.Back,
	                                    tap : function() {
	                                        
	                                        app.back();
	                                        
	                                    }
	                                }) ],
	                        contentMiddle : [ new sap.m.Label("offerItemDetailsDetailLabel", 
	                                {
	                                    text : ""
	                                }) ],
	                        contentRight : [ new sap.m.Button('offerItemDetailsDetailMapButton',
	                                {
			                        	icon : "sap-icon://map",
										activeIcon : "sap-icon://map",
	                                    tap : function(event, src) {
	                                        if (userState['DEMO_MODE'] == true) {
	                                            logError("demo_mode_message","In Demo Mode","Not Supported In Demo Mode");
	                                            return;
	                                        }
	                                        if (mapController == undefined) {
	                                            mapController = sap.ui.controller("app.ui.googleMaps.mapController");
	                                            // mapController =
	                                            // sap.ui.controller("app.ui.storelocator.map");
	                                        }
	                                        mapController.programId = allOffersController.currentProgramId;
	                                        mapController.previousPage = COUPON_DETAIL_PAGE;
	                                        mapController.updateMyLocation();
	                                        mapController.launchPage();
	                                    }
	                                }) ]
	                    });

	            var button1ios = new sap.m.Button('couponItemDetailsDetailButton1iOS',
	                    {
	                        text : oBundle.getText("want"),
	                        type : sap.m.ButtonType.Default,
	                        width : "100px",
	                        icon : "app/ui/offers/images/want-heart-button-up.png",
	                        activeIcon : "app/ui/offers/images/want-heart-button-red-ios.png",
	                        enabled : true,
	                        tap : function(event) {
	                            button1ios.fireEvent("iosButtonActiveRemove");
	                            if (userState['DEMO_MODE'] == true) {
	                                logError("demo_mode_message","In Demo Mode","Not Supported In Demo Mode");
	                                return;
	                            }
	                            if(userState['LOGGED_IN']){
	                            	itemDetailController.wantOfferCall();
	                            	//itemDetailController.getOffersAfterWant();
	                            }
	                            else {
	                                    /*homeController.notLoggedInToPage = "Offers";
	                                    if (homepageController==undefined){
	                                        homepageController = sap.ui.controller("app.ui.login.login");
	                                    }   
	                                    launchLoginPage();*/
	                            	//console.log("Not logged in");
	                            }
	                                
	                        }
	                    });

	            var button1 = new sap.m.Button('couponItemDetailsDetailButton1',
	                    {
	                        text : oBundle.getText("want"),
	                        type : sap.m.ButtonType.Default,
	                        icon : "app/ui/offers/images/want-heart-button-up.png",
	                        activeIcon : "app/ui/offers/images/want-heart-button-down.png",
	                        enabled : true,
	                        tap : function(event) {
	                            if (userState['DEMO_MODE'] == true) {
	                                logError("demo_mode_message","In Demo Mode","Not Supported In Demo Mode");
	                                return;
	                            }
	                            if(userState['LOGGED_IN']){
	                            	itemDetailController.wantOfferCall();
	                            	//itemDetailController.getOffersAfterWant();
	                            }
	                            else {
	                                 /*homeController.notLoggedInToPage = "Offers";
	                                    if (homepageController==undefined){
	                                        homepageController = sap.ui.controller("app.ui.login.login");
	                                    }   
	                                    launchLoginPage();*/
	                            	//console.log("Not logged in");
	                            }
	                        }
	                    });

	            var button2 = new sap.m.Button('couponItemDetailsDetailButton2',
	                    {
	                        text : oBundle.getText("share"),
	                        type : sap.m.ButtonType.Default,
	                        icon : "app/ui/offers/images/share-icon-button-up.png",
	                        activeIcon : "app/ui/offers/images/share-icon-button-down.png",
	                        enabled : true,
	                        tap : function(event) {
	                            if (userState['DEMO_MODE'] == true) {
	                                logError("demo_mode_message","In Demo Mode","Not Supported In Demo Mode");
	                                return;
	                            }
	                            allOffersController.shareOffer();
	                        }
	                    });
	            var footer;
	            if (window.cordova && window.device.platform === "iOS") {
	                footer = new sap.m.Bar('couponItemDetailsDetailFooterBar',
	                        {
	                            contentMiddle : [ button1ios, button2 ],
	                                      enableFlexBox : true
	                        });
	            } else {
	                footer = new sap.m.Bar('couponItemDetailsDetailFooterBar',
	                        {
	                            contentLeft : [],
	                            contentMiddle : [ button1, button2 ],
	                            contentRight : [],
	                            enableFlexBox : true
	                        });
	            }

	            var couponDetailPage = new sap.m.Page("CouponItemDetailsPage",{
	                        title : "Single Offer",
	                        content : [ couponDetailView ],
	                        showNavButton : false,
	                        customHeader : headerBar,
	                        footer : footer
	                    });
	            couponDetailPage.addStyleClass("customFooter");
	            couponDetailPage.addStyleClass("offerDetails");
	            this.couponDetailModel = new sap.ui.model.json.JSONModel();
	            couponDetailPage.setModel(this.couponDetailModel);
	            app.addPage(couponDetailPage);
	        }
	        if(userState['LOGGED_IN']){
	        	var programLogo;
	        	if(homeController.modelData.brandMode == "single")
	        		programLogo = itemDetailController.getProgramImageFromProgramId(currentPageData.programId);
	        	else
	        		programLogo = itemDetailController.getProgramImageFromProgramId(currentPageData.programId);
	        }
	        else
	            var programLogo = null;
	        var isHighlight = true;

	        if (currentPageData.highlight == null) {
	            isHighlight = false;
	        }
	        if (currentPageData.isWanted == null) {
	        	currentPageData.isWanted = false;
	        }
	        if (currentPageData.isExpiring == null) {
	        	currentPageData.isExpiring = false;
	        }
	        if (currentPageData.isNew == null) {
	        	currentPageData.isNew = false;
	        }
	        var tempCaption;
	        if(currentPageData.caption == null){
	            tempCaption = "";
	        }
	        else
	            tempCaption = currentPageData.caption.toUpperCase();
	        var validFrom = itemDetailController.convertOfferDatesToReadableFormat(currentPageData.validFrom);
			var validTo = itemDetailController.convertOfferDatesToReadableFormat(currentPageData.validTo);
			var validTime = validFrom + " " + validTo;
	        couponDetailData = {
	        		offerId : currentPageData.offerId,
	        		amountPointsNeeded : currentPageData.amountPointsNeeded,
	                caption : tempCaption,
	                highlight : currentPageData.highlight,
	                description : currentPageData.description,
	                subCaption : currentPageData.subCaption,
	                couponImage : currentPageData.image,
	                isWanted : currentPageData.isWanted,
	                isExpiring : currentPageData.isExpiring,
	                isFeatured : currentPageData.isFeatured,
	                isNew : currentPageData.isNew,
	                imageSource : "",
	                programId : currentPageData.programId,
	                thumbUrl : currentPageData.thumbUrl,
	                url : currentPageData.url,
	                validTime : validTime,
	                programLogo : programLogo,
	                isHighlight : isHighlight,
	                couponTypeid : currentPageData.couponTypeid,
	                operationMode : currentPageData.operationMode
	        };
	        allOffersController.currentCouponTypeid = couponDetailData.couponTypeid;
	        if (couponDetailData.isWanted !== false) {
	            couponDetailData.imageSource = "sap-icon://electrocardiogram";
	            //sap.ui.getCore().byId("couponDetailButton1iOS").addStyleClass("sapmbtnactive");
	        }
	        else if (couponDetailData.isExpiring !== false) {
	            couponDetailData.imageSource = "sap-icon://history";
	        }
	        else if (couponDetailData.isNew !== false) {
	            couponDetailData.imageSource = "sap-icon://lightbulb";
	        }
	        app.getPage("CouponItemDetailsPage").getContent()[0].getModel().setData(couponDetailData);
	        
	        if(userState['LOGGED_IN']){
	        	
        		var programName = itemDetailController.getProgramNameFromProgramId(couponDetailData.programId);
        		app.getPage("CouponItemDetailsPage").getCustomHeader().getContentMiddle()[0].setText(programName);
	        	
	        }
	        else
	        	app.getPage("CouponItemDetailsPage").getCustomHeader().getContentMiddle()[0].setText(couponDetailData.caption);

	        
	        app.to("CouponItemDetailsPage");
	        if (couponDetailData.isWanted === true) {
	            sap.ui.getCore().byId("couponItemDetailsDetailButton1").addStyleClass("sapmbtnactive");
	            sap.ui.getCore().byId("couponItemDetailsDetailButton1iOS").addStyleClass("sapmbtnactive");
	            sap.ui.getCore().byId("couponItemDetailsDetailButton1").setIcon("app/ui/offers/images/want-heart-button-down.png");
	            sap.ui.getCore().byId("couponItemDetailsDetailButton1iOS").setIcon("app/ui/offers/images/want-heart-button-red-ios.png");
	        } else {
	            sap.ui.getCore().byId("couponItemDetailsDetailButton1").removeStyleClass("sapmbtnactive");
	            sap.ui.getCore().byId("couponItemDetailsDetailButton1iOS").removeStyleClass("sapmbtnactive");
	            sap.ui.getCore().byId("couponItemDetailsDetailButton1").setIcon("app/ui/offers/images/want-heart-button-up.png");
	            sap.ui.getCore().byId("couponItemDetailsDetailButton1iOS").setIcon("app/ui/offers/images/want-heart-button-up.png");
	        }
	        var wantedIcon = app.getPage("CouponItemDetailsPage").getContent()[0].byId("wantedIconHolder");
			wantedIcon.rerender();
		
	},
	getProgramNameFromProgramId : function(programId) {
		var programName = "";
		for (i in subscribedPrograms) {
			if (subscribedPrograms[i].programId == programId) {
				programName = subscribedPrograms[i].programName;
				break;
			}
		}
		return programName;
	},
   getProgramImageFromProgramId : function(programId) {
		var programImage = "";
		for (i in subscribedPrograms) {
			if (subscribedPrograms[i].programId == programId) {
				if (userState['DEMO_MODE'] == true)
					programImage = subscribedPrograms[i].logo;
				else
					programImage = "data:image/png;base64,"+ subscribedPrograms[i].logo;
				break;
			}
		}
		//console.log(programImage);
		return programImage;
	},
	convertDateToReadableFormat : function(dateinms) {
		if (dateinms == null)
			return null;
		var newDate = new Date(dateinms);
		var dateOfMonth = newDate.getDate();
		var val = newDate.toDateString();
		var month_name = val.substr(val.indexOf(" ") + 1, 3).toLowerCase();
		// Bad way to get the month names. Dont want to change the strings file as may break SLS way of adding the names
		if (month_name === "jun") {
			month_name = "june";
		} else if (month_name === "jul") {
			month_name = "july";
		}
		var month = oBundle.getText("month_" + month_name);
		month = month.substr(0, 3);
		month = month.charAt(0).toUpperCase() + month.slice(1);
		return month + " " + dateOfMonth;
	},

	convertOfferDatesToReadableFormat : function(date) {
		var formatedDate = itemDetailController.convertDateToReadableFormat(date);
		return formatedDate;
	},
	wantOfferCall : function() {
		var wnatedData = app.getCurrentPage().getContent()[0].getModel().getData();
		if (wnatedData.isWanted === true)
			util.createBusyDialog(oBundle.getText("Offers_Progress_Message"),oBundle.getText("offer_removed_from_wanted"));
		else
			util.createBusyDialog(oBundle.getText("Offers_Progress_Message"),oBundle.getText("offer_set_as_wanted"));
		var wantOfferCallData = {
			couponTypeid : wnatedData.couponTypeid,
			amountPointsNeeded : wnatedData.amountPointsNeeded,
			offerId : wnatedData.offerId,
			couponCaption : wnatedData.caption
		};
		SmartphoneService.wantOffer(wantOfferCallData,itemDetailController.wantOfferBack);
		
	},
	wantOfferBack : function(response, status) {
		if (status != 200) {
			checkErrorStatus(status);
			return;
		}
		if (isRESTStatusCodeCorrect(response)) {
			util.closeBusyDialog();
			if(allOffersController != undefined && allOffersController.dataOffers){
				for ( var i = 0; i < allOffersController.dataOffers.length; i++) {
					
					if (allOffersController.dataOffers[i].couponTypeid == allOffersController.currentCouponTypeid) {
						// No need to do this for different cards data as the offer object is being referenced in card data also.
						// So a change here will be reflected in the cards offers as well.
						allOffersController.dataOffers[i].isWanted = !allOffersController.dataOffers[i].isWanted;
						
						/*var pageData = app.getCurrentPage().getContent()[0].getModel().getData();
						pageData.isWanted = allOffersController.dataOffers[i].isWanted;*/
						allOffersController.dataOffers[i].imageSource = "";
						//pageData.imageSource = "";
	
						if (allOffersController.dataOffers[i].isWanted !== false) {
							allOffersController.dataOffers[i].imageSource = "sap-icon://electrocardiogram";
							//pageData.imageSource = "sap-icon://electrocardiogram";
						}
						else if (allOffersController.dataOffers[i].isExpiring !== false) {
							allOffersController.dataOffers[i].imageSource = "sap-icon://history";
							//pageData.imageSource = "sap-icon://history";
						}
						else if (allOffersController.dataOffers[i].isNew !== false) {
							allOffersController.dataOffers[i].imageSource = "sap-icon://lightbulb";
							//pageData.imageSource = "sap-icon://lightbulb";
						}
						else {
							allOffersController.dataOffers[i].imageSource = "";
							//pageData.imageSource = "";
						}
	
						//allOffersController.couponDetailModel.setData(pageData);
						//app.getCurrentPage().getContent()[0].getModel().setData(pageData);
						var wantedIcon = app.getCurrentPage().getContent()[0].byId("wantedIconHolder");
						wantedIcon.rerender();
						allOffersController.dataOffers[i].couponInstanceid = response.offer.couponInstanceid;
						allOffersController.dataOffers[i].strCode = response.offer.strCode;
						allOffersController.dataOffers[i].serialNumber = response.offer.serialNumber;
					}
				}
			}
			if(app.getPreviousPage().sId == ITEM_DETAIL_PAGE){
				for(var j = 0 ; j < itemDetailController.listDetailsItemDetails.offers.length ; j++){
					if (itemDetailController.listDetailsItemDetails.offers[j].couponTypeid == allOffersController.currentCouponTypeid) {
						// No need to do this for different cards data as the offer object is being referenced in card data also.
						// So a change here will be reflected in the cards offers as well.
						var pageData = app.getCurrentPage().getContent()[0].getModel().getData();
						itemDetailController.listDetailsItemDetails.offers[j].isWanted = !itemDetailController.listDetailsItemDetails.offers[j].isWanted;
						pageData.isWanted = itemDetailController.listDetailsItemDetails.offers[j].isWanted;
						if (itemDetailController.listDetailsItemDetails.offers[j].isWanted === true) {
							sap.ui.getCore().byId("couponItemDetailsDetailButton1").addStyleClass("sapmbtnactive");
							sap.ui.getCore().byId("couponItemDetailsDetailButton1iOS").addStyleClass("sapmbtnactive");
							sap.ui.getCore().byId("couponItemDetailsDetailButton1").setIcon("app/ui/offers/images/want-heart-button-down.png");
							sap.ui.getCore().byId("couponItemDetailsDetailButton1iOS").setIcon("app/ui/offers/images/want-heart-button-red-ios.png");
	
						} 
						else {
							sap.ui.getCore().byId("couponItemDetailsDetailButton1").removeStyleClass("sapmbtnactive");
							sap.ui.getCore().byId("couponItemDetailsDetailButton1iOS").removeStyleClass("sapmbtnactive");
							sap.ui.getCore().byId("couponItemDetailsDetailButton1").setIcon("app/ui/offers/images/want-heart-button-up.png");
							sap.ui.getCore().byId("couponItemDetailsDetailButton1iOS").setIcon("app/ui/offers/images/want-heart-button-up.png");
							
						}
						
						/*var pageData = app.getCurrentPage().getContent()[0].getModel().getData();
						pageData.isWanted = allOffersController.dataOffers[j].isWanted;*/
						itemDetailController.listDetailsItemDetails.offers[j].imageSource = "";
						pageData.imageSource = "";
						//pageData.imageSource = "";
	
						if (itemDetailController.listDetailsItemDetails.offers[j].isWanted !== false) {
							itemDetailController.listDetailsItemDetails.offers[j].imageSource = "sap-icon://electrocardiogram";
							pageData.imageSource = "sap-icon://electrocardiogram";
							//pageData.imageSource = "sap-icon://electrocardiogram";
						}
						else if (itemDetailController.listDetailsItemDetails.offers[j].isExpiring !== false) {
							itemDetailController.listDetailsItemDetails.offers[j].imageSource = "sap-icon://history";
							pageData.imageSource = "sap-icon://history";
							//pageData.imageSource = "sap-icon://history";
						}
						else if (itemDetailController.listDetailsItemDetails.offers[j].isNew !== false) {
							itemDetailController.listDetailsItemDetails.offers[j].imageSource = "sap-icon://lightbulb";
							pageData.imageSource = "sap-icon://lightbulb";
							//pageData.imageSource = "sap-icon://lightbulb";
						}
						else {
							itemDetailController.listDetailsItemDetails.offers[j].imageSource = "";
							pageData.imageSource = "";
							//pageData.imageSource = "";
						}
	
						//allOffersController.couponDetailModel.setData(pageData);
						app.getCurrentPage().getContent()[0].getModel().setData(pageData);
						var wantedIcon = app.getCurrentPage().getContent()[0].byId("wantedIconHolder");
						wantedIcon.rerender();
					}
				}
			}
			if(app.getPreviousPage().sId == ID_CHECK_IN_ITEM_DETAILS){
				for(var j = 0 ; j < checkInItemDetailsController.listDetailsItemDetails.offers.length ; j++){
					if (checkInItemDetailsController.listDetailsItemDetails.offers[j].couponTypeid == allOffersController.currentCouponTypeid) {
						// No need to do this for different cards data as the offer object is being referenced in card data also.
						// So a change here will be reflected in the cards offers as well.
						var pageData = app.getCurrentPage().getContent()[0].getModel().getData();
						checkInItemDetailsController.listDetailsItemDetails.offers[j].isWanted = !checkInItemDetailsController.listDetailsItemDetails.offers[j].isWanted;
						pageData.isWanted = checkInItemDetailsController.listDetailsItemDetails.offers[j].isWanted;
						if (checkInItemDetailsController.listDetailsItemDetails.offers[j].isWanted === true) {
							sap.ui.getCore().byId("couponItemDetailsDetailButton1").addStyleClass("sapmbtnactive");
							sap.ui.getCore().byId("couponItemDetailsDetailButton1iOS").addStyleClass("sapmbtnactive");
							sap.ui.getCore().byId("couponItemDetailsDetailButton1").setIcon("app/ui/offers/images/want-heart-button-down.png");
							sap.ui.getCore().byId("couponItemDetailsDetailButton1iOS").setIcon("app/ui/offers/images/want-heart-button-red-ios.png");
	
						} 
						else {
							sap.ui.getCore().byId("couponItemDetailsDetailButton1").removeStyleClass("sapmbtnactive");
							sap.ui.getCore().byId("couponItemDetailsDetailButton1iOS").removeStyleClass("sapmbtnactive");
							sap.ui.getCore().byId("couponItemDetailsDetailButton1").setIcon("app/ui/offers/images/want-heart-button-up.png");
							sap.ui.getCore().byId("couponItemDetailsDetailButton1iOS").setIcon("app/ui/offers/images/want-heart-button-up.png");
							
						}
						
						/*var pageData = app.getCurrentPage().getContent()[0].getModel().getData();
						pageData.isWanted = allOffersController.dataOffers[j].isWanted;*/
						checkInItemDetailsController.listDetailsItemDetails.offers[j].imageSource = "";
						pageData.imageSource = "";
						//pageData.imageSource = "";
	
						if (checkInItemDetailsController.listDetailsItemDetails.offers[j].isWanted !== false) {
							checkInItemDetailsController.listDetailsItemDetails.offers[j].imageSource = "sap-icon://electrocardiogram";
							pageData.imageSource = "sap-icon://electrocardiogram";
							//pageData.imageSource = "sap-icon://electrocardiogram";
						}
						else if (checkInItemDetailsController.listDetailsItemDetails.offers[j].isExpiring !== false) {
							checkInItemDetailsController.listDetailsItemDetails.offers[j].imageSource = "sap-icon://history";
							pageData.imageSource = "sap-icon://history";
							//pageData.imageSource = "sap-icon://history";
						}
						else if (checkInItemDetailsController.listDetailsItemDetails.offers[j].isNew !== false) {
							checkInItemDetailsController.listDetailsItemDetails.offers[j].imageSource = "sap-icon://lightbulb";
							pageData.imageSource = "sap-icon://lightbulb";
							//pageData.imageSource = "sap-icon://lightbulb";
						}
						else {
							checkInItemDetailsController.listDetailsItemDetails.offers[j].imageSource = "";
							pageData.imageSource = "";
							//pageData.imageSource = "";
						}
	
						//allOffersController.couponDetailModel.setData(pageData);
						app.getCurrentPage().getContent()[0].getModel().setData(pageData);
						var wantedIcon = app.getCurrentPage().getContent()[0].byId("wantedIconHolder");
						wantedIcon.rerender();
					}
				}
			}
			if(app.getPreviousPage().sId == ID_ITEM_DETAIL_SHOPPING_HISTORY){
				for(var j = 0 ; j < checkInItemDetailsController.shoppingHistoryItemDetails.offers.length ; j++){
					if (checkInItemDetailsController.shoppingHistoryItemDetails.offers[j].couponTypeid == allOffersController.currentCouponTypeid) {
						// No need to do this for different cards data as the offer object is being referenced in card data also.
						// So a change here will be reflected in the cards offers as well.
						var pageData = app.getCurrentPage().getContent()[0].getModel().getData();
						checkInItemDetailsController.shoppingHistoryItemDetails.offers[j].isWanted = !checkInItemDetailsController.shoppingHistoryItemDetails.offers[j].isWanted;
						pageData.isWanted = checkInItemDetailsController.shoppingHistoryItemDetails.offers[j].isWanted;
						if (checkInItemDetailsController.shoppingHistoryItemDetails.offers[j].isWanted === true) {
							sap.ui.getCore().byId("couponItemDetailsDetailButton1").addStyleClass("sapmbtnactive");
							sap.ui.getCore().byId("couponItemDetailsDetailButton1iOS").addStyleClass("sapmbtnactive");
							sap.ui.getCore().byId("couponItemDetailsDetailButton1").setIcon("app/ui/offers/images/want-heart-button-down.png");
							sap.ui.getCore().byId("couponItemDetailsDetailButton1iOS").setIcon("app/ui/offers/images/want-heart-button-red-ios.png");
	
						} 
						else {
							sap.ui.getCore().byId("couponItemDetailsDetailButton1").removeStyleClass("sapmbtnactive");
							sap.ui.getCore().byId("couponItemDetailsDetailButton1iOS").removeStyleClass("sapmbtnactive");
							sap.ui.getCore().byId("couponItemDetailsDetailButton1").setIcon("app/ui/offers/images/want-heart-button-up.png");
							sap.ui.getCore().byId("couponItemDetailsDetailButton1iOS").setIcon("app/ui/offers/images/want-heart-button-up.png");
							
						}
						
						/*var pageData = app.getCurrentPage().getContent()[0].getModel().getData();
						pageData.isWanted = allOffersController.dataOffers[j].isWanted;*/
						checkInItemDetailsController.shoppingHistoryItemDetails.offers[j].imageSource = "";
						pageData.imageSource = "";
						//pageData.imageSource = "";
	
						if (checkInItemDetailsController.shoppingHistoryItemDetails.offers[j].isWanted !== false) {
							checkInItemDetailsController.shoppingHistoryItemDetails.offers[j].imageSource = "sap-icon://electrocardiogram";
							pageData.imageSource = "sap-icon://electrocardiogram";
							//pageData.imageSource = "sap-icon://electrocardiogram";
						}
						else if (checkInItemDetailsController.shoppingHistoryItemDetails.offers[j].isExpiring !== false) {
							checkInItemDetailsController.shoppingHistoryItemDetails.offers[j].imageSource = "sap-icon://history";
							pageData.imageSource = "sap-icon://history";
							//pageData.imageSource = "sap-icon://history";
						}
						else if (checkInItemDetailsController.shoppingHistoryItemDetails.offers[j].isNew !== false) {
							checkInItemDetailsController.shoppingHistoryItemDetails.offers[j].imageSource = "sap-icon://lightbulb";
							pageData.imageSource = "sap-icon://lightbulb";
							//pageData.imageSource = "sap-icon://lightbulb";
						}
						else {
							checkInItemDetailsController.shoppingHistoryItemDetails.offers[j].imageSource = "";
							pageData.imageSource = "";
							//pageData.imageSource = "";
						}
	
						//allOffersController.couponDetailModel.setData(pageData);
						app.getCurrentPage().getContent()[0].getModel().setData(pageData);
						var wantedIcon = app.getCurrentPage().getContent()[0].byId("wantedIconHolder");
						wantedIcon.rerender();
					}
				}
			}
		} else {
			checkErrorMobiliserStatus(response);
		}
		
	},
});
