sap.ui.controller("app.ui.myLists.addItem", {
    searchbar : null,
    
    pageModel : {
        itemList:[{
            title : "Eggs - John Farms",
            certification: "",
            quantity : 0,
            price : "$2.99" ,
            notes : "",
            description : "Now $2.99",
            isChecked : false,
        },{
            title : "Eggs - Organic Valley",
            certification: "",
            quantity : 0,
            price : "$5.99",
            notes : "",
            description : "$5.59  1 offer",
            isChecked : false,
        },{
            title : "Bacon",
            certification: "",
            quantity : 0,
            price : "$3.50 lb",
            notes : "",
            description : "2 offer",
            isChecked : false,
        },{
            title : "Milk",
            certification: "",
            quantity : 0,
            price : "$1000.00",
            notes : "",
            description : "",
            isChecked : false,
        }]
    },
    
    launchAddItemPage : function(details){
        var header = null;
    
        if (app.getPage(ADD_ITEM_LIST_PAGE) == null) {

            var listDetailView = sap.ui.view({
                  type : sap.ui.core.mvc.ViewType.XML,
                  viewName : "app.ui.myLists.addItem",
                  id : "addItemView",
                  controller : this
            });
            
            this.oModel = new sap.ui.model.json.JSONModel();
            this.oModel.setData(addItemListController.pageModel);
            listDetailView.setModel(this.oModel);
            
            header = new sap.m.Bar({
                contentRight : [new sap.m.Button({
                    tap : function(event, src) {
                        addItemListController.addItemToList();
                    },
                    text : oBundle.getText("addItem_addButton"),
                })],
                contentMiddle : [new sap.m.Label({
                    text : oBundle.getText("list_add_item"),
                })],
                contentLeft : [new sap.m.Button({
                    text :  oBundle.getText("cancel"),
                    tap : function(event, src) {
                        app.back();
                    }
                })]
            });
            
            addItemListController.searchbar = new sap.m.SearchField('searchBarAddListItem',{
                search : this.search,
            });
        
            var searchContainer = new sap.m.Bar("searchBarWrapperAddListItem", {
                contentMiddle : [addItemListController.searchbar]
            });
            addItemListController.searchBar = searchContainer;
            //subHeader : searchContainer,
            var listDetailPage = new sap.m.Page(ADD_ITEM_LIST_PAGE, {
                customHeader : header,
                
                content : [listDetailView],
            });
            
            app.addPage(listDetailPage);
        }
        if (myListController.listAdd) {
            myListController.listAdd = false;
            header = new sap.m.Bar({
                contentRight : [new sap.m.Button({
                    tap : function(event, src) {
                        addItemListController.addItemtoNewList();
                    },
                    //TODO: translation text
                    text : oBundle.getText("Save_Text")
                })],
                contentMiddle : [new sap.m.Label({
                    text : oBundle.getText("list_add_item"),
                })],
                contentLeft : [new sap.m.Button({
                    text :  oBundle.getText("cancel"),
                    tap : function(event, src) {
                        myListController.listAdd = false;
                        app.back();
                    }
                })]
            });
        }
        else{
            header = new sap.m.Bar({
                contentRight : [new sap.m.Button('addItemToListButton', {
                    tap : function(event, src) {
                        addItemListController.addItemToList();
                    },
                    text : oBundle.getText("addItem_addButton"),
                })],
                contentMiddle : [new sap.m.Label("addItemTitle", {
                    text : oBundle.getText("list_add_item"),
                })],
                contentLeft : [new sap.m.Button('menuButtonAddItem', {
                    text :  oBundle.getText("cancel"),
                    tap : function(event, src) {
                        app.back();
                    }
                })]
            });
        }
        
        app.getPage(ADD_ITEM_LIST_PAGE).getContent()[0].getModel().setData(addItemListController.pageModel);
        app.getPage(ADD_ITEM_LIST_PAGE).setCustomHeader(header);
        app.to(ADD_ITEM_LIST_PAGE);
    },
    search: function(oControlEvent){
        
    },
    checkItem : function(oControlEvent) {
        var item = oControlEvent.getParameters().listItem;
        var data = item.getBindingContext().getObject();
        data.isChecked = item.isSelected();
    },
    addItemtoNewList : function(){
        if (newListController == undefined) {
            newListController = sap.ui.controller("app.ui.myLists.newListController");
        }
        newListController.launchNewListPage(addItemListController.pageModel);
    },
    addItemToList : function(){
        for (i=0; addItemListController.pageModel.itemList.length >i ; i++){
            if (addItemListController.pageModel.itemList[i].isChecked ){
                listData.list[listDetailController.listID-1].detail.push(addItemListController.pageModel.itemList[i]);
            }
        }
        //after add, need to rerender/bind pages
        if (listDetailController == undefined) {
            listDetailController = sap.ui.controller("app.ui.myLists.listDetailController");
        }
        if (listDetailController.emptyPage == false) {
            app.getPage(LIST_DETAIL_PAGE).getContent()[0].getModel().setData(listData.list[listDetailController.listID-1]);
            app.getPage(LIST_DETAIL_PAGE).rerender();
            app.backToPage(LIST_DETAIL_PAGE);
        }
        else {
            listDetailController.launchListDetailPage(listData.list[listDetailController.listID-1]);
        }
        
    },
});