
isListOrCart = "Cart"; //Global variable to identify whether the flow is through checkIn or my list.
sap.ui.controller('app.ui.myLists.checkIn', {
    //JSON data for initial screen in checkIn process.
		myStore : {
        storeDetail: {
            name :  null,
            additionalInfo : null,
            generalHours: null,
            storeId: null,
            address:{
                shortAddress : null,
                formattedAddress: null,
                address2 : null,
                city : null,
                stateZip : null,
                url: null,
                businessPhone: null,
            },
        },
    },
		
		selfScanning : false,
		mobilePayment : false,
		checkInEnabled : false,
        isPOSToScanForTransfer : false,

    //Initial screen of CheckIn.
		launchCheckInPage : function() { 
				if (app.getPage(ID_CHECK_IN) == null) {
					var checkInView = sap.ui.view({
						type : sap.ui.core.mvc.ViewType.XML,
						viewName : "app.ui.myLists.checkIn",
						controller : checkInController
					});
				
				var checkInModel = new sap.ui.model.json.JSONModel();
				checkInController.myStore.storeDetail.address.address2 = checkInController.myStore.storeDetail.address.city + ", " + checkInController.myStore.storeDetail.address.stateZip;
				checkInModel.setData(checkInController.myStore);
                checkInView.setModel(checkInModel);
					
				header = new sap.m.Bar({
						contentMiddle : [ new sap.m.Label("checkInTitle", {
							// TODO: add to translation file
							text : oBundle.getText("check_in")
						}) ],
						contentLeft : [ new sap.m.Button('menuButtonCheckIn', {
							icon : "sap-icon://menu2",
							activeIcon : "sap-icon://menu2",
							tap : function(event, src) {
								sliderMenuController.action('menuButtonCheckIn');
							}
						}).addStyleClass("menuButtonIconFont") ]
				});
		
				var checkInPage = new sap.m.Page(ID_CHECK_IN, {
						customHeader : header,
						title : oBundle.getText("check_in"),
						content : [ checkInView ]
					});
					app.addPage(checkInPage);
				}
				util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
				SmartphoneService.getPreferredStoreForMember("no obj needed", checkInController.getPreferredStoreBack);
		},
        
        getPreferredStoreBack: function(response,status){
                if (status != 200) {
                        checkErrorStatus(status);
                        return;
                } else if (isRESTStatusCodeCorrect(response)) {
                    if (response.PreferredStoreDetails) {
                    	checkInController.selfScanning = response.PreferredStoreDetails.isSelfScanningEnabled;
						checkInController.mobilePayment = response.PreferredStoreDetails.isMobilePaymentEnabled;
						checkInController.checkInEnabled = response.PreferredStoreDetails.isCheckInEabled;
						checkInController.isPOSToScanForTransfer = response.PreferredStoreDetails.isPOSToScanForTransfer;
                            checkInController.updateStoreModel(response.PreferredStoreDetails);
                    }
                    else{
                    	//Clearing the previous data.
                    	var tempData = {
                    			storeDetail : {
                    				name : "",
                    				storeId : "",
                    				address : {
                    					shortAddress : "",
                    					formattedAddress : oBundle.getText("no_store_set"),
                    					address2 : "",
                    					city : "",
                    					stateZip : "",
                    					url : "",
                    					businessPhone : ""
                    				}
                    			}
                    	};
                        app.getPage(ID_CHECK_IN).getContent()[0].getModel().setData(tempData);
                        //Clear the previous users store details.
                    	checkInController.myStore.storeDetail.storeId = null;
                        
                    	checkInController.customDialog = new sap.m.Dialog({
                            title: oBundle.getText("Warning"), type : "Message",
                            content : [
                                new sap.m.Text({
                                        text: oBundle.getText("set_prefered_store"),
                                        textAlign : "Center",
                                        wrapping : true
                                }),
                                new sap.m.Button({
                                    text: oBundle.getText("OK"),
                                    type: sap.m.ButtonType.Accept,
                                    width: "100%",
                                    tap : function() {
                                        checkInController.customDialog.close();
                                        //no default store set
                                        if (mapController == undefined) {
                                                mapController = sap.ui.controller("app.ui.googleMaps.mapController");
                                        }
                                        if (storeLocatorListController == undefined) {
                                            storeLocatorListController = sap.ui.controller("app.ui.storelocator.list");
                                        }
                                        storeLocatorListController.launchPage( ID_CHECK_IN );   
                                    }
                                }),
                            ]
                        });
                        checkInController.customDialog.open();
                    }    
                    util.closeBusyDialog();
                    app.to(ID_CHECK_IN);
                }
                else {
                    checkErrorMobiliserStatus(response);
                    util.closeBusyDialog();
                }
        },
        
		//Function called when checkIn button is pressed to select shopping list.
		checkIn : function() {
			
			if(checkInController.checkInEnabled == true) {
                var storeId = app.getPage(ID_CHECK_IN).getContent()[0].getModel().getData();
                var obj = {
                        storeId : checkInController.myStore.storeDetail.storeId,
                };
				util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
                SmartphoneService.getStoreCheckinInfo( obj, checkInController.checkInBack);
			}
			else {
				
				util.alertDialog( oBundle.getText("checkIn_disabled") );
			}
				
		},
        checkInBack : function(response, status){
                if (status != 200) {
						checkErrorStatus(status);
						return;
				}
				else if( isRESTStatusCodeCorrect(response) ) {
						util.closeBusyDialog();
						checkInController.selfScanning = response.storeCheckinInfo.isSelfScanningEnabled;
						checkInController.mobilePayment = response.storeCheckinInfo.isMobilePaymentEnabled;
						checkInController.checkInEnabled = response.storeCheckinInfo.isCheckInEabled;
						checkInController.isPOSToScanForTransfer = response.storeCheckinInfo.isPOSToScanForTransfer;
                        checkInController.updateStoreModel(response.storeDetails);
                        if (checkInSelectMyListsController == undefined) {
                            checkInSelectMyListsController = sap.ui.controller("app.ui.myLists.checkInSelectMyLists");
                        }
                        checkInSelectMyListsController.launchCheckInSelectMyListsPage();
						
				}
				else{
						checkErrorMobiliserStatus(response);
						util.closeBusyDialog();
				}
        },
		// Method to select a new store.
		notYourStore : function(){
				/*  mapcontroller instantiated if not already to stores list is not empty 
				 *  MUST KEEP until service is completed
				 */
				if(userState.DEMO_MODE){
					alert(oBundle.getText("feature_not_supported"));
					return;
				}else{
					if (mapController == undefined) {
							mapController = sap.ui.controller("app.ui.googleMaps.mapController");
					}
					if (storeLocatorListController == undefined) {
						storeLocatorListController = sap.ui.controller("app.ui.storelocator.list");
					}
					storeLocatorListController.launchPage( ID_CHECK_IN );
				}
		},
        updateStoreModel : function(response){
                if (response !== null) {
					var preferredStore = response;
                    var tempData = app.getPage(ID_CHECK_IN).getContent()[0].getModel().getData();
                        tempData.storeDetail.name = preferredStore.name;
                        tempData.storeDetail.storeId = preferredStore.id;
                        checkInController.myStore.storeDetail.storeId = preferredStore.id;
                        if(preferredStore.address !== null) {
                        	tempData.storeDetail.address.shortAddress = preferredStore.address.street1 + ", " +
                                                                    preferredStore.address.city + ", " +
                                                                    preferredStore.address.state + ", " +
                                                                    preferredStore.address.zip;
                        	tempData.storeDetail.address.formattedAddress = preferredStore.address.street1 ;
                        	tempData.storeDetail.address.address2 = preferredStore.address.city + ", " +
                                                                preferredStore.address.state + " " +
                                                                preferredStore.address.zip;
                        	tempData.storeDetail.address.city = preferredStore.address.city;
                        	tempData.storeDetail.address.stateZip = preferredStore.address.state + " " +preferredStore.address.zip;
                        	tempData.storeDetail.address.url = preferredStore.address.url;
                        	tempData.storeDetail.address.businessPhone = preferredStore.address.businessPhone;
                		}
						
                        app.getPage(ID_CHECK_IN).getContent()[0].getModel().setData(tempData); 
						
							
                }
				else {
					var preferredStore = response;
                    var tempData = app.getPage(ID_CHECK_IN).getContent()[0].getModel().getData();
					tempData.storeDetail.address.formattedAddress = oBundle.getText("no_store_set");
					tempData.storeDetail.address.address2 = "";
					 app.getPage(ID_CHECK_IN).getContent()[0].getModel().setData(tempData); 
				}
        },
        
        updateStoreBack : function(response, status){
                if (status != 200) {
                        checkErrorStatus(status);
                        return;
                } else if (isRESTStatusCodeCorrect(response)) {
						util.closeBusyDialog();
						checkInController.selfScanning = response.storeCheckinInfo.isSelfScanningEnabled;
						checkInController.mobilePayment = response.storeCheckinInfo.isMobilePaymentEnabled;
						checkInController.checkInEnabled = response.storeCheckinInfo.isCheckInEabled;
						checkInController.isPOSToScanForTransfer = response.storeCheckinInfo.isPOSToScanForTransfer;
                        checkInController.updateStoreModel(response.storeDetails);
                        app.getPage(ID_CHECK_IN).rerender();
                        app.backToPage(ID_CHECK_IN);
                }
                else {
                        checkErrorMobiliserStatus(response);
						util.closeBusyDialog();
                }
        },
		checkInScan : function() { // 
				if (!window.plugins)
						window.plugins = {};
				if (window.plugins.barcodeScanner == undefined) {
						window.plugins.barcodeScanner = new BarcodeScanner();
				}
				else {
						//console.log("Not installing barcodeScanner: window.plugins.barcodeScanner already exists")
				}
				if (window.cordova && window.device.name != "iPhone Simulator"){
                        //iOS barcode scan
						if (window.device.platform == "iOS"){
                            //console.warn("scanning for iOS");
                            window.plugins.barcodeScanner.scan(
                                function(result) {
                                    if (result.cancelled){
                                        //console.warn("RESULT TEXT: " + result.text);
                                        //console.warn("RESULT FORMAT: " + result.format);
                                        //console.warn("FORMAT CANCELLED: " + result.cancelled);
                                        //console.warn("the user cancelled the scan");
                                    }
                                    else{
                                        //console.warn("GOT BARCODE");
                                        //console.warn("RESULT TEXT: " + result.text);
                                        //console.warn("RESULT FORMAT: " + result.format);
                                        //console.warn("FORMAT CANCELLED: " + result.cancelled);
                                        
                                        if (result.text == "ManualEntry" && result.format =="Manual" ) {
                                            //display dialog with popup
                                            util.createCustomScanDialog( "storeCheckIn" );
                                        }
                                        else{
                                            //scan image to add to list
                                            var obj = {
                                                storeCode : result.text,
                                            };
                                            util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
                                            SmartphoneService.getStoreCheckinInfo( obj, checkInController.checkInScanBack);
                                        }
                                    }
                                },
                                function(error) {
                                    alert("scanning failed: " + error)
                                },
                                ["BarcodeOverlay"]
                            );
                        }
                        //Android barcode scan
                        else if (window.device.platform == "Android"){
                            //console.log("On Android device");
                            window.plugins.barcodeScanner.scan(
                                function(result) {
                                    if (result.cancelled){
                                        //open dialog ask if want to scan
                                        util.createAndroidManualEntryPrompt( "storeCheckIn" );
                                    }
                                    else{
                                        //console.warn("GOT BARCODE");
                                        //console.warn("RESULT TEXT: " + result.text);
                                        //console.warn("RESULT FORMAT: " + result.format);
                                        //console.warn("FORMAT CANCELLED: " + result.cancelled);
                                        //scan image to add to list
                                        var obj = {
                                            storeCode : result.text,
                                        }
                                        util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
                                        SmartphoneService.getStoreCheckinInfo( obj, checkInController.checkInScanBack);
                                    }
                                },
                                function(error) {
                                    alert("scanning failed: " + error)
                                }
                            );
                        }
				}
				else{
                    util.createCustomScanDialog( "storeCheckIn" );
                    var storeId = app.getPage(ID_CHECK_IN).getContent()[0].getModel().getData();
                    var obj = {
                            storeCode : storeId.storeDetail.storeId,
                    };
                    //console.warn(obj.storeCode)
				}
		},
		checkInScanBack : function (response, status){
				if (status != 200) {
						checkErrorStatus(status);
						return;
				}
				else if( isRESTStatusCodeCorrect(response) ) {
						util.closeBusyDialog();
						checkInController.selfScanning = response.storeCheckinInfo.isSelfScanningEnabled;
						checkInController.mobilePayment = response.storeCheckinInfo.isMobilePaymentEnabled;
						checkInController.checkInEnabled = response.storeCheckinInfo.isCheckInEabled;
						checkInController.isPOSToScanForTransfer = response.storeCheckinInfo.isPOSToScanForTransfer;
						checkInController.updateStoreModel(response.storeDetails);
						
						if (checkInSelectMyListsController == undefined) {
								checkInSelectMyListsController = sap.ui.controller("app.ui.myLists.checkInSelectMyLists");
						}
						checkInSelectMyListsController.launchCheckInSelectMyListsPage();
				}
                else if (response.Status.code == 201) {
                    util.closeBusyDialog();
                    logError( oBundle.getText("item_not_found"), "Barcode Not Found", "Barcode Not Found");
                }
				else{	
						checkErrorMobiliserStatus(response);
						util.closeBusyDialog();
				}
		},
		
//		updateStoreData : function(response) {
//			if (response.storeDetails !== undefined) {
//                  if (response.storeDetails !== null) {
//                    var storeDetails = response.storeDetails;
//                    var tempData = app.getPage(ID_CHECK_IN).getContent()[0].getModel().getData();
//                    tempData.storeDetail.name = storeDetails.name;
//                    tempData.storeDetail.storeId = storeDetails.id;
//                    if(storeDetails.address !== null) {
//                    	tempData.storeDetail.address.shortAddress = storeDetails.address.street1 + ", " +
//                    	storeDetails.address.city + ", " +
//                    	storeDetails.address.state + ", " +
//                    	storeDetails.address.zip;
//                    	tempData.storeDetail.address.formattedAddress = storeDetails.address.street1 ;
//                    	tempData.storeDetail.address.address2 = storeDetails.address.city + ", " +
//                    	storeDetails.address.state + " " +
//                    	storeDetails.address.zip;
//                    	tempData.storeDetail.address.city = storeDetails.address.city;
//                    	tempData.storeDetail.address.stateZip = storeDetails.address.state + " " +storeDetails.address.zip;
//                    	tempData.storeDetail.address.url = storeDetails.address.url;
//                    	tempData.storeDetail.address.businessPhone = storeDetails.address.businessPhone;
//            		}
//					checkInController.selfScanning = response.storeDetails.isSelfScanningEnabled;
//					checkInController.mobilePayment = response.storeDetails.isCheckInEabled;
//					checkInController.checkInEabled = response.storeDetails.isMobilePaymentEnabled;
//                    app.getPage(ID_CHECK_IN).getContent()[0].getModel().setData(tempData); 
//                  }
//                  else {
//                    var storeDetails = response.storeDetails;
//                    var tempData = app.getPage(ID_CHECK_IN).getContent()[0].getModel().getData();
//                    tempData.storeDetail.address.formattedAddress = oBundle.getText("no_store_set");
//                    tempData.storeDetail.address.address2 = "";
//                    app.getPage(ID_CHECK_IN).getContent()[0].getModel().setData(tempData);
//                  }
//            }
//			
//		}
});
