
sap.ui.controller('app.ui.myLists.checkInStoreOffers', {
	offers : {
		inStoreOffers : [],
		wantedOffers : [],
		inStoreOffersVisible : true,
		wantedOffersVisible : false,
		isCartVisible : false,
		isListVisible : false,
		offerItemSelected : "",
		inOffers : [],
	},
	storeId : "",
	couponInstanceid : [],
	launchCheckInStoreOffers: function(){
		
		//SmartphoneService.getStoreOffers("no obj needed", checkInStoreOffersController.getStoreOffersBack);
		if(app.getPage(ID_CHECK_IN_STORE_OFFERS_PAGE) == null)
		{
			var storeOffersButton = new sap.m.Button({
				text : oBundle.getText("store_offers"),
				tap : function(){
					checkInStoreOffersController.offers.wantedOffersVisible = false;
					checkInStoreOffersController.offers.inStoreOffersVisible = true;
					//checkInStoreOffersController.navigateToCheckInOfferspage();
					checkInStoreOffersController.getOffers();
				},
				
			});
			var wantedOffersButton = new sap.m.Button({
				text : oBundle.getText("wanted_offers"),
				tap : function(){
					checkInStoreOffersController.offers.wantedOffersVisible = true;
					checkInStoreOffersController.offers.inStoreOffersVisible = false;
					/*if(checkInStoreOffersController.offers.wantedOffers.length > 0)
						app.getPage(ID_CHECK_IN_STORE_OFFERS_PAGE).getContent()[0].getModel().setData(checkInStoreOffersController.offers);
					else*/
					//checkInStoreOffersController.getWantedOffers();
					checkInStoreOffersController.getOffers();
				},
				
			});
			var segmentedOffersButton = new sap.m.SegmentedButton({
				buttons : [storeOffersButton,wantedOffersButton],
				width : "100%",
				selectedButton : storeOffersButton
			});
			var header = new sap.m.Bar({
                contentMiddle : [new sap.m.Label({
                    //TODO: add to translation file
                    text : oBundle.getText("offers_word")
                })],
                contentLeft : [new sap.m.Button({
                    icon: "sap-icon://menu2",
                    activeIcon: "sap-icon://menu2",
                    tap : function(event, src) {
                        sliderMenuController.action('menuButtonCheckIn');
                    }
                }).addStyleClass("menuButtonIconFont")],
                contentRight : []
            });
			var checkInStoreOffersView = sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.myLists.checkInStoreOffers",
				controller : checkInStoreOffersController
			});
			
			var checkInStoreOffersPage = new sap.m.Page(ID_CHECK_IN_STORE_OFFERS_PAGE, {
				title : "",
				content : [ checkInStoreOffersView ],
				customHeader : header,
				subHeader : new sap.m.Bar("inStoreOffersOptions",{
					enableFlexBox : true,
					contentMiddle : [segmentedOffersButton],
					width : "100%"
				}),
			});
			checkInStoreOffersPage.addStyleClass("customSegmentedBar");
			checkInStoreOffersPage.addStyleClass("inStoreOffers");
			var checkInStoreOffersModel = new sap.ui.model.json.JSONModel();
			checkInStoreOffersView.setModel(checkInStoreOffersModel);

			app.addPage(checkInStoreOffersPage);
			/*var footer = app.getPage(ID_CHECK_IN_SHOPPING).getFooter();
			checkInStoreOffersPage.setFooter(footer);*/
			if(checkInShoppingController.listItemSelected.isScanVisible){
				checkInStoreOffersPage.setFooter(checkInShoppingController.footerBar);
			}
			else{
				checkInStoreOffersPage.setFooter(checkInShoppingController.footerBarWithoutCart);
			}
		}
		app.to(ID_CHECK_IN_STORE_OFFERS_PAGE,"show");
	},
	//Navigation to offers screen in the check in scenario. To add wanted and store offers to the cart.
	navigateToCheckInOfferspage : function(){
		if(allOffersController == undefined){
    	   allOffersController = sap.ui.controller('app.ui.offers.allOffersController');
       }
		if(app.getPage(ID_CHECK_IN_STORE_OFFERS_PAGE) == null)
		{
			if(checkInStoreOffersController == undefined)
				checkInStoreOffersController = sap.ui.controller('app.ui.myLists.checkInStoreOffers');
			checkInStoreOffersController.launchCheckInStoreOffers();
		}
		var inStroeOffersCount = 0;
		
		for(var i = 0 ; i < checkInStoreOffersController.offers.wantedOffers.length ; i++){
			if(checkInStoreOffersController.offers.wantedOffers[i].inStore != undefined){
				inStroeOffersCount = 1;
				break;
			}
		}
		if(checkInStoreOffersController.offers.inStoreOffers.length > 0)
			inStroeOffersCount = 1;
		//Call getStoreOffers() once check-in is in process.
		if(inStroeOffersCount == 0){
			util.createBusyDialog(oBundle.getText("Offers_Progress_Message"),oBundle.getText("Offers_Progress_Message_Title"));
			SmartphoneService.getStoreOffers(checkInShoppingController.storeId, checkInStoreOffersController.getStoreOffersBack);
		}
		else{
			if(checkInStoreOffersController.offers.wantedOffersVisible)
	    		checkInStoreOffersController.offers.inOffers = checkInStoreOffersController.offers.wantedOffers;
	    	else
	    		checkInStoreOffersController.offers.inOffers = checkInStoreOffersController.offers.inStoreOffers;
	    	checkInStoreOffersController.offers.inOfferVIsible = true;
	    	app.getPage(ID_CHECK_IN_STORE_OFFERS_PAGE).getContent()[0].getModel().setData(checkInStoreOffersController.offers);
		}
		if(checkInShoppingController.listItemSelected.isScanVisible){
			app.getPage(ID_CHECK_IN_STORE_OFFERS_PAGE).setFooter(checkInShoppingController.footerBar);
		}
		else{
			app.getPage(ID_CHECK_IN_STORE_OFFERS_PAGE).setFooter(checkInShoppingController.footerBarWithoutCart);
		}
		app.to(ID_CHECK_IN_STORE_OFFERS_PAGE,"show");
    },
    getOffers : function(){
    	for(var i = 0 ; i < checkInStoreOffersController.offers.inStoreOffers.length ; i++){
    		if(checkInStoreOffersController.offers.inStoreOffers[i].isWanted){
    			var found = 0;
    			for( var j = 0 ; j < checkInStoreOffersController.offers.wantedOffers.length ; j++){
    				if(checkInStoreOffersController.offers.wantedOffers[j].couponTypeid == checkInStoreOffersController.offers.inStoreOffers[i].couponTypeid){
    					if(checkInStoreOffersController.offers.wantedOffers[j].inStore == undefined)
    						checkInStoreOffersController.offers.wantedOffers[j].inStore = true;
    					found = 1;
    					break;
    				}
    			}
    			if(found == 0)
    				checkInStoreOffersController.offers.wantedOffers.push(checkInStoreOffersController.offers.inStoreOffers[i]);
    			checkInStoreOffersController.offers.inStoreOffers.splice(i,1);
    		}
    		
    	}
    	for(var i = 0 ; i < checkInStoreOffersController.offers.wantedOffers.length ; i++){
    		if(checkInStoreOffersController.offers.wantedOffers[i].inStore != undefined){
	    		if(!checkInStoreOffersController.offers.wantedOffers[i].isWanted){
	    			checkInStoreOffersController.offers.inStoreOffers.push(checkInStoreOffersController.offers.wantedOffers[i]);
	    			checkInStoreOffersController.offers.wantedOffers.splice(i,1);
	    		}
    		}
    	}
    	for(var i = 0 ; i < checkInStoreOffersController.offers.wantedOffers.length ; i++){
    		
	    		if(!checkInStoreOffersController.offers.wantedOffers[i].isWanted){
	    			//checkInStoreOffersController.offers.inStoreOffers.push(checkInStoreOffersController.offers.wantedOffers[i]);
	    			checkInStoreOffersController.offers.wantedOffers.splice(i,1);
	    		}
    		
    	}

    	if(checkInStoreOffersController.offers.wantedOffersVisible)
    		checkInStoreOffersController.offers.inOffers = checkInStoreOffersController.offers.wantedOffers;
    	else
    		checkInStoreOffersController.offers.inOffers = checkInStoreOffersController.offers.inStoreOffers;
    	checkInStoreOffersController.offers.inOfferVIsible = true;
    	    	app.getPage(ID_CHECK_IN_STORE_OFFERS_PAGE).getContent()[0].getModel().setData(checkInStoreOffersController.offers);
    	//app.getPage(ID_CHECK_IN_STORE_OFFERS_PAGE).getContent()[0].getModel().setData(checkInStoreOffersController.offers);
    },
    getWantedOffers : function(){
		/*checkInStoreOffersController.offers.wantedOffers = [];
		checkInStoreOffersController.offers.inStoreOffers = [];*/
    	if(allOffersController != undefined){
	    	for(var h = 0 ; h < checkInStoreOffersController.offers.inStoreOffers.length ; h++){
	    		if(checkInStoreOffersController.offers.inStoreOffers[h].isWanted)
	    			var found = 0;
	    			for(var t = 0 ;t < checkInStoreOffersController.offers.wantedOffers.length ; t++){
	    				if(checkInStoreOffersController.offers.wantedOffers[t].couponTypeid == checkInStoreOffersController.offers.inStoreOffers[h].couponTypeid)
	    					found = 1;
	    			}
	    			if(found == 0)
	    				checkInStoreOffersController.offers.wantedOffers.push(checkInStoreOffersController.offers.inStoreOffers[h]);
	    		
	    	}
	    	var temp = checkInStoreOffersController.offers.wantedOffers;
	    	checkInStoreOffersController.offers.wantedOffers = [];
	    	for(var i = 0 ; i < temp.length ; i++){
	    		if(temp[i].isWanted){
	    			
	    					checkInStoreOffersController.offers.wantedOffers.push(temp[i]);
	    			
	    		}
	    	}
			for ( var i = 0; i < allOffersController.dataOffers.length; i++) {
				var wantOffer = {};
				
				if(allOffersController.dataOffers[i].isWanted){
					var programLogo;
					if(userState['LOGGED_IN'])
		                programLogo = allOffersController.getProgramImageFromProgramId(allOffersController.dataOffers[i].programId);
		            else
		                programLogo = null;
		            var isHighlight = true;
	
		            if (allOffersController.dataOffers[i].isHighlight == null) {
		                isHighlight = false;
		            }
		            var tempCaption;
		            if(allOffersController.dataOffers[i].caption == null){
		                tempCaption = "";
		            }
		            else
		                tempCaption = allOffersController.dataOffers[i].caption.toUpperCase();
		            wantOffer.offerId = allOffersController.dataOffers[i].offerId;
		            wantOffer.amountPointsNeeded = allOffersController.dataOffers[i].amountPointsNeeded;
					wantOffer.caption = tempCaption;
					wantOffer.couponInstanceid = allOffersController.dataOffers[i].couponInstanceid;
					wantOffer.description = allOffersController.dataOffers[i].description;
					wantOffer.subCaption = allOffersController.dataOffers[i].subCaption;
					wantOffer.highlight = allOffersController.dataOffers[i].highlight;
					wantOffer.couponImage = allOffersController.dataOffers[i].couponImage;
					wantOffer.isWanted = allOffersController.dataOffers[i].isWanted;
					wantOffer.isExpiring = allOffersController.dataOffers[i].isExpiring;
					wantOffer.isFeatured = allOffersController.dataOffers[i].isFeatured;
					wantOffer.isNew = allOffersController.dataOffers[i].isNew;
					wantOffer.imageSource = "";
					wantOffer.programId = allOffersController.dataOffers[i].programId;
					wantOffer.thumbUrl = allOffersController.dataOffers[i].thumbUrl;
					wantOffer.url = allOffersController.dataOffers[i].url;
					wantOffer.image = allOffersController.dataOffers[i].image;
					wantOffer.validTime = allOffersController.dataOffers[i].validTime;
					wantOffer.programLogo = programLogo;
					wantOffer.isHighlight = isHighlight;
					wantOffer.couponTypeid = allOffersController.dataOffers[i].couponTypeid;
					if (wantOffer.isWanted !== false) {
						wantOffer.imageSource = "sap-icon://electrocardiogram";
						//sap.ui.getCore().byId("couponDetailButton1iOS").addStyleClass("sapmbtnactive");
					}
					else if (wantOffer.isExpiring !== false) {
						wantOffer.imageSource = "sap-icon://history";
					}
					else if (wantOffer.isNew !== false) {
						wantOffer.imageSource = "sap-icon://lightbulb";
					}
					else{
						wantOffer.imageSource = "";
					}
					var found = 0;
					for(var j = 0 ;j < checkInStoreOffersController.offers.wantedOffers.length ;j++){
						if(checkInStoreOffersController.offers.wantedOffers[j].couponTypeid == wantOffer.couponTypeid)
							found = 1;
					}
					if(found == 0)
						checkInStoreOffersController.offers.wantedOffers.push(wantOffer);
				}
			}
			checkInStoreOffersController.formateCheckInWantedOffers();
			checkInStoreOffersController.getOffers();
    	}
    	else
    		checkInStoreOffersController.offers.wantedOffers = [];
	},
	
	getStoreOffersBack :function(response,status){
		if(isRESTStatusCodeCorrect(response)){
			var offers = response.offer;
			for(var i=0; i< offers.length;i++){
				if(userState['LOGGED_IN'])
	                var programLogo = allOffersController.getProgramImageFromProgramId(offers[i].programId);
	            else
	                var programLogo = null;
	            var isHighlight = true;

	            if (offers[i].isHighlight == null) {
	                isHighlight = false;
	            }
	            var tempCaption;
	            if(offers[i].caption == null){
	                tempCaption = "";
	            }
	            else
	                tempCaption = offers[i].caption.toUpperCase();
				var storeOffer = {
						offerId : offers[i].offerId,
						amountPointsNeeded : offers[i].amountPointsNeeded,
						caption : tempCaption,
						couponInstanceid : offers[i].couponInstanceid,
						description : offers[i].description,
						subCaption : offers[i].subCaption,
						highlight : offers[i].highlight,
						couponImage : offers[i].couponImage,
						isWanted : offers[i].isWanted,
						isExpiring : offers[i].isExpiring,
						isFeatured : offers[i].isFeatured,
						isNew : offers[i].isNew,
						imageSource : "",
						programId : offers[i].programId,
						thumbUrl : offers[i].thumbUrl,
						url : offers[i].url,
						image : offers[i].image,
						validTime : offers[i].validTime,
						programLogo : programLogo,
						isHighlight : isHighlight,
						couponTypeid : offers[i].couponTypeid,
				};
				var validFrom = allOffersController.convertOfferDatesToReadableFormat(offers[i].validFrom);
				var validTo = allOffersController.convertOfferDatesToReadableFormat(offers[i].validTo);
				storeOffer.validTime = validFrom + " " + validTo;
				if(!storeOffer.isExpiring)
					storeOffer.isExpiring = false;
				if(!storeOffer.isWanted)
					storeOffer.isWanted = false;
				if(!storeOffer.isNew)
					storeOffer.isNew = false;
	            if (storeOffer.isWanted !== false) {
	            	storeOffer.imageSource = "sap-icon://electrocardiogram";
					//sap.ui.getCore().byId("couponDetailButton1iOS").addStyleClass("sapmbtnactive");
				}
				else if (storeOffer.isExpiring !== false) {
					storeOffer.imageSource = "sap-icon://history";
				}
				else if (storeOffer.isNew !== false) {
					storeOffer.imageSource = "sap-icon://lightbulb";
				}
				else{
					storeOffer.imageSource = "";
				}
	            checkInStoreOffersController.offers.inStoreOffers.push(storeOffer);	
			}
			checkInStoreOffersController.formateCheckInStoreOffers();
			checkInStoreOffersController.getWantedOffers();
    		checkInStoreOffersController.getOffers();
		}
		else{
			//console.log("get store offers error");
		}
		util.closeBusyDialog();
	},
	formateCheckInStoreOffers : function(){
		for(var i = 0 ; i < checkInStoreOffersController.offers.inStoreOffers.length ; i++){
			if(checkInStoreOffersController.offers.inStoreOffers[i].inCart == undefined){
				if(checkInShoppingController.listItemSelected.isScanVisible)
					checkInStoreOffersController.offers.inStoreOffers[i].inCart = true;
				else
					checkInStoreOffersController.offers.inStoreOffers[i].inCart = false;
				checkInStoreOffersController.offers.inStoreOffers[i].operationMode = oBundle.getText("add_to_cart");
			}
			if(checkInStoreOffersController.offers.inStoreOffers[i].inStore == undefined)
				checkInStoreOffersController.offers.inStoreOffers[i].inStore = true;
		}
	},
	formateCheckInWantedOffers : function(){
		for(var i = 0 ; i < checkInStoreOffersController.offers.wantedOffers.length ; i++){
			if(checkInStoreOffersController.offers.wantedOffers[i].inCart == undefined){
				if(checkInShoppingController.listItemSelected.isScanVisible)
					checkInStoreOffersController.offers.wantedOffers[i].inCart = true;
				else
					checkInStoreOffersController.offers.wantedOffers[i].inCart = false;
				checkInStoreOffersController.offers.wantedOffers[i].operationMode = oBundle.getText("add_to_cart");
			}
		}
	},
	itemOperation : function(ev){
		if(checkInStoreOffersController.offers.wantedOffersVisible)
			checkInStoreOffersController.itemWantedOperation(ev);
		else
			checkInStoreOffersController.itemOffersOperation(ev);
	},
	itemOffersOperation: function(ev){
		checkInStoreOffersController.couponInstanceid = [];
		var selectedOffer = ev.getSource();
		checkInStoreOffersController.offerItemSelected = selectedOffer.getBindingContext().getProperty(selectedOffer.getBindingContext().getPath());
		util.createBusyDialog();
		for(var i = 0 ; i < checkInStoreOffersController.offers.inStoreOffers.length ; i++){
			//TODO need to replace the caption comparison with offerId
			if(checkInStoreOffersController.offerItemSelected.couponTypeid == checkInStoreOffersController.offers.inStoreOffers[i].couponTypeid){
				if(checkInStoreOffersController.offers.inStoreOffers[i].operationMode == oBundle.getText("add_to_cart")){
					
					checkInStoreOffersController.couponInstanceid.push(checkInStoreOffersController.offers.inStoreOffers[i].couponInstanceid);
					var  body = {
							/*couponInstanceid : checkInStoreOffersController.couponInstanceid,*/
							storeId : checkInShoppingController.storeId,
							amountPointsNeeded : checkInStoreOffersController.offers.inStoreOffers[i].amountPointsNeeded,
							couponTypeid : checkInStoreOffersController.offers.inStoreOffers[i].couponTypeid,
							offerId : checkInStoreOffersController.offers.inStoreOffers[i].offerId,
							/*offerCaption : checkInStoreOffersController.offers.inStoreOffers[i].offerCaption*/
					}
					if(checkInStoreOffersController.offers.inStoreOffers[i].offerCaption)
						body.offerCaption = checkInStoreOffersController.offers.inStoreOffers[i].offerCaption;
					else
						body.offerCaption = "";
					if(checkInStoreOffersController.offers.inStoreOffers[i].couponInstanceid != null)
						body.couponInstanceid = checkInStoreOffersController.offers.inStoreOffers[i].couponInstanceid;
					util.createBusyDialog(oBundle.getText("Loading"), oBundle.getText("add_to_cart"));
					SmartphoneService.addCouponsToActiveCheckIn(body,checkInStoreOffersController.offersCallBack);
				}
				else{
					
					checkInStoreOffersController.couponInstanceid.push(checkInStoreOffersController.offers.inStoreOffers[i].couponInstanceid);
					var  body = {
							/*couponInstanceid : checkInStoreOffersController.offers.inStoreOffers[i].couponInstanceid,*/
							storeId : checkInShoppingController.storeId,
							couponTypeid : checkInStoreOffersController.offers.inStoreOffers[i].couponTypeid,
							amountPointsNeeded : checkInStoreOffersController.offers.inStoreOffers[i].amountPointsNeeded,
					}
					if(checkInStoreOffersController.offers.inStoreOffers[i].couponInstanceid != null)
						body.couponInstanceid = checkInStoreOffersController.offers.inStoreOffers[i].couponInstanceid;
					util.createBusyDialog(oBundle.getText("Loading"), oBundle.getText("remove_from_cart"));
					SmartphoneService.removeCouponsFromActiveCheckIn(body,checkInStoreOffersController.offersCallBack);
				}
			}
		}
		//app.getPage(ID_CHECK_IN_STORE_OFFERS_PAGE).getContent()[0].getModel().setData(checkInStoreOffersController.offers);
	},
	itemWantedOperation: function(ev){
		checkInStoreOffersController.couponInstanceid = [];
		var selectedOffer = ev.getSource();
		checkInStoreOffersController.offerItemSelected = selectedOffer.getBindingContext().getProperty(selectedOffer.getBindingContext().getPath());
		util.createBusyDialog();
		for(var i = 0 ; i < checkInStoreOffersController.offers.wantedOffers.length ; i++){
			//TODO need to replace the caption comparison with offerId
			if(checkInStoreOffersController.offerItemSelected.couponTypeid == checkInStoreOffersController.offers.wantedOffers[i].couponTypeid){
				if(checkInStoreOffersController.offers.wantedOffers[i].operationMode == oBundle.getText("add_to_cart")){
					
					checkInStoreOffersController.couponInstanceid.push(checkInStoreOffersController.offers.wantedOffers[i].couponInstanceid);
					var  body = {
							
							storeId : checkInShoppingController.storeId,
							amountPointsNeeded : checkInStoreOffersController.offers.wantedOffers[i].amountPointsNeeded,
							couponTypeid : checkInStoreOffersController.offers.wantedOffers[i].couponTypeid,
							offerId : checkInStoreOffersController.offers.wantedOffers[i].offerId,
					}
					/*if(checkInStoreOffersController.couponInstanceid)
						body.couponInstanceid = checkInStoreOffersController.couponInstanceid;*/
					if(checkInStoreOffersController.offers.wantedOffers[i].offerCaption)
						body.offerCaption = checkInStoreOffersController.offers.wantedOffers[i].offerCaption;
					else
						body.offerCaption = "";
					if(checkInStoreOffersController.offers.wantedOffers[i].couponInstanceid != null)
						body.couponInstanceid = checkInStoreOffersController.offers.wantedOffers[i].couponInstanceid;
					util.createBusyDialog(oBundle.getText("Loading"), oBundle.getText("add_to_cart"));
					SmartphoneService.addCouponsToActiveCheckIn(body,checkInStoreOffersController.wantCallBack);
				}
				else{
					util.createBusyDialog(oBundle.getText("Loading"), oBundle.getText("remove_from_cart"));
					checkInStoreOffersController.couponInstanceid.push(checkInStoreOffersController.offers.wantedOffers[i].couponInstanceid);
					var  body = {
							//couponInstanceid : checkInStoreOffersController.couponInstanceid,
							storeId : checkInShoppingController.storeId,
							amountPointsNeeded : checkInStoreOffersController.offers.wantedOffers[i].amountPointsNeeded,
							couponTypeid : checkInStoreOffersController.offers.wantedOffers[i].couponTypeid,
					}
					if(checkInStoreOffersController.offers.wantedOffers[i].couponInstanceid != null)
						body.couponInstanceid = checkInStoreOffersController.offers.wantedOffers[i].couponInstanceid;
					SmartphoneService.removeCouponsFromActiveCheckIn(body,checkInStoreOffersController.wantCallBack);
				}
				
			}
		}
		
		//app.getPage(ID_CHECK_IN_STORE_OFFERS_PAGE).getContent()[0].getModel().setData(checkInStoreOffersController.offers);
	},
	offersCallBack : function(response,status){
		
		if(isRESTStatusCodeCorrect(response)){
			
			if(util.isShoppingSessionExpired(response)){
				return;
			}
			
			for(var i = 0 ; i < checkInStoreOffersController.offers.inStoreOffers.length ; i++){
				if(checkInStoreOffersController.offerItemSelected.caption == checkInStoreOffersController.offers.inStoreOffers[i].caption){
					if(checkInStoreOffersController.offers.inStoreOffers[i].operationMode == oBundle.getText("add_to_cart")){
						if(checkInShoppingController.listItemSelected.isScanVisible)
							checkInStoreOffersController.offers.inStoreOffers[i].inCart = true;
						else
							checkInStoreOffersController.offers.inStoreOffers[i].inCart = false;
						checkInStoreOffersController.offers.inStoreOffers[i].operationMode = oBundle.getText("remove_from_cart");
						
					}
					else{
						if(checkInShoppingController.listItemSelected.isScanVisible)
							checkInStoreOffersController.offers.inStoreOffers[i].inCart = true;
						else
							checkInStoreOffersController.offers.inStoreOffers[i].inCart = false;
						checkInStoreOffersController.offers.inStoreOffers[i].operationMode = oBundle.getText("add_to_cart");
						
					}
				}
			}
			app.getPage(ID_CHECK_IN_STORE_OFFERS_PAGE).getContent()[0].getModel().setData(checkInStoreOffersController.offers);
			
		}
		else{
			//console.log("Error while performing operation on cart");
			logError( oBundle.getText("unexpected_error"), "status code not handled in checkErrorMobiliserStatus", "unknown component");
		}
		util.closeBusyDialog();
	},
	wantCallBack : function(response,status){
		if(isRESTStatusCodeCorrect(response)){
			
			if(util.isShoppingSessionExpired(response)){
				return;
			}
			
			for(var i = 0 ; i < checkInStoreOffersController.offers.wantedOffers.length ; i++){
				if(checkInStoreOffersController.offerItemSelected.caption == checkInStoreOffersController.offers.wantedOffers[i].caption){
					if(checkInStoreOffersController.offers.wantedOffers[i].operationMode == oBundle.getText("add_to_cart")){
						if(checkInShoppingController.listItemSelected.isScanVisible)
							checkInStoreOffersController.offers.wantedOffers[i].inCart = true;
						else
							checkInStoreOffersController.offers.wantedOffers[i].inCart = false;
						checkInStoreOffersController.offers.wantedOffers[i].operationMode = oBundle.getText("remove_from_cart");
						
					}
					else{
						if(checkInShoppingController.listItemSelected.isScanVisible)
							checkInStoreOffersController.offers.wantedOffers[i].inCart = true;
						else
							checkInStoreOffersController.offers.wantedOffers[i].inCart = false;
						checkInStoreOffersController.offers.wantedOffers[i].operationMode = oBundle.getText("add_to_cart");
						
					}
					
				}
			}
			app.getPage(ID_CHECK_IN_STORE_OFFERS_PAGE).getContent()[0].getModel().setData(checkInStoreOffersController.offers);
			
		}
		else{
			//console.log("Error while performing operation on cart");
			logError( oBundle.getText("unexpected_error"), "status code not handled in checkErrorMobiliserStatus", "unknown component");
		}
		util.closeBusyDialog();
	},
	displayCheckInOfferDetails : function(oControlEvent){
	       var currentPageData = oControlEvent.getSource().getBindingContext().getProperty();
	       if(allOffersController == undefined){
	    	   allOffersController = sap.ui.controller('app.ui.offers.allOffersController');
	       }
	        if (app.getPage("CouponCheckInOffersPage") == null) {
	            var couponDetailView = sap.ui.view({
	                type : sap.ui.core.mvc.ViewType.XML,
	                viewName : "app.ui.offers.couponDetailView",
	                id : "couponCheckInOffersDetailView",
	                controller : this
	            });


	            var headerBar = new sap.m.Bar({
	                        contentLeft : [ new sap.m.Button(
	                                {
	                                    text : oBundle.getText("Back_Button"),
	                                    type : sap.m.ButtonType.Back,
	                                    tap : function() {
	                                        
	                                        app.back();
	                                        
	                                    }
	                                }) ],
	                        contentMiddle : [ new sap.m.Label("offercheckInOffersDetailLabel", 
	                                {
	                                    text : ""
	                                }) ],
	                        contentRight : [ new sap.m.Button('offercheckInOffersDetailMapButton',
	                                {
	                                    icon : "sap-icon://map",
	                                    activeIcon : "sap-icon://map",
	                                    tap : function(event, src) {
	                                        if (userState['DEMO_MODE'] == true) {
	                                            logError("demo_mode_message","In Demo Mode","Not Supported In Demo Mode");
	                                            return;
	                                        }
	                                        if (mapController == undefined) {
	                                            mapController = sap.ui.controller("app.ui.googleMaps.mapController");
	                                            // mapController =
	                                            // sap.ui.controller("app.ui.storelocator.map");
	                                        }
	                                        mapController.programId = allOffersController.currentProgramId;
	                                        mapController.previousPage = "CouponCheckInOffersPage";
	                                        mapController.updateMyLocation();
	                                        mapController.launchPage();
	                                    }
	                                }) ]
	                    });

	            var button1ios = new sap.m.Button('couponCheckInOffersDetailButton1iOS',
	                    {
	                        text : oBundle.getText("want"),
	                        type : sap.m.ButtonType.Default,
	                        width : "100px",
	                        icon : "app/ui/offers/images/want-heart-button-up.png",
	                        activeIcon : "app/ui/offers/images/want-heart-button-red-ios.png",
	                        enabled : true,
	                        tap : function(event) {
	                            button1ios.fireEvent("iosButtonActiveRemove");
	                            if (userState['DEMO_MODE'] == true) {
	                                logError("demo_mode_message","In Demo Mode","Not Supported In Demo Mode");
	                                return;
	                            }
	                            if(userState['LOGGED_IN']){
	                            	checkInStoreOffersController.wantOfferCall();
	                            	//checkInStoreOffersController.getOffersAfterWant();
	                            }
	                            else {
	                            	//console.log("Not logged in");
	                            }
	                                
	                        }
	                    });

	            var button1 = new sap.m.Button('couponCheckInOffersDetailButton1',
	                    {
	                        text : oBundle.getText("want"),
	                        type : sap.m.ButtonType.Default,
	                        icon : "app/ui/offers/images/want-heart-button-up.png",
	                        activeIcon : "app/ui/offers/images/want-heart-button-down.png",
	                        enabled : true,
	                        tap : function(event) {
	                            if (userState['DEMO_MODE'] == true) {
	                                logError("demo_mode_message","In Demo Mode","Not Supported In Demo Mode");
	                                return;
	                            }
	                            if(userState['LOGGED_IN']){
	                            	checkInStoreOffersController.wantOfferCall();
	                            	//checkInStoreOffersController.getOffersAfterWant();
	                            }
	                            else {
	                            	//console.log("Not logged in");
	                            }
	                        }
	                    });

	            var button2 = new sap.m.Button('couponCheckInOffersDetailButton2',
	                    {
	                        text : oBundle.getText("share"),
	                        type : sap.m.ButtonType.Default,
	                        icon : "app/ui/offers/images/share-icon-button-up.png",
	                        activeIcon : "app/ui/offers/images/share-icon-button-down.png",
	                        enabled : true,
	                        tap : function(event) {
	                            if (userState['DEMO_MODE'] == true) {
	                                logError("demo_mode_message","In Demo Mode","Not Supported In Demo Mode");
	                                return;
	                            }
	                            allOffersController.shareOffer();
	                        }
	                    });
	            var footer;
	            if (window.cordova && window.device.platform === "iOS") {
	                footer = new sap.m.Bar('couponCheckInOffersDetailFooterBar',
	                        {
	                            contentMiddle : [ button1ios, button2 ],
	                                      enableFlexBox : true
	                        });
	            } else {
	                footer = new sap.m.Bar('couponCheckInOffersDetailFooterBar',
	                        {
	                            contentLeft : [],
	                            contentMiddle : [ button1, button2 ],
	                            contentRight : [],
	                            enableFlexBox : true
	                        });
	            }

	            var couponDetailPage = new sap.m.Page("CouponCheckInOffersPage",{
	                        title : "Single Offer",
	                        content : [ couponDetailView ],
	                        showNavButton : false,
	                        customHeader : headerBar,
	                        footer : footer
	                    });
	            couponDetailPage.addStyleClass("customFooter");
	            couponDetailPage.addStyleClass("offerDetails");
	            this.couponDetailModel = new sap.ui.model.json.JSONModel();
	            couponDetailPage.setModel(this.couponDetailModel);
	            app.addPage(couponDetailPage);
	        }
	        if(userState['LOGGED_IN']){
	        	var programLogo;
	        	programLogo = allOffersController.getProgramImageFromProgramId(currentPageData.programId);
	        	
	        }
	        else
	            var programLogo = null;
	        var isHighlight = true;

	        if (currentPageData.highlight == null) {
	            isHighlight = false;
	        }
	        var tempCaption;
	        if(currentPageData.caption == null){
	            tempCaption = "";
	        }
	        else
	            tempCaption = currentPageData.caption.toUpperCase();
	        couponDetailData = {
	        		offerId : currentPageData.offerId,
	        		amountPointsNeeded : currentPageData.amountPointsNeeded,
	                caption : tempCaption,
	                highlight : currentPageData.highlight,
	                description : currentPageData.description,
	                subCaption : currentPageData.subCaption,
	                couponImage : currentPageData.image,
	                isWanted : currentPageData.isWanted,
	                isExpiring : currentPageData.isExpiring,
	                isFeatured : currentPageData.isFeatured,
	                isNew : currentPageData.isNew,
	                imageSource : "",
	                programId : currentPageData.programId,
	                thumbUrl : currentPageData.thumbUrl,
	                url : currentPageData.url,
	                validTime : currentPageData.validTime,
	                programLogo : programLogo,
	                isHighlight : isHighlight,
	                couponTypeid : currentPageData.couponTypeid,
	                operationMode : currentPageData.operationMode
	        };
	        allOffersController.currentCouponTypeid = couponDetailData.couponTypeid;
	        if (couponDetailData.isWanted !== false) {
	            couponDetailData.imageSource = "sap-icon://electrocardiogram";
	            //sap.ui.getCore().byId("couponDetailButton1iOS").addStyleClass("sapmbtnactive");
	        }
	        else if (couponDetailData.isExpiring !== false) {
	            couponDetailData.imageSource = "sap-icon://history";
	        }
	        else if (couponDetailData.isNew !== false) {
	            couponDetailData.imageSource = "sap-icon://lightbulb";
	        }
	        //homeController.modelData.currentCouponTypeid = currentPageData.couponTypeid;
	        app.getPage("CouponCheckInOffersPage").getContent()[0].getModel().setData(couponDetailData);
	        
	        if(userState['LOGGED_IN']){
	        	if(homeController.modelData.brandMode == "single"){
	        		var programName = allOffersController.getProgramNameFromProgramId(couponDetailData.programId);
	        		app.getPage("CouponCheckInOffersPage").getCustomHeader().getContentMiddle()[0].setText(programName);
	        	}
	        	else{
	        		var programName = allOffersController.getProgramNameFromProgramId(couponDetailData.programId);
	        		app.getPage("CouponCheckInOffersPage").getCustomHeader().getContentMiddle()[0].setText(programName);
	        	}
	        }
	        else
	        	app.getPage("CouponCheckInOffersPage").getCustomHeader().getContentMiddle()[0].setText(couponDetailData.caption);

	        
	        app.to("CouponCheckInOffersPage");
	        if (couponDetailData.isWanted === true) {
	            sap.ui.getCore().byId("couponCheckInOffersDetailButton1").addStyleClass("sapmbtnactive");
	            sap.ui.getCore().byId("couponCheckInOffersDetailButton1iOS").addStyleClass("sapmbtnactive");
	            sap.ui.getCore().byId("couponCheckInOffersDetailButton1").setIcon("app/ui/offers/images/want-heart-button-down.png");
	            sap.ui.getCore().byId("couponCheckInOffersDetailButton1iOS").setIcon("app/ui/offers/images/want-heart-button-red-ios.png");
	        } else {
	            sap.ui.getCore().byId("couponCheckInOffersDetailButton1").removeStyleClass("sapmbtnactive");
	            sap.ui.getCore().byId("couponCheckInOffersDetailButton1iOS").removeStyleClass("sapmbtnactive");
	            sap.ui.getCore().byId("couponCheckInOffersDetailButton1").setIcon("app/ui/offers/images/want-heart-button-up.png");
	            sap.ui.getCore().byId("couponCheckInOffersDetailButton1iOS").setIcon("app/ui/offers/images/want-heart-button-up.png");
	        }
	        var wantedIcon = app.getPage("CouponCheckInOffersPage").getContent()[0].byId("wantedIconHolder");
			wantedIcon.rerender();
	   },
		wantOfferCall : function() {
			var wnatedData = app.getCurrentPage().getContent()[0].getModel().getData();
			if (wnatedData.isWanted === true)
				util.createBusyDialog(oBundle.getText("Offers_Progress_Message"),oBundle.getText("offer_removed_from_wanted"));
			else
				util.createBusyDialog(oBundle.getText("Offers_Progress_Message"),oBundle.getText("offer_set_as_wanted"));
			var wantOfferCallData = {
				couponTypeid : wnatedData.couponTypeid,
				amountPointsNeeded : wnatedData.amountPointsNeeded,
				offerId : wnatedData.offerId,
				couponCaption : wnatedData.caption
			};
			if(wnatedData.operationMode == oBundle.getText("add_to_cart"))
				SmartphoneService.wantOffer(wantOfferCallData,checkInStoreOffersController.wantOfferBack);
			else{
				logError(oBundle.getText("remove_item_before_unwant"),"Please remove the item from cart before unwanting the offer","Remove item from cart before unwanting offer");;
				app.back();
				util.closeBusyDialog();
			}
		},
		wantOfferBack : function(response, status) {
			if (status != 200) {
				checkErrorStatus(status);
				return;
			}
			if (isRESTStatusCodeCorrect(response)) {
				util.closeBusyDialog();
				for ( var i = 0; i < allOffersController.dataOffers.length; i++) {
					
					if (allOffersController.dataOffers[i].couponTypeid == allOffersController.currentCouponTypeid) {
						// No need to do this for different cards data as the offer object is being referenced in card data also.
						// So a change here will be reflected in the cards offers as well.
						allOffersController.dataOffers[i].isWanted = !allOffersController.dataOffers[i].isWanted;
						if (allOffersController.dataOffers[i].isWanted === true) {
							sap.ui.getCore().byId("couponCheckInOffersDetailButton1").addStyleClass("sapmbtnactive");
							sap.ui.getCore().byId("couponCheckInOffersDetailButton1iOS").addStyleClass("sapmbtnactive");
							sap.ui.getCore().byId("couponCheckInOffersDetailButton1").setIcon("app/ui/offers/images/want-heart-button-down.png");
							sap.ui.getCore().byId("couponCheckInOffersDetailButton1iOS").setIcon("app/ui/offers/images/want-heart-button-red-ios.png");

						} 
						else {
							sap.ui.getCore().byId("couponCheckInOffersDetailButton1").removeStyleClass("sapmbtnactive");
							sap.ui.getCore().byId("couponCheckInOffersDetailButton1iOS").removeStyleClass("sapmbtnactive");
							sap.ui.getCore().byId("couponCheckInOffersDetailButton1").setIcon("app/ui/offers/images/want-heart-button-up.png");
							sap.ui.getCore().byId("couponCheckInOffersDetailButton1iOS").setIcon("app/ui/offers/images/want-heart-button-up.png");
							
						}
						
						/*var pageData = app.getCurrentPage().getContent()[0].getModel().getData();
						pageData.isWanted = allOffersController.dataOffers[i].isWanted;*/
						allOffersController.dataOffers[i].imageSource = "";
						//pageData.imageSource = "";

						if (allOffersController.dataOffers[i].isWanted !== false) {
							allOffersController.dataOffers[i].imageSource = "sap-icon://electrocardiogram";
							//pageData.imageSource = "sap-icon://electrocardiogram";
						}
						else if (allOffersController.dataOffers[i].isExpiring !== false) {
							allOffersController.dataOffers[i].imageSource = "sap-icon://history";
							//pageData.imageSource = "sap-icon://history";
						}
						else if (allOffersController.dataOffers[i].isNew !== false) {
							allOffersController.dataOffers[i].imageSource = "sap-icon://lightbulb";
							//pageData.imageSource = "sap-icon://lightbulb";
						}
						else {
							allOffersController.dataOffers[i].imageSource = "";
							//pageData.imageSource = "";
						}

						//allOffersController.couponDetailModel.setData(pageData);
						//app.getCurrentPage().getContent()[0].getModel().setData(pageData);
						var wantedIcon = app.getCurrentPage().getContent()[0].byId("wantedIconHolder");
						wantedIcon.rerender();
						allOffersController.dataOffers[i].couponInstanceid = response.offer.couponInstanceid;
						allOffersController.dataOffers[i].strCode = response.offer.strCode;
						allOffersController.dataOffers[i].serialNumber = response.offer.serialNumber;
					}
				}
				if(checkInStoreOffersController.offers.wantedOffersVisible){
					for ( var i = 0; i < checkInStoreOffersController.offers.wantedOffers.length; i++) {
						
						if (checkInStoreOffersController.offers.wantedOffers[i].couponTypeid == allOffersController.currentCouponTypeid) {
							// No need to do this for different cards data as the offer object is being referenced in card data also.
							// So a change here will be reflected in the cards offers as well.
							checkInStoreOffersController.offers.wantedOffers[i].isWanted = !checkInStoreOffersController.offers.wantedOffers[i].isWanted;
							if (checkInStoreOffersController.offers.wantedOffers[i].isWanted === true) {
								sap.ui.getCore().byId("couponCheckInOffersDetailButton1").addStyleClass("sapmbtnactive");
								sap.ui.getCore().byId("couponCheckInOffersDetailButton1iOS").addStyleClass("sapmbtnactive");
								sap.ui.getCore().byId("couponCheckInOffersDetailButton1").setIcon("app/ui/offers/images/want-heart-button-down.png");
								sap.ui.getCore().byId("couponCheckInOffersDetailButton1iOS").setIcon("app/ui/offers/images/want-heart-button-red-ios.png");
	
							} 
							else {
								sap.ui.getCore().byId("couponCheckInOffersDetailButton1").removeStyleClass("sapmbtnactive");
								sap.ui.getCore().byId("couponCheckInOffersDetailButton1iOS").removeStyleClass("sapmbtnactive");
								sap.ui.getCore().byId("couponCheckInOffersDetailButton1").setIcon("app/ui/offers/images/want-heart-button-up.png");
								sap.ui.getCore().byId("couponCheckInOffersDetailButton1iOS").setIcon("app/ui/offers/images/want-heart-button-up.png");
								
							}
							
							var pageData = app.getCurrentPage().getContent()[0].getModel().getData();
							pageData.isWanted = checkInStoreOffersController.offers.wantedOffers[i].isWanted;
							checkInStoreOffersController.offers.wantedOffers[i].imageSource = "";
							pageData.imageSource = "";
	
							if (checkInStoreOffersController.offers.wantedOffers[i].isWanted !== false) {
								checkInStoreOffersController.offers.wantedOffers[i].imageSource = "sap-icon://electrocardiogram";
								pageData.imageSource = "sap-icon://electrocardiogram";
							}
							else if (checkInStoreOffersController.offers.wantedOffers[i].isExpiring !== false) {
								checkInStoreOffersController.offers.wantedOffers[i].imageSource = "sap-icon://history";
								pageData.imageSource = "sap-icon://history";
							}
							else if (checkInStoreOffersController.offers.wantedOffers[i].isNew !== false) {
								checkInStoreOffersController.offers.wantedOffers[i].imageSource = "sap-icon://lightbulb";
								pageData.imageSource = "sap-icon://lightbulb";
							}
							else {
								checkInStoreOffersController.offers.wantedOffers[i].imageSource = "";
								pageData.imageSource = "";
							}
							
							//allOffersController.couponDetailModel.setData(pageData);
							app.getCurrentPage().getContent()[0].getModel().setData(pageData);
							var wantedIcon = app.getCurrentPage().getContent()[0].byId("wantedIconHolder");
							wantedIcon.rerender();
							checkInStoreOffersController.offers.wantedOffers[i].couponInstanceid = response.offer.couponInstanceid;
							checkInStoreOffersController.offers.wantedOffers[i].strCode = response.offer.strCode;
							checkInStoreOffersController.offers.wantedOffers[i].serialNumber = response.offer.serialNumber;
						}
					}
					checkInStoreOffersController.getOffers();
				}
				else{
					for ( var i = 0; i < checkInStoreOffersController.offers.inStoreOffers.length; i++) {
						
						if (checkInStoreOffersController.offers.inStoreOffers[i].couponTypeid == allOffersController.currentCouponTypeid) {
							// No need to do this for different cards data as the offer object is being referenced in card data also.
							// So a change here will be reflected in the cards offers as well.
							checkInStoreOffersController.offers.inStoreOffers[i].isWanted = !checkInStoreOffersController.offers.inStoreOffers[i].isWanted;
							if (checkInStoreOffersController.offers.inStoreOffers[i].isWanted === true) {
								sap.ui.getCore().byId("couponCheckInOffersDetailButton1").addStyleClass("sapmbtnactive");
								sap.ui.getCore().byId("couponCheckInOffersDetailButton1iOS").addStyleClass("sapmbtnactive");
								sap.ui.getCore().byId("couponCheckInOffersDetailButton1").setIcon("app/ui/offers/images/want-heart-button-down.png");
								sap.ui.getCore().byId("couponCheckInOffersDetailButton1iOS").setIcon("app/ui/offers/images/want-heart-button-red-ios.png");
	
							} 
							else {
								sap.ui.getCore().byId("couponCheckInOffersDetailButton1").removeStyleClass("sapmbtnactive");
								sap.ui.getCore().byId("couponCheckInOffersDetailButton1iOS").removeStyleClass("sapmbtnactive");
								sap.ui.getCore().byId("couponCheckInOffersDetailButton1").setIcon("app/ui/offers/images/want-heart-button-up.png");
								sap.ui.getCore().byId("couponCheckInOffersDetailButton1iOS").setIcon("app/ui/offers/images/want-heart-button-up.png");
								
							}
							
							var pageData = app.getCurrentPage().getContent()[0].getModel().getData();
							pageData.isWanted = checkInStoreOffersController.offers.inStoreOffers[i].isWanted;
							checkInStoreOffersController.offers.inStoreOffers[i].imageSource = "";
							pageData.imageSource = "";
	
							if (checkInStoreOffersController.offers.inStoreOffers[i].isWanted !== false) {
								checkInStoreOffersController.offers.inStoreOffers[i].imageSource = "sap-icon://electrocardiogram";
								pageData.imageSource = "sap-icon://electrocardiogram";
							}
							else if (checkInStoreOffersController.offers.inStoreOffers[i].isExpiring !== false) {
								checkInStoreOffersController.offers.inStoreOffers[i].imageSource = "sap-icon://history";
								pageData.imageSource = "sap-icon://history";
							}
							else if (checkInStoreOffersController.offers.inStoreOffers[i].isNew !== false) {
								checkInStoreOffersController.offers.inStoreOffers[i].imageSource = "sap-icon://lightbulb";
								pageData.imageSource = "sap-icon://lightbulb";
							}
							else {
								checkInStoreOffersController.offers.inStoreOffers[i].imageSource = "";
								pageData.imageSource = "";
							}
							
							//allOffersController.couponDetailModel.setData(pageData);
							app.getCurrentPage().getContent()[0].getModel().setData(pageData);
							var wantedIcon = app.getCurrentPage().getContent()[0].byId("wantedIconHolder");
							wantedIcon.rerender();
							checkInStoreOffersController.offers.inStoreOffers[i].couponInstanceid = response.offer.couponInstanceid;
							checkInStoreOffersController.offers.inStoreOffers[i].strCode = response.offer.strCode;
							checkInStoreOffersController.offers.inStoreOffers[i].serialNumber = response.offer.serialNumber;
						}
					}
					checkInStoreOffersController.getOffers();
				}
				
			} else {
				checkErrorMobiliserStatus(response);
			}
			app.back();
		},
});