sap.ui.controller('app.ui.myLists.checkOutPaymentController', {

	checkOutPaymentData : {
			subTotal : "",
			taxes : "",
			totalAmount : "",
			amountToPayEnabled : false,
			amountToPay : "",
			paymentEnabled : false,
			paymentBankName : "",
			paymentAccountType : "",
	
	},
	
	launchCheckOutPaymentController: function(){  
		if(app.getPage(ID_CHECK_OUT_PAYMENT_PAGE)==null){
            var checkOutPaymentView = sap.ui.view({
              type : sap.ui.core.mvc.ViewType.XML,
              viewName : "app.ui.myLists.checkOutPayment",
              controller : checkoutPaymentController
            });
			 

            var checkOutPaymentPage = new sap.m.Page(ID_CHECK_OUT_PAYMENT_PAGE,{
                content : [checkOutPaymentView],
				title : oBundle.getText("checkout")
            });
            var paymentCheckOutModel = new sap.ui.model.json.JSONModel();
            checkOutPaymentView.setModel(paymentCheckOutModel);
			
            app.addPage(checkOutPaymentPage);
        }
		if (openTransactionController.openTransactionData.currency == 1) {
			checkoutPaymentController.checkOutPaymentData.amountToPay = openTransactionController.openTransactionData.currency + parseFloat(openTransactionController.openTransactionData.currentAmount/100).toFixed(2);
		}
		else if (openTransactionController.openTransactionData.currency != 1) { //if currency is euro
			checkoutPaymentController.checkOutPaymentData.amountToPay = parseFloat(openTransactionController.openTransactionData.currentAmount/100).toFixed(2) + openTransactionController.openTransactionData.currency;
		}
		
		//checkoutPaymentController.checkOutPaymentData.amountToPay = parseFloat(openTransactionController.openTransactionData.currentAmount/100).toFixed(2);
        
        app.getPage(ID_CHECK_OUT_PAYMENT_PAGE).getContent()[0].getModel().setData(checkoutPaymentController.checkOutPaymentData);
        app.to(ID_CHECK_OUT_PAYMENT_PAGE);
		
		var obj = { customerId : loginResponseModel.customer.id };
		util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
		SmartphoneService.getWalletEntriesByCustomer(obj,checkoutPaymentController.callback);
        
	},
	
	callback : function(response, status) {
		if (status != 200) {
			checkErrorStatus(status);
			return;
		}
		else if( isRESTStatusCodeCorrect(response) ) {
			
    		//logic to get Primary Card
    		for(var i=0; i<response.walletEntries.length; i++){
    			if(response.walletEntries[i].creditPriority == 1){
					checkoutPaymentController.checkOutPaymentData.paymentBankName = response.walletEntries[i].alias;
					break;
    			}
    		}
			util.closeBusyDialog();
			app.getPage(ID_CHECK_OUT_PAYMENT_PAGE).getContent()[0].getModel().setData(checkoutPaymentController.checkOutPaymentData);
		}
		else {
				checkErrorMobiliserStatus(response);
				util.closeBusyDialog();
		}
	},
	
	authenticateCallBack: function(response, status) {
		if (status != 200) {
			checkErrorStatus(status);
			util.closeBusyDialog();
			return;
		}
		else if( isRESTStatusCodeCorrect(response) ) {
			util.closeBusyDialog();
			if (checkoutThankYouController == undefined) {
                checkoutThankYouController = sap.ui.controller("app.ui.myLists.checkOutThankYouController");
            }
            checkoutThankYouController.launchCheckOutThankYouController();
		}
		else {
				checkErrorMobiliserStatus(response);
				util.closeBusyDialog();
		}
	
	},
	
	appectFunction : function() {
	
		if(openTransactionController.openTransactionData.currentAuthenticationType == "0") {
			if (checkoutThankYouController == undefined) {
                checkoutThankYouController = sap.ui.controller("app.ui.myLists.checkOutThankYouController");
            }
            checkoutThankYouController.launchCheckOutThankYouController();
		}
		else if (openTransactionController.openTransactionData.currentAuthenticationType == "100") {
		
			
			
			var msgDialog = new sap.m.Dialog({
				title: oBundle.getText("alert"),
				type: sap.m.DialogType.Message,
				content: new sap.m.Text({
					text: oBundle.getText("do_you_agree")+ " " +checkoutPaymentController.checkOutPaymentData.amountToPay + "?"
					}),
				leftButton: new sap.m.Button({
						text: oBundle.getText("agree"),
						width: "100%",
						press: function () {
							msgDialog.close();
							var tempObj = {
											credential: "OK",
											transactionId : openTransactionController.openTransactionData.currentTransactionId,
											};
							util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
							SmartphoneService.authenticatePosTransaction(tempObj, checkoutPaymentController.authenticateCallBack);
						}
				}),
				rightButton: new sap.m.Button({
						text: oBundle.getText("disagree"),
						width: "100%",
						press: function () {
							msgDialog.close();
						}
				}),
				afterClose: function (oEvent) {
					//console.log(oEvent);
				}
			});
			msgDialog.open();
			// var callBackFunction = function(selectedButtonIndex){
										// appExitAlreadyShown = false;
										// if(selectedButtonIndex == 0){
											// var tempObj = {
												// credential: openTransactionController.openTransactionData.currentAuthenticationType,
												// transactionId : openTransactionController.openTransactionData.currentTransactionId,
											// }
											// SmartphoneService.authenticatePosTransaction(tempObj, checkoutPaymentController.authenticateCallBack);
										// }
										// else {

											// }
								// };
								// util.showDialogWithOptions(callBackFunction,
										// "Are you sure you want to pay "+checkoutPaymentController.checkOutPaymentData.amountToPay+" EUR ?",
										// [oBundle.getText("Yes"),oBundle.getText("No")]);
		
		}
		else {
			if (checkoutPinEntryController == undefined) {
				checkoutPinEntryController = sap.ui.controller("app.ui.myLists.checkOutPinEntryController");
			}
			checkoutPinEntryController.launchCheckOutPinEntryController();
		}

	},
	
	doneFunction : function() {
		if (openTransactionController.openTransactionData.currentAuthenticationType == "101"){
			sliderMenuController.checkInSliderViewModFunction(false);
			homeController.launchAnonymousHomePage();
		}
		else {
			var tempObj = {
				credential: "reject",
				transactionId : openTransactionController.openTransactionData.currentTransactionId,
				};
			util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
			SmartphoneService.authenticatePosTransaction(tempObj, checkoutPaymentController.rejectCallBack);
		}
		
	},
	
	rejectCallBack : function(response, status) {
		if (status != 200) {
			checkErrorStatus(status);
			util.closeBusyDialog();
			return;
		}
		else if (response.Status.code == 2524) {
			util.closeBusyDialog();
			sliderMenuController.checkInSliderViewModFunction(false);
			homeController.launchAnonymousHomePage();
			return;
		}
		else if( isRESTStatusCodeCorrect(response) ) {
			util.closeBusyDialog();
			sliderMenuController.checkInSliderViewModFunction(false);
			homeController.launchAnonymousHomePage();
		}
		else {
			util.closeBusyDialog();
				checkErrorMobiliserStatus(response);
		}
		
	},
	
	gotoPaymentAccount : function() {
	
	
	}
	
});