sap.ui.controller('app.ui.myLists.checkOutPinEntryController', {

	launchCheckOutPinEntryController: function(){  
		if(app.getPage(ID_CHECK_OUT_PIN_PAGE)==null){
            var checkOutPinEntryView = sap.ui.view({
              type : sap.ui.core.mvc.ViewType.XML,
              viewName : "app.ui.myLists.checkOutPinEntry",
              controller : checkoutPinEntryController
            });
			 
			header = new sap.m.Bar({
                contentMiddle : [new sap.m.Label({
                    //TODO: add to translation file
                    text : oBundle.getText("enter_pin")
                })],
                contentLeft : [new sap.m.Button({
					text : oBundle.getText("cancel"),
                    tap : function(event, src) {
						app.back();
                    }
                })],
				contentRight : [new sap.m.Button("nextPinButton",{
					text : oBundle.getText("next"),
                    tap : function(event, src) {
						var pin = app.getPage(ID_CHECK_OUT_PIN_PAGE).getContent()[0].byId("pin1");
						var tempObj = {
												credential: pin.getValue(),
												transactionId : openTransactionController.openTransactionData.currentTransactionId,
										}
						util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
						SmartphoneService.authenticatePosTransaction(tempObj, checkoutPinEntryController.authenticateCallBack);
						
                    },
                    enabled : false
                })]
				
            });
			
            var checkOutPinEntryPage = new sap.m.Page(ID_CHECK_OUT_PIN_PAGE,{
				customHeader : header,
                content : [checkOutPinEntryView],
            });
            var opticalCheckOutModel = new sap.ui.model.json.JSONModel();
            
            checkOutPinEntryView.setModel(opticalCheckOutModel);
            app.addPage(checkOutPinEntryPage);
        }
        var pin = app.getPage(ID_CHECK_OUT_PIN_PAGE).getContent()[0].byId("pin1");
		pin.setValue("");
        //app.getPage(ID_CHECK_OUT_PAGE).getContent()[0].getModel().setData(checkInShoppingController.listItemSelected);
        app.to(ID_CHECK_OUT_PIN_PAGE);
        
	},
	
	authenticateCallBack: function(response, status) {
		if (status != 200) {
			checkErrorStatus(status);
			util.closeBusyDialog();
			return;
		}
		else if (response.Status.code == 2522) {
			util.alertDialog(oBundle.getText("error_message_app_not_recognize_user_or_pass"));
			util.closeBusyDialog();
			return;
		}
		else if (response.Status.code == 2524) {
			util.closeBusyDialog();
			util.alertDialog(oBundle.getText("too_many_attempts"));
			if (userCredentialSettingsController == undefined) {
				userCredentialSettingsController = sap.ui.controller("app.ui.settings.userCredentialSettings");
            }
			userCredentialSettingsController.SignOut();
			return;
		}
		else if( isRESTStatusCodeCorrect(response) ) {
			util.closeBusyDialog();
			if (checkoutThankYouController == undefined) {
                checkoutThankYouController = sap.ui.controller("app.ui.myLists.checkOutThankYouController");
            }
            checkoutThankYouController.launchCheckOutThankYouController();
		}
		else {
				checkErrorMobiliserStatus(response);
				util.closeBusyDialog();
		}
	
	},
	changePinOneFocus : function(ev){
		var input = ev.getSource().getValue();
		/*var viewRef = app.getPage(ID_CHECK_OUT_PIN_PAGE).getContent()[0].byId("pin2");
		if(input.length == 1)
			viewRef.focus();*/
		var nextButton = app.getCurrentPage().getCustomHeader().getContentRight()[0];
		if(input.length == 4){
			nextButton.setEnabled(true);
		}
		else{
			nextButton.setEnabled(false);
		}
	},
	changePinTwoFocus : function(ev){
		var input = ev.getSource().getValue();
		var viewRef = app.getPage(ID_CHECK_OUT_PIN_PAGE).getContent()[0].byId("pin3");
		if(input.length == 1)
			viewRef.focus();
			
	},
	changePinThreeFocus : function(ev){
		var input = ev.getSource().getValue();
		var viewRef = app.getPage(ID_CHECK_OUT_PIN_PAGE).getContent()[0].byId("pin4");
		if(input.length == 1)
			viewRef.focus();
			
	},
	changePinFourFocus : function(ev){
		var input = ev.getSource().getValue();
		var viewRef = app.getPage(ID_CHECK_OUT_PIN_PAGE).getContent()[0].byId("pin3");
		if(input.length == 0)
			viewRef.focus();
	}
});