sap.ui.controller("app.ui.myLists.listDetailController", {
    //items able to add
    pageModel : {
        listData:[],
	},
	
	emptyModeldata : {listData:[]},
	isNewList : false,
	addItem : false,
	previousModelData : null,
    newItemsData : null,
    listID : null,
	previousHeader : null,
	listSize : 0,
	searching : false,
	listTitle : "",
	
	dynSrcLastCallTime : new Date(),
    DYN_SRCH_MIN_INTERVAL : 1400,
    searchTimer: undefined,
    searchString : "",
    searchResult: {listData:[] },
	
	homePageScan : false,
	checkedSorter: null,
	
	ACTIVE_STATUS: 1,
	COMPLETED_STATUS: 2,
	
	newListHeader :new sap.m.Bar({
            contentRight : [new sap.m.Button({
                tap : function(event, src) {
                    listDetailController.saveListFunction();
                },
                //TODO TRANSLATION
                text : oBundle.getText("Save_Text"),
            })],
            contentMiddle : [new sap.m.Label({
                //TODO TRANSLATION
                text : oBundle.getText("new_list")
            })],
            contentLeft : [new sap.m.Button({
                text :  oBundle.getText("Back_Button"),
                tap : function(event, src) {
                    app.back();
                }
            })]
        }),
		
	launchListDetailPage : function(details){
        if (app.getPage(LIST_DETAIL_PAGE) == null) {
            var listDetailView = sap.ui.view({
                type : sap.ui.core.mvc.ViewType.XML,
                viewName : "app.ui.myLists.listDetail",
                id : "listDetailView",
                controller : this
            });
            this.oModel = new sap.ui.model.json.JSONModel();
            this.oModel.setData(details);
            listDetailView.setModel(this.oModel);
			
            header = new sap.m.Bar({});
			
			//Sub-header Bar items
            listDetailController.searchbar = new sap.m.SearchField('searchBarAddListItem',{
                placeholder : oBundle.getText("type_to_add_item"),
                liveChange: function(oEvent){
                	listDetailController.searchItems(oEvent.getParameter("newValue"));	
                },
            });
            listDetailController.searchbar.addStyleClass("listDetail_searchBoxPadding");
            var barcodeImage = new sap.m.Button('barcodeSearchList',{
                icon : "sap-icon://bar-code",
				type : "Transparent",
                tap : function (){
                	listDetailController.barcodeButtonTapFunction();
                },
            }); 
            barcodeImage.addStyleClass("barcode_button");
            var searchContainer = new sap.m.Bar("searchBarWrapperAddListItem", {
                contentMiddle : [listDetailController.searchbar],
                contentRight : [barcodeImage],
            });
            listDetailController.searchBar = searchContainer
                  
            var listDetailPage = new sap.m.Page(LIST_DETAIL_PAGE, {
                customHeader : header,
                subHeader : searchContainer,
                content : [listDetailView],
            });
            app.addPage(listDetailPage); 
        }
		app.getPage(LIST_DETAIL_PAGE).getContent()[0].getModel().setData(listDetailController.emptyModeldata);
        app.getPage(LIST_DETAIL_PAGE).getSubHeader().getContentMiddle()[0].setValue("");
        //if existing list
        if (details){
            listDetailController.isNewList = false;
			listDetailController.addItem = false;
            listDetailController.previousModelData = {listData:[] };
            listDetailController.newItemsData = {listData:[] };
            listDetailController.listID = details.id;
			listDetailController.listTitle = details.name;
            var backHeader = new sap.m.Bar({
                contentRight : [],
                contentMiddle : [new sap.m.Label({
                    text : listDetailController.listTitle,
                })],
                contentLeft : [new sap.m.Button({
                    text :  oBundle.getText("Back"),
                    tap : function(event, src) {
                        app.back();
                    }
                })]
            });
            
			listDetailController.previousHeader = backHeader;
            app.getPage(LIST_DETAIL_PAGE).setCustomHeader(listDetailController.previousHeader );
			
			util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
            SmartphoneService.getListDataForList(listDetailController.listID, listDetailController.getListDataBack);
        }
        //else creating new list
        else{
            listDetailController.isNewList = true;
			listDetailController.addItem = true;
			listDetailController.listSize = 0;
            listDetailController.previousModelData = {listData:[] };//listDetailController.emptyModeldata;
            listDetailController.newItemsData = {listData:[] };
            listDetailController.previousHeader = listDetailController.newListHeader;
            app.getPage(LIST_DETAIL_PAGE).setCustomHeader(listDetailController.previousHeader );
            this.oModel = new sap.ui.model.json.JSONModel();         
            app.getPage(LIST_DETAIL_PAGE).getContent()[0].setModel(this.oModel);
            
        }
        
        listDetailController.resetListMode();
        
        listDetailController.checkedSorter = new sap.ui.model.Sorter("isChecked",false,function (oContext) {
        	var checked = oContext.getProperty("isChecked");
        	var key, text;
        	if (checked == true) {
        		key = true;
        		text = oBundle.getText("Completed_Items_Title");
        	}  else {
        		key = false;
        		text = oBundle.getText("open_items");
        	}
        	return {
        		key: key,
        		text: text
        	};
        });
        
        app.to(LIST_DETAIL_PAGE);
    },
	
    resetListMode: function(){
    	if(listDetailController.isNewList){
    		 var detailList = app.getPage(LIST_DETAIL_PAGE).getContent()[0].byId("listDetail");
             detailList.setMode(sap.m.ListMode.None);
    	}else{
    		 var detailList = app.getPage(LIST_DETAIL_PAGE).getContent()[0].byId("listDetail");
             detailList.setMode(sap.m.ListMode.MultiSelect);
    	}
    },
    
	getListDataBack : function (response, status){
        if (status != 200) {
			checkErrorStatus(status);
			return;
		}
		else if( isRESTStatusCodeCorrect(response) ) {
            if (response.listData == undefined || response.listData == null) {
				listDetailController.listSize = 0;
                listDetailController.previousModelData.listData = [];
            }
            else{
            	for(var i=0;i<response.listData.length; i++){
            		if(response.listData[i].dataStatusId == listDetailController.COMPLETED_STATUS)
            			response.listData[i].isChecked = true;
            		else
            			response.listData[i].isChecked = false;
					
					if (response.listData[i].contentTypeId == 1) {
						response.listData[i].listItemType = "Inactive";	
					}
					else if (response.listData[i].contentTypeId == 2){
						response.listData[i].listItemType = "Navigation";
						
						if (response.listData[i].listPrice) {
							if (response.listData[i].currency.length == 1) {
								response.listData[i].adjPrice = response.listData[i].currency + parseFloat(response.listData[i].listPrice).toFixed(2)/100;
							}
							else if (response.listData[i].currency.length != 1) { //if currency is euro
								response.listData[i].adjPrice = parseFloat(response.listData[i].listPrice).toFixed(2)/100 + response.listData[i].currency;
							}
						}
						if (response.listData[i].offerCount) {
							response.listData[i].numOffers = response.listData[i].offerCount +" " + oBundle.getText("offers");
						}
					}
            	}
				listDetailController.listSize = response.listData.length;
                listDetailController.previousModelData = response;
            }
			app.getPage(LIST_DETAIL_PAGE).getContent()[0].getModel().setData(listDetailController.previousModelData);
			var detailList = app.getPage(LIST_DETAIL_PAGE).getContent()[0].byId("listDetail");
			detailList.getBinding("items").sort(listDetailController.checkedSorter);
			util.closeBusyDialog();
		}
		else{
			checkErrorMobiliserStatus(response);
			util.closeBusyDialog();
		}
    },
	
    searchItems : function() {
    	/*
    	 * The below function does a dynamic search for shop articles. It is invoked at the liveChange event of the 
    	 * search bar. So whenever the user will enter/delete a character in the search bar, this function would be
    	 * invoked.
    	 * If the searhbar contains less than 3 chars we don't call the service and simply show just
    	 * one item in the search result list, the chars in the search bar. If the search bar contains 3 or more chars
    	 * we call the searchShopArticle service. Again we don't want to invoke too many service calls if the user is
    	 * typing very fast. So what we do is that we maintain a constant DYN_SRCH_MIN_INTERVAL (in milliseconds). If
    	 * after a char typed, the next char is typed within this period, we ignore the event and don't call the service
    	 * again. But what if it was the last char user typed, in that case we will never make a call with all the chars
    	 * user typed. To overcome, we create a timer which will invoke this method after DYN_SRCH_MIN_INTERVAL again.
    	 * This timer is cleared in case user types in any char before DYN_SRCH_MIN_INTERVAL.
    	 * 
    	 */
    	clearTimeout(listDetailController.searchTimer);
    	var sPrefix = listDetailController.searchbar.getValue();
        if (sPrefix == "") {
			listDetailController.searching = false;
			if ( listDetailController.addItem == false ) {
				var backHeader = new sap.m.Bar({
					contentRight : [],
					contentMiddle : [new sap.m.Label({
						text : listDetailController.listTitle,
					})],
					contentLeft : [new sap.m.Button({
						text :  oBundle.getText("Back"),
						tap : function(event, src) {
							app.back();
						}
					})]
				});
				listDetailController.previousHeader = backHeader;
				app.getPage(LIST_DETAIL_PAGE).setCustomHeader(listDetailController.previousHeader );
			}
			app.getPage(LIST_DETAIL_PAGE).getContent()[0].getModel().setData(listDetailController.previousModelData);
			listDetailController.resetListMode();
        	//listDetailController.searchResult = listDetailController.emptyModelData;
            //app.getPage(LIST_DETAIL_PAGE).getContent()[0].getModel().setData(listDetailController.searchResult);
        }
        else if(sPrefix.length < 3){
			listDetailController.searching = true;
    		var aResult = {listData:[] }
        	var newItem = {
    				title : sPrefix,
                    contentTypeId : 1,
                    entitySourceId : null,
                    qty : 0,
                    freeText : "",
                    isChecked : false,
                };
			aResult.listData.push(newItem);
			listDetailController.searchResult = aResult;
            app.getPage(LIST_DETAIL_PAGE).getContent()[0].getModel().setData(listDetailController.searchResult);
            
            var detailList = app.getPage(LIST_DETAIL_PAGE).getContent()[0].byId("listDetail");
            detailList.setMode(sap.m.ListMode.None);
    	}
        else if(sPrefix.length >= 3){
			listDetailController.searching = true;
        	var currTime = (new Date()).getTime();
        	var delta = currTime - listDetailController.dynSrcLastCallTime;
        	//console.log("delta " + delta);
        	if(delta > listDetailController.DYN_SRCH_MIN_INTERVAL){
        		
        		//console.log("CALLING SERVICE");
        		listDetailController.dynSrcLastCallTime = currTime;
        		listDetailController.searchString = sPrefix;
        		var body = {
            			searchText:sPrefix,
        		};
        		SmartphoneService.searchShopArticles(body,listDetailController.filterItems);
        	}else{
        		//console.log("SETTING TIMER");
        		listDetailController.searchTimer = setTimeout(listDetailController.searchItems, listDetailController.DYN_SRCH_MIN_INTERVAL);
        	}
            
        }
    },
	
	//Helper method to filter search items
    filterItems: function(response, status){
    	//console.log("GOT RESPONSE");
        if (status != 200) {
			checkErrorStatus(status);
			return;
		}
		
		if(isRESTStatusCodeCorrect(response)) {
			var aResult = {listData:[] }
			//aResult = app.getPage(LIST_DETAIL_PAGE).getContent()[0].getModel().getData();
			//console.log("CORRECT RESPONSE");
			var newItem = {
                    title : listDetailController.searchString,
					listItemType: "Navigation",
                    contentTypeId : 1,
                    entitySourceId : null,
                    qty : 0,
                    freeText : "",
                    isChecked : false,
                };
			aResult.listData.push(newItem);
			if(response.article != undefined && response.article.length > 0){
				for(var i=0; i<response.article.length; i++){
					var serviceResult = {
						gtin : response.article[i].gtin,
						title : response.article[i].shortdescription,
						contentTypeId : 2,
						listItemType: "Navigation",
						id_entity : response.article[i].id,
						quantity : 0,
						freeText : response.article[i].longdescription,
						isChecked : false,
						listprice : response.article[i].listprice,
						memberprice: response.article[i].memberprice,
						adjPrice : parseFloat(response.article[i].listprice).toFixed(2)/100,
						uom : response.article[i].uom,
						currency : response.article[i].currency,
						description : response.article[i].longdescription,
					};
					if (serviceResult.adjPrice) {
						if (serviceResult.currency.length == 1) {
							serviceResult.adjPrice = serviceResult.currency + serviceResult.adjPrice;
						}
						else if (serviceResult.currency.length != 1) { //if currency is euro
							serviceResult.adjPrice = serviceResult.adjPrice + " "+ serviceResult.currency;
						}
					}
					aResult.listData.push(serviceResult);
				}
			}
			
			listDetailController.searchResult = aResult;
            app.getPage(LIST_DETAIL_PAGE).getContent()[0].getModel().setData(listDetailController.searchResult);
            
            var detailList = app.getPage(LIST_DETAIL_PAGE).getContent()[0].byId("listDetail");
            detailList.setMode(sap.m.ListMode.None);
		}
    },
	
	gotoItemDetail : function (ev) {
        if(listDetailController.searching == true) {
			listDetailController.addItem = true;
            var source = ev.getSource();
            var item = source.getBindingContext().getProperty(source.getBindingContext().getPath());
			item.listItemType = "Inactive";
            listDetailController.previousModelData.listData.push(item);
            listDetailController.newItemsData.listData.push(item);
            listDetailController.searchCancelFunction();
        }
        else {
            var source = ev.getSource();
            var details = source.getBindingContext().getProperty(source.getBindingContext().getPath());
            if (itemDetailController == undefined) {
                itemDetailController = sap.ui.controller("app.ui.myLists.CheckInItemDetailController");
            }
            itemDetailController.launchListItemDetailPage(details);
        }
    },
	
	searchCancelFunction : function() {
        listDetailController.searching = false;
        app.getPage(LIST_DETAIL_PAGE).getSubHeader().getContentMiddle()[0].setValue("");
		var saveListHeader = new sap.m.Bar({
                contentRight : [new sap.m.Button({
                    tap : function(event, src) {
						listDetailController.saveListFunction();
						listDetailController.resetListMode();
                    },
                    //TODO TRANSLATION
                    text : oBundle.getText("Save_Text"),
                })],
                contentMiddle : [new sap.m.Label({
                    text : listDetailController.listTitle,
                })],
                contentLeft : [new sap.m.Button({
                    text :  oBundle.getText("Cancel"),
                    tap : function(event, src) {
						listDetailController.cancelListFunction();
						listDetailController.resetListMode();
                    }
                })]
            });
        app.getPage(LIST_DETAIL_PAGE).setCustomHeader(saveListHeader);
        listDetailController.searchResult = {listData:[] };
        app.getPage(LIST_DETAIL_PAGE).getContent()[0].getModel().setData(listDetailController.previousModelData);
        
        var detailList = app.getPage(LIST_DETAIL_PAGE).getContent()[0].byId("listDetail");
        detailList.setMode(sap.m.ListMode.None);
    },
	
	saveListFunction : function() {
        if (listDetailController.isNewList == true) {
            if (newListController == undefined) {
                newListController = sap.ui.controller("app.ui.myLists.newListController");
            }
            newListController.launchNewListPage();
        }
        else {
            if ( listDetailController.addItem == true ) {
              var obj = {
                  listId : listDetailController.listID,
                  list : listDetailController.newItemsData,
              };
			  util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
			  SmartphoneService.createArrayOfListData( obj,listDetailController.addDataBack )
            }
        }
    },
	
	addDataBack : function(response, status) {
		if (status != 200) {
			checkErrorStatus(status);
			return;
        }
        else if( isRESTStatusCodeCorrect(response) ) {
        	listDetailController.newItemsData = {listData:[] };
			listDetailController.addItem = false;
			app.getPage(LIST_DETAIL_PAGE).setCustomHeader(listDetailController.previousHeader );
			util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
            SmartphoneService.getListDataForList(listDetailController.listID, listDetailController.getListDataBack);
		}
		else {
			checkErrorMobiliserStatus(response);
			util.closeBusyDialog();
		}
	},
	
	cancelListFunction : function() {
        listDetailController.cancelList = false;
		listDetailController.addItem = false;
		var tempCount = listDetailController.previousModelData.listData.length;
		for(i = tempCount; i> listDetailController.listSize; i-- ) {
			var count = listDetailController.previousModelData.listData.length-1;
			listDetailController.previousModelData.listData.splice(count,1);
		}
		listDetailController.newItemsData = {listData:[] };
		app.getPage(LIST_DETAIL_PAGE).setCustomHeader(listDetailController.previousHeader );
        app.getPage(LIST_DETAIL_PAGE).getContent()[0].getModel().setData(listDetailController.previousModelData);
    },
	
	clickDelete : function(ev) {
		var page = app.getPage(LIST_DETAIL_PAGE);
		var content = page.getContent()[0];
		var list = content.byId("listDetail");
		var oSwipedItem = list.getSwipedItem(); // Get which list item is swiped to delete
		var localItem = false;
		var item = oSwipedItem.getBindingContext().getProperty(oSwipedItem.getBindingContext().getPath());
		// we are done, hide the swipeContent from screen
		list.swipeOut();
		localItem = listDetailController.removeItemfromLists(item.id);
		if(localItem == false) {
			util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
			SmartphoneService.deleteListData(item.id, listDetailController.deleteListBack);      
		}
		else {
			app.getPage(LIST_DETAIL_PAGE).getContent()[0].getModel().setData(listDetailController.previousModelData);
		}
	},
    deleteListBack : function(response, status){
        if (status != 200) {
			checkErrorStatus(status);
			return;
		}
		else if( isRESTStatusCodeCorrect(response) ) {
			app.getPage(LIST_DETAIL_PAGE).getContent()[0].getModel().setData(listDetailController.previousModelData);
			util.closeBusyDialog();
		}
		else{
			checkErrorMobiliserStatus(response);
			util.closeBusyDialog();
		}          
    },
	removeItemfromLists : function(id) {	
		var temp = false;
			for(i = 0; i<listDetailController.newItemsData.listData.length;i++){
				if (id == listDetailController.newItemsData.listData[i].id) {
					temp = true;
					listDetailController.newItemsData.listData.splice(i,1);
					break;
				}
			}
			for(i = 0; i<listDetailController.previousModelData.listData.length;i++){
				if (id == listDetailController.previousModelData.listData[i].id) {
					listDetailController.previousModelData.listData.splice(i,1);
					break;
				}	
			}
		return temp;
	},
	
	barcodeButtonTapFunction : function (fromHome) {
		if (fromHome) {
			listDetailController.homePageScan = true;
		}
		else{
			listDetailController.homePageScan = false;
		}
		
		if (!window.plugins)
			window.plugins = {};
	
		if (window.plugins.barcodeScanner == undefined) {
			window.plugins.barcodeScanner = new BarcodeScanner();
		}
		else {
			//console.log("Not installing barcodeScanner: window.plugins.barcodeScanner already exists")
		}
		
		if (!window.cordova ) {
			util.createCustomScanDialog( "listDetail" );
		}
		else if(window.device.platform == "iOS"){
			//iOS barcode scan
			if (window.device.platform == "iOS"){
				//console.warn("scanning for iOS");
				window.plugins.barcodeScanner.scan(
					function(result) {
						if (result.cancelled){
							//console.warn("RESULT TEXT: " + result.text);
							//console.warn("RESULT FORMAT: " + result.format);
							//console.warn("FORMAT CANCELLED: " + result.cancelled);
							//console.warn("the user cancelled the scan");
						}
						else{
							//console.warn("GOT BARCODE");
							//console.warn("RESULT TEXT: " + result.text);
							//console.warn("RESULT FORMAT: " + result.format);
							//console.warn("FORMAT CANCELLED: " + result.cancelled);
							
							if (result.text == "ManualEntry" && result.format =="Manual" ) {
								//display dialog with popup
								util.createCustomScanDialog( "listDetail" );
							}
							else{
								//scan image to add to list
								SmartphoneService.decodeBarcode( result ,listDetailController.scanItemDetailBack);
							}
						}
					},
					function(error) {
						alert(oBundle.getText("scanning_failed")+": " + error);
					},
					["BarcodeOverlay"]
				);
			}
		}
		//Android barcode scan
		else if (window.device.platform == "Android"){
			//console.log("On Android device");
			//util.createCustomScanDialog( "listDetail" );
			window.plugins.barcodeScanner.scan(
				function(result) {
					if (result.cancelled){
						util.createAndroidManualEntryPrompt( "listDetail" );
					}
					else{
						//console.warn("GOT BARCODE");
						//console.warn("RESULT TEXT: " + result.text);
						//console.warn("RESULT FORMAT: " + result.format);
						//console.warn("FORMAT CANCELLED: " + result.cancelled);
						util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
						SmartphoneService.decodeBarcode( result ,listDetailController.scanItemDetailBack);
					}
				},
				function(error) {
					alert(oBundle.getText("scanning_failed")+": " + error);
				}
			);
		}
	},
	scanItemDetailBack : function (response, status){
        if (status != 200) {
			checkErrorStatus(status);
			return;
		}
		else if( isRESTStatusCodeCorrect(response) ) {
			 if (listDetailController.homePageScan) {
				//util.closeBusyDialog();
				
				if (itemDetailController == undefined) {
					itemDetailController = sap.ui.controller("app.ui.myLists.CheckInItemDetailController");
				}
				itemDetailController.launchHomeScanItemDetailPage(response.article);
			 }
			 else{
				//util.closeBusyDialog();
				 var price;
					if(response.article.finalprice == null || response.article.finalprice == undefined) {
						price = response.article.listprice;
			        }
			        else {
			        	price = response.article.finalprice;
			        }
				var item = {
					gtin : response.article.gtin,
					title : response.article.shortdescription,
					certification: "",
					quantity : 0,
					listprice : response.article.listprice ,
					memberprice: response.article.memberprice ,
					uom : response.article.uom,
					currency : response.article.currency,
					adjPrice : parseFloat(price).toFixed(2)/100,
					notes : "",
					description : response.article.longdescription,
					isChecked : false,
					contentTypeId : 2,
					id_entity : response.article.id
				};
				if (item.adjPrice) {
					if (item.currency.length == 1) {
						item.adjPrice = serviceResult.currency + item.adjPrice;
					}
					else if (item.currency.length != 1) { //if currency is euro
						item.adjPrice = item.adjPrice + " "+ item.currency;
					}
				}
				
				listDetailController.previousModelData.listData.push(item);
				listDetailController.newItemsData.listData.push(item);
				listDetailController.addItem = true;
				listDetailController.searchCancelFunction();
			 }
			 listDetailController.homePageScan = false;
			 util.closeBusyDialog();
		}
		else if (response.Status.code == 201) {
			util.closeBusyDialog();
			logError( oBundle.getText("item_not_found"), "Barcode Not Found", "Barcode Not Found");
		}
		else{
			checkErrorMobiliserStatus(response);
		}	
    },
    
    changeStatus: function(ev){
    	var selectedItem = ev.getParameter("listItem");
		var data = selectedItem.getBindingContext().getProperty(selectedItem.getBindingContext().getPath());
		
		var callback = function(response, status){
			util.closeBusyDialog();
			if ( ! isRESTStatusCodeCorrect(response) )
			{
				logError("error_message_general", "Error in the response of updateListData under settings", "MyLists");
				return;
			}
			
			var detailList = app.getPage(LIST_DETAIL_PAGE).getContent()[0].byId("listDetail");
			detailList.getBinding("items").sort(listDetailController.checkedSorter);
			
		}
		if(data.isChecked)
			data.dataStatusId = listDetailController.COMPLETED_STATUS; //Completed
		else
			data.dataStatusId = listDetailController.ACTIVE_STATUS; //Active
		
		//Seems like the service needs all the attributes of the item and hence doing
		//a copy of the item structure and deleting the properties which we have
		//ourself added in client and should not be a part of request
		var updateData = jQuery.extend(true, {}, data);
		delete updateData.isChecked;
		delete updateData.numOffers;
		delete updateData.adjPrice;
		delete updateData.listItemType;
		
		util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
		SmartphoneService.updateListData(updateData,callback);
		
    }
	
});
			
