sap.ui.controller("app.ui.myLists.newListController", {
  newHeader: null,
  editHeader: null,
  newListItems : undefined,
  addItemLength : 0,
  addItemCount : 0,
  addToListID : null,
  model : {
    householdingEnabled: userState.HOUSEHOLDING_ENABLED,
  },
    launchNewListPage : function(newListItems){
        if (app.getPage(NEW_LISTS_PAGE) == null) {
            //view
            var newListView = sap.ui.view({
                type : sap.ui.core.mvc.ViewType.XML,
                viewName : "app.ui.myLists.newLists",
                id : "newListsview",
                controller : this
            });
	    
	    var newListModel = new sap.ui.model.json.JSONModel();
	    newListView.setModel(newListModel);
        
            newListController.newHeader = new sap.m.Bar({
                contentRight : [new sap.m.Button('newListsDoneButton', {
                    tap : function(event, src) {
                    	newListController.doneFunc();
                    },
                    text : oBundle.getText("done"),
                })],
                contentMiddle : [new sap.m.Label("newListTitle", {
                    //TODO: add to translation file
                    text : oBundle.getText("new_list_title"),
                })],
                contentLeft : [new sap.m.Button('newListCancelButton', {
                    tap : function(event, src) {
                    	newListController.cancelFunc();
                    },
                    text : oBundle.getText("cancel"),
                })]
            });
            var newListpage = new sap.m.Page(NEW_LISTS_PAGE, {
              customHeader : newListController.newHeader,
              content : [newListView]
            });
            app.addPage(newListpage);
        }
		
		
		app.getPage(NEW_LISTS_PAGE).getContent()[0].getModel().setData(newListController.model);
		newListController.resetData();
	newListController.addItemCount = 0;
	newListController.addItemLength = listDetailController.newItemsData.listData.length;
	
        app.to(NEW_LISTS_PAGE);
    },
	resetData : function() {
		var page = app.getPage(NEW_LISTS_PAGE);
        var content = page.getContent()[0];
        var input = content.byId("inputName");
        input.setValue("");
        var privateSwitch = content.byId("privateBool");
        privateSwitch.setState(false);
	
	},
    cancelFunc: function() {
        app.back();
        
    },
    doneFunc: function(){
	myListController.listAdd = false;
        //done making new list
         var page = app.getPage(NEW_LISTS_PAGE);
         var content = page.getContent()[0];
         var input = content.byId("inputName");
         if (input.getValue()!= ""){
	   var privateSwitch = content.byId("privateBool").getState();
	  
	  var obj = {
	    title : input.getValue(),
		list: listDetailController.newItemsData,
	    /* description : "some description", */
	  };
	  
	  
			util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
			
			if (userState.HOUSEHOLDING_ENABLED == true) {
				if (privateSwitch) {
					SmartphoneService.createIndividualCustomListInstanceWithListData(obj, newListController.createListCallBack);
				}
				else {
					SmartphoneService.createSharedCustomListInstanceWithListData(obj, newListController.createListCallBack);
				}
			}
			else {
				SmartphoneService.createIndividualCustomListInstanceWithListData(obj, newListController.createListCallBack);
			}
		
    }
         else {
	   util.alertDialog( oBundle.getText("give_name_new_list") );
	 }
        
    },
	
	createListCallBack : function(response, status) {
		if (status != 200) {
			checkErrorStatus(status);
			return;
        }
        else if( isRESTStatusCodeCorrect(response) ) {
			util.closeBusyDialog();
			// var page = app.getPage(NEW_LISTS_PAGE);
			// var content = page.getContent()[0];
			// var input = content.byId("inputName");
			// input.setValue("");
			// var privateSwitch = content.byId("privateBool");
			// privateSwitch.setState(false);
			//launch list page
			 myListController.launchMyListsPage(true);
		}
		else {
			checkErrorMobiliserStatus(response);
			util.closeBusyDialog();
		}
	
	},
    // createListBack : function(response, status){
      // if (status != 200) {
	  // checkErrorStatus(status);
	  // return;
      // }
      // else if( isRESTStatusCodeCorrect(response) ) {
  	// newListController.addToListID = response.id;
// /*!!!!!!!  can only ad one item at a time, first item of list will be added !!!!!!*/
	// if (listDetailController.newItemsData.listData.length > 0 ) {
	  // var obj = {
	    // listId : newListController.addToListID,
	    // listData : listDetailController.newItemsData.listData[0],
	  // };
	  // SmartphoneService.createListData(obj, newListController.createDataBack)
	// }
	// else{
	  // console.warn("data to add to list is empty");
	  // var page = app.getPage(NEW_LISTS_PAGE);
	  // var content = page.getContent()[0];
	  // var input = content.byId("inputName");
	  // input.setValue("");
	  // var privateSwitch = content.byId("privateBool");
	  // privateSwitch.setState(false);
	  //launch list page
	  // myListController.launchMyListsPage(true);
	// }
      // }
      // else{
	  // checkErrorMobiliserStatus(response);
      // }
    // },
    // createDataBack : function(response, status){
      // if (status != 200) {
	  // checkErrorStatus(status);
	  // return;
      // }
      // else if( isRESTStatusCodeCorrect(response) ) {
	// newListController.addItemCount++;
	// if ( newListController.addItemCount < newListController.addItemLength) {
	  // var obj = {
	    // listId : newListController.addToListID,
	    // listData : listDetailController.newItemsData.listData[newListController.addItemCount],
	  // };
	  // SmartphoneService.createListData(obj, newListController.createDataBack)	
	// }
	// else{
	  //clear new list page data
	  // var page = app.getPage(NEW_LISTS_PAGE);
	  // var content = page.getContent()[0];
	  // var input = content.byId("inputName");
	  // input.setValue("");
	  // var privateSwitch = content.byId("privateBool");
	  // privateSwitch.setState(false);
	  //launch list page
	  // myListController.launchMyListsPage(true);
	// }
      // }
      // else{
	// checkErrorMobiliserStatus(response);
      // }
    // },
	
});