sap.ui.controller('app.ui.myLists.opticalScannerCheckOutController', {

	scannerType : {
		laserScanner : false,
		opticalScanner : false
	},
	launchOpticalCheckOutController: function(){  
		
		if ( checkInController.isPOSToScanForTransfer ) {
			//display barcode (true)
			if(app.getPage(ID_OPTICAL_CHECK_OUT_PAGE)==null){
				var opticalCheckOutView = sap.ui.view({
				  type : sap.ui.core.mvc.ViewType.XML,
				  viewName : "app.ui.myLists.opticalScanner",
				  controller : opticalScannerCheckoutController
				});
				 header = new sap.m.Bar({
					contentMiddle : [new sap.m.Label({
						//TODO: add to translation file
						text : oBundle.getText("scan_barcode")
					})],
					contentLeft : [new sap.m.Button({
						text : oBundle.getText("cancel"),
						tap : function(event, src) {
							app.back();
						}
					})],
					contentRight : [new sap.m.Button({
						text : oBundle.getText("next"),
						tap : function(event, src) {
							// if (checkoutMobilePaymentController == undefined) {
								// checkoutMobilePaymentController = sap.ui.controller("app.ui.myLists.checkOutMobilePaymentController");
							// }
							// checkoutMobilePaymentController.launchCheckOutMobilePaymentController();
							if(checkInController.mobilePayment == true && userState.MOBILE_PAYMENT_ENABLED == 'true') {
								if (openTransactionController == undefined) {
									openTransactionController = sap.ui.controller("app.ui.myLists.openTransactionController");
								}
								openTransactionController.launchOpenTransactionController();
							}
							else {
								if (checkoutMobilePaymentController == undefined) {
									checkoutMobilePaymentController = sap.ui.controller("app.ui.myLists.checkOutMobilePaymentController");
								}
								checkoutMobilePaymentController.launchCheckOutMobilePaymentController();
							}
						}
					})]
					
				});
	
				var opticalCheckOutPage = new sap.m.Page(ID_OPTICAL_CHECK_OUT_PAGE,{
					customHeader : header,
					content : [opticalCheckOutView],
					
				});
				var opticalCheckOutModel = new sap.ui.model.json.JSONModel();
				
				opticalCheckOutView.setModel(opticalCheckOutModel);
				app.addPage(opticalCheckOutPage);
			}
			app.to(ID_OPTICAL_CHECK_OUT_PAGE);
			//encode customerId to barcode
			var viewRef = app.getPage(ID_OPTICAL_CHECK_OUT_PAGE).getContent()[0];
			var viewId = viewRef.getId();
			$('#' + viewId + '--' + 'checkOutPlaceholder').barcode(loginResponseModel.customer.id.toString(), "code128", { barWidth: 1, barHeight: 80 });
			$('#' + viewId + '--' + 'checkOutPlaceholder').addClass("barcode_formatting");	
		}
		//scan (false)
		else{
			opticalScannerCheckoutController.checkoutScan();
		}
	},
	checkoutScan : function(){
		if (!window.plugins)
			window.plugins = {};
		if (window.plugins.barcodeScanner == undefined) {
			window.plugins.barcodeScanner = new BarcodeScanner();
		}
		else {
			//console.log("Not installing barcodeScanner: window.plugins.barcodeScanner already exists")
		}
		if (window.cordova && window.device.name != "iPhone Simulator"){
			//iOS barcode scan
			if (window.device.platform == "iOS"){
				//console.warn("scanning for iOS");
				window.plugins.barcodeScanner.scan(
					function(result) {
						if (result.cancelled){
							//console.warn("RESULT TEXT: " + result.text);
							//console.warn("RESULT FORMAT: " + result.format);
							//console.warn("FORMAT CANCELLED: " + result.cancelled);
							//console.warn("the user cancelled the scan");
						}
						else{
							//console.warn("GOT BARCODE");
							//console.warn("RESULT TEXT: " + result.text);
							//console.warn("RESULT FORMAT: " + result.format);
							//console.warn("FORMAT CANCELLED: " + result.cancelled);
							
							if (result.text == "ManualEntry" && result.format =="Manual" ) {
								//display dialog with popup
								util.createCustomScanDialog( "checkoutScan" );
							}
							else{
								opticalScannerCheckoutController.checkoutScanBack(result.text);
								//scan image to add to list
								// var obj = {
									// storeCode : result.text,
								// }
								//util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
								//SmartphoneService.??( obj, opticalScannerCheckoutController.checkoutScanBack);
							}
						}
					},
					function(error) {
						alert(oBundle.getText("scanning_failed")+": " + error);
					},
					["BarcodeOverlay"]
				);
			}
			//Android barcode scan
			else if (window.device.platform == "Android"){
				//console.log("On Android device");
				window.plugins.barcodeScanner.scan(
					function(result) {
						if (result.cancelled){
							//open dialog ask if want to scan
							util.createAndroidManualEntryPrompt( "checkoutScan" );
						}
						else{
							//console.warn("GOT BARCODE");
							//console.warn("RESULT TEXT: " + result.text);
							//console.warn("RESULT FORMAT: " + result.format);
							//console.warn("FORMAT CANCELLED: " + result.cancelled);
							opticalScannerCheckoutController.checkoutScanBack(result.text);
							//scan image to add to list
							// var obj = {
								// storeCode : result.text,
							// }
							// util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
							//SmartphoneService.??( obj, opticalScannerCheckoutController.checkoutScanBack);
						}
					},
					function(error) {
						alert(oBundle.getText("scanning_failed")+": " + error)
					}
				);
			}
		}
		else{
			util.createCustomScanDialog( "checkoutScan" );
			// var storeId = app.getPage(ID_CHECK_IN).getContent()[0].getModel().getData();
			// var obj = {
					// storeId : storeId.storeDetail.storeId,
			// }
			// //console.warn(obj.storeId)
		}
	},
	checkoutScanBack : function(terminalId){
		if (checkoutMobilePaymentController == undefined) {
			checkoutMobilePaymentController = sap.ui.controller("app.ui.myLists.checkOutMobilePaymentController");
		}
		checkoutMobilePaymentController.terminalId = terminalId;
		checkoutMobilePaymentController.launchCheckOutMobilePaymentController();
	}
});