sap.ui.controller('app.ui.myLists.viewReceiptController', {

	viewData : {
	
		loadingDataVisible : true,
	},
	
	stopFetching : true,
                  transactionId : null,

	launchViewReceiptController: function(shoppingHistory){  
		if(app.getPage(ID_VIEW_RECEIPT_PAGE)==null){
            var viewReceiptView = sap.ui.view({
              type : sap.ui.core.mvc.ViewType.XML,
              viewName : "app.ui.myLists.viewReceipt",
              controller : viewReceiptController,
            });
			 

            var viewReceiptPage = new sap.m.Page(ID_VIEW_RECEIPT_PAGE,{
				title : oBundle.getText("receipt"),
                content : [viewReceiptView],
                showNavButton : true,
                navButtonText : oBundle.getText("Back_Button"),
                navButtonTap : function() {
                	viewReceiptController.stopFetching = true;
                    app.back();
                },
            });
            var viewReceiptModel = new sap.ui.model.json.JSONModel();
            
            viewReceiptView.setModel(viewReceiptModel);
            app.addPage(viewReceiptPage);
        }
        
        app.getPage(ID_VIEW_RECEIPT_PAGE).getContent()[0].getModel().setData(viewReceiptController.viewData);
        app.to(ID_VIEW_RECEIPT_PAGE);
        viewReceiptController.stopFetching = false;
		if(shoppingHistory == undefined)
                  viewReceiptController.transactionId = openTransactionController.openTransactionData.currentTransactionId;
		else
                  viewReceiptController.transactionId = individualShoppingHistoryController.transactionIdForReceipt;
			
        SmartphoneService.getTransactionReceipt( viewReceiptController.transactionId, viewReceiptController.getRecieptDataBack);
                  
	},
	getRecieptDataBack : function(response,status) {
		if (status != 200) {
						checkErrorStatus(status);
						viewReceiptController.stopFetching = true;
						return;
				}
				else if( isRESTStatusCodeCorrect(response) ) {
						
						if(viewReceiptController.stopFetching == false && response.receipt == null){
							SmartphoneService.getTransactionReceipt( viewReceiptController.transactionId, viewReceiptController.getRecieptDataBack);
						}
						else {
                            if(response.receipt !== null) {
                                viewReceiptController.stopFetching = true;
                                viewReceiptController.viewData.loadingDataVisible = false;
                                app.getPage(ID_VIEW_RECEIPT_PAGE).getContent()[0].getModel().setData(viewReceiptController.viewData);
                                viewReceiptController.showReceipt(response.receipt);
                                app.back();
                            }
						}
				}
				else{
					viewReceiptController.stopFetching = true;
						checkErrorMobiliserStatus(response);
				}
	},
	
	showReceipt : function(data) {
                if (device.platform.match("Android"))
				{
					try
					{
						window.FileViewer.displayFile
						({	
							data:data, 
							error:"PDF Viewer Not Found"
						});
					}
					catch(exception)
					{
						//console.log("ERROR WHILE LOADING PDF");
					}
				}
				else
				{
					var childbrowser = window.plugins.childBrowser;
					if(childbrowser != null)
					{           
						window.plugins.childBrowser.loadData("Receipt" ,"Back",data,"application/pdf","");
					}	
					else
					{
						//console.log("ERROR WHILE LOADING PDF");
					}
				}

	}
});
