sap.ui.controller(
		'app.ui.offers.allOffersController',
		{
			allOffersModel : null,
			selectedFooterButton : null,
			selectedButtonOldIcon : "",
			allOffersView : null,
			searchBar : null,
			cardOffersView : [],
			singleOffersView : null,
			scanOffersView : null,
			scanCardOffersView : [],
			dataOffers : null,
			couponDetailView : null,
			singleOffersModel : null,
			modeOfScreen : null,
			multiAllOffers : null,
			cardOffersPage : [],
			cardOffersPageModel : [],
			cardOffersPageData : [],
			loadWalletAfterOffers : false,
			cardFeaturedOffersPageData : [],
			cardExpiringOffersPageData : [],
			cardWantedOffersPageData : [],
			carouselControl : null,
			allOffersPostRenderingCall : null,
			currentCouponTypeid : null,
			startRenderTime : 0,
			startServiceTime : 0,
			currentProgramId : "",
			offersRefreshTime : 0,
			indexOfCarouselToDisplay : 0,

			displayAllOffersScreen : function() {
				allOffersController.startRenderTime = util.startPerformanceReading();
				
				if (!app.getPage(CAROUSEL_PAGE)) {
					allOffersController.allOffersView = sap.ui.view({
						type : sap.ui.core.mvc.ViewType.XML,
						viewName : "app.ui.offers.allOffersView",
						id : "allOffersView",
						controller : this
					});

					if (sliderMenuController == undefined) {
						sliderMenuController = sap.ui.controller("app.ui.slidermenu.sliderMenuController");
						sliderMenuController.createSliderMenu();
					}

					var carouselTitle = "";
					if (userState['BRANDTYPE'] === "single")
						carouselTitle = (oBundle.getText("my_offers"));
					else
						carouselTitle = (oBundle.getText("AllOffersTitle"));

					allOffersController.mapButton = new sap.m.Button('allOffersMapButton',
							{
								icon : "sap-icon://map",
								activeIcon : "sap-icon://map",
								tap : function(event, src) {
									if (userState['DEMO_MODE'] == true) {
										logError("demo_mode_message","In Demo Mode","Not Supported In Demo Mode");
										return;
									}
									if (mapController == undefined) {
										mapController = sap.ui.controller("app.ui.googleMaps.mapController");
									}
									mapController.programId = allOffersController.currentProgramId;
									mapController.previousPage = CAROUSEL_PAGE;
									mapController.updateMyLocation();
									mapController.launchPage();
								}
							});

					var headerBar = new sap.m.Bar(
							{
								contentLeft : [ new sap.m.Button('offersMenuButton',
										{
											icon : "sap-icon://menu2",
											activeIcon : "sap-icon://menu2",
											tap : function(event, src) {
												sliderMenuController.action('offersMenuButton');
											}
										}).addStyleClass("menuButtonIconFont") ],
								contentMiddle : [ new sap.m.Label("offersCarouselLabel", 
										{
											text : carouselTitle
										}) ],
								contentRight : allOffersController.mapButton
							});
					headerBar.addStyleClass("offersHeader");
					// By default, map button will be invisible for All
					// Offers screen
					if (userState['BRANDTYPE'] === "single") {
						allOffersController.mapButton.setVisible(true);
					} else
						allOffersController.mapButton.setVisible(false);

					button1 = new sap.m.Button('segmentedButton1',
							{
								text : oBundle.getText("Offers_All_Label"),
								type : sap.m.ButtonType.Default,
								icon : "app/ui/offers/images/all-offer-icon.png",
								activeIcon : "app/ui/offers/images/all-offer-icon-active.png",
								tap : function(event) {
									allOffersController.changeFooterButtonSelection(this);
									allOffersController.displayAllOffersData();
								},
								enabled : true
							});

					var button2 = new sap.m.Button('segmentedButton2',
							{
								text : oBundle.getText("Offers_Featured_Label"),
								type : sap.m.ButtonType.Default,
								icon : "app/ui/offers/images/featured-icon.png",
								activeIcon : "app/ui/offers/images/featured-icon-active.png",
								enabled : true,
								tap : function(event) {
									allOffersController.changeFooterButtonSelection(this);
									allOffersController.displayFeaturedData();
								}
							});

					var button3 = new sap.m.Button('segmentedButton3',
							{
								type : sap.m.ButtonType.Default,
								icon : "app/ui/offers/images/scan-icon.png",
								text : oBundle.getText("redeem_label"),
								activeIcon : "app/ui/offers/images/scan-icon-active.png",
								enabled : true,
								tap : function(event) {
									allOffersController.changeFooterButtonSelection(this);
									allOffersController.displayScanOffersScreen();
								}
							});

					var button4 = new sap.m.Button('segmentedButton4',
							{
								type : sap.m.ButtonType.Default,
								icon : "app/ui/offers/images/expiring-icon.png",
								activeIcon : "app/ui/offers/images/expiring-icon-active.png",
								text : oBundle.getText("Offers_Expiring_Label"),
								enabled : true,
								tap : function(event) {
									allOffersController.changeFooterButtonSelection(this);
									allOffersController.displayExpiringData();
								}
							});

					var button5 = new sap.m.Button('segmentedButton5',
							{
								type : sap.m.ButtonType.Default,
								icon : "app/ui/offers/images/wanted-icon.png",
								activeIcon : "app/ui/offers/images/wanted-icon-active.png",
								text : oBundle.getText("offers_wanted"),
								enabled : true,
								tap : function(event) {
									allOffersController.changeFooterButtonSelection(this);
									allOffersController.displayWantedData();
								}
							});

					allOffersController.changeFooterButtonSelection(button1);

					var footer = new sap.m.Bar('footerBar', {
						contentLeft : [],
						contentMiddle : [ button3, button2, button1, button4, button5 ],
						contentRight : [],
						enableFlexBox : true
					});

					// var searchbar = new sap.m.SearchField("offersSearchField",
					// {
								// placeholder : oBundle.getText("Offers_Search_Button"),
								// width : "100%",
								// search : this.search,
					// });
					
					allOffersController.searchBar = new sap.m.SearchField("offersSearchField1",
					{
								placeholder : oBundle.getText("Offers_Search_Button"),
								width : "100%",
								search : this.search
					});

					var allOffersPage = new sap.m.Page(ALL_OFFERS_PAGE,
							{
								content : [ allOffersController.searchBar, allOffersController.allOffersView],
								showNavButton : false,
								showHeader : false,
								enableScrolling : true
							});

					var carouselControl = new sap.m.Carousel("offersCarousel",
							{
								pageIndicatorPlacement : sap.m.PlacementType.Top,
							});

					// create a function which contains a fix for the erroneous behavior
					var fnOntouchstart = jQuery.proxy(
							function(oEvent) {
								// for controls which need to know if they should handle events from the Carousel control
								if (this._oSwipeView) {
									var oElement = jQuery(oEvent.target).control(0);
									if (oElement instanceof sap.m.Image) {
										// Make an Exception for sap.m.Image. Ensure that horizontal swipe is performed anyway
										oEvent.originalEvent._sapui_handledByControl = false;
									}
									this._oSwipeView.__start(oEvent);
								}
								oEvent.originalEvent._sapui_handledByControl = true;
							}, carouselControl);
					// replace the erroneous function in the carousel
					carouselControl.ontouchstart = fnOntouchstart;
					carouselControl.addPage(allOffersPage);
					
					carouselControl.attachLoadPage(function(oControlEvent) {
						var sPageId = oControlEvent.getParameters().pageId;
						jQuery.sap.log.info("sap.m.Carousel: loading page " + sPageId);
						
						var activePage = allOffersController.getOffersCarouselActivePage();
						var indexOfActivePage = allOffersController.carouselControl.indexOfPage(activePage);
						var offerScreenTitle = sap.ui.getCore().byId("offersCarouselLabel");
						var pageTitle = "";
						if (indexOfActivePage == 0) {
							if (userState['BRANDTYPE'] === "single")
								offerScreenTitle.setText(oBundle.getText("my_offers"));
							else {
								offerScreenTitle.setText(oBundle.getText("AllOffersTitle"));
								allOffersController.mapButton.setVisible(false);
							}
						} else {
							if(allOffersController.cardOffersPageData[indexOfActivePage - 1] !== undefined) {
								pageTitle = allOffersController.cardOffersPageData[indexOfActivePage - 1].programName+ " " + oBundle.getText("offers_word");
								offerScreenTitle.setText(pageTitle);
								allOffersController.currentProgramId = allOffersController.cardOffersPageData[indexOfActivePage - 1].programId;
								allOffersController.mapButton.setVisible(true);
							}
						}
						//app.getPage(CAROUSEL_PAGE).getCustomHeader().rerender();

						// Example for usage of 'loadPage' event: Add content to 'demoPage' when it is  loaded into the carousel
						if (sPageId == allOffersPage.getId()) {
							// To demonstrate a loading delay, the following timeout waits for two seconds, until it hides
							// the carousel's busy indicator and shows the demo page
							setTimeout(
									function() {
										if (allOffersController.modeOfScreen !== "scanOffers") {
											allOffersPage.addContent(allOffersController.allOffersView);
											if (userState['BRANDTYPE'] === "multi" && allOffersController.cardOffersPage.length > 0) {
												// for (i in allOffersController.cardOffersView)
												// {
												// allOffersController.carouselControl.fireLoadPage({
												// pageId:"CardOfferScreen1"});
												// allOffersController.cardOffersPage[0].addContent(allOffersController.cardOffersView[0]);
												// }
												for (i in allOffersController.cardOffersPage) {
													allOffersController.cardOffersPage[i].rerender();
												}
											}
										} else if (allOffersController.modeOfScreen == "scanOffers") {
											allOffersPage.addContent(allOffersController.scanOffersView);
											if (userState['BRANDTYPE'] === "multi" && allOffersController.cardOffersPage.length > 0)
												allOffersController.cardOffersPage[0].addContent(allOffersController.scanCardOffersView[0]);
										}

										// if(userState['BRANDTYPE'] === "multi" && allOffersController.cardOffersPage.length  > 0) {
										// allOffersController.carouselControl.fireLoadPage({
										// pageId: "CardOfferScreen1"});
										// }
									}, 500);
						} else {
							// for(i in allOffersController.cardOffersPage)
							// {
							// 	if(sPageId == allOffersController.cardOffersPage[i].getId())
							// 	{
							// 		allOffersController.cardOffersPage[i].addContent(allOffersController.cardOffersView[i]);
							// 	}
							// }
						}
					}),

					carouselControl.attachPageChanged(function(oControlEvent) {
						var sPageId = oControlEvent.getParameters().pageId;
						jQuery.sap.log.info("sap.m.Carousel: loading page: PageChanged: "+ sPageId);
						var activePage = allOffersController.getOffersCarouselActivePage();
						var indexOfActivePage = allOffersController.carouselControl.indexOfPage(activePage);
						var offerScreenTitle = sap.ui.getCore().byId("offersCarouselLabel");
						var pageTitle = "";
						if (indexOfActivePage == 0) {
							if (userState['BRANDTYPE'] === "single")
								offerScreenTitle.setText(oBundle.getText("my_offers"));
							else {
								offerScreenTitle.setText(oBundle.getText("AllOffersTitle"));
								allOffersController.mapButton.setVisible(false);
							}
						} else {
							pageTitle = allOffersController.cardOffersPageData[indexOfActivePage - 1].programName+ " " + oBundle.getText("offers_word");
							offerScreenTitle.setText(pageTitle);
							allOffersController.currentProgramId = allOffersController.cardOffersPageData[indexOfActivePage - 1].programId;
							allOffersController.mapButton.setVisible(true);
						}
						
						app.getPage(CAROUSEL_PAGE).getCustomHeader().rerender();
					});

					var carouselPage = new sap.m.Page(CAROUSEL_PAGE, {
						title : oBundle.getText("add_existing_card"),
						content : [ carouselControl ],
						footer : footer,
						customHeader : headerBar,
						enableScrolling : false,
						showNavButton : false
					});
					carouselPage.addStyleClass("customFooter");
					allOffersController.carouselControl = carouselControl;
					this.allOffersModel = new sap.ui.model.json.JSONModel();
					allOffersPage.setModel(this.allOffersModel);
					
					allOffersController.allOffersPostRenderingCall = {
							onAfterRendering : function() {
								// allOffersController.applyOfferImages();
							}
					};

					var carouselReload = {
							onAfterRendering : function() {
								allOffersController.reloadCarouselIfNeeded();
							}
					};
					// allOffersController.allOffersView.byId("offersList").addDelegate(allOffersController.allOffersPostRenderingCall);
					// allOffersPage.addDelegate(allOffersController.allOffersPostRenderingCall);
					carouselControl.addDelegate(carouselReload);
					app.addPage(carouselPage);
					
					/*var buttonScan = new sap.m.Button('segmentedScanButton',
							{
								type : sap.m.ButtonType.Default,
								icon : "app/ui/offers/images/scan-icon.png",
								text : oBundle.getText("redeem_label"),
								activeIcon : "app/ui/offers/images/scan-icon-active.png",
								enabled : true,
								tap : function(event) {
									allOffersController.changeFooterButtonSelection(this);
									allOffersController.displayScanOffersScreen();
								}
							});

					buttonControlForScanCard = new ScanOffersButtonControl(
							{
								content : [ buttonScan ]
							});
					
					 * NOT AVAILABLE IN UI5 1.8.7
					 * carouselPage.addEventDelegate({ onAfterRendering:
					 * function(oEvent) {
					 * buttonControlForScanCard.attachToPage(carouselPage,
					 * buttonControlForScanCard); } });
					 */
				}
				
				
				var getAllOffersData = {
						locale : navigator.language.split("-")[0]
							// ,
							// programId: "500000553"
				};

				// if(allOffersController.dataOffers !== null) {
				// util.closeBusyDialog();
				// // if(sliderMenuController.isNavigationViaSliderMenu == true) app.to(CAROUSEL_PAGE,"show");
				// // else app.to(CAROUSEL_PAGE);
				// // sliderMenuController.isNavigationViaSliderMenu = false;
				// app.to(CAROUSEL_PAGE);
				// return;
				// }
				
				
				if(userState.DEMO_MODE == false){
					if (allOffersController.isRefreshNeeded() || allOffersController.subscriptionChangesMade == true || (homeController && homeController.isRefreshNeeded())) {
						util.createBusyDialog(oBundle.getText("Offers_Progress_Message"),oBundle.getText("Offers_Progress_Message_Title"));
						allOffersController.startServiceTime = util.startPerformanceReading();
	                  if(userState['LOGGED_IN']){
	                    SmartphoneService.getAllOffers(getAllOffersData,allOffersController.getAllOffersDataBack);
	                  }
	                  else {
						
	                    SmartphoneService.getAnonymousOffers(getAllOffersData,allOffersController.getAllOffersDataBack);
	                  }
						
					} 
					else {
						if(allOffersController.modeOfScreen == "scanOffers") {
							allOffersController.displayScanOffersScreen();
						}
						if (allOffersController.indexOfCarouselToDisplay !== 0) {
							allOffersController.loadCarouselCardOfferPageForIndex(allOffersController.indexOfCarouselToDisplay);
							allOffersController.indexOfCarouselToDisplay = 0;
						} 
						else {
							if (app.getCurrentPage().sId === CAROUSEL_PAGE) {
								app.to(CAROUSEL_PAGE);
								var page = allOffersController.carouselControl.getPages()[0];
								setTimeout(function() {
									allOffersController.carouselControl.setActivePage(page);
								}, 500);
							} else {
								var page = allOffersController.carouselControl.getPages()[0];
								allOffersController.carouselControl.setActivePage(page);
								app.to(CAROUSEL_PAGE);
							}
						}
						util.closeBusyDialog(); // to close login dialog
					}
				}else{
					util.createBusyDialog(oBundle.getText("Offers_Progress_Message"),oBundle.getText("Offers_Progress_Message_Title"));
					if(userState['LOGGED_IN']){
	                    SmartphoneService.getAllOffers(getAllOffersData,allOffersController.getAllOffersDataBack);
	                  }
				}
				

				//allOffersController.carouselControl.rerender();
			},
			displayCardDetails : function(){
				var activePage = allOffersController.getOffersCarouselActivePage();
				var indexOfActivePage = allOffersController.carouselControl.indexOfPage(activePage);
				var id = allOffersController.cardOffersPageData[indexOfActivePage - 1].programId;
				if(subscribedPrograms && subscribedPrograms.length > 0){
					for(var i = 0 ; i < subscribedPrograms.length ; i++){
						if(id == subscribedPrograms[i].programId){
							 if (cardController == undefined) {
						        cardController = sap.ui.controller("app.ui.card.card");
						    }
						    cardController.launchCardPage(subscribedPrograms[i].cardId, subscribedPrograms[i].membershipId, subscribedPrograms[i].programName, subscribedPrograms[i].programId);
						}
					}
				}
			},
			
			// Function called from All Offers/My Offers tap in Slider menu
			navigateToOffersScreen : function() {
				allOffersController.indexOfCarouselToDisplay = 0;
				allOffersController.displayAllOffersScreen();
				app.to(CAROUSEL_PAGE);
				if (userState.BRANDTYPE == "single") {
					allOffersController.carouselControl.setShowPageIndicator(false);
				}else{
					allOffersController.carouselControl.setShowPageIndicator(true);
				}
			},

			// Function call to change the footer selection visually to the passed button.
			// This function is triggered after tap on a footer button including the scan/redeem offers button
			changeFooterButtonSelection : function(currentSelButton) {
				if (allOffersController.selectedFooterButton !== null) {
					allOffersController.selectedFooterButton.removeStyleClass("footerBarBtnSel");
					if (allOffersController.selectedFooterButton.getId() !== "segmentedScanButton")
						allOffersController.selectedFooterButton.setIcon(allOffersController.selectedButtonOldIcon);
					else {
						var img = sap.ui.getCore().byId("segmentedScanButton" + "-img");
						if (img && allOffersController.selectedFooterButton.getIcon()) {
							img.setSrc(allOffersController.selectedFooterButton.getIcon());
						}
					}
				}
				currentSelButton.addStyleClass("footerBarBtnSel");
				allOffersController.selectedButtonOldIcon = currentSelButton.getIcon();

				if (currentSelButton.getId() !== "segmentedScanButton")
					currentSelButton.setIcon(currentSelButton.getActiveIcon());
				else {
					var img = sap.ui.getCore().byId(currentSelButton.getId() + "-img");
					if (img && currentSelButton.getActiveIcon()) {
						img.setSrc(currentSelButton.getActiveIcon());
					}
				}
				allOffersController.selectedFooterButton = currentSelButton;
			},

			// Utility function to filter the all offers array based on program/brand.
			// Hence this function finds use in getAllOffers response callback function
			getOffersForProgramId : function(programId) {
				var offersForProgram = [];
				for ( var i = 0; i < allOffersController.dataOffers.length; i++) {
					if (allOffersController.dataOffers[i].programId == programId) {
						offersForProgram
						.push(allOffersController.dataOffers[i]);
					}
				}

				offersForProgram = allOffersController.applyOfferContentFlag(offersForProgram);
				// if(offersForProgram.length > 0) {
				// offersForProgram.isOffersContentEmpty = false;
				// } else offersForProgram.isOffersContentEmpty = true;
				return offersForProgram;
			},

			// Utility function to display empty offers message if no offers present for a program/brand or category of offers like all/expiration/featured/wanted
			// This call finds usage in getAllOffers for all offers or when category/page offers arrays are populated before passing such data to respective models.
			applyOfferContentFlag : function(pageData) {
				if (pageData.length > 0) {
					pageData.isOffersContentEmpty = false;
					pageData.noContentText = "";
				} 
				else {
					pageData.isOffersContentEmpty = true;
					pageData.noContentText = oBundle.getText("no_offer_to_display");
				}
				return pageData;
			},

			// Function to switch from scan offers layout to offers list view if needed.
			// This function call is important as this switch is needed to be done if user taps on any horizontal navigation tab other than scan offers.
			// Thus this call should be first call for part of event handlers for bottom navigation bar
			// Also other usage of this function call is to clear the search bar value and make search bar invisible.
			backToNormalOffersMode : function() {
				allOffersController.searchBar.setValue(""); 
				allOffersController.searchBar.setVisible(false);
				if (allOffersController.modeOfScreen == "scanOffers") {
					allOffersController.searchBar.setVisible(false);
					var carouselFirstOffersPage = allOffersController.carouselControl.getPages()[0];
					carouselFirstOffersPage.removeAllContent();
					carouselFirstOffersPage.addContent(allOffersController.searchBar);
					carouselFirstOffersPage.addContent(allOffersController.allOffersView);
					
					for ( var i = 1; i < allOffersController.carouselControl.getPages().length; i++) {
						currentPage = allOffersController.carouselControl.getPages()[i];
						currentPage.removeAllContent();
						currentPage.addContent(allOffersController.cardOffersView[i - 1]);
					}
				}
			},

			displayFeaturedData : function() {
				allOffersController.backToNormalOffersMode();
				allOffersController.modeOfScreen = "AllFeature";
				allOffersController.featuredOffers = [];
				for ( var i = 0; i < allOffersController.dataOffers.length; i++) {
					if (allOffersController.dataOffers[i].isFeatured == true) {
						allOffersController.featuredOffers.push(allOffersController.dataOffers[i]);
					}
				}
				allOffersController.featuredOffers = allOffersController.applyOfferContentFlag(allOffersController.featuredOffers);
				allOffersController.featuredOffers.doNotShowBrandHeader = false;
				allOffersController.allOffersModel.setData(allOffersController.featuredOffers);

				if (userState.BRANDTYPE !== "single") {
					allOffersController.cardFeaturedOffersPageData = [];
					for ( var j = 0; j < allOffersController.cardOffersPage.length; j++) {
						var currentPageFeaturedOffers = [];
						var currentPageData = allOffersController.cardOffersPageData[j];
						for ( var i = 0; i < currentPageData.length; i++) {
							if (currentPageData[i].isFeatured == true) {
								currentPageFeaturedOffers.push(currentPageData[i]);
							}
						}

						currentPageFeaturedOffers.programName = currentPageData.programName;
						currentPageFeaturedOffers.logo = currentPageData.logo;
						currentPageFeaturedOffers.programDetails = currentPageData.programDetails;
						currentPageFeaturedOffers = allOffersController.applyOfferContentFlag(currentPageFeaturedOffers);
						allOffersController.cardFeaturedOffersPageData.push(currentPageFeaturedOffers);
						allOffersController.cardOffersPageModel[j].setData(currentPageFeaturedOffers);
					}
				}
				// allOffersController.reloadCarouselIfNeeded();
			},

			displayAllOffersData : function() {
				allOffersController.backToNormalOffersMode();
				allOffersController.searchBar.setVisible(true);
				allOffersController.modeOfScreen = "MultiAll";
				// allOffersController.multiAllOffers = allOffersController.dataOffers;
				allOffersController.dataOffers = allOffersController.applyOfferContentFlag(allOffersController.dataOffers);
				allOffersController.dataOffers.doNotShowBrandHeader = false;
				allOffersController.allOffersModel.setData(allOffersController.dataOffers);

				if (userState.BRANDTYPE !== "single") {
					for ( var j = 0; j < allOffersController.cardOffersPage.length; j++) {
						allOffersController.cardOffersPageModel[j].setData(allOffersController.cardOffersPageData[j]);
					}
				}
			},

			displayExpiringData : function() {
				allOffersController.backToNormalOffersMode();
				allOffersController.modeOfScreen = "AllExpiring";
				allOffersController.expiringOffers = [];

				for ( var i = 0; i < allOffersController.dataOffers.length; i++) {
					if (allOffersController.dataOffers[i].isExpiring == true) {
						allOffersController.expiringOffers.push(allOffersController.dataOffers[i]);
					}
				}
				allOffersController.expiringOffers = allOffersController.applyOfferContentFlag(allOffersController.expiringOffers);
				allOffersController.expiringOffers.doNotShowBrandHeader = false;
				allOffersController.allOffersModel.setData(allOffersController.expiringOffers);

				if (userState.BRANDTYPE !== "single") {
					allOffersController.cardExpiringOffersPageData = [];
					
					for ( var j = 0; j < allOffersController.cardOffersPage.length; j++) {
						var currentPageExpiringOffers = [];
						var currentPageData = allOffersController.cardOffersPageData[j];
						
						for ( var i = 0; i < currentPageData.length; i++) {
							if (currentPageData[i].isExpiring == true) {
								currentPageExpiringOffers
								.push(currentPageData[i]);
							}
						}
						currentPageExpiringOffers.programName = currentPageData.programName;
						currentPageExpiringOffers.logo = currentPageData.logo;
						currentPageExpiringOffers.programDetails = currentPageData.programDetails;
						currentPageExpiringOffers = allOffersController.applyOfferContentFlag(currentPageExpiringOffers);
						allOffersController.cardExpiringOffersPageData.push(currentPageExpiringOffers);
						allOffersController.cardOffersPageModel[j].setData(currentPageExpiringOffers);
					}
				}
			},

			populateWantedOffers : function() {
				if(userState['LOGGED_IN']){
				allOffersController.wantedOffers = [];
				
				for ( var i = 0; i < allOffersController.dataOffers.length; i++) {
					if (allOffersController.dataOffers[i].isWanted == true) {
						allOffersController.wantedOffers.push(allOffersController.dataOffers[i]);
					}
				}
				allOffersController.wantedOffers = allOffersController.applyOfferContentFlag(allOffersController.wantedOffers);

				if (userState.BRANDTYPE !== "single") {
					allOffersController.cardWantedOffersPageData = [];

					for ( var j = 0; j < allOffersController.cardOffersPage.length; j++) {
						var currentPageWantedOffers = [];
						var currentPageData = allOffersController.cardOffersPageData[j];
						
						for ( var i = 0; i < currentPageData.length; i++) {
							if (currentPageData[i].isWanted == true) {
								currentPageWantedOffers.push(currentPageData[i]);
							}
						}
						currentPageWantedOffers.membershipId = currentPageData.membershipId;
						currentPageWantedOffers.programName = currentPageData.programName;
						currentPageWantedOffers.logo = currentPageData.logo;
						currentPageWantedOffers.programDetails = currentPageData.programDetails;
						currentPageWantedOffers = allOffersController.applyOfferContentFlag(currentPageWantedOffers);
						
						allOffersController.cardWantedOffersPageData.push(currentPageWantedOffers);
					}
				} 
				else {
					allOffersController.wantedOffers.membershipId = subscribedPrograms[0].membershipId;
					allOffersController.wantedOffers.programName = subscribedPrograms[0].programName;
					allOffersController.wantedOffers.programId = subscribedPrograms[0].programId;
					if (userState['DEMO_MODE'] == true)
						allOffersController.wantedOffers.logo = subscribedPrograms[0].logo;
					else
						allOffersController.wantedOffers.logo = "data:image/png;base64,"+ subscribedPrograms[0].logo;
					allOffersController.wantedOffers.programDetails = allOffersController.generateProgramTierAndPointsInfo(subscribedPrograms[0]);
				}
				}
			},

			displayWantedData : function() {
				allOffersController.backToNormalOffersMode();
				allOffersController.modeOfScreen = "AllWanted";
				allOffersController.wantedOffers = [];

				for ( var i = 0; i < allOffersController.dataOffers.length; i++) {
					if (allOffersController.dataOffers[i].isWanted == true) {
						allOffersController.wantedOffers.push(allOffersController.dataOffers[i]);
					}
				}
				allOffersController.wantedOffers = allOffersController.applyOfferContentFlag(allOffersController.wantedOffers);
				allOffersController.wantedOffers.doNotShowBrandHeader = false;
				//Handling in case of anonymous mode.
				if(userState['LOGGED_IN']){
					if (userState.BRANDTYPE == "single") {
						// This code is being used to display Program/Brand info in Scan/Redeeem mode for Single Brand App mode.
						
						allOffersController.wantedOffers.membershipId = subscribedPrograms[0].membershipId;
						allOffersController.wantedOffers.programName = subscribedPrograms[0].programName;
						allOffersController.wantedOffers.programId = subscribedPrograms[0].programId;
						if (userState['DEMO_MODE'] == true)
							allOffersController.wantedOffers.logo = subscribedPrograms[0].logo;
						else
							allOffersController.wantedOffers.logo = "data:image/png;base64,"+ subscribedPrograms[0].logo;
						allOffersController.wantedOffers.programDetails = allOffersController.generateProgramTierAndPointsInfo(subscribedPrograms[0]);
					}
				}
				allOffersController.allOffersModel.setData(allOffersController.wantedOffers);

				if (userState.BRANDTYPE !== "single") {
					allOffersController.cardWantedOffersPageData = [];
					for ( var j = 0; j < allOffersController.cardOffersPage.length; j++) {
						var currentPageWantedOffers = [];
						var currentPageData = allOffersController.cardOffersPageData[j];
						
						for ( var i = 0; i < currentPageData.length; i++) {
							if (currentPageData[i].isWanted == true) {
								currentPageWantedOffers.push(currentPageData[i]);
							}
						}
						currentPageWantedOffers.membershipId = currentPageData.membershipId;
						currentPageWantedOffers.programName = currentPageData.programName;
						currentPageWantedOffers.logo = currentPageData.logo;
						currentPageWantedOffers.programDetails = currentPageData.programDetails;
						currentPageWantedOffers = allOffersController.applyOfferContentFlag(currentPageWantedOffers);
						
						allOffersController.cardWantedOffersPageData.push(currentPageWantedOffers);
						allOffersController.cardOffersPageModel[j].setData(currentPageWantedOffers);
					}
				}
			},

			displayScanOffersScreen : function() {
				allOffersController.backToNormalOffersMode();
				allOffersController.searchBar.setVisible(false);
				allOffersController.modeOfScreen = "scanOffers";
				allOffersController.populateWantedOffers();
				var carouselFirstOffersPage = allOffersController.carouselControl.getPages()[0];
				carouselFirstOffersPage.removeAllContent();

				if (userState['BRANDTYPE'] === "multi") {
					// Here doNotShowBrandHeader does not mean Single Brand app but means the Offers Screen is not All Offers but Individual/Single Brand Offers screen
					// However for Single Brand App mode, we need to show Program header and hence will make doNotShowBrandHeader as true
					allOffersController.wantedOffers.doNotShowBrandHeader = false;
				} else {
					allOffersController.wantedOffers.doNotShowBrandHeader = true;
				}
				allOffersController.allOffersModel.setData(allOffersController.wantedOffers);
				allOffersController.scanOffersView.setModel(allOffersController.allOffersModel);
				carouselFirstOffersPage.addContent(allOffersController.scanOffersView);

				for ( var i = 1; i < allOffersController.carouselControl.getPages().length; i++) {
					currentPage = allOffersController.carouselControl.getPages()[i];
					currentPage.removeAllContent();
					allOffersController.cardOffersPageModel[i - 1].setData(allOffersController.cardWantedOffersPageData[i - 1]);
					allOffersController.scanCardOffersView[i - 1].setModel(allOffersController.cardOffersPageModel[i - 1]);
					currentPage.addContent(allOffersController.scanCardOffersView[i - 1]);
				}
				allOffersController.searchBar.setVisible(false);
			},

			onAfterRendering : function() {
			if (userState['LOGGED_IN']) {
				if (allOffersController.scanOffersView !== undefined && allOffersController.scanOffersView !== null) {
					//var imagePlaceHolderId = allOffersController.scanOffersView.byId("barcode-image").getId();
					var viewId = allOffersController.scanOffersView.getId();
					var listId = allOffersController.scanOffersView.byId("scan_offers_offersList").getId();
					var data = allOffersController.allOffersModel.getData();
					
					for (key in data) {
						if (data[key].couponInstanceid != null) {
							var barcode = data[key].strCode;
							// $('#'+imagePlaceHolderId+'-'+listId+'-'+key).barcode(barcode.toString(), "code128", { barWidth: 2, barHeight: 120 });

							$('#' + viewId + '--' + "barcode-image" + '-' + listId + '-' + key).barcode(barcode.toString(),"code128", {
										barWidth : 1,
										barHeight : 60
									});
							// $('#' + viewId + '--' + "barcode-image" + '-' + listId + '-' + key).barcode("123456789", "code128", { barWidth: 2, barHeight: 60 });
						} 
						else {
						}
					}
					if (userState.BRANDTYPE == "single") {
						if (allOffersController.wantedOffers !== undefined && allOffersController.wantedOffers.membershipId !== undefined) {
							
							$('#' + viewId + '--' + "barcode-program-image").barcode(allOffersController.wantedOffers.membershipId.toString(),"code128", {
												barWidth : 1,
												barHeight : 38
											});
						}
					}
				}
				
				for ( var i = 0; i < allOffersController.scanCardOffersView.length; i++) {
					//var imagePlaceHolderId = allOffersController.scanCardOffersView[i].byId("barcode-image").getId();
					var viewId = allOffersController.scanCardOffersView[i].getId();
					var listId = allOffersController.scanCardOffersView[i].byId("scan_offers_offersList").getId();
					var data = allOffersController.cardWantedOffersPageData[i];
					
					for (key in data) {
						if (data[key].couponInstanceid != null) {
							var barcode = data[key].strCode;
							// $('#'+imagePlaceHolderId +'-'+listId+'-'+key).barcode( barcode.toString(), "code128", { barWidth: 2, barHeight: 120 });
							$('#' + viewId + '--' + "barcode-image" + '-' + listId + '-' + key).barcode(barcode.toString(), "code128", {
										barWidth : 1,
										barHeight : 60
									});
							// $('#' + viewId + '--' + "barcode-image" + '-' + listId + '-' +  key).barcode("123456789", "code128", { barWidth: 2, barHeight: 60 });
						} 
						else {
						}
					}
					if (data !== undefined) {
						$('#' + viewId + '--' + "barcode-program-image").barcode(data.membershipId.toString(),"code128", {
							barWidth : 1,
							barHeight : 38
						});
					}
					if(subscribedPrograms.length > i){
						var headerBar = allOffersController.scanCardOffersView[i].byId("scan_offers_single_brand_offers_view_card_detail");
						if (headerBar != undefined && headerBar != null) {
							var hId = allOffersController.scanCardOffersView[i].byId("scan_offers_single_brand_offers_view_card_detail").getId();
							if (subscribedPrograms[i].logoUrlOrColour != undefined && subscribedPrograms[i].logoUrlOrColour.length > 0) {

								$('#' + hId).css("background",subscribedPrograms[i].logoUrlOrColour);
								$('#' + hId).css("backgroundColor",subscribedPrograms[i].logoUrlOrColour);
							} 
							else {
								$('#' + hId).css("background", "#f2f2f2");
								$('#' + hId).css("backgroundColor","#f2f2f2");
							}
						}
					}
					
				}

				
				if (userState['BRANDTYPE'] == "single" && subscribedPrograms.length > 0 && allOffersController.scanOffersView != null) {
					
					var headerBar = allOffersController.scanOffersView.byId("scan_offers_single_brand_offers_view_card_detail");
					if (headerBar != undefined && headerBar != null) {
						
						var hId = allOffersController.scanOffersView.byId("scan_offers_single_brand_offers_view_card_detail").getId();
						if (subscribedPrograms[0].logoUrlOrColour != undefined && subscribedPrograms[0].logoUrlOrColour.length > 0) {

							$('#' + hId).css("background",subscribedPrograms[0].logoUrlOrColour);
							$('#' + hId).css("backgroundColor",subscribedPrograms[0].logoUrlOrColour);
						} 
						else {
							$('#' + hId).css("background", "#f2f2f2");
							$('#' + hId).css("backgroundColor","#f2f2f2");
						}
					}
				}
				
				
				if (allOffersController.modeOfScreen == "scanOffers") {
					allOffersController.searchBar.setVisible(false);
				}

				//The Below code is o change the color of the headerbar in case for each program based on the responsefrom server.
				if (userState['BRANDTYPE'] != undefined && userState['BRANDTYPE'] == "multi") {

					for ( var i = 0; i < subscribedPrograms.length; i++) {
						var pageInstance = sap.ui.getCore().byId("CardOfferScreen" + (i + 1));
						if (pageInstance != undefined && pageInstance != null) {
							var headerBarView = pageInstance.getContent()[0].byId("single_brand_offers_view_card_detail");
							if (headerBarView != undefined && headerBarView != null) {

								var headerBar = pageInstance.getContent()[0].byId("single_brand_offers_view_card_detail").getDomRef();
								var hId = pageInstance.getContent()[0].byId("single_brand_offers_view_card_detail").getId();
								if (headerBar != undefined && headerBar != null) {
									if (subscribedPrograms[i].logoUrlOrColour != undefined && subscribedPrograms[i].logoUrlOrColour.length > 0) {
										$('#' + hId).css("background",subscribedPrograms[i].logoUrlOrColour);
										$('#' + hId).css("backgroundColor",subscribedPrograms[i].logoUrlOrColour);
									} 
									else {
										$('#' + hId).css("background","#f2f2f2");
										$('#' + hId).css("backgroundColor","#f2f2f2");
									}
								}
							}
						}
					}
				}
			}
			},

			backToAllOffersScreen : function() {
				app.getCurrentPage().removeAllContent();
				app.getCurrentPage().insertContent(allOffersController.allOffersView);
			},

			getAllOffersDataBack : function(response, status) {
				if (status != 200) {
					checkErrorStatus(status);
					return;
				}
				if (isRESTStatusCodeCorrect(response)) {
					allOffersController.resetOffersState();
					allOffersController.rebootCarouselControl();

					if (response.offer === undefined || response.offer == null || response.offer.length == 0) {
						allOffersController.dataOffers = [];
						allOffersController.dataOffers.isOffersContentEmpty = true;
					} 
					else {
						allOffersController.dataOffers = response.offer;
						if (allOffersController.dataOffers.length > 0) {
							allOffersController.dataOffers.isOffersContentEmpty = false;
						}
						allOffersController.convertOfferDatesToReadableFormat();
					}

					for ( var i = 0; i < allOffersController.dataOffers.length; i++) {
						if (allOffersController.dataOffers[i].image !== null) {
							allOffersController.dataOffers[i].image = "data:image/png;base64,"+ allOffersController.dataOffers[i].image;
							allOffersController.dataOffers[i].url = allOffersController.dataOffers[i].image;
							allOffersController.dataOffers[i].thumbUrl = allOffersController.dataOffers[i].image;
						}
						allOffersController.dataOffers[i].imageSource = "";
						
						if (allOffersController.dataOffers[i].thumbUrl == null || allOffersController.dataOffers[i].thumbUrl.length == 0 || userState['DEMO_MODE'] == true) {
							allOffersController.dataOffers[i].thumbUrl = allOffersController.dataOffers[i].url;
						}
						//In case the url image is not there, insertinga blank transparent image so that the uilayout doesn't break on redeem offers page.
						if (allOffersController.dataOffers[i].url == null || allOffersController.dataOffers[i].url.length == 0) {
							allOffersController.dataOffers[i].url = "data:image/gif;base64,R0lGODlhAQABAAAAACH5BAEKAAEALAAAAAABAAEAAAICTAEAOw==";
						}
						if (allOffersController.dataOffers[i].isExpiring === null) {
							allOffersController.dataOffers[i].isExpiring = false;
						}
						if (allOffersController.dataOffers[i].isWanted === null) {
							allOffersController.dataOffers[i].isWanted = false;
						}
						if (allOffersController.dataOffers[i].isFeatured === null) {
							allOffersController.dataOffers[i].isFeatured = false;
						}
						if (allOffersController.dataOffers[i].isNew === null) {
							allOffersController.dataOffers[i].isNew = false;
						}
						
						if (allOffersController.dataOffers[i].highlight === null) {
							allOffersController.dataOffers[i].isHighlight = false;
						} 
						else {
							allOffersController.dataOffers[i].isHighlight = true;
						}
						
						if (allOffersController.dataOffers[i].isWanted !== false) {
							allOffersController.dataOffers[i].imageSource = "sap-icon://electrocardiogram";
						}
						else if (allOffersController.dataOffers[i].isExpiring !== false) {
							allOffersController.dataOffers[i].imageSource = "sap-icon://history";
						}
						else if (allOffersController.dataOffers[i].isNew !== false) {

							allOffersController.dataOffers[i].imageSource = "sap-icon://lightbulb";
						}
						allOffersController.dataOffers[i].validTime = allOffersController.generateValidTime(allOffersController.dataOffers[i]);
					}

					var allBrandDataOffers = allOffersController.dataOffers;
					// The below line is done to hide the Program info
					allBrandDataOffers.doNotShowBrandHeader = false;
					allOffersController.scanOffersView = allOffersController.createScanCardViews("");
					allOffersController.allOffersModel.setData(allBrandDataOffers);

					if (userState.BRANDTYPE !== "single") {
						var countOfSubscribedPrograms = subscribedPrograms.length;
						
						for ( var i = 0; i < countOfSubscribedPrograms; i++) {
							allOffersController.cardOffersPage[i] = allOffersController.createCardOfferScreen("CardOfferScreen"+ (i + 1));
							allOffersController.carouselControl.addPage(allOffersController.cardOffersPage[i]);
							
							/*
							 * Below Style Class addition is a temporary fix for the case
							 * when a user has only one card, then on the carousel page the
							 * card specific page comes blank. It is because somehow the
							 * visibility hidden CSS property is getting set for the page.
							 */
							allOffersController.cardOffersPage[i].addStyleClass("visibleContent");
							
							allOffersController.cardOffersPageModel[i] = new sap.ui.model.json.JSONModel();
							allOffersController.cardOffersPage[i].setModel(allOffersController.cardOffersPageModel[i]);
							allOffersController.cardOffersPageData[i] = allOffersController.getOffersForProgramId(subscribedPrograms[i].programId);
							allOffersController.cardOffersPageData[i].membershipId = subscribedPrograms[i].membershipId;
							allOffersController.cardOffersPageData[i].programName = subscribedPrograms[i].programName;
							allOffersController.cardOffersPageData[i].programId = subscribedPrograms[i].programId;
							if (userState['DEMO_MODE'] == true)
								allOffersController.cardOffersPageData[i].logo = subscribedPrograms[i].logo;
							else
								allOffersController.cardOffersPageData[i].logo = "data:image/png;base64,"+ subscribedPrograms[i].logo;
							allOffersController.cardOffersPageData[i].programDetails = allOffersController.generateProgramTierAndPointsInfo(subscribedPrograms[i]);
							allOffersController.cardOffersPageModel[i].setData(allOffersController.cardOffersPageData[i]);
							allOffersController.scanCardOffersView.push(allOffersController.createScanCardViews(i));
						}
					} 
					else {
						allOffersController.carouselControl.setShowPageIndicator(false);
						if (allOffersController.dataOffers.length != 0)
							allOffersController.currentProgramId = allOffersController.dataOffers[0].programId;
					}

					if (allOffersController.modeOfScreen == "AllFeature") {
						allOffersController.displayFeaturedData();
					} else if (allOffersController.modeOfScreen == "MultiAll") {
						allOffersController.displayAllOffersData();
					} else if (allOffersController.modeOfScreen == "AllWanted") {
						allOffersController.displayWantedData();
					} else if (allOffersController.modeOfScreen == "AllExpiring") {
						allOffersController.displayExpiringData();
					} else {
						allOffersController.displayAllOffersData();
					}

					if (allOffersController.indexOfCarouselToDisplay !== 0) {
						allOffersController.loadCarouselCardOfferPageForIndex(allOffersController.indexOfCarouselToDisplay);
						allOffersController.indexOfCarouselToDisplay = 0;
					} 
					else {

						app.to(CAROUSEL_PAGE);
						//var allOffersMenuItem = sliderMenuController.sliderListView.byId("menuNavList").getItems()[1];
						/*setTimeout(function(){
							sliderMenuController.setSelectedItemForNavList(allOffersMenuItem);
						},500);*/
						//sliderMenuController.setSelectedItemForNavList(allOffersMenuItem);
					}
						
//if change
					if (userState.BRANDTYPE === "single") {
						allOffersController.carouselControl.setShowPageIndicator(false);
					}else{
						allOffersController.carouselControl.setShowPageIndicator(true);
					}
					

					//util.closeBusyDialog();
					util.stopPerformanceReading(allOffersController.startRenderTime,"All Offers Page Render Time");
					util.stopPerformanceReading(allOffersController.startServiceTime,"All Offers Service Call Time");
					// Current Refresh will be marked after 60 seconds
					allOffersController.offersRefreshTime = new Date().getTime() + 60 * 1000 * 1;
					allOffersController.subscriptionChangesMade = false;
				} 
				else {
					checkErrorMobiliserStatus(response);
				}
				util.closeBusyDialog(); // to close login dialog
			},

			// Utility function which removes all the Offers state data present before applying new Offers data
			resetOffersState : function() {
				for ( var property in allOffersController) {
					if (allOffersController.hasOwnProperty(property) && allOffersController[property] instanceof Array) {
						allOffersController[property] = [];
					}
				}
			},

			// Utility function to check if Offers data is scheduled to be refreshed
			isRefreshNeeded : function() {
				var currentTime = new Date().getTime();
				if (currentTime >= allOffersController.offersRefreshTime) {
					return true;
				} else {
					return false;
				}
			},

			// Utility function to remove existing pages in carousel before new Offers data/updated Offers data is applied.
			// This function needs use as number of pages may get added/removed after Offers data refresh post brand addition/removal
			rebootCarouselControl : function() {
				var allOffersPage = allOffersController.carouselControl.getPages()[0];
				for (i in allOffersController.carouselControl.getPages()) {
					allOffersController.carouselControl.removePage(allOffersController.carouselControl.getPages()[0]);
				}

				// allOffersController.carouselControl.removeAllPages();
				allOffersController.carouselControl.addPage(allOffersPage);
			},

			// Utility function to extract Program/Brand name from Program Id present in an Offer data. getAllOffers does not contain 
			// Program name which is needed in Offers screen so we use the data obtained from getSubscribedProgramsAndMembershipByCustomerId to get Program Name
			getProgramNameFromProgramId : function(programId) {
				var programName = "";
				for (i in subscribedPrograms) {
					if (subscribedPrograms[i].programId == programId) {
						programName = subscribedPrograms[i].programName;
						break;
					}
				}
				return programName;
			},

			// Utility function to extract Program/Brand image from Program Id present in an Offer data. getAllOffers does not contain Program image which is
			// needed in Offers screen so we use the data obtained from getSubscribedProgramsAndMembershipByCustomerId to get Program Name
			getProgramImageFromProgramId : function(programId) {
				var programImage = "";
				for (i in subscribedPrograms) {
					if (subscribedPrograms[i].programId == programId) {
						if (userState['DEMO_MODE'] == true)
							programImage = subscribedPrograms[i].logo;
						else
							programImage = "data:image/png;base64,"+ subscribedPrograms[i].logo;
						break;
					}
				}
				return programImage;
			},

			// Utility function to generate the Program/Brand Tier info displayed in Brand/Program headers in Carousel
			generateProgramTierAndPointsInfo : function(subscribedProgram) {
				var tierInfo = "";
				var amtBalancePoints = "";
				var details = "";
				try {
					var currentTierInfo = subscribedProgram.currentTierInfo;
					if (currentTierInfo !== null) {
						if (currentTierInfo.tierName !== null)
							tierInfo = currentTierInfo.tierName;
					}
					var memberPointInfo = subscribedProgram.memberPointInfo;
					if (memberPointInfo !== null) {
						if (memberPointInfo.redeemablePointInfo !== null) {
							if (memberPointInfo.redeemablePointInfo.amtBalancePoints !== null)
								amtBalancePoints = memberPointInfo.redeemablePointInfo.amtBalancePoints;
						}
					}
					var pointsName = subscribedProgram.pointsName;
					if (pointsName == null)
						pointsName = "";
					if (tierInfo !== "" && amtBalancePoints !== "") {
						details = tierInfo + " | " + amtBalancePoints + " " + pointsName;
					} else if (tierInfo !== "") {
						details = tierInfo;
					} else if (amtBalancePoints !== "") {
						details = amtBalancePoints + " " + pointsName;
					}
				} catch (error) {
					//console.warn("Not able to get Program tier and points info");
				}
				return details;
			},

			// Function to create individual Brand/Program Offers list screen which are added to carousel(Not the All Brand Offers screen)
			createCardOfferScreen : function(cardPageId) {
				
				var pageInstance = sap.ui.getCore().byId(cardPageId);
				//console.log(pageInstance);
				if (pageInstance !== undefined) {
					allOffersController.cardOffersView.push(sap.ui.getCore().byId(cardPageId + "View"));
					return pageInstance;
				}

				var offersView = sap.ui.view({
					type : sap.ui.core.mvc.ViewType.XML,
					viewName : "app.ui.offers.allOffersView",
					id : cardPageId + "View",
					controller : this
				});

				allOffersController.cardOffersView.push(offersView);

				var offersPage = new sap.m.Page(cardPageId, {
					content : [ offersView ],
					showNavButton : false,
					enableScrolling : true,
					showHeader : false
				});
				return offersPage;
			},

			// Function to create individual Brand/Program Scan/ Redeem Offers views which are used in carousel when switching to
			// Scan/Redeem mode Here we dont create pages as above function as we use the Offers List Page and just switch the Offers List views
			// with the Scan/Redeem Views.
			createScanCardViews : function(i) {
				var viewInstance = sap.ui.getCore().byId("scanCardOffersView" + i);
				if (viewInstance !== undefined) {
					// Below setting of model has been done as for unknown reasons, model does not get reset at times.
					viewInstance.setModel(new sap.ui.model.json.JSONModel());
					return viewInstance;
				}
					

				var scanOffersView = sap.ui.view({
					type : sap.ui.core.mvc.ViewType.XML,
					viewName : "app.ui.offers.scanOffersView",
					id : "scanCardOffersView" + i,
					controller : allOffersController
				});
				return scanOffersView;
			},

			// Function to create Single Coupon screen, detect which offer has been selected and pass the correct Offer Detail data to the screen
			displaySingleCouponScreen : function(oControlEvent) {
				var selectedItem = oControlEvent.getSource();
				//var offersList = allOffersController.allOffersView.byId("offersList");
				//var selectedCouponIndex = offersList.indexOfItem(selectedItem.oParent);

				if (app.getPage(COUPON_DETAIL_PAGE) == null) {
					allOffersController.couponDetailView = sap.ui.view({
						type : sap.ui.core.mvc.ViewType.XML,
						viewName : "app.ui.offers.couponDetailView",
						id : "couponDetailView",
						controller : this
					});

					var headerBar = new sap.m.Bar({
								contentLeft : [ new sap.m.Button(
										{
											text : oBundle.getText("Back_Button"),
											type : sap.m.ButtonType.Back,
											tap : function() {
												//sap.ui.getCore().byId("couponDetailButton1iOS").removeStyleClass("sapmbtnactive");
												//allOffersController.carouselControl.rerender();
												if(userState['LOGGED_IN']){
													if (allOffersController.selectedFooterButton.sId == "segmentedButton1") {
														allOffersController.displayWantedData();
														allOffersController.displayAllOffersData();
													}
													else if (allOffersController.selectedFooterButton.sId == "segmentedButton2") {
														allOffersController.displayFeaturedData();
													}
													else if (allOffersController.selectedFooterButton.sId == "segmentedButton3") {
														allOffersController.displayScanOffersScreen();
													}
													else if (allOffersController.selectedFooterButton.sId == "segmentedButton4") {
														allOffersController.displayExpiringData();
													}	
													else {
														allOffersController.displayWantedData();
													}
												}
												app.back();
												//allOffersController.carouselControl.rerender();
											}
										}) ],
								contentMiddle : [ new sap.m.Label("offerDetailLabel", 
										{
											text : ""
										}) ],
								contentRight : [ new sap.m.Button('offerDetailMapButton',
										{
											icon : "sap-icon://map",
											activeIcon : "sap-icon://map",
											tap : function(event, src) {
												if (userState['DEMO_MODE'] == true) {
													logError(
															"demo_mode_message",
															"In Demo Mode",
													"Not Supported In Demo Mode");
													return;
												}
												if (mapController == undefined) {
													mapController = sap.ui
													.controller("app.ui.googleMaps.mapController");
													// mapController =
													// sap.ui.controller("app.ui.storelocator.map");
												}
												mapController.programId = allOffersController.currentProgramId;
												mapController.previousPage = COUPON_DETAIL_PAGE;
												mapController
												.updateMyLocation();
												mapController
												.launchPage();
											}
										}) ]
							});

					var button1ios = new sap.m.Button('couponDetailiOS',
							{
								text : oBundle.getText("want"),
								type : sap.m.ButtonType.Default,
								width : "100px",
								icon : "app/ui/offers/images/want-heart-button-up.png",
								activeIcon : "app/ui/offers/images/want-heart-button-red-ios.png",
								enabled : true,
								tap : function(event) {
									button1ios.fireEvent("iosButtonActiveRemove");
									if (userState['DEMO_MODE'] == true) {
										logError("demo_mode_message","In Demo Mode","Not Supported In Demo Mode");
										return;
									}
									if(userState['LOGGED_IN'])
										allOffersController.wantOfferCall();
									else {
										    homeController.notLoggedInToPage = "Offers";
											if (homepageController==undefined){
												homepageController = sap.ui.controller("app.ui.login.login");
											}	
											launchLoginPage();
									}
										
								}
							});

					var button1 = new sap.m.Button('couponDetailAndroid',
							{
								text : oBundle.getText("want"),
								type : sap.m.ButtonType.Default,
								icon : "app/ui/offers/images/want-heart-button-up.png",
								activeIcon : "app/ui/offers/images/want-heart-button-down.png",
								enabled : true,
								tap : function(event) {
									if (userState['DEMO_MODE'] == true) {
										logError("demo_mode_message","In Demo Mode","Not Supported In Demo Mode");
										return;
									}
									if(userState['LOGGED_IN'])
										allOffersController.wantOfferCall();
									else {
										 homeController.notLoggedInToPage = "Offers";
											if (homepageController==undefined){
												homepageController = sap.ui.controller("app.ui.login.login");
											}	
											launchLoginPage();
									}
								}
							});

					var button2 = new sap.m.Button('couponDetailButton2',
							{
								text : oBundle.getText("share"),
								type : sap.m.ButtonType.Default,
								icon : "app/ui/offers/images/share-icon-button-up.png",
								activeIcon : "app/ui/offers/images/share-icon-button-down.png",
								enabled : true,
								tap : function(event) {
									if (userState['DEMO_MODE'] == true) {
										logError("demo_mode_message","In Demo Mode","Not Supported In Demo Mode");
										return;
									}
									allOffersController.shareOffer();
								}
							});
					var footer;
					if (window.cordova && window.device.platform === "iOS") {
						footer = new sap.m.Bar('couponDetailFooterBar',
								{
									contentMiddle : [ button1ios, button2 ],
                                               enableFlexBox : true
								});
					} else {
						footer = new sap.m.Bar('couponDetailFooterBar',
								{
									contentLeft : [],
									contentMiddle : [ button1, button2 ],
									contentRight : [],
									enableFlexBox : true
								});
					}

					var couponDetailPage = new sap.m.Page(
							COUPON_DETAIL_PAGE,
							{
								title : "Single Offer",
								content : [ allOffersController.couponDetailView ],
								showNavButton : false,
								customHeader : headerBar,
								footer : footer
							});
					couponDetailPage.addStyleClass("customFooter");
					couponDetailPage.addStyleClass("offerDetails");
					this.couponDetailModel = new sap.ui.model.json.JSONModel();
					couponDetailPage.setModel(this.couponDetailModel);
					app.addPage(couponDetailPage);
				}

				// app.getCurrentPage().getContent()[0] is another way to access the carousel Otherwise just use allOffersController.carouselControl

				var selectedCouponIndex = "";
				var activePageId = app.getCurrentPage().getContent()[0].getActivePage();

				if (activePageId !== "allOffersPage") {
					var carouselActivePage = sap.ui.getCore().byId(activePageId);
					var carouselActivePageView = sap.ui.getCore().byId(activePageId + "View");
					var activePageOffersList = carouselActivePageView.byId("offersList");
					selectedCouponIndex = activePageOffersList.indexOfItem(selectedItem);
					var indexOfPage = allOffersController.carouselControl.indexOfPage(carouselActivePage);
				} 
				else {
					var offersList = allOffersController.allOffersView.byId("offersList");
					selectedCouponIndex = offersList.indexOfItem(selectedItem);
				}
				var couponDetailData = null;
				var currentPageData = "";
				if (activePageId !== "allOffersPage") {
					//console.log(">>"+indexOfPage);
					if (allOffersController.modeOfScreen == "AllFeature") {
						currentPageData = allOffersController.cardFeaturedOffersPageData[indexOfPage - 1];
					} 
					else if (allOffersController.modeOfScreen == "AllExpiring") {
						currentPageData = allOffersController.cardExpiringOffersPageData[indexOfPage - 1];
					} 
					else if (allOffersController.modeOfScreen == "AllWanted") {
						currentPageData = allOffersController.cardWantedOffersPageData[indexOfPage - 1];
					} 
					else {
						currentPageData = allOffersController.cardOffersPageData[indexOfPage - 1];
					}
				} 
				else {
					if (allOffersController.modeOfScreen == "AllFeature") {
						currentPageData = allOffersController.featuredOffers;
					} 
					else if (allOffersController.modeOfScreen == "AllExpiring") {
						currentPageData = allOffersController.expiringOffers;
					} 
					else if (allOffersController.modeOfScreen == "AllWanted") {
						currentPageData = allOffersController.wantedOffers;
					} 
					else {
						if(allOffersController.searchBar.getValue() == "") currentPageData = allOffersController.dataOffers;
						else {
							currentPageData = allOffersController.allOffersModel.oData;
						}
					}
				}

				allOffersController.currentProgramId = currentPageData[selectedCouponIndex].programId;
				if(userState['LOGGED_IN'])
					var programLogo = this.getProgramImageFromProgramId(currentPageData[selectedCouponIndex].programId);
				else
					var programLogo = null;
				var isHighlight = true;

				if (currentPageData[selectedCouponIndex].highlight == null) {
					isHighlight = false;
				}
				var tempCaption;
				if(currentPageData[selectedCouponIndex].caption == null){
					tempCaption = "";
				}
				else
					tempCaption = currentPageData[selectedCouponIndex].caption.toUpperCase();
				couponDetailData = {
						offerId : currentPageData[selectedCouponIndex].offerId,
						amountPointsNeeded : currentPageData[selectedCouponIndex].amountPointsNeeded,
						caption : tempCaption,
						highlight : currentPageData[selectedCouponIndex].highlight,
						description : currentPageData[selectedCouponIndex].description,
						subCaption : currentPageData[selectedCouponIndex].subCaption,
						couponImage : currentPageData[selectedCouponIndex].image,
						isWanted : currentPageData[selectedCouponIndex].isWanted,
						isExpiring : currentPageData[selectedCouponIndex].isExpiring,
						isFeatured : currentPageData[selectedCouponIndex].isFeatured,
						isNew : currentPageData[selectedCouponIndex].isNew,
						imageSource : "",
						thumbUrl : currentPageData[selectedCouponIndex].thumbUrl,
						url : currentPageData[selectedCouponIndex].url,
						validTime : currentPageData[selectedCouponIndex].validTime,
						programLogo : programLogo,
						isHighlight : isHighlight
				};

				if (couponDetailData.isWanted !== false) {
					couponDetailData.imageSource = "sap-icon://electrocardiogram";
					//sap.ui.getCore().byId("couponDetailButton1iOS").addStyleClass("sapmbtnactive");
				}
				else if (couponDetailData.isExpiring !== false) {
					couponDetailData.imageSource = "sap-icon://history";
				}
				else if (couponDetailData.isNew !== false) {
					couponDetailData.imageSource = "sap-icon://lightbulb";
				}
				allOffersController.currentCouponTypeid = currentPageData[selectedCouponIndex].couponTypeid;

				app.getPage(COUPON_DETAIL_PAGE).getContent()[0].getModel().setData(couponDetailData);
				// this.couponDetailModel = setData(couponDetailData);
				var couponDetailScreenTitle = sap.ui.getCore().byId("offerDetailLabel");
				// couponDetailScreenTitle.setText(currentPageData.programName);
				if(userState['LOGGED_IN'])
				couponDetailScreenTitle.setText(this.getProgramNameFromProgramId(currentPageData[selectedCouponIndex].programId));
				else
				couponDetailScreenTitle.setText(currentPageData[selectedCouponIndex].caption);
				app.to(COUPON_DETAIL_PAGE);
				if (couponDetailData.isWanted === true) {
					sap.ui.getCore().byId("couponDetailAndroid").setIcon("app/ui/offers/images/want-heart-button-down.png");
					sap.ui.getCore().byId("couponDetailiOS").setIcon("app/ui/offers/images/want-heart-button-red-ios.png");
				} else {
					sap.ui.getCore().byId("couponDetailAndroid").setIcon("app/ui/offers/images/want-heart-button-up.png");
					sap.ui.getCore().byId("couponDetailiOS").setIcon("app/ui/offers/images/want-heart-button-up.png");
				}
				var wantedIcon = app.getPage(COUPON_DETAIL_PAGE).getContent()[0].byId("wantedIconHolder");
				wantedIcon.rerender();
			},

			getOffersCarouselActivePage : function() {
				var activePageId = allOffersController.carouselControl.getActivePage();
				var carouselActivePage = sap.ui.getCore().byId(activePageId);
				return carouselActivePage;
			},

			// Function which ideally should not be required but it is needed to re-render Carousel at times.
			reloadCarouselIfNeeded : function() {
				if (userState.BRANDTYPE === "single") {
					allOffersController.carouselControl.setShowPageIndicator(false);
				}else{
					allOffersController.carouselControl.setShowPageIndicator(true);
				}
				if ($("#allOffersPage-scroll").children().length == 0) {
					allOffersController.carouselControl.fireLoadPage({
						pageId : "allOffersPage"
					});
				}
			},

			// Function which gets called from Slider menu when tap is made on Programs/Brand link
			// This is similar to navigateToOffersScreen but here we navigate to a Program/Brand Screen in Carousel and not the All Brands screen
			loadCardOfferPage : function(indexOfCardOffers) {
				// First we need to load carousel screen which may need to be refreshed based on refresh timer or subscription changes
				allOffersController.indexOfCarouselToDisplay = indexOfCardOffers + 1;
				allOffersController.displayAllOffersScreen();
			},

			loadCarouselCardOfferPageForIndex : function(pageIndex) {
				if(allOffersController.modeOfScreen == "scanOffers") {
					allOffersController.displayScanOffersScreen();
				}

				if (app.getCurrentPage().sId !== CAROUSEL_PAGE) {
					app.to(CAROUSEL_PAGE);
					var page = allOffersController.carouselControl.getPages()[pageIndex];
					setTimeout(function() {
						allOffersController.carouselControl.setActivePage(page);
					}, 500);
				} else {
					var page = allOffersController.carouselControl.getPages()[pageIndex];
					allOffersController.carouselControl.setActivePage(page);
					app.to(CAROUSEL_PAGE);
				}
			},

			shareOffer: function() {
                  
                if (window.cordova && window.device.platform === "iOS") {
                  window.plugins.NativeDataPlugin.appIdCheck(function(e) {
                                                             window.plugins.NativeDataPlugin.schemeCheck(function(e){
                                                                                                         },
                                                                                                         function(f){
                                                                                                         alert(oBundle.getText("application_not_configured_facebook"));
                                                                                                         });
                                                                          },
                                                             function (f) {
                                                             alert(oBundle.getText("application_not_configured_facebook"));
                                                             });
                  
                  }
                  else {
				if(facebookAppId != undefined && facebookAppId != null && facebookAppId.length > 0)
				{
					
					if (window.cordova){
						if(isConnectedToFacebook === false)	{ 
							FB.login( function(response) {
								if (response.authResponse) {
									allOffersController.facebookWallPost();
								} else {

								}
							}, {scope: 'email'});                 
						} else {
							allOffersController.facebookWallPost();
						}
					}
					
				}
				else{
					logError( "application_not_configured_facebook", "Cannot share the offer on facebook since Application is not configured for sharing on Facebook", "OfferDetails")
				}
                  }

			},

			facebookWallPost : function() {

                  var nameTemp; var captionTemp; var descriptionTemp; var pictureTemp;
                  if(this.couponDetailModel.oData.caption == null){
                  nameTemp = "";
                  }
                  else {
                  nameTemp = this.couponDetailModel.oData.caption;
                  }
                  if (this.couponDetailModel.oData.thumbUrl == null) {
                  pictureTemp = ""
                  }
                  else {
                  pictureTemp = this.couponDetailModel.oData.thumbUrl;
                  }
                  if (this.couponDetailModel.oData.subCaption == null) {
                  captionTemp = "";
                  }
                  else {
                  captionTemp = this.couponDetailModel.oData.subCaption
                  }
                  if (this.couponDetailModel.oData.description == null) {
                  descriptionTemp = "";
                  }
                  else {
                  descriptionTemp = this.couponDetailModel.oData.description;
                  }
                  
                  var params = {
                  method : 'feed',
                  name : nameTemp,
                  link : 'https://developers.facebook.com/docs/reference/dialogs/',
                  picture : pictureTemp,
                  caption : captionTemp,
                  description : descriptionTemp
                  };

				FB.ui(params, function(obj) {
					//console.log(obj);
				});
			},

			wantOfferCall : function() {
				if (app.getCurrentPage().getModel().oData.isWanted === true)
					util.createBusyDialog(oBundle.getText("Offers_Progress_Message"),oBundle.getText("offer_removed_from_wanted"));
				else
					util.createBusyDialog(oBundle.getText("Offers_Progress_Message"),oBundle.getText("offer_set_as_wanted"));
					var wantOfferCallData = {
						couponTypeid : allOffersController.currentCouponTypeid,
						amountPointsNeeded : this.couponDetailModel.oData.amountPointsNeeded,
						offerId : this.couponDetailModel.oData.offerId,
						couponCaption : this.couponDetailModel.oData.caption
					};
				SmartphoneService.wantOffer(wantOfferCallData,allOffersController.wantOfferBack);
			},

			wantOfferBack : function(response, status) {
				if (status != 200) {
					checkErrorStatus(status);
					return;
				}
				if (isRESTStatusCodeCorrect(response)) {
					util.closeBusyDialog();
					for ( var i = 0; i < allOffersController.dataOffers.length; i++) {
						
						if (allOffersController.dataOffers[i].couponTypeid == allOffersController.currentCouponTypeid) {
							// No need to do this for different cards data as the offer object is being referenced in card data also.
							// So a change here will be reflected in the cards offers as well.
							allOffersController.dataOffers[i].isWanted = !allOffersController.dataOffers[i].isWanted;
							if (allOffersController.dataOffers[i].isWanted === true) {
								sap.ui.getCore().byId("couponDetailAndroid").setIcon("app/ui/offers/images/want-heart-button-down.png");
								sap.ui.getCore().byId("couponDetailiOS").setIcon("app/ui/offers/images/want-heart-button-red-ios.png");

							} 
							else {
								sap.ui.getCore().byId("couponDetailAndroid").setIcon("app/ui/offers/images/want-heart-button-up.png");
								sap.ui.getCore().byId("couponDetailiOS").setIcon("app/ui/offers/images/want-heart-button-up.png");
							}
							
							var pageData = allOffersController.couponDetailModel.oData;
							pageData.isWanted = allOffersController.dataOffers[i].isWanted;
							allOffersController.dataOffers[i].imageSource = "";
							pageData.imageSource = "";

							if (allOffersController.dataOffers[i].isWanted !== false) {
								allOffersController.dataOffers[i].imageSource = "sap-icon://electrocardiogram";
								pageData.imageSource = "sap-icon://electrocardiogram";
							}
							else if (allOffersController.dataOffers[i].isExpiring !== false) {
								allOffersController.dataOffers[i].imageSource = "sap-icon://history";
								pageData.imageSource = "sap-icon://history";
							}
							else if (allOffersController.dataOffers[i].isNew !== false) {
								allOffersController.dataOffers[i].imageSource = "sap-icon://lightbulb";
								pageData.imageSource = "sap-icon://lightbulb";
							}
							else {
								allOffersController.dataOffers[i].imageSource = "";
								pageData.imageSource = "";
							}

							allOffersController.couponDetailModel.setData(pageData);
							//app.getCurrentPage().getContent()[0].getModel().setData(pageData);
							var wantedIcon = app.getPage(COUPON_DETAIL_PAGE).getContent()[0].byId("wantedIconHolder");
							wantedIcon.rerender();
							allOffersController.dataOffers[i].couponInstanceid = response.offer.couponInstanceid;
							allOffersController.dataOffers[i].strCode = response.offer.strCode;
							allOffersController.dataOffers[i].serialNumber = response.offer.serialNumber;
						}
					}

					//app.getPage(CAROUSEL_PAGE).rerender();//.getFooter().
					allOffersController.allOffersModel.setData(allOffersController.dataOffers);
					 //allOffersController.allOffersModel.setData(allOffersController.dataOffers);
					// if (allOffersController.modeOfScreen == "AllFeature") {
						// allOffersController.displayFeaturedData();
					// } else if (allOffersController.modeOfScreen == "MultiAll") {
						// allOffersController.displayAllOffersData();
					// } else if (allOffersController.modeOfScreen == "AllWanted") {
						// allOffersController.displayWantedData();
					// } else if (allOffersController.modeOfScreen == "AllExpiring") {
						// allOffersController.displayExpiringData();
					// } else {
						// allOffersController.displayAllOffersData();
					// }

					//Rerendering the footer
					//if(app.getPage(COUPON_DETAIL_PAGE) != null && app.getPage(COUPON_DETAIL_PAGE).getFooter() != null)
					//Rerendering Entire page to reflect the UI changes.
					//app.getPage(COUPON_DETAIL_PAGE).rerender();
				} else {
					checkErrorMobiliserStatus(response);
				}
			},

			search : function(oControlEvent) {
				var data = null;
				if (allOffersController.modeOfScreen == "AllFeature") {
					data = allOffersController.featuredOffers;
				} else if (allOffersController.modeOfScreen == "AllExpiring") {
					data = allOffersController.expiringOffers;
				} else if (allOffersController.modeOfScreen == "AllWanted") {
					data = allOffersController.wantedOffers;
				} else
					data = allOffersController.dataOffers;

				var searchValue = oControlEvent.getSource().getValue();
				if (searchValue == "") {
					allOffersController.allOffersModel.setData(data);
				} else {
					//var data = allOffersController.dataOffers;
					var searchResultOffers = [];
					for (i in data) {
						if ((data[i].caption != null && data[i].caption.toLowerCase().search(searchValue.toLowerCase()) > -1) || (data[i].description != null && data[i].description.toLowerCase().search(searchValue.toLowerCase()) > -1) || (data[i].subCaption != null && data[i].subCaption.toLowerCase().search(searchValue.toLowerCase()) > -1)) {
							searchResultOffers.push(data[i]);
						}
					}
					searchResultOffers = allOffersController.applyOfferContentFlag(searchResultOffers);
					allOffersController.allOffersModel.setData(searchResultOffers);
					//allOffersController.modeOfScreen = "searchResults";
				}
			},

			convertDateToReadableFormat : function(dateinms) {
				if (dateinms == null)
					return null;
				var newDate = new Date(dateinms);
				var dateOfMonth = newDate.getDate();
				var val = newDate.toDateString();
				var month_name = val.substr(val.indexOf(" ") + 1, 3)
				.toLowerCase();
				// Bad way to get the month names. Dont want to change the strings file as may break SLS way of adding the names
				if (month_name === "jun") {
					month_name = "june";
				} else if (month_name === "jul") {
					month_name = "july";
				}
				var month = oBundle.getText("month_" + month_name);
				month = month.substr(0, 3);
				month = month.charAt(0).toUpperCase() + month.slice(1);
				return month + " " + dateOfMonth;
			},

			convertOfferDatesToReadableFormat : function() {
				for (i in allOffersController.dataOffers) {
					allOffersController.dataOffers[i].validTo = allOffersController.convertDateToReadableFormat(allOffersController.dataOffers[i].validTo);
					allOffersController.dataOffers[i].validFrom = allOffersController.convertDateToReadableFormat(allOffersController.dataOffers[i].validFrom);
				}
			},

			generateValidTime : function(offer) {
				if (offer.isExpiring == false) {
					validTime = offer.validFrom + " " + oBundle.getText("word_to") + " " + offer.validTo;
				} 
				else {
					validTime = oBundle.getText("word_ends") + " " + offer.validTo;
				}
				return validTime;
			},

			resetCarousel : function() {
				allOffersController.carouselControl.setShowPageIndicator(false);
				var page = allOffersController.carouselControl.getPages()[0];
				setTimeout(function() {
					allOffersController.carouselControl.setActivePage(page);
					allOffersController.carouselControl.setShowPageIndicator(false);
				}, 500);
				sap.ui.getCore().byId("segmentedButton1").fireTap();
			}
			
		});
