sap.ui.controller('app.ui.passcode.passcodeController', {
    
    passcodeData : {
		label : "",
		placeholder : "",
		PINValue : "",
		maxLength : 4
    },
    
    passcodeDataVerify : {
		label : "",
			placeholder : "",
		PINValue : "",
		maxLength : 4
    },
	
	callBackForNext : "",
	
	loadingNextPage : false,
/******************PASSCODE CHALLENGE**************************/     
    onInit : function(){
		//get length of Passcode
    },
    
    
/*************** CREATE PROFILE PASSCODE  *********************/  
    startPasscodeEntry : function(){
		this.loadingNextPage = false;
		//set passcode model
		this.passcodeData.label = oBundle.getText("set_passcode");
		this.passcodeData.PINValue = "";
		this.passcodeData.placeholder = oBundle.getText("Enter_App_Passcode");
		this.passcodeData.maxLength =25;
		
		//set verify passcode model
		this.passcodeDataVerify.label = oBundle.getText("confirm_passcode");
		this.passcodeDataVerify.placeholder = oBundle.getText("Enter_App_Passcode");
		this.passcodeDataVerify.maxLength = 25;
		
		passcodeDataModel = new sap.ui.model.json.JSONModel();
		passcodeDataModel.setData(this.passcodeData);
		this.createPasscodePage( "setPasscode", oBundle.getText("My_Passcode"), oBundle.getText("next"), this.goToVerifyPasscode);
		app.getPage("setPasscode").setModel(passcodeDataModel);
		
		passcodeDataVerifyModel = new sap.ui.model.json.JSONModel();
		passcodeDataVerifyModel.setData(this.passcodeDataVerify);
		this.createPasscodePage( "verifyPasscode", oBundle.getText("Confirm_App_Passcode"), oBundle.getText("done"), this.setPreviousModel);
		app.getPage("verifyPasscode").setModel(passcodeDataVerifyModel);
		
		this.callBackForNext = "goToVerify";
		app.to("setPasscode");
    },
    
    goToVerifyPasscode : function(){
		var temp = app.getPage("setPasscode").getModel().getData().PINValue;
		var length = app.getPage("setPasscode").getModel().getData().maxLength;
		if ( temp.trim().length == 0){
			logError("error_message_passcode", "missing passcode", "User Registration")
		}
		else if ( !util.isNumeric(temp)  ){
			logError("error_message_passcode_not_numeric", "passcode is not numeric", "non numeric numbers in passcode")
		}
		else{
			PINController.callBackForNext = "goToPrevious";
			app.to("verifyPasscode");
		}
    },
	
    setPreviousModel : function(){
		this.passcodeData = app.getPage("setPasscode").getModel().getData();
		this.passcodeDataVerify = app.getPage("verifyPasscode").getModel().getData();
		//verify two passcodes match
		if ( this.passcodeData.PINValue != this.passcodeDataVerify.PINValue){
			//clear passcode value
			this.passcodeData.PINValue = "";
			app.getPage("setPasscode").getModel().setData(PINController.passcodeData);
			this.passcodeDataVerify.PINValue = "";
			app.getPage("verifyPasscode").getModel().setData(PINController.passcodeDataVerify);
			logError("error_message_Passcode_not_match", "Passcode did not match", "Create Profile Passcode");
			//go to first PIN page
			this.callBackForNext = "goToVerify";
			app.to("setPasscode");
		}
		else{
			//set previous pageModel to passcode
			var profileData = app.getPage(ID_CREATE_PROFILE).getContent()[0].getModel().getData();
			profileData.passcode.passcode = this.passcodeData.PINValue;
			app.getPage(ID_CREATE_PROFILE).getContent()[0].getModel().setData(profileData);
			//clear passcode value
			this.passcodeData.PINValue = "";
			app.getPage("setPasscode").getModel().setData(PINController.passcodeData);
			this.passcodeDataVerify.PINValue = "";
			app.getPage("verifyPasscode").getModel().setData(PINController.passcodeDataVerify);
			//go to createProfilePage
			app.to(ID_CREATE_PROFILE);
		}
    },
  /******************PASSCODE CHALLENGE FOR SETTINGS **************************/
  
    passcodeTo : "",
    
    toWallet : function(){
		this.passcodeTo = "wallet";
		this.loadingNextPage = false;
		var currentTime = new Date().getTime();
		if (userState['EXPIRATION'] > currentTime){
			this.passcodeChallenge();
		}
		else{
			logError( oBundle.getText("error_message_401_expiration"), "Cookie Expired", "expired");
			//app.to(ID_LOGIN_PAGE);
			if(userCredentialSettingsController == undefined)
				userCredentialSettingsController = sap.ui.controller('app.ui.settings.userCredentialSettings');
			userCredentialSettingsController.SignOut();
			return;
		}
    },
    
    toSettings : function(){
		this.passcodeTo = "settings";
		this.loadingNextPage = false;
		var currentTime = new Date().getTime();
		if ( userState['EXPIRATION'] > currentTime){
			this.passcodeChallenge();
		}
		else{
			logError( oBundle.getText("error_message_401_expiration"), "Cookie Expired", "expired");
			//app.to(ID_LOGIN_PAGE);
			if(userCredentialSettingsController == undefined)
				userCredentialSettingsController = sap.ui.controller('app.ui.settings.userCredentialSettings');
			userCredentialSettingsController.SignOut();
			return;
		}
    },
    toBrowseProducts : function(){
		this.passcodeTo = "browseproducts";
		this.loadingNextPage = false;
		var currentTime = new Date().getTime();
		if ( userState['EXPIRATION'] > currentTime){
			this.passcodeChallenge();
		}
		else{
			logError( oBundle.getText("error_message_401_expiration"), "Cookie Expired", "expired");
			//app.to(ID_LOGIN_PAGE);
			if(userCredentialSettingsController == undefined)
				userCredentialSettingsController = sap.ui.controller('app.ui.settings.userCredentialSettings');
			userCredentialSettingsController.SignOut();
			return;
		}
    },
    toCheckIn : function(){
		this.passcodeTo = "checkin";
		this.loadingNextPage = false;
		var currentTime = new Date().getTime();
		if ( userState['EXPIRATION'] > currentTime){
			this.passcodeChallenge();
		}
		else{
			logError( oBundle.getText("error_message_401_expiration"), "Cookie Expired", "expired");
			//app.to(ID_LOGIN_PAGE);
			if(userCredentialSettingsController == undefined)
				userCredentialSettingsController = sap.ui.controller('app.ui.settings.userCredentialSettings');
			userCredentialSettingsController.SignOut();
			return;
		}
    },
    
    passcodeChallenge : function(){
		//set passcode model
		userState['PASSCODE_FIRST'] = false;
		this.passcodeData.label = oBundle.getText("My_Passcode");
		this.passcodeData.placeholder = oBundle.getText("Enter_App_Passcode");
		this.passcodeData.maxLength = 25;
		
		passcodeDataModel = new sap.ui.model.json.JSONModel();
		passcodeDataModel.setData(this.passcodeData);
		this.createPasscodePage( "passcodeCheck", oBundle.getText("My_Passcode"), oBundle.getText("done"), this.checkPasscode);
		app.getPage("passcodeCheck").setModel(passcodeDataModel);
		
		PINController.callBackForNext = "passcodeCheck";
		app.to("passcodeCheck");
    },
    
    checkPasscode : function(){
		if( ! (PINController.passcodeData.PINValue.length > 0 ) ){
			logError("error_message_passcode", "", "")
			return;
		}
		util.createBusyDialog( oBundle.getText("Confirm_Passcode"), oBundle.getText("Busy_Title") );
//call smartphone service to check passcode
		SmartphoneService.checkCredential( PINController.passcodeData.PINValue, PINController.passcodeVerifyBack);
    },
    
    passcodeVerifyBack : function(response, status){
	    if (status != 200) {
		checkErrorStatus(status);
		return;
	    }
	    else if( isRESTStatusCodeCorrect(response) || response.Status.code == 332) {
			
			util.closeBusyDialog();
			if(response.Status.code == 332){
				//Temporratuy PIN, need to be rest
				var callback = function(){
					PINController.startResetPasscodeEntry();
				}
				util.alertDialog(oBundle.getText("pin_temporary_need_reset"), callback);
			}else{
				PINController.gotoTargetPage();
			}
			
	    }
	    else{
			checkErrorMobiliserStatus(response);
	    }
    },
    
    gotoTargetPage: function(){
    	PINController.passcodeData.PINValue = "";
		var passcodeDataModel = new sap.ui.model.json.JSONModel();
		passcodeDataModel.setData(PINController.passcodeData);
		app.getPage("passcodeCheck").setModel(passcodeDataModel);
		
    	var currentTime =	new Date().getTime();
		userState['PASSCODE_EXP'] = currentTime + userState['PASSCODE_TIMEOUT'] - 5000;
		//which page to go to
		
    	if (PINController.passcodeTo == "settings"){
    		if(settingsController == undefined)
    			settingsController = sap.ui.controller("app.ui.settings.settingsController");
    		settingsController.displaySettingsPage();
    	}
		else if (PINController.passcodeTo == "wallet"){
			if (walletController == undefined) 
				walletController = sap.ui.controller("app.ui.wallet.wallet");
			walletController.launchWalletPage(userState.MEMBERID);
		}
		else if (PINController.passcodeTo == "browseproducts"){
			if (productCatalogController == undefined) 
				productCatalogController = sap.ui.controller("app.ui.productCatalog.productCatalog");
			productCatalogController.launchProductCatalogPage();
		}
		else if (PINController.passcodeTo == "checkin"){
			if (checkInController == undefined) 
				checkInController = sap.ui.controller("app.ui.myLists.checkIn");
			checkInController.launchCheckInPage();
		}
			
    },
    
 /******************PIN AND PASSCODE PAGE VIEW*******************/
 onChangeDone : function(){
	this.loadingNextPage = true;
	if (PINController.callBackForNext == "goToVerify"){
		this.goToVerifyPasscode();
	}
	else if( PINController.callBackForNext  == "goToPrevious"){
		this.setPreviousModel();
	}
	else if ( PINController.callBackForNext  == "passcodeCheck"){
		this.checkPasscode();
	}
 },
 
	 startResetPasscodeEntry: function(){
		 var pageData = {
				 label : "",
				 placeholder : "",
				 PINValue : "",
				 maxLength : 25
		 };
		 pageData.label = oBundle.getText("set_passcode");
		 pageData.PINValue = "";
		 pageData.placeholder = oBundle.getText("Enter_App_Passcode");
	
		 var goToVerifyPage = function(){
			 var temp = app.getPage("resetPasscode").getModel().getData().PINValue;
			 var length = app.getPage("resetPasscode").getModel().getData().maxLength;
			 if ( temp.trim().length == 0){
				 logError("error_message_passcode", "missing passcode", "Reset Passcode")
			 }
			 else if ( !util.isNumeric(temp)  ){
				 logError("error_message_passcode_not_numeric", "passcode is not numeric", "non numeric numbers in passcode")
			 }
			 else{
				 app.to("verifyResetPasscode");
			 }
		 };
		 var pageDataModel = new sap.ui.model.json.JSONModel();
		 pageDataModel.setData(pageData);
		 this.createResetPasscodePage( "resetPasscode", oBundle.getText("My_Passcode"), oBundle.getText("next"), goToVerifyPage);
		 app.getPage("resetPasscode").setModel(pageDataModel);
	
		 var pageDataVerify = {
				 label : "",
				 placeholder : "",
				 PINValue : "",
				 maxLength : 25
		 };
		 pageDataVerify.label = oBundle.getText("confirm_passcode");
		 pageDataVerify.PINValue = "";
		 pageDataVerify.placeholder = oBundle.getText("Enter_App_Passcode");
	
		 var checkResetCredential = function(){
			 var passcodeData = app.getPage("resetPasscode").getModel().getData();
			 var passcodeDataVerify = app.getPage("verifyResetPasscode").getModel().getData();
			 //verify two passcodes match
			 if ( passcodeData.PINValue != passcodeDataVerify.PINValue){
				 //clear passcode value
				 passcodeData.PINValue = "";
				 app.getPage("resetPasscode").getModel().setData(passcodeData);
				 passcodeDataVerify.PINValue = "";
				 app.getPage("verifyResetPasscode").getModel().setData(passcodeDataVerify);
				 logError("error_message_Passcode_not_match", "Passcode did not match", "Reset Passcode");
				 //go to first PIN page
				 app.back();
			 }
			 else{
	
				 var resetPasscodeBack = function (response, status){
					 if (status != 200) {
						 checkErrorStatus(status);
						 return;
					 }
					 util.closeBusyDialog();
					 if(isRESTStatusCodeCorrect(response)){
						 PINController.gotoTargetPage();
					 }
					 else{
						 //passcode fail to reset
						 var errorMsg = "";
						 if(response.Status.code == 334)
							 logError("passcode_retention", "Passcode update failed, retention", "Passcode Reset");
						 else
							 logError("error_message_passcode_update_fail", "Passcode update failed, check response Status Code", "Passcode Reset");
	
					 }
				 }
	
	
				 // Calling service to update the PIN
				 var member = {
						 identification : loginResponseModel.customer.id,
						 identificationType : 1,
						 oldCredential: PINController.passcodeData.PINValue, 
						 newCredential : passcodeData.PINValue,
						 credentialType : 0
				 }
				 util.createBusyDialog( oBundle.getText("Updating_data"), "" );
				 SmartphoneService.ChangeLoyaltyWalletCredential(member, resetPasscodeBack);
	
			 }
	
		 }
		 var pageDataVerifyModel = new sap.ui.model.json.JSONModel();
		 pageDataVerifyModel.setData(pageDataVerify);
		 this.createResetPasscodePage( "verifyResetPasscode", oBundle.getText("Confirm_App_Passcode"), oBundle.getText("done"), checkResetCredential);
		 app.getPage("verifyResetPasscode").setModel(pageDataVerifyModel);
	
		 app.to("resetPasscode");
	 },
 
	 createResetPasscodePage : function( pageId, title, rightButtonText, callbackForNext){
		 if(app.getPage(pageId) == null ) {
			 var header = new sap.m.Bar({
				 contentRight : [new sap.m.Button({ text: rightButtonText,
					 tap : function() {
						 callbackForNext();
					 }
				 })],
				 contentMiddle : [new sap.m.Label({text: title })],
				 contentLeft : [new sap.m.Button({
					 text : oBundle.getText("Back_Button"),
					 type : sap.m.ButtonType.Back,
					 tap : function() {
						 app.back();
					 }
				 })],
			 });

			 var passcodeView = sap.ui.view({
				 type : sap.ui.core.mvc.ViewType.XML,
				 viewName : "app.ui.passcode.passcode",
				 controller : this
			 });

			 var newPage = new sap.m.Page(pageId, {
				 customHeader: header,
				 content: [ passcodeView ],
			 });
			 app.addPage(newPage);
		 }
	 },
 
    createPasscodePage : function( pageId, title, rightButton, callbackForNext){
		if(app.getPage(pageId) == null ) {
			var header = new sap.m.Bar({
				contentRight : [new sap.m.Button(pageId+'PasscodeDoneButton', { text: rightButton,
					tap : function() {
						PINController.onChangeDone();
					}
				})],
				contentMiddle : [new sap.m.Label(pageId+"PasscodeTitle", {text: title })],
				contentLeft : [new sap.m.Button({
						text : oBundle.getText("Back_Button"),
						type : sap.m.ButtonType.Back,
						tap : function() {
							if ( !this.loadingNextPage)
								{
									if(sliderMenuController != undefined && app.getPage(CAROUSEL_PAGE) != null)
										sliderMenuController.selectPreviousActiveItem();
									if (PINController.callBackForNext == "goToVerify"){
										app.backToPage(ID_CREATE_PROFILE);
									}
									else{
										var prevPage = app.getPreviousPage().getId();
										if(prevPage == ID_LOGIN_PAGE){
											homeController.prevPage = "back";
											homeController.launchAnonymousHomePage();
										}
										else
											app.back();
									}
								}
						}
					})],
			});
	
			var passcodeView = sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.passcode.passcode",
				controller : this
			});
	
			var newPage = new sap.m.Page(pageId, {
				customHeader: header,
				content: [ passcodeView ],
			});
			app.addPage(newPage);
		}
    },
});
