//Demo data for product catalog.
productCatalogData = {
		catalog : [{
					catalogFilterName : "Departments",
					category : [{
						categoryName : "All",
						categoryID : 1000,
						parentID : 0
					},{
						categoryName : "Bakery and Desert",
						categoryID : 1100,
						parentID : 0
					},{
						categoryName : "Beverages",
						categoryID : 1200,
						parentID : 0
					},{
						categoryName : "All Beverages",
						categoryID : 1210,
						parentID : 1200
					},{
						categoryName : "Beer Liquor & Wine",
						categoryID : 1220,
						parentID : 1200
					},{
						categoryName : "Stella Artois",
						categoryID : 1221,
						parentID : 1220
					},{
						categoryName : "Heineken",
						categoryID : 1222,
						parentID : 1220
					},{
						categoryName : "Coffee, Tea & Cocoa",
						categoryID : 1230,
						parentID : 1200
					},{
						categoryName : "Black",
						categoryID : 1231,
						parentID : 1230
					},{
						categoryName : "Starbucks Coffee",
						categoryID : 1232,
						parentID : 1230
					},{
						categoryName : "Meat",
						categoryID : 1300,
						parentID : 0
				}]
			},{
					catalogFilterName : "Brand",
					category : [{
						categoryName : "All",
						categoryID : 5000,
						parentID : 0
					},{
						categoryName : "Shoes",
						categoryID : 5010,
						parentID : 5000
					},{
						categoryName : "Adidas",
						categoryID : 5100,
						parentID : 0
					},{
						categoryName : "Shoes",
						categoryID : 5110,
						parentID : 5100
					},{
						categoryName : "T-Shirt",
						categoryID : 5120,
						parentID : 5100
					},{
						categoryName : "D & J",
						categoryID : 5200,
						parentID : 0
					},{
						categoryName : "Nike",
						categoryID : 5300,
						parentID : 0
					},{
						categoryName : "Shoes",
						categoryID : 5310,
						parentID : 5300
					},{
						categoryName : "Basketball",
						categoryID : 5311,
						parentID : 5310
					},{
						categoryName : "Football",
                    	categoryID : 5312,
                    	parentID : 5310
					},{
						categoryName : "spikes",
						categoryID : 5412,
						parentID : 5312
					},
					{
						categoryName : "Football",
						categoryID : 5413,
						parentID : 5312
					},{
						categoryName : "Shoes",
						categoryID : 5513,
						parentID : 5413
					},
					{
						categoryName : "Shorts",
						categoryID : 5320,
						parentID : 5300
					},{
						categoryName : "T-Shirt",
						categoryID : 5330,
						parentID : 5300
					},{
					}]
			}],
    categoryMode : true,
    searchMode: false
};
//Global variable that references the pop up overlay screen.
//Add the list to pop up overlay screen
var popUpForSearch = new sap.m.Dialog("popUpForSearchCatalog",{
	content : []
});;

sap.ui.controller('app.ui.productCatalog.productCatalog', {
	//Method called when browse catalog menu option is selected from menu.
    launchProductCatalogPage : function(prevPage) {
        productCatalogData.categoryMode = true; //Initially categoryMode is set so that category filters in segmented button and its category list be visible 
        productCatalogData.searchMode = false;  //Member variable is used for search mode.
        
        //Depending on number of filter option the segmented buttons width are dynamically set using this value. 
        productCatalogData.filterCount = (1/productCatalogData.catalog.length) * 100;
        productCatalogData.filterCount = productCatalogData.filterCount + "%";

        if(app.getPage(ID_PRODUCT_CATALOG_PAGE)==null){
            var productCatalogView = sap.ui.view({
              type : sap.ui.core.mvc.ViewType.XML,
              viewName : "app.ui.productCatalog.productCatalog",
              controller : productCatalogController
            });
          
            var productCatalogModel = new sap.ui.model.json.JSONModel();
          
            var header = new sap.m.Bar({
                contentMiddle : [ new sap.m.Label("productCatalogTitle", {
                  text : oBundle.getText("products")
                }) ],
                contentLeft : [ new sap.m.Button('menuButtonProductCatalog', {
                  icon : "sap-icon://menu2",
                  activeIcon : "sap-icon://menu2",
                  tap : function(event, src) {
                    sliderMenuController.action('menuButtonShoppingList');
                  }
                }).addStyleClass("menuButtonIconFont") ],
                contentRight : [new sap.m.Button("productCatalogSearch",{
                  text : oBundle.getText("Offers_Search_Button"),
                  tap : function(){
                	//If search button is pressed then hide the visibility of the search button. Display searchMode details. 
                    productCatalogData.categoryMode = false; 
                    productCatalogData.searchMode = true;
                    app.getPage(ID_PRODUCT_CATALOG_PAGE).getCustomHeader().getContentRight()[0].setVisible(false);
                    app.getPage(ID_PRODUCT_CATALOG_PAGE).getContent()[0].getModel().setData(productCatalogData);
                  }
                })]
            });
            var productCatalogPage = new sap.m.Page(ID_PRODUCT_CATALOG_PAGE,{
                customHeader : header,
                content : [productCatalogView],	 
            });
            productCatalogPage.setModel(productCatalogModel);
            app.addPage(productCatalogPage);
        }
        productCatalogData.catalogPresent = [];
        
        //begin setting/resetting model for product catalog
        
        if(productCategoryController==undefined){
        	productCatalogController.computeCatalogPresentData(0);
        }
        else{
          productCatalogController.computeCatalogPresentData(productCategoryController.index);
        }
        app.getPage(ID_PRODUCT_CATALOG_PAGE).getContent()[0].getModel().setData(productCatalogData);
        /*
         *select which button is active in "subheader" of "department"  or "brand"
         */
        var initialSelectedButton = app.getPage(ID_PRODUCT_CATALOG_PAGE).getContent()[0].byId("demo");
        if(productCategoryController==undefined){
            initialSelectedButton.setSelectedButton(app.getPage(ID_PRODUCT_CATALOG_PAGE).getContent()[0].byId("demo").getButtons()[0]);
        }
        else{
            initialSelectedButton.setSelectedButton(app.getPage(ID_PRODUCT_CATALOG_PAGE).getContent()[0].byId("demo").getButtons()[productCategoryController.index]);
        }
        //Default set the visibility of search button true.
        app.getPage(ID_PRODUCT_CATALOG_PAGE).getCustomHeader().getContentRight()[0].setVisible(true);
        
        app.to(ID_PRODUCT_CATALOG_PAGE);
        //Re-render the segmented button sapui5 issue.
        app.getPage(ID_PRODUCT_CATALOG_PAGE).getContent()[0].byId("demo").rerender();
        
    },
    //changing the catalog filter name in sub header.
    changeCatalogFilter: function(){
      var index = productCatalogController.computeIndex();
      productCatalogData.catalogPresent = [];
      productCatalogController.computeCatalogPresentData(index);
      
      app.getPage(ID_PRODUCT_CATALOG_PAGE).getContent()[0].getModel().setData(productCatalogData);
      app.to(ID_PRODUCT_CATALOG_PAGE);
    },
    //To browse the catalogs categories.
    changeCatalogCategory: function(ev){

      var index = productCatalogController.computeIndex();
      var categorySource = ev.getSource();
      var itemSelected = categorySource.getBindingContext().getProperty(categorySource.getBindingContext().getPath());
      if(productCategoryController == null){
        productCategoryController = sap.ui.controller("app.ui.productCatalog.productCategory");
      }
      
      productCategoryController.launchProductCategoryPage(index,itemSelected);
    },
    //Computes the index to which the categoryFilter belongs.
    computeIndex : function(){
		var changeFilter = app.getPage(ID_PRODUCT_CATALOG_PAGE).getContent()[0].byId("demo");
	      for(var i =0 ;i<changeFilter.getButtons().length;i++){ 
	    	  if(changeFilter.getButtons()[i].getId() == changeFilter.getSelectedButton()){
	    		  return i;
	    	  }
	      }
	},
	//Compute the catalog present Data.
	computeCatalogPresentData : function(index){
		for(var j=0; j<productCatalogData.catalog[index].category.length;j++){
	    	  if(productCatalogData.catalog[index].category[j].parentID == 0){
	    		  productCatalogData.catalogPresent.push(productCatalogData.catalog[index].category[j]);
	    	  }
	    }
	},
	//Method to add the event handler onBlur and onFocus.
	/*onAfterRendering : function(){
		//var viewRef = app.getPage(ID_PRODUCT_CATALOG_PAGE).getContent()[0];
		
		var viewRef = app.getPage(ID_PRODUCT_CATALOG_PAGE).getContent()[0];
        var username = viewRef.byId("product_search");
        var z = username.getDomRef();
        var c = z.childNodes[0].childNodes[0].childNodes[1].childNodes[0];
        c.onfocus = function(){
        	//console.log("focus");
        	productCatalogController.showOverlay(viewRef);
       };
      c.onblur = function(){
        	//console.log("blur");
        	productCatalogController.hideOverlay(viewRef);
      	};
        	
	},*/
	//Method that provides overlay effect to background by adding appropriate style class
	showOverlay: function(viewRef){
		var os = viewRef.byId("tempId");
		var ps = viewRef.byId("productCatalogList");
		os.addStyleClass("overlayScreen");
		ps.addStyleClass("overlayScreen");
	},
	//Method that removes overlay effect to background by removing appropriate style class
	hideOverlay: function(viewRef){
		var os = viewRef.byId("tempId");
		var ps = viewRef.byId("productCatalogList");
		os.removeStyleClass("overlayScreen");
		ps.removeStyleClass("overlayScreen");
		popUpForSearch.close();
		
	},
	//Live search for the data 
	searchProductsInCatalog : function(ev){
		var viewRef = app.getPage(ID_PRODUCT_CATALOG_PAGE).getContent()[0];
        var username = viewRef.byId("product_search");
        var z = username.getDomRef();
        var c = z.childNodes[0].childNodes[0].childNodes[1].childNodes[0];
        c.onfocus = function(){
        	//console.log("focus");
        	productCatalogController.showOverlay(viewRef);
       };
       c.onblur = function(){
        	//console.log("blur");
        	productCatalogController.hideOverlay(viewRef);
      	};
       var os = viewRef.byId("tempId");
		var ps = viewRef.byId("productCatalogList");
		os.addStyleClass("overlayScreen");
		ps.addStyleClass("overlayScreen");

		/*if(popUpForSearch != undefined || popUpForSearch != null)
			popUpForSearch.close();*/
		var inputSearch = ev.getSource().getValue();
		//Demo data assumed to be recevied from service.
		productServerCatalog = {
				products : [{
					id : 1100,
					productName : "Cookies",
					productImage : "app/ui/productCatalog/img/bakery1.png",
					productBrandName : "Britania",
					productPrice : 100,
					productType : ""
				},{
					id : 1100,
					productName : "Butter Cookies",
					productImage : "app/ui/productCatalog/img/bakery2.png",
					productBrandName : "Britania",
					productPrice : 60,
					productType : ""
				},{
					id : 1100,
					productName : "Muffens",
					productImage : "app/ui/productCatalog/img/bakery3.png",
					productBrandName : "abc",
					productPrice : 90,
					productType : ""
				},{
					id : 1100,
					productName : "Biscuts",
					productImage : "app/ui/productCatalog/img/bakery4.png",
					productBrandName : "UM",
					productPrice : 100,
					productType : ""
				},{
					id : 1221,
					productName : "Biscuts",
					productImage : "app/ui/productCatalog/img/bakery4.png",
					productBrandName : "Kinderjoy",
					productPrice : 100,
					productType : ""
				},{
					id : 1222,
					productName : "Biscuts",
					productImage : "app/ui/productCatalog/img/bakery4.png",
					productBrandName : "Walley",
					productPrice : 100,
					productType : ""
				},{
					id : 1231,
					productName : "Biscuts",
					productImage : "app/ui/productCatalog/img/bakery4.png",
					productBrandName : "Britania",
					productPrice : 100,
					productType : ""
				},{
					id : 1232,
					productName : "Biscuts",
					productImage : "app/ui/productCatalog/img/bakery4.png",
					productBrandName : "Cream Treat",
					productPrice : 100,
					productType : ""
				},{
					id : 5110,
					productName : "T-Shirt",
					productImage : "app/ui/productCatalog/img/cshirt1.png",
					productBrandName : "Lee cooper",
					productPrice : 900,
					productType : ""
				},{
					id : 5110,
					productName : "T-Shirt",
					productImage : "app/ui/productCatalog/img/cshirt2.png",
					productBrandName : "Levis",
					productPrice : 750,
					productType : ""
				},{
					id : 5120,
					productName : "T-Shirt",
					productImage : "app/ui/productCatalog/img/cshirt3.png",
					productBrandName : "Shopper Stop",
					productPrice : 800,
					productType : ""
				}]
		};
		//Default variable that holds the data according to the search performed.
		addProductItems = {
				products : []
		};
		for ( var i = 0; i < productServerCatalog.products.length; i++) {
			var brandName = productServerCatalog.products[i].productBrandName.toLowerCase();
			
			var searchString = inputSearch.toLowerCase();
			if (brandName.indexOf(searchString) != -1)
				addProductItems.products.push(productServerCatalog.products[i]);
		}
		productCatalogController.fillProductList(addProductItems);
	},
	//Method inflates the pop up with list items.
	fillProductList : function(addProductItems){
		popUpForSearch.destroyContent();
		//Empty the list every time a live search is performed.
		var gList = new sap.m.List({
			items : [],
			
		});
		for(var i=0 ; i<addProductItems.products.length ; i++){
			gList.addItem(new sap.m.StandardListItem({
				title : addProductItems.products[i].productBrandName,
				description : addProductItems.products[i].productName,
				icon : addProductItems.products[i].productImage,
				tap : function(ev){
					
					var initialItem = ev.getSource().getTitle();
					productCatalogData.catalog[0].category.push({categoryName : initialItem,categoryID : 1000,parentID : 0})
					
					productCatalogController.launchProductCatalogPage();
				},
				type : "Active"
			}));
		}
		
		//Add the list to pop up overlay screen
		popUpForSearch.addContent(gList);
		popUpForSearch.addStyleClass("productStyleSearch");
		popUpForSearch.open();
		$("#popUpForSearchCatalog-header").hide();
	}
});
