
function createRegisterBusyDialog() { 
	util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Registering_User_In_Progress") );
}

function launchPasscode(){
    if ( PINController == null)
        PINController = sap.ui.controller("app.ui.passcode.passcodeController")
    if (createProfileController.okFlag )
		PINController.startPasscodeEntry();
    else
		createProfileController.okFlag = true;
}


var registerBack = function(response, status){
	
	if(status != 200) {
		//logindialog change
		util.closeBusyDialog();
		checkErrorStatus(response)
		return;
	}
	
	var dataRegisterBack = {};
		objVal = {};
	
	if( isRESTStatusCodeCorrect(response) ) {

		dataRegisterBack['Status'] = '0';
		
		var customerId = response.customerId;
		dataRegisterBack['customerId'] = customerId;
		
		//reset signup values
		var dataCreateProfile ={
		    personalinfo: {
			firstname:"",
			lastname:"",
			phonenumber:"",
			email:"",
			zipcode:"",
			country:userState.DEFAULT_COUNTRY_CODE
		    },
		    password: {
			password:""
		    },
		    passcode: {
			passcode:""
		    }
		};
		app.getPage(ID_CREATE_PROFILE).getContent()[0].getModel().setData(dataCreateProfile);

		//reset codeverification values		
		var dataVerification = vericationCodeModel;
		dataVerification.type = "";
		dataVerification.token = "";
		vericationCodeModel.setData(dataVerification);
		//app.getPage(VERIFICATION_PAGE).getContent()[0].getModel().setData(dataVerification);
		util.closeBusyDialog();
		if (homepageController==undefined){
            homepageController = sap.ui.controller("app.ui.login.login");
        }
		launchLoginPage();
	}
	else{
		util.closeBusyDialog();
		if ( response.Status.code == 202){
			//user already exists
		    app.to(ID_CREATE_PROFILE);
			if( window.device!=undefined && window.device.platform === "iOS" )
				createProfileController.okFlag = false;
			logError( "log_error_message_User_Exists","LoginBack", "Login"); 
		}
		else{
				checkErrorMobiliserStatus( response);
			}
	}
	
	registerResponseModel = new sap.ui.model.json.JSONModel();
	registerResponseModel.setData(dataRegisterBack);
}

function launchVerificationCodePage(){
	app.to(VERIFICATION_PAGE);
}

var createTokenBack = function(response, status){
	if( isRESTStatusCodeCorrect(response) ) {		
		//set so sms
		var tempData = vericationCodeModel;
		tempData.type = "token";
		vericationCodeModel.setData(tempData);
		//launch verificationCode page
		popupControl.removeFromPage();
		app.to(VERIFICATION_PAGE);
		//verificationCodePage.open();
	}
	else {
		//failed make token go back to create profile page
		alert("did not create token");
		popupControl.removeFromPage();
		app.to(ID_CREATE_PROFILE);
	}
}

function doRegister(){
	createRegisterBusyDialog();
	
	var data = {
		createProfileModel :  CreateProfileModel,
		verificationCodeModel : vericationCodeModel
	};
	//var registerResponseModel = proxy_Register.Register(registerBack,CreateProfileModel, vericationCodeModel);
	SmartphoneService.createLoyaltyCustomer(data, registerBack, null, null, false);
}

function validateEmail(email) { 
    var re = /^([a-zA-Z][\w\.-]*[a-zA-Z0-9]@[a-zA-Z0-9][\w\.-]*[a-zA-Z0-9]\.[a-zA-Z][a-zA-Z\.]*[a-zA-Z]){0,1}(,[a-zA-Z][\w\.-]*[a-zA-Z0-9]@[a-zA-Z0-9][\w\.-]*[a-zA-Z0-9]\.[a-zA-Z][a-zA-Z\.]*[a-zA-Z])*$/;
    return re.test(email);
}

function validatePhoneNum(num){
		for (  i=0 ; i < num.length ; i++){
				num = num.replace(" ","");
				num = num.replace("-","");
				num = num.replace(".","");
				num = num.replace("(","");
				num = num.replace(")","");
		}
		var re= /^((\+){0,1}[0-9]+){0,1}(,(\+){0,1}[0-9]+)*$/;
		return re.test(num);
}
function validateZipCode(num){
	var re = /^[0-9]+$/;
	return re.test(num);
}
function configTokenBack(response){
	if(isRESTStatusCodeCorrect(response)) {
		if (response.configValue == "true"){
			SmartphoneService.getLoyaltyConfiguration("TokenValidationType", tokenValidationBack, null, null, false);
		}
		else{
			doRegister();
		}
	}
	else{
		checkErrorMobiliserStatus(response);	
	}		
}

function tokenValidationBack(response){
		if(isRESTStatusCodeCorrect(response)) {
				var config = response.configValue;
				config = config.toLowerCase();
				if ( config == "both"){
					popupControl.attachToPage(app.getCurrentPage(), popupControl);
				}
				else if (config == "email"){
						createProfileController.doEmail();
				}
				else if (config == "sms"){
						createProfileController.doSMS();
				}
		}
		else{
			checkErrorMobiliserStatus(response);	
		}		
}

sap.ui.controller('app.ui.register.registerList', {
	
	okFlag : true,
	previousPage: ID_LOGIN_PAGE,
	
	launchCreateProfile : function(prevPage){

		this.previousPage = prevPage;

		if (app.getPage(ID_CREATE_PROFILE)==null) {
			//main view
			var CreateProfileListView = new sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.register.registerList",
				controller : createProfileController
			});
			
			//CreateProfileListView.byId("signUp_Country").setTitle("Country");

			var page1 = new sap.m.Page(ID_CREATE_PROFILE, {
				title : oBundle.getText("Create_Profile"),
				content : [ CreateProfileListView ],
				showNavButton : false,
				//footer : new sap.m.Bar()
			});

			CreateProfileModel = new sap.ui.model.json.JSONModel();
			CreateProfileListView.setModel(CreateProfileModel);

			var buttonsPanel = sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.register.buttonsPanelView",
				controller : createProfileController
			});

			popupControl = new PopupSliderControl({ content: [ buttonsPanel]});

			//enter verification code			
			var verficiationCodeView = sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.register.verificationCode",
				controller : createProfileController
			});

			verificationCodePage = new sap.m.Page(VERIFICATION_PAGE, {
				title: oBundle.getText("{i18n>Verification}"),
				content: [ verficiationCodeView ]
			});

			vericationCodeModel = new sap.ui.model.json.JSONModel();
			verficiationCodeView.setModel(vericationCodeModel);

			app.addPage(verificationCodePage);

			app.addPage(page1);
		}

		var dataCreateProfile ={
				personalinfo: {
					firstname:"",
					lastname:"",
					phonenumber:"",
					email:"",
					zipcode:"",
					country:userState.DEFAULT_COUNTRY_CODE
				},
				password: {
					password:""
				},
				passcode: {
					passcode:"",
					showPasscode: true
				}
		};
		var showPasscode = userState['WALLET_PASSCODE_ENABLED'];
		dataCreateProfile.passcode.showPasscode = showPasscode;
		app.getPage(ID_CREATE_PROFILE).getContent()[0].getModel().setData(dataCreateProfile);
		
		var dataVerificationCode = {
				token:"",
				type:"",
		};
		app.getPage(VERIFICATION_PAGE).getContent()[0].getModel().setData(dataVerificationCode);

		var createProfileView = app.getPage(ID_CREATE_PROFILE).getContent()[0];
		createProfileView.byId("signUp_Country").setInfo(userState.DEFAULT_COUNTRY_CODE);
		
		var errorLabel = createProfileView.byId("createProfile_error_label");
		errorLabel.setText("");

		util.closeBusyDialog();
		app.to(ID_CREATE_PROFILE);
		util.createBusyDialog( oBundle.getText("Countries"), oBundle.getText("Loading") );
		SmartphoneService.getCountries({}, this.getCountriesBack);
	},
	getCountriesBack: function(response, status) {
		if (status != 200) {
			//alert("callbackFunc");
			checkErrorStatus(status);
			return;
		}

		if (isRESTStatusCodeCorrect(response)) {
			//settingsController.memberCardsData = util.processResponse(response, "GetMemberCardsResponse");
			//countryListController.listData = response;
			if(countryListController == undefined) 
				countryListController = sap.ui.controller("app.ui.register.countryList");
			countryListController.listData.country = [];
			for(var i=0; i<response.country.length; i++){
				//If translation for country code is present then push it to country list array
				if(oCountry.getText(response.country[i].countryId) != response.country[i].countryId){
					countryListController.listData.country.push({name : oCountry.getText(response.country[i].countryId), countryId : response.country[i].countryId});
					//If the country code is same as the default country code then set the country name in signup page.
					if(response.country[i].countryId == userState.DEFAULT_COUNTRY_CODE){
						app.getPage(ID_CREATE_PROFILE).getContent()[0].byId("signUp_Country").setInfo(oCountry.getText(response.country[i].countryId));
						CreateProfileModel.getData().personalinfo.country = response.country[i].countryId;
					}
				}
			}
		}
		else{
			util.closeBusyDialog();
			logError("error_message_general", "Error in the response of getMemberCards", "settings");
		}
		util.closeBusyDialog();
	},
	onAfterRendering: function(){ 

	},
	doCreateProfile : function(){

		dataLogger.debug("Openning wait cursor");
		dataLogger.debug("Wait cursor opennned");

		//Basic Validations
		var createProfileView = app.getPage(ID_CREATE_PROFILE).getContent()[0];
		var errorLabel = createProfileView.byId("createProfile_error_label");

		var firstName = createProfileView.byId("signUp_FirstName").getValue();
		var lastName = createProfileView.byId("signUp_LastName").getValue();
		var phoneNumber = createProfileView.byId("signUp_PhoneNumber").getValue();
		var password = createProfileView.byId("signUp_Password").getValue();
		var verifyPassword = createProfileView.byId("signUp_VerifyPassword").getValue();
		var email = createProfileView.byId("signUp_Email").getValue();
		var verifyEmail = createProfileView.byId("signUp_VerifyEmail").getValue();
		var passcode = createProfileView.byId("signUp_Passcode").getValue();
		var zipcode = createProfileView.byId("signUp_ZipCode").getValue();
		var countryName = createProfileView.byId("signUp_Country").getInfo();
		
		//check there are entries
		if ( firstName.trim().length==0 || lastName.trim().length==0 || phoneNumber.trim().length == 0 ||
				phoneNumber.trim().length == 0 || password.trim().length ==0 || verifyPassword.trim().length ==0 ||
				email.trim().length ==0 || verifyEmail.trim().length ==0 || zipcode.trim().length == 0 || 
				countryName == ""
		){
			errorLabel.setText(oBundle.getText("error_message_missing_entry"));
			return;
		}
		//check valid phone # with + at beginning
		else if( phoneNumber.charAt(0) != "+" ){
			errorLabel.setText(oBundle.getText("error_message_number_start"));
			return;
		}

		else if ( !validatePhoneNum(phoneNumber) ){
			errorLabel.setText(oBundle.getText("error_message_valid_phone"));
			return;
		}

		//check password and verify password
		else if ( password.trim() != verifyPassword.trim() ){
			errorLabel.setText(oBundle.getText("error_message__password"));
			return;
		}
		else if ( password.trim().length <8 || password.trim().length >23 ){
			errorLabel.setText(oBundle.getText("error_message_password_length"));
			return;
		}
		//check email == verify email
		else if ( email.trim() != verifyEmail.trim() ){
			errorLabel.setText(oBundle.getText("error_message_email"));
			return;
		}
		else if ( !validateEmail(email) ){
			errorLabel.setText(oBundle.getText("error_message_validEmail"));
			return;
		}
		//check valid PIN
		else if ( userState['WALLET_PASSCODE_ENABLED'] && passcode.trim().length == 0){
			errorLabel.setText(oBundle.getText("error_message_passcode"));
			return;
		}
		else if(!validateZipCode(zipcode)){
			errorLabel.setText(oBundle.getText("error_message_zipcode"));
			return;
		}
		else if( isNaN(passcode) ){
			errorLabel.setText(oBundle.getText("error_message_passcode_not_numeric"));
			return;
		}
		else{
			errorLabel.setText("");
		}

		//SmartphoneService.getLoyaltyConfiguration("TokenValidationEnabled", configTokenBack);
		if (userState['TOKEN_VALIDATION_ENABLED'] == true){
			//SmartphoneService.getLoyaltyConfiguration("TokenValidationType", tokenValidationBack, null, null, false);
			config = userState['TOKEN_VALIDATION_TYPE'].toLowerCase();
			//console.log(config);
			if ( config == "both"){
				popupControl.attachToPage(app.getCurrentPage(), popupControl);
			}
			else if (config == "email"){
					createProfileController.doEmail();
			}
			else if (config == "sms"){
					createProfileController.doSMS();
			}
		}
		else{
			doRegister();
		}
	},
	doSMS : function(){
		SmartphoneService.createSmsToken(CreateProfileModel, createTokenBack);
	},
	doEmail : function(){
		SmartphoneService.createEmailToken(CreateProfileModel, createTokenBack);
	},
	doRegisterCall : function(){
		var code = app.getPage(VERIFICATION_PAGE).getContent()[0].byId("tokeverification_input").getValue();
		if (code.trim().length > 0)
			doRegister();
		else{
			logError("enter_verification_code", "Token Empty", "Sign Up Token Empty");
		}
	},
	doPopUpCancel: function(){
		popupControl.removeFromPage();
	},
	doCancel: function(){
		var dataCreateProfile ={
				personalinfo: {
					firstname:"",
					lastname:"",
					phonenumber:"",
					email:"",
					zipcode:"",
					country:oBundle.getText("country")
				},
				password: {
					password:""
				},
				passcode: {
					passcode:""
				}
		};
		app.getPage(ID_CREATE_PROFILE).getContent()[0].getModel().setData(dataCreateProfile);
		app.backToPage(createProfileController.previousPage);
	},
	closeRegisterFail : function(){
		util.closeBusyDialog();
	},
	doVerificationCancel : function(){
		app.back();
	},
	tapCountry : function(ev) {
		if(countryListController == undefined) 
			countryListController = sap.ui.controller("app.ui.register.countryList");
			countryListController.displayCountryListPage();
	}
});

