// 2012 SAP AG. All rights reserved.
// Author : SAP.

sap.ui.controller('app.ui.servicesettings.serviceSettings', {
	
	settingsControllerPageDirty : false,

	onAfterRendering : function(){
		
	},
	
    onDonePressed:function(){
		userState['PROTOCOL'] = connectSettingsModel.oData.protocol;
		userState['IPADDRESS'] = connectSettingsModel.oData.ip;
		userState['PORT'] = connectSettingsModel.oData.port;
		//userState['CONTEXT'] = connectSettingsModel.oData.servicecontext;
		SmartphoneService.setUrl();

		window.localStorage.setItem("protocol", connectSettingsModel.oData.protocol);
		window.localStorage.setItem("ipaddress", connectSettingsModel.oData.ip);
		window.localStorage.setItem("port", connectSettingsModel.oData.port);
		//window.localStorage.setItem("context", connectSettingsModel.oData.servicecontext);
		
		this.settingsControllerPageDirty = false;
		if (userState.IPADDRESS != "" && userState.PROTOCOL != "")
			connectSettingsController.checkServerConnection();
		if (homeController == undefined) {
			homeController = sap.ui.controller("app.ui.home.homeController");
		}
		homeController.modelData.offersRefreshNeeded = 0;
		homeController.modelData.callAppConfig = true;
    	homeController.prevPage = "to";
		homeController.launchAnonymousHomePage();
    },
    
    onInputValueChanged : function(){
        var viewId = app.getPage(MOBILISER_SETTINGS_PAGE).getContent()[0].getId();
			$('#' + viewId + '--' + 'statusConnectionColor-inner').removeClass('statusColorRed');
			$('#' + viewId + '--' + 'statusConnectionColor-inner').addClass('statusColorGreen');
    },
    
    loadMobiliserSettingsPage:function(prevPage){
         if (app.getPage(MOBILISER_SETTINGS_PAGE) == null){
                /*var header = new sap.m.Bar({
                    contentLeft : [new sap.m.Button({
                        text : oBundle.getText("Back_Button"),
                        type : sap.m.ButtonType.Back,
                        tap : function() {
                                app.back();
                            }
                        })],
                        contentMiddle : [new sap.m.Label({text: oBundle.getText("connection_settings")})],
                        contentRight : [new sap.m.Button({ text: oBundle.getText("done"),
                            tap : function() {
                                connectSettingsController.onDonePressed();
                            }
                    })],                
               	});*/ 
                
            var loginView = sap.ui.view({
                type : sap.ui.core.mvc.ViewType.XML,
                viewName : "app.ui.servicesettings.serviceSettings",
                controller : connectSettingsController
            });

            var page1 = new sap.m.Page(MOBILISER_SETTINGS_PAGE, {
                
                content : [ loginView ],
                title : oBundle.getText("connection_settings"),
                showNavButton : true,
                navButtonText : oBundle.getText("Back_Button"),
                navButtonTap : function(){
                	//If incorrect connection setting details are provided the navigate back to landing page.
                	if(homeController){
                		if(homeController.modelData){
                			if(homeController.modelData.notConnectedToServer){
                				app.backToPage(ID_CONNECTION_SETTINGS_PAGE);
                				return;
                			}
                		}
                	}
                	//Else just navigate back if connection settings are correct.
					app.back();
                },
                headerContent : [new sap.m.Button({ text: oBundle.getText("done"),
                    tap : function() {
                        connectSettingsController.onDonePressed();
                    }
                })],
            });
            
            var dataLogin = null;
            if(window.localStorage.getItem("ipaddress"))
            {
            	dataLogin = {
            			protocol:window.localStorage.getItem("protocol"),
            			ip:window.localStorage.getItem("ipaddress"),
            			port:window.localStorage.getItem("port"),
            			connectionStatus : oBundle.getText("disconnected"),
            			//servicecontext:window.localStorage.getItem("context")
            	};
            } else {
                dataLogin = {
                    protocol: userState['PROTOCOL'],
                    ip: userState['IPADDRESS'] ,
                    port: userState['PORT'],
                    connectionStatus : oBundle.getText("disconnected"),
                    //servicecontext : "",
                };

            }
            connectSettingsModel = new sap.ui.model.json.JSONModel();
            connectSettingsModel.setData(dataLogin);
            loginView.setModel(connectSettingsModel);
            app.addPage(page1);
        
        }   
        app.to(MOBILISER_SETTINGS_PAGE);
        
        if(window.localStorage.getItem("ipaddress")) {
        	connectSettingsController.checkServerConnection();
        }
    },
    
    connectionMadeBack: function(response, status) {
		if (status != 200) {
			checkErrorStatus(status);
			return;
		}
		
		if(isRESTStatusCodeCorrect(response)) {
			var tempData = app.getPage(MOBILISER_SETTINGS_PAGE).getContent()[0].getModel().getData();
			tempData.connectionStatus = oBundle.getText("connected");
			app.getPage(MOBILISER_SETTINGS_PAGE).getContent()[0].getModel().setData(tempData);
			var viewId = app.getPage(MOBILISER_SETTINGS_PAGE).getContent()[0].getId();
			$(".serviceSettings_connection_width.sapMInputBaseInner").css("color", "#CC1919");
			//$('#' + viewId + '--' + 'statusConnectionColor-inner').removeClass('statusColorRed');
			//$('#' + viewId + '--' + 'statusConnectionColor-inner').addClass('statusColorGreen');
		}
		else{
			//$('#' + viewId + '--' + 'statusConnectionColor-inner').removeClass('statusColorGreen');
			//$('#' + viewId + '--' + 'statusConnectionColor-inner').addClass('statusColorRed');
		}
    },
    
    checkServerConnection: function() {
    	var body = {
    			origin:"mLoyalty",
    			traceNo: UUIDv4()
		};
    	if(window.cordova){
			if(navigator.connection.type != "none" && navigator.connection.type != "unknown"){
				SmartphoneService.ping(body,connectSettingsController.connectionMadeBack);
			}
		} else 	SmartphoneService.ping(body,connectSettingsController.connectionMadeBack);

    }
    
});
