
var resetPasswordBack = function(response, status){
    //reset reset values
    var dataReset = {
        currentPassword : "",
        newPassword : "",
        verifyNewPassword : ""
    };
    app.getPage(RESET_PASSWORD).getContent()[0].getModel().setData(dataReset);
    
    if (status != 200) {
	    checkErrorStatus(status);
	    return;
    }
    if(isStatusCodeCorrect(response)) {
        app.to(CARD_PICKER_PAGE);
    }
    else{
        //failed change password
	logError("error_message_change_PW_fail", "failed update password, check status code", "resetPasswordBack")
    }
}

sap.ui.controller('app.ui.settings.resetPassword', {
    
    launchResetPasswordPage : function(){
        if (app.getPage(RESET_PASSWORD)==null) { 
            var resetPasswordView = sap.ui.view({
                        type : sap.ui.core.mvc.ViewType.XML,
                        viewName : "app.ui.settings.resetPassword",
                        controller : resetPasswordController
            });

        //ADDING PAGES
            var page1 = new sap.m.Page(RESET_PASSWORD, {
                title : oBundle.getText("Reset_Password"),
                content : [ resetPasswordView ],
                showNavButton : true,
				text : oBundle.getText("Back_Button"),
                navButtonTap : function() {
                                        app.back();
                                },
                footer : new sap.m.Bar()
            });
            
            var dataReset = {
                currentPassword : "",
                newPassword : "",
                verifyNewPassword : ""
            };

            resetPasswordModel = new sap.ui.model.json.JSONModel();
            resetPasswordModel.setData(dataReset);
            resetPasswordView.setModel(resetPasswordModel);
            app.addPage(page1);
        }
        app.to(RESET_PASSWORD);
    },
    
    doReset: function(){
        var tempView = app.getPage(RESET_PASSWORD).getContent()[0];
	var errorLabel = tempView.byId("reset_error_error_label");
        
        var password = tempView.byId("input_current").getValue();
        var newpassword = tempView.byId("input_new_password").getValue();
        var verifynewpassword = tempView.byId("input_verify_password").getValue();
        
        if (password.trim().length == 0 || newpassword.trim().length == 0 || verifynewpassword == 0){
            errorLabel.setText(oBundle.getText("error_message_missing_entry"));
	    return;
        }
        else if ( newpassword.trim().length < 3 || newpassword.trim().length > 23 ){
            errorLabel.setText(oBundle.getText("error_message_password_length"));
            return;
        }
        else if ( newpassword.trim() !=verifynewpassword.trim() ){
            errorLabel.setText(oBundle.getText("error_message__password"));
            return;
        }
        else{
		errorLabel.setText("");
	}
        
        //var proxy_passwordReset = new Proxy();
	    //var resetPassword = proxy_passwordReset.resetPassword( resetPasswordBack, resetPasswordModel);
    }
    
});