sap.ui.controller('app.ui.settings.settingsController', {
	cardFront : "",

	settingsModel: "",
	
	memberCardsData: "",
	
	cardCredentialBusyDialog: null,
	
	data : {
		cardId : "",
		membershipId : ""
	},
	
	customerData : {
		customerId : loginResponseModel.customer.id
	},
	
	cardsData : {},
	
	onAfterRendering: function(){ 

	},
	
	displaySettingsPage: function() {
		
		settingsController.customerData.customerId=null;
		
		settingsController.customerData.customerId=loginResponseModel.customer.id;
	
		if(app.getPage(SETTINGS_PAGE) == null ) {
			
			var header = new sap.m.Bar('SettingsBar', {
				contentRight : "",
				contentMiddle : [new sap.m.Label("settingsTitle", {text: oBundle.getText("settings") })],
				contentLeft : [new sap.m.Button({ 
                	icon: "sap-icon://menu2",
                	activeIcon: "sap-icon://menu2",
					tap :function(event, src) {
						
						sliderMenuController.action('menuButtonSettings');
					}
				}).addStyleClass("menuButtonIconFont")]
			});

			
			var settingsView = sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.settings.settingsView",
				controller : this
			});


			var settingsPage = new sap.m.Page(SETTINGS_PAGE, {
				customHeader : header,
				//title : oBundle.getText("settings"),
				content : [ settingsView ],
				showNavButton : false
			});
			
			app.addPage(settingsPage);
			
			this.settingsModel = new sap.ui.model.json.JSONModel();
			settingsView.setModel(this.settingsModel);

		}
		
		//SmartphoneService.getMemberByCustomerId(loginResponseModel.customer.id, settingsController.getMemberByCustomerIdBack, null, null, true);
		util.createBusyDialog(oBundle.getText("Settings_Progress_Message"), oBundle.getText("Loading"));
		SmartphoneService.getMemberCards(loginResponseModel.customer.id, settingsController.getMemberCardsBack);
		//proxy_login.GetMemberByCustomerId(settingsController.getMemberByCustomerIdBack, loginResponseModel.customer.id);
		//app.to(SETTINGS_PAGE);
		
	},
	/*
	getMemberByCustomerIdBack: function(response, status) {
		if (status != 200) {
			alert("Error!");
			return;
		}

		if (isStatusCodeCorrect(response)) {

			var responseModel = util.processResponse(response, "GetMemberByCustomerIdResponse");
			SmartphoneService.getMemberCards(responseModel.Member.memberId, settingsController.getMemberCardsBack);
			//proxy_login.GetMemberCards(settingsController.getMemberCardsBack, responseModel.Member.memberId);

		} else {
			var statusValue = response.getElementsByTagName('Status')[0].attributes.getNamedItem('code').value;
			alert("Status Code not 0!!!");
		}
		
		
	},
	*/
	getMemberCardsBack: function(response, status) {
		if (status != 200) {
			//alert("callbackFunc");
			checkErrorStatus(status);
			return;
		}

		if (isRESTStatusCodeCorrect(response)) {
			//settingsController.memberCardsData = util.processResponse(response, "GetMemberCardsResponse");
			settingsController.memberCardsData = response;
			var cardsInfo = settingsController.memberCardsData.Cards;
			var cardsInfoCount = cardsInfo.length;
			var currentCard = "",
			currentCardModel = "",
			cardItems = [];

			
			if(cardsInfoCount == undefined) {
				currentCard = cardsInfo;
				currentCardModel = {
						 title : currentCard.programName,
						 navItem : currentCard.programName,
						 programId : currentCard.programId,
						 id : 0
				};
				
				cardItems.push(currentCardModel);
			}
			else {
				for(var i=0; i<cardsInfoCount; i++) {
					currentCard = cardsInfo[i];
					
					if (currentCard.membershipId == null){
						currentCardModel = {
							title : currentCard.cardName,
							navItem : currentCard.cardName,
							programId : currentCard.programId,
							id : i
						};
					}
					else{
						var logoVal = currentCard.logo;
						if(userState['DEMO_MODE'] == false)
							logoVal = "data:image/png;base64," + logoVal;
						currentCardModel = {
							title : currentCard.programName,
							navItem : currentCard.programName,
							logo : logoVal,
							id : i
						};
					}
					 
					 cardItems.push(currentCardModel);
				}
			}
				var serverStatus ="";
				if(userState['DEMO_MODE'] == true)
						serverStatus = oBundle.getText("disconnected")
				else
						serverStatus = oBundle.getText("connected")
			
			var cardsData = {
				connectionStatus : serverStatus,
				cardItems: cardItems,
				showPreferences: true,
				preferenceCategories: [{
						title: oBundle.getText("general_pref"),
						category: "application",
					}],
				cardDetails : []
			};
				
				settingsController.cardsData = cardsData;
			
			if(userState['BRANDTYPE'] == "single")
			{
				if(subscribedPrograms.length > 0){
					var cardCategory = {
							title: oBundle.getText("Card_Menu_Title"),
							category: "card",
					};
					cardsData.preferenceCategories.push(cardCategory);
				}
			}	
			
			settingsController.settingsModel.setData(cardsData);
			
			//Calls the function to get paymentCardInstruments
			SmartphoneService.getWalletEntriesByCustomer(settingsController.customerData, settingsController.paymentCardDetailsCallBack);
				
			
		}
		else{
			util.closeBusyDialog();
			logError("error_message_general", "Error in the response of getMemberCards", "settings");
		}
	},
	settingHouseholdHandler : function(response,status){
		if (isRESTStatusCodeCorrect(response)){
			if(response.households.length > 0){
				var cardsData = settingsController.settingsModel.getData();
				var householdCategory = {
						title: oBundle.getText("household"),
						category: "household",
				};
				cardsData.preferenceCategories.push(householdCategory);
				settingsController.settingsModel.setData(cardsData);
			}
		}
		else{
			logTechnicalError("Error while retreiving the household details");
		}
		util.closeBusyDialog();
	},
    paymentCardDetailsCallBack : function (response, status) {
    	if (isRESTStatusCodeCorrect(response)){
    		settingsController.cardsData.cardDetails = response.walletEntries;
    		//logic to set Primary Card
    		for(var i=0; i<settingsController.cardsData.cardDetails.length; i++){
    			if(settingsController.cardsData.cardDetails[i].creditPriority == 1){
    				settingsController.cardsData.cardDetails[i].isPrimary = true;
    			}
    			else{
    				settingsController.cardsData.cardDetails[i].isPrimary = false;
    			}
    		}
    		
    		settingsController.settingsModel.setData(settingsController.cardsData);
			var data = app.getPage(SETTINGS_PAGE).getContent()[0].getModel().getData();
			data.showHousehold = userState.HOUSEHOLDING_ENABLED;
			settingsController.preferencesData = null;
			app.getPage(SETTINGS_PAGE).getContent()[0].getModel().setData(data);
			//util.closeBusyDialog();
			app.to(SETTINGS_PAGE);
			if(userState['BRANDTYPE'] == "single")
			{
				//Household preference whether created or not.
				SmartphoneService.getHouseholdDetailsForMember({},settingsController.settingHouseholdHandler);
			}
			else{
				util.closeBusyDialog();
			}
    	}
    	else{
    		logTechnicalError("Error while retreiving the payment cards for the customer");
    	}
	},
	
	householdingEnabledBack: function(response, status){
		if (isRESTStatusCodeCorrect(response)) {
			
			var data = app.getPage(SETTINGS_PAGE).getContent()[0].getModel().getData();
			if(response.configValue == "true")
				data.showHousehold = true;
			else
				data.showHousehold = false;
			app.getPage(SETTINGS_PAGE).getContent()[0].getModel().setData(data);
			
			util.closeBusyDialog();
			settingsController.preferencesData = null;
		}else{
			util.closeBusyDialog();
			logTechnicalError("getLoyaltyConfiguration Failed", "getLoyaltyConfiguration HouseholdingEnabled Couldn't be fetched");
		}
	},
	
	displayLoginCredentialScreen: function() {
		util.createBusyDialog(oBundle.getText("Loading"), oBundle.getText("Loading"));
		//go to login credentials page
		if ( userCredentialSettingsController == undefined )
		    userCredentialSettingsController = sap.ui.controller("app.ui.settings.userCredentialSettings")
		userCredentialSettingsController.launchUserCredentialPage();
		return;
	},
	
	/*
	 * We need selectedCardTitle on the tap of a card row so that when we land up on the card credential screen for a standard
	 * loyalty card, we can show the title on the Preferences Option row, something like "CardTitle Preferences"
	 */
	selectedCardTitle: "",
	displayCardCredentialScreen: function(event) {
		var listSelectedCardCredential = event.getSource();
		
		var rowData = listSelectedCardCredential.getBindingContext().getProperty(listSelectedCardCredential.getBindingContext().getPath());
		settingsController.selectedCardTitle = rowData.title;
		
		//console.log("JSON " + JSON.stringify(rowData));
		var cardCredentialIndex = listSelectedCardCredential.data("cardcredential");
		var cardId = "", membershipId = "", programId = "";
		
		if (settingsController.memberCardsData.Cards.length == undefined) {
			cardId = settingsController.memberCardsData.Cards.cardId;
			membershipId = settingsController.memberCardsData.Cards.membershipId;
			programId = settingsController.memberCardsData.Cards.programId;
		} else {
			cardId = settingsController.memberCardsData.Cards[cardCredentialIndex].cardId;
			membershipId = settingsController.memberCardsData.Cards[cardCredentialIndex].membershipId;
			programId = settingsController.memberCardsData.Cards[cardCredentialIndex].programId;
		}
		this.data.cardId = cardId;
		this.data.membershipId = membershipId;
		this.data.programId = programId;
		/*
		this.data = {
				cardId : cardId,
				membershipId : membershipId
		};*/
		
		util.createBusyDialog( oBundle.getText("Loading"), "");
		SmartphoneService.showMemberFrontCard(settingsController.data, settingsController.showMemberFrontCardBack, null, null, true);
		//proxy_login.ShowMemberFrontCard(settingsController.showMemberFrontCardBack, this.data);
		
	},
	
	displayCompletedItems : function(){
		if (completedItemsController == null)
			completedItemsController = sap.ui.controller("app.ui.settings.completedItemsSettings");
		completedItemsController.launchCompletedItems();
	},
	
	showMemberFrontCardBack : function(response, status) {
		if (status != 200) {
			checkErrorStatus(status);
			return;
		}

		else if (isRESTStatusCodeCorrect(response)) {
			//var cardDataFromResponse = util.processResponse(response, "ShowMemberFrontCardResponse");
			
			this.cardFront = response.Card;
			
			SmartphoneService.showMemberRearCard(settingsController.data, settingsController.showMemberRearCardBack, null, null, true);

		} 

	},
	
	showMemberRearCardBack : function(response, status){
		if (status != 200) {
			checkErrorStatus(status);
			return;
		}
		//else if (isRESTStatusCodeCorrect(response)) {
			if(cardCredentialsController == undefined) cardCredentialsController = sap.ui.controller("app.ui.settings.cardCredentialsController");
			cardCredentialsController.displayCardCredentialsPage(this.cardFront, response.CardRearSideInformation);
		//}
	},
	
	/*
	 * Everytime user will come to settings page, we will set the preferencesData to null. When he will tap on basic/card/household
	 * preferences we will make a service call and store the response in preferencesData. Until the user goes back and come again to
	 * settings page we will not make the service call again and show the preferences page with the response stored in preferencesData.
	 */
	preferencesData: null,
	tapPreferences: function(ev){
		var source = ev.getSource();
		var rowData = source.getBindingContext().getProperty(source.getBindingContext().getPath());
		settingsController.displayPreferences(rowData.category);
	},
	
	displayPreferences: function(category, programId){
		
		var callback = function(response, status){
			//console.log("response\n" + JSON.stringify(response));
			
			if ( isRESTStatusCodeCorrect(response) ){
				if (preferencesController == undefined)
					preferencesController = sap.ui.controller("app.ui.preferences.preferences");
				
				settingsController.preferencesData = response;
				preferencesController.launchPreferencesPage(category, response, programId);
			}else{
				util.closeBusyDialog();
		    	logError("error_message_general", "Error in the response of getAllPreferences", "login");
			}
			
		}
		
		if(settingsController.preferencesData == null){
			util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
			SmartphoneService.getAllPreferences({}, callback);
		}
		else
			callback(settingsController.preferencesData, 0);
	},
	
	displayHousehold: function(){
	
	   if(householdController == undefined)
			householdController = sap.ui.controller("app.ui.household.household");
	   	householdController.programId = subscribedPrograms[0].programId;
	   	householdController.programName = subscribedPrograms[0].programName;
	   	householdController.launchHouseholdPage(SETTINGS_PAGE);
		
	},
	
	//Financial Accounts : Payment Card Details
	paymentCardTap : function(ev){
		if(paymentCardDetailsController == undefined){
			paymentCardDetailsController = sap.ui.controller("app.ui.financialAccounts.paymentCardDetailsController");
		}
		var source = ev.getSource();
		var selectedCardDetails = source.getBindingContext().getProperty(source.getBindingContext().getPath());
		if(selectedCardDetails.creditCard != null){
			
			paymentCardDetailsController.paymentCardDetailsData.cardDetails = selectedCardDetails;
		}
		//console.log(selectedCardDetails.alias);
		paymentCardDetailsController.cardTypeSelected(selectedCardDetails);
	},
	
	displayAboutPage: function(){
		if(aboutController == undefined){
			aboutController = sap.ui.controller("app.ui.settings.aboutController");
		}
		aboutController.launchAboutPage();
	}
	
});


