//2013 SAP AG. All rights reserved.
//Author : SAP.

// LOAD PAGE
var setCredModelBack = function (response, status){
    if (status != 200) {
	    checkErrorStatus(status);
	    return;
    }
    
    if( isRESTStatusCodeCorrect(response) && response.address != undefined && response.address != null) {
        app.getPage(CREDENTIAL_SETTINGS_PAGE).getContent()[0].byId("settings_input_current_password").removeStyleClass("no_bottom_rounded");
        
        var dataBack = {};
        dataBack['address'] = response.address;
         
        var dataCredential ={
            id : dataBack.address.id,
            //First Name
            firstNameValue : dataBack.address.firstName,
            firstNamePlaceholder : oBundle.getText("My_First_Name"),
            firstNameType : "Text",
            firstNameEnabled : false,
            firstNameVisible : true,
            firstNameID : "input_FirstName",
            //Last Name
            lastNameValue : dataBack.address.lastName,
            lastNamePlaceholder : oBundle.getText("My_Last_Name"),
            lastNameType : "Text",
            lastNameEnabled : false,
            lastNameVisible : true,
            lastNameID : "input_LastName",
            //Phone Number
            phoneValue : userCredentialSettingsController.phoneNum,
            phonePlaceholder : oBundle.getText("My_Phone_Number"),
            phoneType : "Tel",
            phoneEnabled : false,
            phoneVisible : true,
            phoneID : "input_PhoneNumber",
            //Email
            emailValue : dataBack.address.email,
            emailPlaceholder : oBundle.getText("My_Email"),
            emailType : "Email",
            emailEnabled : false,
            emailVisible : true,
            emailID : "input_Email",
            //Current Password
            currPassValue : "",
            currPassPlaceholder :oBundle.getText("current_Password"),
            currPassEnabled : false,
            currPassVisible : true,
            currPassID : "input_current_password",
            //New Password
            newPassValue : "",
            newPassPlaceholder : oBundle.getText("New_Password"),
            newPassEnabled : false,
            newPassVisible : false,
            newPassID : "input_new_password",
            //Verify Password
            verPassValue : "",
            verPassPlaceholder : oBundle.getText("Verify_Password"),
            verPassEnabled : false,
            verPassVisible : false,
            verPassID : "input_verify_password",
            //passcode       
            passcode: [{
                value : "",
                placeholder : oBundle.getText("Enter_Current_App_Passcode"),
                enabled: false, visible : true, id : "my_Passcode",
				maxLength : 25
            },{
                value : "",
                placeholder : oBundle.getText("set_passcode"),
                enabled: false, visible : true, id : "input_Passcode",
				maxLength : 25
            },{
                value : "",
                placeholder : oBundle.getText("confirm_passcode"),
                enabled: false, visible : true, id : "confirm_input_Passcode",
				maxLength : 25
            }],
			passcodeLabelvisible : true
        };
        
		
		if (!userState['WALLET_PASSCODE_ENABLED']){
			dataCredential.passcode[0].visible = false;
			dataCredential.passcodeLabelvisible = false;
		}
        userCredentialSettingsModel = new sap.ui.model.json.JSONModel();
        userCredentialSettingsModel.setData(dataCredential);
        app.getPage(CREDENTIAL_SETTINGS_PAGE).getContent()[0].setModel(userCredentialSettingsModel);

        app.getPage(CREDENTIAL_SETTINGS_PAGE).setCustomHeader(userCredentialSettingsController.headerEdit);
        
        SmartphoneService.getIdentifications(loginResponseModel.customer.id, getPhoneNumBack);	
        
    }
    else{
    	//could not query data for card in list
    	util.closeBusyDialog();
    	logError("error_message_load_User_Credential", "Could not load user data, check resposne Status Code", "setCredModelBack");
    }
}

var getPhoneNumBack = function(response, status){
	if (status != 200) {
	    checkErrorStatus(status);
	    return;
    }
    if( isRESTStatusCodeCorrect(response) ) {
		var tempData = app.getPage(CREDENTIAL_SETTINGS_PAGE).getContent()[0].getModel().getData();
		tempData.phoneValue = response.identifications[0].identification;
		userCredentialSettingsController.phoneNum = response.identifications[0].identification;
        userCredentialSettingsModel.setData(tempData);
		app.getPage(CREDENTIAL_SETTINGS_PAGE).getContent()[0].setModel(userCredentialSettingsModel);
		util.closeBusyDialog();
		
		//On Successful response open the page
		if(app.getCurrentPage().getId() != CREDENTIAL_SETTINGS_PAGE)
			app.to(CREDENTIAL_SETTINGS_PAGE);
	}
	else{
		//address fail to update
		checkErrorMobiliserStatus(response);
    }
}

//UPDATE DATA
var updateAddressBack = function( response, status){
    if (status != 200) {
	    checkErrorStatus(status);
	    return;
    }
    if( isRESTStatusCodeCorrect(response) ) {
		//update password
        if (userCredentialSettingsController.updatePassword){
            
			SmartphoneService.changeCredential(userCredentialSettingsModel, resetPasswordBack);
        }
	    //no need update password
        else{
			//log info password update skipped
			logPerfInfo("info_message_pw_update_skipped", "Password Update skipped because left blank", "PasswordUpdate");
            //check update passcode
			if (userCredentialSettingsController.updatePasscode ){
				
				/*var member = {
					walletPin: userCredentialSettingsModel.oData.passcode[0].value	
				};*/
				var member = {
						identification : loginResponseModel.customer.id,
						identificationType : 1,
						oldCredential: userCredentialSettingsModel.oData.passcode[0].value, 
						newCredential : userCredentialSettingsModel.oData.passcode[1].value,
						credentialType : 0
				}
				//SmartphoneService.updateLoyaltyMember(member, updatePasscodeBack);
				SmartphoneService.ChangeLoyaltyWalletCredential(member, updatePasscodeBack);
			}
			//no need update passcode
			//reset values
			else{
				//log info passcode update skipped
				logPerfInfo("info_message_passcode_update_skipped", "Passcode Update skipped because left blank", "PasscodeUpdate");
				userCredentialSettingsController.resetModel();
			}
        }
    }
    else{
	//address fail to update
    util.closeBusyDialog();
	logError("error_message_address_update_fail", "Personal Data update failed, check response Status Code", "updateAddressBack");
	//userCredentialSettingsController.resetModel();
    }
}

//UPDATE PASSWORD
var resetPasswordBack = function(response, status){
	userCredentialSettingsController.updatePassword = false;
    if (status != 200) {
	    checkErrorStatus(status);
	    return;
    }
    if(isRESTStatusCodeCorrect(response)) {
		//password change successs
		//call change passcode
		if (userCredentialSettingsController.updatePasscode ){
			
			var member = {
					identification : loginResponseModel.customer.id,
					identificationType : 1,
					oldCredential: userCredentialSettingsModel.oData.passcode[0].value, 
					newCredential : userCredentialSettingsModel.oData.passcode[1].value,
					credentialType : 0
			}
			//SmartphoneService.updateLoyaltyMember(member, updatePasscodeBack);
			SmartphoneService.ChangeLoyaltyWalletCredential(member, updatePasscodeBack);
		}
		else{
			//log info passcode update skipped
			logPerfInfo("info_message_passcode_update_skipped", "Passcode Update skipped because left blank", "PasscodeUpdate");
			userCredentialSettingsController.resetModel();
		}
    }
    else{
		//password update failed
		if (response.Status.code == 329){
			util.closeBusyDialog();
			logError( oBundle.getText("error_message_update_password_current"), "Incorrect Current Password", "Password Update" );
		}
		else{
			checkErrorMobiliserStatus(response);
			//userCredentialSettingsController.resetModel();
		}
    }
}

//UPDATE PASSCODE
var updatePasscodeBack = function (response, status){
	userCredentialSettingsController.updatePasscode = false;
    if (status != 200) {
	    checkErrorStatus(status);
	    return;
    }
    if(isRESTStatusCodeCorrect(response)){
		userCredentialSettingsController.resetModel();
    }
    else{
		//passcode fail to update
    	util.closeBusyDialog();
    	var errorMsg = "";
    	if(response.Status.code == 334)
    		logError("passcode_retention", "Passcode update failed, retention", "updateAddressBack");
    	else
    		logError("error_message_passcode_update_fail", "Passcode update failed, check response Status Code", "updateAddressBack");
		
		//userCredentialSettingsController.resetModel();
    }
}



sap.ui.controller('app.ui.settings.userCredentialSettings', {
    
    settingsPageMode : "edit",
    updatePassword : false,
    updatePasscode : false,
	successfulUpdate : false,
	phoneNum : null,
	headerEdit : null,
    
	onAfterRendering: function(){
	    
	},
	
    launchUserCredentialPage : function(){
        if(app.getPage(CREDENTIAL_SETTINGS_PAGE) == null ) {
			var dataCredential ={
			mode : oBundle.getText("edit")
	    }
		
			userCredentialSettingsController.headerEdit = new sap.m.Bar('CredentialSettingBarEdit', {
				contentLeft : [new sap.m.Button({
				text : oBundle.getText("Back_Button"),
				type : sap.m.ButtonType.Back,
				tap : function() {
							app.back();
					}
				})],
			contentMiddle : [new sap.m.Label("settingsCredentialsTitle", {text: oBundle.getText("loginCredential") }) ],
			contentRight : [new sap.m.Button('loginCredentialEditButton', { text: oBundle.getText("edit"),                                    
				tap : function() {
					if(userState['DEMO_MODE'] == true) {
						logError("demo_mode_message", "In Demo Mode", "Not Supported In Demo Mode");
						return;
					}
					
					app.getPage(CREDENTIAL_SETTINGS_PAGE).setCustomHeader(headerDone);
					userCredentialSettingsController.edit();
				}
			})]
		});
	    
	    var headerDone= new sap.m.Bar('CredentialSettingBarDone', {
					contentLeft : [new sap.m.Button({
					text : oBundle.getText("Back_Button"),
					type : sap.m.ButtonType.Back,
					tap : function() {
								app.getPage(CREDENTIAL_SETTINGS_PAGE).setCustomHeader(userCredentialSettingsController.headerEdit);
								app.back();
						}
					})],
                contentMiddle : [new sap.m.Label("settingsCredentialsTitle2", {text: oBundle.getText("loginCredential") }) ],
                contentRight : [new sap.m.Button('loginCredentialDoneButton', { text: oBundle.getText("done"),                                    
                    tap : function() {
						userCredentialSettingsController.done();
                    }
                })]
            });
	    

            var settingsView = sap.ui.view({
                    type : sap.ui.core.mvc.ViewType.XML,
                    viewName : "app.ui.settings.userCredentialSettings",
                    controller : this
            });

            var settingsPage = new sap.m.Page(CREDENTIAL_SETTINGS_PAGE, {
                    customHeader : userCredentialSettingsController.headerEdit,
                    //title : oBundle.getText("settings"),
                    content : [ settingsView ],
                    showNavButton : false
            });

            settingsView.setModel(userCredentialSettingsModel);
            app.addPage(settingsPage);
        }
		
        app.getPage(CREDENTIAL_SETTINGS_PAGE).setCustomHeader(userCredentialSettingsController.headerEdit);
        util.createBusyDialog(oBundle.getText("Loading"), oBundle.getText("Loading"));
        userCredentialSettingsController.resetModel();
        
        app.getPage(CREDENTIAL_SETTINGS_PAGE).getContent();
        
    },
    
    edit : function(){
        var dataModel = app.getPage(CREDENTIAL_SETTINGS_PAGE).getContent()[0].getModel().getData();
		this.settingsPageMode = "done";
		//make visible and editable
		dataModel.newPassVisible = true;
		dataModel.verPassVisible = true;
		dataModel.firstNameEnabled = true; dataModel.lastNameEnabled = true; dataModel.phoneEnabled = false; dataModel.emailEnabled = false;
		dataModel.currPassEnabled = true; dataModel.newPassEnabled = true; dataModel.verPassEnabled = true;
		dataModel.passcode[0].enabled = true;
		dataModel.passcode[1].enabled = true;
		dataModel.passcode[2].enabled = true;
	  //dataModel.passcode[0].enabled = true;
		//reset model
		userCredentialSettingsModel = new sap.ui.model.json.JSONModel();
		userCredentialSettingsModel.setData(dataModel);
    
		app.getPage(CREDENTIAL_SETTINGS_PAGE).getContent()[0].setModel(userCredentialSettingsModel);
    app.getPage(CREDENTIAL_SETTINGS_PAGE).getContent()[0].byId("settings_input_current_password").addStyleClass("no_bottom_rounded");
    },
    
    done : function(){
		this.updateData();
    },
    
    updateData : function(){
        var tempView = app.getPage(CREDENTIAL_SETTINGS_PAGE).getContent()[0].getModel().getData();
		var errorLabel = app.getPage(CREDENTIAL_SETTINGS_PAGE).getContent()[0].byId("reset_error_error_label");
        
		var currpassword = tempView.currPassValue;
        var newpassword = tempView.newPassValue;
        var verifynewpassword =  tempView.verPassValue;
        var passcode = tempView.passcode[0].value;
        var newPasscode = tempView.passcode[1].value;
        var confirmPasscode = tempView.passcode[2].value;
		
		if (currpassword.trim().length !=0){
			if ( newpassword.trim().length == 0 || verifynewpassword.trim().length == 0 ){
				logError( oBundle.getText("error_message_password_length"), "credentials too short", "" );
				util.closeBusyDialog();
				return;
			}
			//if entered password
			else if ( newpassword.trim().length != 0 || verifynewpassword.trim().length != 0){
				if ( newpassword.trim().length < 8 || verifynewpassword.trim().length > 23 ){
					logError( oBundle.getText("error_message_password_length"), "credentials too short", "" );
					util.closeBusyDialog();
					return;
				}
				else if ( newpassword.trim() != verifynewpassword.trim() ){
					logError( oBundle.getText("error_message__password"), "passwords do not match", "" );
					util.closeBusyDialog();
					return;
				}
				this.updatePassword = true;
			}
		}
		else if ( currpassword.trim().length ==0 ){
			if ( newpassword.trim().length != 0 || verifynewpassword.trim().length != 0 ){
				logError( oBundle.getText("error_message_enter_current_password"), "enter current password", "" );
				util.closeBusyDialog();
				return;
			}
		}
		
       //entered passcode
		this.updatePasscode = false;
		if (passcode.trim().length != 0){
			if( isNaN(passcode) ){
				logError("error_message_passcode_not_numeric", "passcode must be numeric", "passcode must be numeric");
				util.closeBusyDialog();
				return;
			}
			if( isNaN(newPasscode) ){
				logError("error_message_passcode_not_numeric", "passcode must be numeric", "passcode must be numeric");
				util.closeBusyDialog();
				return;
			}
			if( isNaN(confirmPasscode) ){
				logError("error_message_passcode_not_numeric", "passcode must be numeric", "passcode must be numeric");
				util.closeBusyDialog();
				return;
			}
			if(newPasscode != confirmPasscode){
				logError("error_message_Passcode_not_match", "passcode does not match", "passcode does not match");
				util.closeBusyDialog();
				return;
			}
            this.updatePasscode = true;
      }
		
		if(userCredentialSettingsModel.oData.firstNameValue != ""){
			if(userCredentialSettingsModel.oData.lastNameValue != ""){

				var addressData = {
					id : userCredentialSettingsModel.oData.id,
					customerId : loginResponseModel.customer.id,
					addressType : "0",
					addressStatus : "0",
					firstName : userCredentialSettingsModel.oData.firstNameValue,
					lastName : userCredentialSettingsModel.oData.lastNameValue,
					email : userCredentialSettingsModel.oData.emailValue
				};
				//create busy dialog
				util.createBusyDialog( oBundle.getText("Updating_data"), "" );
				SmartphoneService.updateAddress(addressData, updateAddressBack);
			}else{
				var dialog = new sap.m.Dialog({
					title : "Message",
					content : [new sap.m.Text({
						text : "Please enter the Last Name"
					})],
					rightButton : new sap.m.Button({
						text : "Ok",
						width : "100%",
						tap :function(){
								//close the dialog
								dialog.close();
						}
					})
				});
				dialog.open();
			}
		}else{
			var dialog = new sap.m.Dialog({
				title : "Message",
				content : [new sap.m.Text({
					text : "Please enter the First Name"
				})],
				rightButton : new sap.m.Button({
					text : "Ok",
					width : "100%",
					tap :function(){
							//close the dialog
							dialog.close();
					}
				})
			});
			dialog.open();
		}
    },
    
    resetModel : function( signout ){
		this.settingsPageMode = "edit";
		SmartphoneService.getAddressByCustomer(userCredentialSettingsModel, setCredModelBack);
    },
		
	SignOut : function(){
		if(homeController && homeController.modelData)
			homeController.modelData.offersRefreshNeeded = 0;
		if (sliderMenuController.sliderMenuControl.visibleState)
			sliderMenuController.sliderMenuControl.close();
		if ( !userState['DEMO_MODE'] && this.settingsPageMode === "done"){
			util.customDialogWithButton( oBundle.getText("message_your_changes_not_be_saved") );
		}
		else{
			this.SignOutAfterCheck();
		}
	},
		
	SignOutAfterCheck : function(){
		util.createBusyDialog( oBundle.getText("Signing_Out"), "" );
		
		this.settingsPageMode = "edit";
		
		if(userState['DEMO_MODE'] == true) {
				userState['DEMO_MODE'] = false;
				userCredentialSettingsController.clearupAfterSignOut();
			}
		else
			SmartphoneService.logout("", userCredentialSettingsController.SignOutBack, null, null, true);
	},
	
	SignOutBack : function(response, status){
		if (status != 200) {
			checkErrorStatus(status);
			return;
		}
		else if (isRESTStatusCodeCorrect(response)) {
			userCredentialSettingsController.clearupAfterSignOut();
		} 
	},
	
	clearupAfterSignOut: function(){
		
		//window.location.reload(true);
		userState.LOGGED_IN = false;
		userState.BRANDTYPE = "";
		userState.PASSCODE_LENGTH = 4;
		userState.SESSION_TIMEOUT = 0;
		userState.EXPIRATION = 0;
		userState.PASSCODE_TIMEOUT = 0;
		userState.PASSCODE_EXP = 0;
		userState.PASSCODE_FIRST = true;
		userState.HOUSEHOLDING_ENABLED = false;
		
		//Remove the current active menu item background.
		try{
			sliderMenuController.currentActiveItem.getDomRef().style.background = "";
		}catch(e){
			
		}
		// For reset the Slider menu active item and carousel bottom navigation
		sliderMenuController.removeAllSelections();
		sliderMenuController.currentActiveItemOldIcon = "";
		if(allOffersController != undefined) {
			//allOffersController = sap.ui.controller('app.ui.offers.allOffersController');
			if(allOffersController.carouselControl)
				allOffersController.resetCarousel();
			allOffersController.offersRefreshTime = 0;
		}
			
		util.closeBusyDialog();
		
		var loginView = app.getPage(ID_LOGIN_PAGE).getContent()[0];
		//loginView.byId("input_username").setValue("");
		loginView.byId("input_password").setValue("");
		if(userState.DEMO_MODE)
			sliderMenuController.getShoppingListPref();
		//homeController.restHeaderBar();
		//app.to(ANONYMOUS_HOME_PAGE);
		if(homeController.modelData.homeDemoConnectedToServer == false){
			
				if(connectionSettingsController == undefined)
					connectionSettingsController = sap.ui.controller('app.ui.home.connectionSettings');
				connectionSettingsController.launchConnectionSettingPage();
			
		}
		else{
			if (homeController == undefined) {
				homeController = sap.ui.controller("app.ui.home.homeController");
			}
			homeController.modelData.callAppConfig = true;
			homeController.launchAnonymousHomePage();
		}
	}
    
});
