sap.ui.controller('app.ui.shoppingHistory.individualShoppingHistoryController', {
    shoppingHistory : {
        recieptDetails : [],
        listData:[],
    },
    transactionIdForReceipt : "",
    launchIndividShoppingHistory : function(details){
        if(app.getPage(INDIVIDUAL_SHOPPING_HISTORY_PAGE)==null){
            var shoppingHistoryView = sap.ui.view({
              type : sap.ui.core.mvc.ViewType.XML,
              viewName : "app.ui.shoppingHistory.individualShoppingHistory",
              controller : individualShoppingHistoryController
            });
            
            var header = new sap.m.Bar({
                contentMiddle : [new sap.m.Label({
                    //TO DO: translation
                    text : details.header,
                })],
                contentLeft : [new sap.m.Button({
                    text : oBundle.getText("Back_Button"),
                    type : sap.m.ButtonType.Back,
                    tap : function(){
                        app.back();
                    }
                })],
                contentRight : [new sap.m.Button({
                	text : oBundle.getText("view_receipt"),
                	tap : function(){
                		if(viewReceiptController == undefined)
                			viewReceiptController = sap.ui.controller('app.ui.myLists.viewReceiptController');
                		viewReceiptController.launchViewReceiptController(true);
                	}
                })]
            });
            
            var shoppingHistoryPage = new sap.m.Page(INDIVIDUAL_SHOPPING_HISTORY_PAGE,{
                customHeader : header,
                content : [shoppingHistoryView],
            });
			
            var shoppingHistoryModel = new sap.ui.model.json.JSONModel();
            shoppingHistoryView.setModel(shoppingHistoryModel);
            app.addPage(shoppingHistoryPage);
        }
        
        
        individualShoppingHistoryController.shoppingHistory.recieptDetails = [];
        individualShoppingHistoryController.shoppingHistory.recieptDetails.push( details );
        var body ={
        		basketId : details.basketId
        }
        individualShoppingHistoryController.transactionIdForReceipt = details.transactionId;
        var showRightContent = app.getPage(INDIVIDUAL_SHOPPING_HISTORY_PAGE).getCustomHeader().getContentRight()[0];
        //app.getPage(INDIVIDUAL_SHOPPING_HISTORY_PAGE).setCustomHeader(custheader);
        if(individualShoppingHistoryController.transactionIdForReceipt)
        	showRightContent.setVisible(true);
        else
        	showRightContent.setVisible(false);
        util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
        SmartphoneService.getShoppingBasketItemsForBasket(body,individualShoppingHistoryController.getBasketItemDetailsBack);
    },
    getBasketItemDetailsBack : function(response,status){
    	
    	individualShoppingHistoryController.shoppingHistory.listData = [];
    	if(isRESTStatusCodeCorrect(response)){
    		var basketItem = response.shoppingBasketItem;
    		for(var i=0;i<basketItem.length;i++){
    			var adjTotal;
    			if (basketItem[i].price && basketItem[i].unitOfMeasurement) {
					if (basketItem[i].unitOfMeasurement.length == 1) {
						adjTotal = basketItem[i].unitOfMeasurement + numberFormatInstance.format(parseFloat(parseInt(basketItem[i].price)/100).toFixed(2));
					}
					else if (basketItem[i].unitOfMeasurement.length != 1) { //if currency is euro
						adjTotal = numberFormatInstance.format(parseFloat(parseInt(basketItem[i].price)/100).toFixed(2)) + basketItem[i].unitOfMeasurement;
					}
				}
    			var newBasket = {
    					title : basketItem[i].shortDescription,
    					longdescription : basketItem[i].largeDescription,
    					articleId : basketItem[i].articleId,
    					freeText : adjTotal,
    					imageUrl : basketItem[i].imageUrl,
    					quantity : basketItem[i].quantity,
    					adjPrice : adjTotal,
    			}
    			individualShoppingHistoryController.shoppingHistory.listData.push(newBasket);
    		}
    	}
    	else{
    		//console.log("Error while fetching the basket items");
    	}
        app.getPage(INDIVIDUAL_SHOPPING_HISTORY_PAGE).getContent()[0].getModel().setData(individualShoppingHistoryController.shoppingHistory);
        app.to(INDIVIDUAL_SHOPPING_HISTORY_PAGE);
        util.closeBusyDialog();
    },
    
    goToRecieptDetails : function(ev){
        if(checkInItemDetailsController == undefined){
            checkInItemDetailsController = sap.ui.controller("app.ui.myLists.CheckInItemDetailController");
        }
        var selected = ev.getSource();
        var con = selected.getBindingContext().getProperty(selected.getBindingContext().getPath());
        
        
        //checkInShoppingController.listItemSelected.itemInCart = demoData;
        checkInItemDetailsController.launchItemDetailFromIndividualShoppingHistory(con);
        
    }
    
});