sap.ui.controller('app.ui.shoppingHistory.shoppingHistoryController', {
	shoppingHistory : {
		historyList : []
	},
	storeId : "",
	responseObject : null,
	totalIndex : 0,
	tempIndex : 0,

	launchShoppingHistory : function(){

		if(app.getPage(SHOPPING_HISTORY_PAGE)==null){
			var shoppingHistoryView = sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.shoppingHistory.shoppingHistory",
				controller : shoppingHistoryController
			});

			var header = new sap.m.Bar({
				contentMiddle : [new sap.m.Label({
					//TO DO: translation
					text : oBundle.getText("shopping_history"),
				})],
				contentLeft : [new sap.m.Button({
					icon: "sap-icon://menu2",
					activeIcon: "sap-icon://menu2",
					tap : function(event, src) {
						sliderMenuController.action('shoppingHistoryMenuButton');
					}
				}).addStyleClass("menuButtonIconFont")],
			});

			var shoppingHistoryPage = new sap.m.Page(SHOPPING_HISTORY_PAGE,{
				customHeader : header,
				content : [shoppingHistoryView],
			});

			var shoppingHistoryModel = new sap.ui.model.json.JSONModel();
			shoppingHistoryView.setModel(shoppingHistoryModel);
			app.addPage(shoppingHistoryPage);
		}
		shoppingHistoryController.totalIndex = 0;
		shoppingHistoryController.tempIndex = 0;
        shoppingHistoryController.responseObject = null;
		util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading"));
		SmartphoneService.getShoppingHistoryBasket("",shoppingHistoryController.getShoppingHistoryBack);
	},

	getShoppingHistoryBack : function(response, status){
		shoppingHistoryController.shoppingHistory.historyList = [];
		if(isRESTStatusCodeCorrect(response)){

			shoppingHistoryController.responseObject = response.shoppingHistoryBasket;
			if(shoppingHistoryController.responseObject){
				shoppingHistoryController.totalIndex = shoppingHistoryController.responseObject.length;
				var basket = shoppingHistoryController.responseObject;
				if(basket && basket.length > 0){
					for(var i = 0; i<basket.length;i++){
						var dateTime = new Date(parseInt(basket[i].timestamp));
						shoppingHistoryController.convertDateToFormat(i,dateTime);
					}
				}
				else{
					shoppingHistoryController.renderTheView();
				}
			}
			else
				shoppingHistoryController.renderTheView();
		}
		else{
			checkErrorMobiliserStatus(response);
			util.closeBusyDialog();
		}
	},


	convertDateToFormat : function (index, dateTime) {
		navigator.globalization.dateToString(
				dateTime,
				function (date) {
					shoppingHistoryController.responseObject[index].timestamp = date.value;
					shoppingHistoryController.tempIndex = shoppingHistoryController.tempIndex + 1;
					if(shoppingHistoryController.tempIndex == shoppingHistoryController.totalIndex) {
						shoppingHistoryController.renderTheView();
					}
				},
				function () {
					shoppingHistoryController.tempIndex = shoppingHistoryController.tempIndex + 1;
					
				},
				{formatLength:'short', selector:'date and time'}
		);


	},

	renderTheView : function() {
		var basket = shoppingHistoryController.responseObject;
		if(basket){
			for(var i = 0; i<basket.length;i++){

				var historyBas = {
						basketId : basket[i].basketId,
						header : basket[i].storeName,
						date : basket[i].timestamp,
						total : basket[i].totalAmount,
						time : "",
						numItems : basket[i].numberOfItems,
						currency : basket[i].currency,
						transactionId : basket[i].txnId
				};

				if(basket[i].totalAmount != null){
					historyBas.total = basket[i].totalAmount;
					if(basket[i].currency == null)
						historyBas.cost = parseFloat(historyBas.total/100).toFixed(2);
					else if(basket[i].currency.length == 1)
						historyBas.cost = historyBas.currency +" "+ parseFloat(historyBas.total/100).toFixed(2);
					else
						historyBas.cost = parseFloat(historyBas.total/100).toFixed(2) +" "+ historyBas.currency;
				}
				if(historyBas.transactionId)
					shoppingHistoryController.shoppingHistory.historyList.push(historyBas);

			}
		}
		else{
			
		}
		app.getPage(SHOPPING_HISTORY_PAGE).getContent()[0].getModel().setData(shoppingHistoryController.shoppingHistory);
		app.to(SHOPPING_HISTORY_PAGE);
		util.closeBusyDialog();

	},


	goToRecieptHistory : function(ev){
		var source = ev.getSource();
		var item = source.getBindingContext().getProperty(source.getBindingContext().getPath());
		if (individualShoppingHistoryController == undefined) {
			individualShoppingHistoryController = sap.ui.controller("app.ui.shoppingHistory.individualShoppingHistoryController");
		}
		individualShoppingHistoryController.launchIndividShoppingHistory(item);
	},
});