var addingItemHeader;
var header;
var addingItem;
var EditingItem;
var deleteItems;
var detailsController;
var shoppingListId;

sap.ui.controller("app.ui.shoppinglist.checkeditems", {//shoppingListCheckedItemsController
	onInit : function() {
	},

	listData : {
		list : []
	},
	onAfterRendering: function(){
		if (app.getPage(SHOPPING_LIST_CHECKEDITEMS_PAGE)!=null){
				var viewRef = app.getPage(SHOPPING_LIST_CHECKEDITEMS_PAGE).getContent()[0];
				var viewId = viewRef.getId();
				$('#' + viewId).css("min-height", "100%");
				$('#' + viewId).css("background-color" , "#FCFCFC");
		}
	},
	launchPage : function() {
		if (app.getPage(SHOPPING_LIST_CHECKEDITEMS_PAGE) == null) {
			//view
			var view = sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.shoppinglist.checkeditems",
				id : "checkeditems",
				controller : this,
				afterRendering: function(e){
					shoppingListCheckedItemsController.updateCheckBox();
				}
			});
			this.list = view.byId("list");

			this.oModel = new sap.ui.model.json.JSONModel();

			view.setModel(this.oModel);

			header = new sap.m.Bar({
				contentMiddle : [new sap.m.Label({
					text : oBundle.getText("Completed_Items")
				})],
				contentLeft : [new sap.m.Button({
					text : oBundle.getText("Back_Button"),
					type : sap.m.ButtonType.Back,
					tap : function() {
						shoppingListController.updateListData();
						app.back();
					}
				})],
			});
			
			// var footer = new sap.m.Bar({
				// contentMiddle : [new sap.m.Button({
					// tap : this.deleteCheckedItems,
					// text : oBundle.getText("Delete_Checked_Items"),
					// type : sap.m.ButtonType.Transparent,
					// layoutData:new sap.m.FlexItemData({growFactor: 1})
				// })]
			// });

			var page1 = new sap.m.Page(SHOPPING_LIST_CHECKEDITEMS_PAGE, {
				customHeader : header,
				content : [view],
				footer : null//footer
			});

			app.addPage(page1);
		}
		if (shoppingListCheckedItemsController.listData.length != 0) {
			shoppingListCheckedItemsController.oModel.setData(shoppingListCheckedItemsController.listData);
		}
		app.getPage(SHOPPING_LIST_CHECKEDITEMS_PAGE).getContent()[0].rerender();
		app.to(SHOPPING_LIST_CHECKEDITEMS_PAGE);
	},

	/*** User Interaction Functions ***/

	selectListItem : function(oControlEvent) {
		if (detailsController == undefined) {
			detailsController = sap.ui.controller("app.ui.shoppinglist.listItemDetails");
		}
		var selectedItem = oControlEvent.getSource();
		var index = this.list.indexOfItem(selectedItem);
		var item = shoppingListCheckedItemsController.oModel.getData().list[index];

		detailsController.launchDetailsPage("edit", item);
	},

	checkItem : function(oControlEvent) {
		var item = oControlEvent.getParameters().listItem;
		var data = item.getBindingContext().getObject();
		data.isChecked = item.isSelected();
		SmartphoneService.updateListItem(data, CheckItemBack);
	},

	deleteCheckedItems : function() {
        if(userState['DEMO_MODE'] == true) {
                logError("demo_mode_message", "In Demo Mode", "Not Supported In Demo Mode");
                return;
        }
		var selectedItems = shoppingListCheckedItemsController.list.getSelectedItems();
		deleteItems = [];
		for (index in selectedItems) {
			var item = selectedItems[index];
			var id = item.getBindingContext().getObject()["id"];
			deleteItems.push(id);
		}
		if (deleteItems.length < 1) {
			return;
		}
		SmartphoneService.deleteListItem(deleteItems, DeleteCheckedItemBack);
	},

	/*** User Interaction Functions END ***/

	updateItem : function(item) {

		var oData = shoppingListCheckedItemsController.oModel.getData();
		var id = item.id;

		for (key in oData.list) {
			if (id == oData.list[key].id) {
				oData.list[key] = item;
			}
		}
		shoppingListCheckedItemsController.oModel.setData(oData, false);
		//false means replace
		shoppingListCheckedItemsController.updateCheckBox();
	},

	deleteItems : function(deleteItems) {
		var oData = shoppingListCheckedItemsController.oModel.getData();
		var num = oData.list.length;
		var delCount = 0;
		for (var i = 0; i < num; i++) {
			var id = oData.list[i - delCount].id;
			var dIndex = deleteItems.indexOf(id);
			if (dIndex != -1) {
				oData.list.splice(i - delCount, 1);
				//splice will async change the array, so need delCount for adjusting the index
				delCount++;
			}
		}
		shoppingListCheckedItemsController.oModel.setData(oData, false);
	},

	updateCheckBox : function() {
		//sap.ui.getCore().applyChanges();
		var data = shoppingListCheckedItemsController.oModel.getData().list;
		var items = this.list.getItems();
		for (var i = 0; i < data.length; i++) {
			var item = items[i];
			item.setSelected(data[i].isChecked)
		}
	}
});

DeleteCheckedItemBack = function(response, status) {

	if (status != 200) {
		checkErrorStatus(status);
		return;
	}

	var data = [];

	if (!isRESTStatusCodeCorrect(response)) {

		checkErrorMobiliserStatus(response);
		return;
	}

	shoppingListCheckedItemsController.deleteItems(deleteItems);
};

CheckItemBack = function(response, status) {
	if (status != 200) {
		checkErrorStatus(status);
		//TODO after alert, will program continue? there is a lot of potential code need to change if that happens
		return;
	}

	if (!isRESTStatusCodeCorrect(response)) {
		checkErrorMobiliserStatus(response);
	}
	//TODO for check Item, if failed, how to get it back.
};
