sap.ui.controller("app.ui.shoppinglist.listItemDetails", {
	onInit : function() {
	},
	onAfterRendering: function(){
		if (app.getPage(SHOPPING_LIST_DETAILS_PAGE)!=null){
				var viewRef = app.getPage(SHOPPING_LIST_DETAILS_PAGE).getContent()[0];
				var viewId = viewRef.getId();
				$('#' + viewId).css("min-height", "100%");
				$('#' + viewId).css("background-color" , "#FCFCFC");
		}
	},
	launchDetailsPage : function(action, item) {
		var itemData = {
			id : item.id,
			shoppingListId : item.shoppingListId,
			title : item.title,
			description : item.description,
			isFavourite : item.isFavourite,
			isChecked : item.isChecked
		};
		this.inputBackup = item.title;

		this.action = action;
		if (app.getPage(SHOPPING_LIST_DETAILS_PAGE) == null) {
			//view
			this.detailsView = sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.shoppinglist.listItemDetails",
				controller : this
			});

			//Data

			// var itemData = {
			// shoppingListId : item.shoppingListId,
			// title : "",
			// description : "",
			// isFavourite : true,
			// isChecked : true
			// }

			//Model
			this.oModel = new sap.ui.model.json.JSONModel();
			this.oModel.setData(itemData);
			this.detailsView.setModel(this.oModel);

			//Header
			var header = new sap.m.Bar({
				contentRight : [new sap.m.Button({//Done
					text : oBundle.getText("done"),
					tap : this.clickDone
				})],
				contentMiddle : [new sap.m.Label({
					text : oBundle.getText("Details")
				})],
				contentLeft : [new sap.m.Button({//Cancel
					text : oBundle.getText("cancel"),
					tap : function(event, src) {
						app.back();
						app.getPage(SHOPPING_LIST_PAGE).rerender();
					}
				})]
			});

			var page1 = new sap.m.Page(SHOPPING_LIST_DETAILS_PAGE, {
				customHeader : header,
				content : [this.detailsView]
			});
			app.addPage(page1);
		} else {
			this.oModel.setData(itemData);
		}
		if (action == "add") {
			detailsController.detailsView.byId("deleteButton").addStyleClass("shoppinglistHidden");
		} else {
			detailsController.detailsView.byId("deleteButton").removeStyleClass("shoppinglistHidden");
		}

		detailsController.detailsView.byId("input").focus();

		app.to(SHOPPING_LIST_DETAILS_PAGE);
		//TODO how to remove page from stack
	},

	clickDone : function(event, src) {
		if(userState['DEMO_MODE'] == true) {
                logError("demo_mode_message", "In Demo Mode", "Not Supported In Demo Mode");
                return;
        }
		// either update or create
		sap.ui.getCore().applyChanges();
		var input = detailsController.detailsView.byId("input").getValue();
		//console.log(input);
		if (input.length > 127) {
			logError(oBundle.getText("shopping_list_item_length"));
			detailsController.detailsView.byId("input").setValue("");
		} else if (input != "") {
			var data = detailsController.oModel.getData();
			data.description = input;
			if (detailsController.action == "add") {
				SmartphoneService.createListItem(data, CreateListItemBack);
			} else {
				SmartphoneService.updateListItem(data, UpdateListItemBack);
			}
		} else {
			// app.back();
		}
	},

	deleteItem : function() {
		if (userState['DEMO_MODE'] == true) {
			logError("demo_mode_message", "In Demo Mode", "Not Supported In Demo Mode");
			return;
		}
		var deleteItems = [];
		var data = detailsController.oModel.getData();
		deleteItems.push(data.id);
		if (deleteItems.length < 1) {
			return;
		}
		SmartphoneService.deleteListItem(deleteItems, DeleteListItemBack);
	}
});

CreateListItemBack = function(response, status) {

	if (status != 200) {
		checkErrorStatus(status);
		return;
	}

	var data = [];
	var obj = {};

	if (isRESTStatusCodeCorrect(response)) {
		// Confirm that listItemId path is corrent. It can give error otherwise
		obj["id"] = response.listItemId;
		var input = detailsController.detailsView.byId("input").getValue();
		obj["title"] = input;
		obj["description"] = input;
		obj["isFavourite"] = false;
		obj["isChecked"] = false;
		data.push(obj);
		shoppingListController.addItems(data);
		app.back();
		
		shoppingListController.reloadShoppingListItems();

	} else {
		checkErrorMobiliserStatus(response);
		return;
	}
	
};

DeleteListItemBack = function(response, status) {

	if (status != 200) {
		checkErrorStatus(status);
	}

	if (!isRESTStatusCodeCorrect(response)) {
		checkErrorMobiliserStatus(response);
		return;
	}

	var data = [];
	var data = detailsController.oModel.getData();
	var deleteItems = [];
	deleteItems.push(data.id);
	shoppingListController.deleteItems(deleteItems);
	app.back();
};

UpdateListItemBack = function(response, status) {

	if (status != 200) {
		checkErrorStatus(status);
	}

	if (!isRESTStatusCodeCorrect(response)) {
		checkErrorMobiliserStatus(response);
		return;
	}
	
	var data = detailsController.oModel.getData();
	shoppingListController.updateItem(data);
	app.back();
};
