var addingItemHeader;
var header;
var addingItem;
var EditingItem;
var deleteItems;
var detailsController;
var shoppingListId;

sap.ui.controller("app.ui.shoppinglist.shoppingList", {
	//list data for intial binding
	listData : {
		list : [],
		checked : []
	},
	//list element in view
	listElement : null,

	onInit : function() {
		
	},
	onAfterRendering: function(){
		if (app.getPage(SHOPPING_LIST_PAGE)!=null){
				var viewRef = app.getPage(SHOPPING_LIST_PAGE).getContent()[0];
				var viewId = viewRef.getId();
				$('#' + viewId).css("min-height", "100%");
				$('#' + viewId).css("background-color" , "#FCFCFC");
		}
	},
	
	launchShoppingListPage : function() {
		if (app.getPage(SHOPPING_LIST_PAGE) == null) {
			//view
			var shoppingListView = sap.ui.view({
				type : sap.ui.core.mvc.ViewType.XML,
				viewName : "app.ui.shoppinglist.shoppingList",
				id : "shoppingListView",
				controller : this
			});
			this.listElement = shoppingListView.byId("shoppingList");

			this.oModel = new sap.ui.model.json.JSONModel();
			this.oModel.setData(this.listData);
			shoppingListView.setModel(this.oModel);

			if (sliderMenuController == undefined) {
				sliderMenuController = sap.ui.controller("app.ui.slidermenu.sliderMenuController");
				sliderMenuController.createSliderMenu();
			}

			header = new sap.m.Bar({
				contentRight : [new sap.m.Button('addItemButtonShoppingList', {
					tap : function(event, src) {
						if(userState['DEMO_MODE'] == true) {
								logError("demo_mode_message", "In Demo Mode", "Not Supported In Demo Mode");
								return;
						}
						if (detailsController == undefined) {
							detailsController = sap.ui.controller("app.ui.shoppinglist.listItemDetails");
						}
						addItem = {
							shoppingListId : shoppingListId,
							title : "",
							description : "",
							isFavourite : 0,
							isChecked : 0
						};
						detailsController.launchDetailsPage("add", addItem);
					},
					icon : "app/resources/img/shoppinglist/add-button.png",
					activeIcon : "app/resources/img/shoppinglist/add-button-active.png"
				})],
				contentMiddle : [new sap.m.Label("shoppingListTitle1", {
					text : oBundle.getText("Shopping_list")
				})],
				contentLeft : [new sap.m.Button('menuButtonShoppingList', {
					icon: "sap-icon://menu2",
					activeIcon: "sap-icon://menu2",
					tap : function(event, src) {
						sliderMenuController.action('menuButtonShoppingList');
					}
				}).addStyleClass("menuButtonIconFont")]
			});

			var shoppingListpage = new sap.m.Page(SHOPPING_LIST_PAGE, {
				customHeader : header,
				content : [shoppingListView]
			});
		    
			/*  not available in UI5 1.8.7
			shoppingListpage.addEventDelegate({
				onBeforeShow : function(event) {
					shoppingListController.updateListData();
				}
			});
		    */
			app.addPage(shoppingListpage);
		}
		
		app.to(SHOPPING_LIST_PAGE);
		
		shoppingListController.reloadShoppingListItems();
		
	},
    onAfterRendering : function(){
		shoppingListController.updateListData();	
	},
	/*** User Interaction Functions ***/

	selectListItem : function(oControlEvent) {
		if (detailsController == undefined) {
			detailsController = sap.ui.controller("app.ui.shoppinglist.listItemDetails");
		}
		var selectedItem = oControlEvent.getSource();
		var index = this.listElement.indexOfItem(selectedItem);
		var item = shoppingListController.oModel.getData().list[index];

		detailsController.launchDetailsPage("edit", item);
	},

	checkItem : function(oControlEvent) {
		var item = oControlEvent.getParameters().listItem;
		var data = item.getBindingContext().getObject();
		data.isChecked = item.isSelected();
		SmartphoneService.updateListItem(data, CheckItemBack);
	},

	deleteCheckedItems : function() {
		var selectedItems = this.listElement.getSelectedItems();
		deleteItems = [];
		for (index in selectedItems) {
			var item = selectedItems[index];
			var id = item.getBindingContext().getObject()["id"];
			deleteItems.push(id);
		}
		if (deleteItems.length < 1) {
			return;
		}
		SmartphoneService.deleteListItem(deleteItems, DeleteCheckedItemBack);
	},

	/*** User Interaction Functions END ***/

	addItems : function(items) {

		var oData = shoppingListController.oModel.getData();
		for (key in items) {
			oData.list.push(items[key]);
		}
		shoppingListController.oModel.setData(oData, false);
		//false means replace
		shoppingListController.updateCheckBox();
	},

	updateItem : function(item) {

		var oData = shoppingListController.oModel.getData();
		var id = item.id;

		//for the case update item from list items screen
		for (key in oData.list) {
			if (id == oData.list[key].id) {
				oData.list[key] = item;
				shoppingListController.oModel.setData(oData, false);
				shoppingListController.updateCheckBox();
				break;
			}
		}

		//for the case update item from checked items screen
		for (key in oData.checked) {
			if (id == oData.checked[key].id) {
				oData.checked[key] = item;
				shoppingListController.oModel.setData(oData, false);
				shoppingListController.updateCheckBox();
				var data = {
					list : oData.checked
				}
				shoppingListCheckedItemsController.oModel.setData(data, false);
				app.getPage(SHOPPING_LIST_CHECKEDITEMS_PAGE).rerender();
				break;
			}
		}
		
		app.getPage(SHOPPING_LIST_PAGE).rerender();
	},

	deleteItems : function(deleteItems) {
		var oData = shoppingListController.oModel.getData();

		//for the case update item from list items screen
		var listCount = 0;
		for (var i = oData.list.length - 1; i >= 0; i--) {
			var id = oData.list[i].id;
			var dIndex = deleteItems.indexOf(id);
			if (dIndex != -1) {
				oData.list.splice(i, 1);
				//splice will async change the index of the array
				listCount++;
			}
		}
		if (listCount > 0) {
			shoppingListController.oModel.setData(oData, false);
			shoppingListController.updateCheckBox();
		}

		//for the case update item from checked items screen
		var checkCount = 0;
		for (var i = oData.checked.length - 1; i >= 0; i--) {
			var id = oData.checked[i].id;
			var dIndex = deleteItems.indexOf(id);
			if (dIndex != -1) {
				oData.checked.splice(i, 1);
				//splice will async change the index of the array
				checkCount++;
			}
		}
		if (checkCount > 0) {
			var data = {
				list : oData.checked
			}
			shoppingListCheckedItemsController.oModel.setData(data, false);
			app.getPage(SHOPPING_LIST_CHECKEDITEMS_PAGE).rerender();
		}
	},

	updateCheckBox : function() {
		sap.ui.getCore().applyChanges();
		var data = shoppingListController.oModel.getData().list;
		var items = this.listElement.getItems();
		for (var i = 0; i < data.length; i++) {
			var item = items[i];
			item.setSelected(data[i].isChecked)
		}
	},
	updateListData : function() {
		var data = shoppingListController.oModel.getData();
		var activeData = data.list;
		var checkedData = data.checked;
		for (var i = activeData.length - 1; i >= 0; i--) {
			if (activeData[i].isChecked == true) {
				checkedData.push(activeData[i]);
				activeData.splice(i, 1);
			}
		}
		for (var i = checkedData.length - 1; i >= 0; i--) {
			if (checkedData[i].isChecked == false) {
				activeData.push(checkedData[i]);
				checkedData.splice(i, 1);
			}
		}
		data.list = activeData;
		data.checked = checkedData;
		shoppingListController.oModel.setData(data);
	},
	
	reloadShoppingListItems: function(){
		util.createBusyDialog( oBundle.getText("Loading"), oBundle.getText("Loading") );
		SmartphoneService.getAllShoppingList(GetAllShoppingListBack);
	},
	
	getUpdatedSelections: function(){
		
		var data = shoppingListController.oModel.getData();
		var activeData = data.list;
		var checkedData = data.checked;
		for (var i = activeData.length - 1; i >= 0; i--) {
			if (activeData[i].isChecked == true) {
				checkedData.push(activeData[i]);
				activeData.splice(i, 1);
			}
		}
		for (var i = checkedData.length - 1; i >= 0; i--) {
			if (checkedData[i].isChecked == false) {
				activeData.push(checkedData[i]);
				checkedData.splice(i, 1);
			}
		}
		data.list = activeData;
		data.checked = checkedData;
		
		return data;
	}
	
});

showCheckedItems = function() {
	if (shoppingListCheckedItemsController == undefined) {
		shoppingListCheckedItemsController = sap.ui.controller("app.ui.shoppinglist.checkeditems");
	}
	//just in case if user check some items before segue to the page
	//shoppingListController.updateListData();
	
	shoppingListCheckedItemsController.listData.list = shoppingListController.getUpdatedSelections().checked;
	shoppingListCheckedItemsController.launchPage();
}
GetAllShoppingListBack = function(response, status) {
	if (status != 200) {
		checkErrorStatus(status);
		return;
	}

	if (isRESTStatusCodeCorrect(response)) {
		var data = [];
		
		data = response.shoppingList;
		loginResponseModel.customer.shoppingListId = data[0].id;
		shoppingListId = loginResponseModel.customer.shoppingListId;
		SmartphoneService.getAllListItem(shoppingListId, GetAllListItemBack);
		
	} else {
		checkErrorMobiliserStatus(response);
	}

};

GetAllListItemBack = function(response, status) {

	if (status != 200) {
		checkErrorStatus(status);
		return;
	}

	if (isRESTStatusCodeCorrect(response)) {
		
		var data = [];
		data = response.listItem;
		
		var activeData = [];
		var checkedData = [];
		for (key in data) {
			if (data[key].isChecked == true) {
				checkedData.push(data[key]);
			} else {
				activeData.push(data[key]);
			}
		}
		var data = {
			list : activeData,
			checked : checkedData
		}
		shoppingListController.oModel.setData(data);
		app.getPage(SHOPPING_LIST_PAGE).getContent()[0].rerender();
		
		util.closeBusyDialog();
		
	} else {
		checkErrorMobiliserStatus(response);	
	}
	
};


DeleteCheckedItemBack = function(response, status) {

	if (status != 200) {
		checkErrorStatus(status);
		return;
	}

	var data = [];

	if (!isRESTStatusCodeCorrect(response)) {

		var statusVal = response.Status.code;

		if (statusVal == 329) {
			checkErrorMobiliserStatus(response);
		}
		return;
	}

	shoppingListController.deleteItems(deleteItems);
};

CheckItemBack = function(response, status) {
	if (status != 200) {
		checkErrorStatus(status);
		//TODO after alert, will program continue? there is a lot of potential code need to change if that happens
		return;
	}

	if (!isRESTStatusCodeCorrect(response)) {
		var status = response.Status.code;

		if (status == 329) {
			checkErrorMobiliserStatus(response);
		}
	}
	//TODO for check Item, if failed, how to get it back.
};
