function SliderMenuControl() {
	
	this.visibleState = false;
	this.overlayControl = new OverlayControl({ content : null});
	
};

SliderMenuControl.prototype.create = function(app, listView) {
	
	menuPage = new sap.m.Page("MenuPage", {
		showHeader: false,
		content : [ listView ]
	});

	app.addPage(menuPage);
	
	menuPage.addStyleClass('sapMNavItemRendering',true);

	var r= sap.ui.getCore().createRenderManager();
	r.render(menuPage, app.getDomRef());
	r.destroy();
	menuPage.addStyleClass('sapMNavItemHidden',true).removeStyleClass('sapMNavItemRendering',true);
	menuPage.addStyleClass('sliderMenu', true);
	
	$("#MenuPage-scroll").css("background-color", "#f1f1f1");


}

SliderMenuControl.prototype.action = function(idOfButton) {
	
	//If the app is loaded for the first time then set the selected item to home or offers depending on the scenario.
	//Fetch the item to be selected in slider menu
	var item;
	var options = sliderMenuController.sliderListView.byId("menuNavList").getItems();
	var menuItem = "";
	var cardPage = "";
	if(allOffersController){
		if(allOffersController.carouselControl){
			cardPage = allOffersController.carouselControl.getActivePage();
		}
	}
	switch(idOfButton){
	case "menuButtonCheckIn":
		menuItem= "CheckIn";
		break;
	case "menuButtonHomePage":
		menuItem = "homeType"; 
		break;
	case "menuButtonShoppingList":
		menuItem= "MyLists";
		break;
	case "offersMenuButton":
		menuItem= "Offers";
		break;
	case "walletMenuButton":
		menuItem= "Wallet";
		break;
	case "shoppingHistoryMenuButton":
		menuItem = "shoppingHistory";
		break;
	case "menuButtonSettings":
		menuItem = "Settings";
		break;
	default : 
		menuItem = "Offers";
		break;
	}
	if(menuItem != ""){
		if(menuItem == "Offers"){
			if(cardPage.indexOf("CardOfferScreen") == -1)
				item = sliderMenuController.sliderListView.byId("menuNavList").getItems()[1];
			else{
				var activePage = allOffersController.getOffersCarouselActivePage();
				var indexOfActivePage = allOffersController.carouselControl.indexOfPage(activePage);
				item = sliderMenuController.sliderListView.byId("offersList").getItems()[indexOfActivePage - 1];
			}
		}
		else{
			var itemsDetail = sliderMenuController.sliderMenuModel.getData().listItems;
			for(var i = 0 ; i < options.length ; i++){
				if(menuItem == itemsDetail[i].navItem){
					item = sliderMenuController.sliderListView.byId("menuNavList").getItems()[i];
					break;
				}
			}
		}
	}
	sliderMenuController.setSelectedItemForNavList(item);

	 if(!this.visibleState)	{
		 this.open();
	 }
	 else {
		 this.close();
	 }
	 try{
		sliderMenuController.previousActiveItem.getDomRef().style.background = "";
	 }catch(e){
		
	 }
	
	 try{
		sliderMenuController.currentActiveItem.getDomRef().style.background = "#248986";
	 }catch(e){
		
	 }
}

SliderMenuControl.prototype.removeInactivityHandler = function(){
	var menuListItems = sliderMenuController.sliderListView.getContent()[0].getItems()[0].getItems();
		for ( var indexOfMenuListItems = 0; indexOfMenuListItems < menuListItems.length; indexOfMenuListItems++) {
			menuListItems[indexOfMenuListItems]._inactiveHandlingInheritor = function() {
		};
	}
}

SliderMenuControl.prototype.open = function() {
	
	var that = this;
	
	//Removing the inactivity handler
	this.removeInactivityHandler();
	
	if(this.visibleState == false) {
		$(menuPage.getDomRef()).show();
		$(app.getCurrentPage().getDomRef()).animate({ marginLeft: "272px" }, 300); 
		this.visibleState = true;
		this.overlayControl.attachToPage(app.getCurrentPage(), this.overlayControl);
        $(".overlayContainer").click(function(e){
    		that.close();    	
        });


	}
}

SliderMenuControl.prototype.close = function() {
	
	var that = this;
	
	$(app.getCurrentPage().getDomRef()).animate({ marginLeft: "0px" }, 300, function(){ 
		$(menuPage.getDomRef()).hide();
		that.visibleState = false;
	}); 
	
	that.overlayControl.removeFromPage();
}