sap.ui.controller("app.ui.slidermenu.sliderMenuController", {
	
	onInit : function(){
	},
	
	sliderMenuModel: null,
	sliderMenuPrevPage : "",
	//sliderMenuTempItem : null,
	// To hold slider menu instance	
	sliderMenuControl: null,
	
	// Reference for custom content view which is added inside the Slider menu
	sliderListView: null,
	
	// To hold Shopping List Preference Data
	shoppingListPrefData: "",
	
	offersItems: [],

	currentActiveItem: null,
	previousActiveItem: null,
	currentActiveItemOldIcon: "",
	currentShoppingActive : false,
	
	// To create Slider menu in DOM with the custom content
	createSliderMenu: function() {
		
	    sliderMenuController.sliderListView = sap.ui.view({
			type : sap.ui.core.mvc.ViewType.XML,
			viewName : "app.ui.slidermenu.menuView",
			controller : sliderMenuController
		});
	    
		this.sliderListView.setModel(this.getSliderMenuNavListModel());
		this.sliderMenuControl = new SliderMenuControl();
		this.sliderMenuControl.create(app, this.sliderListView);
		
		if (userState['LOGGED_IN']) {
			this.getShoppingListPref();
		}
	},
	
	// Function to handle the taps in the button to which slider menu is attached
	action: function(idOfButton) {
		this.sliderMenuControl.action(idOfButton);
	},
	
	// Handles taps in the main navigation list
	selectTopNavList: function(event) {
		if(!userState.DEMO_MODE){
			if(homeController != undefined){
				util.closeBusyDialog();
				if(homeController.modelData.notConnectedToServer == true){
					this.sliderMenuControl.close();
					logError( "error_connection_msg", "Connection settings are not correct", "Connection settings are not correct" );
					return;
				}
			}
		}
		this.sliderMenuControl.close();

		// Used a different approach to find the list item in which tap is made compared to in offers list
		// Will change it later to down
		
		var navListSelectedItem = event.getSource();
		//for use with UI5 1.9+
		//var navListSelectedItem = event.getSource().getSelectedItem();
		// The below line is an important one.
		sliderMenuController.setSelectedItemForNavList(navListSelectedItem);
		
		var navType = navListSelectedItem.data("nav");
		
		if(navType === "Settings") {
			if ( !userState.LOGGED_IN) {
				homeController.notLoggedInToPage = "settings";
				logError( "error_login_msg", "Login to change your settings", "Login to change your settings" );
				if (homepageController==undefined){
					homepageController = sap.ui.controller("app.ui.login.login");
				}   
				launchLoginPage();
				//console.log("Not logged in");
			}
			else{
				var checkTime = new Date().getTime();
				if (userState['WALLET_PASSCODE_ENABLED'] && (userState['PASSCODE_FIRST'] || checkTime > userState['PASSCODE_EXP']) && !userState['DEMO_MODE']) {
						if ( PINController == null)
							PINController = sap.ui.controller("app.ui.passcode.passcodeController")
						PINController.toSettings();
				}
				else{
					if(settingsController == undefined)
						settingsController = sap.ui.controller("app.ui.settings.settingsController");
					settingsController.displaySettingsPage();
				}
			}
		} else if(navType === "Wallet") {
			if ( !userState.LOGGED_IN) {
				homeController.notLoggedInToPage = "wallet";
				logError( "error_login_msg", "Login to change your settings", "Login to change your settings" );
				if (homepageController==undefined){
					homepageController = sap.ui.controller("app.ui.login.login");
				}   
				launchLoginPage();
				//console.log("Not logged in");
			}
			else{
				var checkTime = new Date().getTime();
				if (userState['WALLET_PASSCODE_ENABLED'] && (userState['PASSCODE_FIRST'] || checkTime > userState['PASSCODE_EXP']) && !userState['DEMO_MODE']) {
					if ( PINController == null)
						PINController = sap.ui.controller("app.ui.passcode.passcodeController")
					PINController.toWallet();
				}
				else{
					if (walletController == undefined) 
					walletController = sap.ui.controller("app.ui.wallet.wallet");
					walletController.launchWalletPage();
				}
			}
		} else if(navType === "BrowseProducts") {
		    var checkTime = new Date().getTime();
		    if (userState['WALLET_PASSCODE_ENABLED'] && (userState['PASSCODE_FIRST'] || checkTime > userState['PASSCODE_EXP']) && !userState['DEMO_MODE']) {
				if ( PINController == null)
					PINController = sap.ui.controller("app.ui.passcode.passcodeController")
				PINController.toBrowseProducts();
			}
			else{
				if (catalogueController == undefined) {
                  catalogueController = sap.ui.controller("app.ui.catalogue.catalogueController");
                  }
                  catalogueController.loadCataloguePage();
			}
		} else if(navType === "CheckIn") {
			if ( !userState.LOGGED_IN) {
				homeController.notLoggedInToPage = "inStoreShopping";
				logError( "error_login_msg", "Login to change your settings", "Login to change your settings" );
				if (homepageController==undefined){
					homepageController = sap.ui.controller("app.ui.login.login");
				}   
				launchLoginPage();
				//console.log("Not logged in");
			}else if(sliderMenuController.currentShoppingActive == false) {
				if (checkInController == undefined) 
					checkInController = sap.ui.controller("app.ui.myLists.checkIn");
				checkInController.launchCheckInPage();
			}
			else {
				if(SmartphoneService.getInactivityPeriod() > userState.PICKLIST_TIMEOUT) { 
					var dummyResponse = {
							shoppingSessionExpired: true
					};
					util.isShoppingSessionExpired(dummyResponse);
					
				}else{
					app.to(ID_CHECK_IN_SHOPPING);
				}
				
			}
		} else if(navType === "ShoppingList") {
			// Call Shopping List launch function
			if (shoppingListController == undefined) {
				shoppingListController = sap.ui.controller("app.ui.shoppinglist.shoppingList");
			}
			shoppingListController.launchShoppingListPage();
			
		} else if( navType === "MyLists") {
			if ( !userState.LOGGED_IN) {
				homeController.notLoggedInToPage = "shoppingList";
				logError( "error_login_msg", "Login to change your settings", "Login to change your settings" );
				if (homepageController==undefined){
					homepageController = sap.ui.controller("app.ui.login.login");
				}   
				launchLoginPage();
				//console.log("Not logged in");
			}else {
				if (myListController == undefined) {
					myListController = sap.ui.controller("app.ui.myLists.myListController");
				}
				myListController.launchMyListsPage();
			}
      
		} else if(navType === "AllOffers") {
			
			if(app.getCurrentPage().getId() !== ALL_OFFERS_PAGE) {
			
				if(userState['LOGGED_IN'] !== true)
					userState['BRANDTYPE'] = 'single';
				if (allOffersController == undefined) {
					allOffersController = sap.ui.controller("app.ui.offers.allOffersController");
				}
				allOffersController.navigateToOffersScreen();
			}

			// Call All Offers launch function
		} else if(navType === "MyOffers") {
			if(app.getCurrentPage().getId() !== ALL_OFFERS_PAGE) {
				if (allOffersController == undefined) {
					allOffersController = sap.ui.controller("app.ui.offers.allOffersController");
				}
				allOffersController.navigateToOffersScreen();
			}	
		} else if (navType === "homeType"){ 
			/*if(userState.DEMO_MODE){
				if(connectionSettingsController == undefined)
					connectionSettingsController = sap.ui.controller('app.ui.home.connectionSettings');
				connectionSettingsController.launchConnectionSettingPage();
				return;
			}*/
			if (homeController == undefined) {
				homeController = sap.ui.controller("app.ui.home.homeController");
			}
			if(!userState.DEMO_MODE)
				homeController.restHeaderBar();
			if(app.getCurrentPage().sId == ANONYMOUS_HOME_PAGE)
				homeController.prevPage = "initial";
			else
				homeController.prevPage = "back";
			homeController.launchAnonymousHomePage();
		}

		else if ( navType === "shoppingHistory") {
			if ( !userState.LOGGED_IN) {
				homeController.notLoggedInToPage = "shoppingHistory";
				logError( "error_login_msg", "Login to change your settings", "Login to change your settings" );
				if (homepageController==undefined){
					homepageController = sap.ui.controller("app.ui.login.login");
				}   
				launchLoginPage();
				//console.log("Not logged in");
			}else {
				if (shoppingHistoryController == undefined) {
					shoppingHistoryController = sap.ui.controller("app.ui.shoppingHistory.shoppingHistoryController");
				}
				shoppingHistoryController.launchShoppingHistory();
			}
		}
		
	},

	handleActiveIconChange: function(item) {
		var img = sap.ui.getCore().byId(item.getId() + "-img");
		if (img && item.getActiveIcon()) {
				img.setSrc(item.getActiveIcon());
		}
		item.addStyleClass("sapmlibactive");
	},
	
	handleNormalIconChange: function(item) {
		var img = sap.ui.getCore().byId(item.getId() + "-img");
		if (img && item.getIcon()) {
				img.setSrc(item.getIcon());
		}
		item.removeStyleClass("sapmlibactive");
	},
	
	// Handles the taps in different card offers
	selectOffersList: function(event) {
		this.sliderMenuControl.close();
		
		var listSelectedCardOffer = event.getSource();
		//var listSelectedCardOffer = event.getSource().getSelectedItem();
		if(listSelectedCardOffer === undefined || listSelectedCardOffer == this.currentActiveItem) return;
		
		if(this.currentActiveItem !== null) {
			this.handleNormalIconChange(this.currentActiveItem);
			//sliderMenuController.sliderListView.getContent()[0].getItems()[0].removeSelections();
			//this.currentActiveItem.setIcon(this.currentActiveItemOldIcon);
		}

		this.previousActiveItem = this.currentActiveItem;
		this.currentActiveItem = listSelectedCardOffer;
		sliderMenuController.handleActiveIconChange(sliderMenuController.currentActiveItem);

		var cardOfferType = listSelectedCardOffer.data("cardoffer");
		var offersList = sliderMenuController.sliderListView.getContent()[0].getItems()[2];
		var selectedCardOffersIndex = offersList.indexOfItem(listSelectedCardOffer);
        if (allOffersController == undefined)
            allOffersController = sap.ui.controller("app.ui.offers.allOffersController");
           allOffersController.loadCardOfferPage(selectedCardOffersIndex);
        try{
   			sliderMenuController.previousActiveItem.getDomRef().style.background = "";
   		}catch(e){
   			
   		}
        /*try{
   			sliderMenuController.previousActiveItem.getDomRef().style.background = "";
   		}catch(e){
   			
   		}
   		
   		try{
   			sliderMenuController.currentActiveItem.getDomRef().style.background = "#248986";
   		}catch(e){
   			
   		}
   		try{
   			sliderMenuController.previousActiveItem.getDomRef().style.background = "";
   		}catch(e){
   			
   		}*/
           
		// Here we need to write navigation logic based on taps on different card offers
	},
	
	selectPreviousActiveItem : function() {
		if(this.currentActiveItem !== null) {
			this.handleNormalIconChange(this.currentActiveItem);
			//sliderMenuController.sliderListView.getContent()[0].getItems()[0].removeSelections();
		}
		
		if(this.previousActiveItem !== null) {
			//this.previousActiveItem.setSelected(true);
			this.handleActiveIconChange(this.previousActiveItem);
		}
		
		this.currentActiveItem = this.previousActiveItem;
		this.previousActiveItem = null;
	},
	
	getSliderMenuNavListModel : function() {
	    var navItemTitleStrings = "", navItemType = "";
	    //console.warn(userState.BRANDTYPE);
	    
//	    if(userState.SHOPPING_LIST_ENABLED == true) {
//	    	navItemTitleStrings = ["about_us","all_offers", "wallet", "shopping_list", "Settings"];
//	    	navItemType = ["About","AllOffers","Wallet","ShoppingList","Settings"];
//	    } else {
//			navItemTitleStrings = ["about_us","all_offers", "wallet", "Settings"];
//			navItemType = ["About","AllOffers","Wallet", "Settings"];
//	    }
	    
		//SINGLE BRAND ITEMS
	    if(userState.BRANDTYPE === "single" && userState.CHECKIN_ENABLED == "true" && userState.APP_MODE == "mShopping") {
		if(sliderMenuController.currentShoppingActive == false) {
	    	navItemTitleStrings = ["HomePageTitle",
								   "my_offers",
								   "wallet",
								   "my_list",
								   "check_in",
								   "shopping_history",
								   "Settings"];
	    	navItemType = ["homeType",
						   "MyOffers",
						   "Wallet",
						   "MyLists",
						   "CheckIn",
						   "shoppingHistory",
						   "Settings"];
	    	iconNames = [ "sap-icon://home",
						 "sap-icon://shelf",
						 "sap-icon://wallet",
						 "sap-icon://activity-items",
						 "sap-icon://accept",
						 "sap-icon://history",
						 "sap-icon://settings"];
	    	activeIconNames = ["sap-icon://home",
							   "sap-icon://shelf",
							   "sap-icon://wallet",
							   "sap-icon://activity-items",
							   "sap-icon://accept",
							   "sap-icon://history",
							   "sap-icon://settings"];
		}
		else {
			navItemTitleStrings = ["HomePageTitle",
								   "my_offers",
								   "wallet",
								   "my_list",
								   "continue_shopping",
								   "shopping_history",
								   "Settings"];
	    	navItemType = ["homeType",
						   "MyOffers",
						   "Wallet",
						   "MyLists",
						   "CheckIn",
						   "shoppingHistory",
						   "Settings"];
	    	iconNames = [ "sap-icon://home",
						 "sap-icon://shelf",
						 "sap-icon://wallet",
						 "sap-icon://activity-items",
						 "sap-icon://accept",
						 "sap-icon://history",
						 "sap-icon://settings"];
	    	activeIconNames = ["sap-icon://home",
							   "sap-icon://shelf",
							   "sap-icon://wallet",
							   "sap-icon://activity-items",
							   "sap-icon://accept",
							   "sap-icon://history",
							   "sap-icon://settings"];
		
		}
	    }
		//SINGLE BRAND && SHOPPING DISABLED
		else if (userState.BRANDTYPE === "single" && userState.APP_MODE == "mLoyalty") {
			navItemTitleStrings = ["HomePageTitle",
								   "all_offers",
								   "wallet",
								   "my_list",
								   "Settings"];
	    	navItemType = ["homeType",
						   "AllOffers",
						   "Wallet",
						   "MyLists",
						   "Settings"];
	    	iconNames = ["sap-icon://home",
						 "sap-icon://shelf",
						 "sap-icon://wallet",
						 "sap-icon://activity-items",
						 "sap-icon://settings"];
	    	activeIconNames = ["sap-icon://home",
							   "sap-icon://shelf",
							   "sap-icon://wallet",
							   "sap-icon://activity-items",
							   "sap-icon://settings"];
		}
		//MULTI BRAND MENU ITEMS
		else if(userState.BRANDTYPE === "multi" && userState.SHOPPING_LIST_ENABLED == true) {
	    	navItemTitleStrings = ["HomePageTitle",
								   "all_offers",
								   "wallet",
								   "my_list",
								   "Settings"];
	    	navItemType = ["homeType",
						   "AllOffers",
						   "Wallet",
						   "MyLists",
						   "Settings"];
	    	iconNames = ["sap-icon://home",
						 "sap-icon://shelf",
						 "sap-icon://wallet",
						 "sap-icon://activity-items",
						 "sap-icon://settings"];
	    	activeIconNames = ["sap-icon://home",
							   "sap-icon://shelf",
							   "sap-icon://wallet",
							   "sap-icon://activity-items",
							   "sap-icon://settings"];
	    }
		else if(userState.BRANDTYPE === "single" && userState.SHOPPING_LIST_ENABLED == false) {
			navItemTitleStrings = ["my_offers", "my_card", "Settings"];
			navItemType = ["MyOffers","my_card", "Settings"];
			iconNames = ["sap-icon://shelf", "sap-icon://wallet", "sap-icon://settings"];
			activeIconNames = ["sap-icon://shelf", "sap-icon://wallet", "sap-icon://settings"];
	    } 
	    else if(userState.BRANDTYPE === "single" && userState.SHOPPING_LIST_ENABLED == true) {
	    	navItemTitleStrings = ["HomePageTitle", "my_offers", "my_card", /*"shopping_list",*/ "my_list", "shopping_history", "Settings"];
	    	navItemType = ["homeType", "MyOffers","Wallet", /*"ShoppingList",*/ "MyLists", "shoppingHistory", "Settings"];
	    	iconNames = [ "sap-icon://home", "sap-icon://shelf", "sap-icon://wallet", "sap-icon://activity-items", "sap-icon://history", "sap-icon://settings"];
	    	activeIconNames = ["sap-icon://home", "sap-icon://shelf", "sap-icon://wallet", "sap-icon://activity-items", "sap-icon://history", "sap-icon://settings"];
	    } else {
	    	navItemTitleStrings = ["HomePageTitle", "all_offers", "wallet",/*"shopping_list",*/ "my_list","Settings"];
			navItemType = ["homeType",  "AllOffers","Wallet",/*"ShoppingList",*/ "MyLists", "Settings"];
			iconNames = [ "sap-icon://home", "sap-icon://shelf", "sap-icon://wallet","sap-icon://activity-items",  "sap-icon://settings"];
			activeIconNames = ["sap-icon://home", "sap-icon://shelf", "sap-icon://wallet","sap-icon://activity-items","sap-icon://settings"];
	    }

	    var listItems = [];
		for(var i=0; i<navItemType.length; i++) {
					
			 currentNavItemModel = {
				 title : oBundle.getText(navItemTitleStrings[i]),
				 navItem : navItemType[i],
				 id : i+1,
				 iconPath : iconNames[i],
				 activeIconPath : activeIconNames[i]
			 };
			 
			 listItems.push(currentNavItemModel);
		}
		
		
		var isOffersSectionVisible = false;
		if(userState.BRANDTYPE === "single") {
			isOffersSectionVisible = false;
		} else if (userState.BRANDTYPE == "multi" && userState.LOGGED_IN) {
			if(sliderMenuController.offersItems.length > 0) isOffersSectionVisible = true;
		}
		else{
			isOffersSectionVisible = false;
		}

		var mdData = {
			listItems : listItems,
			offersItems : sliderMenuController.offersItems,
			isOffersSectionVisible: isOffersSectionVisible
		};

		// The offersItems will be set based on data coming from server
		if(sliderMenuController.sliderMenuModel === null) {
			sliderMenuController.sliderMenuModel = new sap.ui.model.json.JSONModel();
		}
		
		sliderMenuController.sliderMenuModel.setData(mdData);
		return sliderMenuController.sliderMenuModel;
	},
	
	getShoppingListPref: function() {
		//SmartphoneService.getLoyaltyConfiguration("ShoppingListEnabled", sliderMenuController.shoppingListPrefBack);
		//sliderMenuController.shoppingListPrefData = response;
		sliderMenuController.sliderListView.setModel(sliderMenuController.getSliderMenuNavListModel());
	},
	
	/*shoppingListPrefBack: function(response, status) {
		if (status != 200) {
			checkErrorStatus(status);
			return;
		}
		if (isRESTStatusCodeCorrect(response)) {
			sliderMenuController.shoppingListPrefData = response;
			sliderMenuController.sliderListView.setModel(sliderMenuController.getSliderMenuNavListModel());
		} else {
			checkErrorMobiliserStatus(response);
		}


	},*/
	
	takeToCardDetail: false,
	getSubscribedProgramAndMembershipDetails: function(showCardDetail) {
		if(showCardDetail != undefined && showCardDetail == true)
			sliderMenuController.takeToCardDetail = true;
		else
			sliderMenuController.takeToCardDetail = false;
		SmartphoneService.getSubscribedProgramAndMembershipDetailsByCustomerId(loginResponseModel, sliderMenuController.subscribedProgramAndMembershipDetailsBack);
	},
	
	subscribedProgramAndMembershipDetailsBack: function(response, status) {
		if (status != 200) {
			checkErrorStatus(status);
			return;
		}

		if (isRESTStatusCodeCorrect(response)) {
			subscribedPrograms = [];
			var countOfOfferSubscribedPrograms = 0 ;
			
			if (response.SubscribedProgram != undefined) {
				subscribedPrograms = sliderMenuController.filterOffersEnabledSubscribedPrograms(response.SubscribedProgram);
				countOfOfferSubscribedPrograms = subscribedPrograms.length;
				
			}
			sliderMenuController.offersItems = [];
			for(var i=0; i<countOfOfferSubscribedPrograms; i++) {
				
				var logoVal = subscribedPrograms[i].logo;
				if(userState['DEMO_MODE'] == false)
					logoVal = "data:image/png;base64," + logoVal;
				 currentOfferItemModel = {
					 title : subscribedPrograms[i].programName,
					 cardOfferType : subscribedPrograms[i].programName,
					 logo : logoVal,
					 //logo: "",
					 id : i+1
				 };
				 
				 sliderMenuController.offersItems.push(currentOfferItemModel);
			}
			
			sliderMenuController.sliderListView.setModel(sliderMenuController.getSliderMenuNavListModel());
			
			if(sliderMenuController.takeToCardDetail == true)
			{
				preferencesController.launchCardDetailScreen();
			}
			
//			setTimeout(function() {
//				for(var i=0; i<countOfSubscribedPrograms; i++) {
//			
//				$($(".slider_menu_offers .listItemStyle img")[i]).attr('src', "data:image/png;base64," + response.SubscribedProgram[i].logo);
//				} }, 500);
			
			if(userState.BRANDTYPE === "single" && response.SubscribedProgram && response.SubscribedProgram.length > 0){
				if(response.SubscribedProgram[0].householdingEnabled != undefined && response.SubscribedProgram[0].householdingEnabled != null)
					userState.HOUSEHOLDING_ENABLED = response.SubscribedProgram[0].householdingEnabled;
			}
			
		} else {
			// Better error handling code needed
			checkErrorMobiliserStatus(response);
		}

		
	},
	
	createOrRefreshSliderMenu: function() {
		sliderMenuController.getSubscribedProgramAndMembershipDetails();
	},
	
	filterOffersEnabledSubscribedPrograms: function(subscribedPrograms) {
		var offersEnabledSubscribedPrograms = [];
		for(var i = 0; i< subscribedPrograms.length; i++) {
			if(subscribedPrograms[i].offerEnabled == true) {
				offersEnabledSubscribedPrograms.push(subscribedPrograms[i]);
			}
		}
		
		return offersEnabledSubscribedPrograms;
	},
	
	updateOffersWithAddedCard: function() {
		 var cardName = cardPickerController.listData.programs[selectedProgramIndex].name;
		 var currentOfferItemModel = {
				 title : cardName,
				 cardOfferType : cardName,
				 id : sliderMenuController.offersItems.length
		 };
		 
		 sliderMenuController.offersItems.push(currentOfferItemModel);
		 sliderMenuController.sliderListView.setModel(sliderMenuController.getSliderMenuNavListModel());

	},
	
	removeAllSelections: function() {
		if(this.currentActiveItem !== null) {
			this.handleNormalIconChange(this.currentActiveItem);
			this.currentActiveItem = null;
			this.previousActiveItem = null;
			//Remove the temporary item.
			//this.sliderMenuTempItem = null;
			//sliderMenuController.sliderListView.getContent()[0].getItems()[0].removeSelections();
			
			//if(userState['BRANDTYPE'] === "multi") sliderMenuController.sliderListView.getContent()[0].getItems()[2].removeSelections();
			//this.currentActiveItem.setIcon(this.currentActiveItemOldIcon);
		}

	},
	
	setSelectedItemForNavList: function(item){
		if(item === undefined || item == this.currentActiveItem) return;

		if(this.currentActiveItem !== null) {
			this.handleNormalIconChange(this.currentActiveItem);
			//if(userState['BRANDTYPE'] === "multi") sliderMenuController.sliderListView.getContent()[0].getItems()[2].removeSelections();
		}
		//this.sliderMenuTempItem = this.previousActiveItem; 
		this.previousActiveItem = this.currentActiveItem;
		this.currentActiveItem = item;
		
		/*try{
			sliderMenuController.previousActiveItem.getDomRef().style.background = "";
		}catch(e){
			
		}
		
		try{
			sliderMenuController.currentActiveItem.getDomRef().style.background = "#248986";
		}catch(e){
			
		}
		try{
			sliderMenuController.previousActiveItem.getDomRef().style.background = "";
		}catch(e){
			
		}*/
		try{
			sliderMenuController.previousActiveItem.getDomRef().style.background = "";
		}catch(e){
			
		}
		sliderMenuController.handleActiveIconChange(sliderMenuController.currentActiveItem);
		
	},
	
	checkInSliderViewModFunction : function( state) {
		sliderMenuController.currentShoppingActive = state;
		sliderMenuController.sliderListView.setModel(sliderMenuController.getSliderMenuNavListModel());
	
	}
	
});
