var storemode = "store";
var citymode = "store";
var prevPageId = "";
sap.ui.controller('app.ui.storelocator.list', {//storeLocatorListController

		storemode : "store",

		citymode : "city",

		startRenderTime : "",
    
    previousPage : null,

		searchType: null,
    
		onInit : function() {
				this.startRenderTime = util.startPerformanceReading();
		},

		launchPage : function(prevPage) {
				prevPageId = prevPage;
				var header = new sap.m.Bar({
						contentMiddle : [new sap.m.Label({
								text : oBundle.getText("Store_Locator")
						})],
				});
				if (app.getPage(STORE_LOCATOR_LIST_PAGE) == null) {
						//view
						this.view = sap.ui.view({
								type : sap.ui.core.mvc.ViewType.XML,
								viewName : "app.ui.storelocator.list",
								controller : this
						});
						this.list = this.view.byId("storeList");
						this.mode = this.storemode;
						this.oModel = new sap.ui.model.json.JSONModel();
						// this.oModel.setData(data);
						this.view.setModel(this.oModel);
						var searchField = new sap.m.Input({
							width : "100%",
							placeholder : oBundle.getText("store_search"),
							change : this.searchByField,
							layoutData : new sap.m.FlexItemData({
								growFactor : 1
							})
						});
				
						this.searchField = searchField;
				
						var footer = new sap.m.Bar('store_Locator_footer',{
								contentRight : [new sap.m.Button({
									tap : this.locateMe,
									icon : "app/ui/googleMaps/img/locate.png",
									activeIcon : "app/ui/googleMaps/img/locate-active.png"
								})],
								contentMiddle : [searchField],
								enableFlexBox : true
						});
		
						var page1 = new sap.m.Page(STORE_LOCATOR_LIST_PAGE, {
								customHeader : header,
								content : [this.view],
								footer : footer
						});
						app.addPage(page1);
				}
				this.updateList();
        //from check-in, go back check in and no map button
        if (prevPage == ID_CHECK_IN){
		storeLocatorListController.searchType = "checkIn";
            header = new sap.m.Bar({
                contentMiddle : [new sap.m.Label({
                    text : oBundle.getText("Store_Locator")
                })],
                contentLeft : [new sap.m.Button({
                    text : oBundle.getText("Back_Button"),
                    type : sap.m.ButtonType.Back,
                    tap : function(event, src) {
                        app.backToPage( prevPage );
                    }
                })]
            });
            this.previousPage = prevPage;
        }
        //go back to home page
        else if (prevPage == ANONYMOUS_HOME_PAGE){
    		storeLocatorListController.searchType = "home";
                header = new sap.m.Bar({
                    contentMiddle : [new sap.m.Label({
                        text : oBundle.getText("Store_Locator")
                    })],
                    contentLeft : [new sap.m.Button({
                        text : oBundle.getText("Back_Button"),
                        type : sap.m.ButtonType.Back,
                        tap : function(event, src) {
                            app.backToPage( prevPage );
                        }
                    })]
                });
                this.previousPage = prevPage;
            }
        //if from map, go back to map and have map button
        else {
		storeLocatorListController.searchType = "mapSearch";
            header = new sap.m.Bar({
                contentRight : [new sap.m.Button({
                    text : oBundle.getText("Wallet_Map_Button"),
                    tap : this.toMap
                })],
                contentMiddle : [new sap.m.Label({
                    text : oBundle.getText("Store_Locator")
                })],
                contentLeft : [new sap.m.Button({
                    /*text : oBundle.getText("Back_Button"),
                    type : sap.m.ButtonType.Back,
                    tap : function(event, src) {
                        app.backToPage( mapController.previousPage );
                    }*/
                	icon : "sap-icon://menu2",
					activeIcon : "sap-icon://menu2",
					tap : function(event, src) {
						sliderMenuController.action('menuButtonStoreLocator');
					}
                }).addStyleClass("menuButtonIconFont")]
            });
            this.previousPage = mapController.previousPage;
        }
        app.getPage(STORE_LOCATOR_LIST_PAGE).setCustomHeader(header);
		app.to(STORE_LOCATOR_LIST_PAGE);
		util.stopPerformanceReading(this.startRenderTime, "Locator Render Time");
		if (prevPage == ID_CHECK_IN) {
				storeLocatorListController.locateMe();
		}
	},
	
	toMap : function() {
			if (mapController == undefined) {
					mapController = sap.ui.controller("app.ui.googleMaps.mapController");
					//mapController = sap.ui.controller("app.ui.storelocator.map");
			}
			//console.warn(mapController.stores);
			if ( mapController.customGMap != null )
					mapController.customGMap.clearOverlays();
			//mapController.stores = mapController.launchPage();
			mapController.loadGoogleAPI();
			app.backToPage(MAP_PAGE);
	},
	
	selectItem : function(oControlEvent) {
		    // if (!userState.LOGGED_IN) {
				//do nothing
				// return;
			// }
			var selectedItem = oControlEvent.getSource();
			var index = this.list.indexOfItem(selectedItem);
			var item = this.oModel.getData().list[index];
			if (storeLocatorListController.searchType == "mapSearch") {
				if (this.mode == this.storemode) {
						mapController.toDetailsPage(item.id);
				} else if (this.mode == this.citymode) {
						var request = {
								programId : mapController.programId,
								location : {
										longitude : item.location.longitude, //storeLocatorListController.myLocation.longitude,
										latitude : item.location.latitude//storeLocatorListController.myLocation.latitude
								}
						};
						var startServiceTime = util.startPerformanceReading();
						this.attachEvent("storeDataRetrieved", storeLocatorListController.updateList);
						SmartphoneService.getStoreLocatorResults(request, GetStoreLocatorResultsBackOnListPage, null, null, true);
				}
			}
			else{
				if (this.mode == this.storemode) {
					 var obj = {
		                        storeId : item.id,
		                };
					 if(checkInController.myStore.storeDetail.storeId == null){
						SmartphoneService.createUpdatePreferredStoreForMember(item.id, checkInController.getPreferredStoreBack, null, null, true);
						util.createBusyDialog(oBundle.getText("Loading"),oBundle.getText("Loading"));
					 }
					 else
						 SmartphoneService.getStoreCheckinInfo( obj, checkInController.updateStoreBack);
				} else if (this.mode == this.citymode) {
						var request = {
								programCode : userState.SINGLE_BRAND_PROGRAM_CODE,
								location : {
										longitude : item.location.longitude, //storeLocatorListController.myLocation.longitude,
										latitude : item.location.latitude//storeLocatorListController.myLocation.latitude
								}
						};
						var startServiceTime = util.startPerformanceReading();
						this.attachEvent("storeDataRetrieved", storeLocatorListController.updateList);
						SmartphoneService.getStoreLocatorResults(request, GetStoreLocatorResultsBackOnListPage, null, null, true);
				}
			}
	},
		
	updateList : function() {
			
			var data = {
					list : mapController.stores
			}
			this.generateDistanceString(data.list);
			this.oModel.setData(data);
			app.getPage(STORE_LOCATOR_LIST_PAGE).getContent()[0].getModel().setData( data );
	},
	
	locateMe : function() {
		var options = {
				enableHighAccuracy : true
		};
		var onSuccess = function(position) {
				mapController.locationPermissionAllowed = true;
				mapController.myLocation = {
						latitude : position.coords.latitude,
						longitude : position.coords.longitude,
						altitude : position.coords.altitude,
						accuracy : position.coords.accuracy,
						altitudeAccuracy : position.coords.altitudeAccuracy,
						heading : position.coords.heading,
						speed : position.coords.speed,
						timestamp : position.timestamp
				}
				//mapController.getStores();
				mapController.updateMyLocation();
				var request = {
						programCode : userState.SINGLE_BRAND_PROGRAM_CODE,
						location : {
								longitude : mapController.myLocation.longitude, //storeLocatorListController.myLocation.longitude,
								latitude : mapController.myLocation.latitude//storeLocatorListController.myLocation.latitude
						}
				};
				SmartphoneService.getStoreLocatorResults(request, storeLocatorListController.locateMeUpdateList, null, null, true);	
		};
		var onError = function(error) {
			//console.log('NAVIGATOR.GEOLOCATION ERROR');
			//console.log('code: ' + error.code + '\n' + 'message: ' + error.message + '\n');
			mapController.myLocation = undefined;
			mapController.locationPermissionAllowed = false;
			
			if (error.code == 1) {
				//console.log("Location Permission Denied");
				logError("location_Not_Allowed","Location Permission Denied","MapController");
				return;
			} else if (error.code == 2) {
				//console.log("Location Not Available");
				logError("location_Not_Allowed","Location Not Available","MapController");
				return;
			}
		};
		navigator.geolocation.getCurrentPosition(onSuccess, onError, options);

	},
			
	locateMeUpdateList : function (response, status){
			if (status != 200) {
					checkErrorStatus(status);
					return;
			} else if (isRESTStatusCodeCorrect(response)) {
					mapController.stores = response.StoreSearchResultList;
					storeLocatorListController.updateList();
					storeLocatorListController.mode = storeLocatorListController.storemode;
			} else {
					checkErrorMobiliserStatus(response);
			}
	},
		
	searchByField : function(oControlEvent) {
		
		if (storeLocatorListController.searchType == "mapSearch") {
		        var searchValue = storeLocatorListController.searchField.getValue();
			if (searchValue == "") {
					data = {
							list : storeLocatorListController.stores
					}
					storeLocatorListController.mode = storeLocatorListController.storemode;
					//for different item segue behavior
					storeLocatorListController.oModel.setData(data);
					return;
			}
			var request = {
					programId : mapController.programId,
					searchItem : searchValue
			};
			//console.warn("SEARCH BY FIELD PRE SERVICE CALL");
			SmartphoneService.getStoreSearch(request, GetStoreSearchBack, null, null, true);
		}
		else{
		    var searchValue = storeLocatorListController.searchField.getValue();
			if (searchValue == "") {
					data = {
							list : storeLocatorListController.stores
					}
					storeLocatorListController.mode = storeLocatorListController.storemode;
					//for different item segue behavior
					storeLocatorListController.oModel.setData(data);
					return;
			}
			var request = {
					programCode : userState.SINGLE_BRAND_PROGRAM_CODE,
					searchItem : searchValue
			};
			//console.warn("SEARCH BY FIELD PRE SERVICE CALL");
			SmartphoneService.getStoreSearch(request, GetStoreSearchBack, null, null, true);
		}
	},
		
	generateDistanceString : function(data) {
			for (key in data) {
				if(data[key].distance != null || data[key].distance != undefined) {
					var distance = data[key].distance.toFixed(1);
					var Unit = data[key].distanceUOM;
					var distanceString = distance + " " + Unit;
					var listType = "Navigation";
					if (prevPageId == ID_CHECK_IN) {
						listType = "Active";
					}
					data[key].listType = listType;
					data[key].distanceString = distanceString;
				}
			}
	}
});

GetStoreSearchBack = function(response, status) {
	if (status != 200) {
		//checkErrorStatus(status);
		return;
	} else if (isRESTStatusCodeCorrect(response)) {
		var results = response.StoreSearchResultList;
		if (results.length != 0) {
			var data;
			var id = results[0].id;
			var name = results[0].name;
			if (id == 0 && name == "LocationSearchResult") {
				// choose from city list from furthuer search
				var cities = response.StoreSearchResultList;
				for (key in cities) {
					cities[key].name = cities[key].shortAddress;
					cities[key].shortAddress = null;
				}
				storeLocatorListController.cities = cities;
				data = {
					list : storeLocatorListController.cities
				}
				storeLocatorListController.mode = storeLocatorListController.citymode;
				// for different item segue behavior
			} else {
				// no need to choose city, stores got back directly
				storeLocatorListController.stores = response.StoreSearchResultList;
				data = {
					list : storeLocatorListController.stores
				}
				storeLocatorListController.generateDistanceString(data.list);
				storeLocatorListController.mode = storeLocatorListController.storemode;
				// for different item segue behavior
			}
			storeLocatorListController.oModel.setData(data);
		} else {
			//logError(oBundle.getText("error_message_no_results_found"),
			//		"Store List page search result gave empty response",
			//		"StoreListController");
		}
	} else {
		//checkErrorMobiliserStatus(response);
	}
};

GetStoreLocatorResultsBackOnListPage  = function(response, status) {
		if (status != 200) {
				//checkErrorStatus(status);
				return;
		} else if (isRESTStatusCodeCorrect(response)) {
				mapController.stores = response.StoreSearchResultList;
				storeLocatorListController.fireEvent("storeDataRetrieved");
				storeLocatorListController.mode = storeLocatorListController.storemode;
		} else {
				//checkErrorMobiliserStatus(response);
		}
		storeLocatorListController.detachEvent("storeDataRetrieved", storeLocatorListController.updateList);
};
