/// <reference path="http://veui5infra.dhcp.wdf.sap.corp:8080/sapui5/resources/sap-ui-core.js" />

var parMemberID;
var cardController;
var cardPickerController;
var walletModelList;
var viewRef;
var showWalletProgressBusyDialog;
var imge = "";
_keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";



sap.ui.controller('app.ui.wallet.wallet', {
	paymentCards :[],
	paymentCardTemplates :[],
	bankAccountPresent : "",
	dataCards : [],
	memberID : null,
    onInit: function () {

    },

    onAfterRendering: function () {

    },
    
    customerData : {
		customerId : loginResponseModel.customer.id
	},

    doCancel: function () {
        app.back();

    },
    launchWalletPage: function (memberId) {
    	walletController.memberId = memberId;
		var startRenderTime = util.startPerformanceReading();
        if (app.getPage(WALLET_PAGE) == null) {
            var walletData =[{
					cardId: "",
					cardFrontImage: imge,
				},{
					cardId: "",
					cardFrontImage: imge,
			}];

            
            var myListView = sap.ui.view({
                type: sap.ui.core.mvc.ViewType.XML,
                viewName: "app.ui.wallet.wallet",
                viewId: "app.ui.wallet.wallet",
                controller: walletController
            });

            walletModelList = new sap.ui.model.json.JSONModel();
            walletModelList.setData(walletData);
            myListView.setModel(walletModelList);

            var Bar = new sap.m.Bar({
                contentLeft: [new sap.m.Button('walletMenuButton', {
                    icon: "sap-icon://menu2",
                    activeIcon: "sap-icon://menu2",
                    tap: function (event, src) {
                        sliderMenuController.action('walletMenuButton');
                    }
                }).addStyleClass("menuButtonIconFont")],
                contentMiddle: [new sap.m.Label("walletLabel", { text: oBundle.getText("Wallet_Page_Title") })],
            });

            var walletPage = new sap.m.Page(WALLET_PAGE, {
                title: "Wallet",
                color: "White",
                content: [myListView],
                header: [Bar],
            });

            walletPage.setCustomHeader(Bar);
            app.addPage(walletPage);
        }
        
        walletController.customerData.customerId = null;
        walletController.customerData.customerId = loginResponseModel.customer.id;
        
		var startServiceTime = util.startPerformanceReading();
		util.createBusyDialog(oBundle.getText("Wallet_Progress_Message"),oBundle.getText("Wallet_Progress_Message_Title"));
		//Calls the service to get paymentCardInstruments
		if(userState.MOBILE_PAYMENT_ENABLED == "true")
			SmartphoneService.getWalletEntriesByCustomer(walletController.customerData, paymentCardDetailsCallBack);
	    else{
	    	walletController.dataCards = [];
	    	walletController.paymentCards = [];
	    	walletModelList.setData(walletController.dataCards);
	    	SmartphoneService.getMemberCards(walletController.memberId, getWalletCards);
	    }
	    var paymentList = app.getPage(WALLET_PAGE).getContent()[0].byId('paymentInstrumentList');
	    paymentList.onAfterRendering = walletController.assignBackground;
		
		util.stopPerformanceReading(startServiceTime, "Wallet Service Call Time");
		util.stopPerformanceReading(startRenderTime, "Wallet Render Time");
    },

    assignBackground:function(){
    	//sample code for setting bg for payment cards
		var paymentList = app.getPage(WALLET_PAGE).getContent()[0].byId('paymentInstrumentList');
		
		var bankBg = ""; var creditBg = ""; var svaBg = "";
		if(walletController.paymentCardTemplates){
			for(var i=0; i<walletController.paymentCardTemplates.length; i++){
				
				var backgroundImage = util.decode(walletController.paymentCardTemplates[i].paymentWalletTemplate);
				var index = backgroundImage.indexOf("background-image: ")+18;
				var subStr = backgroundImage.slice(index);
				var endStr = subStr.indexOf(");")+1;
				
				if(walletController.paymentCardTemplates[i].paymentTemplateCode == "type_bank"){
					bankBg = subStr.substring(0,endStr);
				}
				else if(walletController.paymentCardTemplates[i].paymentTemplateCode == "type_cc"){
					creditBg = subStr.substring(0,endStr);
				}
				else{
					svaBg = subStr.substring(0,endStr);
				}
			}
			
			for(var i=0; i<walletController.paymentCards.length; i++){
				
				if(walletController.paymentCards[i].creditPriority == 1){
					$('#'+paymentList.getItems()[i].getContent()[1].sId).css('marginTop', '16px');
				}
				
				if(walletController.paymentCards[i].bankAccount != null){
					$('#'+paymentList.getItems()[i].sId).css('backgroundImage', bankBg);
				}
				else if(walletController.paymentCards[i].creditCard != null){
					$('#'+paymentList.getItems()[i].sId).css('backgroundImage', creditBg);
				}else {
					$('#'+paymentList.getItems()[i].sId).css('backgroundImage', svaBg);
				}
			}
		}
		else{
			logError("template_missing","Payment card template missing","Payment card template missing");
		}
    },
    
//NEW PAYMENT INFO STUFF  DON'T TOUCH ABOVE CODE

    //Calls the controller that displays various payment options.
    addNewPaymentCard : function(){
    	if(addNewPaymentCardController == undefined)
    		addNewPaymentCardController = sap.ui.controller("app.ui.financialAccounts.addPaymentCard");
		addNewPaymentCardController.launchAddNewPaymentCard();
    },
    
    paymentCardSelected : function(ev){
    	if(makePrimaryCardController == undefined){
    		makePrimaryCardController = sap.ui.controller("app.ui.financialAccounts.makePrimaryCardController");
    	}
    	
    	var source = ev.getSource();
		var selectedCardDetails = source.getBindingContext().getProperty(source.getBindingContext().getPath());
    	makePrimaryCardController.cardSelected(selectedCardDetails);
    },
});

//Callback function for getWalletEntriesRequest
var paymentCardDetailsCallBack = function (response, status) {
	walletController.paymentCards = response.walletEntries;
	if (isRESTStatusCodeCorrect(response)){
		walletController.dataCards.cardDetails = response.walletEntries;
		//console.log(walletController.dataCards.cardDetails);
		//logic to set Primary Card
		for(var i=0; i<walletController.dataCards.cardDetails.length; i++){
			if(walletController.dataCards.cardDetails[i].creditPriority == 1){
				walletController.dataCards.cardDetails[i].isPrimary = true;
			}
			else{
				walletController.dataCards.cardDetails[i].isPrimary = false;
			}
		}
		
		//check if the response has any bank account : for makePrimaryCardController
		for(var i=0; i<walletController.dataCards.cardDetails.length; i++){
			if(walletController.dataCards.cardDetails[i].bankAccount != null){
				walletController.bankAccountPresent = true;
				break;
			}else{
				walletController.bankAccountPresent = false;
			}
		}
		
		walletModelList.setData(walletController.dataCards);
		
		SmartphoneService.getMemberCards(walletController.memberId, getWalletCards);
		
	}
	else{
		logTechnicalError("Error while retreiving the payment cards for the customer");
	}
	
};

function getWalletCards(response, status) {
	
	if (status != 200) {
		checkErrorStatus(status);
		return;
	}
	else if( isRESTStatusCodeCorrect(response) ) {
		var viewRef = app.getPage(WALLET_PAGE).getContent()[0];
		var viewId = viewRef.getId();
		
		/*if(userState.BRANDTYPE === "single") {
			var cardId = response.Cards[0].cardId;
			var membershipId = response.Cards[0].membershipId;
			var programName = response.Cards[0].programName;
			var programId = response.Cards[0].programId;
			
			if (cardController == undefined) {
				cardController = sap.ui.controller("app.ui.card.card");
			}

			//util.closeBusyDialog();
			cardController.launchCardPage(cardId, membershipId, programName, programId);
			return;
		}*/
		
		//go to wallet page
		app.to(WALLET_PAGE);
		
		$('#' + viewId + '--' + 'loyaltyCardsPlaceHolder').html('');
		
		//getting data from 
	
		walletController.dataCards = response.Cards;
		walletController.paymentCardTemplates = response.PaymentCardTemplates;
		var countCards = walletController.dataCards.length;
		for (var i = 0; i < countCards; i++) {
			if (walletController.dataCards[i].cardWalletTemplate != null) {
				var varProgramName="" ;
				if (walletController.dataCards[i].programName != null) {
					varProgramName = walletController.dataCards[i].programName.replace("'", "")
				}
				walletController.dataCards[i].cardWalletTemplate = util.decode(walletController.dataCards[i].cardWalletTemplate);
				walletController.dataCards[i].cardWalletTemplate = walletController.dataCards[i].cardWalletTemplate.replace("{action}", "showCard (" + walletController.dataCards[i].cardId + "," + walletController.dataCards[i].membershipId + ", '" + varProgramName + "'," + walletController.dataCards[i].programId + ")");
			   if (walletController.dataCards[i].membershipId == null)
				   walletController.dataCards[i].cardWalletTemplate = walletController.dataCards[i].cardWalletTemplate.replace("{cardName}",  walletController.dataCards[i].cardName  );
			   else
				   walletController.dataCards[i].cardWalletTemplate = walletController.dataCards[i].cardWalletTemplate.replace("{cardName}", varProgramName);
				$('#' + viewId + '--' + 'loyaltyCardsPlaceHolder').append(walletController.dataCards[i].cardWalletTemplate );
			// NEED NEW DIVIDER IMAGE	
				$('#' + viewId + '--' + 'loyaltyCardsPlaceHolder').append('<Div class="walletDividerWrapper">   <img class="walletDivider" src="app/ui/wallet/images/wallet-slot.png" />    </Div >');
			
			}
		}
		
		walletController.assignBackground()
		
		util.closeBusyDialog();
	}
	else {
		checkErrorMobiliserStatus(response);
	}	

};

function addCard() {
	if(userState['DEMO_MODE'] == true) {
		logError("demo_mode_message", "In Demo Mode", "Not Supported In Demo Mode");
		return;
	}
    if (cardPickerController == undefined)//TODO(jie) !!!memory leak potential, creating unlimited circle
        cardPickerController = sap.ui.controller("app.ui.cardPicker.cardPicker");
    cardPickerController.launchCardPickerPage();
};
 
function showCard(cardID, membershipId, programName ,programId) {
    if (cardController == undefined) {
        cardController = sap.ui.controller("app.ui.card.card");
    }
    cardController.launchCardPage(cardID, membershipId, programName, programId);
}



