/*!
 * SAP UI development toolkit for HTML5 (SAPUI5)
 * 
 * (c) Copyright 2009-2013 SAP AG. All rights reserved
 */
jQuery.sap.declare("sap.m.ActionSheet");jQuery.sap.require("sap.m.library");jQuery.sap.require("sap.ui.core.Control");sap.ui.core.Control.extend("sap.m.ActionSheet",{metadata:{publicMethods:["openBy","close","isOpen"],library:"sap.m",properties:{"placement":{type:"sap.m.PlacementType",group:"Appearance",defaultValue:sap.m.PlacementType.Bottom},"showCancelButton":{type:"boolean",group:"Appearance",defaultValue:true},"cancelButtonText":{type:"string",group:"Appearance",defaultValue:null},"title":{type:"string",group:"Appearance",defaultValue:null}},aggregations:{"buttons":{type:"sap.m.Button",multiple:true,singularName:"button"},"_cancelButton":{type:"sap.m.Button",multiple:false,visibility:"hidden"}},events:{"cancelButtonTap":{},"beforeOpen":{},"afterOpen":{},"beforeClose":{},"afterClose":{}}}});sap.m.ActionSheet.M_EVENTS={'cancelButtonTap':'cancelButtonTap','beforeOpen':'beforeOpen','afterOpen':'afterOpen','beforeClose':'beforeClose','afterClose':'afterClose'};jQuery.sap.require("sap.m.Dialog");jQuery.sap.require("sap.m.Popover");
sap.m.ActionSheet.prototype.exit=function(){if(this._parent){this._parent.destroy();this._parent=null}if(this._oCancelButton){this._oCancelButton.destroy();this._oCancelButton=null}};
sap.m.ActionSheet.prototype.openBy=function(c){var t=this;if(!this._parent){if(jQuery.device.is.ipad||(sap.m.Dialog._bOneDesign&&!jQuery.device.is.phone)){this._parent=new sap.m.Popover({placement:this.getPlacement(),showHeader:false,content:[this],beforeOpen:function(){t.fireBeforeOpen()},afterOpen:function(){t.fireAfterOpen()},beforeClose:function(){t.fireBeforeClose()},afterClose:function(){if(t.getShowCancelButton()){t.fireCancelButtonTap()}t.fireAfterClose()}}).addStyleClass("sapMActionSheetPopover");if(jQuery.browser.msie){this._parent._fSetArrowPosition=jQuery.proxy(function(){sap.m.Popover.prototype._setArrowPosition.apply(this);var $=this.$(),C=$.children(".sapMPopoverCont")[0].getBoundingClientRect().width;jQuery.each($.find(".sapMActionSheet > .sapMBtn"),function(i,b){var a=jQuery(b),B;a.css("width","");B=b.getBoundingClientRect().width;if(B<=C){a.css("width","100%")}})},this._parent)}}else{this._parent=new sap.m.Dialog({title:this.getTitle(),type:sap.m.DialogType.Standard,content:[this],beforeOpen:function(){t.fireBeforeOpen()},afterOpen:function(){t.fireAfterOpen()},beforeClose:function(e){t.fireBeforeClose({origin:e.getParameter("origin")})},afterClose:function(e){t.fireAfterClose({origin:e.getParameter("origin")})}}).addStyleClass("sapMActionSheetDialog");if(this.getTitle()){this._parent.addStyleClass("sapMActionSheetDialogWithTitle")}if(!(jQuery.device.is.iphone||(sap.m.Dialog._bOneDesign&&jQuery.device.is.phone))){this._parent.setLeftButton(this._getCancelButton())}if(jQuery.device.is.iphone||(sap.m.Dialog._bOneDesign&&jQuery.device.is.phone)){this._parent.oPopup.setModal(true);this._parent._setDimensions=function(){var $=this.$(),a=jQuery.sap.byId(this.getId()+"-cont");$.css({"width":"100%","max-height":"100%","bottom":"","left":"0px"});a.css("max-height","")};function g(y){return"translate3d(0px, "+(y>0?y:0)+"px, 0px)"};this._parent._openAnimation=function($,r,o){var a=jQuery(window),w=a.height(),s=g(w);$.css({"top":"","-webkit-transform":s,"transform":s,"display":"block"});$.bind("webkitTransitionEnd transitionend",function(){jQuery(this).unbind("webkitTransitionEnd transitionend");$.removeClass("sapMDialogSliding");o()});setTimeout(function(){var T=w-$.outerHeight(),e=g(T);$.css({"-webkit-transform":e,"transform":e}).addClass("sapMDialogSliding").removeClass("sapMDialogHidden")},0)};this._parent._closeAnimation=function($,r,C){var a=jQuery(window),T=g(a.height());$.bind("webkitTransitionEnd transitionend",function(){jQuery(this).unbind("webkitTransitionEnd transitionend");$.removeClass("sapMDialogSliding");C()});$.css({"-webkit-transform":T,"transform":T}).addClass("sapMDialogSliding")};this._parent.oPopup.setAnimations(jQuery.proxy(this._parent._openAnimation,this._parent),jQuery.proxy(this._parent._closeAnimation,this._parent));this._parent._adjustScrollingPane=function(){var $=this.$(),h=$.height(),H=$.children("header.sapMBar").outerHeight(true),a=jQuery.sap.byId(this.getId()+"-cont");a.css("max-height",h-H);this._oScroller.refresh()};this._parent._fOrientationChange=jQuery.proxy(function(){this._setDimensions();var $=jQuery(window),w=$.height(),a=this.$(),T=w-a.outerHeight(),s=g(T),b=jQuery.sap.byId(this.getId()+"-cont");a.css({"-webkit-transform":s,"transform":s});this._adjustScrollingPane()},this._parent)}}}if(jQuery.device.is.ipad||(sap.m.Dialog._bOneDesign&&!jQuery.device.is.phone)){this._parent.openBy(c)}else{this._parent.open()}};
sap.m.ActionSheet.prototype.close=function(c){if(this._parent){this._parent.close()}};
sap.m.ActionSheet.prototype.isOpen=function(c){return!!this._parent&&this._parent.isOpen()};
sap.m.ActionSheet.prototype._createCancelButton=function(){if(!this._oCancelButton){var c=(this.getCancelButtonText())?this.getCancelButtonText():sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACTIONSHEET_CANCELBUTTON_TEXT"),t=this;this._oCancelButton=new sap.m.Button(this.getId()+'-cancelBtn',{text:c,type:sap.m.ButtonType.Transparent,tap:function(){if(!(jQuery.device.is.ipad||(sap.m.Dialog._bOneDesign&&!jQuery.device.is.phone))&&t._parent){t._parent._oCloseTrigger=this}t.close();t.fireCancelButtonTap()}}).addStyleClass("sapMActionSheetButton sapMActionSheetCancelButton sapMBtnTransparent");if(jQuery.device.is.iphone||(sap.m.Dialog._bOneDesign&&jQuery.device.is.phone)){this.setAggregation("_cancelButton",this._oCancelButton,true)}}return this};
sap.m.ActionSheet.prototype._getCancelButton=function(){if(!(jQuery.device.is.ipad||(sap.m.Dialog._bOneDesign&&!jQuery.device.is.phone))&&this.getShowCancelButton()){this._createCancelButton();return this._oCancelButton}return null};
sap.m.ActionSheet.prototype._preProcessActionButton=function(b){var t=this,T=b.getType();if(sap.m.Dialog._bOneDesign){if(T!==sap.m.ButtonType.Accept&&T!==sap.m.ButtonType.Reject){b.setType(sap.m.ButtonType.Transparent)}}b.addDelegate({ontap:function(){if(!(jQuery.device.is.ipad||(sap.m.Dialog._bOneDesign&&!jQuery.device.is.phone))){t._parent._oCloseTrigger=this}t.close()}},true);return this};
sap.m.ActionSheet.prototype.setShowCancelButton=function(v){if(this._parent){if(jQuery.device.is.iphone||(sap.m.Dialog._bOneDesign&&jQuery.device.is.phone)){this.setProperty("showCancelButton",v,false)}else if(!sap.m.Dialog._bOneDesign&&!jQuery.os.ios){this.setProperty("showCancelButton",v,true);this._parent.setLeftButton(this._getCancelButton())}}else{this.setProperty("showCancelButton",v,true)}return this};
sap.m.ActionSheet.prototype.setTitle=function(t){this.setProperty("title",t,true);if(this._parent&&!(jQuery.device.is.ipad||(sap.m.Dialog._bOneDesign&&!jQuery.device.is.phone))){this._parent.setTitle(t)}if(this._parent){if(t){this._parent.addStyleClass("sapMActionSheetDialogWithTitle")}else{this._parent.removeStyleClass("sapMActionSheetDialogWithTitle")}}return this};
sap.m.ActionSheet.prototype.setPlacement=function(p){this.setProperty("placement",p,true);if(jQuery.device.is.ipad||(sap.m.Dialog._bOneDesign&&!jQuery.device.is.phone)){if(this._parent){this._parent.setPlacement(p)}}return this};
