/*!
 * SAP UI development toolkit for HTML5 (SAPUI5)
 * 
 * (c) Copyright 2009-2013 SAP AG. All rights reserved
 */
jQuery.sap.declare("sap.m.BusyDialog");jQuery.sap.require("sap.m.library");jQuery.sap.require("sap.ui.core.Control");sap.ui.core.Control.extend("sap.m.BusyDialog",{metadata:{publicMethods:["open","close"],library:"sap.m",properties:{"text":{type:"string",group:"Appearance",defaultValue:null},"title":{type:"string",group:"Appearance",defaultValue:null},"customIcon":{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},"customIconRotationSpeed":{type:"int",group:"Appearance",defaultValue:1000},"customIconDensityAware":{type:"boolean",group:"",defaultValue:true},"customIconWidth":{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},"customIconHeight":{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},"cancelButtonText":{type:"string",group:"Misc",defaultValue:null},"showCancelButton":{type:"boolean",group:"Appearance",defaultValue:false}},aggregations:{"_busyLabel":{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},events:{"close":{}}}});sap.m.BusyDialog.M_EVENTS={'close':'close'};jQuery.sap.require("sap.ui.core.Popup");jQuery.sap.require("sap.ui.core.theming.Parameters");
sap.m.BusyDialog.prototype.init=function(){var t=this;this._$window=jQuery(window);this._isPlatformDependent=sap.ui.core.theming.Parameters.get("sapMPlatformDependent")=="true";this._oLabel=new sap.m.Label(this.getId()+"-busyLabel",{}).addStyleClass("sapMBusyDialogLabel");this.setAggregation("_busyLabel",this._oLabel,true);this.iOldWinHeight=0;this._oPopup=new sap.ui.core.Popup();(jQuery.os.ios&&this._isPlatformDependent)?this._oPopup.setShadow(true):this._oPopup.setShadow(false);this._oPopup.setModal(true,'sapMDialogBLyInit');this._oPopup.setAnimations(this.openAnimation,this.closeAnimation);this._fOrientationChange=jQuery.proxy(this._reposition,this);this._oPopup._applyPosition=function(p){t._setDimensions();sap.ui.core.Popup.prototype._applyPosition.call(this,p)};this._oPopup._showBlockLayer=function(){sap.ui.core.Popup.prototype._showBlockLayer.call(this);var b=jQuery("#sap-ui-blocklayer-popup"),B;b.toggleClass("sapMDialogBLyInit",true);if(!jQuery.os.ios&&this._isPlatformDependent){B=jQuery("#sap-ui-blocklayer-popup-bar");b.css('top','48px');if(B.length===0){var c="sapUiBLy"+(this._sModalCSSClass?" "+this._sModalCSSClass:"")+' sapUiBLyBar';var B=jQuery("<div id=\"sap-ui-blocklayer-popup-bar\" tabindex=\"0\" class=\""+c+"\" style=\"display:block; z-index:"+b.css('z-index')+"; visibility:visible\"></div>");B.insertBefore(t.$())}else{var B=jQuery("#sap-ui-blocklayer-popup-bar");B.css({"z-index":b.css('z-index'),"visibility":"visible","display":"block"})}}};this._oPopup._hideBlockLayer=function(){var b=jQuery("#sap-ui-blocklayer-popup");var B=jQuery("#sap-ui-blocklayer-popup-bar");B.css({'visibility':'','display':'none'});b.toggleClass('sapMDialogBLyInit',false);b.css("top","");sap.ui.core.Popup.prototype._hideBlockLayer.call(this)}};
sap.m.BusyDialog.prototype.openAnimation=function(r,R,o){if(jQuery.os.ios&&this._isPlatformDependent){r.css('display','block');r.bind("webkitAnimationEnd animationend",function(){jQuery(this).unbind("webkitAnimationEnd animationend");o()});r.css('-webkit-animation-name','sapMDialogBounce').css('animation-name','sapMDialogBounce')}else{o()}};
sap.m.BusyDialog.prototype.closeAnimation=function(r,R,c){c()};
sap.m.BusyDialog.prototype.exit=function(){this._oPopup.close();this._oPopup.destroy();this._oPopup=null;if(this._oLabel){this._oLabel.destroy();this._oLabel=null}if(this._oButton){this._oButton.destroy();this._oButton=null}if(this._busyIndicator){this._busyIndicator.destroy();this._busyIndicator=null}this._$window.unbind("resize",this._fOrientationChange)};
sap.m.BusyDialog.prototype.open=function(){jQuery.sap.log.debug("sap.m.BusyDialog.open called at "+new Date().getTime());var p=this._oPopup;if(p.isOpen()){return this}p.setContent(this);p.attachEvent(sap.ui.core.Popup.M_EVENTS.opened,this._handleOpened,this);p.setPosition("center center","center center",document,"0 0","fit");this._bOpenRequested=true;this._openNowIfPossibleAndRequested();return this};
sap.m.BusyDialog.prototype._openNowIfPossibleAndRequested=function(){if(!this._bOpenRequested){return}if(!document.body||!sap.ui.getCore().isInitialized()){jQuery.sap.delayedCall(50,this,"_openNowIfPossibleAndRequested");return}this._bOpenRequested=false;this._oPopup.open()};
sap.m.BusyDialog.prototype.close=function(){this._bOpenRequested=false;var p=this._oPopup;var e=this._oPopup.getOpenState();if(!(e===sap.ui.core.OpenState.CLOSED||e===sap.ui.core.OpenState.CLOSING)){p.attachEvent(sap.ui.core.Popup.M_EVENTS.closed,this._handleClosed,this);jQuery.sap.log.debug("sap.m.BusyDialog.close called at "+new Date().getTime());p.close();this.fireClose()}return this};
sap.m.BusyDialog.prototype.setText=function(t){this.setProperty("text",t,true);this._oLabel.setText(t)};
sap.m.BusyDialog.prototype._reposition=function(){var e=this._oPopup.getOpenState();if(!(e===sap.ui.core.OpenState.OPEN)){return}this._oPopup._applyPosition(this._oPopup._oLastPosition)};
sap.m.BusyDialog.prototype._handleOpened=function(){this._oPopup.detachEvent(sap.ui.core.Popup.M_EVENTS.opened,this._handleOpened,this);this._$window.bind("resize",this._fOrientationChange)};
sap.m.BusyDialog.prototype._handleClosed=function(){this._oPopup.detachEvent(sap.ui.core.Popup.M_EVENTS.closed,this._handleClosed,this);this._$window.unbind("resize",this._fOrientationChange)};
sap.m.BusyDialog.prototype._setDimensions=function(){var w=(jQuery.os.ios||!this._isPlatformDependent)?this._$window.height():(this._$window.height()-50);var $=this.$();;$.css({"left":"0px","top":"0px","max-height":this._$window.height()+"px"});if(w<=this.iOldWinHeight){if(!this.$().hasClass("sapMBsyDSmall")){this._checkSize(w)}}if(w>this.iOldWinHeight){if((this.$().hasClass("sapMBsyDSmall"))){this._checkSize(w)}}if(this.iOldWinHeight==0){this._checkSize(w)}this.iOldWinHeight=(jQuery.os.ios||!this._isPlatformDependent)?this._$window.height():(this._$window.height()-50)};
sap.m.BusyDialog.prototype._checkSize=function(w){if(w<this.$()[0].scrollHeight){this.$().toggleClass("sapMBsyDSmall",true);if(!jQuery.os.ios&&this._isPlatformDependent){this.$().css("width",this._$window.width()*0.7)}}else{this.$().toggleClass("sapMBsyDSmall",false);if(!jQuery.os.ios&&!this._isPlatformDependent){this.$().css("width","18.75em")}}};
