/*!
 * SAP UI development toolkit for HTML5 (SAPUI5)
 * 
 * (c) Copyright 2009-2013 SAP AG. All rights reserved
 */
jQuery.sap.declare("sap.m.Dialog");jQuery.sap.require("sap.m.library");jQuery.sap.require("sap.ui.core.Control");sap.ui.core.Control.extend("sap.m.Dialog",{metadata:{publicMethods:["open","close","isOpen"],library:"sap.m",properties:{"icon":{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},"title":{type:"string",group:"Appearance",defaultValue:null},"type":{type:"sap.m.DialogType",group:"Appearance",defaultValue:sap.m.DialogType.Standard},"state":{type:"sap.ui.core.ValueState",group:"Appearance",defaultValue:sap.ui.core.ValueState.None},"stretchOnPhone":{type:"boolean",group:"Appearance",defaultValue:false}},defaultAggregation:"content",aggregations:{"content":{type:"sap.ui.core.Control",multiple:true,singularName:"content"},"_header":{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},"_leftButton":{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},"_rightButton":{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},"_title":{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},"_icon":{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{"leftButton":{type:"sap.m.Button",multiple:false},"rightButton":{type:"sap.m.Button",multiple:false}},events:{"beforeOpen":{},"afterOpen":{},"beforeClose":{},"afterClose":{}}}});sap.m.Dialog.M_EVENTS={'beforeOpen':'beforeOpen','afterOpen':'afterOpen','beforeClose':'beforeClose','afterClose':'afterClose'};jQuery.sap.require("sap.ui.core.Popup");jQuery.sap.require("sap.m.Bar");jQuery.sap.require("sap.ui.core.delegate.ScrollEnablement");jQuery.sap.require("sap.m.InstanceManager");jQuery.sap.require("sap.ui.core.IconPool");jQuery.sap.require("sap.ui.core.theming.Parameters");jQuery.sap.require("sap.ui.core.ValueState");sap.m.Dialog._bOneDesign=(sap.ui.core.theming.Parameters.get("sapMPlatformDependent")!=='true');sap.m.Dialog._mStateClasses={};sap.m.Dialog._mStateClasses[sap.ui.core.ValueState.None]="";sap.m.Dialog._mStateClasses[sap.ui.core.ValueState.Success]="sapMDialogSuccess";sap.m.Dialog._mStateClasses[sap.ui.core.ValueState.Warning]="sapMDialogWarning";sap.m.Dialog._mStateClasses[sap.ui.core.ValueState.Error]="sapMDialogError";sap.m.Dialog._mIcons={};sap.m.Dialog._mIcons[sap.ui.core.ValueState.Success]=sap.ui.core.IconPool.getIconURI("accept");sap.m.Dialog._mIcons[sap.ui.core.ValueState.Warning]=sap.ui.core.IconPool.getIconURI("warning2");sap.m.Dialog._mIcons[sap.ui.core.ValueState.Error]=sap.ui.core.IconPool.getIconURI("alert");
sap.m.Dialog.prototype.init=function(){var t=this;this._firstOpen=true;this._externalIcon=undefined;this._sResizeListenerId=null;this._$window=jQuery(window);if(sap.m.Dialog._bOneDesign){this._createHeader()}this.oPopup=new sap.ui.core.Popup();this.oPopup.setShadow(true);if(jQuery.device.is.iphone&&!this._bMessageType){this.oPopup.setModal(true,"sapMDialogTransparentBlk")}else{this.oPopup.setModal(true,"sapMDialogBlockLayerInit")}if(jQuery.os.ios||(jQuery.os.android&&jQuery.os.fVersion>2.4)){this.oPopup.setAnimations(jQuery.proxy(this._openAnimation,this),jQuery.proxy(this._closeAnimation,this))}this._fOrientationChange=jQuery.proxy(this._reposition,this);this.oPopup._applyPosition=function(p){var $=t.$();if(!jQuery.device.is.iphone&&t.oPopup.getOpenState()===sap.ui.core.OpenState.OPEN){$.css("visibility","hidden")}t._setDimensions();t._adjustScrollingPane();sap.ui.core.Popup.prototype._applyPosition.call(this,p);if(!jQuery.device.is.iphone&&t.oPopup.getOpenState()===sap.ui.core.OpenState.OPEN){$.css("visibility","visible")}};this._oScroller=new sap.ui.core.delegate.ScrollEnablement(this,this.getId()+"-scroll",{horizontal:false,vertical:true,zynga:false,preventDefault:false,nonTouchScrolling:"scrollbar"})};
sap.m.Dialog.prototype.onBeforeRendering=function(){if(this._sResizeListenerId){sap.ui.core.ResizeHandler.deregister(this._sResizeListenerId);this._sResizeListenerId=null}};
sap.m.Dialog.prototype.exit=function(){if(this._sResizeListenerId){sap.ui.core.ResizeHandler.deregister(this._sResizeListenerId);this._sResizeListenerId=null}this._$window.unbind("resize",this._fOrientationChange);if(this.oPopup){this.oPopup.destroy();this.oPopup=null}if(this._oScroller){this._oScroller.destroy();this._oScroller=null}if(this._header){this._header.destroy();this._header=null}if(this._headerTitle){this._headerTitle.destroy();this._headerTitle=null}if(this._iconImage){this._iconImage.destroy();this._iconImage=null}};
sap.m.Dialog.prototype.open=function(){var p=this.oPopup;if(p.isOpen()){return this}this._oCloseTrigger=null;var $=jQuery("#sap-ui-blocklayer-popup");if($.length>0){var t=jQuery.device.is.iphone&&!this._bMessageType&&!this.hasStyleClass("sapMActionSheetDialog");$.toggleClass("sapMDialogTransparentBlk",t);$.toggleClass("sapMDialogBlockLayerInit",!t)}this.fireBeforeOpen();p.attachEvent(sap.ui.core.Popup.M_EVENTS.opened,this._handleOpened,this);p.setContent(this);if(!sap.m.Dialog._bOneDesign&&jQuery.device.is.iphone&&!this._bMessageType){p.setPosition("center top","center bottom",document,"0 0","fit")}else{p.setPosition("center center","center center",document,"0 0","fit")}p.open();if(!this._sResizeListenerId){this._sResizeListenerId=sap.ui.core.ResizeHandler.register(jQuery.sap.domById(this.getId()+"-scroll"),this._fOrientationChange)}sap.m.InstanceManager.addDialogInstance(this);return this};
sap.m.Dialog.prototype.close=function(){var p=this.oPopup;var e=this.oPopup.getOpenState();if(!(e===sap.ui.core.OpenState.CLOSED||e===sap.ui.core.OpenState.CLOSING)){this.fireBeforeClose({origin:this._oCloseTrigger});p.attachEvent(sap.ui.core.Popup.M_EVENTS.closed,this._handleClosed,this);p.close()}return this};
sap.m.Dialog.prototype.isOpen=function(){return this.oPopup&&this.oPopup.isOpen()};
sap.m.Dialog.prototype._handleOpened=function(){this.oPopup.detachEvent(sap.ui.core.Popup.M_EVENTS.opened,this._handleOpened,this);this._$window.bind("resize",this._fOrientationChange);this.fireAfterOpen();this._firstOpen=false};
sap.m.Dialog.prototype._handleClosed=function(){this.oPopup.detachEvent(sap.ui.core.Popup.M_EVENTS.closed,this._handleClosed,this);if(this._sResizeListenerId){sap.ui.core.ResizeHandler.deregister(this._sResizeListenerId);this._sResizeListenerId=null}this._$window.unbind("resize",this._fOrientationChange);sap.m.InstanceManager.removeDialogInstance(this);this.fireAfterClose({origin:this._oCloseTrigger})};
sap.m.Dialog.prototype._openAnimation=function(r,R,o){r.css("display","block");if(!sap.m.Dialog._bOneDesign&&jQuery.device.is.iphone&&!this._bMessageType){r.addClass("sapMDialogBottom").removeClass("sapMDialogHidden");window.setTimeout(function(){r.bind("webkitTransitionEnd transitionend",function(){jQuery(this).unbind("webkitTransitionEnd transitionend");r.removeClass("sapMDialogSliding");o()});r.addClass("sapMDialogSliding").removeClass("sapMDialogBottom")},0)}else{r.bind("webkitAnimationEnd animationend",function(){jQuery(this).unbind("webkitTransitionEnd transitionend");o();r.removeClass("sapMDialogOpening")});r.addClass("sapMDialogOpening")}};
sap.m.Dialog.prototype._closeAnimation=function(r,R,c){if(!sap.m.Dialog._bOneDesign&&jQuery.device.is.iphone&&!this._bMessageType){r.bind("webkitTransitionEnd transitionend",function(){jQuery(this).unbind("webkitTransitionEnd transitionend");r.addClass("sapMDialogHidden").removeClass("sapMDialogBottom").removeClass("sapMDialogSliding");c()});r.addClass("sapMDialogSliding").addClass("sapMDialogBottom")}else{if(sap.m.Dialog._bOneDesign||!jQuery.os.ios){r.bind("webkitAnimationEnd animationend",function(){jQuery(this).unbind("webkitTransitionEnd transitionend");c();r.removeClass("sapMDialogClosing")});r.addClass("sapMDialogClosing")}else{c()}}};
sap.m.Dialog.prototype._setDimensions=function(){this._$window=jQuery(window);var w=this._$window.width(),W=this._$window.height(),$=this.$(),s=this.getStretchOnPhone(),h=jQuery.device.is.phone?64:128,v=16,p=window.parseInt($.css("padding-left"),10),P=window.parseInt($.css("padding-right"),10),i=window.parseInt($.css("padding-top"),10),a=window.parseInt($.css("padding-bottom"),10),m=w-h-p-P,M=W-v-i-a,b=jQuery.sap.byId(this.getId()+"-cont");$.css({"width":"","height":"","min-width":"","max-width":"","left":"0px","top":"0px","right":"","bottom":"","max-height":""});b.css("max-height","");if(jQuery.device.is.tablet||jQuery.device.is.desktop){$.css({"min-width":"400px","max-width":m+"px","max-height":M+"px"})}else{if(!sap.m.Dialog._bOneDesign&&jQuery.device.is.iphone&&!this._bMessageType){$.css({width:"100%",height:"100%"})}else{if(sap.m.Dialog._bOneDesign&&s){$.css({"right":"0px","bottom":"0px","max-height":W+"px"})}else{if(jQuery.device.is.portrait){$.css({"width":m+"px","max-height":M+"px"})}else{$.css({"min-width":W+"px","max-width":m+"px","max-height":M+"px"})}}}}};
sap.m.Dialog.prototype._adjustScrollingPane=function(){var $=this.$(),a=jQuery.sap.byId(this.getId()+"-cont"),c=window.parseInt(a.css("padding-top"),10),C=window.parseInt(a.css("padding-bottom"),10),b=jQuery.sap.byId(this.getId()+"-scroll"),s=b.css("position")==="absolute",m=s?window.parseInt($.css("max-height"),10):$.height(),S=this.getStretchOnPhone(),h,f,M,i;if(!sap.m.Dialog._bOneDesign&&jQuery.os.ios&&!this._bMessageType){h=$.children(".sapMBar").outerHeight(true);f=0}else{h=$.children("header").outerHeight(true);f=$.children("footer").outerHeight(true)}M=m-h-f-c-C;if(s){b.css("width","100%");i=b.outerHeight(true);if(sap.m.Dialog._bOneDesign&&S&&jQuery.device.is.phone){a.css("height",M)}else{a.css("height",Math.min(M,i))}}else{a.css(((sap.m.Dialog._bOneDesign&&S&&jQuery.device.is.phone)||(!sap.m.Dialog._bOneDesign&&jQuery.device.is.iphone&&!this._bMessageType))?"height":"max-height",M+"px")}this._oScroller.refresh()};
sap.m.Dialog.prototype._reposition=function(){var t=this;var e=this.oPopup.getOpenState();if(e!==sap.ui.core.OpenState.OPEN||this._sAvoidRepeatTimer){return}if(jQuery.support.touch&&jQuery.os.ios&&jQuery.os.fVersion>=6){this._sAvoidRepeatTimer=window.setTimeout(function(){t._sAvoidRepeatTimer=null},50)}this.oPopup._applyPosition(this.oPopup._oLastPosition)};
sap.m.Dialog.prototype._createHeader=function(){if(sap.m.Dialog._bOneDesign||(jQuery.os.ios&&!this._bMessageType)){if(!this._header){this._header=new sap.m.Bar(this.getId()+"-header").addStyleClass("sapMHeader-CTX");this.setAggregation("_header",this._header,false)}}};
sap.m.Dialog.prototype._getHeader=function(){if(!sap.m.Dialog._bOneDesign&&!this.getTitle()&&!this.getLeftButton()&!this.getRightButton()){return null}this._createHeader();return this._header};
sap.m.Dialog.prototype._initBlockLayerAnimation=function(){if(!sap.m.Dialog._bOneDesign&&(!jQuery.device.is.iphone||this._bMessageType)){this.oPopup._showBlockLayer=function(){sap.ui.core.Popup.prototype._showBlockLayer.call(this);var $=jQuery("#sap-ui-blocklayer-popup");if(jQuery.os.ios){$.addClass('sapMDialogBLyInit')}else{$.addClass("sapMDialogBlockLayerAnimation");setTimeout(function(){$.addClass("sapMDialogBlockLayer")},0)}};this.oPopup._hideBlockLayer=function(){var $=jQuery("#sap-ui-blocklayer-popup"),t=this;if(sap.ui.core.Popup.blStack.length>1){sap.ui.core.Popup.prototype._hideBlockLayer.call(t)}else{$.removeClass('sapMDialogBlockLayerInit');if(jQuery.os.ios){$.removeClass("sapMDialogBLyInit");sap.ui.core.Popup.prototype._hideBlockLayer.call(t)}else{$.removeClass("sapMDialogBlockLayer");$.bind("webkitTransitionEnd transitionend",function(){jQuery(this).unbind("webkitTransitionEnd transitionend");sap.ui.core.Popup.prototype._hideBlockLayer.call(t);$.removeClass("sapMDialogBlockLayerAnimation")})}}}}else{this.oPopup._hideBlockLayer=function(){var $=jQuery("#sap-ui-blocklayer-popup");$.removeClass("sapMDialogTransparentBlk");sap.ui.core.Popup.prototype._hideBlockLayer.call(this)}}};
sap.m.Dialog.prototype._clearBlockLayerAnimation=function(){if(jQuery.device.is.iphone&&!this._bMessageType){delete this.oPopup._showBlockLayer;this.oPopup._hideBlockLayer=function(){var $=jQuery("#sap-ui-blocklayer-popup");$.removeClass("sapMDialogTransparentBlk");sap.ui.core.Popup.prototype._hideBlockLayer.call(this)}}};
sap.m.Dialog.prototype.getScrollDelegate=function(){return this._oScroller};
sap.m.Dialog.prototype.setLeftButton=function(b){var t=this;if(typeof(b)==="string"){b=sap.ui.getCore().byId(b)}var o=this.getLeftButton();if(b&&o===b.getId()){return this}if(!this._oLeftButtonDelegate){this._oLeftButtonDelegate={ontap:function(){t._oCloseTrigger=this}}}if(o){o=sap.ui.getCore().byId(o);o.removeDelegate(this._oLeftButtonDelegate)}if(b){b.addDelegate(this._oLeftButtonDelegate,true,b);if(sap.m.Dialog._bOneDesign){if(!(b.getType()===sap.m.ButtonType.Accept||b.getType()===sap.m.ButtonType.Reject)){b.setType(sap.m.ButtonType.Transparent)}}}if(!sap.m.Dialog._bOneDesign&&jQuery.os.ios&&!this._bMessageType){this._createHeader();if(b){if(o){this._header.removeAggregation("contentLeft",o,true)}this._header.addAggregation("contentLeft",b,true);this._header.invalidate()}else{if(o){this._header.removeContentLeft(o)}}}else{if(b){this.setAggregation("_leftButton",b)}else{if(o){this.removeAggregation("_leftButton",o)}}}return this.setAssociation("leftButton",b,!sap.m.Dialog._bOneDesign&&jQuery.os.ios&&!this._bMessageType)};
sap.m.Dialog.prototype.setRightButton=function(b){var t=this;if(typeof(b)==="string"){b=sap.ui.getCore().byId(b)}var o=this.getRightButton();if(b&&o===b.getId()){return this}if(!this._oRightButtonDelegate){this._oRightButtonDelegate={ontap:function(){t._oCloseTrigger=this}}}if(o){o=sap.ui.getCore().byId(o);o.removeDelegate(this._oRightButtonDelegate)}if(b){b.addDelegate(this._oRightButtonDelegate,true,b);if(sap.m.Dialog._bOneDesign){if(!(b.getType()===sap.m.ButtonType.Accept||b.getType()===sap.m.ButtonType.Reject)){b.setType(sap.m.ButtonType.Transparent)}}}if(!sap.m.Dialog._bOneDesign&&jQuery.os.ios&&!this._bMessageType){this._createHeader();if(b){if(o){this._header.removeAggregation("contentRight",o,true)}this._header.addAggregation("contentRight",b,true);this._header.invalidate()}else{if(o){this._header.removeContentRight(o)}}}else{if(b){this.setAggregation("_rightButton",b)}else{if(o){this.removeAggregation("_leftButton",o)}}}this.setAssociation("rightButton",b,!sap.m.Dialog._bOneDesign&&jQuery.os.ios&&!this._bMessageType);return this};
sap.m.Dialog.prototype.setTitle=function(t){this.setProperty("title",t,true);if(this._headerTitle){this._headerTitle.setText(t)}else{this._headerTitle=new sap.m.Label(this.getId()+"-title",{text:t}).addStyleClass("sapMDialogTitle");if(sap.m.Dialog._bOneDesign||(jQuery.os.ios&&!this._bMessageType)){this._createHeader();this._header.addContentMiddle(this._headerTitle)}else{this.setAggregation("_title",this._headerTitle)}}return this};
sap.m.Dialog.prototype.setState=function(s){var f={},$=this.$(),n;f[s]=true;this.setProperty("state",s,true);if(sap.m.Dialog._bOneDesign){for(n in sap.m.Dialog._mStateClasses){$.toggleClass(sap.m.Dialog._mStateClasses[n],!!f[n])}this.setIcon(sap.m.Dialog._mIcons[s],true)}};
sap.m.Dialog.prototype.setIcon=function(i,I){if(!I){this._externalIcon=i}else{if(this._externalIcon){i=this._externalIcon}}if(sap.m.Dialog._bOneDesign||!jQuery.os.ios){if(i){if(i!==this.getIcon()){if(this._iconImage){this._iconImage.setSrc(i)}else{this._iconImage=sap.ui.core.IconPool.createControlByURI({id:this.getId()+"-icon",src:i},sap.m.Image).addStyleClass("sapMDialogIcon");if(sap.m.Dialog._bOneDesign){this._createHeader();this._header.insertAggregation("contentMiddle",this._iconImage,0)}else{this.setAggregation("_icon",this._iconImage)}}}}else{var d=this.getState();if(!I&&d!==sap.ui.core.ValueState.None&&sap.m.Dialog._bOneDesign){if(this._iconImage){this._iconImage.setSrc(sap.m.Dialog._mIcons[d])}}else{if(this._iconImage){this._iconImage.destroy();this._iconImage=null}}}}this.setProperty("icon",i,true);return this};
sap.m.Dialog.prototype.setType=function(t){if(!sap.m.Dialog._bOneDesign){var o=this.getType();var $=jQuery("#sap-ui-blocklayer-popup");if(o===t){return}this._bMessageType=(t===sap.m.DialogType.Message);if(jQuery.device.is.iphone){if(this._bMessageType){if($.length===0){this.oPopup.setModal(true,"sapMDialogBlockLayerInit")}else{$.removeClass("sapMDialogTransparentBlk").addClass("sapMDialogBlockLayerInit");if(this.oPopup.isOpen()){$.addClass("sapMBusyBLyInit sapMBusyBLyShown")}}this.oPopup.setPosition("center center","center center",document,"0 0","fit");this._initBlockLayerAnimation()}else{if($.length===0){this.oPopup.setModal(true,"sapMDialogTransparentBlk")}else{$.removeClass("sapMBusyBLyShown sapMBusyBLyInit").addClass("sapMDialogTransparentBlk")}this.oPopup.setPosition("center top","center bottom",document,"0 0","fit");this._clearBlockLayerAnimation()}}}return this.setProperty("type",t,false)};
sap.m.Dialog.prototype.forceInvalidate=sap.ui.core.Control.prototype.invalidate;
sap.m.Dialog.prototype.invalidate=function(o){if(!this._firstOpen){this.forceInvalidate()}};
