/*!
 * SAP UI development toolkit for HTML5 (SAPUI5)
 * 
 * (c) Copyright 2009-2013 SAP AG. All rights reserved
 */
jQuery.sap.declare("sap.m.ListItemBase");jQuery.sap.require("sap.m.library");jQuery.sap.require("sap.ui.core.Control");sap.ui.core.Control.extend("sap.m.ListItemBase",{metadata:{publicMethods:["isSelected"],library:"sap.m",properties:{"type":{type:"sap.m.ListType",group:"Misc",defaultValue:sap.m.ListType.Inactive},"visible":{type:"boolean",group:"Appearance",defaultValue:true},"unread":{type:"boolean",group:"Misc",defaultValue:false},"selected":{type:"boolean",group:"",defaultValue:false},"counter":{type:"int",group:"Misc",defaultValue:null}},events:{"tap":{},"detailTap":{},"press":{},"detailPress":{}}}});sap.m.ListItemBase.M_EVENTS={'tap':'tap','detailTap':'detailTap','press':'press','detailPress':'detailPress'};
sap.m.ListItemBase.prototype.init=function(){this._mode=sap.m.ListMode.None};
sap.m.ListItemBase.prototype._getRadioButton=function(r,g){var _=this._radioButton||new sap.m.RadioButton(r,{groupName:g,activeHandling:false,selected:this.getSelected()}).setParent(this,null,true).attachSelect(this._select);return this._radioButton=_};
sap.m.ListItemBase.prototype._getCheckBox=function(b){var _=this._checkBox||new sap.m.CheckBox(b,{activeHandling:false,selected:this.getSelected()}).setParent(this,null,true).attachSelect(this._select);return this._checkBox=_};
sap.m.ListItemBase.prototype.exit=function(){if(this._radioButton){this._radioButton.destroy()}if(this._checkBox){this._checkBox.destroy()}if(this._navImage){this._navImage.destroy()}if(this._delIcon){this._delIcon.destroy()}if(this._detailIcon){this._detailIcon.destroy()}};
sap.m.ListItemBase.prototype.isSelected=function(){return this.getSelected()};
sap.m.ListItemBase.prototype.setSelected=function(s){if(this._listId&&this.getDomRef()&&!arguments[1]){var l=sap.ui.getCore().byId(this._listId);l.setSelectedItem(this,s)}else{this.setProperty("selected",s,true)}return this};
sap.m.ListItemBase.prototype.setUnread=function(u){this.setProperty("unread",u,true);this.$().toggleClass('sapMLIBUnread',u);return this};
sap.m.ListItemBase.prototype._getNavImage=function(i,I,s,a){if(!jQuery.os.ios&&this.getType()==sap.m.ListType.Navigation)return null;if(!this._imagePath)if(jQuery.os.ios)this._imagePath=jQuery.sap.getModulePath("sap.m",'/')+"themes/"+sap.ui.getCore().getConfiguration().getTheme()+"/img/list/ios/";else this._imagePath=jQuery.sap.getModulePath("sap.m",'/')+"themes/"+sap.ui.getCore().getConfiguration().getTheme()+"/img/list/android/";if(a){a=this._imagePath+a}var n=this._navImage||new sap.m.Image(i,{src:this._imagePath+s,activeSrc:a,densityAware:false}).addStyleClass(I,true).setParent(this,null,true);;return this._navImage=n};
sap.m.ListItemBase.prototype._getDelImage=function(i,I,s){if(!this._imagePath)if(jQuery.os.ios)this._imagePath=jQuery.sap.getModulePath("sap.m",'/')+"themes/"+sap.ui.getCore().getConfiguration().getTheme()+"/img/list/ios/";else this._imagePath=jQuery.sap.getModulePath("sap.m",'/')+"themes/"+sap.ui.getCore().getConfiguration().getTheme()+"/img/list/android/";var d=this._delImage||new sap.m.Image(i,{src:this._imagePath+s,densityAware:false}).addStyleClass(I,true).setParent(this,null,true).attachPress(this._delete);return this._delImage=d};
sap.m.ListItemBase.prototype.ontap=function(e){var t=this.getType();if(this._includeItemInSelection&&(this._mode===sap.m.ListMode.SingleSelect||this._mode===sap.m.ListMode.SingleSelectLeft||this._mode===sap.m.ListMode.MultiSelect)||this._mode===sap.m.ListMode.SingleSelectMaster){switch(this._mode){case sap.m.ListMode.SingleSelect:case sap.m.ListMode.SingleSelectLeft:case sap.m.ListMode.SingleSelectMaster:if(e.srcControl&&e.srcControl.getId()!==this._radioButton.getId()){this.setSelected(true)}(sap.ui.getCore().byId(this._listId))._selectTapped(this);break;case sap.m.ListMode.MultiSelect:if(e.srcControl&&e.srcControl.getId()!==this._checkBox.getId()){this.setSelected(!this.isSelected())}(sap.ui.getCore().byId(this._listId))._selectTapped(this);break}}else{switch(t){case sap.m.ListType.Inactive:break;case sap.m.ListType.Active:case sap.m.ListType.Navigation:var a=this._doActiveHandling(e);if(a&&(!this._eventHandledByControl)){window.clearTimeout(this._timeoutIdStart);window.clearTimeout(this._timeoutIdEnd);this._event=e;this._active=true;this._activeHandling();if(t===sap.m.ListType.Navigation){this._activeHandlingNav()}this._activeHandlingInheritor();var b=this}if(!this._eventHandledByControl){this.fireTap({});this.firePress({})}if(a&&(!this._eventHandledByControl)){window.setTimeout(function(){b._active=false;b._activeHandling();if(t===sap.m.ListType.Navigation){b._inactiveHandlingNav()}b._inactiveHandlingInheritor()},180)}break;case sap.m.ListType.Detail:if(e.srcControl&&e.srcControl.getId()===(this.getId()+"-imgDet")){this.fireDetailTap({});this.fireDetailPress({})}break;case sap.m.ListType.DetailAndActive:if(e.srcControl&&e.srcControl.getId()===(this.getId()+"-imgDet")){this.fireDetailTap({});this.fireDetailPress({})}else{var a=this._doActiveHandling(e);if(a&&(!this._eventHandledByControl)){window.clearTimeout(this._timeoutIdStart);window.clearTimeout(this._timeoutIdEnd);this._event=e;this._active=true;this._activeHandling();this._activeHandlingInheritor();var b=this}if(!this._eventHandledByControl){this.fireTap({});this.firePress({})}if(a&&(!this._eventHandledByControl)){window.setTimeout(function(){b._active=false;b._activeHandling();b._inactiveHandlingInheritor()},180)}}break;default:}}};
sap.m.ListItemBase.prototype.ontouchstart=function(e){this._eventHandledByControl=e.originalEvent._sapui_handledByControl;this._active=true;if(e.targetTouches){this._touchedY=e.targetTouches[0].clientY;this._touchedX=e.targetTouches[0].clientX}var t=this;var _=e;if(!t._touchEndProxy){t._touchEndProxy=jQuery.proxy(t._ontouchend,t)}if(jQuery.support.touch){jQuery(window.document).bind("touchend touchcancel",t._touchEndProxy)}else{jQuery(window.document).bind("mouseup",t._touchEndProxy)}if(!t._touchMoveProxy){t._touchMoveProxy=jQuery.proxy(t._ontouchmove,t)}jQuery(window.document).bind("vmousemove",t._touchMoveProxy);this._timeoutIdStart=window.setTimeout(function(){if(!(t._includeItemInSelection&&(t._mode===sap.m.ListMode.SingleSelect||t._mode===sap.m.ListMode.SingleSelectLeft||t._mode===sap.m.ListMode.MultiSelect))&&((_.touches&&_.touches.length===1)||!_.touches)){var a=t.getType();switch(a){case sap.m.ListType.Inactive:case sap.m.ListType.Detail:break;case sap.m.ListType.Active:case sap.m.ListType.Navigation:var b=t._doActiveHandling(e);if(b&&(!t._eventHandledByControl)){t._event=e;t._activeHandling();if(a===sap.m.ListType.Navigation){t._activeHandlingNav()}t._activeHandlingInheritor()}break;case sap.m.ListType.DetailAndActive:var b=t._doActiveHandling(e);if(b&&e.srcControl.getId()!==(t.getId()+"-imgDet")&&(!t._eventHandledByControl)){t._event=e;t._activeHandling();t._activeHandlingInheritor()}break;default:}}},100)};
sap.m.ListItemBase.prototype._ontouchmove=function(e){var t=e.targetTouches&&((Math.abs(this._touchedY-e.targetTouches[0].clientY)>10)||Math.abs(this._touchedX-e.targetTouches[0].clientX)>10);if((this._active||this._timeoutIdStart)&&t){window.clearTimeout(this._timeoutIdStart);this._active=false;this._activeHandling();if(this.getType()===sap.m.ListType.Navigation){this._inactiveHandlingNav()}this._inactiveHandlingInheritor();this._timeoutIdStart=null;this._timeoutIdEnd=null}};
sap.m.ListItemBase.prototype._ontouchend=function(e){if(((e.targetTouches&&e.targetTouches.length===0)||!e.targetTouches)){var t=this.getType();var a=this;switch(t){case sap.m.ListType.Active:case sap.m.ListType.Navigation:case sap.m.ListType.DetailAndActive:this._timeoutIdEnd=window.setTimeout(function(){a._event=e;a._active=false;a._activeHandling();a._inactiveHandlingNav();a._inactiveHandlingInheritor()},100);break;case sap.m.ListType.Detail:case sap.m.ListType.Inactive:default:}if(jQuery.support.touch){jQuery(window.document).unbind("touchend touchcancel",a._touchEndProxy)}else{jQuery(window.document).unbind("mouseup",a._touchEndProxy)}jQuery(window.document).unbind("vmousemove",this._touchMoveProxy)}};
sap.m.ListItemBase.prototype._inactiveHandlingNav=function(){this._active=false;if(jQuery.os.ios){jQuery.sap.byId(this.getId()+"-imgNav").toggleClass('sapMLIBImgNavActive',this._active)}};
sap.m.ListItemBase.prototype._activeHandlingNav=function(){if(jQuery.os.ios){jQuery.sap.byId(this.getId()+"-imgNav").toggleClass('sapMLIBImgNavActive',this._active)}};
sap.m.ListItemBase.prototype._activeHandlingInheritor=function(){};
sap.m.ListItemBase.prototype._inactiveHandlingInheritor=function(){};
sap.m.ListItemBase.prototype._activeHandling=function(){this.$().toggleClass('sapMLIBActive',this._active);jQuery.sap.byId(this.getId()+"-counter").toggleClass('sapMLIBActiveCounter',this._active);if(this.getUnread()){jQuery.sap.byId(this.getId()+"-unread").toggleClass('sapMLIBActiveUnread',this._active)}var i=sap.ui.getCore().byId(this.getId()+"-imgDet");if(i instanceof sap.ui.core.Icon){i.$().toggleClass('sapMLIBIconDetActive',this._active)}var a=sap.ui.getCore().byId(this.getId()+"-imgDel");if(a instanceof sap.ui.core.Icon){a.$().toggleClass('sapMLIBIconDelActive',this._active)}};
sap.m.ListItemBase.prototype._doActiveHandling=function(e){if(e.srcControl&&(!e.srcControl.getActiveHandling||e.srcControl.getActiveHandling&&e.srcControl.getActiveHandling()!==false)&&e.srcControl.getId()!==(this.getId()+"-imgDel")){return true}return false};
