/*!
 * SAP UI development toolkit for HTML5 (SAPUI5)
 * 
 * (c) Copyright 2009-2013 SAP AG. All rights reserved
 */
jQuery.sap.declare("sap.makit.Chart");jQuery.sap.require("sap.makit.library");jQuery.sap.require("sap.ui.core.Control");sap.ui.core.Control.extend("sap.makit.Chart",{metadata:{publicMethods:["getSelectedCategory","getSelectedSeries","getNumberOfCategories","getSelectedCategoryGroup"],library:"sap.makit",properties:{"width":{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},"height":{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},"type":{type:"sap.makit.ChartType",group:"Appearance",defaultValue:sap.makit.ChartType.Column},"categoryAxis":{type:"object",group:"Misc",defaultValue:null},"valueAxis":{type:"object",group:"Misc",defaultValue:null},"valueBubble":{type:"object",group:"Misc",defaultValue:null},"showRangeSelector":{type:"boolean",group:"Appearance",defaultValue:true},"showTableView":{type:"boolean",group:"Misc",defaultValue:false},"legendPosition":{type:"sap.makit.LegendPosition",group:"Misc",defaultValue:null},"lineThickness":{type:"float",group:"Misc",defaultValue:1},"showTableValue":{type:"boolean",group:"Misc",defaultValue:true},"maxSliceCount":{type:"int",group:"Misc",defaultValue:12},"primaryColorPalette":{type:"any",group:"Misc",defaultValue:null},"showTotalValue":{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{"rows":{type:"sap.makit.Row",multiple:true,singularName:"row",bindable:"bindable"},"columns":{type:"sap.makit.Column",multiple:true,singularName:"column",bindable:"bindable"},"series":{type:"sap.makit.Series",multiple:false},"values":{type:"sap.makit.Value",multiple:true,singularName:"value"},"categoryRegions":{type:"sap.makit.Category",multiple:true,singularName:"categoryRegion"},"category":{type:"sap.makit.Category",multiple:false,deprecated:true}},events:{"doubletap":{},"tap":{},"init":{}}}});sap.makit.Chart.M_EVENTS={'doubletap':'doubletap','tap':'tap','init':'init'};
/*!

 * @copyright@

 */
jQuery.sap.require("sap.makit.MakitLib");
sap.makit.Chart.prototype.init=function(){this._makitChart=null;this._parentCurrentHeight=0;this._selectedCatIdx=0;this._chartTypeDefined=false;this._legendPosDefined=false;this._datarows=[];this._styleClasses=[];this.setCategoryAxis(new sap.makit.CategoryAxis());this.setValueAxis(new sap.makit.ValueAxis());this.setValueBubble(new sap.makit.ValueBubble());this.setPrimaryColorPalette(null);if(this.getType()===sap.makit.ChartType.Pie||this.getType()===sap.makit.ChartType.Donut){this.setLegendPosition(sap.makit.LegendPosition.Left)}else{this.setLegendPosition(sap.makit.LegendPosition.None)}this.attachEvent("_change",this._onPropertyChanged);sap.ui.getCore().attachThemeChanged(this._applyCSS,this)};
sap.makit.Chart.prototype.onBeforeRendering=function(e){this.fireEvent("_beforeRendering",this);if(this.getDomRef()&&!sap.ui.core.RenderManager.isPreservedContent(this.getDomRef())){sap.ui.core.RenderManager.preserveContent(this.getDomRef(),true,false)}};
sap.makit.Chart.prototype.onAfterRendering=function(e){this.fireEvent("_afterRendering",this);var $=jQuery(jQuery.sap.domById("sap-ui-dummy-"+this.getId()));var a=sap.ui.core.RenderManager.findPreservedContent(this.getId());var b=null;if(a.size()==0){this.fireEvent("_createMAKitObject",this);this._createChartObject();b=new jQuery(this.getDomRef());$.replaceWith(b);var p=this.getParent();var c=p.getId();var d=jQuery.sap.domById(c);this._parentCurrentHeight=d.offsetHeight;sap.ui.core.ResizeHandler.register(d,jQuery.proxy(this._onResize,this))}else if(a.size()>0){this.fireEvent("_restoreMAKitObject",this);$.replaceWith(a)}else{$.remove()}if(b){this._makitChart.showRangeSelectorView(this.getShowRangeSelector());this._makitChart.showTableView(this.getShowTableView());this._makitChart.setGraphLineWidth(this.getLineThickness());this._makitChart.showTableValue(this.getShowTableValue());this._makitChart.setMaxPies(this.getMaxSliceCount());this._makitChart.setPalette(this.getPrimaryColorPalette());this._makitChart.setProperty("ShowTotal",this.getShowTotalValue())}this._setDataTable()};
sap.makit.Chart.prototype.addStyleClass=function(s,S){if(this._styleClasses.indexOf(s)===-1){this._styleClasses.push(s)}if(this._makitChart){sap.ui.core.Control.prototype.addStyleClass.call(this,s,S)}return this};
sap.makit.Chart.prototype.removeStyleClass=function(s,S){var i=this._styleClasses.indexOf(s);if(i>-1){this._styleClasses.splice(i,1)}if(this._makitChart){sap.ui.core.Control.prototype.removeStyleClass.call(this,s,S)}return this};
sap.makit.Chart.prototype.bindAggregation=function(n,b){if(n==="rows"){if(typeof b=="string"){b={path:arguments[1],template:arguments[2],sorter:arguments[3],filters:arguments[4]}}b.template=undefined;b.factory=function(){};return sap.ui.core.Element.prototype.bindAggregation.call(this,n,b)}return sap.ui.core.Element.prototype.bindAggregation.apply(this,arguments)};
sap.makit.Chart.prototype.addRow=function(r){jQuery.sap.log.error("The control manages the rows aggregation. The method \"addRow\" cannot be used programmatically!")};
sap.makit.Chart.prototype.insertRow=function(r,i){jQuery.sap.log.error("The control manages the rows aggregation. The method \"insertRow\" cannot be used programmatically!")};
sap.makit.Chart.prototype.removeRow=function(r){jQuery.sap.log.error("The control manages the rows aggregation. The method \"removeRow\" cannot be used programmatically!")};
sap.makit.Chart.prototype.removeAllRows=function(){jQuery.sap.log.error("The control manages the rows aggregation. The method \"removeAllRows\" cannot be used programmatically!")};
sap.makit.Chart.prototype.destroyRows=function(r){jQuery.sap.log.error("The control manages the rows aggregation. The method \"destroyRows\" cannot be used programmatically!")};
sap.makit.Chart.prototype.updateRows=function(){this.fireEvent("_startUpdateRows",this);this._createRows();if(this._makitChart){this._setDataTable()}this.fireEvent("_endUpdateRows",this)};
sap.makit.Chart.prototype.setValueBubble=function(v){if(v instanceof sap.makit.ValueBubble){sap.ui.core.Element.prototype.setProperty.call(this,"valueBubble",v,false);v.attachEvent("_change",this._onValueBubbleChanged,this);if(this._makitChart){var a=v.toObject();this._makitChart.setValueBubbleStyle(a);if(this._makitChart.isValueBubbleVisible()!=a.visible){this._makitChart.showValueBubble(a.visible)}}}else{throw new Error("valueBubble property must be of type sap.makit.ValueBubble")}return this};
sap.makit.Chart.prototype.setCategory=function(c){var a=this.getCategoryRegions();if(a.length>0){this.removeCategoryRegion(0)}this.insertCategoryRegion(c,0);return this};
sap.makit.Chart.prototype.getCategory=function(c){var a=this.getCategoryRegions();return a[0]};
sap.makit.Chart.prototype.destroyCategory=function(){this.removeCategoryRegion(0);return this};
sap.makit.Chart.prototype.addCategoryRegion=function(c){sap.ui.core.Element.prototype.addAggregation.call(this,"categoryRegions",c,false);c.attachEvent("_change",{type:"categories"},this._onDataRegionPropChanged,this);return this};
sap.makit.Chart.prototype.insertCategoryRegion=function(c,i){sap.ui.core.Element.prototype.insertAggregation.call(this,"categoryRegions",c,i,false);c.attachEvent("_change",{type:"categories"},this._onDataRegionPropChanged,this);return this};
sap.makit.Chart.prototype.removeCategoryRegion=function(c){var r=sap.ui.core.Element.prototype.removeAggregation.call(this,"categoryRegions",c,false);if(r!=null){c.detachEvent("_change",this._onDataRegionPropChanged,this)}return r};
sap.makit.Chart.prototype.removeAllCategoryRegions=function(){var r=sap.ui.core.Element.prototype.removeAllAggregation.call(this,"categoryRegions",false);var l=r.length;var i;for(i=0;i<l;i++){r[i].detachEvent("_change",this._onDataRegionPropChanged,this)}return r};
sap.makit.Chart.prototype.addValue=function(v){sap.ui.core.Element.prototype.addAggregation.call(this,"values",v,false);v.attachEvent("_change",{type:"values"},this._onDataRegionPropChanged,this);return this};
sap.makit.Chart.prototype.insertValue=function(v,i){sap.ui.core.Element.prototype.insertAggregation.call(this,"values",v,i,false);v.attachEvent("_change",{type:"values"},this._onDataRegionPropChanged,this);return this};
sap.makit.Chart.prototype.removeValue=function(v){var r=sap.ui.core.Element.prototype.removeAggregation.call(this,"values",v,false);if(r!=null){r.detachEvent("_change",this._onDataRegionPropChanged,this)}return r};
sap.makit.Chart.prototype.removeAllValues=function(){var r=sap.ui.core.Element.prototype.removeAllAggregation.call(this,"values",false);var l=r.length;var i;for(i=0;i<l;i++){r[i].detachEvent("_change",this._onDataRegionPropChanged,this)}return r};
sap.makit.Chart.prototype.setSeries=function(s){sap.ui.core.Element.prototype.setAggregation.call(this,"series",s,false);s.attachEvent("_change",{type:"series"},this._onDataRegionPropChanged,this);return this};
sap.makit.Chart.prototype.setValueAxis=function(v){if(v instanceof sap.makit.ValueAxis){sap.ui.core.Element.prototype.setProperty.call(this,"valueAxis",v,false);v.attachEvent("_change",{axis:"values"},this._onAxisPropChanged,this)}else{throw new Error("valueAxis property must be of type sap.makit.ValueAxis")}return this};
sap.makit.Chart.prototype.setCategoryAxis=function(c){if(c instanceof sap.makit.CategoryAxis){sap.ui.core.Element.prototype.setProperty.call(this,"categoryAxis",c,false);c.attachEvent("_change",{axis:"category"},this._onAxisPropChanged,this)}else{throw new Error("categoryAxis property must be of type sap.makit.CategoryAxis")}return this};
sap.makit.Chart.prototype.setPrimaryColorPalette=function(c){if(c==null||(c instanceof Array&&c.length>0)){sap.ui.core.Element.prototype.setProperty.call(this,"primaryColorPalette",c,false);if(this._makitChart){this._makitChart.setPalette(c)}}else{throw new Error("primaryColorPalette property must be an array")}return this};
sap.makit.Chart.prototype._setRealHeight=function(h){var e=this.getDomRef();var p=e.style.height;var n="0px";if(h.indexOf("%")>-1){var d=this.getDomRef();var a=d.offsetParent;if(!a){var b=this.getParent();var c=b.getId();var a=jQuery.sap.domById(c)}var i=parseInt(h,10);var r=Math.ceil(a.offsetHeight*(i/100));n=r+"px"}else{n=h}if(p!=n){e.style.height=n}};
sap.makit.Chart.prototype._createRows=function(){this.fireEvent("_startCreateRows",this);var t=new sap.makit.Row(this.getId()+"-dummyrows");var c=this.getColumns();for(var i=0,l=c.length;i<l;i++){var C=c[i];if(C){var n=c[i].getName();var o=C.clone("col"+i);o.data("sap-ui-colindex",i);t.addAggregation("cells",o)}}this.fireEvent("_endColumn",this);this.destroyAggregation("rows");this.fireEvent("_endDestroyRows",this);var a=undefined;var b=this.getBinding("rows");if(b){a=b.getContexts()}var d=b.getLength();this._datarows=[];this.fireEvent("_endPrepareRows",this);for(var i=0;i<d;i++){if(a&&a[i]){var o=t.clone("row"+i);o.setBindingContext(a[i]);this.addAggregation("rows",o);this._datarows.push(o._datarow)}}this.fireEvent("_endCreateRows",this);t.destroy()};
sap.makit.Chart.prototype._createChartObject=function(){var e=this.getDomRef();e.style.width=this.getWidth();this._setRealHeight(this.getHeight());this._makitChart=new window.$MA.Chart(this.getId(),true);var t=this;this._makitChart.bind("initialized",function(){t._makitChart.showToolBar(false);t._setMakitChartProperties()});this._makitChart.bind("beforerender",function(){t.fireEvent("_makitBeforeRender",t)});this._makitChart.bind("renderstart",function(){t.fireEvent("_makitRenderStart",t)});this._makitChart.bind("renderend",function(){t.fireEvent("_makitRenderEnd",t)});this._makitChart.bind("animationend",function(){t.fireEvent("_makitAnimationEnd",t)});var s=this._getChartSyntax();this._makitChart.create(s);this._makitChart.bind("tap",function(){t._selectedCatIdx=t._makitChart.getSelectedCategoryIndex();t.fireTap({})});this._makitChart.bind("doubletap",function(){t.fireEvent("doubletap",t)});this._makitChart.bind("longpress",function(){t._selectedCatIdx=t._makitChart.getSelectedCategoryIndex();t.fireEvent("longpress",t)});var l=this._styleClasses.length;for(var i=0;i<l;i++){this.addStyleClass(this._styleClasses[i])}this._applyCSS()};
sap.makit.Chart.prototype._setMakitChartProperties=function(){if(!this._makitChart){return}this._makitChart.setLegend(this.getLegendPosition().toLowerCase());if(this._dataInitialized){this._makitChart.showTableView(this.getShowTableView());this._makitChart.showRangeSelectorView(this.getShowRangeSelector());this._makitChart.setGraphLineWidth(this.getLineThickness());this._makitChart.showTableValue(this.getShowTableValue());this._makitChart.setPalette(this.getPrimaryColorPalette());this._makitChart.setProperty("ShowTotal",this.getShowTotalValue())}var v=this.getValueBubble();if(v){var a=v.toObject();this._makitChart.setValueBubbleStyle(a);if(this._makitChart.isValueBubbleVisible()!=a.visible){this._makitChart.showValueBubble(a.visible)}}};
sap.makit.Chart.prototype._getChartSyntax=function(){var c=this.getCategoryAxis();var a=this.getCategoryRegions();var b=a.length;if(b>0){var i;var d="<Categories";if(c){if(c.getDisplayAll()){d+=' display="'+c.getDisplayAll()+'"'}}d+=">";var e="";for(i=b-1;i>=0;i--){var t=a[i].getDisplayName();if(t&&t.length>0){e+=t+" | "}}e=e.substr(0,e.length-3);for(i=0;i<b;i++){var f=a[i];d+='<Category column="'+f.getColumn()+'"';if(f.getFormat()){d+=' format="'+f.getFormat()+'"'}if(i==0){d+=' displayname="'+e+'"'}if(c){d+=' showprimaryline="'+c.getShowPrimaryLine()+'"';d+=' showgrid="'+c.getShowGrid()+'"';d+=' showlabel="'+c.getShowLabel()+'"';d+=' thickness="'+c.getThickness()+'"';d+=' color="'+c.getColor()+'"';d+=' sortorder="'+c.getSortOrder().toLowerCase()+'"';d+=' displaylastlabel="'+c.getDisplayLastLabel()+'"'}d+=' />'}d+="</Categories>"}else{throw new Error("Chart '"+this.getId()+"' needs at least one Category data region")}var s=this.getSeries();var g='';if(s){g='<Series Column="'+s.getColumn()+'"';if(s.getFormat()){g+=' format="'+s.getFormat()+'"'}if(s.getDisplayName()){g+=' displayname="'+s.getDisplayName()+'"'}g+='/>'}var v=this.getValueAxis();var h='<Values>';if(v){h='<Values';h+=' showprimaryline="'+v.getShowPrimaryLine()+'"';h+=' showgrid="'+v.getShowGrid()+'"';h+=' showlabel="'+v.getShowLabel()+'"';h+=' thickness="'+v.getThickness()+'"';h+=' color="'+v.getColor()+'"';if(v.getMin()!==""){h+=' min="'+v.getMin()+'"'}if(v.getMax()!==""){h+=' max="'+v.getMax()+'"'}h+='>'}var j=this.getValues();var l=j.length;if(l==0){throw new Error("Chart '"+this.getId()+"' needs at least one Value data region")}var k;for(var i=0;i<l;i++){k=j[i];h+='<Value Expression="'+k.getExpression()+'"';if(k.getFormat()){h+=' format="'+k.getFormat()+'"'}if(k.getDisplayName()){h+=' displayname="'+k.getDisplayName()+'"'}h+='/>'}h+='</Values>';var m=this.getType().toLowerCase();var p=null;if(m==="donut"||m==="pie"){p=m;m="pie"}var n='<Chart ChartType="'+m+'"';if(p!==null){n+=' PieStyle="'+p+'"'}n+=' >';n+=d;if(s){n+=g}n+=h;n+='</Chart>';return n};
sap.makit.Chart.prototype._setDataTable=function(){this._setDataTableTimer=this._setDataTableTimer||jQuery.sap.delayedCall(150,this,function(){if(this._datarows&&this._datarows.length>0){this.fireEvent("_createDataTable",this);var d=this._datarows;var a=new window.$MA.DataTable();var c=this.getColumns();var b=c.length;if(b==0){c=this.getRows()[0].getCells();b=c.length}for(var i=0;i<b;i++){a.addColumn(c[i].getName(),c[i].getType())}a.addRows(d);this.fireEvent("_beforeSetDataTable",this);this._makitChart.setDataTable(a);this._dataInitialized=true}this._setDataTableTimer=undefined})};
sap.makit.Chart.prototype._applyCSS=function(e){if(this._makitChart){this._makitChart.applyCSS()}};
sap.makit.Chart.prototype._onResize=function(e){var p=this.getParent();var a=p.getId();var b=jQuery.sap.domById(a);var c=b.offsetHeight;var d=b.offsetWidth;if(this._parentCurrentHeight!=c&&c>0){this._setRealHeight(this.getHeight());this._parentCurrentHeight=b.offsetHeight}if(this._makitChart!=null&&c>0&&d>0){this._makitChart.refresh()}};
sap.makit.Chart.prototype._onPropertyChanged=function(e){var n=e.mParameters["name"];var a=e.mParameters["newValue"];if(n==="type"&&!this._chartTypeDefined){this._chartTypeDefined=true;if(!this._legendPosDefined){if(a===sap.makit.ChartType.Pie||a===sap.makit.ChartType.Donut){this.setLegendPosition(sap.makit.LegendPosition.Left)}else{this.setLegendPosition(sap.makit.LegendPosition.None)}}}else if(n==="legendPosition"&&!this._legendPosDefined){this._legendPosDefined=true}if(this._makitChart){if(n==="type"){var t=a.toLowerCase();var p=null;this._makitChart.setProperty("ChartType",t);if(t==="donut"||t==="pie"){p=t;t="pie";this._makitChart.setProperty("PieStyle",p)}}else if(n==="showRangeSelector"){this._makitChart.showRangeSelectorView(a)}else if(n==="showTableView"){this._makitChart.showTableView(a)}else if(n==="legendPosition"){this._makitChart.setLegend(a.toLowerCase())}else if(n==="width"){this.getDomRef().style.width=this.getWidth()}else if(n==="height"){this._setRealHeight(a)}else if(n==="lineThickness"){this._makitChart.setGraphLineWidth(a)}else if(n==="maxSliceCount"){this._makitChart.setMaxPies(a)}else if(n==="showTableValue"){this._makitChart.showTableValue(a)}else if(n==="primaryColorPalette"){this._makitChart.setPalette(a)}else if(n==="showTotalValue"){this._makitChart.setProperty("ShowTotal",a)}this._makitChart.setSelectedCategoryIndex(this._selectedCatIdx);this._makitChart.refresh()}};
sap.makit.Chart.prototype._onDataRegionPropChanged=function(e,d){if(!this._makitChart){return}var p=e.mParameters;if(d["type"]=="values"){var v=e.oSource;var a=this.indexOfValue(v);if(a>-1){this._makitChart.setProperty(d["type"]+"["+a+"]."+p["name"],p["newValue"])}}else if(d["type"]=="categories"){var c=e.oSource;var a=this.indexOfCategoryRegion(c);var b=p["name"];if(a>-1){if(b=="displayName"){var f=this.getCategoryRegions();var i,g="",l=f.length;for(i=0;i<l;i++){g+=f[i].getDisplayName();if(i!=l-1){g+=" | "}}this._makitChart.setProperty("category."+b,p["newValue"])}else{this._makitChart.setProperty(d["type"]+"["+a+"]."+b,p["newValue"])}}}else{this._makitChart.setProperty(d["type"]+"."+p["name"],p["newValue"])}};
sap.makit.Chart.prototype._onAxisPropChanged=function(e,d){if(!this._makitChart){return}var p=e.mParameters;var n=p["name"].toLowerCase();var v=p["newValue"];var a=d["axis"];if(n==="sortorder"){v=v.toLowerCase()}else if(n==="displayall"){a="categories";n="display";if(!v){v=""}}this._makitChart.setProperty(a+"."+n,v);if(n==="sortorder"){this._setDataTable()}};
sap.makit.Chart.prototype._onValueBubbleChanged=function(e){if(!this._makitChart){return}var v=this.getValueBubble().toObject();this._makitChart.setValueBubbleStyle(v);if(this._makitChart.isValueBubbleVisible()!=v.visible){this._makitChart.showValueBubble(v.visible)}this._makitChart.refresh()};
sap.makit.Chart.prototype.getSelectedCategory=function(){var s=undefined;if(this._makitChart){s=this._makitChart.getSelectedCategory()}return s};
sap.makit.Chart.prototype.getSelectedSeries=function(){var s=undefined;if(this._makitChart){s=this._makitChart.getSelectedSeries()}return s};
sap.makit.Chart.prototype.getNumberOfCategories=function(){var n=undefined;if(this._makitChart){n=this._makitChart.getNumberOfCategories()}return n};
sap.makit.Chart.prototype.getSelectedCategoryGroup=function(){var s=undefined;if(this._makitChart){s=this._makitChart.getSelectedCategoryGroup()}return s};
