/*!

 * URI.js - Mutating URLs

 *

 * Version: 1.8.1

 *

 * Author: Rodney Rehm

 * Web: http://medialize.github.com/URI.js/

 *

 * Licensed under

 *   MIT License http://www.opensource.org/licenses/mit-license

 *   GPL v3 http://opensource.org/licenses/GPL-3.0

 *

 */
(function(r,f){if(typeof exports==='object'){module.exports=f(require('./punycode'),require('./IPv6'),require('./SecondLevelDomains'))}else if(typeof define==='function'&&define.amd){define(['./punycode','./IPv6','./SecondLevelDomains'],f)}else{r.URI=f(r.punycode,r.IPv6,r.SecondLevelDomains)}}(this,function(a,I,S){"use strict";function U(u,c){if(!(this instanceof U)){return new U(u,c)}if(u===undefined){if(typeof location!=='undefined'){u=location.href+""}else{u=""}}this.href(u);if(c!==undefined){return this.absoluteTo(c)}return this};var p=U.prototype;var h=Object.prototype.hasOwnProperty;function b(s){return s.replace(/([.*+?^=!:${}()|[\]\/\\])/g,'\\$1')}function f(c){return String(Object.prototype.toString.call(c))==="[object Array]"}function g(d,v){var l={};var i,c;if(f(v)){for(i=0,c=v.length;i<c;i++){l[v[i]]=true}}else{l[v]=true}for(i=0,c=d.length;i<c;i++){if(l[d[i]]!==undefined){d.splice(i,1);c--;i--}}return d}U.duplicateQueryParameters=false;U.protocol_expression=/^[a-z][a-z0-9-+-]*$/i;U.idn_expression=/[^a-z0-9\.-]/i;U.punycode_expression=/(xn--)/i;U.ip4_expression=/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/;U.ip6_expression=/^\s*((([0-9A-Fa-f]{1,4}:){7}([0-9A-Fa-f]{1,4}|:))|(([0-9A-Fa-f]{1,4}:){6}(:[0-9A-Fa-f]{1,4}|((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){5}(((:[0-9A-Fa-f]{1,4}){1,2})|:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){4}(((:[0-9A-Fa-f]{1,4}){1,3})|((:[0-9A-Fa-f]{1,4})?:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){3}(((:[0-9A-Fa-f]{1,4}){1,4})|((:[0-9A-Fa-f]{1,4}){0,2}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){2}(((:[0-9A-Fa-f]{1,4}){1,5})|((:[0-9A-Fa-f]{1,4}){0,3}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){1}(((:[0-9A-Fa-f]{1,4}){1,6})|((:[0-9A-Fa-f]{1,4}){0,4}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(:(((:[0-9A-Fa-f]{1,4}){1,7})|((:[0-9A-Fa-f]{1,4}){0,5}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:)))(%.+)?\s*$/;U.find_uri_expression=/\b((?:[a-z][\w-]+:(?:\/{1,3}|[a-z0-9%])|www\d{0,3}[.]|[a-z0-9.\-]+[.][a-z]{2,4}\/)(?:[^\s()<>]+|\(([^\s()<>]+|(\([^\s()<>]+\)))*\))+(?:\(([^\s()<>]+|(\([^\s()<>]+\)))*\)|[^\s`!()\[\]{};:'".,<>?«»“”‘’]))/ig;U.defaultPorts={http:"80",https:"443",ftp:"21",gopher:"70",ws:"80",wss:"443"};U.invalid_hostname_characters=/[^a-zA-Z0-9\.-]/;function j(s){return encodeURIComponent(s).replace(/[!'()*]/g,escape).replace(/\*/g,"%2A")}U.encode=j;U.decode=decodeURIComponent;U.iso8859=function(){U.encode=escape;U.decode=unescape};U.unicode=function(){U.encode=j;U.decode=decodeURIComponent};U.characters={pathname:{encode:{expression:/%(24|26|2B|2C|3B|3D|3A|40)/ig,map:{"%24":"$","%26":"&","%2B":"+","%2C":",","%3B":";","%3D":"=","%3A":":","%40":"@"}},decode:{expression:/[\/\?#]/g,map:{"/":"%2F","?":"%3F","#":"%23"}}},reserved:{encode:{expression:/%(21|23|24|26|27|28|29|2A|2B|2C|2F|3A|3B|3D|3F|40|5B|5D)/ig,map:{"%3A":":","%2F":"/","%3F":"?","%23":"#","%5B":"[","%5D":"]","%40":"@","%21":"!","%24":"$","%26":"&","%27":"'","%28":"(","%29":")","%2A":"*","%2B":"+","%2C":",","%3B":";","%3D":"="}}}};U.encodeQuery=function(s){return U.encode(s+"").replace(/%20/g,'+')};U.decodeQuery=function(s){return U.decode((s+"").replace(/\+/g,'%20'))};U.recodePath=function(s){var c=(s+"").split('/');for(var i=0,l=c.length;i<l;i++){c[i]=U.encodePathSegment(U.decode(c[i]))}return c.join('/')};U.decodePath=function(s){var c=(s+"").split('/');for(var i=0,l=c.length;i<l;i++){c[i]=U.decodePathSegment(c[i])}return c.join('/')};var _={'encode':'encode','decode':'decode'};var k;var m=function(d,k){return function(s){return U[k](s+"").replace(U.characters[d][k].expression,function(c){return U.characters[d][k].map[c]})}};for(k in _){U[k+"PathSegment"]=m("pathname",_[k])}U.encodeReserved=m("reserved","encode");U.parse=function(s,c){var d,t;if(!c){c={}}d=s.indexOf('#');if(d>-1){c.fragment=s.substring(d+1)||null;s=s.substring(0,d)}d=s.indexOf('?');if(d>-1){c.query=s.substring(d+1)||null;s=s.substring(0,d)}if(s.substring(0,2)==='//'){c.protocol='';s=s.substring(2);s=U.parseAuthority(s,c)}else{d=s.indexOf(':');if(d>-1){c.protocol=s.substring(0,d);if(c.protocol&&!c.protocol.match(U.protocol_expression)){c.protocol=undefined}else if(c.protocol==='file'){s=s.substring(d+3)}else if(s.substring(d+1,d+3)==='//'){s=s.substring(d+3);s=U.parseAuthority(s,c)}else{s=s.substring(d+1);c.urn=true}}}c.path=s;return c};U.parseHost=function(s,c){var d=s.indexOf('/');var e;var t;if(d===-1){d=s.length}if(s[0]==="["){e=s.indexOf(']');c.hostname=s.substring(1,e)||null;c.port=s.substring(e+2,d)||null}else if(s.indexOf(':')!==s.lastIndexOf(':')){c.hostname=s.substring(0,d)||null;c.port=null}else{t=s.substring(0,d).split(':');c.hostname=t[0]||null;c.port=t[1]||null}if(c.hostname&&s.substring(d)[0]!=='/'){d++;s="/"+s}return s.substring(d)||'/'};U.parseAuthority=function(s,c){s=U.parseUserinfo(s,c);return U.parseHost(s,c)};U.parseUserinfo=function(s,c){var d=s.indexOf('@');var e=s.indexOf('/');var t;if(d>-1&&(e===-1||d<e)){t=s.substring(0,d).split(':');c.username=t[0]?U.decode(t[0]):null;t.shift();c.password=t[0]?U.decode(t.join(':')):null;s=s.substring(d+1)}else{c.username=null;c.password=null}return s};U.parseQuery=function(s){if(!s){return{}}s=s.replace(/&+/g,'&').replace(/^\?*&*|&+$/g,'');if(!s){return{}}var c={};var d=s.split('&');var l=d.length;var v,e,t;for(var i=0;i<l;i++){v=d[i].split('=');e=U.decodeQuery(v.shift());t=v.length?U.decodeQuery(v.join('=')):null;if(c[e]){if(typeof c[e]==="string"){c[e]=[c[e]]}c[e].push(t)}else{c[e]=t}}return c};U.build=function(c){var t="";if(c.protocol){t+=c.protocol+":"}if(!c.urn&&(t||c.hostname)){t+='//'}t+=(U.buildAuthority(c)||'');if(typeof c.path==="string"){if(c.path[0]!=='/'&&typeof c.hostname==="string"){t+='/'}t+=c.path}if(typeof c.query==="string"&&c.query){t+='?'+c.query}if(typeof c.fragment==="string"&&c.fragment){t+='#'+c.fragment}return t};U.buildHost=function(c){var t="";if(!c.hostname){return""}else if(U.ip6_expression.test(c.hostname)){if(c.port){t+="["+c.hostname+"]:"+c.port}else{t+=c.hostname}}else{t+=c.hostname;if(c.port){t+=':'+c.port}}return t};U.buildAuthority=function(c){return U.buildUserinfo(c)+U.buildHost(c)};U.buildUserinfo=function(c){var t="";if(c.username){t+=U.encode(c.username);if(c.password){t+=':'+U.encode(c.password)}t+="@"}return t};U.buildQuery=function(d,c){var t="";var u,e,i,l;for(e in d){if(h.call(d,e)&&e){if(f(d[e])){u={};for(i=0,l=d[e].length;i<l;i++){if(d[e][i]!==undefined&&u[d[e][i]+""]===undefined){t+="&"+U.buildQueryParameter(e,d[e][i]);if(c!==true){u[d[e][i]+""]=true}}}}else if(d[e]!==undefined){t+='&'+U.buildQueryParameter(e,d[e])}}}return t.substring(1)};U.buildQueryParameter=function(c,v){return U.encodeQuery(c)+(v!==null?"="+U.encodeQuery(v):"")};U.addQuery=function(d,c,v){if(typeof c==="object"){for(var e in c){if(h.call(c,e)){U.addQuery(d,e,c[e])}}}else if(typeof c==="string"){if(d[c]===undefined){d[c]=v;return}else if(typeof d[c]==="string"){d[c]=[d[c]]}if(!f(v)){v=[v]}d[c]=d[c].concat(v)}else{throw new TypeError("URI.addQuery() accepts an object, string as the name parameter")}};U.removeQuery=function(d,c,v){var i,l,e;if(f(c)){for(i=0,l=c.length;i<l;i++){d[c[i]]=undefined}}else if(typeof c==="object"){for(e in c){if(h.call(c,e)){U.removeQuery(d,e,c[e])}}}else if(typeof c==="string"){if(v!==undefined){if(d[c]===v){d[c]=undefined}else if(f(d[c])){d[c]=g(d[c],v)}}else{d[c]=undefined}}else{throw new TypeError("URI.addQuery() accepts an object, string as the first parameter")}};U.commonPath=function(c,t){var l=Math.min(c.length,t.length);var d;for(d=0;d<l;d++){if(c[d]!==t[d]){d--;break}}if(d<1){return c[0]===t[0]&&c[0]==='/'?'/':''}if(c[d]!=='/'){d=c.substring(0,d).lastIndexOf('/')}return c.substring(0,d+1)};U.withinString=function(s,c){return s.replace(U.find_uri_expression,c)};U.ensureValidHostname=function(v){if(v.match(U.invalid_hostname_characters)){if(!a){throw new TypeError("Hostname '"+v+"' contains characters other than [A-Z0-9.-] and Punycode.js is not available")}if(a.toASCII(v).match(U.invalid_hostname_characters)){throw new TypeError("Hostname '"+v+"' contains characters other than [A-Z0-9.-]")}}};p.build=function(d){if(d===true){this._deferred_build=true}else if(d===undefined||this._deferred_build){this._string=U.build(this._parts);this._deferred_build=false}return this};p.clone=function(){return new U(this)};p.toString=function(){return this.build(false)._string};p.valueOf=function(){return this.toString()};_={protocol:'protocol',username:'username',password:'password',hostname:'hostname',port:'port'};m=function(k){return function(v,c){if(v===undefined){return this._parts[k]||""}else{this._parts[k]=v;this.build(!c);return this}}};for(k in _){p[k]=m(_[k])}_={query:'?',fragment:'#'};m=function(k,c){return function(v,d){if(v===undefined){return this._parts[k]||""}else{if(v!==null){v=v+"";if(v[0]===c){v=v.substring(1)}}this._parts[k]=v;this.build(!d);return this}}};for(k in _){p[k]=m(k,_[k])}_={search:['?','query'],hash:['#','fragment']};m=function(k,c){return function(v,d){var t=this[k](v,d);return typeof t==="string"&&t.length?(c+t):t}};for(k in _){p[k]=m(_[k][1],_[k][0])}p.pathname=function(v,c){if(v===undefined||v===true){var d=this._parts.path||(this._parts.urn?'':'/');return v?U.decodePath(d):d}else{this._parts.path=v?U.recodePath(v):"/";this.build(!c);return this}};p.path=p.pathname;p.href=function(c,d){if(c===undefined){return this.toString()}this._string="";this._parts={protocol:null,username:null,password:null,hostname:null,urn:null,port:null,path:null,query:null,fragment:null,duplicateQueryParameters:U.duplicateQueryParameters};var e=c instanceof U;var i=typeof c==="object"&&(c.hostname||c.path);var l;if(!e&&i&&Object.prototype.toString.call(c)!=="[object Object]"){c=c.toString()}if(typeof c==="string"){this._parts=U.parse(c,this._parts)}else if(e||i){var s=e?c._parts:c;for(l in s){if(h.call(this._parts,l)){this._parts[l]=s[l]}}}else{throw new TypeError("invalid input")}this.build(!d);return this};p.is=function(w){var i=false;var c=false;var d=false;var e=false;var s=false;var l=false;var a=false;var t=!this._parts.urn;if(this._parts.hostname){t=false;c=U.ip4_expression.test(this._parts.hostname);d=U.ip6_expression.test(this._parts.hostname);i=c||d;e=!i;s=e&&S&&S.has(this._parts.hostname);l=e&&U.idn_expression.test(this._parts.hostname);a=e&&U.punycode_expression.test(this._parts.hostname)}switch(w.toLowerCase()){case'relative':return t;case'absolute':return!t;case'domain':case'name':return e;case'sld':return s;case'ip':return i;case'ip4':case'ipv4':case'inet4':return c;case'ip6':case'ipv6':case'inet6':return d;case'idn':return l;case'url':return!this._parts.urn;case'urn':return!!this._parts.urn;case'punycode':return a}return null};var n=p.protocol;var o=p.port;var r=p.hostname;p.protocol=function(v,c){if(v!==undefined){if(v){v=v.replace(/:(\/\/)?$/,'');if(v.match(/[^a-zA-z0-9\.+-]/)){throw new TypeError("Protocol '"+v+"' contains characters other than [A-Z0-9.+-]")}}}return n.call(this,v,c)};p.scheme=p.protocol;p.port=function(v,c){if(this._parts.urn){return v===undefined?'':this}if(v!==undefined){if(v===0){v=null}if(v){v+="";if(v[0]===":"){v=v.substring(1)}if(v.match(/[^0-9]/)){throw new TypeError("Port '"+v+"' contains characters other than [0-9]")}}}return o.call(this,v,c)};p.hostname=function(v,c){if(this._parts.urn){return v===undefined?'':this}if(v!==undefined){var x={};U.parseHost(v,x);v=x.hostname}return r.call(this,v,c)};p.host=function(v,c){if(this._parts.urn){return v===undefined?'':this}if(v===undefined){return this._parts.hostname?U.buildHost(this._parts):""}else{U.parseHost(v,this._parts);this.build(!c);return this}};p.authority=function(v,c){if(this._parts.urn){return v===undefined?'':this}if(v===undefined){return this._parts.hostname?U.buildAuthority(this._parts):""}else{U.parseAuthority(v,this._parts);this.build(!c);return this}};p.userinfo=function(v,c){if(this._parts.urn){return v===undefined?'':this}if(v===undefined){if(!this._parts.username){return""}var t=U.buildUserinfo(this._parts);return t.substring(0,t.length-1)}else{if(v[v.length-1]!=='@'){v+='@'}U.parseUserinfo(v,this._parts);this.build(!c);return this}};p.resource=function(v,c){var d;if(v===undefined){return this.path()+this.search()+this.hash()}d=U.parse(v);this._parts.path=d.path;this._parts.query=d.query;this._parts.fragment=d.fragment;this.build(!c);return this};p.subdomain=function(v,c){if(this._parts.urn){return v===undefined?'':this}if(v===undefined){if(!this._parts.hostname||this.is('IP')){return""}var d=this._parts.hostname.length-this.domain().length-1;return this._parts.hostname.substring(0,d)||""}else{var e=this._parts.hostname.length-this.domain().length;var s=this._parts.hostname.substring(0,e);var i=new RegExp('^'+b(s));if(v&&v[v.length-1]!=='.'){v+="."}if(v){U.ensureValidHostname(v)}this._parts.hostname=this._parts.hostname.replace(i,v);this.build(!c);return this}};p.domain=function(v,c){if(this._parts.urn){return v===undefined?'':this}if(typeof v==='boolean'){c=v;v=undefined}if(v===undefined){if(!this._parts.hostname||this.is('IP')){return""}var t=this._parts.hostname.match(/\./g);if(t&&t.length<2){return this._parts.hostname}var e=this._parts.hostname.length-this.tld(c).length-1;e=this._parts.hostname.lastIndexOf('.',e-1)+1;return this._parts.hostname.substring(e)||""}else{if(!v){throw new TypeError("cannot set domain empty")}U.ensureValidHostname(v);if(!this._parts.hostname||this.is('IP')){this._parts.hostname=v}else{var d=new RegExp(b(this.domain())+"$");this._parts.hostname=this._parts.hostname.replace(d,v)}this.build(!c);return this}};p.tld=function(v,c){if(this._parts.urn){return v===undefined?'':this}if(typeof v==='boolean'){c=v;v=undefined}if(v===undefined){if(!this._parts.hostname||this.is('IP')){return""}var d=this._parts.hostname.lastIndexOf('.');var t=this._parts.hostname.substring(d+1);if(c!==true&&S&&S.list[t.toLowerCase()]){return S.get(this._parts.hostname)||t}return t}else{var e;if(!v){throw new TypeError("cannot set TLD empty")}else if(v.match(/[^a-zA-Z0-9-]/)){if(S&&S.is(v)){e=new RegExp(b(this.tld())+"$");this._parts.hostname=this._parts.hostname.replace(e,v)}else{throw new TypeError("TLD '"+v+"' contains characters other than [A-Z0-9]")}}else if(!this._parts.hostname||this.is('IP')){throw new ReferenceError("cannot set TLD on non-domain host")}else{e=new RegExp(b(this.tld())+"$");this._parts.hostname=this._parts.hostname.replace(e,v)}this.build(!c);return this}};p.directory=function(v,c){if(this._parts.urn){return v===undefined?'':this}if(v===undefined||v===true){if(!this._parts.path&&!this._parts.hostname){return''}if(this._parts.path==='/'){return'/'}var d=this._parts.path.length-this.filename().length-1;var i=this._parts.path.substring(0,d)||(this._parts.hostname?"/":"");return v?U.decodePath(i):i}else{var e=this._parts.path.length-this.filename().length;var l=this._parts.path.substring(0,e);var s=new RegExp('^'+b(l));if(!this.is('relative')){if(!v){v='/'}if(v[0]!=='/'){v="/"+v}}if(v&&v[v.length-1]!=='/'){v+='/'}v=U.recodePath(v);this._parts.path=this._parts.path.replace(s,v);this.build(!c);return this}};p.filename=function(v,c){if(this._parts.urn){return v===undefined?'':this}if(v===undefined||v===true){if(!this._parts.path||this._parts.path==='/'){return""}var d=this._parts.path.lastIndexOf('/');var e=this._parts.path.substring(d+1);return v?U.decodePathSegment(e):e}else{var i=false;if(v[0]==='/'){v=v.substring(1)}if(v.match(/\.?\//)){i=true}var l=new RegExp(b(this.filename())+"$");v=U.recodePath(v);this._parts.path=this._parts.path.replace(l,v);if(i){this.normalizePath(c)}else{this.build(!c)}return this}};p.suffix=function(v,c){if(this._parts.urn){return v===undefined?'':this}if(v===undefined||v===true){if(!this._parts.path||this._parts.path==='/'){return""}var d=this.filename();var e=d.lastIndexOf('.');var s,i;if(e===-1){return""}s=d.substring(e+1);i=(/^[a-z0-9%]+$/i).test(s)?s:"";return v?U.decodePathSegment(i):i}else{if(v[0]==='.'){v=v.substring(1)}var l=this.suffix();var t;if(!l){if(!v){return this}this._parts.path+='.'+U.recodePath(v)}else if(!v){t=new RegExp(b("."+l)+"$")}else{t=new RegExp(b(l)+"$")}if(t){v=U.recodePath(v);this._parts.path=this._parts.path.replace(t,v)}this.build(!c);return this}};p.segment=function(s,v,c){var d=this._parts.urn?':':'/';var e=this.path();var i=e.substring(0,1)==='/';var l=e.split(d);if(typeof s!=='number'){c=v;v=s;s=undefined}if(s!==undefined&&typeof s!=='number'){throw new Error("Bad segment '"+s+"', must be 0-based integer")}if(i){l.shift()}if(s<0){s=Math.max(l.length+s,0)}if(v===undefined){return s===undefined?l:l[s]}else if(s===null||l[s]===undefined){if(f(v)){l=v}else if(v||(typeof v==="string"&&v.length)){if(l[l.length-1]===""){l[l.length-1]=v}else{l.push(v)}}}else{if(v||(typeof v==="string"&&v.length)){l[s]=v}else{l.splice(s,1)}}if(i){l.unshift("")}return this.path(l.join(d),c)};var q=p.query;p.query=function(v,c){if(v===true){return U.parseQuery(this._parts.query)}else if(v!==undefined&&typeof v!=="string"){this._parts.query=U.buildQuery(v,this._parts.duplicateQueryParameters);this.build(!c);return this}else{return q.call(this,v,c)}};p.addQuery=function(c,v,d){var e=U.parseQuery(this._parts.query);U.addQuery(e,c,v===undefined?null:v);this._parts.query=U.buildQuery(e,this._parts.duplicateQueryParameters);if(typeof c!=="string"){d=v}this.build(!d);return this};p.removeQuery=function(c,v,d){var e=U.parseQuery(this._parts.query);U.removeQuery(e,c,v);this._parts.query=U.buildQuery(e,this._parts.duplicateQueryParameters);if(typeof c!=="string"){d=v}this.build(!d);return this};p.addSearch=p.addQuery;p.removeSearch=p.removeQuery;p.normalize=function(){if(this._parts.urn){return this.normalizeProtocol(false).normalizeQuery(false).normalizeFragment(false).build()}return this.normalizeProtocol(false).normalizeHostname(false).normalizePort(false).normalizePath(false).normalizeQuery(false).normalizeFragment(false).build()};p.normalizeProtocol=function(c){if(typeof this._parts.protocol==="string"){this._parts.protocol=this._parts.protocol.toLowerCase();this.build(!c)}return this};p.normalizeHostname=function(c){if(this._parts.hostname){if(this.is('IDN')&&a){this._parts.hostname=a.toASCII(this._parts.hostname)}else if(this.is('IPv6')&&I){this._parts.hostname=I.best(this._parts.hostname)}this._parts.hostname=this._parts.hostname.toLowerCase();this.build(!c)}return this};p.normalizePort=function(c){if(typeof this._parts.protocol==="string"&&this._parts.port===U.defaultPorts[this._parts.protocol]){this._parts.port=null;this.build(!c)}return this};p.normalizePath=function(c){if(this._parts.urn){return this}if(!this._parts.path||this._parts.path==='/'){return this}var d;var e;var i=this._parts.path;var l,s;if(i[0]!=='/'){if(i[0]==='.'){e=i.substring(0,i.indexOf('/'))}d=true;i='/'+i}i=i.replace(/(\/(\.\/)+)|\/{2,}/g,'/');while(true){l=i.indexOf('/../');if(l===-1){break}else if(l===0){i=i.substring(3);break}s=i.substring(0,l).lastIndexOf('/');if(s===-1){s=l}i=i.substring(0,s)+i.substring(l+3)}if(d&&this.is('relative')){if(e){i=e+i}else{i=i.substring(1)}}i=U.recodePath(i);this._parts.path=i;this.build(!c);return this};p.normalizePathname=p.normalizePath;p.normalizeQuery=function(c){if(typeof this._parts.query==="string"){if(!this._parts.query.length){this._parts.query=null}else{this.query(U.parseQuery(this._parts.query))}this.build(!c)}return this};p.normalizeFragment=function(c){if(!this._parts.fragment){this._parts.fragment=null;this.build(!c)}return this};p.normalizeSearch=p.normalizeQuery;p.normalizeHash=p.normalizeFragment;p.iso8859=function(){var e=U.encode;var d=U.decode;U.encode=escape;U.decode=decodeURIComponent;this.normalize();U.encode=e;U.decode=d;return this};p.unicode=function(){var e=U.encode;var d=U.decode;U.encode=j;U.decode=unescape;this.normalize();U.encode=e;U.decode=d;return this};p.readable=function(){var u=this.clone();u.username("").password("").normalize();var t='';if(u._parts.protocol){t+=u._parts.protocol+'://'}if(u._parts.hostname){if(u.is('punycode')&&a){t+=a.toUnicode(u._parts.hostname);if(u._parts.port){t+=":"+u._parts.port}}else{t+=u.host()}}if(u._parts.hostname&&u._parts.path&&u._parts.path[0]!=='/'){t+='/'}t+=u.path(true);if(u._parts.query){var q='';for(var i=0,c=u._parts.query.split('&'),l=c.length;i<l;i++){var d=(c[i]||"").split('=');q+='&'+U.decodeQuery(d[0]).replace(/&/g,'%26');if(d[1]!==undefined){q+="="+U.decodeQuery(d[1]).replace(/&/g,'%26')}}t+='?'+q.substring(1)}t+=u.hash();return t};p.absoluteTo=function(c){var d=this.clone();var e=['protocol','username','password','hostname','port'];var l,i,p;if(this._parts.urn){throw new Error('URNs do not have any generally defined hierachical components')}if(this._parts.hostname){return d}if(!(c instanceof U)){c=new U(c)}for(i=0,p;p=e[i];i++){d._parts[p]=c._parts[p]}e=['query','path'];for(i=0,p;p=e[i];i++){if(!d._parts[p]&&c._parts[p]){d._parts[p]=c._parts[p]}}if(d.path()[0]!=='/'){l=c.directory();d._parts.path=(l?(l+'/'):'')+d._parts.path;d.normalizePath()}d.build();return d};p.relativeTo=function(c){var d=this.clone();var e=['protocol','username','password','hostname','port'];var l,s;if(this._parts.urn){throw new Error('URNs do not have any generally defined hierachical components')}if(!(c instanceof U)){c=new U(c)}if(this.path()[0]!=='/'||c.path()[0]!=='/'){throw new Error('Cannot calculate common path from non-relative URLs')}l=U.commonPath(d.path(),c.path());s=c.directory();for(var i=0,p;p=e[i];i++){d._parts[p]=null}if(!l||l==='/'){return d}if(s+'/'===l){d._parts.path='./'+d.filename()}else{var t='../';var u=new RegExp('^'+b(l));var v=s.replace(u,'/').match(/\//g).length-1;while(v--){t+='../'}d._parts.path=d._parts.path.replace(u,t)}d.build();return d};p.equals=function(u){var c=this.clone();var t=new U(u);var d={};var e={};var s={};var v,w,x;c.normalize();t.normalize();if(c.toString()===t.toString()){return true}v=c.query();w=t.query();c.query("");t.query("");if(c.toString()!==t.toString()){return false}if(v.length!==w.length){return false}d=U.parseQuery(v);e=U.parseQuery(w);for(x in d){if(h.call(d,x)){if(!f(d[x])){if(d[x]!==e[x]){return false}}else{if(!f(e[x])){return false}if(d[x].length!==e[x].length){return false}d[x].sort();e[x].sort();for(var i=0,l=d[x].length;i<l;i++){if(d[x][i]!==e[x][i]){return false}}}s[x]=true}}for(x in e){if(h.call(e,x)){if(!s[x]){return false}}}return true};p.duplicateQueryParameters=function(v){this._parts.duplicateQueryParameters=!!v;return this};return U}));
